(
/* The Computer Language Benchmarks Game
 * http://benchmarksgame.alioth.debian.org/
 *
 * contributed by Christoph Bauer
 * slightly sped up by Petr Prokhorenkov
 */
)

39.478417604357428482118055131396e fconstant solar_mass
( mass x y z vx vy vz )
7 floats constant size_p 
4 floats constant vx_offset 

fvariable px
fvariable py
fvariable pz
fvariable pm

5 constant NBODIES
create bodies
  ( sun )
  solar_mass f, 
  0e f, 
  0e f, 
  0e f, 
  0e f, 
  0e f, 
  0e f, 
  ( jupiter )
  0.037693674870389489455880787455473602957e f, 
  4.84143144246472090e+00 f, 
  -1.16032004402742839e+00 f, 
  -1.03622044471123109e-01 f, 
  0.6063263929958320519656e f, 
  2.81198684491625992827e f, 
  -2.5218361659887629852052e-02 f, 
  ( saturn )
  0.0112863261319687660871559412399584017726e f, 
  8.34336671824457987e+00 f, 
  4.12479856412430479e+00 f, 
  -4.03523417114321381e-01 f, 
  -1.0107743461787922699364e f, 
  1.8256623712304117200712e f, 
  0.008415761376584153742796e f, 
  ( uranus )
  0.0017237240570597110309151884878251366745e f, 
  1.28943695621391310e+01 f, 
  -1.51111514016986312e+01 f, 
  -2.23307578892655734e-01 f, 
  1.0827910064415353335832e f, 
  0.86871301816960822178e f, 
  -0.010832637401363636495344e f, 
  ( neptune )
  0.002033686869924630245154486521894305127e f,
  1.53796971148509165e+01 f, 
  -2.59193146099879641e+01 f, 
  1.79258772950371181e-01 f, 
  0.9790907322438979596728e f, 
  0.594698998647676158258e f, 
  -0.03475595550407810243588e f, 
  
(
  : show_bodies \  p nbodies   
  ." sun fdepth: " fdepth . cr
  for 
    ."  m: " dup f@ f. cr float+      \ p.x
    ."  x: " dup f@ f. cr float+      \ p.y
    ."  y: " dup f@ f. cr float+      \ p.z
    ."  z: " dup f@ f. cr float+      \ p.vx
    ." vx: " dup f@ f. cr float+      \ p.vy
    ." vy: " dup f@ f. cr float+      \ p.vz
    ." vz: " dup f@ f. cr float+      \ p.mass
    cr
  next
  drop
;
)

: advance ( p nbodies -- )

  2dup                                   ( p nbodies -- p nbodies p nbodies )
  for                                    ( p nbodies pn )
    dup size_p + tuck                    ( p nbodies p+1 p p2 )
    i if i 1- for                        ( p nbodies p+1 p p2 ) 
      2dup float+ swap float+ swap       ( p nbodies p+1 p p2 p.x p2.x )
      over f@ over f@ f-                 ( p nbodies p+1 p p2 p.x p2.x dx )
      fdup px f! fdup f*                 ( p nbodies p+1 p p2 p.x p2.x dx*dx )
                                         
      -rot float+ swap float+ swap       ( p nbodies p+1 p p2 dx*dx p.y p2.y )
      over f@ over f@ f-                 ( p nbodies p+1 p p2 dx*dx p.y p2.y dy )
      fdup py f! fdup f*                 ( p nbodies p+1 p p2 dx*dx p.y p2.y dy*dy )
                                        
      -rot float+ f@ swap float+ f@ swap ( p nbodies p+1 p p2 dx*dx dy*dy z z2 ) 
      f- fdup pz f! fdup f*              ( p nbodies p+1 p p2 dx*dx dy*dy dz*dz )
                                         
      f+ f+ fsqrt 1e fswap f/            ( p nbodies p+1 p p2 inv_distance )
      fdup fdup f* f*                    ( p nbodies p+1 p p2 mag )
                                         
      fdup pz f@ f* pz f!                ( p nbodies p+1 p p2 mag )
      fdup py f@ f* py f!                ( p nbodies p+1 p p2 mag )
           px f@ f* px f!                ( p nbodies p+1 p p2 )
                                         
      over vx_offset + over f@ swap      ( p nbodies p+1 p p2 mass2 p.vx )
                                         
      2dup f@ swap px f@ f* f-           ( p nbodies p+1 p p2 mass2 p.vx vx-mass2*dx*mag )
      over f! float+                     ( p nbodies p+1 p p2 mass2 p.vy ) 
      2dup f@ swap py f@ f* f-           ( p nbodies p+1 p p2 mass2 p.vy vy-mass2*dy*mag )
      over f! float+                     ( p nbodies p+1 p p2 mass2 p.vz ) 
      tuck f@ swap pz f@ f* f-           ( p nbodies p+1 p p2       p.vz vz-mass2*dz*mag )
      swap f!                            ( p nbodies p+1 p p2 ) 
                                         
      over f@ swap vx_offset +           ( p nbodies p+1 p mass p2.vx )
                                         
      2dup f@ swap px f@ f* f+           ( p nbodies p+1 p mass p2.vx vx+mass*dx*mag )
      over f! float+                     ( p nbodies p+1 p mass p2.vy ) 
      2dup f@ swap py f@ f* f+           ( p nbodies p+1 p mass p2.vy vy+mass*dy*mag )
      over f! float+                     ( p nbodies p+1 p mass p2.vz ) 
      tuck f@ swap pz f@ f* f+           ( p nbodies p+1 p      p2.vz vz+mass*dz*mag )
      over f! float+                     ( p nbodies p+1 p p2+1 ) 
    next then                            
                                         
    drop dup vx_offset + swap float+     ( p nbodies p+1 p.vx p.x )
    over f@ over f@ f+ over f!           ( p nbodies p+1 p.vx p.x )
    swap float+ swap float+              ( p nbodies p+1 p.vy p.y )
    over f@ over f@ f+ over f!           ( p nbodies p+1 p.vy p.y )
    float+ swap float+ swap              ( p nbodies p+1 p.vz p.z )
    tuck f@ swap f@ f+ swap f!           ( p nbodies p+1 )
  next
  drop
;

: energy ( p nbodies -- e )

  0e pz f!
  
  ( p nbodies )
  for
    dup f@ f2/                       ( p mass/2 ) 
    over vx_offset +                 ( p mass/2 p.vx )
    dup f@ fdup f*                   ( p mass/2 p.vx vx*vx ) 
    swap float+                      ( p mass/2 vx*vx p.vy )
    dup f@ fdup f*                   ( p mass/2 vx*vx p.vy vy*vy ) 
    swap float+                      ( p mass/2 vx*vx vy*vy p.vz )
        f@ fdup f*                   ( p mass/2 vx*vx vy*vy vz*vz )
    f+ f+ 
    f* 
    pz f@ f+ 
    pz f!          ( p ) 
    dup size_p + tuck                ( p+1 p p+1 )
    i if i 1- for
      2dup                           ( p+1 p p2 p p2 )
      over f@ over f@ f*             ( p+1 p p2 p p2 mass*mass2 )
      -rot float+ swap float+        ( p+1 p p2 mass*mass2       p2.x p.x )
      over f@ over f@ f- fdup f*     ( p+1 p p2 mass*mass2       p2.x p.x dx*dx )
      -rot float+ swap float+        ( p+1 p p2 mass*mass2 dx*dx p.y p2.y )
      over f@ over f@ f- fdup f*     ( p+1 p p2 mass*mass2 dx*dx p.y p2.y dy*dy )
      -rot float+ f@ swap float+ f@  ( p+1 p p2 mass*mass2 dx*dx dy*dy z2 z ) 
      f- fdup f*                     ( p+1 p p2 mass*mass2 dx*dx dy*dy dz*dz )
      f+ f+ fsqrt f/                 ( p+1 p p2 de )
      pz f@ fswap f- 
      pz f!           ( p+1 p p2 )
      size_p +                       ( p+1 p p2+1 )
    next then
    2drop                            ( p+1 )
  next
  drop pz f@                         ( e )             
;

: offset_momentum  ( p nbodies -- )
  0e px f!
  0e py f!
  0e pz f! 
  over swap               ( p p nbodies )
  for                     ( p      p+n )
    dup f@ swap           ( p mass p+n.mass       )
    vx_offset +           ( p mass p+n.vx         )
    2dup f@ f*            ( p mass p+n.vx mass*vx )
    px f@ f+ px f! float+ ( p mass p+n.vy         )
    2dup f@ f*            ( p mass p+n.vy mass*vy )
    py f@ f+ py f! float+ ( p mass p+n.vz         )
    tuck f@ f*            ( p      p+n.vz mass*vz )
    pz f@ f+ pz f! float+ ( p      p+n+1          )
  next
  drop
  vx_offset +             ( p.vx )
  px f@ solar_mass f/     ( p.vx px/solar_mass )
  fnegate over f! float+  ( p.vx )
  py f@ solar_mass f/     ( p.vy py/solar_mass )
  fnegate over f! float+  ( p.vz )
  pz f@ solar_mass f/     ( p.vz pz/solar_mass )
  fnegate swap f!         (  )
;

: scale_bodies ( scale p nbodies )  
  for 
    over fdup f* over f@ f* over f!   ( scale p )
    vx_offset +                       ( scale p.vx )
    2dup f@ f* over f!                ( scale p.vx )
    float+                            ( scale p.vy )
    2dup f@ f* over f!                ( scale p.vy )
    float+                            ( scale p.vz )
    2dup f@ f* over f!                ( scale p.vz )
    float+                            ( scale p+1 )
  next
  2drop
;



1e-2 fconstant DT
100e fconstant RECIP_DT


bodies NBODIES 1- offset_momentum
\  bodies NBODIES 1- energy f. cr

DT bodies NBODIES 1- scale_bodies

999 for
  bodies NBODIES 1- advance
next

RECIP_DT bodies NBODIES 1- scale_bodies

\  bodies NBODIES 1- energy f. cr
\  bodies NBODIES 1- show_bodies
