include(`../M4/FIRST.M4')dnl
  ifdef __ORG
    org __ORG
  else
    org 32768
  endif
  INIT(60000)
;# /* The Computer Language Benchmarks Game
;#  * http://benchmarksgame.alioth.debian.org/
;#  *
;#  * contributed by Christoph Bauer
;#  * slightly sped up by Petr Prokhorenkov
;#  */
;# 


FCONSTANT(_solar_mass,39.478417604357428482118055131396e)
;# mass x y z vx vy vz 

PUSH(7) FLOATS CONSTANT(_size_p) 
PUSH(4) FLOATS CONSTANT(_vx_offset) 

FVARIABLE(_px)
FVARIABLE(_py)
FVARIABLE(_pz)
FVARIABLE(_pm)

CONSTANT(_NBODIES,5)
CREATE(_bodies)
  ;# sun 

  PUSH(_solar_mass) FCOMMA 
  FPUSH(0e) FCOMMA 
  FPUSH(0e) FCOMMA 
  FPUSH(0e) FCOMMA 
  FPUSH(0e) FCOMMA 
  FPUSH(0e) FCOMMA 
  FPUSH(0e) FCOMMA 
  ;# jupiter 

  FPUSH(0.037693674870389489455880787455473602957e) FCOMMA 
  FPUSH(4.84143144246472090e+00) FCOMMA 
  FPUSH(-1.16032004402742839e+00) FCOMMA 
  FPUSH(-1.03622044471123109e-01) FCOMMA 
  FPUSH(0.6063263929958320519656e) FCOMMA 
  FPUSH(2.81198684491625992827e) FCOMMA 
  FPUSH(-2.5218361659887629852052e-02) FCOMMA 
  ;# saturn 

  FPUSH(0.0112863261319687660871559412399584017726e) FCOMMA 
  FPUSH(8.34336671824457987e+00) FCOMMA 
  FPUSH(4.12479856412430479e+00) FCOMMA 
  FPUSH(-4.03523417114321381e-01) FCOMMA 
  FPUSH(-1.0107743461787922699364e) FCOMMA 
  FPUSH(1.8256623712304117200712e) FCOMMA 
  FPUSH(0.008415761376584153742796e) FCOMMA 
  ;# uranus 

  FPUSH(0.0017237240570597110309151884878251366745e) FCOMMA 
  FPUSH(1.28943695621391310e+01) FCOMMA 
  FPUSH(-1.51111514016986312e+01) FCOMMA 
  FPUSH(-2.23307578892655734e-01) FCOMMA 
  FPUSH(1.0827910064415353335832e) FCOMMA 
  FPUSH(0.86871301816960822178e) FCOMMA 
  FPUSH(-0.010832637401363636495344e) FCOMMA 
  ;# neptune 

  FPUSH(0.002033686869924630245154486521894305127e) FCOMMA
  FPUSH(1.53796971148509165e+01) FCOMMA 
  FPUSH(-2.59193146099879641e+01) FCOMMA 
  FPUSH(1.79258772950371181e-01) FCOMMA 
  FPUSH(0.9790907322438979596728e) FCOMMA 
  FPUSH(0.594698998647676158258e) FCOMMA 
  FPUSH(-0.03475595550407810243588e) FCOMMA 
  
;#   : show_bodies \  p nbodies   
;#   ." sun fdepth: " fdepth . cr
;#   for 
;#     ."  m: " dup f@ f. cr float+      \ p.x
;#     ."  x: " dup f@ f. cr float+      \ p.y
;#     ."  y: " dup f@ f. cr float+      \ p.z
;#     ."  z: " dup f@ f. cr float+      \ p.vx
;#     ." vx: " dup f@ f. cr float+      \ p.vy
;#     ." vy: " dup f@ f. cr float+      \ p.vz
;#     ." vz: " dup f@ f. cr float+      \ p.mass
;#     cr
;#   next
;#   drop
;# ;
;# 



FCONSTANT(_DT,1e-2)
FCONSTANT(_RECIP_DT,100e)


PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_offset_momentum)
;#  bodies NBODIES 1- energy f. cr

PUSH(_DT) PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_scale_bodies)

PUSH(999) FOR
  PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_advance)
NEXT

PUSH(_RECIP_DT) PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_scale_bodies)

;#  bodies NBODIES 1- energy f. cr
;#  bodies NBODIES 1- show_bodies
  STOP

COLON(_advance,({{{{ p nbodies -- }}}}))

  _2DUP                                   ;# p nbodies -- p nbodies p nbodies 

  FOR                                    ;# p nbodies pn 

    DUP PUSH(_size_p) ADD TUCK                    ;# p nbodies p+1 p p2 

    I IF I _1SUB FOR                        ;# p nbodies p+1 p p2 
 
      _2DUP FLOATADD SWAP FLOATADD SWAP       ;# p nbodies p+1 p p2 p.x p2.x 

      OVER FFETCH OVER FFETCH FSUB                 ;# p nbodies p+1 p p2 p.x p2.x dx 

      FDUP PUSH(_px) FSTORE FDUP FMUL                 ;# p nbodies p+1 p p2 p.x p2.x dx*dx 

                                         
      NROT FLOATADD SWAP FLOATADD SWAP       ;# p nbodies p+1 p p2 dx*dx p.y p2.y 

      OVER FFETCH OVER FFETCH FSUB                 ;# p nbodies p+1 p p2 dx*dx p.y p2.y dy 

      FDUP PUSH(_py) FSTORE FDUP FMUL                 ;# p nbodies p+1 p p2 dx*dx p.y p2.y dy*dy 

                                        
      NROT FLOATADD FFETCH SWAP FLOATADD FFETCH SWAP ;# p nbodies p+1 p p2 dx*dx dy*dy z z2 
 
      FSUB FDUP PUSH(_pz) FSTORE FDUP FMUL              ;# p nbodies p+1 p p2 dx*dx dy*dy dz*dz 

                                         
      FADD FADD FSQRT FPUSH(1e) FSWAP FDIV            ;# p nbodies p+1 p p2 inv_distance 

      FDUP FDUP FMUL FMUL                    ;# p nbodies p+1 p p2 mag 

                                         
      FDUP PUSH(_pz) FFETCH FMUL PUSH(_pz) FSTORE                ;# p nbodies p+1 p p2 mag 

      FDUP PUSH(_py) FFETCH FMUL PUSH(_py) FSTORE                ;# p nbodies p+1 p p2 mag 

           PUSH(_px) FFETCH FMUL PUSH(_px) FSTORE                ;# p nbodies p+1 p p2 

                                         
      OVER PUSH(_vx_offset) ADD OVER FFETCH SWAP      ;# p nbodies p+1 p p2 mass2 p.vx 

                                         
      _2DUP FFETCH SWAP PUSH(_px) FFETCH FMUL FSUB           ;# p nbodies p+1 p p2 mass2 p.vx vx-mass2*dx*mag 

      OVER FSTORE FLOATADD                     ;# p nbodies p+1 p p2 mass2 p.vy 
 
      _2DUP FFETCH SWAP PUSH(_py) FFETCH FMUL FSUB           ;# p nbodies p+1 p p2 mass2 p.vy vy-mass2*dy*mag 

      OVER FSTORE FLOATADD                     ;# p nbodies p+1 p p2 mass2 p.vz 
 
      TUCK FFETCH SWAP PUSH(_pz) FFETCH FMUL FSUB           ;# p nbodies p+1 p p2       p.vz vz-mass2*dz*mag 

      SWAP FSTORE                            ;# p nbodies p+1 p p2 
 
                                         
      OVER FFETCH SWAP PUSH(_vx_offset) ADD           ;# p nbodies p+1 p mass p2.vx 

                                         
      _2DUP FFETCH SWAP PUSH(_px) FFETCH FMUL FADD           ;# p nbodies p+1 p mass p2.vx vx+mass*dx*mag 

      OVER FSTORE FLOATADD                     ;# p nbodies p+1 p mass p2.vy 
 
      _2DUP FFETCH SWAP PUSH(_py) FFETCH FMUL FADD           ;# p nbodies p+1 p mass p2.vy vy+mass*dy*mag 

      OVER FSTORE FLOATADD                     ;# p nbodies p+1 p mass p2.vz 
 
      TUCK FFETCH SWAP PUSH(_pz) FFETCH FMUL FADD           ;# p nbodies p+1 p      p2.vz vz+mass*dz*mag 

      OVER FSTORE FLOATADD                     ;# p nbodies p+1 p p2+1 
 
    NEXT THEN                            
                                         
    DROP DUP PUSH(_vx_offset) ADD SWAP FLOATADD     ;# p nbodies p+1 p.vx p.x 

    OVER FFETCH OVER FFETCH FADD OVER FSTORE           ;# p nbodies p+1 p.vx p.x 

    SWAP FLOATADD SWAP FLOATADD              ;# p nbodies p+1 p.vy p.y 

    OVER FFETCH OVER FFETCH FADD OVER FSTORE           ;# p nbodies p+1 p.vy p.y 

    FLOATADD SWAP FLOATADD SWAP              ;# p nbodies p+1 p.vz p.z 

    TUCK FFETCH SWAP FFETCH FADD SWAP FSTORE           ;# p nbodies p+1 

  NEXT
  DROP
SEMICOLON

COLON(_energy,({{{{ p nbodies -- e }}}}))

  FPUSH(0e) PUSH(_pz) FSTORE
  
  ;# p nbodies 

  FOR
    DUP FFETCH F2DIV                       ;# p mass/2 
 
    OVER PUSH(_vx_offset) ADD                 ;# p mass/2 p.vx 

    DUP FFETCH FDUP FMUL                   ;# p mass/2 p.vx vx*vx 
 
    SWAP FLOATADD                      ;# p mass/2 vx*vx p.vy 

    DUP FFETCH FDUP FMUL                   ;# p mass/2 vx*vx p.vy vy*vy 
 
    SWAP FLOATADD                      ;# p mass/2 vx*vx vy*vy p.vz 

        FFETCH FDUP FMUL                   ;# p mass/2 vx*vx vy*vy vz*vz 

    FADD FADD 
    FMUL 
    PUSH(_pz) FFETCH FADD 
    PUSH(_pz) FSTORE          ;# p 
 
    DUP PUSH(_size_p) ADD TUCK                ;# p+1 p p+1 

    I IF I _1SUB FOR
      _2DUP                           ;# p+1 p p2 p p2 

      OVER FFETCH OVER FFETCH FMUL             ;# p+1 p p2 p p2 mass*mass2 

      NROT FLOATADD SWAP FLOATADD        ;# p+1 p p2 mass*mass2       p2.x p.x 

      OVER FFETCH OVER FFETCH FSUB FDUP FMUL     ;# p+1 p p2 mass*mass2       p2.x p.x dx*dx 

      NROT FLOATADD SWAP FLOATADD        ;# p+1 p p2 mass*mass2 dx*dx p.y p2.y 

      OVER FFETCH OVER FFETCH FSUB FDUP FMUL     ;# p+1 p p2 mass*mass2 dx*dx p.y p2.y dy*dy 

      NROT FLOATADD FFETCH SWAP FLOATADD FFETCH  ;# p+1 p p2 mass*mass2 dx*dx dy*dy z2 z 
 
      FSUB FDUP FMUL                     ;# p+1 p p2 mass*mass2 dx*dx dy*dy dz*dz 

      FADD FADD FSQRT FDIV                 ;# p+1 p p2 de 

      PUSH(_pz) FFETCH FSWAP FSUB 
      PUSH(_pz) FSTORE           ;# p+1 p p2 

      PUSH(_size_p) ADD                       ;# p+1 p p2+1 

    NEXT THEN
    _2DROP                            ;# p+1 

  NEXT
  DROP PUSH(_pz) FFETCH                         ;# e 
             
SEMICOLON

COLON(_offset_momentum,({{{{ p nbodies -- }}}}))
  FPUSH(0e) PUSH(_px) FSTORE
  FPUSH(0e) PUSH(_py) FSTORE
  FPUSH(0e) PUSH(_pz) FSTORE 
  OVER SWAP               ;# p p nbodies 

  FOR                     ;# p      p+n 

    DUP FFETCH SWAP           ;# p mass p+n.mass       

    PUSH(_vx_offset) ADD           ;# p mass p+n.vx         

    _2DUP FFETCH FMUL            ;# p mass p+n.vx mass*vx 

    PUSH(_px) FFETCH FADD PUSH(_px) FSTORE FLOATADD ;# p mass p+n.vy         

    _2DUP FFETCH FMUL            ;# p mass p+n.vy mass*vy 

    PUSH(_py) FFETCH FADD PUSH(_py) FSTORE FLOATADD ;# p mass p+n.vz         

    TUCK FFETCH FMUL            ;# p      p+n.vz mass*vz 

    PUSH(_pz) FFETCH FADD PUSH(_pz) FSTORE FLOATADD ;# p      p+n+1          

  NEXT
  DROP
  PUSH(_vx_offset) ADD             ;# p.vx 

  PUSH(_px) FFETCH PUSH(_solar_mass) FDIV     ;# p.vx px/solar_mass 

  FNEGATE OVER FSTORE FLOATADD  ;# p.vx 

  PUSH(_py) FFETCH PUSH(_solar_mass) FDIV     ;# p.vy py/solar_mass 

  FNEGATE OVER FSTORE FLOATADD  ;# p.vz 

  PUSH(_pz) FFETCH PUSH(_solar_mass) FDIV     ;# p.vz pz/solar_mass 

  FNEGATE SWAP FSTORE         ;#  

SEMICOLON

COLON(_scale_bodies,({{{{ scale p nbodies }}}}))  
  FOR 
    OVER FDUP FMUL OVER FFETCH FMUL OVER FSTORE   ;# scale p 

    PUSH(_vx_offset) ADD                       ;# scale p.vx 

    _2DUP FFETCH FMUL OVER FSTORE                ;# scale p.vx 

    FLOATADD                            ;# scale p.vy 

    _2DUP FFETCH FMUL OVER FSTORE                ;# scale p.vy 

    FLOATADD                            ;# scale p.vz 

    _2DUP FFETCH FMUL OVER FSTORE                ;# scale p.vz 

    FLOATADD                            ;# scale p+1 

  NEXT
  _2DROP
SEMICOLON
