(
/* The Computer Language Benchmarks Game
 * http://benchmarksgame.alioth.debian.org/
 *
 * contributed by Christoph Bauer
 * slightly sped up by Petr Prokhorenkov
 */
)

39.478417604357428482118055131396e fconstant solar_mass
( mass x y z vx vy vz )
7 floats constant size_p 
4 floats constant vx_offset

fvariable px
fvariable py
fvariable pz
fvariable pm

5 constant NBODIES
create bodies
  ( sun )
  solar_mass f, 
  0e f, 
  0e f, 
  0e f, 
  0e f, 
  0e f, 
  0e f, 
  ( jupiter )
  0.037693674870389489455880787455473602957e f, 
  4.84143144246472090e+00 f, 
  -1.16032004402742839e+00 f, 
  -1.03622044471123109e-01 f, 
  0.6063263929958320519656e f, 
  2.81198684491625992827e f, 
  -2.5218361659887629852052e-02 f, 
  ( saturn )
  0.0112863261319687660871559412399584017726e f, 
  8.34336671824457987e+00 f, 
  4.12479856412430479e+00 f, 
  -4.03523417114321381e-01 f, 
  -1.0107743461787922699364e f, 
  1.8256623712304117200712e f, 
  0.008415761376584153742796e f, 
  ( uranus )
  0.0017237240570597110309151884878251366745e f, 
  1.28943695621391310e+01 f, 
  -1.51111514016986312e+01 f, 
  -2.23307578892655734e-01 f, 
  1.0827910064415353335832e f, 
  0.86871301816960822178e f, 
  -0.010832637401363636495344e f, 
  ( neptune )
  0.002033686869924630245154486521894305127e f,
  1.53796971148509165e+01 f, 
  -2.59193146099879641e+01 f, 
  1.79258772950371181e-01 f, 
  0.9790907322438979596728e f, 
  0.594698998647676158258e f, 
  -0.03475595550407810243588e f, 
  
(
  : show_bodies \  p nbodies   
  ." sun fdepth: " fdepth . cr
  for 
    ."  m: " dup f@ f. cr float+      \ p.x
    ."  x: " dup f@ f. cr float+      \ p.y
    ."  y: " dup f@ f. cr float+      \ p.z
    ."  z: " dup f@ f. cr float+      \ p.vx
    ." vx: " dup f@ f. cr float+      \ p.vy
    ." vy: " dup f@ f. cr float+      \ p.vz
    ." vz: " dup f@ f. cr float+      \ p.mass
    cr
  next
  drop
;
)

: advance ( p nbodies -- )

  for                                    \ p                     z: 
    dup size_p + tuck                    \ p+1 p p+1             z: 
    i if i 1- for                        \ p+1 p p+n             z:  
      dup f@ over dup f@ fdup fdup 1e    \ p+1 p p+n   p         z: mass2 mass mass mass 1 
      
           float+ dup f@                 \ p+1 p p+n   p.x       z: mass2 mass mass mass 1 x 
      swap float+ dup f@ f-              \ p+1 p p.x   p+n.x     z: mass2 mass mass mass 1 dx 
      fdup px f! fdup f*                 \ p+1 p p.x   p+n.x     z: mass2 mass mass mass 1 dx*dx 
                                                                
      swap float+ dup f@                 \ p+1 p p+n.x p.y       z: mass2 mass mass mass 1 dx*dx y 
      swap float+ dup f@ f-              \ p+1 p p.y   p+n.y     z: mass2 mass mass mass 1 dx*dx dy 
      fdup py f! fdup f*                 \ p+1 p p.y   p+n.y     z: mass2 mass mass mass 1 dx*dx dy*dy 

      swap float+ dup f@                 \ p+1 p p+n.y p.z       z: mass2 mass mass mass 1 dx*dx dy*dy z 
      swap float+ dup f@ f-              \ p+1 p p.z   p+n.z     z: mass2 mass mass mass 1 dx*dx dy*dy dz 
      fdup pz f! fdup f*                 \ p+1 p p.z   p+n.z     z: mass2 mass mass mass 1 dx*dx dy*dy dz*dz 
                                                                  
      f+ f+ fsqrt f/                     \ p+1 p p.z   p+n.z     z: mass2 mass mass mass inv_distance 
      fdup fdup f* f* fdup fdup          \ p+1 p p.z   p+n.z     z: mass2 mass mass mass mag mag mag 
                                                                  
      pz f@ f* pz f!                     \ p+1 p p.z   p+n.z     z: mass2 mass mass mass mag mag 
      py f@ f* py f!                     \ p+1 p p.z   p+n.z     z: mass2 mass mass mass mag 
      px f@ f* px f!                     \ p+1 p p.z   p+n.z     z: mass2 mass mass mass 

      px f@ f* float+ dup f@ f+ dup f!   \ p+1 p p.z   p+n.vx    z: mass2 mass mass 
      py f@ f* float+ dup f@ f+ dup f!   \ p+1 p p.z   p+n.vy    z: mass2 mass 
      pz f@ f* float+ dup f@ f+ dup f!   \ p+1 p p.z   p+n.vz    z: mass2 

      swap                               \ p+1 p p+n.vz p.z      z: mass2 

\  26m 6.85s 1891 bytes
      fdup fdup                                  \ p+1 p p+n.vz p.z      z: mass2 mass2 mass2
      px f@ f* fnegate float+ dup f@ f+ dup f!   \ p+1 p p+n.vz p.vx     z: mass2 mass2 
      py f@ f* fnegate float+ dup f@ f+ dup f!   \ p+1 p p+n.vz p.vy     z: mass2 
      pz f@ f* fnegate float+ dup f@ f+ dup f!   \ p+1 p p+n.vz p.vz     z:

(
\ 26m 1.89s 1915 bytes
      float+ dup f@ fover px f@ f* f- dup f! \ p+1 p p+n.vz p.vx     z: mass2 
      float+ dup f@ fover py f@ f* f- dup f! \ p+1 p p+n.vz p.vy     z: mass2 
      float+ dup f@ fswap pz f@ f* f- dup f! \ p+1 p p+n.vz p.vz     z: 
)
      drop float+                        \ p+1 p p+n+1           z: 
                                                                   
    next then                                                      
                                                                  
    drop dup vx_offset + swap float+     \ p+1 p.vx p.x         z: 
    2dup f@ f@ f+ dup f!                 \ p+1 p.vx p.x         z: 
    swap float+ swap float+              \ p+1 p.vy p.y         z: 
    2dup f@ f@ f+ dup f!                 \ p+1 p.vy p.y         z: 
    float+ dup f@ swap float+ f@ f+ f!   \ p+1                  z: 
  next
  drop
;

: energy ( p nbodies -- e ) ( z: -- e )
  0e                                 ( p nbodies )           ( z: e )
  for                                                       
    dup f@ f2/                       ( p         )           ( z: e mass/2 ) 
    dup vx_offset +                  ( p p.vx    )           ( z: e mass/2 )
    dup f@ fdup f* float+            ( p p.vy    )           ( z: e mass/2 vx*vx ) 
    dup f@ fdup f* float+            ( p p.vz    )           ( z: e mass/2 vx*vx vy*vy ) 
        f@ fdup f*                   ( p         )           ( z: e mass/2 vx*vx vy*vy vz*vz )
    f+ f+ f* f+                      ( p         )           ( z: e )
       
    dup size_p + tuck                ( p+1 p p+n )           ( z: e )
    i if i 1- for                                        
      2dup                           ( p+1 p p+n p p+n )     ( z: e )
      2dup f@ f@ f*                  ( p+1 p p+n p p+n )     ( z: e mass*mass2 )
      
      swap float+ dup f@             ( p+1 p p+n p+n p.x )   ( z: e mass*mass2 x )
      swap float+ dup f@ f- fdup f*  ( p+1 p p+n p.x p+n.x ) ( z: e mass*mass2 dx*dx )

      swap float+ dup f@             ( p+1 p p+n p+n.x p.y ) ( z: e mass*mass2 dx*dx y )
      swap float+ dup f@ f- fdup f*  ( p+1 p p+n p.y p+n.y ) ( z: e mass*mass2 dx*dx dy*dy )

           float+     f@             ( p+1 p p+n p.y       ) ( z: e mass*mass2 dx*dx dy*dy z2 )
           float+     f@ f- fdup f*  ( p+1 p p+n           ) ( z: e mass*mass2 dx*dx dy*dy dz*dz )
      
      f+ f+ fsqrt f/ f-              ( p+1 p p+n )           ( z: e )
      size_p +                       ( p+1 p p+n+1 )         ( z: e )
    next then
    2drop                            ( p+1 )                 ( z: e )
  next
  drop                               (  )                    ( z: e )             
;


: offset_momentum  ( p nbodies -- ) ( z: -- )
  0e px f!
  0e py f!
  0e pz f!  
  over swap                      ( p p nbodies )    ( z: )
  for                            ( p p+n )          ( z: )
    dup f@ fdup fdup vx_offset + ( p p+n.vx )       ( z: mass mass mass )     
    dup f@ f*                    ( p p+n.vx )       ( z: mass mass mass*vx )
    px f@ f+ px f! float+        ( p p+n.vy )       ( z: mass )
    dup f@ f*                    ( p p+n.vy )       ( z: mass mass*vy )
    py f@ f+ py f! float+        ( p p+n.vz )       ( z: mass )
    dup f@ f*                    ( p p+n.vz )       ( z: mass*vz )
    pz f@ f+ pz f! float+        ( p p+n+1 )        ( z: )
  next      
  drop                           ( p )              ( z: )

  pz f@ solar_mass fnegate       \ p                z: pz -solar_mass 
  fdup fdup                      \ p                z: pz -solar_mass -solar_mass -solar_mass 
  px f@ fswap f/                 \ p                z: pz -solar_mass -solar_mass -px/solar_mass
  vx_offset + dup f!             \ p.vx             z: pz -solar_mass -solar_mass
  py f@ fswap f/                 \ p.vx             z: pz -solar_mass -py/solar_mass
  float+      dup f!             \ p.vy             z: pz -solar_mass
              f/                 \ p.vy             z: -pz/solar_mass 
  float+          f!             \                  z: 

(
  px f@ solar_mass f/ fnegate    \ p                z: -px/solar_mass 
  vx_offset + dup f!             \ p.vx             z: 
  py f@ solar_mass f/ fnegate    \ p.vx             z: -py/solar_mass 
  float+      dup f!             \ p.vy             z: 
  pz f@ solar_mass f/ fnegate    \ p.vy             z: -pz/solar_mass 
  float+          f!             \                  z: 
)
;



: scale_bodies ( p nbodies -- ) ( z: scale -- )  
  fdup fdup f*                  ( p nbodies ) ( z: scale scale*scale ) 
  for 
    fover fover                 ( p )         ( z: scale scale*scale scale scale*scale )
    dup dup f@ f* f!            ( p )         ( z: scale scale*scale scale )
    fdup fdup                   ( p )         ( z: scale scale*scale scale scale scale ) 
    vx_offset +                 ( p.vx )      ( z: scale scale*scale scale scale scale )
    dup dup f@ f* f!            ( p.vx )      ( z: scale scale*scale scale scale )
    float+                      ( p.vy )      ( z: scale scale*scale scale scale )
    dup dup f@ f* f!            ( p.vy )      ( z: scale scale*scale scale )
    float+                      ( p.vz )      ( z: scale scale*scale scale )
    dup dup f@ f* f!            ( p.vz )      ( z: scale scale*scale )
    float+                      ( p+1 )       ( z: scale scale*scale )
  next
  drop fdrop fdrop
;



1e-2 fconstant DT
100e fconstant RECIP_DT


bodies NBODIES 1- offset_momentum
\  bodies NBODIES 1- energy f. cr

DT bodies NBODIES 1- scale_bodies

999 for
  bodies NBODIES 1- advance
next

RECIP_DT bodies NBODIES 1- scale_bodies

\  bodies NBODIES 1- energy f. cr
\  bodies NBODIES 1- show_bodies
\  depth . cr
\  fdepth . cr
