include(`../M4/FIRST.M4')dnl
  ifdef __ORG
    org __ORG
  else
    org 32768
  endif
  INIT(60000)
;# /* The Computer Language Benchmarks Game
;#  * http://benchmarksgame.alioth.debian.org/
;#  *
;#  * contributed by Christoph Bauer
;#  * slightly sped up by Petr Prokhorenkov
;#  */
;# 


ZCONSTANT(_solar_mass,39.478417604357428482118055131396e)
;# mass x y z vx vy vz 

PUSH(7) ZFLOATS CONSTANT(_size_p) 
PUSH(4) ZFLOATS CONSTANT(_vx_offset)

ZVARIABLE(_px)
ZVARIABLE(_py)
ZVARIABLE(_pz)
ZVARIABLE(_pm)

CONSTANT(_NBODIES,5)
CREATE(_bodies)
  ;# sun 

  ZPUSH(_solar_mass) ZCOMMA 
  ZPUSH(0e) ZCOMMA 
  ZPUSH(0e) ZCOMMA 
  ZPUSH(0e) ZCOMMA 
  ZPUSH(0e) ZCOMMA 
  ZPUSH(0e) ZCOMMA 
  ZPUSH(0e) ZCOMMA 
  ;# jupiter 

  ZPUSH(0.037693674870389489455880787455473602957e) ZCOMMA 
  ZPUSH(4.84143144246472090e+00) ZCOMMA 
  ZPUSH(-1.16032004402742839e+00) ZCOMMA 
  ZPUSH(-1.03622044471123109e-01) ZCOMMA 
  ZPUSH(0.6063263929958320519656e) ZCOMMA 
  ZPUSH(2.81198684491625992827e) ZCOMMA 
  ZPUSH(-2.5218361659887629852052e-02) ZCOMMA 
  ;# saturn 

  ZPUSH(0.0112863261319687660871559412399584017726e) ZCOMMA 
  ZPUSH(8.34336671824457987e+00) ZCOMMA 
  ZPUSH(4.12479856412430479e+00) ZCOMMA 
  ZPUSH(-4.03523417114321381e-01) ZCOMMA 
  ZPUSH(-1.0107743461787922699364e) ZCOMMA 
  ZPUSH(1.8256623712304117200712e) ZCOMMA 
  ZPUSH(0.008415761376584153742796e) ZCOMMA 
  ;# uranus 

  ZPUSH(0.0017237240570597110309151884878251366745e) ZCOMMA 
  ZPUSH(1.28943695621391310e+01) ZCOMMA 
  ZPUSH(-1.51111514016986312e+01) ZCOMMA 
  ZPUSH(-2.23307578892655734e-01) ZCOMMA 
  ZPUSH(1.0827910064415353335832e) ZCOMMA 
  ZPUSH(0.86871301816960822178e) ZCOMMA 
  ZPUSH(-0.010832637401363636495344e) ZCOMMA 
  ;# neptune 

  ZPUSH(0.002033686869924630245154486521894305127e) ZCOMMA
  ZPUSH(1.53796971148509165e+01) ZCOMMA 
  ZPUSH(-2.59193146099879641e+01) ZCOMMA 
  ZPUSH(1.79258772950371181e-01) ZCOMMA 
  ZPUSH(0.9790907322438979596728e) ZCOMMA 
  ZPUSH(0.594698998647676158258e) ZCOMMA 
  ZPUSH(-0.03475595550407810243588e) ZCOMMA 
  
;#   : show_bodies \  p nbodies   
;#   ." sun fdepth: " fdepth . cr
;#   for 
;#     ."  m: " dup f@ f. cr float+      \ p.x
;#     ."  x: " dup f@ f. cr float+      \ p.y
;#     ."  y: " dup f@ f. cr float+      \ p.z
;#     ."  z: " dup f@ f. cr float+      \ p.vx
;#     ." vx: " dup f@ f. cr float+      \ p.vy
;#     ." vy: " dup f@ f. cr float+      \ p.vz
;#     ." vz: " dup f@ f. cr float+      \ p.mass
;#     cr
;#   next
;#   drop
;# ;
;# 



ZCONSTANT(_DT,1e-2)
ZCONSTANT(_RECIP_DT,100e)


PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_offset_momentum)
;#  bodies NBODIES 1- energy f. cr

ZPUSH(_DT) PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_scale_bodies)

PUSH(999) FOR
  PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_advance)
NEXT

ZPUSH(_RECIP_DT) PUSH(_bodies) PUSH(_NBODIES) _1SUB CALL(_scale_bodies)

;#  bodies NBODIES 1- energy f. cr
;#  bodies NBODIES 1- show_bodies
;#  depth . cr
;#  fdepth . cr
  STOP

COLON(_advance,({{{{ p nbodies -- }}}}))

  FOR                                    ;# p                     z: 
    DUP PUSH(_size_p) ADD TUCK                    ;# p+1 p p+1             z: 
    I IF I _1SUB FOR                        ;# p+1 p p+n             z:  
      DUP ZFETCH OVER DUP ZFETCH ZDUP ZDUP ZPUSH(1e)    ;# p+1 p p+n   p         z: mass2 mass mass mass 1 
      
           ZFLOATADD DUP ZFETCH                 ;# p+1 p p+n   p.x       z: mass2 mass mass mass 1 x 
      SWAP ZFLOATADD DUP ZFETCH ZSUB              ;# p+1 p p.x   p+n.x     z: mass2 mass mass mass 1 dx 
      ZDUP PUSH(_px) ZSTORE ZDUP ZMUL                 ;# p+1 p p.x   p+n.x     z: mass2 mass mass mass 1 dx*dx 
                                                                
      SWAP ZFLOATADD DUP ZFETCH                 ;# p+1 p p+n.x p.y       z: mass2 mass mass mass 1 dx*dx y 
      SWAP ZFLOATADD DUP ZFETCH ZSUB              ;# p+1 p p.y   p+n.y     z: mass2 mass mass mass 1 dx*dx dy 
      ZDUP PUSH(_py) ZSTORE ZDUP ZMUL                 ;# p+1 p p.y   p+n.y     z: mass2 mass mass mass 1 dx*dx dy*dy 

      SWAP ZFLOATADD DUP ZFETCH                 ;# p+1 p p+n.y p.z       z: mass2 mass mass mass 1 dx*dx dy*dy z 
      SWAP ZFLOATADD DUP ZFETCH ZSUB              ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass 1 dx*dx dy*dy dz 
      ZDUP PUSH(_pz) ZSTORE ZDUP ZMUL                 ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass 1 dx*dx dy*dy dz*dz 
                                                                  
      ZADD ZADD ZSQRT ZDIV                     ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass inv_distance 
      ZDUP ZDUP ZMUL ZMUL ZDUP ZDUP          ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass mag mag mag 
                                                                  
      PUSH(_pz) ZFETCH ZMUL PUSH(_pz) ZSTORE                     ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass mag mag 
      PUSH(_py) ZFETCH ZMUL PUSH(_py) ZSTORE                     ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass mag 
      PUSH(_px) ZFETCH ZMUL PUSH(_px) ZSTORE                     ;# p+1 p p.z   p+n.z     z: mass2 mass mass mass 

      PUSH(_px) ZFETCH ZMUL ZFLOATADD DUP ZFETCH ZADD DUP ZSTORE   ;# p+1 p p.z   p+n.vx    z: mass2 mass mass 
      PUSH(_py) ZFETCH ZMUL ZFLOATADD DUP ZFETCH ZADD DUP ZSTORE   ;# p+1 p p.z   p+n.vy    z: mass2 mass 
      PUSH(_pz) ZFETCH ZMUL ZFLOATADD DUP ZFETCH ZADD DUP ZSTORE   ;# p+1 p p.z   p+n.vz    z: mass2 

      SWAP                               ;# p+1 p p+n.vz p.z      z: mass2 

;#  26m 6.85s 1891 bytes
      ZDUP ZDUP                                  ;# p+1 p p+n.vz p.z      z: mass2 mass2 mass2
      PUSH(_px) ZFETCH ZMUL ZNEGATE ZFLOATADD DUP ZFETCH ZADD DUP ZSTORE   ;# p+1 p p+n.vz p.vx     z: mass2 mass2 
      PUSH(_py) ZFETCH ZMUL ZNEGATE ZFLOATADD DUP ZFETCH ZADD DUP ZSTORE   ;# p+1 p p+n.vz p.vy     z: mass2 
      PUSH(_pz) ZFETCH ZMUL ZNEGATE ZFLOATADD DUP ZFETCH ZADD DUP ZSTORE   ;# p+1 p p+n.vz p.vz     z:

;# \ 26m 1.89s 1915 bytes
;#       float+ dup f@ fover px f@ f* f- dup f! \ p+1 p p+n.vz p.vx     z: mass2 
;#       float+ dup f@ fover py f@ f* f- dup f! \ p+1 p p+n.vz p.vy     z: mass2 
;#       float+ dup f@ fswap pz f@ f* f- dup f! \ p+1 p p+n.vz p.vz     z: 
;# 

      DROP ZFLOATADD                        ;# p+1 p p+n+1           z: 
                                                                   
    NEXT THEN                                                      
                                                                  
    DROP DUP PUSH(_vx_offset) ADD SWAP ZFLOATADD     ;# p+1 p.vx p.x         z: 
    _2DUP ZFETCH ZFETCH ZADD DUP ZSTORE                 ;# p+1 p.vx p.x         z: 
    SWAP ZFLOATADD SWAP ZFLOATADD              ;# p+1 p.vy p.y         z: 
    _2DUP ZFETCH ZFETCH ZADD DUP ZSTORE                 ;# p+1 p.vy p.y         z: 
    ZFLOATADD DUP ZFETCH SWAP ZFLOATADD ZFETCH ZADD ZSTORE   ;# p+1                  z: 
  NEXT
  DROP
SEMICOLON

COLON(_energy,({{{{ p nbodies -- e }}}})) ;# z: -- e 

  ZPUSH(0e)                                 ;# p nbodies 
           ;# z: e 

  FOR                                                       
    DUP ZFETCH ZPUSH(2E) ZDIV                       ;# p         
           ;# z: e mass/2 
 
    DUP PUSH(_vx_offset) ADD                  ;# p p.vx    
           ;# z: e mass/2 

    DUP ZFETCH ZDUP ZMUL ZFLOATADD            ;# p p.vy    
           ;# z: e mass/2 vx*vx 
 
    DUP ZFETCH ZDUP ZMUL ZFLOATADD            ;# p p.vz    
           ;# z: e mass/2 vx*vx vy*vy 
 
        ZFETCH ZDUP ZMUL                   ;# p         
           ;# z: e mass/2 vx*vx vy*vy vz*vz 

    ZADD ZADD ZMUL ZADD                      ;# p         
           ;# z: e 

       
    DUP PUSH(_size_p) ADD TUCK                ;# p+1 p p+n 
           ;# z: e 

    I IF I _1SUB FOR                                        
      _2DUP                           ;# p+1 p p+n p p+n 
     ;# z: e 

      _2DUP ZFETCH ZFETCH ZMUL                  ;# p+1 p p+n p p+n 
     ;# z: e mass*mass2 

      
      SWAP ZFLOATADD DUP ZFETCH             ;# p+1 p p+n p+n p.x 
   ;# z: e mass*mass2 x 

      SWAP ZFLOATADD DUP ZFETCH ZSUB ZDUP ZMUL  ;# p+1 p p+n p.x p+n.x 
 ;# z: e mass*mass2 dx*dx 


      SWAP ZFLOATADD DUP ZFETCH             ;# p+1 p p+n p+n.x p.y 
 ;# z: e mass*mass2 dx*dx y 

      SWAP ZFLOATADD DUP ZFETCH ZSUB ZDUP ZMUL  ;# p+1 p p+n p.y p+n.y 
 ;# z: e mass*mass2 dx*dx dy*dy 


           ZFLOATADD     ZFETCH             ;# p+1 p p+n p.y       
 ;# z: e mass*mass2 dx*dx dy*dy z2 

           ZFLOATADD     ZFETCH ZSUB ZDUP ZMUL  ;# p+1 p p+n           
 ;# z: e mass*mass2 dx*dx dy*dy dz*dz 

      
      ZADD ZADD ZSQRT ZDIV ZSUB              ;# p+1 p p+n 
           ;# z: e 

      PUSH(_size_p) ADD                       ;# p+1 p p+n+1 
         ;# z: e 

    NEXT THEN
    _2DROP                            ;# p+1 
                 ;# z: e 

  NEXT
  DROP                               ;#  
                    ;# z: e 
             
SEMICOLON

COLON(_offset_momentum,({{{{ p nbodies -- }}}})) ;# z: -- 

  ZPUSH(0e) PUSH(_px) ZSTORE
  ZPUSH(0e) PUSH(_py) ZSTORE
  ZPUSH(0e) PUSH(_pz) ZSTORE  
  OVER SWAP                      ;# p p nbodies 
    ;# z: 

  FOR                            ;# p p+n 
          ;# z: 

    DUP ZFETCH ZDUP ZDUP PUSH(_vx_offset) ADD ;# p p+n.vx 
       ;# z: mass mass mass 
     
    DUP ZFETCH ZMUL                    ;# p p+n.vx 
       ;# z: mass mass mass*vx 

    PUSH(_px) ZFETCH ZADD PUSH(_px) ZSTORE ZFLOATADD        ;# p p+n.vy 
       ;# z: mass 

    DUP ZFETCH ZMUL                    ;# p p+n.vy 
       ;# z: mass mass*vy 

    PUSH(_py) ZFETCH ZADD PUSH(_py) ZSTORE ZFLOATADD        ;# p p+n.vz 
       ;# z: mass 

    DUP ZFETCH ZMUL                    ;# p p+n.vz 
       ;# z: mass*vz 

    PUSH(_pz) ZFETCH ZADD PUSH(_pz) ZSTORE ZFLOATADD        ;# p p+n+1 
        ;# z: 

  NEXT      
  DROP                           ;# p 
              ;# z: 


  PUSH(_pz) ZFETCH ZPUSH(_solar_mass) ZNEGATE       ;# p                z: pz -solar_mass 
  ZDUP ZDUP                      ;# p                z: pz -solar_mass -solar_mass -solar_mass 
  PUSH(_px) ZFETCH ZSWAP ZDIV                 ;# p                z: pz -solar_mass -solar_mass -px/solar_mass
  PUSH(_vx_offset) ADD DUP ZSTORE             ;# p.vx             z: pz -solar_mass -solar_mass
  PUSH(_py) ZFETCH ZSWAP ZDIV                 ;# p.vx             z: pz -solar_mass -py/solar_mass
  ZFLOATADD      DUP ZSTORE             ;# p.vy             z: pz -solar_mass
              ZDIV                 ;# p.vy             z: -pz/solar_mass 
  ZFLOATADD          ZSTORE             ;#                  z: 

;#   px f@ solar_mass f/ fnegate    \ p                z: -px/solar_mass 
;#   vx_offset + dup f!             \ p.vx             z: 
;#   py f@ solar_mass f/ fnegate    \ p.vx             z: -py/solar_mass 
;#   float+      dup f!             \ p.vy             z: 
;#   pz f@ solar_mass f/ fnegate    \ p.vy             z: -pz/solar_mass 
;#   float+          f!             \                  z: 
;# 

SEMICOLON

COLON(_scale_bodies,({{{{ p nbodies -- }}}})) ;# z: scale -- 
  
  ZDUP ZDUP ZMUL                  ;# p nbodies 
 ;# z: scale scale*scale 
 
  FOR 
    ZOVER ZOVER                 ;# p 
         ;# z: scale scale*scale scale scale*scale 

    DUP DUP ZFETCH ZMUL ZSTORE            ;# p 
         ;# z: scale scale*scale scale 

    ZDUP ZDUP                   ;# p 
         ;# z: scale scale*scale scale scale scale 
 
    PUSH(_vx_offset) ADD                 ;# p.vx 
      ;# z: scale scale*scale scale scale scale 

    DUP DUP ZFETCH ZMUL ZSTORE            ;# p.vx 
      ;# z: scale scale*scale scale scale 

    ZFLOATADD                      ;# p.vy 
      ;# z: scale scale*scale scale scale 

    DUP DUP ZFETCH ZMUL ZSTORE            ;# p.vy 
      ;# z: scale scale*scale scale 

    ZFLOATADD                      ;# p.vz 
      ;# z: scale scale*scale scale 

    DUP DUP ZFETCH ZMUL ZSTORE            ;# p.vz 
      ;# z: scale scale*scale 

    ZFLOATADD                      ;# p+1 
       ;# z: scale scale*scale 

  NEXT
  DROP ZDROP ZDROP
SEMICOLON
