  ifdef __ORG
    org __ORG
  else
    org 32768
  endif



;   ===  b e g i n  ===
    ld  [Stop+1], SP    ; 4:20      init   storing the original SP value when the "bye" word is used
    ld    L, 0x1A       ; 2:7       init   Upper screen
    call 0x1605         ; 3:17      init   Open channel
    ld   HL, 0xEA60     ; 3:10      init   Return address stack = 60000
    exx                 ; 1:4       init

_size EQU 8190          ;           8190 constant _size
__align_size EQU 0xFF00 & (_size + 255)
_flags EQU __align_flags_start+((256-_size) & 255)
__align_flags_end EQU __align_flags_start+__align_size   

    call _do__prime     ; 3:17      call ( -- )
Stop:                   ;           stop
    ld   SP, 0x0000     ; 3:10      stop   restoring the original SP value when the "bye" word is used
    ld   HL, 0x2758     ; 3:10      stop
    exx                 ; 1:4       stop
    ret                 ; 1:10      stop
;   =====  e n d  =====
;   ---  the beginning of a non-recursive function  ---
_do__prime:                   ;           : 
    ex   DE, HL               ; 1:4 
    ex  [SP],HL               ; 1:19      save nos and load ret
    push DE                   ; 1:11      save tos
    ld  [_do__prime_end+1],HL ; 3:16      :   ( ret -- )

  if ( 1 & (__align_size/256))
__rep   EQU __align_size/256
    ld   B, 0x80              ; 2:7       B = 128
  else
__rep   EQU __align_size/512
    ld   B, 0x00              ; 2:7       B = 256
  endif
    di                        ; 1:4
    ld   HL,257               ; 3:10
    ld  [$+10+__rep],SP       ; 4:20
    ld   SP,__align_flags_end ; 3:10
  REPT __rep
    push HL                   ; 1:11      B*rep*2=_flags_align_size
  ENDM
    djnz $-__rep              ; 2:8/13
    ld   SP, 0x0000           ; 3:10  
    ei                        ; 1:4
                              
    ld   DE, 0x0000           ; 3:10      DE = sum of PRIMES
    push DE                   ; 1:11
    ld    E, 0x03             ; 2:7       DE = 2*i + 3
    ld   BC, _flags           ; 3:10      BC = i + _flags
                              ;           HL = ??
                              
do101save:                    ;           8190 0 do_101(xm)
    ld    A,[BC]              ; 1:7       c@ if   ( addr -- ) bool: [addr] c<> 0
    or    A                   ; 1:4       c@ if
    ld    A, high __align_flags_end-1; 2:7
    jp    z, else101          ; 3:10      c@ if
                              
    ld    L, E                ; 1:4       
    ld    H, D                ; 1:4
    add  HL, BC               ; 1:11      HL = 2*i+3+i+_flags

    cp    H                   ; 1:4       tos u< (buff_end+1) --> HL-(buff_end+1)<0 --> no carry if false    
    jp    c, break101         ; 3:10      repeat 101
begin101:                     ;           begin(101)
    ld  [HL],0x00             ; 2:10      [_flags+3*i+3] = 0
    add  HL, DE               ; 1:11      HL += 2*i+3 --> HL += DE
    cp    H                   ; 1:4       tos u< (buff_end+1) --> HL-(buff_end+1)<0 --> no carry if false    
    jp   nc, begin101         ; 3:10      repeat 101
break101:                     ;           repeat 101
    pop  HL                   ; 1:10
    inc  HL                   ; 1:6       sum of PRIMES++
    push HL                   ; 1:11
else101  EQU $                ;           then  = endif
endif101:                     ;           then
idx101 EQU $+1                ;           loop_101(xm)   idx always points to a 16-bit index
    inc  DE                   ; 1:6       i++
    inc   E                   ; 1:4       i++  126*2+3=255
    inc  BC                   ; 1:6       i++
    cp    B                   ; 1:4       loop_101(xm)
    jp   nc, do101save        ; 3:10      loop_101(xm)
leave101:                     ;           loop_101(xm)
exit101:                      ;           loop_101(xm)

    pop  HL                   ; 1:10      sum of PRIMES
    call PRT_S16              ; 3:17      .   ( s -- )        
    ld    A, ' '              ; 2:7       space   Pollutes: AF, AF', DE', BC'
    rst   0x10                ; 1:11      space   putchar(reg A) with ZX 48K ROM

    ex   DE, HL               ; 1:4       tos

    ld   BC, 0x0006           ; 3:10      print({"PRIMES"})
    ld   DE, string101        ; 3:10      print({"PRIMES"})
    call 0x203C               ; 3:17      print({"PRIMES"})     Print our string with ZX 48K ROM
    
    pop  DE                   ; 1:10      nos
_do__prime_end:               ;           ;   
    jp   0x0000               ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;#------------------------------------------------------------------------------
;# Input: HL
;# Output: Print signed decimal number in HL
;# Pollutes: AF, BC, HL <- DE, DE <- [SP]
PRT_S16:                ;           prt_s16
    ld    A, H          ; 1:4       prt_s16
    add   A, A          ; 1:4       prt_s16
    jr   nc, PRT_U16    ; 2:7/12    prt_s16
    ld    A, '-'        ; 2:7       prt_s16   putchar Pollutes: AF, AF', DE', BC'
    rst   0x10          ; 1:11      prt_s16   putchar(reg A) with ZX 48K ROM
    xor   A             ; 1:4       prt_s16   neg
    sub   L             ; 1:4       prt_s16   neg
    ld    L, A          ; 1:4       prt_s16   neg
    sbc   A, H          ; 1:4       prt_s16   neg
    sub   L             ; 1:4       prt_s16   neg
    ld    H, A          ; 1:4       prt_s16   neg
    ; fall to prt_u16
;#------------------------------------------------------------------------------
;# Input: HL
;# Output: Print unsigned decimal number in HL
;# Pollutes: AF, BC, HL <- DE, DE <- [SP]
PRT_U16:                ;           prt_u16
    xor   A             ; 1:4       prt_u16   HL=103 & A=0 => 103, HL = 103 & A='0' => 00103
    ld   BC, -10000     ; 3:10      prt_u16
    call BIN16_DEC      ; 3:17      prt_u16
    ld   BC, -1000      ; 3:10      prt_u16
    call BIN16_DEC      ; 3:17      prt_u16
    ld   BC, -100       ; 3:10      prt_u16
    call BIN16_DEC      ; 3:17      prt_u16
    ld    C, -10        ; 2:7       prt_u16
    call BIN16_DEC      ; 3:17      prt_u16
    ld    A, L          ; 1:4       prt_u16
    pop  HL             ; 1:10      prt_u16   load ret
    ex  [SP],HL         ; 1:19      prt_u16
    ex   DE, HL         ; 1:4       prt_u16
    jr   BIN16_DEC_CHAR ; 2:12      prt_u16
;#------------------------------------------------------------------------------
;# Input: A = 0 or A = '0' = 0x30 = 48, HL, IX, BC, DE
;# Output: if ((HL/(-BC) > 0) || (A >= '0')) print number -HL/BC
;# Pollutes: AF, HL
    inc   A             ; 1:4       bin16_dec
BIN16_DEC:              ;           bin16_dec
    add  HL, BC         ; 1:11      bin16_dec
    jr    c, $-2        ; 2:7/12    bin16_dec
    sbc  HL, BC         ; 2:15      bin16_dec
    or    A             ; 1:4       bin16_dec
    ret   z             ; 1:5/11    bin16_dec   does not print leading zeros
BIN16_DEC_CHAR:         ;           bin16_dec
    or   '0'            ; 2:7       bin16_dec   1..9 --> '1'..'9', unchanged '0'..'9'
    rst   0x10          ; 1:11      bin16_dec   putchar(reg A) with ZX 48K ROM
    ld    A, '0'        ; 2:7       bin16_dec   reset A to '0'
    ret                 ; 1:10      bin16_dec

STRING_SECTION:
string101:
    db "PRIMES"
size101              EQU $ - string101
 if (size101 != 6)
   .error: Incorrectly calculated character string size, does not match the actual size!
 endif


VARIABLE_SECTION:


; Align to 256-byte page boundary.
; Any use of Allot with a negative value exceeding this address will result in undefined behavior.
    DEFS    (($ + 256 - 1) / (256)) * (256) - $

__align_flags_start:             ;           create _flags

;# ============================================================================
  if ($<0x0100)
    .error Overflow 64k! over 0..255 bytes
  endif
  if ($<0x0200)
    .error Overflow 64k! over 256..511 bytes
  endif
  if ($<0x0400)
    .error Overflow 64k! over 512..1023 bytes
  endif
  if ($<0x0800)
    .error Overflow 64k! over 1024..2047 bytes
  endif
  if ($<0x1000)
    .error Overflow 64k! over 2048..4095 bytes
  endif
  if ($<0x2000)
    .error Overflow 64k! over 4096..8191 bytes
  endif
  if ($<0x3000)
    .error Overflow 64k! over 8192..12287 bytes
  endif
  if ($<0x4000)
    .error Overflow 64k! over 12288..16383 bytes
  endif
  if ($>0xFF00)
    .warning Data ends at 0xFF00+ address!
  endif
; M4_FORTH compiler
; Mon 18 Mar 04:49:41 GMT 2024
; compilation time: 5.918668861 s
