;# Forth program from https://skilldrick.github.io/easyforth/
;# by Nick Morgan

  ifdef __ORG
    org __ORG
  else
    org 0x8000
  endif
    
    
    

















snake_x_head       EQU __c_snake_x_head



















     
                 
          
    

     
                
          
    



    



    



      
     
             
                 
    
      



       



      



     
         
              
        
    
    
    
    



     



     



     



     



     
           
               
         
         
        


; Move each segment of the snake forward by one

      
               
               
    



      
       
      



      
         
       


          

          

        

         


        
          
       
      
      



     
    
      


; get random x or y position within playable area

       



       
    



     



        
        

     
        
        
    


 ;( -- flag )
    ; get current x/y position
       

    

    ; leave boolean flag on stack
    



       
              
    

       
       
    



         


 ;( -- )
    
        
        
         
        
        
        
        
        
    
    


   

;   ===  b e g i n  ===
    ld  [Stop+1], SP    ; 4:20      init   storing the original SP value when the "bye" word is used
    ld    L, 0x1A       ; 2:7       init   Upper screen
    call 0x1605         ; 3:17      init   Open channel
    ld   HL, 0xEA60     ; 3:10      init   Return address stack = 60000
    exx                 ; 1:4       init
    call start          ; 3:17      scall
Stop:                   ;           stop
    ld   SP, 0x0000     ; 3:10      stop   restoring the original SP value when the "bye" word is used
    ld   HL, 0x2758     ; 3:10      stop
    exx                 ; 1:4       stop
    ret                 ; 1:10      stop
;   =====  e n d  =====
left EQU 0              ;           0 constant left
up EQU 1                ;           1 constant up
right EQU 2             ;           2 constant right
down EQU 3              ;           3 constant down
width EQU 32            ;           32 constant width
height EQU 24           ;           24 constant height
white EQU 0x3F          ;           0x3F constant white
red EQU 0x24            ;           0x24 constant red
black EQU 0             ;           0 constant black
graphics EQU 0x5800     ;           0x5800 constant graphics
last_key EQU 0x5C08     ;           0x5C08 constant last_key
                        ;           create snake_x_head
snake_y_head EQU snake_x_head+2*500;           snake_x_head+2*500 constant snake_y_head

;( x y -- )
; C = color
put_color:
    ld    A, L          ; 1:4
    add   A, A          ; 1:4       2x 24->48
    add   A, A          ; 1:4       4x 48->96
    add   A, A          ; 1:4       8x 96->192
    ld    L, A          ; 1:4
    add  HL, HL         ; 1:11      16x 192->384
    add  HL, HL         ; 1:11      32x 384->768
    add  HL, DE         ; 1:11
    ld   DE, graphics   ; 3:10
    add  HL, DE         ; 1:11
    ld  [HL],C          ; 1:7
    ret                 ; 1:10

;( x y -- color )
get_color:
    ld    A, L          ; 1:4
    add   A, A          ; 1:4       2x 24->48
    add   A, A          ; 1:4       4x 48->96
    add   A, A          ; 1:4       8x 96->192
    ld    L, A          ; 1:4
    add  HL, HL         ; 1:11      16x 192->384
    add  HL, HL         ; 1:11      32x 384->768
    add  HL, DE         ; 1:11
    ld   DE, graphics   ; 3:10
    add  HL, DE         ; 1:11
    ld    L,[HL]        ; 1:7
    ld    H, 0x00       ; 2:7
    ret                 ; 1:10
;   ---  the beginning of a non-recursive function  ---
draw_white:             ;           :   ( x y -- )
    pop  BC             ; 1:10      :   ret
    ld  [draw_white_end+1],BC; 4:20      :   ( ret -- )

    ld    C, white      ; 2:7
    call put_color      ; 3:17
    pop  HL             ; 1:10
    pop  DE             ; 1:10
draw_white_end:         ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a non-recursive function  ---
draw_black:             ;           :   ( x y -- )
    pop  BC             ; 1:10      :   ret
    ld  [draw_black_end+1],BC; 4:20      :   ( ret -- )

    ld    C, black      ; 2:7
    call put_color      ; 3:17
    pop  HL             ; 1:10
    pop  DE             ; 1:10
draw_black_end:         ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a non-recursive function  ---
draw:                   ;           :   ( color x y -- )
    pop  BC             ; 1:10      :   ret
    ld  [draw_end+1],BC ; 4:20      :   ( ret -- )

    pop   BC            ; 1:10
    call put_color      ; 3:17
    pop  HL             ; 1:10
    pop  DE             ; 1:10
draw_end:               ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a data stack function  ---
draw_walls:             ;           s:   
    push DE             ; 1:11      32-1
    ex   DE, HL         ; 1:4       32-1
    ld   HL, 31         ; 3:10      32-1
for101:                 ;           for_101(s) ( index -- index )
                        ;           i_101 0(s)   ( -- i 0 )
    push DE             ; 1:11      i_101 0(s)
    push HL             ; 1:11      i_101 0(s)
    ex   DE, HL         ; 1:4       i_101 0(s)
    ld   HL, 0          ; 3:10      i_101 0(s)
    call draw_black     ; 3:17      call ( -- )
                        ;           i_101 24-1(s)   ( -- i 23 )
    push DE             ; 1:11      i_101 24-1(s)
    push HL             ; 1:11      i_101 24-1(s)
    ex   DE, HL         ; 1:4       i_101 24-1(s)
    ld   HL, 23         ; 3:10      i_101 24-1(s)
    call draw_black     ; 3:17      call ( -- )
    ld    A, H          ; 1:4       next_101(s)
    or    L             ; 1:4       next_101(s)
    dec  HL             ; 1:6       next_101(s)   index--
    jp  nz, for101      ; 3:10      next_101(s)
leave101:               ;           next_101(s)
    ex   DE, HL         ; 1:4       unloop_101(s)   ( i -- )
    pop  DE             ; 1:10      unloop_101(s)
    push DE             ; 1:11      24-1
    ex   DE, HL         ; 1:4       24-1
    ld   HL, 23         ; 3:10      24-1
for102:                 ;           for_102(s) ( index -- index )
    push DE             ; 1:11      0 over   ( a -- a 0 a )
    push HL             ; 1:11      0 over
    ld   DE, 0          ; 3:10      0 over
    call draw_black     ; 3:17      call ( -- )
    push DE             ; 1:11      32-1 over   ( a -- a 31 a )
    push HL             ; 1:11      32-1 over
    ld   DE, 31         ; 3:10      32-1 over
    call draw_black     ; 3:17      call ( -- )
    ld    A, H          ; 1:4       next_102(s)
    or    L             ; 1:4       next_102(s)
    dec  HL             ; 1:6       next_102(s)   index--
    jp  nz, for102      ; 3:10      next_102(s)
leave102:               ;           next_102(s)
    ex   DE, HL         ; 1:4       unloop_102(s)   ( i -- )
    pop  DE             ; 1:10      unloop_102(s)
draw_walls_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a non-recursive function  ---
snake_x:                ;           :   ( offset -- address )
    pop  BC             ; 1:10      :   ret
    ld  [snake_x_end+1],BC; 4:20      :   ( ret -- )
    add  HL, HL         ; 1:11      2*
    ld   BC, snake_x_head; 3:10      snake_x_head +   
    add  HL, BC         ; 1:11      snake_x_head +   
snake_x_end:            ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a non-recursive function  ---
snake_y:                ;           :   ( offset -- address )
    pop  BC             ; 1:10      :   ret
    ld  [snake_y_end+1],BC; 4:20      :   ( ret -- )
    add  HL, HL         ; 1:11      2*
    ld   BC, 1000+snake_x_head; 3:10      snake_x_head+2*500 +   
    add  HL, BC         ; 1:11      snake_x_head+2*500 +   
snake_y_end:            ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a data stack function  ---
initialize_snake:       ;           s:   

                        ;[7:30]     4 length !   ( -- )  val=4, addr=length
    ld   BC, 4          ; 3:10      4 length !
    ld  [length], BC    ; 4:20      4 length !
    ld    A, 0x00       ; 2:7       4+1 0 do_103(xm)   8-bit loop
do103saveA:             ;           4+1 0 do_103(xm)
    ld  [idx103],A      ; 3:13      4+1 0 do_103(xm)
                        ;[8:43]     12 i_103   ( -- i i )
    push DE             ; 1:11      12 i_103
    push HL             ; 1:11      12 i_103
    ld    L, A          ; 1:4       12 i_103
    ld    H, high 0     ; 2:7       12 i_103
    ld   DE, 0x000C     ; 3:10      12 i_103
    ex   DE, HL         ; 1:4       -   ( x1 x0 -- x0 x2 )  x2 = x1 - x0
    or    A             ; 1:4       -
    sbc  HL, DE         ; 2:15      -
    ex   DE, HL         ; 1:4       - i_103   ( b a -- a [idx103] )
    ld   HL,[idx103]    ; 3:16      - i_103
    call snake_x        ; 3:17      call ( -- )
                        ;[3:20]     !   ( x addr -- x addr+1 )
    ld  [HL],E          ; 1:7       !
    inc  HL             ; 1:6       !
    ld  [HL],D          ; 1:7       !
                        ;[8:48]     12 i_103   ( -- 12 [idx103] )
    ld   HL,[idx103]    ; 3:16      12 i_103
    ld   DE, 0x000C     ; 3:10      12 i_103
    call snake_y        ; 3:17      call ( -- )
                        ;[3:20]     !   ( x addr -- x addr+1 )
    ld  [HL],E          ; 1:7       !
    inc  HL             ; 1:6       !
    ld  [HL],D          ; 1:7       !
    pop  HL             ; 1:10      !   ( x1 x0 -- )
    pop  DE             ; 1:10      !
                        ;[9:45/32]  loop_103(xm)   variant +1.nop: 8-bit loop and hi(index)=0, run 5x
idx103 EQU $+1          ;           loop_103(xm)   idx always points to a 16-bit index
    ld    A, 0          ; 2:7       loop_103(xm)   0.. +1 ..(5), real_stop:0x0005
    nop                 ; 1:4       loop_103(xm)   hi(index) = 0 = nop -> idx always points to a 16-bit index.
    inc   A             ; 1:4       loop_103(xm)   index++
    cp   0x05           ; 2:7       loop_103(xm)   lo(real_stop)
    jp   nz, do103saveA ; 3:10      loop_103(xm)   index-real_stop
leave103:               ;           loop_103(xm)
exit103:                ;           loop_103(xm)

                        ;[7:30]     2 direction !   ( -- )  val=2, addr=direction
    ld   BC, 2          ; 3:10      2 direction !
    ld  [direction], BC ; 4:20      2 direction !
initialize_snake_end:   ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a non-recursive function  ---
set_apple_position:     ;           :   ( y x -- )
    pop  BC             ; 1:10      :   ret
    ld  [set_apple_position_end+1],BC; 4:20      :   ( ret -- )
                        ;[5:30]     apple_x !   ( x -- )  addr=apple_x
    ld  [apple_x], HL   ; 3:16      apple_x !
    ex   DE, HL         ; 1:4       apple_x !
    pop  DE             ; 1:10      apple_x !
                        ;[5:30]     apple_y !   ( x -- )  addr=apple_y
    ld  [apple_y], HL   ; 3:16      apple_y !
    ex   DE, HL         ; 1:4       apple_y !
    pop  DE             ; 1:10      apple_y !
set_apple_position_end: ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a data stack function  ---
initialize_apple:       ;           s:   
                        ;[7:40]     4 4   ( -- 4 4 )
    push DE             ; 1:11      4 4
    push HL             ; 1:11      4 4
    ld   DE, 0x0004     ; 3:10      4 4
    ld    H, D          ; 1:4       4 4   H = D = 0x00
    ld    L, E          ; 1:4       4 4   L = E = 0x04
    call set_apple_position; 3:17      call ( -- )
initialize_apple_end:   ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
initialize:             ;           s:   
    ld    A, 31         ; 2:7       32-1 for_104   ( -- )
for104:                 ;           32-1 for_104
    ld  [idx104],A      ; 3:13      32-1 for_104   save index
    ld    A, 23         ; 2:7       24-1 for_105   ( -- )
for105:                 ;           24-1 for_105
    ld  [idx105],A      ; 3:13      24-1 for_105   save index
                        ;[9:58]     j_104 i_105   ( -- [idx104] [idx105] )
    push DE             ; 1:11      j_104 i_105
    push HL             ; 1:11      j_104 i_105
    ld   DE,[idx104]    ; 4:20      j_104 i_105
    ld   HL,[idx105]    ; 3:16      j_104 i_105
    call draw_white     ; 3:17      call ( -- )
idx105 EQU $+1          ;           next_105
    ld    A, 0x00       ; 2:7       next_105   idx always points to a 16-bit index
    nop                 ; 1:4       next_105
    sub  0x01           ; 2:7       next_105   index--
    jp   nc, for105     ; 3:10      next_105
leave105:               ;           next_105
idx104 EQU $+1          ;           next_104
    ld    A, 0x00       ; 2:7       next_104   idx always points to a 16-bit index
    nop                 ; 1:4       next_104
    sub  0x01           ; 2:7       next_104   index--
    jp   nc, for104     ; 3:10      next_104
leave104:               ;           next_104
    call draw_walls     ; 3:17      scall
    call initialize_snake; 3:17      scall
    call initialize_apple; 3:17      scall
initialize_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_up:                ;           s:   ( -- )
                        ;[9:46]     -1 snake_x_head+2*500 +!   ( -- )  [snake_x_head+2*500] += -1
    ld   BC,[1000+snake_x_head]; 4:20      -1 snake_x_head+2*500 +!
    dec  BC             ; 1:6       -1 snake_x_head+2*500 +!
    ld  [snake_x_head+2*500], BC; 4:20      -1 snake_x_head+2*500 +!
move_up_end:            ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_left:              ;           s:   ( -- )
                        ;[9:46]     -1 snake_x_head +!   ( -- )  [snake_x_head] += -1
    ld   BC,[snake_x_head]; 4:20      -1 snake_x_head +!
    dec  BC             ; 1:6       -1 snake_x_head +!
    ld  [snake_x_head], BC; 4:20      -1 snake_x_head +!
move_left_end:          ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_down:              ;           s:   ( -- )
                        ;[9:46]     1 snake_x_head+2*500 +!   ( -- )  [snake_x_head+2*500] += 1
    ld   BC,[1000+snake_x_head]; 4:20      1 snake_x_head+2*500 +!
    inc  BC             ; 1:6       1 snake_x_head+2*500 +!
    ld  [snake_x_head+2*500], BC; 4:20      1 snake_x_head+2*500 +!
move_down_end:          ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_right:             ;           s:   ( -- )
                        ;[9:46]     1 snake_x_head +!   ( -- )  [snake_x_head] += 1
    ld   BC,[snake_x_head]; 4:20      1 snake_x_head +!
    inc  BC             ; 1:6       1 snake_x_head +!
    ld  [snake_x_head], BC; 4:20      1 snake_x_head +!
move_right_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_snake_head:        ;           s:   ( -- )
    push DE             ; 1:11      direction @   ( -- [direction] )
    ex   DE, HL         ; 1:4       direction @
    ld   HL,[direction] ; 3:16      direction @
                        ;[5:18]     dup 0 = if   ( x -- x )  flag: x == 0
    ld    A, H          ; 1:4       dup 0 = if
    or    L             ; 1:4       dup 0 = if
    jp   nz, else101    ; 3:10      dup 0 = if
    call move_left      ; 3:17      scall
    jp   endif101       ; 3:10      else
else101:                ;           else

    ld    A, L          ; 1:4       dup 1 = if
    dec   A             ; 1:4       dup 1 = if   x[1] = 1
    or    H             ; 1:4       dup 1 = if   x[2] = 0
    jp   nz, else102    ; 3:10      dup 1 = if
    call move_up        ; 3:17      scall
    jp   endif102       ; 3:10      else
else102:                ;           else

    ld    A, 0x02       ; 2:7       dup 2 = if
    xor   L             ; 1:4       dup 2 = if   x[1] = 0x02
    or    H             ; 1:4       dup 2 = if   x[2] = 0
    jp   nz, else103    ; 3:10      dup 2 = if
    call move_right     ; 3:17      scall
    jp   endif103       ; 3:10      else
else103:                ;           else

    ld    A, 0x03       ; 2:7       dup 3 = if
    xor   L             ; 1:4       dup 3 = if   x[1] = 0x03
    or    H             ; 1:4       dup 3 = if   x[2] = 0
    jp   nz, else104    ; 3:10      dup 3 = if
    call move_down      ; 3:17      scall
else104  EQU $          ;           then  = endif
endif104:               ;           then
endif103:               ;           then
endif102:               ;           then
endif101:               ;           then
    ex   DE, HL         ; 1:4       drop
    pop  DE             ; 1:10      drop   ( a -- )
move_snake_head_end:    ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_snake_tail:        ;           s:   
    push DE             ; 1:11      length @   ( -- [length] )
    ex   DE, HL         ; 1:4       length @
    ld   HL,[length]    ; 3:16      length @
for106:                 ;           for_106(s) ( index -- index )
    push DE             ; 1:11      i_106 dup   ( a -- a a )
    ld    D, H          ; 1:4       i_106 dup
    ld    E, L          ; 1:4       i_106 dup
    push HL             ; 1:11      i_106 dup   ( b a -- a b a )
    call snake_x        ; 3:17      call ( -- )
    ld    A,[HL]        ; 1:7       @   ( addr -- x )
    inc  HL             ; 1:6       @
    ld    H,[HL]        ; 1:7       @
    ld    L, A          ; 1:4       @
    ex   DE, HL         ; 1:4       swap   ( b a -- a b )
    inc  HL             ; 1:6       1+
    call snake_x        ; 3:17      call ( -- )
                        ;[3:20]     !   ( x addr -- x addr+1 )
    ld  [HL],E          ; 1:7       !
    inc  HL             ; 1:6       !
    ld  [HL],D          ; 1:7       !
    pop HL              ; 1:11      i_106 dup   ( c b a -- b c )
    ld    E, L          ; 1:4       i_106 dup   ( b a -- a a )
    ld    D, H          ; 1:4       i_106 dup
    push HL             ; 1:11      i_106 dup   ( b a -- a b a )
    call snake_y        ; 3:17      call ( -- )
    ld    A,[HL]        ; 1:7       @   ( addr -- x )
    inc  HL             ; 1:6       @
    ld    H,[HL]        ; 1:7       @
    ld    L, A          ; 1:4       @
    ex   DE, HL         ; 1:4       swap   ( b a -- a b )
    inc  HL             ; 1:6       1+
    call snake_y        ; 3:17      call ( -- )
                        ;[3:20]     !   ( x addr -- x addr+1 )
    ld  [HL],E          ; 1:7       !
    inc  HL             ; 1:6       !
    ld  [HL],D          ; 1:7       !
    pop  HL             ; 1:10      !   ( x1 x0 -- )
    pop  DE             ; 1:10      !
    ld    A, H          ; 1:4       next_106(s)
    or    L             ; 1:4       next_106(s)
    dec  HL             ; 1:6       next_106(s)   index--
    jp  nz, for106      ; 3:10      next_106(s)
leave106:               ;           next_106(s)
    ex   DE, HL         ; 1:4       unloop_106(s)   ( i -- )
    pop  DE             ; 1:10      unloop_106(s)
move_snake_tail_end:    ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a non-recursive function  ---
is_horizontal:          ;           :   ( -- flag )
    pop  BC             ; 1:10      :   ret
    ld  [is_horizontal_end+1],BC; 4:20      :   ( ret -- )
    push DE             ; 1:11      direction @   ( -- [direction] )
    ex   DE, HL         ; 1:4       direction @
    ld   HL,[direction] ; 3:16      direction @
    push DE             ; 1:11      dup   ( a -- a a )
    ld    D, H          ; 1:4       dup
    ld    E, L          ; 1:4       dup
                        ;[5:29]     0 =   ( x -- bool )  bool: x == 0
    ld    A, H          ; 1:4       0 =
    dec  HL             ; 1:6       0 =
    sub   H             ; 1:4       0 =
    sbc  HL, HL         ; 2:15      0 =   HL = bool
    ex   DE, HL         ; 1:4       swap   ( b a -- a b )
                        ;[8:37]     2 =
    ld    A, 0x02       ; 2:7       2 =   lo(2)
    xor   L             ; 1:4       2 =
    or    H             ; 1:4       2 =
    sub  0x01           ; 2:7       2 =
    sbc  HL, HL         ; 2:15      2 =
    ld    A, E          ; 1:4       or   ( x1 x0 -- x1 x )  x = x0 | x1
    or    L             ; 1:4       or
    ld    L, A          ; 1:4       or
    ld    A, D          ; 1:4       or
    or    H             ; 1:4       or
    ld    H, A          ; 1:4       or
    pop  DE             ; 1:10      or   ( b a -- a )
is_horizontal_end:      ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a non-recursive function  ---
is_vertical:            ;           :   ( -- flag )
    pop  BC             ; 1:10      :   ret
    ld  [is_vertical_end+1],BC; 4:20      :   ( ret -- )
    push DE             ; 1:11      direction @   ( -- [direction] )
    ex   DE, HL         ; 1:4       direction @
    ld   HL,[direction] ; 3:16      direction @

    ld    A, L          ; 1:4       dup 1 =
    dec   A             ; 1:4       dup 1 =   x[1] = 1
    or    H             ; 1:4       dup 1 =   x[2] = 0
    sub 0x01            ; 2:7       dup 1 =
    ex   DE, HL         ; 1:4       dup 1 =
    push HL             ; 1:11      dup 1 =
    sbc  HL, HL         ; 2:15      dup 1 =   bool: x==1
    ex   DE, HL         ; 1:4       swap   ( b a -- a b )
                        ;[8:37]     3 =
    ld    A, 0x03       ; 2:7       3 =   lo(3)
    xor   L             ; 1:4       3 =
    or    H             ; 1:4       3 =
    sub  0x01           ; 2:7       3 =
    sbc  HL, HL         ; 2:15      3 =
    ld    A, E          ; 1:4       or   ( x1 x0 -- x1 x )  x = x0 | x1
    or    L             ; 1:4       or
    ld    L, A          ; 1:4       or
    ld    A, D          ; 1:4       or
    or    H             ; 1:4       or
    ld    H, A          ; 1:4       or
    pop  DE             ; 1:10      or   ( b a -- a )
is_vertical_end:        ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a data stack function  ---
turn_up:                ;           s:   
    call is_horizontal  ; 3:17      call ( -- )
    ld    A, H          ; 1:4       if
    or    L             ; 1:4       if
    ex   DE, HL         ; 1:4       if
    pop  DE             ; 1:10      if
    jp    z, else105    ; 3:10      if

                        ;[7:30]     1 direction !   ( -- )  val=1, addr=direction
    ld   BC, 1          ; 3:10      1 direction !
    ld  [direction], BC ; 4:20      1 direction !
else105  EQU $          ;           then  = endif
endif105:               ;           then
turn_up_end:            ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
turn_left:              ;           s:   
    call is_vertical    ; 3:17      call ( -- )
    ld    A, H          ; 1:4       if
    or    L             ; 1:4       if
    ex   DE, HL         ; 1:4       if
    pop  DE             ; 1:10      if
    jp    z, else106    ; 3:10      if

                        ;[7:30]     0 direction !   ( -- )  val=0, addr=direction
    ld   BC, 0          ; 3:10      0 direction !
    ld  [direction], BC ; 4:20      0 direction !
else106  EQU $          ;           then  = endif
endif106:               ;           then
turn_left_end:          ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
turn_down:              ;           s:   
    call is_horizontal  ; 3:17      call ( -- )
    ld    A, H          ; 1:4       if
    or    L             ; 1:4       if
    ex   DE, HL         ; 1:4       if
    pop  DE             ; 1:10      if
    jp    z, else107    ; 3:10      if

                        ;[7:30]     3 direction !   ( -- )  val=3, addr=direction
    ld   BC, 3          ; 3:10      3 direction !
    ld  [direction], BC ; 4:20      3 direction !
else107  EQU $          ;           then  = endif
endif107:               ;           then
turn_down_end:          ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
turn_right:             ;           s:   
    call is_vertical    ; 3:17      call ( -- )
    ld    A, H          ; 1:4       if
    or    L             ; 1:4       if
    ex   DE, HL         ; 1:4       if
    pop  DE             ; 1:10      if
    jp    z, else108    ; 3:10      if

                        ;[7:30]     2 direction !   ( -- )  val=2, addr=direction
    ld   BC, 2          ; 3:10      2 direction !
    ld  [direction], BC ; 4:20      2 direction !
else108  EQU $          ;           then  = endif
endif108:               ;           then
turn_right_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a non-recursive function  ---
change_direction:       ;           :   ( key -- )
    pop  BC             ; 1:10      :   ret
    ld  [change_direction_end+1],BC; 4:20      :   ( ret -- )

    ld    A, 0x6F       ; 2:7       dup char 'o' = if
    xor   L             ; 1:4       dup char 'o' = if   x[1] = 0x6F
    or    H             ; 1:4       dup char 'o' = if   x[2] = 0
    jp   nz, else109    ; 3:10      dup char 'o' = if
    call turn_left      ; 3:17      scall
    jp   endif109       ; 3:10      else
else109:                ;           else

    ld    A, 0x71       ; 2:7       dup char 'q' = if
    xor   L             ; 1:4       dup char 'q' = if   x[1] = 0x71
    or    H             ; 1:4       dup char 'q' = if   x[2] = 0
    jp   nz, else110    ; 3:10      dup char 'q' = if
    call turn_up        ; 3:17      scall
    jp   endif110       ; 3:10      else
else110:                ;           else

    ld    A, 0x70       ; 2:7       dup char 'p' = if
    xor   L             ; 1:4       dup char 'p' = if   x[1] = 0x70
    or    H             ; 1:4       dup char 'p' = if   x[2] = 0
    jp   nz, else111    ; 3:10      dup char 'p' = if
    call turn_right     ; 3:17      scall
    jp   endif111       ; 3:10      else
else111:                ;           else

    ld    A, 0x61       ; 2:7       dup char 'a' = if
    xor   L             ; 1:4       dup char 'a' = if   x[1] = 0x61
    or    H             ; 1:4       dup char 'a' = if   x[2] = 0
    jp   nz, else112    ; 3:10      dup char 'a' = if
    call turn_down      ; 3:17      scall
else112  EQU $          ;           then  = endif
endif112:               ;           then
endif111:               ;           then
endif110:               ;           then
endif109:               ;           then
    ex   DE, HL         ; 1:4       drop
    pop  DE             ; 1:10      drop   ( a -- )
change_direction_end:   ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a data stack function  ---
check_input:            ;           s:   
    push DE             ; 1:11      0x5C08 c@
    ex   DE, HL         ; 1:4       0x5C08 c@
    ld   HL,[23560]     ; 3:16      0x5C08 c@
    ld    H, 0x00       ; 2:7       0x5C08 c@
    call change_direction; 3:17      call ( -- )
    xor   A             ; 1:4       0 0x5C08 c!   lo(0) = 0x00
    ld  [23560], A      ; 3:13      0 0x5C08 c!
check_input_end:        ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
random_position:        ;           s:   ( n -- 2..n-3 )
    ld   BC, 0xFFFC     ; 3:10      4 -   ( x -- x-0x0004 )
    add  HL, BC         ; 1:11      4 -
    call Random         ; 3:17      random  ( u -- u2 ) u2: 0..u-1
    inc  HL             ; 1:6       2+
    inc  HL             ; 1:6       2+
random_position_end:    ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
move_apple:             ;           s:   
    push DE             ; 1:11      24
    ex   DE, HL         ; 1:4       24
    ld   HL, 24         ; 3:10      24
    call random_position; 3:17      scall
    push DE             ; 1:11      32
    ex   DE, HL         ; 1:4       32
    ld   HL, 32         ; 3:10      32
    call random_position; 3:17      scall
    call set_apple_position; 3:17      call ( -- )
move_apple_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
grow_snake:             ;           s:   
                        ;[9:46]     1 length +!   ( -- )  [length] += 1
    ld   BC,[length]    ; 4:20      1 length +!
    inc  BC             ; 1:6       1 length +!
    ld  [length], BC    ; 4:20      1 length +!
grow_snake_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
check_apple:            ;           s:   
                       ;[17:89]     snake_x_head @ apple_x @ =   ( -- bool )  bool: [snake_x_head] == [apple_x]
    push DE             ; 1:11      snake_x_head @ apple_x @ =
    ex   DE, HL         ; 1:4       snake_x_head @ apple_x @ =
    ld   BC,[snake_x_head]; 4:20      snake_x_head @ apple_x @ =
    ld   HL,[apple_x]   ; 3:16      snake_x_head @ apple_x @ =
    xor   A             ; 1:4       snake_x_head @ apple_x @ =   A = 0x00
    sbc  HL, BC         ; 2:15      snake_x_head @ apple_x @ =
    jr   nz, $+3        ; 2:7/12    snake_x_head @ apple_x @ =
    dec   A             ; 1:4       snake_x_head @ apple_x @ =   A = 0xFF
    ld    L, A          ; 1:4       snake_x_head @ apple_x @ =
    ld    H, A          ; 1:4       snake_x_head @ apple_x @ =   HL = bool
                       ;[17:89]     snake_x_head+2*500 @ apple_y @ =   ( -- bool )  bool: [1000+snake_x_head] == [apple_y]
    push DE             ; 1:11      snake_x_head+2*500 @ apple_y @ =
    ex   DE, HL         ; 1:4       snake_x_head+2*500 @ apple_y @ =
    ld   BC,[1000+snake_x_head]; 4:20      snake_x_head+2*500 @ apple_y @ =
    ld   HL,[apple_y]   ; 3:16      snake_x_head+2*500 @ apple_y @ =
    xor   A             ; 1:4       snake_x_head+2*500 @ apple_y @ =   A = 0x00
    sbc  HL, BC         ; 2:15      snake_x_head+2*500 @ apple_y @ =
    jr   nz, $+3        ; 2:7/12    snake_x_head+2*500 @ apple_y @ =
    dec   A             ; 1:4       snake_x_head+2*500 @ apple_y @ =   A = 0xFF
    ld    L, A          ; 1:4       snake_x_head+2*500 @ apple_y @ =
    ld    H, A          ; 1:4       snake_x_head+2*500 @ apple_y @ =   HL = bool
    ld    A, E          ; 1:4       and   ( x1 x0 -- x1 x )  x = x0 & x1
    and   L             ; 1:4       and
    ld    L, A          ; 1:4       and
    ld    A, D          ; 1:4       and
    and   H             ; 1:4       and
    ld    H, A          ; 1:4       and
    ld    A, H          ; 1:4       and if
    or    L             ; 1:4       and if
    pop  HL             ; 1:10      and if
    pop  DE             ; 1:10      and if
    jp    z, else113    ; 3:10      and if
    call move_apple     ; 3:17      scall
    call grow_snake     ; 3:17      scall
else113  EQU $          ;           then  = endif
endif113:               ;           then
check_apple_end:        ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a non-recursive function  ---
check_collision:        ;           :   
    pop  BC             ; 1:10      :   ret
    ld  [check_collision_end+1],BC; 4:20      :   ( ret -- )
                        ;[9:58]     snake_x_head @ snake_x_head+2*500 @   ( -- [snake_x_head] [1000+snake_x_head] )
    push DE             ; 1:11      snake_x_head @ snake_x_head+2*500 @
    push HL             ; 1:11      snake_x_head @ snake_x_head+2*500 @
    ld   DE,[snake_x_head]; 4:20      snake_x_head @ snake_x_head+2*500 @
    ld   HL,[1000+snake_x_head]; 3:16      snake_x_head @ snake_x_head+2*500 @

    ; get color at current position
    call get_color      ; 3:17
    pop  DE             ; 1:10
                        ;[5:29]     0=   ( x -- bool )  bool: x == 0
    ld    A, H          ; 1:4       0=
    dec  HL             ; 1:6       0=
    sub   H             ; 1:4       0=
    sbc  HL, HL         ; 2:15      0=   HL = bool
check_collision_end:    ;           ;   
    jp   0x0000         ; 3:10      ;
;   ---------  end of non-recursive function  ---------
;   ---  the beginning of a data stack function  ---
draw_snake:             ;           s:   
    push DE             ; 1:11      length @   ( -- [length] )
    ex   DE, HL         ; 1:4       length @
    ld   HL,[length]    ; 3:16      length @
    ld    A, L          ; 1:4       0 do_107 i_107(m)   ( stop 0 -- index )
    ld  [stp_lo107], A  ; 3:13      0 do_107 i_107(m)   lo stop
    ld    A, H          ; 1:4       0 do_107 i_107(m)
    ld  [stp_hi107], A  ; 3:13      0 do_107 i_107(m)   hi stop
    ld   HL, 0          ; 3:10      0 do_107 i_107(m)
do107save:              ;           0 do_107 i_107(m)
    ld  [idx107], HL    ; 3:16      0 do_107 i_107(m)   save index
    call snake_x        ; 3:17      call ( -- )
    push DE             ; 1:11      @ i_107
    ld    E,[HL]        ; 1:7       @ i_107
    inc  HL             ; 1:6       @ i_107
    ld    D,[HL]        ; 1:7       @ i_107
    ld   HL,[idx107]    ; 3:16      @ i_107
    call snake_y        ; 3:17      call ( -- )
    ld    A,[HL]        ; 1:7       @   ( addr -- x )
    inc  HL             ; 1:6       @
    ld    H,[HL]        ; 1:7       @
    ld    L, A          ; 1:4       @
    call draw_black     ; 3:17      call ( -- )
                      ;[20:68,89/87]loop_107(m)
    push DE             ; 1:11      loop_107(m)
    ex   DE, HL         ; 1:4       loop_107(m)
idx107 EQU $+1          ;           loop_107(m)   idx always points to a 16-bit index
    ld   HL, 0x0000     ; 3:10      loop_107(m)
    inc  HL             ; 1:6       loop_107(m)   index++
    ld    A, L          ; 1:4       loop_107(m)   lo new index
stp_lo107 EQU $+1       ;           loop_107(m)
    xor  0x00           ; 2:7       loop_107(m)   lo stop
    jp   nz, do107save  ; 3:10      loop_107(m)
    ld    A, H          ; 1:4       loop_107(m)   hi new index
stp_hi107 EQU $+1       ;           loop_107(m)
    xor  0x00           ; 2:7       loop_107(m)   hi stop
    jp   nz, do107save  ; 3:10      loop_107(m)
    ex   DE, HL         ; 1:4       loop_107(m)
    pop  DE             ; 1:10      loop_107(m)
leave107:               ;           loop_107(m)
exit107:                ;           loop_107(m)
    push DE             ; 1:11      length @   ( -- [length] )
    ex   DE, HL         ; 1:4       length @
    ld   HL,[length]    ; 3:16      length @
    call snake_x        ; 3:17      call ( -- )
    ld    A,[HL]        ; 1:7       @   ( addr -- x )
    inc  HL             ; 1:6       @
    ld    H,[HL]        ; 1:7       @
    ld    L, A          ; 1:4       @
    push DE             ; 1:11      length @   ( -- [length] )
    ex   DE, HL         ; 1:4       length @
    ld   HL,[length]    ; 3:16      length @
    call snake_y        ; 3:17      call ( -- )
    ld    A,[HL]        ; 1:7       @   ( addr -- x )
    inc  HL             ; 1:6       @
    ld    H,[HL]        ; 1:7       @
    ld    L, A          ; 1:4       @
    call draw_white     ; 3:17      call ( -- )
draw_snake_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
draw_apple:             ;           s:   
    push DE             ; 1:11      0x24 apple_x @
    push HL             ; 1:11      0x24 apple_x @
    ld   DE,36          ; 3:10      0x24 apple_x @
    ld   HL,[apple_x]   ; 3:16      0x24 apple_x @
    push DE             ; 1:11      apple_y @   ( -- [apple_y] )
    ex   DE, HL         ; 1:4       apple_y @
    ld   HL,[apple_y]   ; 3:16      apple_y @
    call draw           ; 3:17      call ( -- )
draw_apple_end:         ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
game_loop:              ;           s:   
begin101:               ;           begin(101)
    call draw_snake     ; 3:17      scall
    call draw_apple     ; 3:17      scall
    ei                  ; 1:4       7 wait   ( -- )
    ld    B, 0x07       ; 2:7       7 wait   7x
    halt                ; 1:70000   7 wait   0 .. 0.02 seconds
    djnz $-1            ; 2:8/13    7 wait
    call check_input    ; 3:17      scall
    call move_snake_tail; 3:17      scall
    call move_snake_head; 3:17      scall
    call check_apple    ; 3:17      scall
    call check_collision; 3:17      call ( -- )
    ld    A, H          ; 1:4       until(101)   ( bool -- )
    or    L             ; 1:4       until(101)
    ex   DE, HL         ; 1:4       until(101)
    pop  DE             ; 1:10      until(101)
    jp    z, begin101   ; 3:10      until(101)
break101:               ;           until(101)
    push DE             ; 1:11      print({"Game Over", 0xD})   ( b a -- b ? ? )
    ld   BC, 0x000A     ; 3:10      print({"Game Over", 0xD})
    ld   DE, string101  ; 3:10      print({"Game Over", 0xD})
    call 0x203C         ; 3:17      print({"Game Over", 0xD})     Print our string with ZX 48K ROM
    pop  DE             ; 1:10      print({"Game Over", 0xD})   ( b a -- a )
game_loop_end:          ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;   ---  the beginning of a data stack function  ---
start:                  ;           s:   
    call initialize     ; 3:17      scall
    call game_loop      ; 3:17      scall
start_end:              ;           s;   
    ret                 ; 1:10      s;
;   ---------  end of data stack function  ---------
;#==============================================================================
;# ( max -- rand )
;# 16-bit pseudorandom generator
;# HL = random < max, or HL = 0
Random:                 ;[41:]      Random
    ld    A, H          ; 1:4       Random
    or    A             ; 1:4       Random
    jr    z, Random_0L  ; 2:7/11    Random
    ld    C, 0xFF       ; 2:7       Random
    xor   A             ; 1:4       Random
    adc   A, A          ; 1:4       Random
    cp    H             ; 1:4       Random
    jr    c, $-2        ; 2:7/11    Random
    ld    B, A          ; 1:4       Random   BC = mask = 0x??FF
    jr   Random_Begin   ; 2:12      Random
Random_0L:              ;           Random
    ld    B, A          ; 1:4       Random
    or    L             ; 1:4       Random
    ret   z             ; 1:5/11    Random
    xor   A             ; 1:4       Random
    adc   A, A          ; 1:4       Random
    cp    L             ; 1:4       Random
    jr    c, $-2        ; 2:7/11    Random
    ld    C, A          ; 1:4       Random   BC = mask = 0x00??
;#------------------------------------------------------------------------------
;# In: BC = mask, HL = max
;# Out: HL = 0..max-1
Random_Begin:           ;           Random
    push  DE            ; 1:11      Random
    ex    DE, HL        ; 1:4       Random   DE = max
Random_Next:            ;           Random
    call Rnd            ; 3:17      Random
    ld    A, C          ; 1:4       Random
    and   L             ; 1:4       Random
    ld    L, A          ; 1:4       Random
    ld    A, B          ; 1:4       Random
    and   H             ; 1:4       Random
    ld    H, A          ; 1:4       Random
    sbc  HL, DE         ; 2:15      Random
    jr   nc, Random_Next; 2:7/11    Random
    add  HL, DE         ; 1:11      Random
    pop  DE             ; 1:10      Random
    ret                 ; 1:10      Random
;#==============================================================================
;# ( -- rand )
;# 16-bit pseudorandom generator
;# Out: HL = 0..65535
;# Pollutes: AF, AF', HL
Rnd:                    ;[44:182]   rnd
SEED_8BIT EQU $+1
    ld    L, 0x01       ; 2:7       rnd   seed must not be 0
    ld    A, L          ; 1:4       rnd
    rrca                ; 1:4       rnd
    rrca                ; 1:4       rnd
    rrca                ; 1:4       rnd
    xor  0x1F           ; 2:7       rnd   A = 32*L
    add   A, L          ; 2:7       rnd   A = 33*L
    sbc   A, 0xFF       ; 2:7       rnd   carry
    ld  (SEED_8BIT), A  ; 3:13      rnd   save new 8bit number
    ex   AF, AF'        ; 1:4       rnd
SEED EQU $+1
    ld   HL, 0x0001     ; 3:10      rnd   seed must not be 0
    ld    A, H          ; 1:4       rnd
    rra                 ; 1:4       rnd   hi.0 bit to carry
    ld    A, L          ; 1:4       rnd
    rra                 ; 1:4       rnd
    xor   H             ; 1:4       rnd
    ld    H, A          ; 1:4       rnd   hi(xs) ^= hi(xs << 7);
    ld    A, L          ; 1:4       rnd
    rra                 ; 1:4       rnd   lo.0 bit to carry
    ld    A, H          ; 1:4       rnd
    rra                 ; 1:4       rnd
    xor   L             ; 1:4       rnd
    ld    L, A          ; 1:4       rnd   lo(xs) ^= lo(xs << 7) + (xs >> 9);
    xor   H             ; 1:4       rnd
    ld    H, A          ; 1:4       rnd   xs ^= xs << 8;
    ld  (SEED), HL      ; 3:16      rnd   save new 16bit number
    ex   AF, AF'        ; 1:4       rnd
    xor   L             ; 1:4       rnd
    ld    L, A          ; 1:4       rnd
    ld    A, R          ; 2:9       rnd
    xor   H             ; 1:4       rnd
    ld    H, A          ; 1:4       rnd
    ret                 ; 1:10      rnd

STRING_SECTION:
string101:
    db "Game Over", 0xD
size101              EQU $ - string101
 if (size101 != 10)
   .error: Incorrectly calculated character string size, does not match the actual size!
 endif


VARIABLE_SECTION:

apple_x:                ;           variable apple_x
    dw 0                ;           variable apple_x
apple_y:                ;           variable apple_y
    dw 0                ;           variable apple_y
direction:              ;           variable direction
    dw 0                ;           variable direction
length:                 ;           variable length
    dw 0                ;           variable length
__c_snake_x_head:       ;           create snake_x_head

;# ============================================================================
  if ($<0x0100)
    .error Overflow 64k! over 0..255 bytes
  endif
  if ($<0x0200)
    .error Overflow 64k! over 256..511 bytes
  endif
  if ($<0x0400)
    .error Overflow 64k! over 512..1023 bytes
  endif
  if ($<0x0800)
    .error Overflow 64k! over 1024..2047 bytes
  endif
  if ($<0x1000)
    .error Overflow 64k! over 2048..4095 bytes
  endif
  if ($<0x2000)
    .error Overflow 64k! over 4096..8191 bytes
  endif
  if ($<0x3000)
    .error Overflow 64k! over 8192..12287 bytes
  endif
  if ($<0x4000)
    .error Overflow 64k! over 12288..16383 bytes
  endif
  if ($>0xFF00)
    .warning Data ends at 0xFF00+ address!
  endif
; M4_FORTH compiler
; Thu 15 Feb 18:13:17 GMT 2024
; compilation time: 34.66643532 s
