dnl ## ZX Spectrum 48 ROM Floating point Arithmetic
dnl
dnl
dnl
dnl # $1 = sign (1 bit)
dnl # $2 = exponent (8 bit)
dnl # $3 = mantissa (64 bit)
define({__SET_ZXFLOAT},{dnl
__{}define({ZXTEMP_EXP},substr(__HEX_L($2),2)){}dnl
__{}define({ZXTEMP_MANTISSA_1},format({%02X},eval(128*$1+(($3>>24) & 0x7F)))){}dnl
__{}define({ZXTEMP_MANTISSA_2},substr(__HEX_E($3),2)){}dnl
__{}define({ZXTEMP_MANTISSA_3},substr(__HEX_H($3),2)){}dnl
__{}define({ZXTEMP_MANTISSA_4},substr(__HEX_L($3),2)){}dnl
__{}define({ZXTEMP_REDUCED_SIZE},0){}dnl
__{}define({ZXTEMP_REDUCED_M_2},ZXTEMP_MANTISSA_2){}dnl
__{}define({ZXTEMP_REDUCED_M_3},ZXTEMP_MANTISSA_3){}dnl
__{}define({ZXTEMP_REDUCED_M_4},ZXTEMP_MANTISSA_4){}dnl
__{}define({ZXTEMP_REDUCED_SIZE},4){}dnl
__{}ifelse(ZXTEMP_MANTISSA_4,00,{dnl
__{}__{}define({ZXTEMP_REDUCED_SIZE},3){}dnl
__{}__{}define({ZXTEMP_REDUCED_M_4},{})}){}dnl
__{}ifelse(ZXTEMP_MANTISSA_4:ZXTEMP_MANTISSA_3,00:00,{dnl
__{}__{}define({ZXTEMP_REDUCED_SIZE},2){}dnl
__{}__{}define({ZXTEMP_REDUCED_M_3},{})}){}dnl
__{}ifelse(ZXTEMP_MANTISSA_4:ZXTEMP_MANTISSA_3:ZXTEMP_MANTISSA_2,00:00:00,{dnl
__{}__{}define({ZXTEMP_REDUCED_SIZE},1){}dnl
__{}__{}define({ZXTEMP_REDUCED_M_2},{})}){}dnl
__{}ifelse(eval(($2>0x50) && ($2<=0x8F)),1,{dnl
__{}__{}define({ZXTEMP_REDUCED_E1},__HEX_L(($2-0x50)+(ZXTEMP_REDUCED_SIZE-1)*0x40)){}dnl
__{}__{}define({ZXTEMP_REDUCED_E2},{})},
__{}{dnl
__{}__{}define({ZXTEMP_REDUCED_E1},__HEX_L((ZXTEMP_REDUCED_SIZE-1)*0x40)){}dnl
__{}__{}define({ZXTEMP_REDUCED_E2},__HEX_L($2-0x50)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
define({FSTRING_TO_ZHEX},{dnl
__{}define({$0_SIGN},0){}dnl
__{}ifelse(substr($1,0,1),{-},{dnl
__{}__{}define({$0_SIGN},1){}dnl
__{}__{}define({$0_HEX_REAL},{__HEX_FLOAT(substr($1,1))})},
__{}substr($1,0,1),{+},{dnl
__{}__{}define({$0_HEX_REAL},{__HEX_FLOAT(substr($1,1))})},
__{}{dnl
__{}__{}define({$0_HEX_REAL},{__HEX_FLOAT($1)})}){}dnl
__{}dnl
__{}ifelse($0_HEX_REAL,{0x0p+0},{dnl
__{}__{}__SET_ZXFLOAT(0,0,0)},
__{}$0_SIGN:$0_HEX_REAL,{1:inf},{
__{}__{}  .WARNING You are trying to convert "-inf" to ZX floating point format. It will be converted as a smallest possible value.{}dnl
__{}__{}__SET_ZXFLOAT(1,0xFF,0x7FFFFFFF)},
__{}$0_HEX_REAL,{inf},{
__{}__{}  .WARNING You are trying to convert "+inf" to ZX floating point format. It will be converted as a largest possible value.{}dnl
__{}__{}__SET_ZXFLOAT(0,0xFF,0x7FFFFFFF)},
__{}$0_HEX_REAL,{nan},{
__{}__{}  .WARNING You are trying to convert "Not a Number" to ZX floating point format. It will be converted as a zero.{}dnl
__{}__{}__SET_ZXFLOAT(0,0,0)},
__{}{dnl
__{}__{}dnl    ;# Výpočet exponentu
__{}__{}define({$0_EXP},{eval(substr($0_HEX_REAL,incr(index($0_HEX_REAL,{p}))) + 0x81)}){}dnl
__{}__{}dnl    ;# Výpočet mantisy
__{}__{}define({$0_MAN},{substr($0_HEX_REAL,incr(index($0_HEX_REAL,{x})),eval(index($0_HEX_REAL,{p})-index($0_HEX_REAL,{x})-1))}){}dnl
__{}__{}ifelse(substr($0_MAN,0,2),{1.},{dnl
__{}__{}__{}define({$0_MAN},substr($0_MAN,2))},
__{}__{}{dnl
__{}__{}__{}define({$0_MAN},substr($0_MAN,1))}){}dnl
__{}__{}define({$0_MAN},{0x}substr($0_MAN{00000000},0,8)){}dnl
__{}__{}define({$0_ROUND_BIT},eval($0_MAN & 1)){}dnl
__{}__{}define({$0_MAN},eval((($0_MAN>>1) & 0x7FFFFFFF)+$0_ROUND_BIT)){}dnl
__{}__{}ifelse(__HEX_D($0_MAN),0x80,{dnl
__{}__{}__{}define({$0_EXP},incr($0_EXP)){}dnl
__{}__{}__{}define({$0_MAN},0)}){}dnl
__{}__{}dnl
__{}__{}ifelse(1,0,{errprint({
;---------
;    orig:$1
;orig_hex: }__HEX_FLOAT($1){
;       s: }$0_SIGN{
;       e: }$0_EXP = __HEX_L($0_EXP) = eval($0_EXP-0x81){
;       m: }__HEX_DEHL($0_MAN){
})}){}dnl
__{}__{}dnl
__{}__{}ifelse(eval($0_EXP <= 0),1,{
__{}__{}__{}  .WARNING The value "$1" is too close to zero, so it will be changed to a zero.{}dnl
__{}__{}__{}__SET_ZXFLOAT(0,0,0)},
__{}__{}eval(($0_EXP > 0xFF) && $0_SIGN ),1,{
__{}__{}__{}  .WARNING The value "$1" is less than the smallest possible value, so it will be changed to the smallest possible value.{}dnl
__{}__{}__{}__SET_ZXFLOAT(1,0xFF,0x7FFFFFFF)},
__{}__{}eval($0_EXP > 0xFF),1,{
__{}__{}__{}  .WARNING The value "$1" is greater than the largest possible value, so it will be changed to the largest possible value.{}dnl
__{}__{}__{}__SET_ZXFLOAT(0,0xFF,0x7FFFFFFF)},
__{}__{}{dnl   ;# Sestavení hexadecimální hodnoty
__{}__{}__{}__SET_ZXFLOAT($0_SIGN,$0_EXP,$0_MAN){}dnl
__{}__{}}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl # ---------------------
dnl
dnl
dnl
define({ZCONSTANT},{dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing parameters!},
__{}$#,{1},{dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZCONSTANT},{zconstant $1},{$1})},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}__ADD_TOKEN(__TOKEN_ZCONSTANT,{$1 zconstant $2},$@){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
define({__ASM_TOKEN_ZCONSTANT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing parameters!},
__{}$#,{1},{
__{}__{}  .error {$0}($@): The second parameter is missing!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}format({%-24s},{}){;           }__INFO{}dnl
__{}__{}define({$1},{$2}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # zdepth
dnl # ( -- 0 ) if ( Z: -- )
dnl # ( -- 1 ) if ( Z: z -- z )
dnl # ( -- 2 ) if ( Z: z2 z1 -- z2 z1 )
dnl # ( -- n ) if ( Z: zn .. z1 -- zn .. z1 )
dnl # n is the number of floating-point values contained in the calculator stack
define({ZDEPTH},{dnl
__{}__ADD_TOKEN({__TOKEN_ZDEPTH},{zdepth},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDEPTH},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>0),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__def({USE_ZDEPTH})
__{}__{}    call _ZDEPTH        ; 3:17      __INFO   ( -- n ) if ( Z: zn .. z1 -- zn .. z1 )}){}dnl
}){}dnl
dnl
dnl
dnl
define({ZFLOAT2ARRAY},{dnl
__{}__ADD_TOKEN({__TOKEN_ZFLOAT2ARRAY},{zfloat2array},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZFLOAT2ARRAY},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
dnl
__{}FSTRING_TO_ZHEX($1){}dnl
__{}DB 0x{}ZXTEMP_EXP,0x{}ZXTEMP_MANTISSA_1,0x{}ZXTEMP_MANTISSA_2,0x{}ZXTEMP_MANTISSA_3,0x{}ZXTEMP_MANTISSA_4 ; = $1 = __HEX_FLOAT($1){}dnl
}){}dnl
dnl
dnl
dnl # z@
define({ZFETCH},{dnl
__{}__ADD_TOKEN({__TOKEN_ZFETCH},{z@},$@){}dnl
dnl ;#__{}__ADD_TOKEN({__TOKEN_OVER_SWAP},{z@},$@){}dnl
dnl ;#__{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto},$@){}dnl
dnl ;#__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZFETCH},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>0),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__def({USE_ZFETCH})
__{}__{}    call _ZFETCH        ; 3:17      __INFO   ( addr -- ) ( Z: -- z )}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HL_ZFETCH},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>0),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}    call 0x33B4         ; 3:382     __INFO   call {ZX ROM} floating-point number stack routine{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # dup z@ ( a -- a ) ( z: -- z0 )
dnl define({DUP_ZFETCH},{dnl
dnl __{}__ADD_TOKEN({__TOKEN_2DUP},{dup z@},$@){}dnl
dnl __{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto},$@){}dnl
dnl __{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto},$@){}dnl
dnl }){}dnl
dnl
dnl
dnl
dnl # 2drop dup z@ ( a x1 x0 -- a ) ( z: -- z0 )
define({_2DROP_DUP_ZFETCH},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_OVER},{2drop dup z@},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto},$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2drop swap dup z@ ( a2 a1 x1 x0 -- a1 a2 ) ( z: -- z2 )
define({_2DROP_SWAP_DUP_ZFETCH},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_ROT},{2drop swap dup z@}){}dnl
__{}__ADD_TOKEN({__TOKEN_TUCK},{__dtto}){}dnl
__{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto}){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto}){}dnl
}){}dnl
dnl
dnl
dnl # 2drop swap $1 + dup z@ ( a1 a0 x1 x0 -- a0 a1+$1 ) ( z: -- z0 )
define({_2DROP_SWAP_PUSH_ADD_DUP_ZFETCH},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_ROT},{2drop swap $1 + dup z@}{}dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_ADD},{__dtto},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_TUCK},{__dtto}){}dnl
__{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto}){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto}){}dnl
}){}dnl
dnl
dnl
dnl # 2drop $1 + dup z@ ( a x1 x0 -- a+$1 ) ( z: -- z0 )
define({_2DROP_PUSH_ADD_DUP_ZFETCH},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_SWAP},{2drop $1 + dup z@}{}dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_ADD},{__dtto},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_TUCK},{__dtto}){}dnl
__{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto}){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto}){}dnl
}){}dnl
dnl
dnl
dnl # 2drop $1 z@ ( -- ) ( z: -- z0 )
define({_2DROP_PUSH_ZFETCH},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_PUSH},{2drop $1 z@},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto}){}dnl
}){}dnl
dnl
dnl
dnl # $1 z@ ( -- ) ( z: -- z0 )
dnl define({PUSH_ZFETCH},{dnl
dnl __{}__ADD_TOKEN({__TOKEN_2DUP},{$1 z@}){}dnl
dnl __{}__ADD_TOKEN({__TOKEN_DROP_PUSH},{__dtto},$@){}dnl
dnl __{}__ADD_TOKEN({__TOKEN_HL_ZFETCH},{__dtto}){}dnl
dnl __{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto}){}dnl
dnl }){}dnl
dnl
dnl
dnl
dnl # z!
define({ZSTORE},{dnl
__{}__ADD_TOKEN({__TOKEN_ZSTORE},{z!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>0),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__def({USE_ZSTORE})
__{}__{}    call _ZSTORE        ; 3:17      __INFO   ( addr -- ) ( Z: z -- )}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 1E -2.3E-5 etc. adr z!
define({ZPUSH_PUSH_ZSTORE},{dnl
__{}ifelse(eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}__IS_NUM($1),0,{dnl ;# hex floating?
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_PUSH_ZSTORE},{$1 $2 !z},$@)},
__{}$1,{$1},{dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_PUSH_ZSTORE},{$1 $2 !z},eval($1),$2)},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_PUSH_ZSTORE},{const_$1 $2 !z},eval($1),$2){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZPUSH_PUSH_ZSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}{
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __INFO   = __HEX_FLOAT($1)
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION($2)]){,}A); 3:13      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC   = 0x{}ZXTEMP_EXP{}ZXTEMP_MANTISSA_1{}{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(1+$2)]){,}BC); 4:20      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3,BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(3+$2)]){,}BC); 4:20      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
define({__ASM_TOKEN_ZPUSH_PUSH_ZSTORE_FIRST_REP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}{dnl
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}define({$0_CODE_A},__LD_REG8(A, 0x{}ZXTEMP_EXP,A,$0_A,BC,$0_BC)){}dnl
__{}__{}$0_CODE_A
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION($2)]){,}A); 3:13      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP,BC,$0_BC)){}$0_BC   = 0x{}ZXTEMP_EXP{}ZXTEMP_MANTISSA_1{}{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(1+$2)]){,}BC); 4:20      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3,BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(3+$2)]){,}BC); 4:20      __INFO{}dnl
__{}__{}define({$0_A},0x{}ZXTEMP_EXP){}dnl
__{}__{}define({$0_BC},0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3){}dnl
__{}__{}ifelse(eval($#>2),1,{$0(shift(shift($@)))}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
define({__ASM_TOKEN_ZPUSH_PUSH_ZSTORE_FIRST},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}{
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __INFO   = __HEX_FLOAT($1)
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION($2)]){,}A); 3:13      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC   = 0x{}ZXTEMP_EXP{}ZXTEMP_MANTISSA_1{}{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(1+$2)]){,}BC); 4:20      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3,BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(3+$2)]){,}BC); 4:20      __INFO{}dnl
__{}__{}define({$0_REP_A},0x{}ZXTEMP_EXP){}dnl
__{}__{}define({$0_REP_BC},0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3){}dnl
__{}__{}ifelse(eval($#>2),1,{$0_REP(shift(shift($@)))}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2drop adr z!
define({_2DROP_PUSH_ZSTORE},{dnl
__{}ifelse(eval($#<1),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_NIP_PUSH_SWAP},{2drop $1 !z},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_DE_ZSTORE},{__dtto}){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},__dtto){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DE_ZSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#>0),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}__def({USE_DE_ZSTORE}){}dnl
__{}__{}    call _DE_ZSTORE     ; 3:17      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HL_ZSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#>0),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}__def({USE_HL_ZSTORE}){}dnl
__{}__{}    call _HL_ZSTORE     ; 3:17      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2drop 1e adr z!
define({_2DROP_ZPUSH_PUSH_ZSTORE},{dnl
__{}ifelse(eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}__IS_NUM($1),0,{dnl ;# hex floating?
__{}__{}__ADD_TOKEN({__TOKEN_2DROP_ZPUSH_PUSH_ZSTORE},{2drop $1 $2 !z},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},__dtto)},
__{}$1,{$1},{dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP_ZPUSH_PUSH_ZSTORE},{2drop $1 $2 !z},eval($1),$2){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},__dtto)},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP_ZPUSH_PUSH_ZSTORE},{2drop const_$1 $2 !z},eval($1),$2){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},__dtto){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DROP_ZPUSH_PUSH_ZSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameters!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}{
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __INFO   = __HEX_FLOAT($1)
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION($2)]){,}A); 3:13      __INFO{}dnl
__{}__{}define({$0_HL},__LD_R16(HL,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_HL   = 0x{}ZXTEMP_EXP{}ZXTEMP_MANTISSA_1{}{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(1+$2)]){,}HL); 3:16      __INFO{}dnl
__{}__{}define({$0_HL},__LD_R16(HL,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3,HL,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_HL
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(3+$2)]){,}HL); 3:16      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # zover
define({ZOVER},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZOVER_INLINE},{zover},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZOVER},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZOVER})
__{}    call _ZOVER         ; 3:17      __INFO   ( Z: z1 z2 -- z1 z2 z1 )}){}dnl
dnl
dnl
dnl # zover
define({ZOVER_INLINE},{dnl
__{}__ADD_TOKEN({__TOKEN_ZOVER_INLINE},{zover},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZOVER_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x01            ; 1:        __INFO   exchange
__{}    db  0xC2            ; 1:        __INFO   st_mem_2
__{}    db  0x01            ; 1:        __INFO   exchange
__{}    db  0xE2            ; 1:        __INFO   get_mem_2{}dnl
}){}dnl
dnl
dnl
dnl # zpick
define({ZPICK},{dnl
__{}__ADD_TOKEN({__TOKEN_ZPICK},{zpick},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZPICK},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>0),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__def({USE_ZPICK})
__{}__{}    call _ZPICK         ; 3:17      __INFO   ( u -- ) ( Z: zu .. z1 z0 -- zu .. z1 z0 zu )}){}dnl
}){}dnl
dnl
dnl
dnl # $1 zpick
define({PUSH_ZPICK},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_ZPICK},{$1 zpick},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_ZPICK},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>1),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),1,{dnl
__{}__{}__ASM_TOKEN_PUSH($1){}dnl
__{}__{}__ASM_TOKEN_ZPICK},
__{}__IS_NUM($1),0,{dnl
__{}__{}__ASM_TOKEN_PUSH($1){}dnl
__{}__{}__ASM_TOKEN_ZPICK},
__{}{dnl
__{}__{}ifelse(eval(($1)<0),{1},{
__{}__{}__{}    .error {$0}($@): Negative parameter! 1 and higher are supported.},
__{}__{}eval(($1)>50),{1},{
__{}__{}__{}__def({USE_ZPICK_BC})
__{}__{}__{}    ld   BC, __HEX_HL(-5*($1+1))     ; 3:10      __INFO   ( Z: z$1 .. z0 -- z$1 .. z0 z$1 )
__{}__{}__{}    call _ZPICK_BC      ; 3:17      __INFO},
__{}__{}{dnl
__{}__{}__{}__def({USE_ZPICK_C})
__{}__{}__{}    ld    C, __HEX_L(-5*($1+1))       ; 2:7       __INFO   ( Z: z$1 .. z0 -- z$1 .. z0 z$1 )
__{}__{}__{}    call _ZPICK_C       ; 3:17      __INFO}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # zrot
define({ZROT},{dnl
__{}__ADD_TOKEN({__TOKEN_ZROT},{zrot},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZROT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZROT})
__{}    call _ZROT          ; 3:17      __INFO   ( Z: z3 z2 z1 -- z2 z1 z3 )}){}dnl
dnl
dnl
dnl # z-rot
define({ZNROT},{dnl
__{}__ADD_TOKEN({__TOKEN_ZNROT},{z-rot},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZNROT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZNROT})
__{}    call _ZNROT         ; 3:17      __INFO   ( Z: z3 z2 z1 -- z1 z3 z2 )}){}dnl
dnl
dnl
dnl # zdrop
define({ZDROP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZDROP_INLINE},{zdrop},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDROP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZDROP})
__{}    call _ZDROP         ; 3:17      __INFO   ( Z: z -- )}){}dnl
dnl
define({__ASM_TOKEN_ZDROP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x02            ; 1:        __INFO   calc-delete ( Z: z1 -- ){}dnl
}){}dnl
dnl
dnl
dnl # z2drop
dnl # zdrop zdrop
define({Z2DROP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_Z2DROP_INLINE},{z2drop},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_Z2DROP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_Z2DROP})
__{}    call _Z2DROP        ; 3:17      __INFO   ( Z: z2 z1 -- )}){}dnl
dnl
define({__ASM_TOKEN_Z2DROP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x02            ; 1:        __INFO   calc-delete ( Z: z2 z1 -- )
__{}    db  0x02            ; 1:        __INFO   calc-delete{}dnl
}){}dnl
dnl
dnl
dnl # zdrops
define({ZDROPS},{dnl
__{}__ADD_TOKEN({__TOKEN_ZDROPS},{zdrops($1)},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDROPS},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),1,{
__{}__{}  .error {$0}($@): Parameter is pointer!},

__{}__IS_NUM($1),0,{
__{}__{}  .error {$0}($@): Parameter is not number!},

__{}{dnl
__{}__{}ifelse(__HEX_HL($1),0x0000,{
__{}__{}__{}                        ;           __INFO   ( -- )},

__{}__{}eval(($1<0) || ($1 & 0x8000)),1,{
__{}__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_ZDROP},

__{}__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_Z2DROP},

__{}__{}eval(($1) < 52),1,{dnl
__{}__{}__{}__def({USE_ZDROP_C})
__{}__{}__{}    ld    C, __FORM({%-11s},__HEX_L(-5*($1))); 2:7       __INFO   ( Z: $1*z -- )
__{}__{}__{}    call _ZDROP_C       ; 3:17      __INFO},

__{}__{}{dnl
__{}__{}__{}__def({USE_ZDROP_BC})
__{}__{}__{}    ld   BC, __FORM({%-11s},__HEX_HL(-5*($1))); 3:10      __INFO   ( Z: $1*z -- )
__{}__{}__{}    call _ZDROP_BC      ; 3:17      __INFO{}dnl
__{}__{}}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # zabs
define({ZABS},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZABS_INLINE},{zabs},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZABS},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZABS})
__{}    call _ZABS          ; 3:17      __INFO   ( Z: z1 -- abs(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZABS_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x2A            ; 1:        __INFO   calc-abs ( Z: z1 -- abs(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # z+
define({ZADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZADD_INLINE},{z+},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZADD})
__{}    call _ZADD          ; 3:17      __INFO   ( Z: z1 z2 -- z1+z2 )}){}dnl
dnl
define({__ASM_TOKEN_ZADD_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x0F            ; 1:        __INFO   calc-add ( Z: z1 z2 -- z1+z2 ){}dnl
}){}dnl
dnl
dnl
dnl # z-
define({ZSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZSUB_INLINE},{z-},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZSUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZSUB})
__{}    call _ZSUB          ; 3:17      __INFO   ( Z: z1 z2 -- z1-z2 )}){}dnl
dnl
define({__ASM_TOKEN_ZSUB_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x03            ; 1:        __INFO   calc-sub ( Z: z1 z2 -- z1-z2 ){}dnl
}){}dnl
dnl
dnl
dnl # znegate
define({ZNEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZNEGATE_INLINE},{znegate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZNEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZNEGATE})
__{}    call _ZNEGATE       ; 3:17      __INFO   ( Z: z1 -- -z1 )}){}dnl
dnl
define({__ASM_TOKEN_ZNEGATE_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x1B            ; 1:        __INFO   calc-negate ( Z: z1 -- -z1 ){}dnl
}){}dnl
dnl
dnl
dnl # zsin
define({ZSIN},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZSIN_INLINE},{zsin},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZSIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZSIN})
__{}    call _ZSIN          ; 3:17      __INFO   ( Z: z1 -- sin(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZSIN_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x1F            ; 1:        __INFO   calc-sin ( Z: z1 -- sin(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zcos
define({ZCOS},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZCOS_INLINE},{zcos},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZCOS},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOS})
__{}    call _ZCOS          ; 3:17      __INFO   ( Z: z1 -- cos(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZCOS_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x20            ; 1:        __INFO   calc-cos ( Z: z1 -- cos(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # ztan
define({ZTAN},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZTAN_INLINE},{ztan},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZTAN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZTAN})
__{}    call _ZTAN          ; 3:17      __INFO   ( Z: z1 -- tan(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZTAN_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x21            ; 1:        __INFO   calc-tan ( Z: z1 -- tan(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zasin
define({ZASIN},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZASIN_INLINE},{zasin},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZASIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZASIN})
__{}    call _ZASIN         ; 3:17      __INFO   ( Z: z1 -- arcsin(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZASIN_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x22            ; 1:        __INFO   calc-arcsin ( Z: z1 -- arcsin(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zacos
define({ZACOS},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZACOS_INLINE},{zacos},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZACOS},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZACOS})
__{}    call _ZACOS         ; 3:17      __INFO   ( Z: z1 -- arccos(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZACOS_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x23            ; 1:        __INFO   calc-arccos ( Z: z1 -- arccos(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zatan
define({ZATAN},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZATAN_INLINE},{zatan},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZATAN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZATAN})
__{}    call _ZATAN         ; 3:17      __INFO   ( Z: z1 -- arctan(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZATAN_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x24            ; 1:        __INFO   calc-arctan ( Z: z1 -- arctan(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zln
define({ZLN},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZLN_INLINE},{zln},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZLN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZLN})
__{}    call _ZLN           ; 3:17      __INFO   ( Z: z1 -- ln(z1) )}){}dnl
dnl
define({__ASM_TOKEN_ZLN_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x25            ; 1:        __INFO   calc-ln ( Z: z1 -- ln(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zexp
define({ZEXP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZEXP_INLINE},{zexp},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZEXP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZEXP})
__{}    call _ZEXP          ; 3:17      __INFO   ( Z: z1 -- e^z1 )}){}dnl
dnl
define({__ASM_TOKEN_ZEXP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x26            ; 1:        __INFO   calc-exp ( Z: z1 -- exp(z1) ){}dnl
}){}dnl
dnl
dnl
dnl # zsqrt
define({ZSQRT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZSQRT_INLINE},{zsqrt},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZSQRT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZSQRT})
__{}    call _ZSQRT         ; 3:17      __INFO   ( Z: z1 -- z1^0.5 )}){}dnl
dnl
define({__ASM_TOKEN_ZSQRT_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x28            ; 1:        __INFO   calc-sqrt ( Z: z1 -- z1**0.5 ){}dnl
}){}dnl
dnl
dnl
dnl # ( Z: z -- z z )
define({ZDUP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZDUP_INLINE},{zdup},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDUP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZDUP})
__{}    call _ZDUP          ; 3:17      __INFO   ( Z: z -- z z )}){}dnl
dnl
define({__ASM_TOKEN_ZDUP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x31            ; 1:        __INFO   calc-duplicate ( Z: z1 -- z1 z1 ){}dnl
}){}dnl
dnl
dnl
dnl # ( Z: z2 z1  -- z2 z1 z2 z1 )
define({Z2DUP},{dnl
__{}__ADD_TOKEN({__TOKEN_Z2DUP},{z2dup},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_Z2DUP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_Z2DUP})
__{}    call _Z2DUP         ; 3:17      __INFO   ( Z: z2 z1 -- z2 z1 z2 z1 )}){}dnl
dnl
define({__ASM_TOKEN_Z2DUP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0xC2            ; 1:        __INFO   st_mem_2
__{}    db  0x02            ; 1:        __INFO   calc-delete
__{}    db  0xC3            ; 1:        __INFO   st_mem_3
__{}    db  0xE2            ; 1:        __INFO   get_mem_2
__{}    db  0xE3            ; 1:        __INFO   get_mem_3
__{}    db  0xE2            ; 1:        __INFO   get_mem_2{}dnl
}){}dnl
dnl
dnl
dnl # ( Z: z2 z1  -- z1 )
define({ZNIP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZNIP_INLINE},{znip},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZNIP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZNIP})
__{}    call _ZNIP          ; 3:17      __INFO   ( Z: z2 z1 -- z1 )}){}dnl
dnl
define({__ASM_TOKEN_ZNIP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x01            ; 1:        __INFO   calc-exchange ( Z: z2 z1 -- z1 )
__{}    db  0x02            ; 1:        __INFO   calc-delete{}dnl
}){}dnl
dnl
dnl
dnl # z.
define({ZDOT},{dnl
__{}__ADD_TOKEN({__TOKEN_ZDOT},{z.},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDOT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZDOT})
__{}    call _ZDOT          ; 3:17      __INFO   ( Z: z -- ){}dnl
}){}dnl
dnl
dnl
dnl # z.
define({ZDOT_INLINE},{dnl
__{}__ADD_TOKEN({__TOKEN_ZDOT_INLINE},{z.}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDOT_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZDOT_INLINE})
__{}    call _ZDOT_INLINE   ; 3:17      __INFO   ( Z: z -- ){}dnl
}){}dnl
dnl
dnl
dnl # ( Z: z -- z )  "13,57,9A,CD,EF "
define({ZHEXDOT},{dnl
__{}__ADD_TOKEN({__TOKEN_ZHEXDOT},{zhex.},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZHEXDOT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZHEXDOT})
__{}    call _ZHEXDOT       ; 3:17      __INFO   ( Z: z -- z )}){}dnl
dnl
dnl
dnl # zfloor
define({ZFLOOR},{dnl
__{}__ADD_TOKEN({__TOKEN_ZFLOOR},{zfloor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZFLOOR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZFLOOR})
__{}    call _ZFLOOR        ; 3:17      __INFO   ( Z: z -- x )}){}dnl
dnl
dnl
dnl # zswap
define({ZSWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZSWAP_INLINE},{zswap},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZSWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZSWAP})
__{}    call _ZSWAP         ; 3:17      __INFO   ( Z: z1 z2 -- z2 z1 )}){}dnl
dnl
define({__ASM_TOKEN_ZSWAP_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x01            ; 1:        __INFO   calc-exchange ( Z: z2 z1 -- z1 z2 ){}dnl
}){}dnl
dnl
dnl
dnl # z2swap
define({Z2SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_Z2SWAP},{z2swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_Z2SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_Z2SWAP})
__{}    call _Z2SWAP        ; 3:17      __INFO   ( Z: z3 z2 z1 z0 -- z1 z0 z3 z2 )}){}dnl
dnl
dnl
dnl # Z*
define({ZMUL},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZMUL_INLINE},{z*},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZMUL},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZMUL})
__{}    call _ZMUL          ; 3:17      __INFO   ( Z: z1 z2 -- z1*z2 )}){}dnl
dnl
define({__ASM_TOKEN_ZMUL_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x04            ; 1:        __INFO   calc-mul ( Z: z1 z2 -- z1*z2 ){}dnl
}){}dnl
dnl
dnl
dnl # Z**
define({ZMULMUL},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZMULMUL_INLINE},{z**},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZMULMUL},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZMULMUL})
__{}    call _ZMULMUL       ; 3:17      __INFO   ( Z: z1 z2 -- z1^z2 )}){}dnl
dnl
define({__ASM_TOKEN_ZMULMUL_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x06            ; 1:        __INFO   calc-to_power ( Z: z1 z2 -- z1**z2 ){}dnl
}){}dnl
dnl
dnl
dnl # Z/
define({ZDIV},{dnl
__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZDIV_INLINE},{z/},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZDIV},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZDIV})
__{}    call _ZDIV          ; 3:17      __INFO   ( Z: z1 z2 -- z1/z2 )}){}dnl
dnl
define({__ASM_TOKEN_ZDIV_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON
__{}    db  0x05            ; 1:        __INFO   calc-div ( Z: z1 z2 -- z1/z2 ){}dnl
}){}dnl
dnl
dnl
dnl
define({ZXROM_UMUL},{dnl
__{}__ADD_TOKEN({__TOKEN_ZXROM_UMUL},{zxrom_umul},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZXROM_UMUL},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}                        ;[4:27]     __INFO   ( c b a -- c b*a )
__{}    call 0x30a9         ; 3:17      __INFO   {call ZX ROM HL=HL*DE routine}
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # Z<=
define({ZLE},{dnl
__{}__ADD_TOKEN({__TOKEN_ZLE},{z<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZLE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_FLOAT,fast,{__def({USE_ZTEST})
__{}__{}                        ;[8:51]     __INFO   ( -- flag ) ( Z: z2 z1 -- )
__{}__{}    call ZTEST          ; 3:17      __INFO   carry if z2>z1
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{__def({USE_ZCOMPARE2FLAG})
__{}__{}    ld    B, 0x09       ; 2:7       __INFO   ( -- flag ) ( Z: z1 z2 -- )
__{}__{}    call _ZCOMPARE2FLAG ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # f<= negate s>f
define({ZLE_NEGATE_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_ZLE_NEGATE_S_TO_Z},{z<= negate s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZLE_NEGATE_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOMPARE})
__{}    ld    B, 0x09       ; 2:7       __INFO   ( Z: z1 z2 -- zbool ) z<= if 1e else 0e then
__{}    call _ZCOMPARE      ; 3:17      __INFO}){}dnl
dnl
dnl
dnl # Z>=
define({ZGE},{dnl
__{}__ADD_TOKEN({__TOKEN_ZGE},{z>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_FLOAT,fast,{__def({USE_ZTEST})
__{}__{}                       ;[10:58]     __INFO   ( -- flag ) ( Z: z2 z1 -- )
__{}__{}    call ZTEST          ; 3:17      __INFO   carry if z2>z1
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{__def({USE_ZCOMPARE2FLAG})
__{}__{}    ld    B, 0x0A       ; 2:7       __INFO   ( -- flag ) ( Z: z1 z2 -- )
__{}__{}    call _ZCOMPARE2FLAG ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # f>= negate s>f
define({ZGE_NEGATE_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_ZGE_NEGATE_S_TO_Z},{z>= negate s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZGE_NEGATE_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOMPARE})
__{}    ld    B, 0x0A       ; 2:7       __INFO   ( Z: z1 z2 -- zbool ) z>= if 1e else 0e then
__{}    call _ZCOMPARE      ; 3:17      __INFO}){}dnl
dnl
dnl
dnl # Z<>
define({ZNE},{dnl
__{}__ADD_TOKEN({__TOKEN_ZNE},{z<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_FLOAT,fast,{__def({USE_ZTEST})
__{}__{}                       ;[11:55]     __INFO   ( -- flag ) ( Z: z2 z1 -- )
__{}__{}    call ZTEST          ; 3:17      __INFO   carry if z2>z1
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},
__{}{__def({USE_ZCOMPARE2FLAG})
__{}__{}    ld    B, 0x0B       ; 2:7       __INFO   ( -- flag ) ( Z: z1 z2 -- )
__{}__{}    call _ZCOMPARE2FLAG ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # f<> negate s>f
define({ZNE_NEGATE_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_ZNE_NEGATE_S_TO_Z},{z<> negate s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZNE_NEGATE_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOMPARE})
__{}    ld    B, 0x0B       ; 2:7       __INFO   ( Z: z1 z2 -- zbool ) z<> if 1e else 0e then
__{}    call _ZCOMPARE      ; 3:17      __INFO}){}dnl
dnl
dnl
dnl # Z>
define({ZGT},{dnl
__{}__ADD_TOKEN({__TOKEN_ZGT},{z>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_FLOAT,fast,{__def({USE_ZTEST})
__{}__{}                        ;[7:47]     __INFO   ( -- flag ) ( Z: z2 z1 -- )
__{}__{}    call ZTEST          ; 3:17      __INFO   carry if z2>z1
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{__def({USE_ZCOMPARE2FLAG})
__{}__{}    ld    B, 0x0C       ; 2:7       __INFO   ( -- flag ) ( Z: z1 z2 -- )
__{}__{}    call _ZCOMPARE2FLAG ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # f> negate s>f
define({ZGT_NEGATE_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_ZGT_NEGATE_S_TO_Z},{z> negate s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZGT_NEGATE_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOMPARE})
__{}    ld    B, 0x0C       ; 2:7       __INFO   ( Z: z1 z2 -- zbool ) z> if 1e else 0e then
__{}    call _ZCOMPARE      ; 3:17      __INFO}){}dnl
dnl
dnl
dnl # Z<
define({ZLT},{dnl
__{}__ADD_TOKEN({__TOKEN_ZLT},{z<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZLT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_FLOAT,fast,{__def({USE_ZTEST})
__{}__{}                       ;[10:58]     __INFO   ( -- flag ) ( Z: z2 z1 -- )
__{}__{}    call ZTEST          ; 3:17      __INFO   carry if z2>z1
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    jr    z, $+3        ; 2:7/12    __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{__def({USE_ZCOMPARE2FLAG})
__{}__{}    ld    B, 0x0D       ; 2:7       __INFO   ( -- flag ) ( Z: z1 z2 -- )
__{}__{}    call _ZCOMPARE2FLAG ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # f< negate s>f
define({ZLT_NEGATE_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_ZLT_NEGATE_S_TO_Z},{z< negate s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZLT_NEGATE_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOMPARE})
__{}    ld    B, 0x0D       ; 2:7       __INFO   ( Z: z1 z2 -- zbool ) z< if 1e else 0e then
__{}    call _ZCOMPARE      ; 3:17      __INFO}){}dnl
dnl
dnl
dnl # Z=
define({ZEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_ZEQ},{z=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_FLOAT,fast,{__def({USE_ZTEST})
__{}__{}                       ;[11:55]     __INFO   ( -- flag ) ( Z: z2 z1 -- )
__{}__{}    call ZTEST          ; 3:17      __INFO   carry if z2>z1
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO
__{}__{}    jr    z, $+3        ; 2:7/12    __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},
__{}{__def({USE_ZCOMPARE2FLAG})
__{}__{}    ld    B, 0x0E       ; 2:7       __INFO   ( -- flag ) ( Z: z1 z2 -- )
__{}__{}    call _ZCOMPARE2FLAG ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # f= negate s>f
define({ZEQ_NEGATE_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_ZEQ_NEGATE_S_TO_Z},{z= negate s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZEQ_NEGATE_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_ZCOMPARE})
__{}    ld    B, 0x0E       ; 2:7       __INFO   ( Z: z1 z2 -- zbool ) z= if 1e else 0e then
__{}    call _ZCOMPARE      ; 3:17      __INFO}){}dnl
dnl
dnl
dnl # U>Z
define({U_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_U_TO_Z},{u>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_U_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_U_TO_Z})
__{}    call _U_TO_F        ; 3:17      __INFO   ( u -- ) ( Z: -- z )}){}dnl
dnl
dnl
dnl # u u>z
define({PUSH_U_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_U_TO_Z},{$1 u>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_U_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},
__{}__HAS_PTR($1),1,{dnl
__{}__{}__def({USE_BC_TO_Z})
__{}__{}    ld   BC,__FORM({%-12s},$1); 4:20      __INFO   ( Z: -- $1 )
__{}__{}    call _BC_TO_Z       ; 3:17      __INFO},
__{}eval($1>=0),{1},{dnl
__{}__{}__def({USE_BC_TO_Z})
__{}__{}    ld   BC, __FORM({%-11s},$1); 3:10      __INFO   ( Z: -- $1 )
__{}__{}    call _BC_TO_Z       ; 3:17      __INFO},
__{}{dnl
__{}__{}__def({USE_ZNEGATE}){}dnl
__{}__{}__def({USE_BC_TO_Z})
__{}__{}    ld   BC, __FORM({%-11s},eval(-($1))); 3:10      __INFO   ( Z: -- $1 )
__{}__{}    call _BC_TO_Z       ; 3:17      __INFO
__{}__{}    call _ZNEGATE       ; 3:17      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl ;# S>Z
define({S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_S_TO_Z_INLINE},{s>z},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2DROP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_S_TO_Z})
__{}    call _S_TO_Z        ; 3:17      __INFO   ( x -- ) ( Z: -- z )}){}dnl
dnl
define({__ASM_TOKEN_S_TO_Z_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    push DE             ; 1:11      __INFO   ( x -- ) ( Z: -- z )
__{}    ld    A, H          ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   carry=sign
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    E, A          ; 1:4       __INFO   0-sign
__{}    xor   A             ; 1:4       __INFO
__{}    ld    D, L          ; 1:4       __INFO
__{}    ld    C, H          ; 1:4       __INFO
__{}    ld    B, A          ; 1:4       __INFO
__{}    call 0x2ABB         ; 3:124     __INFO   new float: a=0,e=0-sign,d=lo,c=hi,b=0{}dnl
}){}dnl
dnl
dnl
dnl ;# x s>z
dnl ;# Slo by vylepsit pro 5 konstant a volat rutinu 341B
dnl ;# stk_zero 32C5    DEFB $00,$B0,$00            zero (00 00 00 00 00)
dnl ;# stk_one  32C8    DEFB $40,$B0,$00,$01        one (00 00 01 00 00)
dnl ;# stk_half 32CC    DEFB $30,$00                a half (80 00 00 00 00)
dnl ;# stk_pi_2 32CE    DEFB $F1,$49,$0F,$DA,$A2    a half of pi (81 49 0F DA A2)
dnl ;# stk_ten  32D3    DEFB $40,$B0,$00,$0A        ten (00 00 0A 00 00)
dnl ;# db 0xA0 ; 0.0?
dnl ;# db 0xA1 ; 1.0?
dnl ;# db 0xA2 ; 0.5?
dnl ;# db 0xA3 ; pi/2?
dnl ;# db 0xA4 ; 10.0?
define({PUSH_S_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_S_TO_Z},{$1 s>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_S_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): $# parameters found in macro!},
__{}__HAS_PTR($1),{1},{dnl
__{}__def({USE_SIGN_BC_TO_Z}){}dnl
__{}    ld   BC,__FORM({%-12s},$1); 4:20      __INFO   ( Z: -- $1 )
__{}    call _SIGN_BC_TO_Z  ; 3:17      __INFO},
__{}eval($1>=0),{1},{dnl
__{}    ld   BC, __FORM({%-11s},$1); 3:10      __INFO   ( Z: -- $1 )
__{}ifelse(eval(($1) & 0x8000),{0},{dnl
__{}__{}__def({USE_SIGN_BC_TO_Z}){}dnl
__{}__{}    call _SIGN_BC_TO_Z  ; 3:17      __INFO   $1 == 0 0??????? ????????},
__{}{dnl
__{}__{}__def({USE_CF_BC_TO_Z}){}dnl
__{}__{}    xor   A             ; 1:4       __INFO   $1 == 0 1??????? ????????
__{}__{}    call _CF_BC_TO_Z    ; 3:17      __INFO})},
__{}{dnl
__{}    ld   BC, __FORM({%-11s},$1); 3:10      __INFO   ( Z: -- $1 )
__{}ifelse(eval(($1) & 0x8000),{0},{dnl
__{}__{}__def({USE_CF_BC_TO_Z}){}dnl
__{}__{}    scf                 ; 1:4       __INFO   $1 == 1 0??????? ????????
__{}__{}    call _CF_BC_TO_Z    ; 3:17      __INFO},
__{}{dnl
__{}__{}__def({USE_SIGN_BC_TO_Z}){}dnl
__{}__{}    call _SIGN_BC_TO_Z  ; 3:17      __INFO   $1 == 1 1??????? ????????})}){}dnl
}){}dnl
dnl
dnl
dnl # 1E -2.3E-5 etc.
define({ZPUSH},{dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing parameters!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{dnl ;# pointer
__{}__{}PUSH(regexp({$1},{^\s*\[\(.+\)\]\s*$},\1)){}ZFETCH},
__{}__IS_NAME($1):__PSIZE_$1,{1:5},{dnl ;# tohle je vlastne spatne, protoze to ma vracet adresu a ne hodnotu...  takhle by se to melo chovat jen pro zvalue a zconstant(to nahrazuje jmeno za hodnotu) a ne zvariable
__{}__{}PUSH($1){}ZFETCH},
__{}__IS_NUM($1),0,{dnl ;# hex floating or constant name?
__{}__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_INLINE},{{const-$1}},$1){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@)},
__{}$1,{$1},{dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_INLINE},{{$1}},$1){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@)},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DOWN},{calc-init},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{calc-init},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_INLINE},{{const_$1}},$1){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{calc-terminate},$@){}dnl
__{}__{}__ADD_TOKEN({__TOKEN_2DROP},{calc-terminate},$@){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl ;# need inside 2dup ... 2drop
define({__ASM_TOKEN_ZPUSH},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZXC_ON{}dnl
__{}__ASM_TOKEN_ZPUSH_REC($@){}dnl
__{}__ASM_TOKEN_ZXC_OFF{}dnl
}){}dnl
dnl
dnl ;# need inside 2dup ... 2drop
define({__ASM_TOKEN_ZPUSH_INLINE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_ZPUSH_REC($@){}dnl
}){}dnl
dnl
dnl
define({ZXC_ON},{dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_ON},{zx_calc_on}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZXC_ON},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__CALC_ACTIVE,true,,{
__{}__{}    rst 0x28            ; 1:11      __INFO   calc-init}){}dnl
__{}define({__CALC_ACTIVE},true){}dnl
}){}dnl
dnl
dnl
dnl
define({ZXC_OFF},{dnl
__{}__ADD_TOKEN({__TOKEN_ZXC_OFF},{zx_calc_off}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZXC_OFF},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__CALC_ACTIVE,true,{
__{}__{}    db  0x38            ; 1:        __INFO   calc-end}){}dnl
__{}define({__CALC_ACTIVE},false){}dnl
}){}dnl
dnl
dnl
dnl ;# Input:  __CALC_ACTIVE = true or false
dnl ;# Output: __CALC_ACTIVE = true or false
dnl ;# need inside 2dup ... 2drop
define({__ASM_TOKEN_ZPUSH_REC},{dnl
__{}ifelse($1,,{},
__{}{dnl
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}ifelse(dnl
__{}__{}ifelse(TYP_FLOAT,fast,1,ZXTEMP_REDUCED_SIZE,0,1,0),1,{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_OFF
__{}__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __COMPILE_INFO   $1 = __HEX_FLOAT($1)
__{}__{}__{}    ld   DE, 0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1     ; 3:10      __COMPILE_INFO     = 0x{}ZXTEMP_EXP{}ZXTEMP_MANTISSA_1{}{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4
__{}__{}__{}    ld   BC, 0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3     ; 3:10      __COMPILE_INFO
__{}__{}__{}    call 0x2ABB         ; 3:124     __COMPILE_INFO   new float = a,e,d,c,b},
__{}__{}__HEX_FLOAT($1),{0x0p+0},{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_ON
__{}__{}__{}    db  0xA0            ; 1:        __COMPILE_INFO   calc-stk 0.0},
__{}__{}__HEX_FLOAT($1),{0x1p+0},{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_ON
__{}__{}__{}    db  0xA1            ; 1:        __COMPILE_INFO   calc-stk 1.0},
__{}__{}__HEX_FLOAT($1),{0x1p-1},{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_ON
__{}__{}__{}    db  0xA2            ; 1:        __COMPILE_INFO   calc-stk 0.5},
__{}__{}ZXTEMP_EXP:ZXTEMP_MANTISSA_1:ZXTEMP_REDUCED_M_2:ZXTEMP_REDUCED_M_3:ZXTEMP_REDUCED_M_4,81:49:0F:DA:A2,{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_ON
__{}__{}__{}    db  0xA3            ; 1:        __COMPILE_INFO   calc-stk pi/2},
__{}__{}__HEX_FLOAT($1),{0x1.4p+3},{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_ON
__{}__{}__{}    db  0xA4            ; 1:        __COMPILE_INFO   calc-stk 10.0},
__{}__{}{dnl
__{}__{}__{}__ASM_TOKEN_ZXC_ON
__{}__{}__{}    db  0x34            ; 1:        __COMPILE_INFO   calc-push $1 = __HEX_FLOAT($1){}dnl
__{}__{}__{}ifelse(ZXTEMP_REDUCED_E2,,{
__{}__{}__{}__{}    db  ZXTEMP_REDUCED_E1            ; 1:        __COMPILE_INFO     exp: 0x{}ZXTEMP_EXP, mantissa bytes: ZXTEMP_REDUCED_SIZE},
__{}__{}__{}{
__{}__{}__{}__{}    db  ZXTEMP_REDUCED_E1            ; 1:        __COMPILE_INFO     mantissa bytes: ZXTEMP_REDUCED_SIZE
__{}__{}__{}__{}    db  ZXTEMP_REDUCED_E2            ; 1:        __COMPILE_INFO     exp: 0x{}ZXTEMP_EXP})
__{}__{}__{}    db  0x{}ZXTEMP_MANTISSA_1            ; 1:        __COMPILE_INFO     man 1: __HEX_L(0x{}ZXTEMP_MANTISSA_1 | 0x80)  sign: __HEX_L(0x{}ZXTEMP_MANTISSA_1 & 0x80){}dnl
__{}__{}__{}ifelse(ZXTEMP_REDUCED_M_2,,,{
__{}__{}__{}__{}    db  0x{}ZXTEMP_REDUCED_M_2            ; 1:        __COMPILE_INFO     man 2: 0x{}ZXTEMP_REDUCED_M_2}){}dnl
__{}__{}__{}ifelse(ZXTEMP_REDUCED_M_3,,,{
__{}__{}__{}__{}    db  0x{}ZXTEMP_REDUCED_M_3            ; 1:        __COMPILE_INFO     man 3: 0x{}ZXTEMP_REDUCED_M_3}){}dnl
__{}__{}__{}ifelse(ZXTEMP_REDUCED_M_4,,,{
__{}__{}__{}__{}    db  0x{}ZXTEMP_REDUCED_M_4            ; 1:        __COMPILE_INFO     man 4: 0x{}ZXTEMP_REDUCED_M_4}){}dnl
__{}__{}}){}dnl
__{}$0(shift($@))}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # z,
define({ZCOMMA},{dnl
__{}__ADD_TOKEN({__TOKEN_ZCOMMA},{z{{,}}},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZCOMMA},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>0),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}__def({USE_ZCOMMA}){}dnl
__{}__{}    ld   BC,__FORM({%-12s},LAST_HERE_NAME{}ifelse(eval(LAST_HERE_ADD!=0),1,+LAST_HERE_ADD)); 3:10      __INFO   ( -- ) ( Z: z -- )
__{}__{}    call _ZCOMMA        ; 3:17      __INFO{}dnl
__{}__{}__ASM_TOKEN_PUSH_ALLOT(5){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 1e z,
define({ZPUSH_ZCOMMA},{dnl
__{}ifelse(eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}__IS_NUM($1),0,{dnl ;# hex floating?
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_ZCOMMA},{$1 zcomma},$@)},
__{}$1,{$1},{dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_ZCOMMA},{$1 zcomma},eval($1))},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_ZPUSH_ZCOMMA},{const_$1 zcomma},eval($1)){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZPUSH_ZCOMMA},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): Parameter is pointer!},
__{}__IS_NAME($1),{1},{
__{}__{}  .error {$0}($@): Parameter is variable! {I} don't know the value!},
__{}{
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __INFO   = __HEX_FLOAT($1)
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(LAST_HERE_ADD+LAST_HERE_NAME)]){,}A); 3:13      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC   = 0x{}ZXTEMP_EXP{}ZXTEMP_MANTISSA_1{}{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(1+LAST_HERE_ADD+LAST_HERE_NAME)]){,}BC); 4:20      __INFO{}dnl
__{}__{}define({$0_BC},__LD_R16(BC,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3,BC,0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,A,0x{}ZXTEMP_EXP)){}$0_BC
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(3+LAST_HERE_ADD+LAST_HERE_NAME)]){,}BC); 4:20      __INFO{}dnl
__{}__{}__ASM_TOKEN_PUSH_ALLOT(5){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZPUSH_ZCOMMA},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($#,{0},{},
__{}$#,1,{
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __INFO   = __HEX_FLOAT($1)
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(LAST_HERE_ADD+LAST_HERE_NAME)]){,}A); 3:13      __INFO{}dnl
__{}__{}__ASM_TOKEN_PUSH_ALLOT(1){}dnl
__{}__{}__ASM_TOKEN_PUSHS_COMMA(0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3){}dnl
__{}},
__{}eval(1&($#)),{1},{
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}    ld    A, 0x{}ZXTEMP_EXP       ; 2:7       __INFO   = __HEX_FLOAT($1)
__{}__{}    ld  format({%-16s},__FORM({%s},[__SIMPLIFY_EXPRESSION(LAST_HERE_ADD+LAST_HERE_NAME)]){,}A); 3:13      __INFO{}dnl
__{}__{}__ASM_TOKEN_PUSH_ALLOT(1){}dnl
__{}__{}__ASM_TOKEN_PUSHS_COMMA(0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3,__ZFLOAT_TO_HEXSTREAM(shift($@)))){}dnl
__{}},
__{}{dnl
__{}__{}__ASM_TOKEN_PUSHS_COMMA(__ZFLOAT_TO_HEXSTREAM($@)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
define({__ZFLOAT_TO_HEXSTREAM},{dnl
__{}ifelse(eval($#),{0},{},
__{}eval($#>1),{1},{dnl
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_1{}ZXTEMP_EXP,{}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_2,{}dnl
__{}__{}define({$0_TMP},ZXTEMP_MANTISSA_4){}dnl
__{}__{}FSTRING_TO_ZHEX($2){}dnl
__{}__{}0x{}ZXTEMP_EXP{}$0_TMP,{}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_2{}ZXTEMP_MANTISSA_1,{}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_4{}ZXTEMP_MANTISSA_3{}dnl
__{}__{}ifelse(eval($#>2),1,{,$0(shift(shift($@)))}){}dnl
__{}},
__{}$#,{1},{dnl
__{}__{}FSTRING_TO_ZHEX($1){}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_1{}ZXTEMP_EXP,{}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_2,{}dnl
__{}__{}0x{}ZXTEMP_MANTISSA_3{}ZXTEMP_MANTISSA_4{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # r>s
define({R_TO_S},{dnl
__{}__ADD_TOKEN({__TOKEN_R_TO_S},{r>s},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_R_TO_S},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_R_TO_S})
__{}    call _R_TO_S        ; 3:17      __INFO   ( -- x ) ( Z: z -- )}){}dnl
dnl
dnl
dnl # d>z
define({D_TO_Z},{dnl
__{}__ADD_TOKEN({__TOKEN_D_TO_Z},{d>z},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D_TO_Z},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_D_TO_Z})
__{}    call _D_TO_Z        ; 3:17      __INFO   ( d -- ) ( Z: -- z )}){}dnl
dnl
dnl
dnl # z>d
define({Z_TO_D},{dnl
__{}__ADD_TOKEN({__TOKEN_Z_TO_D},{z>d},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_Z_TO_D},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_Z_TO_D})
__{}    call _Z_TO_D        ; 3:17      __INFO   ( -- d ) ( Z: z -- )}){}dnl
dnl
dnl
dnl
dnl # zfloat+
dnl # sizeof(z) = 5
define({ZFLOATADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHS},{zfloat+},5){}dnl
__{}__ADD_TOKEN({__TOKEN_ADD},{__dtto}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZFLOATADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld   BC, 0x0005     ; 3:10      __INFO   ( a1 -- a2 ) ( Z: -- )
__{}    add  HL, BC         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # ( u -- 5*u )
define({ZFLOATS},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHS},{zfloats},5){}dnl
__{}__ADD_TOKEN({__TOKEN_MUL},{__dtto}){}dnl
}){}dnl
dnl
dnl
dnl # z0=
define({Z0EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_Z0EQ},{z0=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_Z0EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}__def({USE_Z0EQ})
__{}    call _Z0EQ          ; 3:17      __INFO   ( -- flag ) ( Z: z -- )}){}dnl
dnl
dnl
dnl # z0<
define({Z0LT},{dnl
__{}__ADD_TOKEN({__TOKEN_Z0LT},{z0<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_Z0LT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__def({USE_Z0LT})
__{}    call _Z0LT          ; 3:17      __INFO   ( -- flag ) ( Z: z -- )}){}dnl
dnl
dnl
dnl
dnl # ZVARIABLE(name,value)
dnl # ZVARIABLE(name)
define({ZVARIABLE},{dnl
__{}define({__PSIZE_$1},5){}dnl
__{}__ADD_TOKEN({__TOKEN_ZVARIABLE},{zvariable $1 $2},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZVARIABLE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter with variable name!},
__{}eval($#>2),{1},{
__{}__{}    .error {$0}($@): To many parameters!},
__{}eval($#),{1},{
__{}__{}format({%-24s},{});           __INFO{}dnl
__{}__{}define({__PSIZE_$1},5){}dnl
__{}__{}pushdef({LAST_HERE_NAME},$1){}dnl
__{}__{}pushdef({LAST_HERE_ADD},5){}dnl
__{}__{}__{}__ADD_DB_VARIABLE($1,0,__INFO){}dnl
__{}__{}__{}__ADD_DW_VARIABLE(,0,__INFO){}dnl
__{}__{}__{}__ADD_DW_VARIABLE(,0,__INFO)},
__{}{
__{}__{}format({%-24s},{});           __INFO{}dnl
__{}__{}define({__PSIZE_$1},5){}dnl
__{}__{}pushdef({LAST_HERE_NAME},$1){}dnl
__{}__{}pushdef({LAST_HERE_ADD},5){}dnl
__{}__{}FSTRING_TO_ZHEX($2){}dnl
__{}__{}__ADD_SPEC_VARIABLE({
}format({%-24s},$1:){;           }__INFO{   = $2 = }__HEX_FLOAT($2){
}    db 0x{}ZXTEMP_EXP{             ;           }__INFO{   = exp
}    db 0x{}ZXTEMP_MANTISSA_1{             ;           }__INFO{   = sign + high 7 bits mantissa (big-endien)
}    db 0x{}ZXTEMP_MANTISSA_2{,0x}ZXTEMP_MANTISSA_3{,0x}ZXTEMP_MANTISSA_4{   ;           }__INFO{   = low mantissa (big-endien)}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl ;# ZFLOATS = PUSH(5) MUL
define({ZFLOATS},{dnl
__{}ifelse(eval($#>0),{1},{
__{}__{}    .error {$0}($@): Unexpected parameters!},
__{}{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHS},{zfloats},5){}dnl
__{}__ADD_TOKEN({__TOKEN_MUL},{__dtto}){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZFLOATS},{dnl
__{}__ASM_TOKEN_PUSH_MUL(5){}dnl
}){}dnl
dnl
dnl
dnl
dnl ;# ZFLOAT = PUSH(5)
define({ZFLOAT},{dnl
__{}ifelse(eval($#>0),{1},{
__{}__{}    .error {$0}($@): Unexpected parameters!},
__{}{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHS},{zfloat},5){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ZFLOAT},{dnl
__{}__ASM_TOKEN_PUSHS(5){}dnl
}){}dnl
dnl
dnl
dnl
