\ define morse letters 32..127

create ascii_table
,c"  "       \ space
,c" -.-.--"  \ ! ( or ---...-) (or +) 
,c" .-..-."  \ "
,c" ..--.."  \ # --> ? --> "num"?
,c" ...-..-" \ $
,c" ..--.."  \ % --> ? --> "per"?
,c" ..--.."  \ & --> ? --> "amp"?
,c" .----."  \ ' or tab  
,c" -.--."   \ (
,c" -.--.-"  \ )
,c" ..--.."  \ * --> ? --> "mul"?
,c" .-.-."   \ + (or !)
,c" --..--"  \ ,  
,c" -....-"  \ -
,c" .-.-.-"  \ .  
,c" -..-."   \ /   
,c" -----"   \ 0    
,c" .----"   \ 1
,c" ..---"   \ 2    
,c" ...--"   \ 3
,c" ....-"   \ 4    
,c" ....."   \ 5
,c" -...."   \ 6    
,c" --..."   \ 7
,c" ---.."   \ 8    
,c" ----."   \ 9
,c" ---..."  \ :
,c" -.-.-."  \ ;
,c" ..--.."  \ < --> ? --> "lt"?
,c" -...-"   \ =
,c" ..--.."  \ > --> ? --> "gt"?
,c" ..--.."  \ ?
,c" .--.-."  \ @
,c" .-"      \ A  
,c" -..."    \ B   
,c" -.-."    \ C    
,c" -.."     \ D 
,c" ."       \ E  
,c" ..-."    \ F   
,c" --."     \ G    
,c" ...."    \ H 
,c" .."      \ I  
,c" .---"    \ J   
,c" -.-"     \ K    
,c" .-.."    \ L 
,c" --"      \ M  
,c" -."      \ N   
,c" ---"     \ O    
,c" .--."    \ P 
,c" --.-"    \ Q  
,c" .-."     \ R   
,c" ..."     \ S    
,c" -"       \ T 
,c" ..-"     \ U  
,c" ...-"    \ V   
,c" .--"     \ W    
,c" -..-"    \ X 
,c" -.--"    \ Y  
,c" --.."    \ Z 
,c" -.--."   \ [ --> (
,c" .---."   \ \  
,c" -.--.-"  \ ] --> )
,c" ..--.."  \ ↑ or ^ --> "hat"?
,c" ..--.-"  \ _ or ←
,c" .--.-."  \ @
,c" .-"      \ small A  
,c" -..."    \ small B   
,c" -.-."    \ small C    
,c" -.."     \ small D 
,c" ."       \ small E  
,c" ..-."    \ small F   
,c" --."     \ small G    
,c" ...."    \ small H 
,c" .."      \ small I  
,c" .---"    \ small J   
,c" -.-"     \ small K    
,c" .-.."    \ small L 
,c" --"      \ small M  
,c" -."      \ small N   
,c" ---"     \ small O    
,c" .--."    \ small P 
,c" --.-"    \ small Q  
,c" .-."     \ small R   
,c" ..."     \ small S    
,c" -"       \ small T 
,c" ..-"     \ small U  
,c" ...-"    \ small V   
,c" .--"     \ small W    
,c" -..-"    \ small X 
,c" -.--"    \ small Y  
,c" --.."    \ small Z 
,c" -.--."   \ { --> (
,c" ..--.."  \ | --> ? --> "vbr"?
,c" -.--.-"  \ } --> )
,c" ..--.."  \ ~ --> ? --> "til"?
,c" ..--.."  \ (c) or del --> "del"?

80  constant duration       \ 0.08 sec
1   constant dit_dur        \ relative
3   constant dah_dur        \ relative
1   constant inter_gap_dur  \ relative (between the dits and dahs)
3   constant short_gap_dur  \ relative (between letters)
7   constant medium_gap_dur \ relative (between words)

596  constant u_cpudiv2hz  \ F5 --> 3500000/(8*698.4565(hz))-30.125
56   constant u_ft         \ f*t = 698.4565*0.08 (Hz*sec);

: MORSE_CSTRING_EMIT  ( cstring -- )

    count
0 [IF]
    duration short_gap_dur * ms          \ between letters
    1- for
        dup c@
        duration inter_gap_dur * ms         \ inter_gap_dur
        dup bl = if                         \ check for space character
             duration short_gap_dur * ms    \ and delay if detected
        else dup [char] . = if
             u_ft dit_dur * 
             u_cpudiv2hz zx_beep        \ .
        else dup [char] - = if
             u_ft dah_dur * 
             u_cpudiv2hz zx_beep        \ -
        then then then
        drop 
        1+
    next 
[ELSE]
    duration short_gap_dur * ms          \ between letters
    bl emit
    1- for
        dup c@
        8 emit bl emit 8 emit
        duration inter_gap_dur * ms         \ inter_gap_dur
        dup bl = if                         \ check for space character
             bl emit
             duration short_gap_dur * ms    \ and delay if detected
        else dup [char] . = if
             [char] . emit 
             u_ft dit_dur * 
             u_cpudiv2hz zx_beep        \ .
        else dup [char] - = if
             [char] - emit 
             u_ft dah_dur * 
             u_cpudiv2hz zx_beep        \ -
        else
             emit
        then then then
        drop 
        1+
    next
    8 emit bl emit 8 emit
[ENDIF]
    drop ;

: CHAR_EMIT ( char -- )
    32 -
    dup 96 u>=       \ non-printable character
    if
        [char] ? 32 - 
    then
    2* ascii_table + @
    MORSE_CSTRING_EMIT
;

        
: TRANSMIT ( ADDR LEN -- )
           cr                          \ newline,
           bounds                      \ convert loop indices to address ranges
           do
              I C@ dup
              CHAR_EMIT                \ send the morse code
              emit                     \ dup and send char to console
           loop ;

s" Welcome to Wikipedia, the free encyclopedia that anyone can edit." TRANSMIT
\  s" Hello Word!" TRANSMIT
\  s" SOS SOS SOS SSS SSS OOO OOO" TRANSMIT
