include(`../M4/FIRST.M4')dnl
  ifdef __ORG
    org __ORG
  else
    org 32768
  endif
  INIT(60000)
;# define morse letters 32..127

CREATE(_ascii_table)
COMMACSTRING({" "})       ;# space
COMMACSTRING({"-.-.--"})  ;# ! ( or ---...-) (or +) 
COMMACSTRING({".-..-."})  ;# "
COMMACSTRING({"..--.."})  ;# # --> ? --> "num"?
COMMACSTRING({"...-..-"}) ;# $
COMMACSTRING({"..--.."})  ;# % --> ? --> "per"?
COMMACSTRING({"..--.."})  ;# & --> ? --> "amp"?
COMMACSTRING({".----."})  ;# ' or tab  
COMMACSTRING({"-.--."})   ;# (
COMMACSTRING({"-.--.-"})  ;# )
COMMACSTRING({"..--.."})  ;# * --> ? --> "mul"?
COMMACSTRING({".-.-."})   ;# + (or !)
COMMACSTRING({"--..--"})  ;# ,  
COMMACSTRING({"-....-"})  ;# -
COMMACSTRING({".-.-.-"})  ;# .  
COMMACSTRING({"-..-."})   ;# /   
COMMACSTRING({"-----"})   ;# 0    
COMMACSTRING({".----"})   ;# 1
COMMACSTRING({"..---"})   ;# 2    
COMMACSTRING({"...--"})   ;# 3
COMMACSTRING({"....-"})   ;# 4    
COMMACSTRING({"....."})   ;# 5
COMMACSTRING({"-...."})   ;# 6    
COMMACSTRING({"--..."})   ;# 7
COMMACSTRING({"---.."})   ;# 8    
COMMACSTRING({"----."})   ;# 9
COMMACSTRING({"---..."})  ;# :
COMMACSTRING({"-.-.-."})  ;# ;
COMMACSTRING({"..--.."})  ;# < --> ? --> "lt"?
COMMACSTRING({"-...-"})   ;# =
COMMACSTRING({"..--.."})  ;# > --> ? --> "gt"?
COMMACSTRING({"..--.."})  ;# ?
COMMACSTRING({".--.-."})  ;# @
COMMACSTRING({".-"})      ;# A  
COMMACSTRING({"-..."})    ;# B   
COMMACSTRING({"-.-."})    ;# C    
COMMACSTRING({"-.."})     ;# D 
COMMACSTRING({"."})       ;# E  
COMMACSTRING({"..-."})    ;# F   
COMMACSTRING({"--."})     ;# G    
COMMACSTRING({"...."})    ;# H 
COMMACSTRING({".."})      ;# I  
COMMACSTRING({".---"})    ;# J   
COMMACSTRING({"-.-"})     ;# K    
COMMACSTRING({".-.."})    ;# L 
COMMACSTRING({"--"})      ;# M  
COMMACSTRING({"-."})      ;# N   
COMMACSTRING({"---"})     ;# O    
COMMACSTRING({".--."})    ;# P 
COMMACSTRING({"--.-"})    ;# Q  
COMMACSTRING({".-."})     ;# R   
COMMACSTRING({"..."})     ;# S    
COMMACSTRING({"-"})       ;# T 
COMMACSTRING({"..-"})     ;# U  
COMMACSTRING({"...-"})    ;# V   
COMMACSTRING({".--"})     ;# W    
COMMACSTRING({"-..-"})    ;# X 
COMMACSTRING({"-.--"})    ;# Y  
COMMACSTRING({"--.."})    ;# Z 
COMMACSTRING({"-.--."})   ;# [ --> (
COMMACSTRING({".---."})   ;# \  
COMMACSTRING({"-.--.-"})  ;# ] --> )
COMMACSTRING({"..--.."})  ;# ↑ or ^ --> "hat"?
COMMACSTRING({"..--.-"})  ;# _ or ←
COMMACSTRING({".--.-."})  ;# @
COMMACSTRING({".-"})      ;# small A  
COMMACSTRING({"-..."})    ;# small B   
COMMACSTRING({"-.-."})    ;# small C    
COMMACSTRING({"-.."})     ;# small D 
COMMACSTRING({"."})       ;# small E  
COMMACSTRING({"..-."})    ;# small F   
COMMACSTRING({"--."})     ;# small G    
COMMACSTRING({"...."})    ;# small H 
COMMACSTRING({".."})      ;# small I  
COMMACSTRING({".---"})    ;# small J   
COMMACSTRING({"-.-"})     ;# small K    
COMMACSTRING({".-.."})    ;# small L 
COMMACSTRING({"--"})      ;# small M  
COMMACSTRING({"-."})      ;# small N   
COMMACSTRING({"---"})     ;# small O    
COMMACSTRING({".--."})    ;# small P 
COMMACSTRING({"--.-"})    ;# small Q  
COMMACSTRING({".-."})     ;# small R   
COMMACSTRING({"..."})     ;# small S    
COMMACSTRING({"-"})       ;# small T 
COMMACSTRING({"..-"})     ;# small U  
COMMACSTRING({"...-"})    ;# small V   
COMMACSTRING({".--"})     ;# small W    
COMMACSTRING({"-..-"})    ;# small X 
COMMACSTRING({"-.--"})    ;# small Y  
COMMACSTRING({"--.."})    ;# small Z 
COMMACSTRING({"-.--."})   ;# { --> (
COMMACSTRING({"..--.."})  ;# | --> ? --> "vbr"?
COMMACSTRING({"-.--.-"})  ;# } --> )
COMMACSTRING({"..--.."})  ;# ~ --> ? --> "til"?
COMMACSTRING({"..--.."})  ;# (c) or del --> "del"?

CONSTANT(_duration,80)       ;# 0.08 sec
CONSTANT(_dit_dur,1)        ;# relative
CONSTANT(_dah_dur,3)        ;# relative
CONSTANT(_inter_gap_dur,1)  ;# relative (between the dits and dahs)
CONSTANT(_short_gap_dur,3)  ;# relative (between letters)
CONSTANT(_medium_gap_dur,7) ;# relative (between words)

CONSTANT(_u_cpudiv2hz,596)  ;# F5 --> 3500000/(8*698.4565(hz))-30.125
CONSTANT(_u_ft,56)         ;# f*t = 698.4565*0.08 (Hz*sec);

STRING({"Welcome to Wikipedia, the free encyclopedia that anyone can edit."}) CALL(_TRANSMIT)
;#  s" Hello Word!" TRANSMIT
;#  s" SOS SOS SOS SSS SSS OOO OOO" TRANSMIT
  STOP

COLON(_MORSE_CSTRING_EMIT,({{{{ cstring -- }}}}))

    COUNT
    PUSH(_duration) PUSH(_short_gap_dur) MUL PUSH(20) UDIV WAIT          ;# between letters
    PUSH(' ') EMIT
    _1SUB FOR
        DUP CFETCH
        PUSH(8) EMIT PUSH(' ') EMIT PUSH(8) EMIT
        PUSH(_duration) PUSH(_inter_gap_dur) MUL PUSH(20) UDIV WAIT         ;# inter_gap_dur
        DUP PUSH(' ') EQ IF                         ;# check for space character
             PUSH(' ') EMIT
             PUSH(_duration) PUSH(_short_gap_dur) MUL PUSH(20) UDIV WAIT    ;# and delay if detected
        ELSE DUP PUSH('.')EQ IF
             PUSH('.')EMIT 
             PUSH(_u_ft) PUSH(_dit_dur) MUL 
             PUSH(_u_cpudiv2hz) ZX_BEEP        ;# .
        ELSE DUP PUSH('-')EQ IF
             PUSH('-')EMIT 
             PUSH(_u_ft) PUSH(_dah_dur) MUL 
             PUSH(_u_cpudiv2hz) ZX_BEEP        ;# -
        ELSE
             EMIT
        THEN THEN THEN
        DROP 
        _1ADD
    NEXT
    PUSH(8) EMIT PUSH(' ') EMIT PUSH(8) EMIT
    DROP SEMICOLON

COLON(_CHAR_EMIT,({{{{ char -- }}}}))
    PUSH(32) SUB
    DUP PUSH(96) UGE       ;# non-printable character
    IF
        PUSH('?')PUSH(32) SUB 
    THEN
     PUSH(2) MUL PUSH(_ascii_table) ADD FETCH
    CALL(_MORSE_CSTRING_EMIT)
SEMICOLON

COLON(_TRANSMIT,({{{{ ADDR LEN -- }}}}))
           CR                          ;# newline,
           OVER ADD SWAP ;# bounds ( addr u -- addr+u addr ) (ready for "do")
                      ;# convert loop indices to address ranges
           DO
              I CFETCH DUP
              CALL(_CHAR_EMIT)                ;# send the morse code
              EMIT                     ;# dup and send char to console
           LOOP SEMICOLON
