function init_read_word() {
  terminating_character = "space"
  main_ignore_first_space = 1
  if (main_last_char ~/^[[:space:]]$/ )
    main_space = main_last_char
  else
    main_space = ""
  word = ""
  main_raw = ""
  main_last_char = ""
if ( debug > 7 )
print "main_space now: [" main_space "]" > "/dev/stderr"
}

function depth(name) {
    if (stack_pos[name] == "") 
        stack_pos[name] = 0;
    return stack_pos[name];
}

function push(name, val) {
# print "\tin name:" name ", val:" val ", depth:" stack_pos[name]
    if (stack_pos[name] == "") 
        stack_pos[name] = 1;
    else
        stack_pos[name]++;
    stack_array[name, stack_pos[name]] = val;
# print "\tout name:" name ", val:" val ", depth:" stack_pos[name]
}

function pop(name) {
    if (depth(name) > 0) {
        return stack_array[name, stack_pos[name]--];
    } else {
        return "";
    }
}

function stack_last_value(name) {
    if (depth(name) > 0) {
        return stack_array[name, stack_pos[name]];
    } else {
        return "";
    }
}

function stack_i_value(name,i) {
    if ( i > 0 && i <= depth(name) ) {
        return stack_array[name, i];
    } else {
        return "";
    }
}

function add_word(word,spaces) {
    if (inside_word_definition) {
        fn_leading_spaces[fn_count] = spaces
        fn_words[fn_count] = word
        fn_count++;
    }
    else {
        main_leading_spaces[main_count] = spaces
        main_words[main_count] = word
        main_count++;
    }
}


# i == -1 --> last word
# i == -2 --> previous word
function set_previous_word(word,spaces,i) {
    if (inside_word_definition) {
        if ( fn_count+i>=0) {
            fn_leading_spaces[fn_count+i] = spaces
            fn_words[fn_count+i] = word
        }
    }
    else {
        if ( main_count+i>=0) {
            main_leading_spaces[main_count+i] = spaces
            main_words[main_count+i] = word
        }
    }
}


function delete_last_word() {
    if (inside_word_definition)
    {
        if ( fn_count > 0) fn_count--;
    }
    else
    {
        if ( main_count > 0) main_count--;
    }
}


# i == -1 --> last word
# i == -2 --> previous word
function get_previous_spaces(i) {
    if (inside_word_definition)
    {
        if ( fn_count+i >= 0 ) return fn_leading_spaces[fn_count+i];
    }
    else
    {
        if ( main_count+i >= 0 ) return main_leading_spaces[main_count+i];
    }
    return ""
}


# i == -1 --> last word
# i == -2 --> previous word
function get_previous_word(i) {
    if (inside_word_definition) {
        if ( fn_count+i >= 0 ) return fn_words[fn_count+i];
    }
    else
    {
        if ( main_count+i >= 0 ) return main_words[main_count+i];
    }
    return ""
}


function change_previous_word(new) {
    if ( inside_word_definition ) {
        if ( fn_count > 1 ) fn_words[fn_count-1] = new
    }
    else { 
        if ( main_count > 1 ) main_words[main_count-1] = new
    }
}


function find_previous_word() {
    if ( inside_word_definition ) {
        if ( fn_count > 1 ) return fn_words[fn_count-1]
    }
    else if ( main_count > 1 )
        return main_words[main_count-1]
    return ""
}

BEGIN {

  reserved_words["AT-XY"]       = "AT_XY"               # facility ext      
  reserved_words["ERASE"]       = "PUSH(0) FILL"        # for compatibility with the core-ext   
  reserved_words["PAUSE"]       = "PAUSE"               # not standard   
  reserved_words["WAIT"]        = "WAIT"                # not standard   
  reserved_words["MS"]          = "PUSH(20) UDIV WAIT"  # for compatibility with facility ext   
  reserved_words["ROLL"]        = "ROLL"                # core ext   
  reserved_words["BOUNDS"]      = "OVER ADD SWAP ;# bounds ( addr u -- addr+u addr ) (ready for \"do\")\n"   # not standard
  reserved_words["[']"]         = "[']"                 # problem...
  reserved_words["'"]           = "'"                   # problem...
  reserved_words["["]           = ""                    # ignore
  reserved_words["]"]           = ""                    # ignore
  reserved_words["LITERAL"]     = ""                    # ignore
  
  reserved_words["ABORT"]       = "BYE ;# Originally ABORT\n"  # After compilation, there is no difference between ABORT and BYE.  
#   reserved_words["ABORT\""]     = It's complicated, it has to be read as a string --> "IF PRINT({"..."}) BYE THEN ;# Originally ABORTq\n"  # After compilation, there is no difference between ABORT and BYE.  
  reserved_words["ALIGN"]       = "ALIGN"           # + integer --> ALIGN(integer)
  reserved_words["IF"]          = "IF"
  reserved_words["ELSE"]        = "ELSE"
  reserved_words["THEN"]        = "THEN"
  reserved_words["DO"]          = "DO"
  reserved_words["UNLOOP"]      = "UNLOOP"
  reserved_words["LOOP"]        = "LOOP"
  reserved_words["BEGIN"]       = "BEGIN"
  reserved_words["UNTIL"]       = "UNTIL"
  reserved_words["BREAK"]       = "BREAK"           # not standard "begin break again"
  reserved_words["AGAIN"]       = "AGAIN"
  reserved_words["WHILE"]       = "WHILE"
  reserved_words["REPEAT"]      = "REPEAT"
  
  reserved_words["CASE"]        = "CASE"
  reserved_words["OF"]          = "OF DROP"         # for compatibility with the standard   
  reserved_words["ENDOF"]       = "ENDOF"
  reserved_words["ENDCASE"]     = "DROP ENDCASE"    # for compatibility with the standard
  
  reserved_words["DUP"]         = "DUP"
  reserved_words["DROP"]        = "DROP"
  reserved_words["SWAP"]        = "SWAP"
  reserved_words["WITHIN"]      = "WITHIN"
  reserved_words["AND"]         = "AND"
  reserved_words["OR"]          = "OR"
  reserved_words["XOR"]         = "XOR"
  reserved_words["NIP"]         = "NIP"
  reserved_words["TUCK"]        = "TUCK"
  reserved_words["OVER"]        = "OVER"
  reserved_words["ROT"]         = "ROT"
  reserved_words["PICK"]        = "PICK"
  reserved_words["DEPTH"]       = "DEPTH"
  reserved_words["RDROP"]       = "RDROP"
  
  reserved_words["MIN"]         = "MIN"             #                           2dup <= if swap then nip            2dup <= if drop else nip then
  reserved_words["MAX"]         = "MAX"             #                           2dup >= if swap then nip            2dup >= if drop else nip then
  reserved_words["UMIN"]        = "UMIN"            # not standard gforth-0.5   2dup u>= if swap then nip           2dup u<= if drop else nip then
  reserved_words["UMAX"]        = "UMAX"            # not standard gforth-1.0   2dup u>= if swap then nip           2dup u>= if drop else nip then
  reserved_words["DMIN"]        = "DMIN"
  reserved_words["DMAX"]        = "DMAX"
  reserved_words["DUMIN"]       = "DUMIN"           # not standard      2over 2over du<= if 2drop else 2nip then ;
  reserved_words["DUMAX"]       = "DUMAX"           # not standard      2over 2over du>= if 2drop else 2nip then ;
  
  reserved_words["EXIT"]        = "EXIT"
  reserved_words["FILL"]        = "FILL"
  reserved_words["MOVE"]        = "MOVE"
  reserved_words["CMOVE"]       = "CMOVE"
  reserved_words["BYE"]         = "BYE"
  reserved_words["RND"]         = "RND"
  reserved_words["RANDOM"]      = "RANDOM"
  reserved_words["SETSEED"]     = "SETSEED"         # not standard

  reserved_words["ALLOT"]       = "ALLOT"
  reserved_words["HERE"]        = "HERE"
  reserved_words["CREATE"]      = "CREATE"
  reserved_words["I"]           = "I"
  reserved_words["J"]           = "J"
  reserved_words["K"]           = "K"
  reserved_words["ABS"]         = "ABS"
  reserved_words["UMOD"]        = "UMOD"
  reserved_words["MOD"]         = "MOD"
  reserved_words["ACCEPT"]      = "ACCEPT"
  reserved_words["ACCEPTZ"]     = "ACCEPTZ"             # not standard
  reserved_words[">NUMBER"]     = "TO_NUMBER"

  reserved_words["STR>UDNUM"]   = "STR_TO_UDNUM"        # alias ">NUMBER" ( ud1 a1 u1   -- ud2 a2 u2 )
  reserved_words["STR>UNUM"]    = "STR_TO_UNUM"         # not standard    ( u1  a1 ulen1 -- u2 a2 ulen2 )
  reserved_words["S>NUMBER?"]   = "STR_TO_DNUM NIP _0EQ"# not standard    (     a1 u1    -- d  flag )
  reserved_words["STR>DNUM"]    = "STR_TO_DNUM"         # not standard    (     a1 u1    -- d  a2 u2 )
  reserved_words["STR>NUM"]     = "STR_TO_NUM"          # not standard    (     a1 u1    -- x  a2 u2 )

  reserved_words["EMIT"]        = "EMIT"
  
  reserved_words["TYPE"]        = "TYPE"
  reserved_words["TYPEZ"]       = "TYPEZ"               # not standard (null-terminated C-string)
  reserved_words["TYPEI"]       = "TYPEI"               # not standard (ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words["COUNT"]       = "COUNT"               # as Pascal string = counted string with maximum 255 characters
  reserved_words["COUNTZ"]      = "COUNTZ"              # not standard (null-terminated C-string)
  reserved_words["COUNTI"]      = "COUNTI"              # not standard (ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words["COMPARE"]     = "COMPARE"
  reserved_words["COMPAREZ"]    = "COMPAREZ"            # not standard (null-terminated C-string)

  reserved_words["SEARCH"]      = "SEARCH"
  reserved_words["SEARCHZ"]     = "SEARCHZ"             # not standard (null-terminated C-string)
  reserved_words["SEARCHI"]     = "SEARCHI"             # not standard (ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words["/STRING"]     = "DIVSTRING"

  reserved_words["SPACE"]       = "SPACE"
  reserved_words["SPACES"]      = "SPACES"

  reserved_words["CR"]          = "CR"
  reserved_words["FOR"]         = "FOR"
  reserved_words["NEXT"]        = "NEXT"
  reserved_words["TRUE"]        = "TRUE"
  reserved_words["FALSE"]       = "FALSE"
  reserved_words["VARIABLE"]    = "VARIABLE"
  reserved_words["2VARIABLE"]   = "DVARIABLE"
  reserved_words["DVARIABLE"]   = "DVARIABLE"       # not standard

  reserved_words["VALUE"]       = "VALUE"
  reserved_words["2VALUE"]      = "DVALUE"
  reserved_words["DVALUE"]      = "DVALUE"          # not standard
  reserved_words["TO"]          = "TO"
  reserved_words["CONSTANT"]    = "CONSTANT"
  reserved_words["[CHAR]"]      = "__char"
  reserved_words["CHAR"]        = "__char"
  
  reserved_words["INVERT"]      = "INVERT" 
  reserved_words["LSHIFT"]      = "LSHIFT"
  reserved_words["RSHIFT"]      = "RSHIFT"
  reserved_words["<<"]          = "LSHIFT"          # not standard
  reserved_words[">>"]          = "RSHIFT"          # not standard
  reserved_words["NEGATE"]      = "NEGATE"
  
  reserved_words["DINVERT"]     = "DINVERT"         # not standard
  reserved_words["DLSHIFT"]     = "DLSHIFT"         # not standard
  reserved_words["DRSHIFT"]     = "DRSHIFT"         # not standard
  reserved_words["DNEGATE"]     = "DNEGATE"
  
  reserved_words["CMOVE>"]      = "CMOVEGT"
  reserved_words["MOVE>"]       = "MOVEGT"

  reserved_words[","]           = "COMMA"
  reserved_words["D,"]          = "DCOMMA"          # not standard
  reserved_words["?"]           = "FETCH DOT"

  reserved_words["1+"]          = "_1ADD"
  reserved_words["2+"]          = "_2ADD"
  reserved_words["+"]           = "ADD"
  reserved_words["D+"]          = "DADD"
  reserved_words["1-"]          = "_1SUB"
  reserved_words["2-"]          = "_2SUB"
  reserved_words["-"]           = "SUB"
  reserved_words["D-"]          = "DSUB"
  reserved_words["/"]           = "DIV"
  reserved_words["*"]           = "MUL"
  reserved_words["*/"]          = "MULDIV ;# Warning: Truncated division, not Floor division\n"
  reserved_words["*/MOD"]       = "MULDIVMOD ;# Warning: Truncated division, not Floor division\n"

  reserved_words["2/"]          = " PUSH(2) DIV"     # to activate optimizations in tokens (ta mezera je tam aby si constant nemyslel ze je to push)
  reserved_words["2*"]          = " PUSH(2) MUL"     # to activate optimizations in tokens

  reserved_words["/MOD"]        = "DIVMOD"
  reserved_words["U*"]          = "MUL"             # not standard
  reserved_words["U/"]          = "UDIV"            # not standard
  reserved_words["UMOD"]        = "UMOD"            # not standard
  reserved_words["U/MOD"]       = "UDIVMOD"         # not standard

  reserved_words["M+"]          = "MADD"
  reserved_words["M*"]          = "MMUL"
  reserved_words["UM*"]         = "UMMUL"
  reserved_words["FM/MOD"]      = "FMDIVMOD"
  reserved_words["SM/REM"]      = "SMDIVREM"
  reserved_words["UM/MOD"]      = "UMDIVMOD"
  
  reserved_words["256/"]        = " PUSH(256) DIV"  # to activate optimizations in tokens (ta mezera je tam aby si constant nemyslel ze je to push)
  reserved_words["256*"]        = " PUSH(256) MUL"  # to activate optimizations in tokens

  reserved_words[":"]           = "COLON"
  reserved_words["LEAVE"]       = "LEAVE"
  reserved_words["RECURSE"]     = "RECURSE"  
  reserved_words[";"]           = "SEMICOLON"
  reserved_words["DOES>"]       = "DOES_FROM"

  reserved_words["="]           = "EQ"
  reserved_words["<>"]          = "NE"
  reserved_words["<"]           = "LT"
  reserved_words[">"]           = "GT"
  reserved_words["<="]          = "LE"              # not standard
  reserved_words[">="]          = "GE"              # not standard
  
  reserved_words["U="]          = "EQ"              # not standard
  reserved_words["U<>"]         = "NE"              # not standard
  reserved_words["U<"]          = "ULT"
  reserved_words["U>"]          = "UGT"
  reserved_words["U<="]         = "ULE"             # not standard
  reserved_words["U>="]         = "UGE"             # not standard
  
  reserved_words["D="]          = "DEQ"
  reserved_words["D<>"]         = "DNE"             # not standard
  reserved_words["D<"]          = "DLT"
  reserved_words["D>"]          = "DGT"             # not standard
  reserved_words["D<="]         = "DLE"             # not standard
  reserved_words["D>="]         = "DGE"             # not standard

  reserved_words["DU="]         = "DUEQ"            # not standard
  reserved_words["DU<>"]        = "DUNE"            # not standard
  reserved_words["DU<"]         = "DULT"
  reserved_words["DU>"]         = "DUGT"            # not standard
  reserved_words["DU<="]        = "DULE"            # not standard
  reserved_words["DU>="]        = "DUGE"            # not standard
  
  reserved_words["0="]          = "_0EQ"
  reserved_words["0<"]          = "_0LT"
  reserved_words["0>"]          = "_0GT"
  reserved_words["0<="]         = "_0LE"            # not standard
  reserved_words["0>="]         = "_0GE"            # not standard
  reserved_words["0<>"]         = "_0NE"            # core ext

  reserved_words["+!"]          = "ADDSTORE"
  reserved_words["-!"]          = "SUBSTORE"        # not standard

  reserved_words["+LOOP"]       = "ADDLOOP"
  
  reserved_words["!"]           = "STORE"
  reserved_words["@"]           = "FETCH"
  reserved_words["2!"]          = "_2STORE"
  reserved_words["2@"]          = "_2FETCH"
  reserved_words["C!"]          = "CSTORE"
  reserved_words["C+!"]         = "CADDSTORE"       # not standard
  reserved_words["C-!"]         = "CSUBSTORE"       # not standard

  reserved_words["C@"]          = "CFETCH"
  
  reserved_words[">R"]          = "TO_R"
  reserved_words["R>"]          = "R_FROM"
  reserved_words["R@"]          = "R_FETCH"
  reserved_words["2>R"]         = "_2TO_R"
  reserved_words["2R>"]         = "_2R_FROM"
  reserved_words["2R@"]         = "_2R_FETCH"
  reserved_words["2RDROP"]      = "_2RDROP"
  
  reserved_words["2SWAP"]       = "_2SWAP"
  reserved_words["2DROP"]       = "_2DROP"
  reserved_words["2NIP"]        = "_2NIP"
  reserved_words["2TUCK"]       = "_2TUCK"
  reserved_words["2OVER"]       = "_2OVER"
  reserved_words["?DUP"]        = "QUESTIONDUP"
  reserved_words["?DO"]         = "QUESTIONDO"
  reserved_words["2DUP"]        = "_2DUP"
  reserved_words["3DUP"]        = "_3DUP"
  reserved_words["4DUP"]        = "_4DUP"
  reserved_words["-ROT"]        = "NROT"
  reserved_words["-2ROT"]       = "N2ROT"
  reserved_words["2ROT"]        = "_2ROT"

  reserved_words["KEY?"]        = "KEYQUESTION"
  reserved_words["KEY"]         = "KEY"

  reserved_words["D>S"]         = "D_TO_S"
  reserved_words["S>D"]         = "S_TO_D"
  
  reserved_words["EXECUTE"]     = "EXECUTE"
  reserved_words["CELL"]        = "CELL"                # not standard
  reserved_words["CELL+"]       = "CELLADD"
  reserved_words["CELLS"]       = "CELLS"
  
  reserved_words["HEX"]         = "HEX"                 # limited support for combination "hex (u)(d)." not as a permanent output setting parameter
  reserved_words["BL"]          = "PUSH(' ')"           # for compatibility with the standard

  reserved_words["{"]           = "__local_values_begin"# not standard
  reserved_words["}"]           = "__local_values_end"  # not standard

  reserved_words["T{"]          = "TEST_START"          # not standard
  reserved_words["->"]          = "TEST_EQ"             # not standard
  reserved_words["}T"]          = "TEST_END"            # not standard

  reserved_words["UTIME"]       = "UPTIME"              # not standard
  reserved_words["M4_FORTH"]    = "M4_FORTH"            # not standard
  reserved_words["ZX_BEEP"]     = "ZX_BEEP"             # not standard
  
  reserved_words["[DEFINED]"]   = "[DEFINED]"
  reserved_words["[IF]"]        = "[IF]"
  reserved_words["[ELSE]"]      = "[ELSE]"
  reserved_words["[THEN]"]      = "[THEN]"
  reserved_words["[ENDIF]"]     = "[ENDIF]"         # not standard (gforth == [then] ??? )
  
  reserved_words["."]           = "DOT SPACE"       # for compatibility with the standard
  reserved_words["U."]          = "UDOT SPACE"      # for compatibility with the standard
  reserved_words["D."]          = "DDOT SPACE"      # for compatibility with the standard
  reserved_words["UD."]         = "UDDOT SPACE"     # for compatibility with the standard

  reserved_words[".S"]          = "DOTS"            # "DEPTH PUSH('<') EMIT DUP DOT PUSH('>') EMIT DUP IF _1SUB FOR SPACE I PICK DOT NEXT THEN SPACE"
  
# potential change in the recursive word 
  recurse_reserved_words["DO"]          = "DO(R)"
  recurse_reserved_words["QUESTIONDO"]  = "QUESTIONDO(R)"
  recurse_reserved_words["FOR"]         = "FOR(R)"
  recurse_reserved_words["CALL"]        = "RCALL"
  recurse_reserved_words["COLON"]       = "RCOLON"
  recurse_reserved_words["EXIT"]        = "REXIT"
  recurse_reserved_words["SEMICOLON"]   = "RSEMICOLON"

  if ( arg == "-zfloat" ) {

    reserved_words["1/F"]       = "ZPUSH(1e) ZSWAP ZDIV" # not standard
    reserved_words["F,"]        = "ZCOMMA"          # not standard

    reserved_words["FDEPTH"]    = "ZDEPTH"
    reserved_words["FCONSTANT"] = "ZCONSTANT"
        
    reserved_words["FDOT"]      = "ZDOT"

    reserved_words["D>F"]       = "D_TO_Z"
    reserved_words["F>D"]       = "Z_TO_D"
    reserved_words["S>F"]       = "S_TO_Z"
    reserved_words["F>S"]       = "Z_TO_S"
    reserved_words["U>F"]       = "U_TO_Z"          # not standard

    reserved_words["FABS"]      = "ZABS"
    reserved_words["FACOS"]     = "ZACOS"
    reserved_words["F+"]        = "ZADD"
    reserved_words["FASIN"]     = "ZASIN"
    reserved_words["FATAN"]     = "ZATAN"
    reserved_words["FCOS"]      = "ZCOS"
    reserved_words["F/"]        = "ZDIV"
    reserved_words["F."]        = "ZDOT"
    reserved_words["FDROP"]     = "ZDROP"
    reserved_words["F2DROP"]    = "Z2DROP"          # not standard
    reserved_words["FDUP"]      = "ZDUP"
    reserved_words["F2DUP"]     = "Z2DUP"           # not standard
    
    reserved_words["FLOAT"]     = "ZFLOAT"          # not standard
    reserved_words["FLOATS"]    = "ZFLOATS"

    reserved_words["FNIP"]      = "ZNIP"            # not standard
    reserved_words["FEXP"]      = "ZEXP"
    reserved_words["F@"]        = "ZFETCH"
    reserved_words["FLOOR"]     = "ZFLOOR"    
    reserved_words["FTRUNC"]    = "CALL(__ZTRUNC,( z -- round_towards_zero(z)))"    # floating ext
    
    use_reserved_words["FTRUNC"] = 0
    
    reserved_words["FLN"]       = "ZLN"
    reserved_words["F*"]        = "ZMUL"
    reserved_words["F**"]       = "ZMULMUL"
    reserved_words["FNEGATE"]   = "ZNEGATE"
    reserved_words["FOVER"]     = "ZOVER"
    reserved_words["FPICK"]     = "ZPICK"           # not standard
    reserved_words["FROT"]      = "ZROT"
    reserved_words["F-ROT"]     = "ZNROT"           # not standard

    reserved_words["FSIN"]      = "ZSIN"
    reserved_words["FSQRT"]     = "ZSQRT"
    reserved_words["F!"]        = "ZSTORE"
    reserved_words["F-"]        = "ZSUB"
    reserved_words["FSWAP"]     = "ZSWAP"
    reserved_words["F2SWAP"]    = "Z2SWAP"
    
    reserved_words["FTAN"]      = "ZTAN"
    reserved_words["FVARIABLE"] = "ZVARIABLE"
    reserved_words["F<="]       = "ZLE"
    reserved_words["F>="]       = "ZGE"
    reserved_words["F<>"]       = "ZNE"
    reserved_words["F>"]        = "ZGT"
    reserved_words["F<"]        = "ZLT"
    reserved_words["F="]        = "ZEQ"
    reserved_words["F0<"]       = "Z0LT"
    reserved_words["F0="]       = "Z0EQ"
    reserved_words["FLOAT+"]    = "ZFLOATADD"
    reserved_words["FLOATS"]    = "ZFLOATS"
    reserved_words["ZDEPTH"]    = "ZDEPTH"          # not standard
    
#     reserved_words["FFRAC"]     = "FFRAC"           # not standard
        
    reserved_words["FMOD"]      = "CALL(__ZMOD,( za zb  -- zmod(a%b)))"    # not standard
    
    use_reserved_words["FMOD"] = 0

    reserved_words["F2*"]       = "ZPUSH(2E) ZMUL" # not standard
    reserved_words["F2/"]       = "ZPUSH(2E) ZDIV" # not standard
    
    reserved_words["F0<"]       = "Z0LT"            # not standard
    reserved_words["F0="]       = "Z0EQ"            # not standard

    
    
  } else {
      
    reserved_words["F,"]        = "FCOMMA"          # not standard

    reserved_words["FDEPTH"]    = "DEPTH"
    reserved_words["FCONSTANT"] = "FCONSTANT"
    reserved_words["FDOT"]      = "FDOT"
      
    reserved_words["D>F"]       = "D_TO_S S2F"      # for compatibility with the standard
    reserved_words["F>D"]       = "F2S S_TO_D"      # for compatibility with the standard
    reserved_words["S>F"]       = "S2F"
    reserved_words["F>S"]       = "F2S"
    reserved_words["U>F"]       = "U2F"             # not standard
    reserved_words["F>U"]       = "F2U"             # not standard
    
    reserved_words["FABS"]      = "FABS"
    reserved_words["FACOS"]     = "CALL(__FACOS,( rad -- ))"    # for compatibility with the standard
    
    use_reserved_words["FACOS"] = 0

    reserved_words["F+"]        = "FADD"    
    reserved_words["FASIN"]     = "CALL(__FASIN,( rad -- ))"    # for compatibility with the standard
    
    use_reserved_words["FASIN"] = 0

#     reserved_words["FATAN"]     = ""    # for compatibility with the standard
    reserved_words["FCOS"]      = "PUSH(0x4092) SWAP FSUB FSIN ;# ( cos  0..π only)\n"   # for compatibility with the standard
    reserved_words["F/"]        = "FDIV"
    reserved_words["F."]        = "FDOT SPACE"
    reserved_words["FDROP"]     = "FDROP"
    reserved_words["F2DROP"]    = "F2DROP"          # not standard
    reserved_words["FDUP"]      = "FDUP"
    reserved_words["F2DUP"]     = "F2DUP"           # not standard
    reserved_words["FNIP"]      = "FNIP"            # not standard
    reserved_words["FEXP"]      = "FEXP"
    reserved_words["F@"]        = "FFETCH"
    
#     reserved_words["FLOOR"]     = "CALL(__FLOOR,( f -- round_towards_negative_infinity(f)))"    
#     use_reserved_words["FLOOR"] = 0
    
    reserved_words["FLOOR"]     = "FLOOR"
    reserved_words["FTRUNC"]    = "FTRUNC"   
    reserved_words["FLN"]       = "FLN"
    reserved_words["F*"]        = "FMUL"
#     reserved_words["F**"]       = ""
    reserved_words["FNEGATE"]   = "FNEGATE"
    reserved_words["FOVER"]     = "FOVER"
    reserved_words["FPICK"]     = "FPICK"           # not standard
    reserved_words["FROT"]      = "FROT"
    reserved_words["F-ROT"]     = "FNROT"           # not standard
    reserved_words["FSIN"]      = "FSIN ;# ( sin -π/2..π/2 only)\n"
    reserved_words["FSQRT"]     = "FSQRT"
    reserved_words["F!"]        = "FSTORE"
    reserved_words["F-"]        = "FSUB"

    reserved_words["FSWAP"]     = "FSWAP"
    reserved_words["F2SWAP"]    = "F2SWAP"

    reserved_words["FTAN"]      = "DUP FSIN SWAP PUSH(0x4092) SWAP FSUB FSIN FDIV ;# ( tan  0..π/2 only)\n"   # for compatibility with the standard
    reserved_words["FVARIABLE"] = "FVARIABLE"
    reserved_words["F<="]       = "FLE"
    reserved_words["F>="]       = "FGE"   
    reserved_words["F<>"]       = "FNE"
    reserved_words["F>"]        = "FGT"
    reserved_words["F<"]        = "FLT"
    reserved_words["F="]        = "FEQ"    
    reserved_words["F0<"]       = "F0LT"
    reserved_words["F0="]       = "F0EQ"
    reserved_words["FLOAT+"]    = "FLOATADD"
    reserved_words["FLOATS"]    = "FLOATS"

    reserved_words["FFRAC"]     = "FFRAC"           # not standard
    reserved_words["FMOD"]      = "FMOD"            # not standard
    reserved_words["F2*"]       = "F2MUL"           # not standard
    reserved_words["F2/"]       = "F2DIV"           # not standard
  }
  
  reserved_words["ZXFONT_5X8"]  = "ZXFONT_5x8"      # not standard
  
  reserved_words[".("]          = "PRINT"       #  .( ...)
                                
  reserved_words[".\""]         = "PRINT"       #  ." ..."
  reserved_words[".\\\""]       = "PRINT"       # .\" ..."
  reserved_words[".Z\""]        = "PRINTZ"      # .z" ..."   not standard (as a null-terminated C-string)
  reserved_words[".I\""]        = "PRINTI"      # .i" ..."   not standard (as a ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words[",string\""]   = "COMMASTRING"     #   ,string" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",stringz\""]  = "COMMASTRINGZ"    #  ,stringz" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",stringi\""]  = "COMMASTRINGI"    #  ,stringi" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",cstring\""]  = "COMMACSTRING"    #  ,cstring" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",\""]         = "COMMACSTRING"    #         ," ..."   not standard (gforth)

  reserved_words[",S\""]        = "COMMA_S"     # ,s" ..."   not standard
  reserved_words[",SZ\""]       = "COMMA_SZ"    #,sz" ..."   not standard
  reserved_words[",SI\""]       = "COMMA_SI"    #,si" ..."   not standard
  reserved_words[",C\""]        = "COMMA_C"     # ,c" ..."   not standard
                                
  reserved_words["S\""]         = "STRING"      #  s" ..."
  reserved_words["S\\\""]       = "STRING"      # s\" ..."
  reserved_words["SZ\""]        = "STRINGZ"     # sz" ..."   not standard (as a null-terminated C-string)
  reserved_words["SI\""]        = "STRINGI"     # si" ..."   not standard (as a ZX ROM string terminated by a character with the 7th bit inverted)
  reserved_words["C\""]         = "CSTRING"     #  c" ..."   as Pascal string = counted string with maximum 255 characters
                                
  reserved_words["ABORT\""]     = "ABORT_DQ"    # abort" ..."
  reserved_words["POSTPONE"]    = "POSTPONE"
  reserved_words["'"]           = "__tick"
  reserved_words["[']"]         = "__tick"
  reserved_words[":NONAME"]     = "__noname_fn" # after ; push addr_fn on stack

#   reserved_words["WORD"]        = "WORD"        # as Pascal string = counted string with maximum 255 characters
#   reserved_words["FIND"]        = "FIND"        # as Pascal string = counted string with maximum 255 characters
  

  inside_word_definition=0
  function_name=""
  

  string_end=""
  
  fn_count=1  
  main_count=1
  
  word=""
  upword=""
  last_upword=""
  leading_spaces=""
  in_comment=0
  noname_count=0
  makro_if[0]=1
  makro_if_depth=0
  push("__level",1)
  
  local_values_count=-1

#     string_type["WORD"] = "1"

  double_quoted_strings["ABORT_DQ"] = "1"
  double_quoted_strings["__unknown_string"] = "1"

  double_quoted_strings["STRING"] = "1"
  double_quoted_strings["STRINGZ"] = "1"
  double_quoted_strings["STRINGI"] = "1"
  double_quoted_strings["CSTRING"] = "1"
  
  double_quoted_strings["PRINT"] = "1"
  double_quoted_strings["PRINTZ"] = "1"
  double_quoted_strings["PRINTI"] = "1"
  
  double_quoted_strings["COMMASTRING"] = "1"
  double_quoted_strings["COMMASTRINGZ"] = "1"
  double_quoted_strings["COMMASTRINGI"] = "1"
  double_quoted_strings["COMMACSTRING"] = "1"
  
  double_quoted_strings["COMMA_S"] = "1"
  double_quoted_strings["COMMA_SZ"] = "1"
  double_quoted_strings["COMMA_SI"] = "1"
  double_quoted_strings["COMMA_C"] = "1"
  
  init_read_word()
  __debug = 0
}

function pop_local_token() {    
    pop("__local_tokens")
    pop("__local_raw")
    pop("__local_line")
    pop("__local_space")
}

function pop_token() {    
    pop("__tokens")
    pop("__raw")
    pop("__line")
    pop("__space")
}

function push_token(_space,_token,_raw,_line) {
    if ( _space ~/^[[:space:]]*$/ ) {
        push("__space",_space)
    } else  {
        push("__space"," ")
        print "\nError in " FILENAME " at line " _line ", push_token: \"" _space "\" is not only space character!" > "/dev/stderr"
    }
    push("__tokens",_token)
    push("__raw",_raw)
    if ( _line ~ /^[0-9]+$/ ) {
        push("__line",_line)
    } else {
        push("__line",0)
        print "\nError in " FILENAME " at line " _line ", push_token: " _line " is not number!" > "/dev/stderr"
    }
}

function unroll_fn() {
    
#   postupne prochazime uz ulozene tokeny inline funkce a kopirujeme je jako nove
#   nekterym tokenum chybi parametery, ty se nacitaji nove z cteneho proudu
#   kdyz narazime na slovo ";" tak vyskakujeme z jednoho levelu zanoreni, az pripadne uplne opoustime unroll_fn
#   stack "__level" udrzuje indexy kde se nachazim na jednotlivych urovnich zanoreni do inline funkci
    
    while ( depth("__level") > 1 ) {
        i = stack_array["__level",depth("__level")]
        _space = stack_array["__space",i]
        _token = stack_array["__tokens",i]
        _raw   = stack_array["__raw",i]
        _line  = stack_array["__line",i]
        readable_name = ""
        if ( _raw != "" ) readable_name = Name2Readable(_raw) 
        
print "i: " i " line " _line " in unroll_fn(" _token "(" _raw ")-->(\"" readable_name"\"), next: " stack_array["__tokens",i+1] "(" stack_array["__raw",i+1] "))" > "/dev/stderr"

        if ( _token == "VALUE"     || _token == "DVALUE"    ||
             _token == "VARIABLE"  || _token == "DVARIABLE" ||
             _token == "FVARIABLE" || _token == "ZVARIABLE" ||
             _token == "CONSTANT"  || _token == "FCONSTANT" || _token == "ZCONSTANT" ||
             _token == "CREATE" ) {
        
            stack_array["__level",depth("__level")]++    
            init_read_word()
            word = _token
            main_space = _space
            return              # musime vyskocit uplne ven kvuli cteni jmena 
            
        } else if ( _token == "__does" ) {
if ( 0 ) {
print "\ttoken: " _token > "/dev/stderr"
print "\t  raw: " _raw > "/dev/stderr"
print "\t name: " stack_last_value("__last_create_name") > "/dev/stderr"
print "\t reserved_does_functions[" stack_last_value("__last_create_name") "] = " "_does_" _raw > "/dev/stderr"
}
            reserved_does_functions[stack_last_value("__last_create_name")] = "_does_" _raw
            stack_array["__level",depth("__level")]++

        } else if ( _token == "PARSE-NAME" ) {
            stack_array["__level",depth("__level")]++    
            init_read_word()
            word = "STRING"
            main_space = _space
            make_save_string = 1
            return              # musime vyskocit uplne ven kvuli cteni retezce 
            
        } else if ( ( _token == "WORD" || _token == "PARSE" ) && _raw != "" ) {
            stack_array["__level",depth("__level")]++    
            init_read_word()
            terminating_character = _raw
            main_ignore_first_space = 0
            if ( _token == "WORD" ) {
                word = "CSTRING"
            } else {
                word = "STRING"                
            }
            main_space = _space
            make_save_string = 1
            return              # musime vyskocit uplne ven kvuli cteni retezce 

        } else if ( _token == "WORD" || _token == "PARSE" ) {

            stack_array["__level",depth("__level")]++    
            init_read_word()
            # hledani oddelovace pro WORD or PARSE
            i = depth("__tokens") # posledni novy token
            while ( i > 0 &&
                    stack_i_value("__tokens",i) != "__char" && 
                    stack_i_value("__tokens",i) != "__number" && 
                    stack_i_value("__tokens",i) != "BL" ) 
            {
                print "\nWarning in " FILENAME " token " _token " at line " _line ": The token " i " " stack_i_value("__tokens",i) "(" stack_i_value("__raw",i) ") at " stack_i_value("__line",i) " line will be ignored when searching for a delimiter." > "/dev/stderr"
                i--
            }
                    
            if ( i < 1 ) {
                terminating_character = "space"                    
                print "\nError in " FILENAME " Separator for " _token " not found!" > "/dev/stderr"
            } else if ( stack_i_value("__tokens",i) == "__char" ) {
                terminating_character = stack_i_value("__raw",i)
                stack_array["__tokens",i] = "__nop"
            } else if ( stack_i_value("__tokens",i) == "__number" ) {
                terminating_character = sprintf("%c", stack_i_value("__raw",i)+0)
                stack_array["__tokens",i] = "__nop"
            } else if ( stack_i_value("__tokens",i) == "BL" ) {
                terminating_character = "space"
                stack_array["__tokens",i] = "__nop"
            }

            main_ignore_first_space = 0
            if ( _token == "WORD" ) {
                word = "CSTRING"
            } else {
                word = "STRING"                
            }
            main_space = _space
            make_save_string = 1
            return              # musime vyskocit uplne ven kvuli cteni retezce 
        } else if ( _token == "__unknown" && readable_name != "" && ( readable_name in reserved_inline_functions) ) {
            stack_array["__level",depth("__level")]++    
            push("__level",reserved_inline_functions[readable_name])
        } else if ( _token == "SEMICOLON" ) {
            pop("__level")
            init_read_word()
        } else {
            push_token(_space,_token,_raw,_line)
            stack_array["__level",depth("__level")]++
        }
    } # while end
    
}



function save_token(_token,_raw,_space,_line) {
    

if (debug > 1 || 1) {
printf "old i: " depth("__line") " = " depth("__tokens") " = " depth("__raw") " = " depth("__space") > "/dev/stderr"
printf  ", line " _line > "/dev/stderr"
printf "\tdepth(__level): " depth("__level") " depth(__in_fn): " depth("__in_fn") > "/dev/stderr" 
printf " _token(_raw): " _token "(" _raw ")" > "/dev/stderr"
print "\t_space: \"" gensub(/\n/,"\\\\n","g",_space) "\" main_last_char: [" gensub(/\n/,"\\\\n","g",main_last_char) "]" > "/dev/stderr"
}

    if ( _token == "[IF]" && makro_if[makro_if_depth] ) {
        makro_if_depth = makro_if_depth + 1
        
        if ( stack_last_value("__tokens") == "__number" ) {
            _raw = stack_last_value("__raw")
            pop_token()
            makro_if[makro_if_depth] = (_raw != 0)                
        }
        else 
            print "\nError in " FILENAME " at line " _line ": No value found before [IF], found only " stack_last_value("__tokens") stack_last_value("__raw") "." > "/dev/stderr"

        init_read_word()
        if ( makro_if[makro_if_depth] == 0 )
            terminating_character = "false_if"        
        return
    }
    else if (_token == "[IF]") {
        makro_if_depth = makro_if_depth + 1
        makro_if[makro_if_depth] = 0
        init_read_word()
        terminating_character = "false_if"
        return
    }
    else if ( _token == "[ELSE]" && makro_if[makro_if_depth-1] )  {
        makro_if[makro_if_depth] = (1 - makro_if[makro_if_depth])
        init_read_word()
        if ( makro_if[makro_if_depth] == 0 )
            terminating_character = "false_if"
        return
    }
    else if ( _token == "[ELSE]" ) { # in false if branch (just ignore)
        init_read_word()
        terminating_character = "false_if"
        return
    }
    else if ( _token == "[ENDIF]" || _token == "[THEN]" ) {
        makro_if_depth = makro_if_depth - 1
        init_read_word()
        if ( makro_if[makro_if_depth] == 0 )
            terminating_character = "false_if"
        return
    }
    
    readable_name = ""
    if ( _raw != "" ) readable_name = Name2Readable(_raw)
    

if ( debug > 4 )
print " token(" depth("__tokens") "): " _token ", raw(" depth("__raw") "): " _raw ", space(" depth("__space") "): " _space > "/dev/stderr"

# save data
    if ( _token != "__comment" && stack_last_value("__tokens") == "__comment" && _space !~/\n/)
        _space = "\n"

    if ( stack_last_value("__tokens") == "__local_values_begin" ) {
        if ( _token == "__local_values_end" || _token == "__local_values_comment" ) {
            pop_token() # remove __local_values_begin
            if ( _token == "__local_values_comment" ) {
                push("__local_tokens","__comment")
                push("__local_raw",_raw)
                push("__local_line",_line)
                push("__local_space",_space)
            }
            while ( depth("__local_tokens") ) {
                _token = stack_last_value("__local_tokens")
                _raw   = stack_last_value("__local_raw")
                _line  = stack_last_value("__local_line")
                _space = stack_last_value("__local_space")
                pop_local_token()
                save_token(_token,_raw,_space,_line)
            }
            return
        } else if ( _token == "__unknown" && _raw == "--" ) {
            init_read_word()
            word = "__local_values_comment"
            terminating_character = "}"
            return
        } else {
            push("__local_tokens","VALUE")
            push("__local_raw",_raw)
            push("__local_line",_line)
            push("__local_space",_space)
            init_read_word()
            return
        }
    } else {
        push_token(_space,_token,_raw,_line)
    }

if ( 0 ) {
print "\t token:" _token > "/dev/stderr"
print "\t   raw:" _raw > "/dev/stderr"
print "\t  name:" readable_name > "/dev/stderr"
}

# check data    
    if ( _raw == "" ) {
        if ( _token == "__noname_fn" ) {
            push("__in_fn",depth("__tokens"))
            noname_count+=1
            pop("__tokens")
            pop("__raw")        
            push("__tokens","COLON")
            push("__raw","noname" noname_count )
        }
        else if ( _token == "SEMICOLON" ) {
            if ( stack_i_value("__raw",stack_last_value("__in_fn")) ~/^noname[0-9][0-9]*$/ ) {
                push("__tokens","__number")
                push("__raw","_" stack_i_value("__raw",stack_last_value("__in_fn")))
                push("__line",_line)
                push("__space"," ")
            }
            pop("__in_fn")
        }
        else if ( _token == "VALUE"    || _token == "DVALUE" ||
                  _token == "CONSTANT" || _token == "FCONSTANT" ||_token == "ZCONSTANT" ||
                  _token == "CREATE"   ||
                  _token == "VARIABLE" || _token == "DVARIABLE" ||
                  _token == "WORD"     || _token == "PARSE" || _token == "PARSE-NAME" ) 
        {
            if ( depth("__in_fn") > 0 ) {
                delete reserved_functions[stack_i_value("__raw",stack_last_value("__in_fn"))]
                readable_name = Name2Readable(stack_i_value("__raw",stack_last_value("__in_fn")))
                reserved_inline_functions[readable_name] = stack_last_value("__in_fn")
if ( debug > 5 ) {
print "\t...stack_last_value(\"__in_fn\") = " stack_last_value("__in_fn") > "/dev/stderr"
if ( readable_name != "" && ( readable_name in reserved_inline_functions )) print "reserved_inline_functions[" readable_name "] = "  reserved_inline_functions[readable_name];
}
            }
            else
            {
                 print "\nError in " FILENAME " at line " _line ", token " _token ": Missing parameter!" > "/dev/stderr"               
            }
        }
        else if ( _token == "RECURSE" )
        {
if (__debug > 5 )
print "\t...depth(\"__in_fn\"): " depth("__in_fn") > "/dev/stderr"
            if ( depth("__in_fn") > 0 ) {
                readable_name = Name2Readable(stack_i_value("__raw",stack_last_value("__in_fn")))
                reserved_recurse_functions[readable_name] = stack_last_value("__in_fn")
                reserved_words[readable_name] = "RCALL(" readable_name ")" 
                pop("__tokens")
                pop("__raw")
                push("__tokens","RECURSE")
                push("__raw",stack_i_value("__raw",stack_last_value("__in_fn")))
            } else {
                print "\nError in " FILENAME " at line " _line ", token " _token ": Interpreting a compile-only word" > "/dev/stderr"
            }
        }
    }
    else if ( _token == "__unknown" && readable_name in reserved_does_functions ) {
if (__debug > 1 ) {
    print "reserved_does_functions call! token: " _token " main_raw: \"" _raw "\" last_i: " stack_last_value("__level") " last_token: " stack_last_value("__tokens") ":" stack_last_value("__raw")
}
        save_token(_token,reserved_does_functions[readable_name],_space,_line) 
    }
    else if ( _token == "__unknown" && readable_name in reserved_inline_functions ) {
        stack_array["__level",1] = depth("__tokens")
        push("__level",reserved_inline_functions[readable_name]+1)  
        pop_token() # smazani __unknown(fn_name)
if (__debug > 1 )
print "reserved_inline_functions activate! token: " _token " main_raw: \"" _raw "\" last_i: " stack_last_value("__level") " last_token: " stack_last_value("__tokens") ":" stack_last_value("__raw")
    }
    else if ( _token == "WORD" || _token == "PARSE" ) { # WORD/PARSE se nezmenilo na CSTRING/STRING, takze musime byt v definici funkce
        delete reserved_functions[stack_i_value("__raw",stack_last_value("__in_fn"))]
        readable_name = Name2Readable(stack_i_value("__raw",stack_last_value("__in_fn")))
        reserved_inline_functions[readable_name] = stack_last_value("__in_fn")
    } else if ( _token == "COLON" ) {
        push("__in_fn",depth("__tokens"))
if ( debug > 5 )
print "\t...stack_last_value(\"__in_fn\") = " stack_last_value("__in_fn") " = " depth("__tokens") > "/dev/stderr"
        readable_name = Name2Readable(_raw) 
        reserved_functions[_raw] = readable_name
        reserved_words[readable_name] = "CALL(" readable_name ")" 
    } else if ( _token == "VALUE" ) {
        readable_name = Name2Readable(_raw) 
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSH([" readable_name "])"
if ( debug > 5 )
print "\t...!!! reserved_words[" readable_name "]  = " reserved_words[readable_name] > "/dev/stderr"
    } else if ( _token == "DVALUE" ) {
        readable_name = Name2Readable(_raw) 
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSHDOT([" readable_name "])" 
    } else if ( _token == "ZCONSTANT" ) {
        readable_name = Name2Readable(_raw)
if ( debug > 5 )
print "\t..." _raw " -> " readable_name > "/dev/stderr"
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "ZPUSH(" readable_name ")" 
    } else if ( _token == "FCONSTANT" ) {
        readable_name = Name2Readable(_raw)
if ( debug > 5 )
print "\t..."_raw " -> " readable_name > "/dev/stderr"
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "FPUSH(" readable_name ")" 
    } else if ( _token == "CREATE" ) {
        readable_name = Name2Readable(_raw) 
if ( debug > 5 )
print "\t..."_raw " -> " readable_name > "/dev/stderr"
        push("__last_create_name",readable_name)
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSH(" readable_name ")" 
    } else if ( _token == "CONSTANT" || _token == "VARIABLE" || _token == "DVARIABLE" ) {
        readable_name = Name2Readable(_raw) 
if ( debug > 5 )
print "\t..."_raw " -> " readable_name > "/dev/stderr"
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSH(" readable_name ")" 
    }
    
    stack_array["__level",1] = depth("__tokens") + 1 # budeme ukazovat vzdy na pristi token
    if ( depth("__level") > 1 ) {
        # zda se ze jsme dokoncili nejaky token z inline funkce, kteremu chybel parametr, tak se vratime do zbytku inline funkce
        stack_array["__level",1] = depth("__tokens") + 1
        unroll_fn()

    }
    else
        init_read_word()
if ( debug > 4 )
print " token(" depth("__tokens") "): " _token ", main_raw(" depth("__raw") "): " _raw ", space(" depth("__space") "): [" _space "]" > "/dev/stderr"

}



function new_token() 
{
    

#     print "\t" word ": \"" main_raw "\"" > "/dev/stderr"
    
    make_save_string = 0

    if ( word == "" && main_raw == "" ) { 
#         main_raw ~ /^[[:space:]]*$/) {        
        main_space = main_space main_last_char
        main_last_char = ""
    } else if ( word == "" ) {        

        upper_raw = toupper(main_raw)
        
        if ( main_raw == "(" ) { # ( ...comment... )
            terminating_character = "multiline_comment"
            word = "__comment"
            main_raw = ""
        } else if ( main_raw == "\\" ) { # \ ...comment...
            terminating_character = "\n"
            word = "__comment"
            main_raw = ""
        } else if ( substr(main_raw,length(main_raw)) == "(" ) {
            # .( ...)
            # ???( ... )
            terminating_character = ")"                
            word = reserved_words[upper_raw]
            if ( word == "" ) word = "__unknown_string"
            main_raw = ""
            main_last_char = "" # smazat mezeru co lezi hned za (
            make_save_string = 1
        } else if ( substr(main_raw,length(main_raw)) == "\"" ) {
            # ." ..."
            # s" ..."
            # z" ..."
            # ABORT" ..."
            # ???" ..."
            terminating_character = "\""                
            word = reserved_words[upper_raw]
            if ( word == "" ) word = "__unknown_string"
            main_raw = ""
            main_last_char = "" # smazat mezeru co lezi hned za "
            make_save_string = 1
        } else if ( upper_raw == "PARSE-NAME" ) {
            if ( depth("__in_fn") > 0 ) {
                save_token("PARSE-NAME","",main_space,NR)
                print "\nWarning in " FILENAME " at line " NR ": Token number " stack_last_value("__level") " " upper_raw " inside the word definition is not full supported" > "/dev/stderr"
                return                
            } 
            word = "STRING"
            terminating_character = "space"
            main_ignore_first_space = 1
            main_raw = ""
            main_last_char = ""
            make_save_string = 1  
        } else if ( upper_raw == "WORD" || upper_raw == "PARSE" ) {
            
            # hledani oddelovace pro WORD or PARSE
            i = depth("__tokens") # posledni ulozeny token
            while ( i > 0 &&
                    stack_i_value("__tokens",i) != "COLON" &&
                    stack_i_value("__tokens",i) != "__char" && 
                    stack_i_value("__tokens",i) != "__number" && 
                    stack_i_value("__tokens",i) != "BL" ) 
            {
                print "\nWarning in " FILENAME " token " upper_raw " at line " NR ": The token " i " " stack_i_value("__tokens",i) "(" stack_i_value("__raw",i) ") at " stack_i_value("__line",i) " line will be ignored when searching for a delimiter." > "/dev/stderr"
                i--
            }
                    
            if ( i < 1 ) {
                print "\nError in " FILENAME " Separator for " upper_raw " at line " NR " not found!" > "/dev/stderr"
                save_token(upper_raw,"",main_space,NR)
                return
            } else if ( stack_i_value("__tokens",i) == "COLON" ) { # oddelovac nenalezen, mozna jsem ve funkci tak je to ok
                save_token(upper_raw,"",main_space,NR)
                return
            } else if ( stack_i_value("__tokens",i) == "__char" ) {
                terminating_character = stack_i_value("__raw",i)
            } else if ( stack_i_value("__tokens",i) == "__number" ) {
                terminating_character = sprintf("%c", stack_i_value("__raw",i)+0)
            } else if ( stack_i_value("__tokens",i) == "BL" ) {
                terminating_character = "space"
            }
            
            if ( i == depth("__tokens") ) { # posledni ulozeny token
                main_space = stack_last_value("__space") main_space
                pop_token()
            }
            else 
                stack_array["__tokens",i] = "__nop"
            
            if ( depth("__in_fn") == 0 ) {
            
                if ( upper_raw == "WORD" ) {
                    word = "CSTRING"
                } else {
                    word = "STRING"
                    main_ignore_first_space = 0
                }
                main_raw = ""
                main_last_char = ""
                make_save_string = 1  
            } else {
                save_token(upper_raw,terminating_character,main_space,NR)
                return
            }
        } else if ( upper_raw in reserved_words ) {

if (0) print "\nreserved_words found! depth:" depth("__in_fn") ", upper_raw: \"" upper_raw "\" main_space: [" main_space "] word: [" word "] main_last_char: [" main_last_char "]" > "/dev/stderr"

            if ( upper_raw in use_reserved_words ) use_reserved_words[upper_raw]++

            if ( depth("__in_fn") == 0 && 
               ( reserved_words[upper_raw] == "CONSTANT" || reserved_words[upper_raw] == "ZCONSTANT" || reserved_words[upper_raw] == "FCONSTANT" ||
                 reserved_words[upper_raw] == "VALUE"    || reserved_words[upper_raw] == "DVALUE"    ||
                 reserved_words[upper_raw] == "FVARIABLE"|| reserved_words[upper_raw] == "ZVARIABLE" ||                 
                 reserved_words[upper_raw] == "VARIABLE" || reserved_words[upper_raw] == "DVARIABLE" || 
                 reserved_words[upper_raw] == "CREATE" ) )
            {
                terminating_character = "space"
                word = reserved_words[upper_raw]
                main_raw = ""
                main_last_char = "" # smazat mezeru mezi "constant" a "name"
            }
            else if ( depth("__in_fn") > 0 && reserved_words[upper_raw] == "DOES_FROM" ) {

                new_token_temp = stack_i_value("__raw",stack_last_value("__in_fn"))
                reserved_inline_functions[Name2Readable(new_token_temp)] = stack_last_value("__in_fn")

                save_token("__does",new_token_temp," ",NR)
                save_token("SEMICOLON","",main_space,NR)
                delete reserved_functions[new_token_temp]
                save_token("COLON","_does_" new_token_temp,main_space,NR)
            }
            else if ( reserved_words[upper_raw] == "__char"   || reserved_words[upper_raw] == "[DEFINED]" || 
                      reserved_words[upper_raw] == "COLON"    || reserved_words[upper_raw] == "TO" ||
                      reserved_words[upper_raw] == "POSTPONE" || reserved_words[upper_raw] == "__tick" ) 
            {
                terminating_character = "space"
                word = reserved_words[upper_raw]
if (__debug > 3) print "word: " word > "/dev/stderr"
                main_raw = ""
                main_last_char = "" # smazat mezeru mezi ":" a "name"
            } else {            
                word = reserved_words[upper_raw]
                save_token(word,"",main_space,NR)
                return
            }
        } else if ( main_raw ~ /^-?[0-9]+$/) {
            save_token("__number",main_raw,main_space,NR)
            return
        } else if ( main_raw ~ /^-?[0-9]+\.$/) {
            save_token("__double_number",substr(main_raw,1,length(main_raw)-1),main_space,NR)
            return
        } else if ((main_raw ~ /^[+-]?[0-9][0-9]*[.]?[0-9]*[Ee][+-]?[0-9]*$/) || upper_raw == "INF" || upper_raw == "-INF" || upper_raw == "NAN" ) {
            save_token("__floating_point_number",main_raw,main_space,NR)
            return
        } else {
            save_token("__unknown",main_raw,main_space,NR)
            return
        }
    } else if ( word == "[DEFINED]" ) {
        save_token("__number",(toupper(main_raw) in reserved_words),main_space,NR)
        return      
    } else if ( word == "__tick" ) {
        readable_name = Name2Readable(main_raw)        

        if ( main_raw in reserved_functions ) {
            save_token("__number",readable_name,main_space,NR)
        } else if (readable_name in reserved_inline_functions ) {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens")+1 " __tick: Newly defined function/word \"" readable_name "\" is inline so it has no address" > "/dev/stderr"
            save_token("__unknown","address(" readable_name ")",main_space,NR)            
        } else if (main_raw in reserved_words ) {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens")+1 " __tick: Standard function/word \"" reserved_words[main_raw] "\" is inline so it has no address" > "/dev/stderr"
            save_token("__unknown","address(" reserved_words[main_raw] ")",main_space,NR)            
        } else {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens")+1 " __tick: \"" main_raw "\" is not the name of a newly defined function" > "/dev/stderr"
            save_token("__unknown","address(" readable_name ")",main_space,NR)            
        }
        return
    } else if ( word == "__char" ) {
        # tady je skryta chyba, kdy prvni znak muze byt \r nebo \x20 atd. opravit!!!         
        if ( main_raw ~ /^\\x7B/ ) new_token_first_char = 123 # 0x7B
        else if ( main_raw ~ /^\\x7D/ ) new_token_first_char = 125 # 0x7D
        else if ( main_raw ~ /^%%/ ) new_token_first_char = 37 # 0x25
        else if ( main_raw ~ /^\\x23/ ) new_token_first_char = 35 # 0x23
        else if ( main_raw ~ /^\\x24/ ) new_token_first_char = 36 # 0x24
        else if ( main_raw ~ /^\\r/ ) new_token_first_char = 13 # 0x0D
        else 
            new_token_first_char = substr(main_raw,1,1)
            
        save_token(word,new_token_first_char,main_space,NR)
        return
    } else {
        save_token(word,main_raw,main_space,NR)
        return
    }
    

}


function bool_false_if()
{
    # ignores everything except " [else] ", " [then] ", " [endif] " and " [If] ". Regardless of whether it is in the comment thread or behind WORD.
    # 2 varianty: 
    # - pred koncem radku
    #   main_raw = "[IF"    main_last_char_name "]" 
    # - na konci radku
    #   main_raw = "[IF]"   main_last_char_name "" 

    if ( char !~/^[[:space:]]$/ ) return 0;
    if ( index(toupper(main_raw main_last_char),"[IF]") > 0 ) return 1;
    if ( index(toupper(main_raw main_last_char),"[ELSE]") > 0 ) return 1;
    if ( index(toupper(main_raw main_last_char),"[THEN]") > 0 ) return 1;
    if ( index(toupper(main_raw main_last_char),"[ENDIF]") > 0 ) return 1;
    return 0;
}


{

# terminating_character = "space"               normal state
#                         "\""                  text string
#                         "multiline_comment"   multiline_comment ending )
#                         RS    line comment
# main_space
# word
# main_raw    
# main_last_char
# make_save_string
    
# print "terminating_character = [" terminating_character "]"
    for (main_i=1; main_i<=length($0); main_i++) {
            
# print "\tmain_raw: [" main_raw "][" main_last_char "] terminating_character = [" terminating_character "]" > "/dev/stderr"
        char = substr($0, main_i, 1);
        
if (__debug > 8) print "\tmain_last_char: [" main_last_char "] char: [" char "] terminating_character: [" terminating_character "] main_raw : \"" main_raw "\"" > "/dev/stderr"

        if ( make_save_string == 0 ) {
            if ( char == "%" ) {
                # Removal of the problem with the % character, which otherwise awk will understand as a formatting specifier when printing.
                char = "%%"
            } else if ( char == "#") {
                # The # character can be interpreted in awk or M4 as the beginning of a comment.
                char = "\\x23"
            } 
#             else if ( char == "\"") {
#                 # The " == ascii code 34 == \x22 == \042 character can be interpreted in awk or M4 as the end of a string.
#                 char = "\\042"
#             }

        } 
        else  if      ( char == "{" ) {
            # M4 FORTH uses {} characters as the beginning and end of a block instead of `'
            char = "\\x7B"
        }
        else if ( char == "}" ) {
            # M4 FORTH uses {} characters as the beginning and end of a block instead of `'
            char = "\\x7D"
        }
        else if ( char == "%" ) {
            # Removal of the problem with the % character, which otherwise awk will understand as a formatting specifier when printing.
            char = "%%"
        }
        else if ( char == "n" && main_last_char == "\\") {
            # The \r character can be used instead of \n to wrap a line on the ZX Spectrum.
            char = "r"
        }
        else if ( char == "#") {
            # The # character can be interpreted in awk or M4 as the beginning of a comment.
            char = "\\x23"
        }
        else if ( ( char ~ /[0-9#@*]/ ) && ( main_last_char == "$" ) ) {
            # The code tries to remove problematic parts in the string that could be interpreted by the M4 macro processor in the future
            # as a macro name ($0), 
            # or macro parameters ($1 to $9) 
            # or a list of all parameters ($@ or $*) 
            # or a total number of macro parameters ($#).
            main_last_char = "\\x24"
        }
        
        
        if ( main_ignore_first_space && char ~/^[[:space:]]$/ ) {
            main_space = main_space char
            continue
        }
        main_ignore_first_space = 0
        
        if ( terminating_character == "false_if" ) {
            if ( bool_false_if() ) { 
                # ignores everything except " [else] ", " [then] ", " [endif] " and " [If] ". Regardless of whether it is in the comment thread or behind WORD.
                main_raw = main_raw main_last_char
                main_last_char = char
# print " >>>" main_raw "<<< >"main_last_char "<"

                new_token()
            } else if ( char ~/^[[:space:]]$/ ) {
# print "delete [" main_raw main_last_char "]"
                main_raw = ""
                main_last_char = ""
            } else {
                main_raw = main_raw main_last_char                    
                main_last_char = char
            }
        } else if ( terminating_character == "space" && char ~/^[[:space:]]$/ ) { #  make_save_string == 0 || main_last_char != "\\"
            main_raw = main_raw main_last_char
            main_last_char = char
# print "\n space: >>>" main_raw "<<< >"main_last_char "<"
            new_token()
        } else if ( terminating_character == "multiline_comment" && char == ")" ) {
            main_raw = main_raw main_last_char
            main_last_char = ""
            new_token()
        } else if ( terminating_character == char && ( make_save_string == 0 || main_last_char != "\\" ) ) {
# print "\n char: >>>" main_raw "<<< >"main_last_char "<"
            main_raw = main_raw main_last_char
            main_last_char = char
            new_token()
        } else {        
if (debug  > 10) print "\nmain_last_char: [" main_last_char "] char: [" char "] bool: " (char ~/^[[:space:]]$/) " terminating_character: [" terminating_character "]" > "/dev/stderr"
            main_raw = main_raw main_last_char
            main_last_char = char
        }
    }
    # dosazen konec radku
    char = "\n"
# print "endline: >>" main_raw "<< main_last_char: >" main_last_char "< terminating_character: [" terminating_character "]"
    if ( main_raw == "" || EOF ) { # OPRAVIT!!! protoze main_raw jeste neni spojen s poslednim znakem... 
        main_raw = main_raw main_last_char
        main_last_char = "\n"
        new_token()
    } else if ( terminating_character == "multiline_comment" ) {
        main_raw = main_raw main_last_char "\n;# "
        main_last_char = ""
    } else if ( terminating_character == "false_if" ) {
# print "--->" main_raw "<---"
        char = "\n"
        if ( bool_false_if() ) { 
            # ignores everything except " [else] ", " [then] ", " [endif] " and " [If] ". Regardless of whether it is in the comment thread or behind WORD.
            main_raw = main_raw main_last_char
            main_last_char = "\n"
            new_token()
        } else  {
# print "delete [" main_raw main_last_char "]"
            main_raw = ""
            main_last_char = ""
        }
    } else { # vsechno vyjma false_if a multiline_comment zde konci, vcetne retezcu a slov se specialnim ukoncenim typu word 
        main_raw = main_raw main_last_char
        main_last_char = "\n"
        new_token()
    }
}


function Name2Readable(name,readable_name) 
{
    
    if ( name ~ /^'.'$/ ) {
        readable_name = Name2Readable(substr(name,2,1))
        readable_name = "_char" readable_name
        return readable_name
    }
    
    readable_name=""
    main_last_char_name = 0

    for (j=1; j<=length(name); j++) {
        name_char = substr(name, j, 1);
        if ( name_char ~ /^[0-9a-zA-Z_]$/ ) {
            
            if ( main_last_char_name == 0 )
                readable_name = readable_name "_"
                
            readable_name = readable_name name_char
            main_last_char_name = 1
        }
        else {
            main_last_char_name = 0
            readable_name = readable_name "_"
            
            if      ( name_char == "\000" ) readable_name = readable_name "NUL"    #00 Null character
            else if ( name_char == "\001" ) readable_name = readable_name "SOH"    #01 Start of Heading
            else if ( name_char == "\002" ) readable_name = readable_name "STX"    #02 Start of Text
            else if ( name_char == "\003" ) readable_name = readable_name "ETX"    #03 End of Text
            else if ( name_char == "\004" ) readable_name = readable_name "EOT"    #04 End of Transmission
            else if ( name_char == "\005" ) readable_name = readable_name "ENQ"    #05 Enquiry
            else if ( name_char == "\006" ) readable_name = readable_name "ACK"    #06 Acknowledge
            else if ( name_char == "\007" ) readable_name = readable_name "BEL"    #07 Bell, Alert
            else if ( name_char == "\010" ) readable_name = readable_name "BS"     #08 Backspace
            else if ( name_char == "\011" ) readable_name = readable_name "HT"     #09 Horizontal Tab
            else if ( name_char == "\012" ) readable_name = readable_name "LF"     #0A Line Feed
            else if ( name_char == "\013" ) readable_name = readable_name "VT"     #0B Vertical Tabulation
            else if ( name_char == "\014" ) readable_name = readable_name "FF"     #0C Form Feed
            else if ( name_char == "\015" ) readable_name = readable_name "CR"     #0D Carriage Return
            else if ( name_char == "\016" ) readable_name = readable_name "SO"     #0E Shift Out
            else if ( name_char == "\017" ) readable_name = readable_name "SI"     #0F Shift In
            else if ( name_char == "\020" ) readable_name = readable_name "DLE"    #10 Data Link Escape
            else if ( name_char == "\021" ) readable_name = readable_name "DC1"    #11 Device Control One (XON)
            else if ( name_char == "\022" ) readable_name = readable_name "DC2"    #12 Device Control Two
            else if ( name_char == "\023" ) readable_name = readable_name "DC3"    #13 Device Control Three (XOFF)
            else if ( name_char == "\024" ) readable_name = readable_name "DC4"    #14 Device Control Four
            else if ( name_char == "\025" ) readable_name = readable_name "NAK"    #15 Negative Acknowledge
            else if ( name_char == "\026" ) readable_name = readable_name "SYN"    #16 Synchronous Idle
            else if ( name_char == "\027" ) readable_name = readable_name "ETB"    #17 End of Transmission Block
            else if ( name_char == "\030" ) readable_name = readable_name "CAN"    #18 Cancel
            else if ( name_char == "\031" ) readable_name = readable_name "EM"     #19 End of medium
            else if ( name_char == "\032" ) readable_name = readable_name "SUB"    #1A Substitute
            else if ( name_char == "\033" ) readable_name = readable_name "ESC"    #1B Escape
            else if ( name_char == "\034" ) readable_name = readable_name "FS"     #1C File Separator
            else if ( name_char == "\035" ) readable_name = readable_name "GS"     #1D Group Separator
            else if ( name_char == "\036" ) readable_name = readable_name "RS"     #1E Record Separator
            else if ( name_char == "\037" ) readable_name = readable_name "US"     #1F Unit Separator
            else if ( name_char == " "    ) readable_name = readable_name "SP"     #20 Space
            else if ( name_char == "!"    ) readable_name = readable_name "EM"     #21 Exclamation mark
            else if ( name_char == "\042" ) readable_name = readable_name "DQ"     #22 Double quotes (or speech marks)
            else if ( name_char == "#"    ) readable_name = readable_name "HASH"   #23 Number sign
            else if ( name_char == "$"    ) readable_name = readable_name "DOL"    #24 Dollar
            else if ( name_char == "%"    ) readable_name = readable_name "PER"    #25 Per cent sign
            else if ( name_char == "&"    ) readable_name = readable_name "AMP"    #26 Ampersand
            else if ( name_char == "\047" ) readable_name = readable_name "SQ"     #27 Single quote
            else if ( name_char == "("    ) readable_name = readable_name "LP"     #28 Open parenthesis (or open bracket)
            else if ( name_char == ")"    ) readable_name = readable_name "RP"     #29 Close parenthesis (or close bracket)
            else if ( name_char == "*"    ) readable_name = readable_name "AST"    #2A Asterisk
            else if ( name_char == "+"    ) readable_name = readable_name "PLS"    #2B Plus
            else if ( name_char == ","    ) readable_name = readable_name "CM"     #2C Comma
            else if ( name_char == "-"    ) {
                if ( j == 1 )
                    readable_name = readable_name "MNS"    #2D minus
                else if ( j == length(name) )
                    readable_name = readable_name "MNS"    #2D minus
                else
                    readable_name = readable_name ""       #2D Hyphen
            }
            else if ( name_char == "."    ) readable_name = readable_name "DOT"    #2E Period, dot or full stop
            else if ( name_char == "/"    ) readable_name = readable_name "DIV"    #2F Slash or divide            
            else if ( name_char == "0"    ) readable_name = readable_name "0"      #30 Zero
            else if ( name_char == "1"    ) readable_name = readable_name "1"      #31 One
            else if ( name_char == "2"    ) readable_name = readable_name "2"      #32 Two
            else if ( name_char == "3"    ) readable_name = readable_name "3"      #33 Three
            else if ( name_char == "4"    ) readable_name = readable_name "4"      #34 Four
            else if ( name_char == "5"    ) readable_name = readable_name "5"      #35 Five
            else if ( name_char == "6"    ) readable_name = readable_name "6"      #36 Six
            else if ( name_char == "7"    ) readable_name = readable_name "7"      #37 Seven
            else if ( name_char == "8"    ) readable_name = readable_name "8"      #38 Eight
            else if ( name_char == "9"    ) readable_name = readable_name "9"      #39 Nine
            else if ( name_char == ":"    ) readable_name = readable_name "CLN"    #3A Colon
            else if ( name_char == ";"    ) readable_name = readable_name "SCLN"   #3B Semicolon
            else if ( name_char == "<"    ) readable_name = readable_name "LT"     #3C Less than (or open angled bracket)
            else if ( name_char == "="    ) readable_name = readable_name "EQ"     #3D Equals
            else if ( name_char == ">"    ) readable_name = readable_name "GT"     #3E Greater than (or close angled bracket)
            else if ( name_char == "?"    ) readable_name = readable_name "QM"     #3F Question mark
            else if ( name_char == "@"    ) readable_name = readable_name "AT"     #40 At sign
            # A..Z 
            else if ( name_char == "["    ) readable_name = readable_name "LS"     #5B Opening bracket
            else if ( name_char == "\\"   ) readable_name = readable_name "BSL"    #5C Backslash
            else if ( name_char == "]"    ) readable_name = readable_name "RS"     #5D Closing bracket
            else if ( name_char == "^"    ) readable_name = readable_name "HAT"    #5E Caret - circumflex
            # _             
            else if ( name_char == "`"    ) readable_name = readable_name "GRV"    #60 Grave accent
            # a..z
            else if ( name_char == "{"    ) readable_name = readable_name "LC"     #7B Opening brace
            else if ( name_char == "|"    ) readable_name = readable_name "VBAR"   #7C Vertical bar
            else if ( name_char == "}"    ) readable_name = readable_name "RC"     #7D Closing () brace
            else if ( name_char == "~"    ) readable_name = readable_name "TIL"    #7E Equivalency sign - tilde
            else if ( name_char == "\177" ) readable_name = readable_name "DEL"    #7F Delete
            else {
                cmd = "printf \"%d\" \"'" name_char "\""
                cmd | getline name_char
                close(cmd)    
                readable_name = readable_name "_X" name_char    
            }
        }
    }
    return readable_name
}



# Funkce pro zjištění relativní cesty
function find_relative_path(file) {
    # Prohledávání v aktuálním adresáři
    if (file_exists("./" file)) return "./" file

    # Prohledávání v podadresáři M4
    if (file_exists("./M4/" file)) return "./M4/" file

    # Prohledávání v nadřazeném adresáři
    if (file_exists("../M4/" file)) return "../M4/" file

    # Soubor nenalezen, vrátíme prázdný řetězec
    return "./error:relative_path_not_found!!!/" file
}

# Funkce pro ověření existence souboru
function file_exists(file) {
    return (system("[ -f \"" file "\" ]") == 0)
}


function floatToHex(value) {
    # Získání znaménka
    sign = 0
    
    if ( substr(value,1,1) == "-" ) {
        sign = 0x8000
        hexreal = sprintf( "%a", substr(value,2) )
    }
    else if ( substr(value,1,1) == "+" )
        hexreal = sprintf( "%a", substr(value,2) )
    else
        hexreal = sprintf( "%a", value )

    if ( hexreal == "0x0p+0" && sign ) {
        print "\nWarning: You are trying to convert \"negative zero\" to Danagy 16 bit floating point format, so it will be changed to a negative value closest to zero." > "/dev/stderr"                
        return "FMMIN"
    }

    if ( hexreal == "0x0p+0" ) {
        print "\nWarning: You are trying to convert \"positive zero\" to Danagy 16 bit floating point format, so it will be changed to a positive value closest to zero." > "/dev/stderr"        
        return "FPMIN"
    }

    if ( hexreal == "0xinf" && sign ) {
        print "\nWarning: You are trying to convert \"-inf\" to Danagy 16 bit floating point format. It will be converted as a smallest possible value." > "/dev/stderr"
        return "FMMAX"
    }
    
    if ( hexreal == "0xinf" ) {
        print "\nWarning: You are trying to convert \"+inf\" to Danagy 16 bit floating point format. It will be converted as a largest possible value." > "/dev/stderr"
        return "FPMAX"
    }

    if ( hexreal == "NaN" ) {
        print "\nWarning: You are trying to convert \"Not a Number\" to Danagy 16 bit floating point format. It will be converted as a positive value closest to zero." > "/dev/stderr"
        return "FPMIN"              # lol
    }

    # Výpočet exponentu
    exponent = substr(hexreal, index(hexreal, "p") + 1) + 0x40
    # Výpočet mantisy
    mantissa = substr(hexreal, index(hexreal, "x") + 1, index(hexreal, "p") - index(hexreal, "x") - 1)
    if ( mantissa ~ /^1\./ )
        mantissa = "1" substr(mantissa,3)

    mantissa = mantissa "000"
    round_nibble=substr(mantissa,4,1)
    mantissa = "0x" substr(mantissa,1,3)
    mantissa = strtonum(mantissa)

    if ( round_nibble ~ /[^0-7]/ )
        mantissa = mantissa + 1
    
    if ( mantissa == 0x200 ) {
        exponent++
        mantissa=0x00
    }
    else
        mantissa = mantissa - 0x100
        
    if ( exponent < 0 && sign ) {
        print "\nWarning: The value " value " is too close to zero, so it will be changed to a negative value closest to zero." > "/dev/stderr"        
        hexValue = "FMMIN"
    }
    else if ( exponent < 0 )
    {
        print "\nWarning: The value " value " is too close to zero, so it will be changed to a positive value closest to zero." > "/dev/stderr"        
        hexValue = "FPMIN"
    }
    else if ( exponent > 0x7F && sign )
    {
        print "\nWarning: The value " value " is less than the smallest possible value, so it will be changed to the smallest possible value." > "/dev/stderr"
        hexValue = "FMMAX"
    }   
    else if ( exponent > 0x7F)
    {
        print "\nWarning: The value " value " is greater than the largest possible value, so it will be changed to the largest possible value." > "/dev/stderr"
        hexValue = "FPMAX"
    }   
    else {
        # Sestavení hexadecimální hodnoty
        hexValue = sprintf("0x%04X", sign + exponent * 0x100 + mantissa)
    }
    return hexValue
}


function check_recurse() {
    i = 0
    loop_depth = 0
    while ( i <= depth("__tokens") ) {
# print "i: " i
        if ( stack_i_value("__tokens",i) == "DO" || stack_i_value("__tokens",i) == "QUESTIONDO" )
        {
            j = i + 1
            loop_depth = 1
            rec_active = 0
            while ( j <= depth("__tokens") && loop_depth > 0 ) {
# print "j: " j
                if ( stack_i_value("__tokens",j) == "RECURSE" ) rec_active = 1
                if ( stack_i_value("__tokens",j) == "DO" || stack_i_value("__tokens",j) == "QUESTIONDO" ) loop_depth++
                if ( stack_i_value("__tokens",j) == "LOOP" ) loop_depth--
                if ( stack_i_value("__tokens",j) == "ADDLOOP" ) loop_depth--
                if ( loop_depth > 0 ) j++
            }
            if ( rec_active ) {
                if ( stack_i_value("__tokens",i) == "DO" ) stack_array["__tokens",i] = "DO(R)"
                if ( stack_i_value("__tokens",i) == "QUESTIONDO" ) stack_array["__tokens",i] = "QUESTIONDO(R)"
            }
        }
        else if ( stack_i_value("__tokens",i) == "FOR" ) {
            j = i + 1
            loop_depth = 1
            rec_active = 0
            while ( j <= depth("__tokens") && loop_depth > 0 ) {
# print " j: " j
                if ( stack_i_value("__tokens",j) == "RECURSE" ) rec_active = 1
                if ( stack_i_value("__tokens",j) == "FOR" ) loop_depth++
                if ( stack_i_value("__tokens",j) == "NEXT" ) loop_depth--
                if ( loop_depth > 0 ) j++
            }
            if ( rec_active ) {
                stack_array["__tokens",i] = "FOR(R)"
            }            
        }
        i++
    }
}



function print_word(i,_raw,_token,_space,_line,readable_name) {
    
    i = stack_last_value("__level")
    _space = stack_array["__space",i]
    _token = stack_array["__tokens",i]
    _raw   = stack_array["__raw",i]
    _line  = stack_array["__line",i]
    if ( _raw != "" )
        readable_name = Name2Readable(_raw) 
    else
        readable_name = ""
if ( __debug > 2 ) {
  print "\n\ti: " i "(" stack_i_value("__level",1) "=" stack_i_value("__tokens",stack_i_value("__level",1)) ":" stack_i_value("__raw",stack_i_value("__level",1)) "), print_fn == in_fn: " print_fn " == " in_fn", token: " _token ", main_raw: " _raw ", readable_name: " readable_name > "/dev/stderr"
  print "\tdepth(__level): " depth("__level")
  if ( readable_name != "" ) {
    if ( readable_name in reserved_inline_functions)    print "\treserved_inline_functions[" readable_name "] = " reserved_inline_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_functions)           print "\treserved_functions[" readable_name "] = "        reserved_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_value)               print "\treserved_value[" readable_name "] = "            reserved_value[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_words)               print "\treserved_words[" readable_name "] = "            reserved_words[readable_name] > "/dev/stderr"
  }
}
    if ( _token == "__nop" ) {
        if ( print_fn == in_fn )
            printf _space;
    }    
    else if ( _token == "__number" ) {
        if ( print_fn == in_fn )
            printf _space "PUSH(" _raw ")";
    } else if (_token == "__floating_point_number" ) {
        if ( print_fn == in_fn ) {      
            if ( arg == "-zfloat" )
                printf _space "ZPUSH(" _raw ")";    # floating point "string"
            else 
                printf _space "FPUSH(" _raw ")";    # floating point "string"           
        }
        
    } else if ( _token == "__double_number" ) {
        if ( print_fn == in_fn )
            printf _space "PUSHDOT(" _raw ")";
    } else if ( _token == "__char" ) {
        if ( print_fn == in_fn )
            printf _space "PUSH('" _raw "')";

    } else if ( _token == "COLON" ) {
# print "........colon"

        if ( readable_name in reserved_inline_functions ) 
            in_fn = 1 - print_fn;   # nikdy netisknu inline funkci
        else {
            in_fn_name = readable_name
            in_fn = 1;
        }
        if ( print_fn == in_fn ) {
            if ( readable_name in reserved_recurse_functions )
                printf _space "R" _token "(" readable_name ")"                
            else
                printf _space _token "(" readable_name ")"
        }
    } else if ( _token == "SEMICOLON" ) {
# print "........semicolon"
        if ( depth("__level") > 1 ) {
            pop("__level")
            return  # no need ++
        }
        if ( print_fn == in_fn ) {
            if ( in_fn_name in reserved_recurse_functions )
                printf _space "R" _token                
            else 
                printf _space _token
        }
        in_fn_name = ""
        in_fn = 0
    } else if ( _token == "RECURSE" ) {
        if ( print_fn == in_fn ) {
            if ( _raw == "" )
                print "\nError in " FILENAME " at line " _line ": Token " _token " number " i " does not know the name of the called word/function" > "/dev/stderr"
            printf _space "RCALL(" readable_name ")";
        }
    } else if ( _token == "VALUE"    || _token == "DVALUE"    ||
                _token == "CONSTANT" || _token == "FCONSTANT" || _token == "ZCONSTANT" ||
                _token == "CREATE"   ||
                _token == "VARIABLE" || _token == "DVARIABLE" ) 
    {
        if ( print_fn == in_fn )
            printf _space _token "(" readable_name ")";        
    } else if ( _token == "TO" ) {
        if ( print_fn == in_fn )
            printf _space _token "(" readable_name ")";
    } else if ( _token == "ABORT_DQ" ) {
        if ( print_fn == in_fn )
            print _space "IF PRINT({\"" _raw "\"}) BYE THEN ;# Originally ABORT\""
    } else if ( _token in double_quoted_strings ) {
        if ( print_fn == in_fn ) {
            printf _space _token "({\"" _raw "\"})";
        }
    } else if ( _token == "__comment" ) {
        if ( print_fn == in_fn )
            printf _space ";# " _raw;
    } else if ( _token == "DO" || _token == "QUESTIONDO" ) {
        if ( print_fn == in_fn ) {
# print "\n ;# normal with possible parameter(" i "):\n"
            printf _space _token;
            if ( _raw != "" ) 
                printf "(" readable_name ")";        
        }
    } else if ( _token != "__unknown" ) {
        if ( print_fn == in_fn ) {
# print "\n ;# normal(" i "):\n"
            printf _space _token;
        }
    } else if ( readable_name != "" && (readable_name in reserved_words) ) {
        if ( print_fn == in_fn ) {
# print "\n ;# word(" i "):\n"
            printf _space reserved_words[readable_name];
        }
    } else if ( readable_name != "" && (readable_name in reserved_functions) ) {
        if ( print_fn == in_fn ) {
# print "\n ;# reserved_functions\n"
            printf _space reserved_words[readable_name]
        }
    } else if ( readable_name != "" && (readable_name in reserved_value) ) {
        if ( print_fn == in_fn ) {
# print "\n ;# reserved_value\n"
            printf _space reserved_words[readable_name]
        }
    } else {
        if ( print_fn == in_fn ) {
# print "\n ;# else\n"
            print "\nError in " FILENAME " at line " _line ": Token number " stack_last_value("__level") " is unknown word \"" _raw "\"" > "/dev/stderr"
            printf _space _raw
        }
    }

if (__debug >3) {
  print "\n\tout: " i ", token: " _token ", main_raw: " _raw ", readable_name: " readable_name > "/dev/stderr"
  print "\tdepth(__level): " depth("__level") > "/dev/stderr"
  if ( readable_name != "" ) {
    if ( readable_name in reserved_inline_functions)    print "\treserved_inline_functions[" readable_name "] = " reserved_inline_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_functions)           print "\treserved_functions[" readable_name "] = "        reserved_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_value)               print "\treserved_value[" readable_name "] = "            reserved_value[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_words)               print "\treserved_words[" readable_name "] = "            reserved_words[readable_name] > "/dev/stderr"
  }
}

    stack_array["__level",depth("__level")]++    
}

END {
    check_recurse()
        
    printf "include(`" find_relative_path("FIRST.M4") "\47)dnl\n"
    printf "  ifdef __ORG\n"
    printf "    org __ORG\n"
    printf "  else\n"
    printf "    org 32768\n"
    printf "  endif\n"
    printf "  INIT(60000)\n"


if ( 0 ) {
    for (end_i = 1; end_i <= depth("__tokens"); end_i++)
    {
        print "i:" end_i " " stack_array["__tokens",end_i] "(" stack_array["__raw",end_i] ")" > "/dev/stderr"
    }
}

    # vypsani main slov
    for (i=1; i<=depth("__tokens"); i++) {
        printf main_leading_spaces[i] main_words[i] > "/dev/stderr"
    }

    print "\n;# ----- main code -----"
    print_fn = 0
    in_fn = 0
    stack_array["__level",1] = 1
    
    # vypsani main slov
    while( stack_last_value("__level") <= depth("__tokens") )
    {

# print stack_last_value("__level") " < " depth("__tokens")
        if ( stack_last_value("__level") == "" ) {
            print "error?"
            break
        }
        print_word()

    }
if (__debug > 0) print "\n; last token: " stack_last_value("__level")
    printf "\n  STOP"
    print "\n;# ----- list of functions -----"
    print_fn = 1
    in_fn = 0
    in_fn_name = ""
    stack_array["__level",1] = 1

    # vypsani main slov
    while( stack_last_value("__level") <= depth("__tokens") )
    {

# print stack_last_value("__level") " < " depth("__tokens")
        if ( stack_last_value("__level") == "" ) {
            print "error?"
            break
        }
        print_word()

    }
if (__debug > 0) print "\n; last token: " stack_last_value("__level")

    
    if ( "FASIN" in reserved_words && use_reserved_words["FASIN"] ) {
        printf "\n\nCOLON(__FASIN,( rad -- ))\n"
        printf ";# pi/2 =  1.5707963 = 0x4092\n"
        printf ";# a0   =  1.5707288 = 0x4092\n"
        printf ";# a1   = -0.2121144 = 0xBDB2\n"
        printf ";# a2   =  0.0742610 = 0x3C30\n"
        printf ";# a3   = -0.0187293 = 0xBA33\n"
        printf ";# asin(x) = pi/2 - sqrt(1-x)*(a0 + a1*x + a2*x*x + a3*x*x*x)\n"
        printf ";# asin(x) = pi/2 - sqrt(1-x)*(a0 + x*(a1 + x*(a2 + a3*x)))\n"
        printf ";# asin(x) = pi/2 - sqrt(1-x)*(((a3*x + a2)*x + a1)*x + a0)\n"
        printf "\n"
        printf "    DUP PUSH(0x8000) AND SWAP\n"
        printf "    FABS\n"
        printf "    DUP PUSH(0x4000) SWAP FSUB FSQRT\n" 
        printf "    SWAP DUP DUP PUSH(0xBA33) FMUL\n"
        printf "    PUSH(0x3C30) FADD FMUL\n"
        printf "    PUSH(0xBDB2) FADD FMUL\n" 
        printf "    PUSH(0x4092) FADD FMUL\n"
        printf "    PUSH(0x4092) SWAP FSUB\n"
        printf "    XOR\n"
        printf "SEMICOLON"
    }

    if ( "FACOS" in reserved_words && use_reserved_words["FACOS"] ) {
        printf "\n\nCOLON(__FACOS,( rad -- ))\n"
        printf "  ;# x\n"
        printf "  DUP FABS DUP\n"   
        printf "  ;# x u u\n"
        printf "  PUSH(0x4000) SWAP FSUB FSQRT SWAP\n"
        printf "  ;# x sqrt(1.0-u) u\n"
        printf "  DUP DUP\n"
        printf "  PUSH(0xBA33) FMUL\n"
        printf "  PUSH(0x3C30) FADD FMUL\n"
        printf "  PUSH(0xBDB2) FADD FMUL\n"
        printf "  PUSH(0x4092) FADD\n"
        printf "  FMUL SWAP\n"
        printf "  _0LT IF PUSH(0x4192) SWAP FSUB THEN\n"
        printf "SEMICOLON"
    }

    if ( "FTRUNC" in reserved_words && use_reserved_words["FTRUNC"] ) {
        printf "\n\nCOLON(__ZTRUNC,( z -- round_towards_zero(z)))\n"
        printf "ZDUP      ;# ( z -- z z )\n"
        printf "Z0LT      ;# ( z z -- flag(z<0) )\n"
        printf "IF        ;# ( z flag -- z )\n"
        printf "  ZNEGATE ;# ( z -- abs(z) )\n"
        printf "  ZFLOOR  ;# ( z -- floor(fabs(z)) )\n"
        printf "  ZNEGATE ;# ftrunc(z)\n"
        printf "ELSE\n"
        printf "  ZFLOOR  ;# ftrunc(z)\n"
        printf "THEN\n"
        printf "SEMICOLON"
    }
    
#     if ( "FLOOR" in use_reserved_words && use_reserved_words["FLOOR"] ) {
#         printf "\n\nCOLON(__FLOOR,( f -- round_towards_negative_infinity(f)))\n"    
#         printf "  DUP _0LT IF\n"
#         printf "    FNEGATE DUP FTRUNC_ABS TUCK NE IF PUSH(0x4000) ;# = 1e\n"
#         printf "FADD THEN FNEGATE\n"
#         printf "  ELSE\n"
#         printf "    FTRUNC_ABS\n"
#         printf "  THEN\n"
#         printf "SEMICOLON"
#     
# #         printf "COLON(floor,({{{{ f -- n }}}}))
# #         printf "  DUP _0LT IF\n"
# #         printf "    FNEGATE PUSH(0x3FFF) ;# = 0.999E\n"
# #         printf "FADD FTRUNC_ABS FNEGATE\n"
# #         printf "  ELSE\n"
# #         printf "    FTRUNC_ABS\n"
# #         printf "  THEN\n"
# #         printf "SEMICOLON"
#     }
    
    if ( "FMOD" in reserved_words && use_reserved_words["FMOD"] ) {
        printf "\n\nCOLON(__ZMOD,( za zb  -- zmod(a%b)))\n"
        printf "ZSWAP     ;# ( a b -- b a )\n"
        printf "ZOVER     ;# ( b a -- b a b )\n"
        printf "ZDIV      ;# ( b a b -- b (a/b) )\n"
        printf "ZDUP      ;# ( b (a/b) -- b (a/b) (a/b) )\n"
        printf "ZDUP      ;# ( b (a/b) (a/b) -- b (a/b) (a/b) (a/b) )\n"
        printf "Z0LT      ;# ( b (a/b) (a/b) (a/b) -- b (a/b) (a/b) flag )\n"
        printf "IF        ;# ( b (a/b) (a/b) flag -- b (a/b) (a/b) )\n"
        printf "  ZNEGATE ;#    ( b (a/b) (a/b) -- b (a/b) fabs(a/b) )\n"
        printf "  ZFLOOR  ;#    ( b (a/b) (-a/b) -- b (a/b) floor(fabs(a/b)) )\n"
        printf "  ZNEGATE ;#    ( b (a/b) ftrunc(-a/b) -- b (a/b) ftrunc(a/b)) )\n"
        printf "ELSE      ;# ( b (a/b) (a/b) flag -- b (a/b) (a/b) )\n"
        printf "  ZFLOOR  ;# ( b (a/b) (a/b) -- b (a/b) ftrunc(a/b) )\n"
        printf "THEN      ;# ( b (a/b) (a/b) -- b (a/b) ftrunc(a/b) )\n"
        printf "ZSUB      ;# ( b ftrunc(a/b) -- b (a/b)-ftrunc(a/b) )\n"
        printf "ZMUL      ;# ( b (a/b)-ftrunc(a/b) -- fmod(a/b) )\n"
        printf "SEMICOLON"
    }

    printf "\n"
}
