function init_read_word() {
  terminating_character = "space"
  if (last_char ~/^[[:space:]]$/ )
    space = last_char
  else
    space = ""
  word = ""
  raw = ""
  last_char = ""
if ( debug > 7 )
print "space now: [" space "]" > "/dev/stderr"
}

function depth(name) {
    if (stack_pos[name] == "") 
        stack_pos[name] = 0;
    return stack_pos[name];
}

function push(name, val) {
# print "\tin name:" name ", val:" val ", depth:" stack_pos[name]
    if (stack_pos[name] == "") 
        stack_pos[name] = 1;
    else
        stack_pos[name]++;
    stack_array[name, stack_pos[name]] = val;
# print "\tout name:" name ", val:" val ", depth:" stack_pos[name]
}

function pop(name) {
    if (depth(name) > 0) {
        return stack_array[name, stack_pos[name]--];
    } else {
        return "";
    }
}

function stack_last_value(name) {
    if (depth(name) > 0) {
        return stack_array[name, stack_pos[name]];
    } else {
        return "";
    }
}

function stack_i_value(name,i) {
    if ( i > 0 && i <= depth(name) ) {
        return stack_array[name, i];
    } else {
        return "";
    }
}

function add_word(word,spaces) {
    if (inside_word_definition) {
        fn_leading_spaces[fn_count] = spaces
        fn_words[fn_count] = word
        fn_count++;
    }
    else {
        main_leading_spaces[main_count] = spaces
        main_words[main_count] = word
        main_count++;
    }
}


# i == -1 --> last word
# i == -2 --> previous word
function set_previous_word(word,spaces,i) {
    if (inside_word_definition) {
        if ( fn_count+i>=0) {
            fn_leading_spaces[fn_count+i] = spaces
            fn_words[fn_count+i] = word
        }
    }
    else {
        if ( main_count+i>=0) {
            main_leading_spaces[main_count+i] = spaces
            main_words[main_count+i] = word
        }
    }
}


function delete_last_word() {
    if (inside_word_definition)
    {
        if ( fn_count > 0) fn_count--;
    }
    else
    {
        if ( main_count > 0) main_count--;
    }
}


# i == -1 --> last word
# i == -2 --> previous word
function get_previous_spaces(i) {
    if (inside_word_definition)
    {
        if ( fn_count+i >= 0 ) return fn_leading_spaces[fn_count+i];
    }
    else
    {
        if ( main_count+i >= 0 ) return main_leading_spaces[main_count+i];
    }
    return ""
}


# i == -1 --> last word
# i == -2 --> previous word
function get_previous_word(i) {
    if (inside_word_definition) {
        if ( fn_count+i >= 0 ) return fn_words[fn_count+i];
    }
    else
    {
        if ( main_count+i >= 0 ) return main_words[main_count+i];
    }
    return ""
}


function change_previous_word(new) {
    if ( inside_word_definition ) {
        if ( fn_count > 1 ) fn_words[fn_count-1] = new
    }
    else { 
        if ( main_count > 1 ) main_words[main_count-1] = new
    }
}


function find_previous_word() {
    if ( inside_word_definition ) {
        if ( fn_count > 1 ) return fn_words[fn_count-1]
    }
    else if ( main_count > 1 )
        return main_words[main_count-1]
    return ""
}

BEGIN {

  reserved_words["AT-XY"]       = "AT_XY"               # facility ext      
  reserved_words["ERASE"]       = "PUSH(0) FILL"        # for compatibility with the core-ext   
  reserved_words["PAUSE"]       = "PAUSE"               # not standard   
  reserved_words["WAIT"]        = "WAIT"                # not standard   
  reserved_words["MS"]          = "PUSH(20) UDIV WAIT"  # for compatibility with facility ext   
  reserved_words["ROLL"]        = "ROLL"                # core ext   
  reserved_words["BOUNDS"]      = "OVER ADD SWAP ;# bounds ( addr u -- addr+u addr ) (ready for \"do\")\n"   # not standard
  reserved_words["[']"]         = "[']"                 # problem...
  reserved_words["'"]           = "'"                   # problem...
  reserved_words["["]           = ""                    # ignore
  reserved_words["]"]           = ""                    # ignore
  reserved_words["LITERAL"]     = ""                    # ignore
  
  reserved_words["ABORT"]       = "BYE ;# Originally ABORT\n"  # After compilation, there is no difference between ABORT and BYE.  
#   reserved_words["ABORT\""]     = It's complicated, it has to be read as a string --> "IF PRINT({"..."}) BYE THEN ;# Originally ABORTq\n"  # After compilation, there is no difference between ABORT and BYE.  
  reserved_words["ALIGN"]       = "ALIGN"           # + integer --> ALIGN(integer)
  reserved_words["IF"]          = "IF"
  reserved_words["ELSE"]        = "ELSE"
  reserved_words["THEN"]        = "THEN"
  reserved_words["DO"]          = "DO"
  reserved_words["UNLOOP"]      = "UNLOOP"
  reserved_words["LOOP"]        = "LOOP"
  reserved_words["BEGIN"]       = "BEGIN"
  reserved_words["UNTIL"]       = "UNTIL"
  reserved_words["BREAK"]       = "BREAK"           # not standard "begin break again"
  reserved_words["AGAIN"]       = "AGAIN"
  reserved_words["WHILE"]       = "WHILE"
  reserved_words["REPEAT"]      = "REPEAT"
  
  reserved_words["CASE"]        = "CASE"
  reserved_words["OF"]          = "OF DROP"         # for compatibility with the standard   
  reserved_words["ENDOF"]       = "ENDOF"
  reserved_words["ENDCASE"]     = "DROP ENDCASE"    # for compatibility with the standard
  
  reserved_words["DUP"]         = "DUP"
  reserved_words["DROP"]        = "DROP"
  reserved_words["SWAP"]        = "SWAP"
  reserved_words["WITHIN"]      = "WITHIN"
  reserved_words["AND"]         = "AND"
  reserved_words["OR"]          = "OR"
  reserved_words["XOR"]         = "XOR"
  reserved_words["NIP"]         = "NIP"
  reserved_words["TUCK"]        = "TUCK"
  reserved_words["OVER"]        = "OVER"
  reserved_words["ROT"]         = "ROT"
  reserved_words["PICK"]        = "PICK"
  reserved_words["DEPTH"]       = "DEPTH"
  reserved_words["RDROP"]       = "RDROP"
  
  reserved_words["MIN"]         = "MIN"             #                           2dup <= if swap then nip            2dup <= if drop else nip then
  reserved_words["MAX"]         = "MAX"             #                           2dup >= if swap then nip            2dup >= if drop else nip then
  reserved_words["UMIN"]        = "UMIN"            # not standard gforth-0.5   2dup u>= if swap then nip           2dup u<= if drop else nip then
  reserved_words["UMAX"]        = "UMAX"            # not standard gforth-1.0   2dup u>= if swap then nip           2dup u>= if drop else nip then
  reserved_words["DMIN"]        = "DMIN"
  reserved_words["DMAX"]        = "DMAX"
  reserved_words["DUMIN"]       = "DUMIN"           # not standard      2over 2over du<= if 2drop else 2nip then ;
  reserved_words["DUMAX"]       = "DUMAX"           # not standard      2over 2over du>= if 2drop else 2nip then ;
  
  reserved_words["EXIT"]        = "EXIT"
  reserved_words["FILL"]        = "FILL"
  reserved_words["MOVE"]        = "MOVE"
  reserved_words["CMOVE"]       = "CMOVE"
  reserved_words["BYE"]         = "BYE"
  reserved_words["RND"]         = "RND"
  reserved_words["RANDOM"]      = "RANDOM"
  reserved_words["SETSEED"]     = "SETSEED"         # not standard

  reserved_words["ALLOT"]       = "ALLOT"
  reserved_words["HERE"]        = "HERE"
  reserved_words["CREATE"]      = "CREATE"
  reserved_words["I"]           = "I"
  reserved_words["J"]           = "J"
  reserved_words["K"]           = "K"
  reserved_words["ABS"]         = "ABS"
  reserved_words["UMOD"]        = "UMOD"
  reserved_words["MOD"]         = "MOD"
  reserved_words["ACCEPT"]      = "ACCEPT"
  reserved_words["ACCEPTZ"]     = "ACCEPTZ"             # not standard
  reserved_words[">NUMBER"]     = "TO_NUMBER"

  reserved_words["STR>UDNUM"]   = "STR_TO_UDNUM"        # alias ">NUMBER" ( ud1 a1 u1   -- ud2 a2 u2 )
  reserved_words["STR>UNUM"]    = "STR_TO_UNUM"         # not standard    ( u1  a1 ulen1 -- u2 a2 ulen2 )
  reserved_words["S>NUMBER?"]   = "STR_TO_DNUM NIP _0EQ"# not standard    (     a1 u1    -- d  flag )
  reserved_words["STR>DNUM"]    = "STR_TO_DNUM"         # not standard    (     a1 u1    -- d  a2 u2 )
  reserved_words["STR>NUM"]     = "STR_TO_NUM"          # not standard    (     a1 u1    -- x  a2 u2 )

  reserved_words["EMIT"]        = "EMIT"
  
  reserved_words["TYPE"]        = "TYPE"
  reserved_words["TYPEZ"]       = "TYPEZ"               # not standard (null-terminated C-string)
  reserved_words["TYPEI"]       = "TYPEI"               # not standard (ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words["COUNT"]       = "COUNT"               # as Pascal string = counted string with maximum 255 characters
  reserved_words["COUNTZ"]      = "COUNTZ"              # not standard (null-terminated C-string)
  reserved_words["COUNTI"]      = "COUNTI"              # not standard (ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words["COMPARE"]     = "COMPARE"
  reserved_words["COMPAREZ"]    = "COMPAREZ"            # not standard (null-terminated C-string)

  reserved_words["SEARCH"]      = "SEARCH"
  reserved_words["SEARCHZ"]     = "SEARCHZ"             # not standard (null-terminated C-string)
  reserved_words["SEARCHI"]     = "SEARCHI"             # not standard (ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words["/STRING"]     = "DIVSTRING"

  reserved_words["SPACE"]       = "SPACE"
  reserved_words["SPACES"]      = "CALL(__SPACES,( n -- ))"     # for compatibility with the standard
    
  use_reserved_words["SPACES"]  = 0

  reserved_words["CR"]          = "CR"
  reserved_words["FOR"]         = "FOR"
  reserved_words["NEXT"]        = "NEXT"
  reserved_words["TRUE"]        = "TRUE"
  reserved_words["FALSE"]       = "FALSE"
  reserved_words["VARIABLE"]    = "VARIABLE"
  reserved_words["2VARIABLE"]   = "DVARIABLE"
  reserved_words["DVARIABLE"]   = "DVARIABLE"       # not standard

  reserved_words["VALUE"]       = "VALUE"
  reserved_words["2VALUE"]      = "DVALUE"
  reserved_words["DVALUE"]      = "DVALUE"          # not standard
  reserved_words["TO"]          = "TO"
  reserved_words["CONSTANT"]    = "CONSTANT"
  reserved_words["[CHAR]"]      = "__char"
  reserved_words["CHAR"]        = "__char"
  
  reserved_words["INVERT"]      = "INVERT" 
  reserved_words["LSHIFT"]      = "LSHIFT"
  reserved_words["RSHIFT"]      = "RSHIFT"
  reserved_words["<<"]          = "LSHIFT"          # not standard
  reserved_words[">>"]          = "RSHIFT"          # not standard
  reserved_words["NEGATE"]      = "NEGATE"
  
  reserved_words["DINVERT"]     = "DINVERT"         # not standard
  reserved_words["DLSHIFT"]     = "DLSHIFT"         # not standard
  reserved_words["DRSHIFT"]     = "DRSHIFT"         # not standard
  reserved_words["DNEGATE"]     = "DNEGATE"
  
  reserved_words["CMOVE>"]      = "CMOVEGT"
  reserved_words["MOVE>"]       = "MOVEGT"

  reserved_words[","]           = "COMMA"
  reserved_words["D,"]          = "DCOMMA"          # not standard
  reserved_words["?"]           = "FETCH DOT"

  reserved_words["1+"]          = "_1ADD"
  reserved_words["2+"]          = "_2ADD"
  reserved_words["+"]           = "ADD"
  reserved_words["D+"]          = "DADD"
  reserved_words["1-"]          = "_1SUB"
  reserved_words["2-"]          = "_2SUB"
  reserved_words["-"]           = "SUB"
  reserved_words["D-"]          = "DSUB"
  reserved_words["/"]           = "DIV"
  reserved_words["*"]           = "MUL"
  reserved_words["*/"]          = "MULDIV ;# Warning: Truncated division, not Floor division\n"
  reserved_words["*/MOD"]       = "MULDIVMOD ;# Warning: Truncated division, not Floor division\n"

  reserved_words["2/"]          = " PUSH(2) DIV"     # to activate optimizations in tokens (ta mezera je tam aby si constant nemyslel ze je to push)
  reserved_words["2*"]          = " PUSH(2) MUL"     # to activate optimizations in tokens

  reserved_words["/MOD"]        = "DIVMOD"
  reserved_words["U*"]          = "MUL"             # not standard
  reserved_words["U/"]          = "UDIV"            # not standard
  reserved_words["UMOD"]        = "UMOD"            # not standard
  reserved_words["U/MOD"]       = "UDIVMOD"         # not standard

  reserved_words["M+"]          = "MADD"
  reserved_words["M*"]          = "MMUL"
  reserved_words["UM*"]         = "UMMUL"
  reserved_words["FM/MOD"]      = "FMDIVMOD"
  reserved_words["SM/REM"]      = "SMDIVREM"
  reserved_words["UM/MOD"]      = "UMDIVMOD"
  
  reserved_words["256/"]        = " PUSH(256) DIV"  # to activate optimizations in tokens (ta mezera je tam aby si constant nemyslel ze je to push)
  reserved_words["256*"]        = " PUSH(256) MUL"  # to activate optimizations in tokens

  reserved_words[":"]           = "COLON"
  reserved_words["LEAVE"]       = "LEAVE"
  reserved_words["RECURSE"]     = "RECURSE"  
  reserved_words[";"]           = "SEMICOLON"
  reserved_words["DOES>"]       = "DOES_FROM"

  reserved_words["="]           = "EQ"
  reserved_words["<>"]          = "NE"
  reserved_words["<"]           = "LT"
  reserved_words[">"]           = "GT"
  reserved_words["<="]          = "LE"              # not standard
  reserved_words[">="]          = "GE"              # not standard
  
  reserved_words["U="]          = "EQ"              # not standard
  reserved_words["U<>"]         = "NE"              # not standard
  reserved_words["U<"]          = "ULT"
  reserved_words["U>"]          = "UGT"
  reserved_words["U<="]         = "ULE"             # not standard
  reserved_words["U>="]         = "UGE"             # not standard
  
  reserved_words["D="]          = "DEQ"
  reserved_words["D<>"]         = "DNE"             # not standard
  reserved_words["D<"]          = "DLT"
  reserved_words["D>"]          = "DGT"             # not standard
  reserved_words["D<="]         = "DLE"             # not standard
  reserved_words["D>="]         = "DGE"             # not standard

  reserved_words["DU="]         = "DUEQ"            # not standard
  reserved_words["DU<>"]        = "DUNE"            # not standard
  reserved_words["DU<"]         = "DULT"
  reserved_words["DU>"]         = "DUGT"            # not standard
  reserved_words["DU<="]        = "DULE"            # not standard
  reserved_words["DU>="]        = "DUGE"            # not standard
  
  reserved_words["0="]          = "_0EQ"
  reserved_words["0<"]          = "_0LT"
  reserved_words["0>"]          = "_0GT"
  reserved_words["0<="]         = "_0LE"            # not standard
  reserved_words["0>="]         = "_0GE"            # not standard
  reserved_words["0<>"]         = "_0NE"            # core ext

  reserved_words["+!"]          = "ADDSTORE"
  reserved_words["-!"]          = "SUBSTORE"        # not standard

  reserved_words["+LOOP"]       = "ADDLOOP"
  
  reserved_words["!"]           = "STORE"
  reserved_words["@"]           = "FETCH"
  reserved_words["2!"]          = "_2STORE"
  reserved_words["2@"]          = "_2FETCH"
  reserved_words["C!"]          = "CSTORE"
  reserved_words["C+!"]         = "CADDSTORE"       # not standard
  reserved_words["C-!"]         = "CSUBSTORE"       # not standard

  reserved_words["C@"]          = "CFETCH"
  
  reserved_words[">R"]          = "TO_R"
  reserved_words["R>"]          = "R_FROM"
  reserved_words["R@"]          = "R_FETCH"
  reserved_words["2>R"]         = "_2TO_R"
  reserved_words["2R>"]         = "_2R_FROM"
  reserved_words["2R@"]         = "_2R_FETCH"
  reserved_words["2RDROP"]      = "_2RDROP"
  
  reserved_words["2SWAP"]       = "_2SWAP"
  reserved_words["2DROP"]       = "_2DROP"
  reserved_words["2NIP"]        = "_2NIP"
  reserved_words["2TUCK"]       = "_2TUCK"
  reserved_words["2OVER"]       = "_2OVER"
  reserved_words["?DUP"]        = "QUESTIONDUP"
  reserved_words["?DO"]         = "QUESTIONDO"
  reserved_words["2DUP"]        = "_2DUP"
  reserved_words["3DUP"]        = "_3DUP"
  reserved_words["4DUP"]        = "_4DUP"
  reserved_words["-ROT"]        = "NROT"
  reserved_words["-2ROT"]       = "N2ROT"
  reserved_words["2ROT"]        = "_2ROT"

  reserved_words["KEY?"]        = "KEYQUESTION"
  reserved_words["KEY"]         = "KEY"

  reserved_words["D>S"]         = "D_TO_S"
  reserved_words["S>D"]         = "S_TO_D"
  
  reserved_words["EXECUTE"]     = "EXECUTE"
  reserved_words["CELL"]        = "CELL"                # not standard
  reserved_words["CELL+"]       = "CELLADD"
  reserved_words["CELLS"]       = "CELLS"
  
  reserved_words["HEX"]         = "HEX"                 # limited support for combination "hex (u)(d)." not as a permanent output setting parameter
  reserved_words["BL"]          = "PUSH(' ')"           # for compatibility with the standard

  reserved_words["{"]           = "__local_values_begin"# not standard
  reserved_words["}"]           = "__local_values_end"  # not standard

  reserved_words["T{"]          = "TEST_START"          # not standard
  reserved_words["->"]          = "TEST_EQ"             # not standard
  reserved_words["}T"]          = "TEST_END"            # not standard

  reserved_words["UTIME"]       = "UPTIME"              # not standard
  reserved_words["M4_FORTH"]    = "M4_FORTH"            # not standard
  reserved_words["ZX_BEEP"]     = "ZX_BEEP"             # not standard
  
  reserved_words["[DEFINED]"]   = "[DEFINED]"
  reserved_words["[IF]"]        = "[IF]"
  reserved_words["[ELSE]"]      = "[ELSE]"
  reserved_words["[THEN]"]      = "[THEN]"
  reserved_words["[ENDIF]"]     = "[ENDIF]"         # not standard (gforth == [then] ??? )
  
  reserved_words["."]           = "DOT SPACE"       # for compatibility with the standard
  reserved_words["U."]          = "UDOT SPACE"      # for compatibility with the standard
  reserved_words["D."]          = "DDOT SPACE"      # for compatibility with the standard
  reserved_words["UD."]         = "UDDOT SPACE"     # for compatibility with the standard

  reserved_words[".S"]          = "DOTS"            # "DEPTH PUSH('<') EMIT DUP DOT PUSH('>') EMIT DUP IF _1SUB FOR SPACE I PICK DOT NEXT THEN SPACE"
  
# potential change in the recursive word 
  recurse_reserved_words["DO"]          = "DO(R)"
  recurse_reserved_words["QUESTIONDO"]  = "QUESTIONDO(R)"
  recurse_reserved_words["FOR"]         = "FOR(R)"
  recurse_reserved_words["CALL"]        = "RCALL"
  recurse_reserved_words["COLON"]       = "RCOLON"
  recurse_reserved_words["EXIT"]        = "REXIT"
  recurse_reserved_words["SEMICOLON"]   = "RSEMICOLON"

  if ( arg == "-zfloat" ) {

    reserved_words["1/F"]       = "ZPUSH(1e) ZSWAP ZDIV" # not standard
    reserved_words["F,"]        = "ZCOMMA"          # not standard

    reserved_words["FDEPTH"]    = "ZDEPTH"
    reserved_words["FCONSTANT"] = "ZCONSTANT"
        
    reserved_words["FDOT"]      = "ZDOT"

    reserved_words["D>F"]       = "D_TO_Z"
    reserved_words["F>D"]       = "Z_TO_D"
    reserved_words["S>F"]       = "S_TO_Z"
    reserved_words["F>S"]       = "Z_TO_S"
    reserved_words["U>F"]       = "U_TO_Z"          # not standard

    reserved_words["FABS"]      = "ZABS"
    reserved_words["FACOS"]     = "ZACOS"
    reserved_words["F+"]        = "ZADD"
    reserved_words["FASIN"]     = "ZASIN"
    reserved_words["FATAN"]     = "ZATAN"
    reserved_words["FCOS"]      = "ZCOS"
    reserved_words["F/"]        = "ZDIV"
    reserved_words["F."]        = "ZDOT"
    reserved_words["FDROP"]     = "ZDROP"
    reserved_words["F2DROP"]    = "Z2DROP"          # not standard
    reserved_words["FDUP"]      = "ZDUP"
    reserved_words["F2DUP"]     = "Z2DUP"           # not standard
    
    reserved_words["FLOAT"]     = "ZFLOAT"          # not standard
    reserved_words["FLOATS"]    = "ZFLOATS"

    reserved_words["FNIP"]      = "ZNIP"            # not standard
    reserved_words["FEXP"]      = "ZEXP"
    reserved_words["F@"]        = "ZFETCH"
    reserved_words["FLOOR"]     = "ZFLOOR"    
    reserved_words["FTRUNC"]    = "CALL(__ZTRUNC,( z -- round_towards_zero(z)))"    # floating ext
    
    use_reserved_words["FTRUNC"] = 0
    
    reserved_words["FLN"]       = "ZLN"
    reserved_words["F*"]        = "ZMUL"
    reserved_words["F**"]       = "ZMULMUL"
    reserved_words["FNEGATE"]   = "ZNEGATE"
    reserved_words["FOVER"]     = "ZOVER"
    reserved_words["FPICK"]     = "ZPICK"           # not standard
    reserved_words["FROT"]      = "ZROT"
    reserved_words["F-ROT"]     = "ZNROT"           # not standard

    reserved_words["FSIN"]      = "ZSIN"
    reserved_words["FSQRT"]     = "ZSQRT"
    reserved_words["F!"]        = "ZSTORE"
    reserved_words["F-"]        = "ZSUB"
    reserved_words["FSWAP"]     = "ZSWAP"
    reserved_words["F2SWAP"]    = "Z2SWAP"
    
    reserved_words["FTAN"]      = "ZTAN"
    reserved_words["FVARIABLE"] = "ZVARIABLE"
    reserved_words["F<="]       = "ZLE"
    reserved_words["F>="]       = "ZGE"
    reserved_words["F<>"]       = "ZNE"
    reserved_words["F>"]        = "ZGT"
    reserved_words["F<"]        = "ZLT"
    reserved_words["F="]        = "ZEQ"
    reserved_words["F0<"]       = "Z0LT"
    reserved_words["F0="]       = "Z0EQ"
    reserved_words["FLOAT+"]    = "ZFLOATADD"
    reserved_words["FLOATS"]    = "ZFLOATS"
    reserved_words["ZDEPTH"]    = "ZDEPTH"          # not standard
    
#     reserved_words["FFRAC"]     = "FFRAC"           # not standard
        
    reserved_words["FMOD"]      = "CALL(__ZMOD,( za zb  -- zmod(a%b)))"    # not standard
    
    use_reserved_words["FMOD"] = 0

    reserved_words["F2*"]       = "ZPUSH(2E) ZMUL" # not standard
    reserved_words["F2/"]       = "ZPUSH(2E) ZDIV" # not standard
    
    reserved_words["F0<"]       = "Z0LT"            # not standard
    reserved_words["F0="]       = "Z0EQ"            # not standard

    
    
  } else {
      
    reserved_words["F,"]        = "FCOMMA"          # not standard

    reserved_words["FDEPTH"]    = "DEPTH"
    reserved_words["FCONSTANT"] = "FCONSTANT"
    reserved_words["FDOT"]      = "FDOT"
      
    reserved_words["D>F"]       = "D_TO_S S2F"      # for compatibility with the standard
    reserved_words["F>D"]       = "F2S S_TO_D"      # for compatibility with the standard
    reserved_words["S>F"]       = "S2F"
    reserved_words["F>S"]       = "F2S"
    reserved_words["U>F"]       = "U2F"             # not standard
    reserved_words["F>U"]       = "F2U"             # not standard
    
    reserved_words["FABS"]      = "FABS"
    reserved_words["FACOS"]     = "CALL(__FACOS,( rad -- ))"    # for compatibility with the standard
    
    use_reserved_words["FACOS"] = 0

    reserved_words["F+"]        = "FADD"    
    reserved_words["FASIN"]     = "CALL(__FASIN,( rad -- ))"    # for compatibility with the standard
    
    use_reserved_words["FASIN"] = 0

#     reserved_words["FATAN"]     = ""    # for compatibility with the standard
    reserved_words["FCOS"]      = "PUSH(0x4092) SWAP FSUB FSIN ;# ( cos  0..π only)\n"   # for compatibility with the standard
    reserved_words["F/"]        = "FDIV"
    reserved_words["F."]        = "FDOT SPACE"
    reserved_words["FDROP"]     = "FDROP"
    reserved_words["F2DROP"]    = "F2DROP"          # not standard
    reserved_words["FDUP"]      = "FDUP"
    reserved_words["F2DUP"]     = "F2DUP"           # not standard
    reserved_words["FNIP"]      = "FNIP"            # not standard
    reserved_words["FEXP"]      = "FEXP"
    reserved_words["F@"]        = "FFETCH"
    
#     reserved_words["FLOOR"]     = "CALL(__FLOOR,( f -- round_towards_negative_infinity(f)))"    
#     use_reserved_words["FLOOR"] = 0
    
    reserved_words["FLOOR"]     = "FLOOR"
    reserved_words["FTRUNC"]    = "FTRUNC"   
    reserved_words["FLN"]       = "FLN"
    reserved_words["F*"]        = "FMUL"
#     reserved_words["F**"]       = ""
    reserved_words["FNEGATE"]   = "FNEGATE"
    reserved_words["FOVER"]     = "FOVER"
    reserved_words["FPICK"]     = "FPICK"           # not standard
    reserved_words["FROT"]      = "FROT"
    reserved_words["F-ROT"]     = "FNROT"           # not standard
    reserved_words["FSIN"]      = "FSIN ;# ( sin -π/2..π/2 only)\n"
    reserved_words["FSQRT"]     = "FSQRT"
    reserved_words["F!"]        = "FSTORE"
    reserved_words["F-"]        = "FSUB"

    reserved_words["FSWAP"]     = "FSWAP"
    reserved_words["F2SWAP"]    = "F2SWAP"

    reserved_words["FTAN"]      = "DUP FSIN SWAP PUSH(0x4092) SWAP FSUB FSIN FDIV ;# ( tan  0..π/2 only)\n"   # for compatibility with the standard
    reserved_words["FVARIABLE"] = "FVARIABLE"
    reserved_words["F<="]       = "FLE"
    reserved_words["F>="]       = "FGE"   
    reserved_words["F<>"]       = "FNE"
    reserved_words["F>"]        = "FGT"
    reserved_words["F<"]        = "FLT"
    reserved_words["F="]        = "FEQ"    
    reserved_words["F0<"]       = "F0LT"
    reserved_words["F0="]       = "F0EQ"
    reserved_words["FLOAT+"]    = "FLOATADD"
    reserved_words["FLOATS"]    = "FLOATS"

    reserved_words["FFRAC"]     = "FFRAC"           # not standard
    reserved_words["FMOD"]      = "FMOD"            # not standard
    reserved_words["F2*"]       = "F2MUL"           # not standard
    reserved_words["F2/"]       = "F2DIV"           # not standard
  }
  
  reserved_words["ZXFONT_5X8"]  = "ZXFONT_5x8"      # not standard
  
  reserved_words[".("]          = "PRINT"       #  .( ...)
                                
  reserved_words[".\""]         = "PRINT"       #  ." ..."
  reserved_words[".\\\""]       = "PRINT"       # .\" ..."
  reserved_words[".Z\""]        = "PRINTZ"      # .z" ..."   not standard (as a null-terminated C-string)
  reserved_words[".I\""]        = "PRINTI"      # .i" ..."   not standard (as a ZX ROM string terminated by a character with the 7th bit inverted)

  reserved_words[",string\""]   = "COMMASTRING"     #   ,string" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",stringz\""]  = "COMMASTRINGZ"    #  ,stringz" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",stringi\""]  = "COMMASTRINGI"    #  ,stringi" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",cstring\""]  = "COMMACSTRING"    #  ,cstring" ..."   not standard (use VARIABLE_SECTION)
  reserved_words[",\""]         = "COMMACSTRING"    #         ," ..."   not standard (gforth)

  reserved_words[",S\""]        = "COMMA_S"     # ,s" ..."   not standard
  reserved_words[",SZ\""]       = "COMMA_SZ"    #,sz" ..."   not standard
  reserved_words[",SI\""]       = "COMMA_SI"    #,si" ..."   not standard
  reserved_words[",C\""]        = "COMMA_C"     # ,c" ..."   not standard
                                
  reserved_words["S\""]         = "STRING"      #  s" ..."
  reserved_words["S\\\""]       = "STRING"      # s\" ..."
  reserved_words["SZ\""]        = "STRINGZ"     # sz" ..."   not standard (as a null-terminated C-string)
  reserved_words["SI\""]        = "STRINGI"     # si" ..."   not standard (as a ZX ROM string terminated by a character with the 7th bit inverted)
  reserved_words["C\""]         = "CSTRING"     #  c" ..."   as Pascal string = counted string with maximum 255 characters
                                
  reserved_words["ABORT\""]     = "ABORT_DQ"    # abort" ..."
  reserved_words["POSTPONE"]    = "POSTPONE"
  reserved_words["'"]           = "__tick"
  reserved_words["[']"]         = "__tick"
  reserved_words[":NONAME"]     = "__noname_fn" # after ; push addr_fn on stack

#   reserved_words["WORD"]        = "WORD"        # as Pascal string = counted string with maximum 255 characters
#   reserved_words["FIND"]        = "FIND"        # as Pascal string = counted string with maximum 255 characters
  

  inside_word_definition=0
  function_name=""
  

  string_end=""
  
  fn_count=1  
  main_count=1
  
  word=""
  upword=""
  last_upword=""
  leading_spaces=""
  in_comment=0
  noname_count=0
  makro_if[0]=1
  makro_if_depth=0
  push("__level",1)
  
  local_values_count=-1

#     string_type["WORD"] = "1"

  double_quoted_strings["ABORT_DQ"] = "1"
  double_quoted_strings["__unknown_string"] = "1"

  double_quoted_strings["STRING"] = "1"
  double_quoted_strings["STRINGZ"] = "1"
  double_quoted_strings["STRINGI"] = "1"
  double_quoted_strings["CSTRING"] = "1"
  
  double_quoted_strings["PRINT"] = "1"
  double_quoted_strings["PRINTZ"] = "1"
  double_quoted_strings["PRINTI"] = "1"
  
  double_quoted_strings["COMMASTRING"] = "1"
  double_quoted_strings["COMMASTRINGZ"] = "1"
  double_quoted_strings["COMMASTRINGI"] = "1"
  double_quoted_strings["COMMACSTRING"] = "1"
  
  double_quoted_strings["COMMA_S"] = "1"
  double_quoted_strings["COMMA_SZ"] = "1"
  double_quoted_strings["COMMA_SI"] = "1"
  double_quoted_strings["COMMA_C"] = "1"
  
  init_read_word()
  __debug = 0
}

function pop_local_token() {    
    pop("__local_tokens")
    pop("__local_raw")
    pop("__local_line")
    pop("__local_space")
}

function pop_token() {    
    pop("__tokens")
    pop("__raw")
    pop("__line")
    pop("__space")
}


function push_token(_token,_raw,_space,_line) {
    
if (debug > 1) {
    print depth("__line") " = " depth("__tokens") " = " depth("__raw") " = "depth("__space") "\ttoken: " _token " raw: \""_raw"\" space: \"" _space "\" last_char: [" last_char "]" > "/dev/stderr"
}

    if ( _token == "[IF]" && makro_if[makro_if_depth] ) {
        makro_if_depth = makro_if_depth + 1
        
        if ( stack_last_value("__tokens") == "__number" ) {
            pop("__tokens")
            _raw = pop("__raw") 
            pop("__space")
            makro_if[makro_if_depth] = (_raw != 0)                
        }
        else 
            print "\nError in " FILENAME " at line " _line ": No value found before [IF], found only " stack_last_value("__tokens") stack_last_value("__raw") "." > "/dev/stderr"

        init_read_word()
        if ( makro_if[makro_if_depth] == 0 )
            terminating_character = "false_if"        
        return
    }
    else if (_token == "[IF]") {
        makro_if_depth = makro_if_depth + 1
        makro_if[makro_if_depth] = 0
        init_read_word()
        terminating_character = "false_if"
        return
    }
    else if ( _token == "[ELSE]" && makro_if[makro_if_depth-1] )  {
        makro_if[makro_if_depth] = (1 - makro_if[makro_if_depth])
        init_read_word()
        if ( makro_if[makro_if_depth] == 0 )
            terminating_character = "false_if"
        return
    }
    else if ( _token == "[ELSE]" ) { # in false if branch (just ignore)
        init_read_word()
        terminating_character = "false_if"
        return
    }
    else if ( _token == "[ENDIF]" || _token == "[THEN]" ) {
        makro_if_depth = makro_if_depth - 1
        init_read_word()
        if ( makro_if[makro_if_depth] == 0 )
            terminating_character = "false_if"
        return
    }
    
        
if ( debug > 4 )
print " token(" depth("__tokens") "): " _token ", raw(" depth("__raw") "): " _raw ", space(" depth("__space") "): " space "/dev/stderr"

# save data
    if ( _token != "__comment" && stack_last_value("__tokens") == "__comment" && _space !~/\n/)
        _space = "\n"

    if ( stack_last_value("__tokens") == "__local_values_begin" ) {
        if ( _token == "__local_values_end" || _token == "__local_values_comment" ) {
            pop_token() # remove __local_values_begin
            if ( _token == "__local_values_comment" ) {
                push("__local_tokens","__comment")
                push("__local_raw",_raw)
                push("__local_line",_line)
                push("__local_space",_space)
            }
            while ( depth("__local_tokens") ) {
                _token = stack_last_value("__local_tokens")
                _raw   = stack_last_value("__local_raw")
                _line  = stack_last_value("__local_line")
                _space = stack_last_value("__local_space")
                pop_local_token()
                push_token(_token,_raw,_space,_line)
            }
            return
        } else if ( _token == "__unknown" && _raw == "--" ) {
            init_read_word()
            word = "__local_values_comment"
            terminating_character = "}"
            return
        } else {
            push("__local_tokens","VALUE")
            push("__local_raw",_raw)
            push("__local_line",_line)
            push("__local_space",_space)
            init_read_word()
            return
        }
    } else {
        push("__tokens",_token)
        push("__raw",_raw)
        push("__line",_line)
        push("__space",_space)
    }

# check data    
    if ( _raw == "" ) {
        if ( _token == "__noname_fn" ) {
            push("__in_fn",depth("__tokens"))
            noname_count+=1
            pop("__tokens")
            pop("__raw")        
            push("__tokens","COLON")
            push("__raw","noname" noname_count )
        }
        else if ( _token == "SEMICOLON" ) {
            if ( stack_i_value("__raw",stack_last_value("__in_fn")) ~/^noname[0-9][0-9]*$/ ) {
                push("__tokens","__number")
                push("__raw","_" stack_i_value("__raw",stack_last_value("__in_fn")))
                push("__line",_line)
                push("__space"," ")
            }
            pop("__in_fn")
        }
        else if ( _token == "VALUE"    || _token == "DVALUE" ||
                  _token == "CONSTANT" || _token == "FCONSTANT" ||_token == "ZCONSTANT" ||
                  _token == "CREATE"   ||
                  _token == "VARIABLE" || _token == "DVARIABLE" ) 
        {
if (__debug > 5 )
print "\t...depth(\"__in_fn\"): " depth("__in_fn") > "/dev/stderr"
            if ( depth("__in_fn") > 0 ) {
                delete reserved_functions[stack_i_value("__raw",stack_last_value("__in_fn"))]
                readable_name = Name2Readable(stack_i_value("__raw",stack_last_value("__in_fn")))
                reserved_inline_functions[readable_name] = stack_last_value("__in_fn")
if ( debug > 5 ) {
print "\t...stack_last_value(\"__in_fn\") = " stack_last_value("__in_fn") > "/dev/stderr"
if ( readable_name != "" && ( readable_name in reserved_inline_functions )) print "reserved_inline_functions[" readable_name "] = "  reserved_inline_functions[readable_name];
}
            }
        }
        else if ( _token == "RECURSE" )
        {
if (__debug > 5 )
print "\t...depth(\"__in_fn\"): " depth("__in_fn") > "/dev/stderr"
            if ( depth("__in_fn") > 0 ) {
                readable_name = Name2Readable(stack_i_value("__raw",stack_last_value("__in_fn")))
                reserved_recurse_functions[readable_name] = stack_last_value("__in_fn")
                reserved_words[readable_name] = "RCALL(" readable_name ")" 
                pop("__tokens")
                pop("__raw")
                push("__tokens","__unknown")
                push("__raw",stack_i_value("__raw",stack_last_value("__in_fn")))
            } else {
                print "\nError in " FILENAME " at line " _line ", token " _token ": Interpreting a compile-only word" > "/dev/stderr"
            }
        }
    }
    else if ( _token == "WORD" ) {
        delete reserved_functions[stack_i_value("__raw",stack_last_value("__in_fn"))]
        readable_name = Name2Readable(stack_i_value("__raw",stack_last_value("__in_fn")))
        reserved_inline_functions[readable_name] = stack_last_value("__in_fn")
    } else if ( _token == "COLON" ) {
        push("__in_fn",depth("__tokens"))
if ( debug > 5 )
print "\t...stack_last_value(\"__in_fn\") = " stack_last_value("__in_fn") " = " depth("__tokens") > "/dev/stderr"
        readable_name = Name2Readable(_raw) 
        reserved_functions[_raw] = readable_name
        reserved_words[readable_name] = "CALL(" readable_name ")" 
    } else if ( _token == "VALUE" ) {
        readable_name = Name2Readable(_raw) 
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSH([" readable_name "])"
if ( debug > 5 )
print "\t...!!! reserved_words[" readable_name "]  = " reserved_words[readable_name] > "/dev/stderr"
    } else if ( _token == "DVALUE" ) {
        readable_name = Name2Readable(_raw) 
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSHDOT([" readable_name "])" 
    } else if ( _token == "ZCONSTANT" ) {
        readable_name = Name2Readable(_raw)
if ( debug > 5 )
print "\t..." _raw " -> " readable_name > "/dev/stderr"
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "ZPUSH(" readable_name ")" 
    } else if ( _token == "FCONSTANT" ) {
        readable_name = Name2Readable(_raw)
if ( debug > 5 )
print "\t..."_raw " -> " readable_name > "/dev/stderr"
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "FPUSH(" readable_name ")" 
    } else if ( _token == "CONSTANT" || _token == "VARIABLE" || _token == "DVARIABLE" || _token == "CREATE" ) {
        readable_name = Name2Readable(_raw) 
if ( debug > 5 )
print "\t..."_raw " -> " readable_name > "/dev/stderr"
        reserved_value[_raw] = readable_name
        reserved_words[readable_name] = "PUSH(" readable_name ")" 
    }
    
    init_read_word()
if ( debug > 4 )
print " token(" depth("__tokens") "): " _token ", raw(" depth("__raw") "): " _raw ", space(" depth("__space") "): [" space "]" > "/dev/stderr"

}

function new_token() 
{
    
    make_save_string = 0

    if ( word == "" && raw == "" ) { 
#         raw ~ /^[[:space:]]*$/) {        
        space = space last_char
        last_char = ""
    } else if ( word == "" ) {        

        upper_raw = toupper(raw)
        
        if ( raw == "(" ) { # ( ...comment... )
            terminating_character = ")"
            word = "__comment"
            raw = ""
        } else if ( raw == "\\" ) { # \ ...comment...
            terminating_character = "\n"
            word = "__comment"
            raw = ""
        } else if ( substr(raw,length(raw)) == "(" ) {
            # .( ...)
            # ???( ... )
            terminating_character = ")"                
            word = reserved_words[upper_raw]
            if ( word == "" ) word = "__unknown_string"
            raw = ""
            last_char = "" # smazat mezeru co lezi hned za (
            make_save_string = 1
        } else if ( substr(raw,length(raw)) == "\"" ) {
            # ." ..."
            # s" ..."
            # z" ..."
            # ABORT" ..."
            # ???" ..."
            terminating_character = "\""                
            word = reserved_words[upper_raw]
            if ( word == "" ) word = "__unknown_string"
            raw = ""
            last_char = "" # smazat mezeru co lezi hned za "
            make_save_string = 1
        } else if ( upper_raw == "WORD" ) {
            
            if ( stack_last_value("__tokens") == "__char" ) {
                terminating_character = stack_last_value("__raw")
                space = stack_last_value("__space") space
                pop_token()
            }
            else if ( stack_last_value("__tokens") == "BL" ) { 
                terminating_character = "after_space"
                space = stack_last_value("__space") space
                pop_token()
            }
            else if ( stack_last_value("__tokens") == "__number" ) { 
                terminating_character = sprintf("%c", stack_last_value("__raw")+0)
                space = stack_last_value("__space") space
                pop_token()
            }
            else {
                print "\nError in " FILENAME " at line " NR ": Token number " stack_last_value("__level")+1 " is WORD needs a terminating character parameter" > "/dev/stderr"
                terminating_character = "after_space"                
            }
            
            if ( depth("__in_fn") > 0 ) {
                push_token("WORD",terminating_character,space,NR)
                print "\nError in " FILENAME " at line " NR ": Token number " stack_last_value("__level") " WORD inside the word definition is not supported" > "/dev/stderr"
                return                
            } 
            word = "CSTRING"
            raw = ""
            last_char = ""
            make_save_string = 1  
        } else if ( upper_raw in reserved_words ) {

if (0) print "\nreserved_words found! depth:" depth("__in_fn") ", upper_raw: \"" upper_raw "\" space: [" space "] word: [" word "] last_char: [" last_char "]" > "/dev/stderr"

            if ( depth("__in_fn") == 0 && 
               ( reserved_words[upper_raw] == "CONSTANT" || reserved_words[upper_raw] == "ZCONSTANT" || reserved_words[upper_raw] == "FCONSTANT" ||
                 reserved_words[upper_raw] == "VALUE"    || reserved_words[upper_raw] == "DVALUE"    ||
                 reserved_words[upper_raw] == "FVARIABLE"|| reserved_words[upper_raw] == "ZVARIABLE" ||                 
                 reserved_words[upper_raw] == "VARIABLE" || reserved_words[upper_raw] == "DVARIABLE" ) )
            {
                terminating_character = "after_space"
                word = reserved_words[upper_raw]
                raw = ""
                last_char = "" # smazat mezeru mezi "constant" a "name"
            }            
            else if ( reserved_words[upper_raw] == "__char"   || reserved_words[upper_raw] == "[DEFINED]" || 
                      reserved_words[upper_raw] == "COLON"    || reserved_words[upper_raw] == "TO" ||
                      reserved_words[upper_raw] == "POSTPONE" || reserved_words[upper_raw] == "__tick" ) 
            {
                terminating_character = "after_space"
                word = reserved_words[upper_raw]
if (__debug > 3) print "word: " word > "/dev/stderr"
                raw = ""
                last_char = "" # smazat mezeru mezi ":" a "name"
            } else {            
                word = reserved_words[upper_raw]
                push_token(word,"",space,NR)
                return
            }
        } else if ( raw ~ /^-?[0-9]+$/) {
            push_token("__number",raw,space,NR)
            return
        } else if ( raw ~ /^-?[0-9]+\.$/) {
            push_token("__double_number",substr(raw,1,length(raw)-1),space,NR)
            return
        } else if ((raw ~ /^[+-]?[0-9][0-9]*[.]?[0-9]*[Ee][+-]?[0-9]*$/) || upper_raw == "INF" || upper_raw == "-INF" || upper_raw == "NAN" ) {
            push_token("__floating_point_number",raw,space,NR)
            return
        } else {
            push_token("__unknown",raw,space,NR)
            return
        }
    } else if ( word == "[DEFINED]" ) {
        push_token("__number",(toupper(raw) in reserved_words),space,NR)
        return      
    } else if ( word == "__tick" ) {
        readable_name = Name2Readable(raw)        

        if ( raw in reserved_functions ) {
            push_token("__number",readable_name,space,NR)
        } else if (readable_name in reserved_inline_functions ) {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens")+1 " __tick: Newly defined function/word \"" readable_name "\" is inline so it has no address" > "/dev/stderr"
            push_token("__unknown","address(" readable_name ")",space,NR)            
        } else if (raw in reserved_words ) {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens")+1 " __tick: Standard function/word \"" reserved_words[raw] "\" is inline so it has no address" > "/dev/stderr"
            push_token("__unknown","address(" reserved_words[raw] ")",space,NR)            
        } else {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens")+1 " __tick: \"" raw "\" is not the name of a newly defined function" > "/dev/stderr"
            push_token("__unknown","address(" readable_name ")",space,NR)            
        }
        return
    } else if ( word == "__char" ) {
        # tady je skryta chyba, kdy prvni znak muze byt \r nebo \x20 atd. opravit!!!         
        if ( raw ~ /^\\x7B/ ) new_token_first_char = 123 # 0x7B
        else if ( raw ~ /^\\x7D/ ) new_token_first_char = 125 # 0x7D
        else if ( raw ~ /^%%/ ) new_token_first_char = 37 # 0x25
        else if ( raw ~ /^\\x23/ ) new_token_first_char = 35 # 0x23
        else if ( raw ~ /^\\x24/ ) new_token_first_char = 36 # 0x24
        else if ( raw ~ /^\\r/ ) new_token_first_char = 13 # 0x0D
        else 
            new_token_first_char = substr(raw,1,1)
            
        push_token(word,new_token_first_char,space,NR)
        return
    } else {
        push_token(word,raw,space,NR)
        return
    }
}



{

# terminating_character = " "   normal state
#                         "\""  text string
#                         ")"   text string or comment
#                         RS    line comment
# space
# word
# raw    
# last_char
# make_save_string
    
# print "terminating_character = [" terminating_character "]"
    for (i=1; i-1<=length($0); i++) {
            
# print "\traw: [" raw "][" last_char "] terminating_character = [" terminating_character "]"
        if ( i > length($0) )
            char = RS
        else 
            char = substr($0, i, 1);
        
if (__debug > 8) print "\tlast_char: [" last_char "] char: [" char "] terminating_character: [" terminating_character "] raw : \"" raw "\"" > "/dev/stderr"

        if ( make_save_string == 0 ) {
            if ( char == "%" ) {
                # Removal of the problem with the % character, which otherwise awk will understand as a formatting specifier when printing.
                char = "%%"
            } else if ( char == "#") {
                # The # character can be interpreted in awk or M4 as the beginning of a comment.
                char = "\\x23"
            } 
#             else if ( char == "\"") {
#                 # The " == ascii code 34 == \x22 == \042 character can be interpreted in awk or M4 as the end of a string.
#                 char = "\\042"
#             }

        } 
        else  if      ( char == "{" ) {
            # M4 FORTH uses {} characters as the beginning and end of a block instead of `'
            char = "\\x7B"
        }
        else if ( char == "}" ) {
            # M4 FORTH uses {} characters as the beginning and end of a block instead of `'
            char = "\\x7D"
        }
        else if ( char == "%" ) {
            # Removal of the problem with the % character, which otherwise awk will understand as a formatting specifier when printing.
            char = "%%"
        }
        else if ( char == "n" && last_char == "\\") {
            # The \r character can be used instead of \n to wrap a line on the ZX Spectrum.
            char = "r"
        }
        else if ( char == "#") {
            # The # character can be interpreted in awk or M4 as the beginning of a comment.
            char = "\\x23"
        }
        else if ( ( char ~ /[0-9#@*]/ ) && ( last_char == "$" ) ) {
            # The code tries to remove problematic parts in the string that could be interpreted by the M4 macro processor in the future
            # as a macro name ($0), 
            # or macro parameters ($1 to $9) 
            # or a list of all parameters ($@ or $*) 
            # or a total number of macro parameters ($#).
            last_char = "\\x24"
        }
        
        raw = raw last_char
        if ( terminating_character == "false_if" ) { # ignores everything except " [else] ", " [then] ", " [endif] " and " [If] ". Regardless of whether it is in the comment thread or behind WORD.
            if ( char ~/^[[:space:]]$/ ) {
                if ( index(toupper(raw),"[IF]") > 0 ||
                     index(toupper(raw),"[ELSE]") > 0 ||
                     index(toupper(raw),"[THEN]") > 0 ||
                     index(toupper(raw),"[ENDIF]") > 0 ) 
                {
                    last_char = char
                    new_token()
                } else {
# print "delete [" raw last_char "]"
                    raw = ""
                    last_char = ""
                }
            } else {
                last_char = char
            }
        } else {
        
            if ( char == "\\" && last_char == "\\" ) char = ""

            if ( terminating_character == "after_space" && (char ~/^[[:space:]]$/) ) {
                last_char = "" # ignoruji mezery
                continue
            }
            if ( terminating_character == "after_space" ) terminating_character = "space"
            if (( terminating_character == "space" && char ~/^[[:space:]]$/ ) || ( terminating_character == char && last_char != "\\" )) {
if (debug  > 10) print "\nlast_char: [" last_char "] char: [" char "] bool: " (char ~/^[[:space:]]$/) " terminating_character: [" terminating_character "]" > "/dev/stderr"
                last_char = char
                new_token()
            } else
                last_char = char
        }
        
    }
    # novy radek
    if ( raw != "" ) {
        
# print "raw: [" raw "] last_char: [" last_char "] char: [" char "]"
        if ( terminating_character == "false_if" ) { # ignores everything except " [else] ", " [then] ", " [endif] " and " [If] ". Regardless of whether it is in the comment thread or behind WORD.
            if ( char ~/^[[:space:]]$/ ) {
                if ( index(toupper(raw),"[IF]") > 0 ||
                     index(toupper(raw),"[ELSE]") > 0 ||
                     index(toupper(raw),"[THEN]") > 0 ||
                     index(toupper(raw),"[ENDIF]") > 0 ) 
                {
                    last_char = char
                    new_token()
                } else {
print "delete [" raw ":" last_char "]"
                    raw = ""
                    last_char = ""
                }
            } else {
                last_char = char
            }
        } else if ( terminating_character == ")") {
            raw = raw char ";# "
            last_char = "" # zalomeni uz jsem pridal
        } else if ( terminating_character == "\"") {
            raw = raw "\", 0x0D, \""
            last_char = "" # zalomeni uz jsem pridal
        } else {
            print "\nError in " FILENAME " at line " NR ": Token number " depth("__tokens") " \"" word ":" raw "\" and terminating character number is \"" terminating_character "\" with multiple lines" > "/dev/stderr"        
        }
    }
}


function Name2Readable(name,readable_name) 
{
    
    if ( name ~ /^'.'$/ ) {
        readable_name = Name2Readable(substr(name,2,1))
        readable_name = "_char" readable_name
        return readable_name
    }
    
    readable_name=""
    last_char_name = 0

    for (j=1; j<=length(name); j++) {
        name_char = substr(name, j, 1);
        if ( name_char ~ /^[0-9a-zA-Z_]$/ ) {
            
            if ( last_char_name == 0 )
                readable_name = readable_name "_"
                
            readable_name = readable_name name_char
            last_char_name = 1
        }
        else {
            last_char_name = 0
            readable_name = readable_name "_"
            
            if      ( name_char == "\000" ) readable_name = readable_name "NUL"    #00 Null character
            else if ( name_char == "\001" ) readable_name = readable_name "SOH"    #01 Start of Heading
            else if ( name_char == "\002" ) readable_name = readable_name "STX"    #02 Start of Text
            else if ( name_char == "\003" ) readable_name = readable_name "ETX"    #03 End of Text
            else if ( name_char == "\004" ) readable_name = readable_name "EOT"    #04 End of Transmission
            else if ( name_char == "\005" ) readable_name = readable_name "ENQ"    #05 Enquiry
            else if ( name_char == "\006" ) readable_name = readable_name "ACK"    #06 Acknowledge
            else if ( name_char == "\007" ) readable_name = readable_name "BEL"    #07 Bell, Alert
            else if ( name_char == "\010" ) readable_name = readable_name "BS"     #08 Backspace
            else if ( name_char == "\011" ) readable_name = readable_name "HT"     #09 Horizontal Tab
            else if ( name_char == "\012" ) readable_name = readable_name "LF"     #0A Line Feed
            else if ( name_char == "\013" ) readable_name = readable_name "VT"     #0B Vertical Tabulation
            else if ( name_char == "\014" ) readable_name = readable_name "FF"     #0C Form Feed
            else if ( name_char == "\015" ) readable_name = readable_name "CR"     #0D Carriage Return
            else if ( name_char == "\016" ) readable_name = readable_name "SO"     #0E Shift Out
            else if ( name_char == "\017" ) readable_name = readable_name "SI"     #0F Shift In
            else if ( name_char == "\020" ) readable_name = readable_name "DLE"    #10 Data Link Escape
            else if ( name_char == "\021" ) readable_name = readable_name "DC1"    #11 Device Control One (XON)
            else if ( name_char == "\022" ) readable_name = readable_name "DC2"    #12 Device Control Two
            else if ( name_char == "\023" ) readable_name = readable_name "DC3"    #13 Device Control Three (XOFF)
            else if ( name_char == "\024" ) readable_name = readable_name "DC4"    #14 Device Control Four
            else if ( name_char == "\025" ) readable_name = readable_name "NAK"    #15 Negative Acknowledge
            else if ( name_char == "\026" ) readable_name = readable_name "SYN"    #16 Synchronous Idle
            else if ( name_char == "\027" ) readable_name = readable_name "ETB"    #17 End of Transmission Block
            else if ( name_char == "\030" ) readable_name = readable_name "CAN"    #18 Cancel
            else if ( name_char == "\031" ) readable_name = readable_name "EM"     #19 End of medium
            else if ( name_char == "\032" ) readable_name = readable_name "SUB"    #1A Substitute
            else if ( name_char == "\033" ) readable_name = readable_name "ESC"    #1B Escape
            else if ( name_char == "\034" ) readable_name = readable_name "FS"     #1C File Separator
            else if ( name_char == "\035" ) readable_name = readable_name "GS"     #1D Group Separator
            else if ( name_char == "\036" ) readable_name = readable_name "RS"     #1E Record Separator
            else if ( name_char == "\037" ) readable_name = readable_name "US"     #1F Unit Separator
            else if ( name_char == " "    ) readable_name = readable_name "SP"     #20 Space
            else if ( name_char == "!"    ) readable_name = readable_name "EM"     #21 Exclamation mark
            else if ( name_char == "\042" ) readable_name = readable_name "DQ"     #22 Double quotes (or speech marks)
            else if ( name_char == "#"    ) readable_name = readable_name "HASH"   #23 Number sign
            else if ( name_char == "$"    ) readable_name = readable_name "DOL"    #24 Dollar
            else if ( name_char == "%"    ) readable_name = readable_name "PER"    #25 Per cent sign
            else if ( name_char == "&"    ) readable_name = readable_name "AMP"    #26 Ampersand
            else if ( name_char == "\047" ) readable_name = readable_name "SQ"     #27 Single quote
            else if ( name_char == "("    ) readable_name = readable_name "LP"     #28 Open parenthesis (or open bracket)
            else if ( name_char == ")"    ) readable_name = readable_name "RP"     #29 Close parenthesis (or close bracket)
            else if ( name_char == "*"    ) readable_name = readable_name "AST"    #2A Asterisk
            else if ( name_char == "+"    ) readable_name = readable_name "PLS"    #2B Plus
            else if ( name_char == ","    ) readable_name = readable_name "CM"     #2C Comma
            else if ( name_char == "-"    ) {
                if ( j == 1 )
                    readable_name = readable_name "MNS"    #2D minus
                else if ( j == length(name) )
                    readable_name = readable_name "MNS"    #2D minus
                else
                    readable_name = readable_name ""       #2D Hyphen
            }
            else if ( name_char == "."    ) readable_name = readable_name "DOT"    #2E Period, dot or full stop
            else if ( name_char == "/"    ) readable_name = readable_name "DIV"    #2F Slash or divide            
            else if ( name_char == "0"    ) readable_name = readable_name "0"      #30 Zero
            else if ( name_char == "1"    ) readable_name = readable_name "1"      #31 One
            else if ( name_char == "2"    ) readable_name = readable_name "2"      #32 Two
            else if ( name_char == "3"    ) readable_name = readable_name "3"      #33 Three
            else if ( name_char == "4"    ) readable_name = readable_name "4"      #34 Four
            else if ( name_char == "5"    ) readable_name = readable_name "5"      #35 Five
            else if ( name_char == "6"    ) readable_name = readable_name "6"      #36 Six
            else if ( name_char == "7"    ) readable_name = readable_name "7"      #37 Seven
            else if ( name_char == "8"    ) readable_name = readable_name "8"      #38 Eight
            else if ( name_char == "9"    ) readable_name = readable_name "9"      #39 Nine
            else if ( name_char == ":"    ) readable_name = readable_name "CLN"    #3A Colon
            else if ( name_char == ";"    ) readable_name = readable_name "SCLN"   #3B Semicolon
            else if ( name_char == "<"    ) readable_name = readable_name "LT"     #3C Less than (or open angled bracket)
            else if ( name_char == "="    ) readable_name = readable_name "EQ"     #3D Equals
            else if ( name_char == ">"    ) readable_name = readable_name "GT"     #3E Greater than (or close angled bracket)
            else if ( name_char == "?"    ) readable_name = readable_name "QM"     #3F Question mark
            else if ( name_char == "@"    ) readable_name = readable_name "AT"     #40 At sign
            # A..Z 
            else if ( name_char == "["    ) readable_name = readable_name "LS"     #5B Opening bracket
            else if ( name_char == "\\"   ) readable_name = readable_name "BSL"    #5C Backslash
            else if ( name_char == "]"    ) readable_name = readable_name "RS"     #5D Closing bracket
            else if ( name_char == "^"    ) readable_name = readable_name "HAT"    #5E Caret - circumflex
            # _             
            else if ( name_char == "`"    ) readable_name = readable_name "GRV"    #60 Grave accent
            # a..z
            else if ( name_char == "{"    ) readable_name = readable_name "LC"     #7B Opening brace
            else if ( name_char == "|"    ) readable_name = readable_name "VBAR"   #7C Vertical bar
            else if ( name_char == "}"    ) readable_name = readable_name "RC"     #7D Closing () brace
            else if ( name_char == "~"    ) readable_name = readable_name "TIL"    #7E Equivalency sign - tilde
            else if ( name_char == "\177" ) readable_name = readable_name "DEL"    #7F Delete
            else {
                cmd = "printf \"%d\" \"'" name_char "\""
                cmd | getline name_char
                close(cmd)    
                readable_name = readable_name "_X" name_char    
            }
        }
    }
    return readable_name
}


function not_use_process_word(_index)
{
    new_word=""
    
    if ( _token == "__unknown" ) {
        readable_name = Name2Readable(word)
    }
    # Asi by to chtelo jeste vyresit kolizi jmen jako napr. n* a n+, oboje bude n_x_.   

if (0) {
    printf "\nlast:[" last_upword "] \tif[%d]:%d (" string_type ")[%s]\n", makro_if_depth,makro_if[makro_if_depth], word > "/dev/stderr"
}


    if ( stack_array["__tokens",_index] == "__comment" ) {
        if ( stack_array["__tokens",_index] == "COLON" ) {
            new_word = ",({{{{ " word "}}}})"
        } else {
            new_word = ";# " word
            char = "\n"
        }
    }
    else if ( stack_array["__tokens",_index] in string_type ) {
#         if ( string_type == "STRING" || string_type == "STRINGZ" || string_type == "STRINGI" || string_type == "CSTRING" || 
#              string_type == "PRINT"  || string_type == "PRINTZ"  || string_type == "PRINTI"  || string_type == "WORD"   || 
#              string_type == "COMMASTRING" || string_type == "COMMASTRINGZ" || string_type == "COMMASTRINGI" || string_type == "COMMACSTRING" || 
#              string_type == "COMMA_S" || string_type == "COMMA_SZ" || string_type == "COMMA_SI" || string_type == "COMMA_C" )
#             new_word = string_type "({\"" word "\"})"
#         else if ( string_type == "CHAR" ) {
#             if ( substr(word,1,1) == "\"" )
#                 new_word = "PUSH(\47\"\47)"
#             else if ( substr(word,1,1) == "," )
#                 new_word = "PUSH({\47,\47})"
#             else if ( substr(word,1,1) == "I" )
#                 new_word = "PUSH({\47I\47})"
#             else if ( substr(word,1,1) == "J" )
#                 new_word = "PUSH({\47J\47})"
#             else if ( substr(word,1,1) == "K" )
#                 new_word = "PUSH({\47K\47})"
#             else if ( substr(word,1,1) == "(" )
#                 new_word = "PUSH(0x28)"
#             else if ( substr(word,1,1) == ")" )
#                 new_word = "PUSH(0x29)"
#             else if ( substr(word,1,1) == "{" )
#                 new_word = "PUSH(0x7B)"
#             else if ( substr(word,1,1) == "}" )
#                 new_word = "PUSH(0x7D)"
#             else
#                 new_word = "PUSH(\47" substr(word,1,1) "\47)"
    } else if ( stack_array["__tokens",_index] == "ABORT_DQ" ) {
            new_word = "IF PRINT({\"" word "\"}) BYE THEN ;# Originally ABORTq"
            char = "\n"
    
#         else
#         {
#             print "\nError in " FILENAME " at line " NR ": Unknown word with string: " string_type " " word char > "/dev/stderr"
#         }
#         if ( char != RS ) char = ""
#         string_end = ""
#         string_type = ""
#         word = "" # because ." ;" --> word == ";" a this make problem with inside_word_definition
        
    }
    else if (last_upword == ":" ) {
        if ( readable_name in collision_check )
            print "\nError in " FILENAME " at line " NR ": Duplicate definition or accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        else
            collision_check[readable_name] = word       # add new word to collision_check

        reserved_functions[readable_name] = "CALL("
        function_name = readable_name
        new_word = readable_name
        leading_spaces = "" # no use leading_spaces
    }
    else if (upword == "DOES>" ) {

        inline_fn_count[function_name] = 0
        create_found = 0
        
        # vyjmu co bylo predtim z fn_words az do "COLON" "name" ")" a vlozim do inline_fn_count
        while ( (fn_count > 1) && (fn_words[fn_count-2] != "COLON") ) {
            fn_count--
# print "in: [" fn_leading_spaces[fn_count] fn_words[fn_count]  "]"

            push(pomocny_words,fn_words[fn_count])
            push(pomocny_spaces,fn_leading_spaces[fn_count])
        }
# print "name: [" fn_leading_spaces[fn_count-1] fn_words[fn_count-1]  "]"
# print "colon: [" fn_leading_spaces[fn_count-2] fn_words[fn_count-2]  "]"
        if ( fn_words[fn_count] == ")" ) {
            pop(pomocny_spaces)
            pop(pomocny_words)
            fn_count++
        }
        else if ( substr(fn_words[fn_count],1,6) == ",({{{{" && substr(fn_words[fn_count],length(fn_words[fn_count])-4,5) == "}}}})" ) {
            pop(pomocny_words)
            pop(pomocny_spaces)
            temp = ";# (" substr(fn_words[fn_count],7,length(fn_words[fn_count])-11) # ")"
            push(pomocny_words,temp)
            push(pomocny_spaces,"\n")
        }

        fn_leading_spaces[fn_count] == ""
        fn_words[fn_count] == ")"
        fn_count++

        while (depth(pomocny_words)>0) {
                inline_fn_count[function_name]++
                inline_fn_spaces[function_name,inline_fn_count[function_name]] = pop(pomocny_spaces)
                temp = pop(pomocny_words)
                inline_fn_words[function_name,inline_fn_count[function_name]]  = temp

# print "out: [" temp "]"
                
            # v kodu je slovo CREATE ktere chybne vzalo dalsi polozku (nazev bude az za funkci) takze tu opravime 
            # musim smazat reserved_value a collision_check
            # a navic to ani nemusi byt jen CREATE?
            if ( temp == "CREATE" ) {
                create_found++
                inline_fn_count[function_name]++
                inline_fn_spaces[function_name,inline_fn_count[function_name]] = " " pop(pomocny_spaces)
                temp = pop(pomocny_words);
                temp2 = substr(temp,2,length(temp)-2)
# print "temp:[" temp "], temp2:[" temp2 "]"
                if ( temp2 in collision_check ) {
                    temp = collision_check[temp2]
# temp3 = temp2 in collision_check; print "in collision_check: " temp3
# temp3 = temp2 in reserved_value; print "in reserved_value: " temp3
# print "collision_check:[" collision_check[temp2] "], reserved_value:[" reserved_value[temp2] "]"
                    delete reserved_value[temp2]
                    delete collision_check[temp2]
                    
# temp3 = temp2 in collision_check; print "in collision_check: " temp3
# temp3 = temp2 in reserved_value; print "in reserved_value: " temp3
                }
                inline_fn_words[function_name,inline_fn_count[function_name]]  = temp
# print "b>>" inline_fn_words[function_name,inline_fn_count[function_name]] "<<"
            }
        }
        
        if ( create_found == 0 ) {
            print "\nError in " FILENAME " at line " NR ": Word CREATE not found in function definition with DOES>." > "/dev/stderr"        
        }
        else if ( create_found > 1 ) {
            print "\nError in " FILENAME " at line " NR ": Found more than one occurrence of CREATE in function definition with DOES>." > "/dev/stderr"                    
        }
        
        if ( function_name in reserved_inline_does_functions )            
            print "\n\n(reserved_inline_does_functions) Error in " FILENAME " at line " NR ": inline DOES> function with this name already exists.:\"" function_name "\"" > "/dev/stderr"   
        else
            reserved_inline_does_functions[function_name] = function_name

# print "function_name: " function_name
# print inline_fn_words[function_name,0]
# print inline_fn_words[function_name,1]
# print inline_fn_words[function_name,2]
        
        fn_count--
        word = ")"
        upword = ")"
        new_word = ")"
        leading_spaces = "" # no use leading_spaces
    }
    else if ( last_upword == "{" || last_upword == "{ --" ) {
        
        if ( upword == "}" ) {

            delete_last_word()
            leading_spaces = get_previous_spaces(0)
                        
            while ( depth(local_values) > 0) {
                add_word("VALUE",leading_spaces)
                add_word("(" function_name pop(local_values) ")","")
            }
                
            local_values_count=-1
            last_upword = "}"
        }
        else if ( upword == "--" ) {
            last_upword = "{ --"
        }
        else if ( last_upword != "{ --" ) {
            if ( readable_name in reserved_local_value )
                print "\nError in " FILENAME " at line " NR ": Duplicate local definition: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        

            reserved_local_value[readable_name] = "PUSH(["
            
            local_values_count = local_values_count+1
            reserved_local_value[readable_name] = function_name readable_name
            
            push(local_values,readable_name)
            
            # snazim se to ulozit na "zasobnik" abych to na konci mohl emulovat jako VALUE v poradi LIFO
# print "value([" readable_name "]) == local_value["  local_values_count "] == " reserved_local_value[readable_name]

        }
        word = ""
        upword = ""
        leading_spaces = "" # no use leading_spaces
        return
    }
    else if ( last_upword == "VALUE" || last_upword == "DVALUE" || last_upword == "2VALUE" ) {
        if ( readable_name in collision_check )
            print "\nError in " FILENAME " at line " NR ": Duplicate definition or accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        else
            collision_check[readable_name] = word       # add new word to collision_check   

        if ( last_upword == "VALUE" )
            reserved_value[readable_name] = "PUSH(["
        else 
            reserved_value[readable_name] = "PUSHDOT(["
            
        # 30000 value name = 30000 create name ,
        #             name = name @
        # 1000000. 2value dname = 1000000. create dname , ,   ( or maybe "swap , , "?)
        #                 dname = dname 2@         
        new_word = "(" readable_name ")"
        leading_spaces = "" # no use leading_spaces
    }
    else if ( last_upword == "INLINE_CREATE" ) {
        delete_last_word()
        last_upword = ""

        if ( readable_name in collision_check )
            print "\n\n(reserved_does_functions) Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        else
            collision_check[readable_name] = word        
        
        if ( function_name in reserved_does_functions )            
            print "\n\n(reserved_does_functions) Error in " FILENAME " at line " NR ": DOES> function with this name already exists.:\"" readable_name "\"" > "/dev/stderr"   
        else
            reserved_does_functions[readable_name] = "CALL(" inline_fn_name ")"

        create_word = word
        create_readable_name = readable_name
        create_space = leading_spaces
        
        for(create_i=1;create_i<=inline_fn_count[inline_fn_name];create_i++) {
            add_word(inline_fn_words[inline_fn_name,create_i],inline_fn_spaces[inline_fn_name,create_i])
            if ( inline_fn_words[inline_fn_name,create_i] == "CREATE" )
                add_word("(" create_readable_name ")","")
        }
        word = ""
        upword = ""
        last_upword = ""
        string_end = ""
        string_type = ""
        return
    }
    else if (( last_upword == "VARIABLE" || last_upword == "FVARIABLE" || last_upword == "DVARIABLE" || last_upword == "2VARIABLE" || last_upword == "CREATE") && 
             ( inside_word_definition == 0 || !(upword in reserved_words) )) {

        if ( readable_name in collision_check )
            print "\n(" last_upword ") Error in " FILENAME " at line " NR ": Duplicate definition or accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        else
            collision_check[readable_name] = word       # add new word to collision_check   

        #  variable name = create name 2 allot
        # 2variable name = create name 4 allot
        # name ( -- addr_name )         
        reserved_value[readable_name] = "PUSH("
        new_word = "(" readable_name ")"
        leading_spaces = "" # no use leading_spaces
    }
    else if ( last_upword == "TO" && readable_name in reserved_local_value ) { 

        new_word = "(" reserved_local_value[readable_name] ")"
        leading_spaces = "" # no use leading_spaces
    }
    else if ( last_upword == "TO" ) { 
        if ( ! (readable_name in reserved_value) ) 
            print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": You are trying to change the value of a non-existent variable: \"" word "\"!" > "/dev/stderr"
        else if ( collision_check[readable_name] != word )
            print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        

        new_word = "(" readable_name ")"
        leading_spaces = "" # no use leading_spaces
    }
    else if ( last_upword == "CONSTANT" ) { 
        if ( readable_name in reserved_value ) {
            print "\n\nError in " FILENAME " at line " NR ": Constant A constant with this name already exists.: \"" word "\"!" > "/dev/stderr"
            if ( collision_check[readable_name] != word )
                print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        }
        else
            collision_check[readable_name] = word       # add new word to collision_check
            
        reserved_value[readable_name] = "PUSH("


        if ( main_count > 2 && ( main_words[main_count-2] ~ /^PUSH\(/ ) ) {
            
            # main_words[main_count-2] = PUSH(10)
            # main_words[main_count-1] = CONSTANT
            # readable_name = Ten

            main_words[main_count-1] = substr(main_words[main_count-2],6)
            main_words[main_count-2] = last_upword
            
            new_word = "(" readable_name "," main_words[main_count-1]
            leading_spaces = "" # no use leading_spaces

            main_count--
            
            # main_words[main_count-1] = CONSTANT
            # new_word = "(Ten,10)
        }
        else
        {
            new_word = "(" readable_name ")"
            leading_spaces = "" # no use leading_spaces
        }
    }
    else if ( last_upword == "FCONSTANT" && ( arg == "-zfloat" ) ) { 
        if ( readable_name in reserved_value ) {
            print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": Constant A constant with this name already exists.: \"" word "\"!" > "/dev/stderr"
            if ( collision_check[readable_name] != word )
                print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        }
        else
            collision_check[readable_name] = word       # add new word to collision_check
            
        reserved_value[readable_name] = "ZPUSH("

        if ( main_count > 2 && ( main_words[main_count-2] ~ /^ZPUSH\(/ ) ) {
            
            # main_words[main_count-2] = ZPUSH(10)
            # main_words[main_count-1] = ZCONSTANT
            # readable_name = Ten

            main_words[main_count-1] = substr(main_words[main_count-2],7)
            main_words[main_count-2] = "ZCONSTANT"
            
            new_word = "(" readable_name "," main_words[main_count-1]
            leading_spaces = "" # no use leading_spaces

            main_count--
            
#     print ";# last_upword="last_upword"\n[-2]="main_words[main_count-2] "\n[-1]="main_words[main_count-1] "\n"

            # main_words[main_count-1] = ZCONSTANT
            # new_word = "(Ten,10)
        }
        else
        {
            new_word = "(" readable_name ")"
            leading_spaces = "" # no use leading_spaces
        }
    }
    else if ( last_upword == "FCONSTANT" ) { 
        if ( readable_name in reserved_value ) {
            print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": Constant A constant with this name already exists.: \"" word "\"!" > "/dev/stderr"
            if ( collision_check[readable_name] != word )
                print "\n\n(" last_upword ") Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        }
        else
            collision_check[readable_name] = word       # add new word to collision_check
            
        reserved_value[readable_name] = "PUSH("


        if ( main_count > 2 && ( main_words[main_count-2] ~ /^FPUSH\(/ ) ) {
            
            # main_words[main_count-2] = FPUSH(10)
            # main_words[main_count-1] = FCONSTANT
            # readable_name = Ten

            main_words[main_count-1] = substr(main_words[main_count-2],7)
            main_words[main_count-2] = last_upword
            
            new_word = "(" readable_name "," main_words[main_count-1]
            leading_spaces = "" # no use leading_spaces

            main_count--
            
            # main_words[main_count-1] = FCONSTANT
            # new_word = "(Ten,10)
        }
        else
        {
            new_word = "(" readable_name ")"
            leading_spaces = "" # no use leading_spaces
        }
    }
    else if ( readable_name in reserved_local_value ) {

        if ( inside_word_definition && ( last_upword == "'" || last_upword == "[']") ) {
            change_previous_word("")
            new_word = "PUSH(" readable_name ")"
        }
        else
            new_word = "PUSH([" reserved_local_value[readable_name] "])"
    }
    else if ( readable_name in reserved_value ) {
        if ( collision_check[readable_name] != word )
            print "\n\n(reserved_value) Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"   

        if ( substr(reserved_value[readable_name], length(reserved_value[readable_name])-1) == "([" ) {
            if ( inside_word_definition && ( last_upword == "'" || last_upword == "[']") ) {
                change_previous_word("")
                new_word = substr(reserved_value[readable_name],1,length(reserved_value[readable_name])-1) readable_name ")"
            }
            else
                new_word = reserved_value[readable_name] readable_name "])"     # PUSHDOT([addr_name]) or PUSH([addr_name])
        }
        else
            new_word = reserved_value[readable_name] readable_name ")"      # PUSH(create_label)
    }
    else if ( readable_name in reserved_inline_does_functions ) {

        if ( last_upword == "[']" || last_upword == "'") {
            change_previous_word("")
            new_word = "PUSH(" readable_name ")"
        }
        else  {
            inline_fn_name = readable_name
            word = "INLINE_CREATE"
            upword = word
            new_word = word
        }
    }
    else if ( readable_name in reserved_does_functions ) {

        if ( last_upword == "[']" || last_upword == "'") {
            change_previous_word("")
            new_word = "PUSH(" readable_name ")"
        }
        else {
            new_word = "PUSH(" readable_name ") " reserved_does_functions[readable_name]
        }
    }
    else if ( readable_name in reserved_functions ) {
        if ( collision_check[readable_name] != word )
            print "\n\n(reserved_functions) Error in " FILENAME " at line " NR ": Accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        

        if ( last_upword == "[']" || last_upword == "'") {
            change_previous_word("")
            new_word = "PUSH(" readable_name ")"
        }
        else           
            new_word = reserved_functions[readable_name] readable_name ")"
    }
    else if (word == ":" ) { 
        inside_word_definition++                    # define new word
        new_word = reserved_words[word]
        leading_spaces = "\n\n"
    }
    else if ( upword == ":NONAME" ) {
        inside_word_definition++                    # define new word
        fn_leading_spaces[fn_count] = "\n\n"
        fn_words[fn_count] = "COLON"
        fn_count++;
        
        noname_count+=1
        word = "__noname" noname_count
        readable_name = Name2Readable(word)
        
        if ( readable_name in collision_check )
            print "\nError in " FILENAME " at line " NR ": Duplicate definition or accidental match in the transliteration of the word: \"" word "\" -> \"" readable_name "\"" > "/dev/stderr"        
        else
            collision_check[readable_name] = word       # add new word to collision_check

        reserved_functions[readable_name] = "PUSH("
        function_name = readable_name
        new_word = readable_name
        leading_spaces = "" # no use leading_spaces
    }
    else if ( upword == "[CHAR]" || upword == "CHAR" ) {
        string_type = "CHAR"
        string_end = " "
        word = ""
        upword = ""
        return
    }
    else if ( upword == "WORD" || upword == "PARSE" ) {

        string_end = find_previous_word()

        if ( string_end == "BL" )
            string_end = " "
        else if ( string_end ~ /^PUSH\('.'\)$/ ) 
            string_end = substr(string_end,7,1)
        
        if ( string_end == "" )
            print "\nError in " FILENAME " at line " NR ": Unknown terminating character for the word " upword "." > "/dev/stderr"        
        else if (inside_word_definition)
        {
            fn_count--
            leading_spaces = fn_leading_spaces[fn_count]
        }
        else
        {
            main_count--
            leading_spaces = main_leading_spaces[main_count]            
        }
   
   
        if ( upword == "PARSE" ) 
        {
            string_type = "STRING"
            string_read = 1
        }
        else
            string_type = upword

        word = ""
        upword = ""
            
        return
    }
    else if ( upword in reserved_words ) {          # standard forh word
        new_word = reserved_words[upword]
        if ( upword in use_reserved_words ) use_reserved_words[upword] = 1
# print upword "->" new_word "\n"

    }
    else if (word ~ /^-?[0-9]+$/) {
        if ( last_upword == "ALIGN" ) {
            new_word = "(" word ")"                 # integer
            leading_spaces = ""                     # no use leading_spaces
        }
        else
            new_word = "PUSH(" word ")"             # integer
    } 
    else if (word ~ /^-?[0-9]+\.$/) {
        new_word = substr(word,1,length(word)-1)    # delete last dot
        new_word = "PUSHDOT(" new_word ")"          # double integer
    } 
    else if ((word ~ /^[+-]?[0-9][0-9]*[.]?[0-9]*[Ee][+-]?[0-9]*$/) || upword == "INF" || upword == "-INF" || upword == "NAN" ) {
        if ( arg == "-zfloat" )
            new_word = "ZPUSH(" word ")"            # floating point "string"
        else {
            new_word = "FPUSH(" word ")"            # floating point "string"           
#             new_word = "PUSH(" floatToHex(word) ") ;# = " word      # hexadecimal number representing the value of a floating-point number in Danagy 16-bit format
#             char = "\n"
        }
    }
    else {
        print "\nError in " FILENAME " at line " NR ": Undefined word \"" word "\" found." > "/dev/stderr"        
        new_word = word
    }

    if (inside_word_definition) {
        if ( word == ";") {
            if ( reserved_functions[function_name] == "PUSH(" )
            {
                main_leading_spaces[main_count] = "\n"
                main_words[main_count] = "PUSH(" function_name ")"
                main_count++;
            }            
            inside_word_definition--
            function_name = ""
            char = "\n"
            delete reserved_local_value
        }

        if ( upword == "RECURSE" ) {
            reserved_functions[function_name] = "RCALL("
        }

        fn_leading_spaces[fn_count] = leading_spaces
        fn_words[fn_count] = new_word
        fn_count++;
    }
    else {
        main_leading_spaces[main_count] = leading_spaces
        main_words[main_count] = new_word
        main_count++;
    }
        
    last_upword = upword
    leading_spaces = char
    word = ""
    upword = ""
}



# Funkce pro zjištění relativní cesty
function find_relative_path(file) {
    # Prohledávání v aktuálním adresáři
    if (file_exists("./" file)) return "./" file

    # Prohledávání v podadresáři M4
    if (file_exists("./M4/" file)) return "./M4/" file

    # Prohledávání v nadřazeném adresáři
    if (file_exists("../M4/" file)) return "../M4/" file

    # Soubor nenalezen, vrátíme prázdný řetězec
    return "./error:relative_path_not_found!!!/" file
}

# Funkce pro ověření existence souboru
function file_exists(file) {
    return (system("[ -f \"" file "\" ]") == 0)
}


function floatToHex(value) {
    # Získání znaménka
    sign = 0
    
    if ( substr(value,1,1) == "-" ) {
        sign = 0x8000
        hexreal = sprintf( "%a", substr(value,2) )
    }
    else if ( substr(value,1,1) == "+" )
        hexreal = sprintf( "%a", substr(value,2) )
    else
        hexreal = sprintf( "%a", value )

    if ( hexreal == "0x0p+0" && sign ) {
        print "\nWarning: You are trying to convert \"negative zero\" to Danagy 16 bit floating point format, so it will be changed to a negative value closest to zero." > "/dev/stderr"                
        return "FMMIN"
    }

    if ( hexreal == "0x0p+0" ) {
        print "\nWarning: You are trying to convert \"positive zero\" to Danagy 16 bit floating point format, so it will be changed to a positive value closest to zero." > "/dev/stderr"        
        return "FPMIN"
    }

    if ( hexreal == "0xinf" && sign ) {
        print "\nWarning: You are trying to convert \"-inf\" to Danagy 16 bit floating point format. It will be converted as a smallest possible value." > "/dev/stderr"
        return "FMMAX"
    }
    
    if ( hexreal == "0xinf" ) {
        print "\nWarning: You are trying to convert \"+inf\" to Danagy 16 bit floating point format. It will be converted as a largest possible value." > "/dev/stderr"
        return "FPMAX"
    }

    if ( hexreal == "NaN" ) {
        print "\nWarning: You are trying to convert \"Not a Number\" to Danagy 16 bit floating point format. It will be converted as a positive value closest to zero." > "/dev/stderr"
        return "FPMIN"              # lol
    }

    # Výpočet exponentu
    exponent = substr(hexreal, index(hexreal, "p") + 1) + 0x40
    # Výpočet mantisy
    mantissa = substr(hexreal, index(hexreal, "x") + 1, index(hexreal, "p") - index(hexreal, "x") - 1)
    if ( mantissa ~ /^1\./ )
        mantissa = "1" substr(mantissa,3)

    mantissa = mantissa "000"
    round_nibble=substr(mantissa,4,1)
    mantissa = "0x" substr(mantissa,1,3)
    mantissa = strtonum(mantissa)

    if ( round_nibble ~ /[^0-7]/ )
        mantissa = mantissa + 1
    
    if ( mantissa == 0x200 ) {
        exponent++
        mantissa=0x00
    }
    else
        mantissa = mantissa - 0x100
        
    if ( exponent < 0 && sign ) {
        print "\nWarning: The value " value " is too close to zero, so it will be changed to a negative value closest to zero." > "/dev/stderr"        
        hexValue = "FMMIN"
    }
    else if ( exponent < 0 )
    {
        print "\nWarning: The value " value " is too close to zero, so it will be changed to a positive value closest to zero." > "/dev/stderr"        
        hexValue = "FPMIN"
    }
    else if ( exponent > 0x7F && sign )
    {
        print "\nWarning: The value " value " is less than the smallest possible value, so it will be changed to the smallest possible value." > "/dev/stderr"
        hexValue = "FMMAX"
    }   
    else if ( exponent > 0x7F)
    {
        print "\nWarning: The value " value " is greater than the largest possible value, so it will be changed to the largest possible value." > "/dev/stderr"
        hexValue = "FPMAX"
    }   
    else {
        # Sestavení hexadecimální hodnoty
        hexValue = sprintf("0x%04X", sign + exponent * 0x100 + mantissa)
    }
    return hexValue
}


function print_word(i,_raw,_token,_space,_line,readable_name) {
    
    i = stack_last_value("__level")
    _space = stack_array["__space",i]
    _token = stack_array["__tokens",i]
    _raw   = stack_array["__raw",i]
    _line  = stack_array["__line",i]
    if ( _raw != "" )
        readable_name = Name2Readable(_raw) 
    else
        readable_name = ""
if ( __debug > 2 ) {
  print "\n\ti: " i "(" stack_i_value("__level",1) "=" stack_i_value("__tokens",stack_i_value("__level",1)) ":" stack_i_value("__raw",stack_i_value("__level",1)) "), print_fn == in_fn: " print_fn " == " in_fn", token: " _token ", raw: " _raw ", readable_name: " readable_name > "/dev/stderr"
  print "\tdepth(__level): " depth("__level")
  if ( readable_name != "" ) {
    if ( readable_name in reserved_inline_functions)    print "\treserved_inline_functions[" readable_name "] = " reserved_inline_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_functions)           print "\treserved_functions[" readable_name "] = "        reserved_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_value)               print "\treserved_value[" readable_name "] = "            reserved_value[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_words)               print "\treserved_words[" readable_name "] = "            reserved_words[readable_name] > "/dev/stderr"
  }
}

    if ( _token == "__number" ) {
        if ( print_fn == in_fn )
            printf _space "PUSH(" _raw ")";
    } else if (_token == "__floating_point_number" ) {
        if ( print_fn == in_fn ) {      
            if ( arg == "-zfloat" )
                printf _space "ZPUSH(" _raw ")";    # floating point "string"
            else 
                printf _space "FPUSH(" _raw ")";    # floating point "string"           
        }
        
    } else if ( _token == "__double_number" ) {
        if ( print_fn == in_fn )
            printf _space "PUSHDOT(" _raw ")";
    } else if ( _token == "__char" ) {
        if ( print_fn == in_fn )
            printf _space "PUSH('" _raw "')";
    } else if ( _token == "VALUE"   || _token == "DVALUE" ||
              _token == "VARIABLE"  || _token == "DVARIABLE" ||
              _token == "FVARIABLE" || _token == "ZVARIABLE" ||
              _token == "CONSTANT"  || _token == "FCONSTANT" || _token == "ZCONSTANT") {

        if ( print_fn == in_fn ) {
        
            if ( depth("__level") > 1 && _raw == "" ) {
# print "\neh...."
                _raw = stack_array["__raw",stack_array["__level",1]] # raw nesmim ulozit, protoze by to priste melo spatny parametr misto aby to nacitalo novy
                stack_array["__level",1]++
                readable_name = Name2Readable(_raw)
                if ( _token == "VALUE" ) reserved_words[readable_name] = "PUSH([" readable_name "])"
                else if ( _token == "DVALUE" ) reserved_words[readable_name] = "PUSHDOT([" readable_name "])"
                else if ( _token == "VARIABLE" || _token == "CONSTANT" ) reserved_words[readable_name] = "PUSH(" readable_name ")"
                else if ( _token == "FCONSTANT" ) reserved_words[readable_name] = "FPUSH(" readable_name ")"
                else if ( _token == "ZCONSTANT" ) reserved_words[readable_name] = "ZPUSH(" readable_name ")"
                else if ( _token == "DVARIABLE" ) reserved_words[readable_name] = "PUSHDOT(" readable_name ")"
# dodelat ZVARIABLE a FVARIABLE
            }

            printf _space _token "(" readable_name ")";
        }
    } else if ( _token == "WORD" && print_fn == in_fn ) { # pokud se to neprevedlo na CSTRING tak je tam problem
        
            printf _space "CSTRING({\""
            _space = ""
            _token = stack_array["__raw",stack_array["__level",1]] # raw nesmim ulozit, protoze by to priste melo spatny parametr misto aby to nacitalo novy
            stack_array["__level",1]++
            while (1) {
                if ( split(_token,__parts,_raw) > 1 ) {
                    printf _space __parts[1]
                    break
                }
                printf _space _token
                _space = stack_array["__space",stack_array["__level",1]]
                _token = stack_array["__raw",stack_array["__level",1]] # raw nesmim ulozit, protoze by to priste melo spatny parametr misto aby to nacitalo novy
                stack_array["__level",1]++
            }
                readable_name = Name2Readable(_raw)

            printf "\"})";
    } else if ( _token == "COLON" ) {
# print "........colon"

        if ( readable_name in reserved_inline_functions ) 
            in_fn = 1 - print_fn;   # nikdy netisknu inline funkci
        else {
            in_fn_name = readable_name
            in_fn = 1;
        }
        if ( print_fn == in_fn ) {
            if ( readable_name in reserved_recurse_functions )
                printf _space "R" _token "(" readable_name ")"                
            else
                printf _space _token "(" readable_name ")"
        }
    } else if ( _token == "SEMICOLON" ) {
# print "........semicolon"
        if ( depth("__level") > 1 ) {
            pop("__level")
            return  # no need ++
        }
        if ( print_fn == in_fn ) {
            if ( in_fn_name in reserved_recurse_functions )
                printf _space "R" _token                
            else 
                printf _space _token
        }
        in_fn_name = ""
        in_fn = 0
    } else if ( _token == "TO" ) {
        if ( print_fn == in_fn )
            printf _space _token "(" readable_name ")";
    } else if ( _token == "ABORT_DQ" ) {
        if ( print_fn == in_fn )
            print _space "IF PRINT({\"" _raw "\"}) BYE THEN ;# Originally ABORT\""
    } else if ( _token in double_quoted_strings ) {
        if ( print_fn == in_fn )
            printf _space _token "({\"" _raw "\"})";
    } else if ( _token == "__comment" ) {
        if ( print_fn == in_fn )
            printf _space ";# " _raw;
    } else if ( _token != "__unknown" ) {
        if ( print_fn == in_fn )
            printf _space _token;
    } else if ( readable_name != "" && ( readable_name in reserved_inline_functions) ) {
# print "\n ;# reserved_inline_functions:\n"
        if ( print_fn == in_fn ) {
            printf _space
            stack_array["__level",depth("__level")]++    
            push("__level",reserved_inline_functions[readable_name])        
        }
    } else if ( readable_name != "" && (readable_name in reserved_words) ) {
# print "\n ;# word:\n"
        if ( print_fn == in_fn )
            printf _space reserved_words[readable_name];
    } else if ( readable_name != "" && (readable_name in reserved_functions) ) {
# print "\n ;# reserved_functions\n"
        if ( print_fn == in_fn )
            printf _space reserved_words[readable_name]
    } else if ( readable_name != "" && (readable_name in reserved_value) ) {
# print "\n ;# reserved_value\n"
        if ( print_fn == in_fn )
            printf _space reserved_words[readable_name]
    } else {
# print "\n ;# else\n"
        if ( print_fn == in_fn ) {
            print "\nError in " FILENAME " at line " _line ": Token number " stack_last_value("__level") " is unknown word \"" _raw "\"" > "/dev/stderr"
            printf _space _raw
        }
    }

if (__debug >3) {
  print "\n\tout: " i ", token: " _token ", raw: " _raw ", readable_name: " readable_name > "/dev/stderr"
  print "\tdepth(__level): " depth("__level") > "/dev/stderr"
  if ( readable_name != "" ) {
    if ( readable_name in reserved_inline_functions)    print "\treserved_inline_functions[" readable_name "] = " reserved_inline_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_functions)           print "\treserved_functions[" readable_name "] = "        reserved_functions[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_value)               print "\treserved_value[" readable_name "] = "            reserved_value[readable_name] > "/dev/stderr"
    if ( readable_name in reserved_words)               print "\treserved_words[" readable_name "] = "            reserved_words[readable_name] > "/dev/stderr"
  }
}

    stack_array["__level",depth("__level")]++    
    
}

END {
    if ( raw != "" ) new_token()

    printf "include(`" find_relative_path("FIRST.M4") "\47)dnl\n"
    printf "  ifdef __ORG\n"
    printf "    org __ORG\n"
    printf "  else\n"
    printf "    org 32768\n"
    printf "  endif\n"
    printf "  INIT(60000)\n"


    # zpracovani tokenu
    for (end_i = 1; end_i <= depth("__tokens"); end_i++)
    {
print "i:" end_i " " stack_array["__tokens",end_i] "(" stack_array["__raw",end_i] ")" > "/dev/stderr"
#          process_word(__tokens[end_i],__raw[end_i],__space[end_i])
    }

    # vypsani main slov
    for (i=1; i<=depth("__tokens"); i++) {
        printf main_leading_spaces[i] main_words[i] > "/dev/stderr"
    }

    print "\n;# ----- main code -----"
    print_fn = 0
    in_fn = 0
    
    # vypsani main slov
    while( stack_last_value("__level") <= depth("__tokens") )
    {

# print stack_last_value("__level") " < " depth("__tokens")
        if ( stack_last_value("__level") == "" ) {
            print "error?"
            break
        }
        print_word()

    }
if (__debug > 0) print "\n; last token: " stack_last_value("__level")
    printf "\n  STOP"
    print "\n;# ----- list of functions -----"
    print_fn = 1
    in_fn = 0
    in_fn_name = ""
    stack_array["__level",1] = 1

    # vypsani main slov
    while( stack_last_value("__level") <= depth("__tokens") )
    {

# print stack_last_value("__level") " < " depth("__tokens")
        if ( stack_last_value("__level") == "" ) {
            print "error?"
            break
        }
        print_word()

    }
if (__debug > 0) print "\n; last token: " stack_last_value("__level")


    
exit
    recurse=0
    function_name = ""

    # vypsani funkci na konci s tim ze se resi zmena nekterych slov pokud je funkce rekurzivni     
    for (i=1; i<fn_count; i++) {
    
        leading_spaces = fn_leading_spaces[i]
        word = fn_words[i]

        if ( word == "COLON" ) {
            function_name = fn_words[i+1]
            recurse = 0
            if ( reserved_functions[function_name] == "RCALL(" ) recurse = 1
        }

        if ( recurse ) {
        
            if ( word == "DO" || word == "QUESTIONDO" ){
                # kontrola zda je uvnitr volano RECURSE, protoze pokud ne, tak staci obycejne smycky...
                k = 1
                no_recurse_inside = 1
                for (j=i+1; no_recurse_inside && k && j<fn_count; j++)
                {
                    new_word = fn_words[j]

                    if ( new_word == "LOOP" || new_word == "ADDLOOP" ) k--
                    if ( new_word == "DO" || new_word == "QUESTIONDO" ) k++        
                    if ( new_word == "RECURSE" ) no_recurse_inside=0                        
                }
                if ( no_recurse_inside == 0)
                    word = recurse_reserved_words[word]               
            }
            else if ( word == "FOR" ) {
                # kontrola zda je uvnitr volano RECURSE, protoze pokud ne, tak staci obycejne smycky...
                k = 1
                no_recurse_inside = 1
                for (j=i+1; no_recurse_inside && k && j<fn_count; j++)
                {
                    new_word = fn_words[j]

                    if ( new_word == "NEXT" ) k--
                    if ( new_word == "FOR" ) k++        
                    if ( new_word == "RECURSE" ) no_recurse_inside=0                        
                }
                if ( no_recurse_inside == 0)
                    word = recurse_reserved_words[word]               
            }
            else if ( word in recurse_reserved_words )
                word = recurse_reserved_words[word]
                
            if ( word == "RECURSE" ) {
                word = "RCALL(" function_name ")"
            }
        }
        
        if ( word == "COLON" || word == "RCOLON" )
            word = word "("

        printf leading_spaces word

        if ( word == "SEMICOLON" || word == "RSEMICOLON" ) {
            function_name = ""
            recurse = 0
        }

    }

    if ( use_reserved_words["SPACES"] ) {
        printf "\n\nCOLON(__SPACES,( n -- ))\n"
#         printf "    PUSH(0) MAX PUSH(0) QUESTIONDO SPACE LOOP\n"
#         printf "    DUP _0GT IF PUSH(0) DO SPACE LOOP ELSE DROP THEN\n"
#         printf "    DUP _0GT IF _1SUB FOR SPACE NEXT ELSE DROP THEN\n"
        printf "    BEGIN DUP _0GT WHILE _1SUB SPACE AGAIN DROP\n"
        printf "SEMICOLON"
    }
    
    if ( "FASIN" in use_reserved_words && use_reserved_words["FASIN"] ) {
        printf "\n\nCOLON(__FASIN,( rad -- ))\n"
        printf ";# pi/2 =  1.5707963 = 0x4092\n"
        printf ";# a0   =  1.5707288 = 0x4092\n"
        printf ";# a1   = -0.2121144 = 0xBDB2\n"
        printf ";# a2   =  0.0742610 = 0x3C30\n"
        printf ";# a3   = -0.0187293 = 0xBA33\n"
        printf ";# asin(x) = pi/2 - sqrt(1-x)*(a0 + a1*x + a2*x*x + a3*x*x*x)\n"
        printf ";# asin(x) = pi/2 - sqrt(1-x)*(a0 + x*(a1 + x*(a2 + a3*x)))\n"
        printf ";# asin(x) = pi/2 - sqrt(1-x)*(((a3*x + a2)*x + a1)*x + a0)\n"
        printf "\n"
        printf "    DUP PUSH(0x8000) AND SWAP\n"
        printf "    FABS\n"
        printf "    DUP PUSH(0x4000) SWAP FSUB FSQRT\n" 
        printf "    SWAP DUP DUP PUSH(0xBA33) FMUL\n"
        printf "    PUSH(0x3C30) FADD FMUL\n"
        printf "    PUSH(0xBDB2) FADD FMUL\n" 
        printf "    PUSH(0x4092) FADD FMUL\n"
        printf "    PUSH(0x4092) SWAP FSUB\n"
        printf "    XOR\n"
        printf "SEMICOLON"
    }

    if ( "FACOS" in use_reserved_words && use_reserved_words["FACOS"] ) {
        printf "\n\nCOLON(__FACOS,( rad -- ))\n"
        printf "  ;# x\n"
        printf "  DUP FABS DUP\n"   
        printf "  ;# x u u\n"
        printf "  PUSH(0x4000) SWAP FSUB FSQRT SWAP\n"
        printf "  ;# x sqrt(1.0-u) u\n"
        printf "  DUP DUP\n"
        printf "  PUSH(0xBA33) FMUL\n"
        printf "  PUSH(0x3C30) FADD FMUL\n"
        printf "  PUSH(0xBDB2) FADD FMUL\n"
        printf "  PUSH(0x4092) FADD\n"
        printf "  FMUL SWAP\n"
        printf "  _0LT IF PUSH(0x4192) SWAP FSUB THEN\n"
        printf "SEMICOLON"
    }

    if ( "FTRUNC" in use_reserved_words && use_reserved_words["FTRUNC"] ) {
        printf "\n\nCOLON(__ZTRUNC,( z -- round_towards_zero(z)))\n"
        printf "ZDUP      ;# ( z -- z z )\n"
        printf "Z0LT      ;# ( z z -- flag(z<0) )\n"
        printf "IF        ;# ( z flag -- z )\n"
        printf "  ZNEGATE ;# ( z -- abs(z) )\n"
        printf "  ZFLOOR  ;# ( z -- floor(fabs(z)) )\n"
        printf "  ZNEGATE ;# ftrunc(z)\n"
        printf "ELSE\n"
        printf "  ZFLOOR  ;# ftrunc(z)\n"
        printf "THEN\n"
        printf "SEMICOLON"
    }
    
#     if ( "FLOOR" in use_reserved_words && use_reserved_words["FLOOR"] ) {
#         printf "\n\nCOLON(__FLOOR,( f -- round_towards_negative_infinity(f)))\n"    
#         printf "  DUP _0LT IF\n"
#         printf "    FNEGATE DUP FTRUNC_ABS TUCK NE IF PUSH(0x4000) ;# = 1e\n"
#         printf "FADD THEN FNEGATE\n"
#         printf "  ELSE\n"
#         printf "    FTRUNC_ABS\n"
#         printf "  THEN\n"
#         printf "SEMICOLON"
#     
# #         printf "COLON(floor,({{{{ f -- n }}}}))
# #         printf "  DUP _0LT IF\n"
# #         printf "    FNEGATE PUSH(0x3FFF) ;# = 0.999E\n"
# #         printf "FADD FTRUNC_ABS FNEGATE\n"
# #         printf "  ELSE\n"
# #         printf "    FTRUNC_ABS\n"
# #         printf "  THEN\n"
# #         printf "SEMICOLON"
#     }
    
    if ( "FMOD" in use_reserved_words && use_reserved_words["FMOD"] ) {
        printf "\n\nCOLON(__ZMOD,( za zb  -- zmod(a%b)))\n"
        printf "ZSWAP     ;# ( a b -- b a )\n"
        printf "ZOVER     ;# ( b a -- b a b )\n"
        printf "ZDIV      ;# ( b a b -- b (a/b) )\n"
        printf "ZDUP      ;# ( b (a/b) -- b (a/b) (a/b) )\n"
        printf "ZDUP      ;# ( b (a/b) (a/b) -- b (a/b) (a/b) (a/b) )\n"
        printf "Z0LT      ;# ( b (a/b) (a/b) (a/b) -- b (a/b) (a/b) flag )\n"
        printf "IF        ;# ( b (a/b) (a/b) flag -- b (a/b) (a/b) )\n"
        printf "  ZNEGATE ;#    ( b (a/b) (a/b) -- b (a/b) fabs(a/b) )\n"
        printf "  ZFLOOR  ;#    ( b (a/b) (-a/b) -- b (a/b) floor(fabs(a/b)) )\n"
        printf "  ZNEGATE ;#    ( b (a/b) ftrunc(-a/b) -- b (a/b) ftrunc(a/b)) )\n"
        printf "ELSE      ;# ( b (a/b) (a/b) flag -- b (a/b) (a/b) )\n"
        printf "  ZFLOOR  ;# ( b (a/b) (a/b) -- b (a/b) ftrunc(a/b) )\n"
        printf "THEN      ;# ( b (a/b) (a/b) -- b (a/b) ftrunc(a/b) )\n"
        printf "ZSUB      ;# ( b ftrunc(a/b) -- b (a/b)-ftrunc(a/b) )\n"
        printf "ZMUL      ;# ( b (a/b)-ftrunc(a/b) -- fmod(a/b) )\n"
        printf "SEMICOLON"
    }
        

    printf "\n"
}
