dnl ## Arithmetic
dnl
dnl
dnl
include(M4PATH{}divmul/pdiv_mk1.m4){}dnl
include(M4PATH{}divmul/pmul_mk1.m4){}dnl
include(M4PATH{}divmul/pmul_mk2.m4){}dnl
include(M4PATH{}divmul/pmul_mk3.m4){}dnl
include(M4PATH{}divmul/pmul_mk4.m4){}dnl
dnl
dnl # ------------------------
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 + x1
define({ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_ADD},{+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, DE         ; 1:11      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = x1 + x2
define({OVER_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_ADD},{over +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, DE         ; 1:11      __INFO  ( x2 x1 -- x2 x3 )   x3 = x1 + x2}){}dnl
dnl
dnl
dnl # ( x3 x2 x1 -- x3 x4 )  x4 = x3 + x2
define({DROP_OVER_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_OVER_ADD},{drop over +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DROP_OVER_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO  ( x3 x2 x1 -- x3 x4 )  x4 = x3 + x2
    pop  DE             ; 1:10      __INFO
    add  HL, DE         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl
dnl # @ swap @ +
dnl # ( a2 a1 -- [a2]+[a1] )
define({FETCH_SWAP_FETCH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_FETCH_SWAP_FETCH_ADD_DOWN},{@ swap @ +},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},__dtto){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_FETCH_SWAP_FETCH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( a2 a1 -- [a2]+[a1] )
    add   A,[HL]        ; 1:7       __INFO
    ld    C, A          ; 1:4       __INFO
    inc  HL             ; 1:6       __INFO
    inc  DE             ; 1:6       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    adc   A,[HL]        ; 1:7       __INFO
    ld    H, A          ; 1:4       __INFO
    ld    L, C          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # @ swap @ +
dnl # ( a2 a1 -- [a2]+[a1] )
define({FETCH_SWAP_FETCH_ADD_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_FETCH_SWAP_FETCH_ADD_DOWN},{@ swap @ + down},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_FETCH_SWAP_FETCH_ADD_DOWN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( a2 a1 -- ? x )  x: [a2]+[a1]
    add   A,[HL]        ; 1:7       __INFO
    ld    C, A          ; 1:4       __INFO
    inc  HL             ; 1:6       __INFO
    inc  DE             ; 1:6       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    adc   A,[HL]        ; 1:7       __INFO
    ld    H, A          ; 1:4       __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # @ swap @ +
dnl # ( a2 a1 -- [a2]-[a1] )
define({FETCH_SWAP_FETCH_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_FETCH_SWAP_FETCH_SUB},{@ swap @ -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_FETCH_SWAP_FETCH_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( a2 a1 -- [a2]-[a1] )
    sub [HL]            ; 1:7       __INFO
    ld    C, A          ; 1:4       __INFO
    inc  HL             ; 1:6       __INFO
    inc  DE             ; 1:6       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld    H, A          ; 1:4       __INFO
    ld    L, C          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x -- x+n )
dnl # x = x + n
define({PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_ADD},{$1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}define({$0_CODE},__ADD_R16_CONST(HL,$1){}__CODE){}dnl
__{}__{}ifelse(eval(__PRICE>(15+4*__BYTE_PRICE)):__HEX_L($1),1:0x00,{
__{}__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO},
__{}__{}{$0_CODE}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- x+2*$1 )
dnl # x = x + 2*$1
define({PUSH_2MUL_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_2MUL_ADD},{$1 2* +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_2MUL_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),1,{dnl
__{}__{}define({$0_BC},__LD_R16(BC,$1)){}dnl
__{}__{}$0_BC
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO},

__{}{dnl
__{}__{}define({$0_CODE},__ADD_R16_CONST(HL,2*($1)){}__CODE){}dnl
__{}__{}ifelse(eval(__PRICE>(15+4*__BYTE_PRICE)):__HEX_L($1),1:0x00,{
__{}__{}__{}    ld    A, __HEX_H(2*($1))       ; 2:7       __INFO
__{}__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO},
__{}__{}{$0_CODE}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x1 -- x1 x2 )
dnl # x2 = x1 + 2*$1
define({DUP_PUSH_2MUL_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHS},{dup $1 2* +},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_2MUL},{__dtto},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_OVER_ADD},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_2MUL_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),1,{dnl
__{}__{}define({$0_HL},__LD_R16(HL,$1))
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}$0_HL
__{}__{}    add  HL, HL         ; 1:11      __INFO   2x
__{}__{}    add  HL, DE         ; 1:11      __INFO},

__{}{dnl
__{}__{}define({$0_CODE},__ADD_R16_CONST(HL,2*($1)){}__CODE){}dnl
__{}__{}ifelse(eval(__PRICE>(15+4*__BYTE_PRICE)):__HEX_L($1),1:0x00,{
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}__{}    ld    A, __HEX_H(2*($1))       ; 2:7       __INFO
__{}__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO},
__{}__{}{$0_CODE}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x2 x1 x0 -- x1 x2+n )
define({DROP_SWAP_PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DROP_SWAP_PUSH_ADD},{drop swap $1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DROP_SWAP_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}define({$0_CODE},__ADD_R16_CONST(HL,$1){}__CODE){}dnl
__{}__{}__{}    pop  HL             ; 1:10      __INFO   ( x2 x1 x0 -- x1 x2+$1 ){}dnl
__{}__{}ifelse(eval(__PRICE>(15+4*__BYTE_PRICE)):__HEX_L($1),1:0x00,{
__{}__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO},
__{}__{}{$0_CODE}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x2 x1 x0 -- x2+n x2+n )
define({_2DROP_PUSH_ADD_DUP},{dnl
__{}__ADD_TOKEN({__TOKEN_2DROP_PUSH_ADD_DUP},{2drop $1 + dup},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DROP_PUSH_ADD_DUP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}define({$0_CODE},__ADD_R16_CONST(HL,$1){}__CODE){}dnl
__{}__{}__{}    pop  HL             ; 1:10      __INFO   ( x2 x1 x0 -- x x )  x = x2+$1{}dnl
__{}__{}ifelse(eval(__PRICE>(15+4*__BYTE_PRICE)):__HEX_L($1),1:0x00,{
__{}__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO},
__{}__{}{$0_CODE})
__{}__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}__{}    ld    D, H          ; 1:4       __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- x+n )
dnl # x = x + n
define({DUP_DUP_PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_DUP_PUSH_ADD},{$1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_DUP_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}define({$0_BC},__LD_R16(BC,$1)){}dnl
__{}__{}define({$0_P3},eval(37+__PRICE+4*__BYTE_PRICE)){}dnl
__{}__{}define({$0_CODE},__ADD_R16_CONST(HL,$1){}__CODE){}dnl
__{}__{}define({$0_P1},eval(30+__PRICE+4*__BYTE_PRICE)){}dnl
__{}__{}define({$0_P2},eval(45+8*__BYTE_PRICE)){}dnl
__{}__{}ifelse(
__{}__{}eval($0_P1<$0_P3),1,{
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    push HL             ; 1:11      __INFO
__{}__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}__{}    ld    D, H          ; 1:4       __INFO{}dnl
__{}__{}__{}$0_CODE},
__{}__{}eval($0_P2<$0_P3):__HEX_L($1),1:0x00,{
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    push HL             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}__{}    add   A, D          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}__{}    ld    L, E          ; 1:4       __INFO},
__{}__{}{
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    push HL             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}__{}$0_BC
__{}__{}__{}    add  HL, BC         ; 1:11      __INFO}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x3 x3+$1 ) x3 = x2+x1
define({ADD_DUP_PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_ADD_DUP_PUSH_ADD},{+ dup $1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ADD_DUP_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}define({$0_HL},__LD_R16(HL,$1)){}dnl
__{}__{}__{}    add  HL, DE         ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}__{}$0_HL
__{}__{}__{}    add  HL, DE         ; 1:11      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x0 -- x1 )
dnl # x1 = x0 + [addr]
define({PUSH_FETCH_ADD},{dnl
__{}ifelse(
__{}$1,{},{
__{}__{}  .error {$0}($@): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),1,{
__{}__{}  .error {$0}($@): Address is pointer!},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_PUSH_ADD},{$1 +},{[$1]}){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_FETCH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}$1,{},{
__{}__{}  .error {$0}($@): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),1,{
__{}__{}  .error {$0}($@): Address is pointer!},
__{}{dnl
__{}__{}__ASM_TOKEN_PUSH_ADD({[$1]}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( b a -- b a b+n )
define({OVER_PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_PUSH_ADD},{over $1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER{}dnl
__{}__ASM_TOKEN_PUSH_ADD($1){}dnl
}){}dnl
dnl
dnl
dnl
define({PUSH2_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_ADD},{$1 $2 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_ADD},{dnl
__{}define({__INFO},{$1 $2 +}){}dnl
ifelse(dnl
dnl # ( -- x )
dnl # x = $1 + $2
dnl # CONSTANT(_a,5) CONSTANT(_b,7) PUSH2_ADD({_a},{_b}) -->  ld   HL, 0x000C     ; 3:10      _a _b +
dnl # CONSTANT(_a,5) CONSTANT(_b,7) PUSH2_ADD(_a,_b)     -->  ld   HL, 0x000C     ; 3:10      5 7 +
eval((__HAS_PTR($1)+__HAS_PTR($2))>0),{1},{dnl
__{}ifelse(eval(__HAS_PTR($1)+__HAS_PTR($2)),{2},{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1+$2
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 3:16      __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO},
__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1+$2
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:16      __INFO
__{}__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2)); 3:10      __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO},
__{}{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1+$2
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 3:16      __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO})},
{dnl
__{}__{}ifelse(__IS_NUM($1+$2),{0},{
__{}__{}    ; warning The condition >>>$1+$2<<< cannot be evaluated
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1+$2
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1+$2)); 3:10      __INFO},
__{}{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1+$2
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$2)     ; 3:10      __INFO})})}){}dnl
dnl
dnl
dnl
dnl # dup 5 +
dnl # ( x -- x x+n )
define({DUP_PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_ADD},{dup $1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(__HAS_PTR($1),{1},{
__{}    push DE             ; 1:11      __INFO   ( x -- x x+$1 )
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:16      __INFO
__{}    add  HL, DE         ; 1:11      __INFO},
__IS_NUM($1),{0},{
__{}    ; warning The condition >>>$1<<< cannot be evaluated
__{}    push DE             ; 1:11      __INFO   ( x -- x x+$1 )
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    add  HL, DE         ; 1:11      __INFO},
{
__{}    push DE             ; 1:11      __INFO   ( x -- x x+{}__HEX_HL($1) ){}ifelse(dnl
__{}eval((($1)+3*256) & 0xffff),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO},
__{}eval((($1)+2*256) & 0xffff),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO},
__{}eval((($1)+1*256) & 0xffff),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO},
__{}eval((($1)+    2) & 0xffff),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},
__{}eval((($1)+    1) & 0xffff),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},
__{}eval(($1) & 0xFFFF),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO},
__{}eval(($1)-1),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},
__{}eval(($1)-2),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},
__{}eval(($1)-1*256),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO},
__{}eval(($1)-2*256),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO},
__{}eval(($1)-3*256),{0},{
__{}__{}    ld    D, H          ; 1:4       __INFO
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO},
__{}eval((($1)) & 0xFF):_TYP_SINGLE,{0:fast},{
__{}__{}    ld    D, H          ; 1:4       __INFO   fast version can be changed with "{define({_TYP_SINGLE},{default})}"
__{}__{}    ld    E, L          ; 1:4       __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO},
__{}eval((($1)) & 0xFF),{0},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO   default version can be changed with "{define({_TYP_SINGLE},{fast})}"
__{}__{}    ld   HL, __HEX_HL($1)     ; 3:10      __INFO
__{}__{}    add  HL, DE         ; 1:11      __INFO},
__{}{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1)     ; 3:10      __INFO
__{}__{}    add  HL, DE         ; 1:11      __INFO}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # "dup +"
dnl # ( x1 -- x2 )
dnl # x2 = x1 + x1
define({DUP_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_ADD},{dup +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl
dnl # "dup + $1 +"
dnl # ( x1 -- x2 )
dnl # x2 = 2*x1 + $1
define({DUP_ADD_PUSH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_ADD_PUSH_ADD},{dup + $1 +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_ADD_PUSH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),{1},{
__{}__{}  .error {$0}(): Missing parameter!},

__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),1,{
__{}define({$0_BC},__LD_R16({BC},__SIMPLIFY_EXPRESSION($1))){}dnl
__{}__{}    add  HL, HL         ; 1:11      __INFO{}dnl
__{}__{}$0_BC
__{}__{}    add  HL, BC         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0000,{
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0001,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0002,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0003,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0004,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0005,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0006,{
__{}__{}dnl #;                  ;[4:29]
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x00FC,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x00FD,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x00FE,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x00FF,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0100,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0101,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0102,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0103,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0104,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x01FC,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x01FD,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x01FE,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x01FF,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0200,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0201,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0202,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0203,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0204,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x02FC,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x02FD,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x02FE,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x02FF,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0300,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0301,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0302,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0303,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0304,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x03FC,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x03FD,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x03FE,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x03FF,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0400,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0401,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0402,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0403,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0404,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x04FF,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0500,{
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0x0501,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x05FF,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0x0600,{
__{}__{}dnl #;                  ;[4:23]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0x0601,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    inc  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xF9FF,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFA00,{
__{}__{}dnl #;                  ;[4:23]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFA01,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFAFF,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFB00,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFB01,{
__{}__{}dnl #;                  ;[5:29]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFBFC,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFBFD,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFBFE,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFBFF,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFC00,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFC01,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFC02,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFC03,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFC04,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFCFC,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFCFD,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFCFE,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFCFF,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFD00,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFD01,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFD02,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFD03,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFD04,{
__{}__{}dnl #;                  ;[5:31]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFDFC,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFDFD,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFDFE,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFDFF,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFE00,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFE01,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFE02,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFE03,{
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFE04,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFEFC,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFEFD,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFEFE,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFEFF,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFF00,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFF01,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFF02,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFF03,{
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFF04,{
__{}__{}dnl #;                  ;[4:27]
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  H              ; 1:4       __INFO},

__{}__HEX_HL($1),0xFFFA,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFFFB,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFFFC,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFFFD,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_HL($1),0xFFFE,{
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    dec  HL             ; 1:6       __INFO},

__{}__HEX_L($1),0x00,{
__{}__{}dnl #;                  ;[5:26]
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO},

__{}{
__{}define({$0_BC},__LD_R16({BC},__SIMPLIFY_EXPRESSION($1))){}dnl
__{}__{}dnl #;                  ;[5:32]
__{}__{}    add  HL, HL         ; 1:11      __INFO{}dnl
__{}__{}$0_BC
__{}__{}    add  HL, BC         ; 1:11      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # "dup + $1 -"
dnl # ( x1 -- x2 )
dnl # x2 = 2*x1 - $1
define({DUP_ADD_PUSH_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_ADD_PUSH_SUB},{dup + $1 -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_ADD_PUSH_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),{1},{
__{}__{}  .error {$0}(): Missing parameter!},

__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),1,{
__{}define({$0_BC},__LD_R16({BC},__SIMPLIFY_EXPRESSION($1))){}dnl
__{}__{}    add  HL, HL         ; 1:11      __INFO{}dnl
__{}__{}$0_BC
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO},

__{}__IS_NUM($1),1,{dnl
__{}__{}__ASM_TOKEN_DUP_ADD_PUSH_ADD(__HEX_HL(0-($1)))},

__{}{
__{}define({$0_BC},__LD_R16({BC},__SIMPLIFY_EXPRESSION(0-($1)))){}dnl
__{}__{}dnl #;                  ;[5:32]
__{}__{}    add  HL, HL         ; 1:11      __INFO{}dnl
__{}__{}$0_BC
__{}__{}    add  HL, BC         ; 1:11      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # "dup + +1"
dnl # ( x1 -- x2 )
dnl # x2 = x1 + x1 +1
define({DUP_ADD_1ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_ADD_1ADD},{dup + +1},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_ADD_1ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __COMPILE_INFO
    inc  HL             ; 1:6       __COMPILE_INFO}){}dnl
dnl
dnl
dnl
dnl # "dup + -1"
dnl # ( x1 -- x2 )
dnl # x2 = x1 + x1 - 1
define({DUP_ADD_1SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_ADD_1SUB},{dup + -1},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_ADD_1SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __COMPILE_INFO
    dec  HL             ; 1:6       __COMPILE_INFO}){}dnl
dnl
dnl
dnl # over +
dnl # ( x2 x1 -- x2 x1+x2 )
define({OVER_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_ADD},{over +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, DE         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # bc@ +
dnl # ( x0 -- x )  x == x0+bc
define({BC_FETCH_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_BC_FETCH_ADD},{bc@ +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BC_FETCH_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, BC         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 2 pick +
dnl # ( x2 x1 x0 -- x2 x1 x )  x == x0+x2
define({_2_PICK_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_ADD},{2 pick +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x2 x1 x0 -- x2 x1 x )  x == x0+x2
    push BC             ; 1:11      __INFO
    add  HL, BC         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 3 pick +
dnl # ( x3 x2 x1 x0 -- x3 x2 x1 x )  x == x0+x3
define({_3_PICK_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_ADD},{3 pick +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x )  x == x0+x3
    pop  BC             ; 1:10      __INFO
    push BC             ; 1:11      __INFO
    push AF             ; 1:11      __INFO
    add  HL, BC         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # $1 pick +
dnl # ( xn .. x1 x0 -- xn .. x1 x )  x == x0+xn
define({PUSH_PICK_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_ADD},{$1 pick +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(dnl
__{}eval($#<1),1,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HEX_HL(0x8000 & ($1)),{0x8000},{
__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0+x$1
__{}__{}    push HL             ; 1:11      __INFO   pointer version
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    E,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    D,[HL]        ; 1:7       __INFO
__{}__{}    pop  HL             ; 1:10      __INFO
__{}__{}    add  HL, DE         ; 1:11      __INFO
__{}__{}    pop  DE             ; 1:10      __INFO},

__IS_NUM($1),{0},{
__{}__{} if (($1) & 0x8000)
__{}__{}    .error {$0}($@): Parameter is negative!
__{}__{} else
__{}__{}  if (($1) = 0){}dnl
__{}__{}__ASM_TOKEN_DUP_ADD
__{}__{}  else
__{}__{}   if (($1) = 1){}dnl
__{}__{}__ASM_TOKEN_OVER_ADD
__{}__{}   else
__{}__{}    if (($1) = 2){}dnl
__{}__{}__ASM_TOKEN_2_PICK_ADD
__{}__{}    else
__{}__{}     if (($1) = 3){}dnl
__{}__{}__ASM_TOKEN_3_PICK_ADD
__{}__{}     else
__{}__{}    ld    C, L          ; 1:4       __INFO   ( $1 .. x1 x0 -- $1 .. x1 x )  x == x0+$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-4+2*($1))); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}     endif
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{__ASM_TOKEN_DUP_ADD},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_ADD},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_ADD},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_ADD},
__{}{
__{}__{}    ld    C, L          ; 1:4       __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0+x$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$1-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # "dup dup +"
dnl # ( x1 -- x1 x2 )
dnl # x2 = x1 + x1
define({DUP_DUP_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_DUP_ADD},{dup dup +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_DUP_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( a -- a a+a )
    ld   D, H           ; 1:4       __INFO
    ld   E, L           ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl
dnl # "2dup +"
dnl # ( x1 x2 -- x1 x2 x3 )
dnl # x3 = x1 + x2
define({_2DUP_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_ADD},{2dup +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( b a -- b a a+b )
    ex   DE, HL         ; 1:4       __INFO
    add  HL, DE         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 - x1
define({SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_SUB},{-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO   ( x1 x0 -- x )  x == x1 - x0
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x1 x0 -- x1 x )   x = x1 - x0
define({OVER_SWAP_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_SWAP_SUB},{over swap -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_SWAP_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO  ( x1 x0 -- x1 x )   x = x1 - x0
    sub   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # swap -
dnl # ( x1 x0 -- x )  x == x0 - x1
dnl # x = x1 - x2
define({SWAP_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_SUB_DOWN},{swap -},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},__dtto){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    or    A             ; 1:4       __INFO   ( x1 x0 -- x )  x == x0 - x1
    sbc  HL, DE         ; 2:15      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # swap - down
dnl # ( x1 x0 -- x1 x )  x == x0 - x1
define({SWAP_SUB_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_SUB},{swap - down},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_SUB_DOWN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    or    A             ; 1:4       __INFO   ( x1 x0 -- x1 x )  x == x0 - x1
    sbc  HL, DE         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # $1 swap -
dnl # ( x1 -- x2 ) x2: $1-x1
define({PUSH_SWAP_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_SWAP_SUB},{$1 swap -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_SWAP_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<1),{1},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),1,{
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   ( x1 -- x2 ) x2: $1-x1
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO{}dnl
__{}},
__{}__HEX_H($1),0x00,{
__{}__{}    ld    A, __FORM({%-11s},__HEX_L($1)); 2:7       __INFO   ( x1 -- x2 ) x2: $1-x1
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO{}dnl
__{}},
__{}{
__{}__{}    ld    A, __FORM({%-11s},ifelse(__IS_NUM($1),1,__HEX_L($1),__SIMPLIFY_EXPRESSION($1))); 2:7       __INFO   ( x1 -- x2 ) x2: $1-x1
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, __FORM({%-11s},ifelse(__IS_NUM($1),1,__HEX_H($1),__SIMPLIFY_EXPRESSION(high $1))); 2:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # dup $1 swap - $2 !
dnl # ( x1 -- x1 ) [x2]: $1-x1
dnl # zakladni varianta je pomalejsi nez push_swap_sub + push_store protoze prvne pouzije hl pro $1+tos (2x "ld l/h,a") a pak to rychle ulozi pres "ld [$2],hl"
define({DUP_PUSH_SWAP_SUB_PUSH_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_SWAP_SUB_PUSH_STORE},{dup $1 swap - $2 !},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_SWAP_SUB_PUSH_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),{1},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__SIMPLIFY_EXPRESSION($1),__SIMPLIFY_EXPRESSION([$2]),{dnl
__{}__{}define({$0_BC},__LD_R16(BC,$2)){}dnl
__{}__{}$0_BC   ( x1 -- x1 ) [x2]: $1-x1
__{}__{}    ld    A, [BC]       ; 1:7       __INFO
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld  [BC],A          ; 1:7       __INFO
__{}__{}    inc  BC             ; 1:6       __INFO
__{}__{}    ld    A, [BC]       ; 1:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld  [BC],A          ; 1:7       __INFO{}dnl
__{}},
__{}__HAS_PTR($2),1,{dnl
__{}__{}define({$0_BC},__LD_R16(BC,$2)){}dnl
__{}__{}$0_BC   ( x1 -- x1 ) [x2]: $1-x1
__{}__{}    ld    A, __FORM({%-11s},ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,0)},__IS_NUM($1),1,__HEX_L($1),__SIMPLIFY_EXPRESSION($1))); ifelse(__HAS_PTR($1),0,{2:7 },{3:13})      __INFO
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld  [BC],A          ; 1:7       __INFO
__{}__{}    inc  BC             ; 1:6       __INFO
__{}__{}    ld    A, __FORM({%-11s},ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,1)},__IS_NUM($1),1,__HEX_H($1),__SIMPLIFY_EXPRESSION(high $1))); ifelse(__HAS_PTR($1),0,{2:7 },{3:13})      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld  [BC],A          ; 1:7       __INFO{}dnl
__{}},
__{}__HEX_H($1),0x00,{
__{}__{}    ld    A, format({%-11s},ifelse(__IS_NUM($1),1,__HEX_L($1),__SIMPLIFY_EXPRESSION($1))); 2:7       __INFO   ( x1 -- x1 ) [x2]: $1-x1
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld  __FORM({%-16s},[__SIMPLIFY_EXPRESSION($2)]{{,} A}); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld  __FORM({%-16s},[__SIMPLIFY_EXPRESSION(1+$2)]{{,} A}); 3:13      __INFO{}dnl
__{}},
__{}{
__{}__{}    ld    A, __FORM({%-11s},ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,0)},__IS_NUM($1),1,__HEX_L($1),__SIMPLIFY_EXPRESSION($1))); ifelse(__HAS_PTR($1),0,{2:7 },{3:13})      __INFO   ( x1 -- x1 ) [x2]: $1-x1
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld  __FORM({%-16s},[__SIMPLIFY_EXPRESSION($2)]{{,} A}); 3:13      __INFO
__{}__{}    ld    A, __FORM({%-11s},ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,1)},__IS_NUM($1),1,__HEX_H($1),__SIMPLIFY_EXPRESSION(high $1))); ifelse(__HAS_PTR($1),0,{2:7 },{3:13})      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld  __FORM({%-16s},[__SIMPLIFY_EXPRESSION(1+$2)]{{,} A}); 3:13      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # over -
dnl # ( x1 x0 -- x1 x )  x = x0 - x1
define({OVER_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_SUB},{over -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    or    A             ; 1:4       __INFO   ( x1 x0 -- x1 x )  x = x0 - x1
    sbc  HL, DE         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # tuck -
dnl # ( x1 x0 -- x0 x2 )  x2 = x1 - x0
define({TUCK_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_TUCK_SUB},{tuck -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_TUCK_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO   ( x1 x0 -- x0 x2 )  x2 = x1 - x0
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO}){}dnl
dnl
dnl # bc@ +
dnl # ( x0 -- x )  x == x0-bc
define({BC_FETCH_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_BC_FETCH_SUB},{bc@ -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BC_FETCH_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # 2 pick -
dnl # ( x2 x1 x0 -- x2 x1 x )  x == x0-x2
define({_2_PICK_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_SUB},{2 pick -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x2 x1 x0 -- x2 x1 x )  x == x0-x2
    push BC             ; 1:11      __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # 2 pick swap -
dnl # ( x2 x1 x0 -- x2 x1 x )  x == x0-x2
define({_2_PICK_SWAP_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_SWAP_SUB},{2 pick swap -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_SWAP_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO   ( x2 x1 x0 -- x2 x1 x )  x == x2-x0
    ld    B, H          ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    push HL             ; 1:11      __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # 3 pick -
dnl # ( x3 x2 x1 x0 -- x3 x2 x1 x )  x == x0-x3
define({_3_PICK_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_SUB},{3 pick -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x )  x == x0-x3
    pop  BC             ; 1:10      __INFO
    push BC             ; 1:11      __INFO
    push AF             ; 1:11      __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # 3 pick swap -
dnl # ( x3 x2 x1 x0 -- x3 x2 x1 x )  x == x3-x0
define({_3_PICK_SWAP_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_SWAP_SUB},{3 pick swap -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_SWAP_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x )  x == x3-x0
    ld    C, L          ; 1:4       __INFO
    ld    B, H          ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    push HL             ; 1:11      __INFO
    push AF             ; 1:11      __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # $1 pick -
dnl # ( xn .. x1 x0 -- xn .. x1 x )  x == x0-xn
define({PUSH_PICK_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_SUB},{$1 pick -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(dnl
__{}eval($#<1),1,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HEX_HL(0x8000 & ($1)),{0x8000},{
__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0-x$1
__{}__{}    push HL             ; 1:11      __INFO   pointer version
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    E,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    D,[HL]        ; 1:7       __INFO
__{}__{}    pop  HL             ; 1:10      __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    pop  DE             ; 1:10      __INFO},

__IS_NUM($1),{0},{
__{}__{} if (($1) & 0x8000)
__{}__{}    .error {$0}($@): Parameter is negative!
__{}__{} else
__{}__{}  if (($1) = 0){}dnl
__{}__{}__ASM_TOKEN_DROP_PUSH(0)
__{}__{}  else
__{}__{}   if (($1) = 1){}dnl
__{}__{}__ASM_TOKEN_OVER_SUB
__{}__{}   else
__{}__{}    if (($1) = 2){}dnl
__{}__{}__ASM_TOKEN_2_PICK_SUB
__{}__{}    else
__{}__{}     if (($1) = 3){}dnl
__{}__{}__ASM_TOKEN_3_PICK_SUB
__{}__{}     else
__{}__{}    ld    A, L          ; 1:4       __INFO   ( $1 .. x1 x0 -- $1 .. x1 x )  x == x0-$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-4+2*($1))); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}     endif
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{__ASM_TOKEN_DROP_PUSH(0)},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_SUB},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_SUB},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_SUB},
__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0-x$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$1-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # $1 pick swap -
dnl # ( xn .. x1 x0 -- xn .. x1 x )  x == xn - x0
define({PUSH_PICK_SWAP_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_SWAP_SUB},{$1 pick swap -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_SWAP_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(dnl
__{}eval($#<1),1,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HEX_HL(0x8000 & ($1)),{0x8000},{
__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x$1-x0
__{}__{}    push HL             ; 1:11      __INFO   pointer version
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    E,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    D,[HL]        ; 1:7       __INFO
__{}__{}    pop  HL             ; 1:10      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    pop  DE             ; 1:10      __INFO},

__IS_NUM($1),{0},{
__{}__{} if (($1) & 0x8000)
__{}__{}    .error {$0}($@): Parameter is negative!
__{}__{} else
__{}__{}  if (($1) = 0){}dnl
__{}__{}__ASM_TOKEN_DROP_PUSH(0)
__{}__{}  else
__{}__{}   if (($1) = 1){}dnl
__{}__{}__ASM_TOKEN_OVER_SWAP_SUB
__{}__{}   else
__{}__{}    if (($1) = 2){}dnl
__{}__{}__ASM_TOKEN_2_PICK_SWAP_SUB
__{}__{}    else
__{}__{}     if (($1) = 3){}dnl
__{}__{}__ASM_TOKEN_3_PICK_SWAP_SUB
__{}__{}     else
__{}__{}    ld    C, L          ; 1:4       __INFO   ( $1 .. x1 x0 -- $1 .. x1 x )  x == x$1-x0
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-4+2*($1))); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO
__{}__{}     endif
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{__ASM_TOKEN_DROP_PUSH(0)},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_SWAP_SUB},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_SWAP_SUB},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_SWAP_SUB},
__{}{
__{}__{}    ld    C, L          ; 1:4       __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x$1-x0
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$1-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- x-n )
dnl # x = x - n
define({PUSH_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_SUB},{$1 -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(dnl
__HAS_PTR($1),{1},{
__{}    ; warning >>>$1<<< is a pointer to memory
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    or    A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO},
__IS_NUM($1),{0},{
__{}    ; warning M4 does not know the numerical value of >>>$1<<<
__{}    ld   BC, __FORM({%-11s},-($1)); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO},
{ifelse(
__{}eval((($1)+3*256) & 0xffff),{0},{
__{}    inc  H              ; 1:4       __INFO   ( x -- x-__HEX_HL($1) )
__{}    inc  H              ; 1:4       __INFO
__{}    inc  H              ; 1:4       __INFO},
__{}eval((($1)+2*256) & 0xffff),{0},{
__{}    inc  H              ; 1:4       __INFO   ( x -- x-__HEX_HL($1) )
__{}    inc  H              ; 1:4       __INFO},
__{}eval((($1)+1*256) & 0xffff),{0},{
__{}    inc  H              ; 1:4       __INFO   ( x -- x-__HEX_HL($1) )},
__{}eval((($1)+    3) & 0xffff),{0},{
__{}    inc  HL             ; 1:6       __INFO   ( x -- x-__HEX_HL($1) )
__{}    inc  HL             ; 1:6       __INFO
__{}    inc  HL             ; 1:6       __INFO},
__{}eval((($1)+    2) & 0xffff),{0},{
__{}    inc  HL             ; 1:6       __INFO   ( x -- x-__HEX_HL($1) )
__{}    inc  HL             ; 1:6       __INFO},
__{}eval((($1)+    1) & 0xffff),{0},{
__{}    inc  HL             ; 1:6       __INFO   ( x -- x-__HEX_HL($1) )},
__{}eval((-($1)) & 0xFFFF),{0},{
__{}                        ;           __INFO   ( x -- x-__HEX_HL($1) )},
__{}eval(($1)-1),{0},{
__{}    dec  HL             ; 1:6       __INFO   ( x -- x-__HEX_HL($1) )},
__{}eval(($1)-2),{0},{
__{}    dec  HL             ; 1:6       __INFO   ( x -- x-__HEX_HL($1) )
__{}    dec  HL             ; 1:6       __INFO},
__{}eval(($1)-3),{0},{
__{}    dec  HL             ; 1:6       __INFO   ( x -- x-__HEX_HL($1) )
__{}    dec  HL             ; 1:6       __INFO
__{}    dec  HL             ; 1:6       __INFO},
__{}eval(($1)-1*256),{0},{
__{}    dec  H              ; 1:4       __INFO   ( x -- x-__HEX_HL($1) )},
__{}eval(($1)-2*256),{0},{
__{}    dec  H              ; 1:4       __INFO   ( x -- x-__HEX_HL($1) )
__{}    dec  H              ; 1:4       __INFO},
__{}eval(($1)-3*256),{0},{
__{}    dec  H              ; 1:4       __INFO   ( x -- x-__HEX_HL($1) )
__{}    dec  H              ; 1:4       __INFO
__{}    dec  H              ; 1:4       __INFO},
__{}eval((-($1)) & 0xFF),{0},{
__{}    ld    A, __HEX_H(-($1))       ; 2:7       __INFO   ( x -- x-__HEX_HL($1) )
__{}    add   A, H          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO},
__{}{
__{}    ld   BC, __HEX_HL(-($1))     ; 3:10      __INFO   ( x -- x-__HEX_HL($1) )
__{}    add  HL, BC         ; 1:11      __INFO})})}){}dnl
dnl
dnl
dnl
define({PUSH2_SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_SUB},{$1 $2 -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(dnl
dnl # ( -- x )
dnl # x = $1 - $2
dnl # CONSTANT(_a,7) CONSTANT(_b,5) PUSH2_SUB({_a},{_b}) -->  ld   HL, 0x0002     ; 3:10      _a _b -
dnl # CONSTANT(_a,7) CONSTANT(_b,5) PUSH2_SUB(_a,_b)     -->  ld   HL, 0x0002     ; 3:10      5 7 -
eval((__HAS_PTR($1)+__HAS_PTR($2))>0),{1},{dnl
__{}ifelse(eval(__HAS_PTR($1)+__HAS_PTR($2)),{2},{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1-($2)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:16      __INFO
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO},
__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1-($2)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:16      __INFO
__{}__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); 3:10      __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO},
__{}{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1-($2)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO})},
{dnl
__{}__{}ifelse(__IS_NUM($1+$2),{0},{
__{}__{}    ; warning The condition >>>$1+$2<<< cannot be evaluated
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1-($2)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},$1-($2)); 3:10      __INFO},
__{}{
__{}__{}    push DE             ; 1:11      __INFO   ( -- x )   x = $1-($2)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1-($2))     ; 3:10      __INFO})})}){}dnl
dnl
dnl
dnl
dnl # ( x -- u )
dnl # absolute value of x
define({ABS},{dnl
__{}__ADD_TOKEN({__TOKEN_ABS},{abs},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ABS},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(1,0,{
dnl ;#__{}__{}                        ;[10:30/38] __INFO
__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld    C, A          ; 1:4       __INFO
__{}__{}    sbc   A, C          ; 1:4       __INFO
__{}__{}    sub   H             ; 1:4       __INFO
__{}__{}    jp    m, $+5        ; 3:10      __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO},
__{}{
dnl ;#__{}__{}                        ;[10:20/39] __INFO
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO
__{}__{}    jr   nc, $+8        ; 2:7/12    __INFO{}dnl
__{}__{}__ASM_TOKEN_NEGATE}){}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 -- ?  5 )
dnl # ( -5 -3 -- ? -3 )
define({MAX_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_MAX_DOWN},{max down},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MAX_DOWN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    sub   E             ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    ld    A, H          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    sbc   A, D          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    jp    p, $+4        ; 3:10      __INFO
    ex   DE, HL         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5  3 --  5 )
dnl # ( -5 -3 -- -3 )
define({MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_MAX},{max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    sub   E             ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    ld    A, H          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    sbc   A, D          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    jp    p, $+4        ; 3:10      __INFO
    ex   DE, HL         ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # bc=  5 (  3 --  5 )
dnl # bc= -5 ( -3 -- -3 )
define({BC_FETCH_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_BC_FETCH_MAX},{bc@ max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BC_FETCH_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
    sub   C             ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
    ld    A, H          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
    sbc   A, B          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   B             ; 1:4       __INFO
    jp    p, $+5        ; 3:10      __INFO
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5 x  3 -- x  5 )
dnl # (  5 x -3 -- x -3 )
define({ROT_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_MAX},{rot max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( x3 x2 x1 -- x2 x )  x: max(x3,x1){}dnl
__{}__ASM_TOKEN_BC_FETCH_MAX{}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 --  5  5 )
dnl # ( -5 -3 -- -5 -3 )
define({OVER_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_MAX},{over max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    sub   E             ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    ld    A, H          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    sbc   A, D          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is max
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    jp    p, $+5        ; 3:10      __INFO
    ld    L, E          ; 1:4       __INFO
    ld    H, D          ; 1:4       __INFO{}dnl
}){}dnl
dnl
dnl
dnl # 2 pick max
dnl # 2 pick >bc bc@ max
dnl # (  5 x  3 --  5 x  5 )
dnl # ( -5 x -3 -- -5 x -3 )
define({_2_PICK_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_MAX},{2 pick max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( x3 x2 x1 -- x3 x2 x )  x: max(x3,x1)
__{}    push BC             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_MAX{}dnl
}){}dnl
dnl
dnl
dnl # 3 pick max
dnl # 3 pick >bc bc@ max
dnl # (  5 x2 x1  3 --  5 x2 x1  5 )
dnl # ( -5 x2 x1 -3 -- -5 x2 x1 -3 )
define({_3_PICK_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_MAX},{3 pick max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  AF             ; 1:10      __INFO    ( x4 x3 x2 x1 -- x4 x3 x2 x )  x: max(x4,x1)
__{}    pop  BC             ; 1:10      __INFO
__{}    push BC             ; 1:11      __INFO
__{}    push AF             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_MAX{}dnl
}){}dnl
dnl
dnl
dnl # (  5 --  5 ) $1 = 3
dnl # ( -5 -- -3 ) $1 =-3
define({PUSH_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_MAX},{$1 max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[16:66/58]  __INFO   ( x1 $1 -- x )  x: max(x1,$1)
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO    HL<$1 --> HL-$1<0 --> carry if $1 is max
__{}__{}    sub   C             ; 1:4       __INFO    HL<$1 --> HL-$1<0 --> carry if $1 is max
__{}__{}    ld    A, H          ; 1:4       __INFO    HL<$1 --> HL-$1<0 --> carry if $1 is max
__{}__{}    sbc   A, B          ; 1:4       __INFO    HL<$1 --> HL-$1<0 --> carry if $1 is max
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+5        ; 3:10      __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO},
__{}{dnl
__{}define({_TMP_STACK_INFO},( x1 $1 -- x )  x: max(x1{{,}}$1)){}dnl
__{}__{}__MAKE_CODE_DUP_PUSH_LT_JP_FALSE($1,$+6)
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( 5  3 -- ?  5 )
dnl # ( 5 -3 -- ? -3 )
define({UMAX_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_UMAX_DOWN},{umax down},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMAX_DOWN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    sub   E             ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    ld    A, H          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    sbc   A, D          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    jr   nc, $+3        ; 2:7/12    __INFO
    ex   DE, HL         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( 5  3 --  5 )
dnl # ( 5 -3 -- -3 )
define({UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_UMAX},{umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    sub   E             ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    ld    A, H          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    sbc   A, D          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    jr   nc, $+3        ; 2:7/12    __INFO
    ex   DE, HL         ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # bc=  5 (  3 --  5 )
dnl # bc= -5 ( -3 -- -3 )
define({BC_FETCH_UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_BC_FETCH_UMAX},{bc@ umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BC_FETCH_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is umax
    sub   C             ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is umax
    ld    A, H          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is umax
    sbc   A, B          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is umax
    jr   nc, $+4        ; 2:7/12    __INFO
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5 x  3 -- x  5 )
dnl # (  5 x -3 -- x -3 )
define({ROT_UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_UMAX},{rot umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( u3 x2 u1 -- x2 u )  u: max(u3,u1){}dnl
__{}__ASM_TOKEN_BC_FETCH_UMAX{}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 --  5  5 )
dnl # ( -5 -3 -- -5 -3 )
define({OVER_UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_UMAX},{over umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    sub   E             ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    ld    A, H          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    sbc   A, D          ; 1:4       __INFO    HL>=DE --> HL-DE>=0 --> not carry if HL is umax
    jr   nc, $+4        ; 2:7/12    __INFO
    ld    L, E          ; 1:4       __INFO
    ld    H, D          ; 1:4       __INFO{}dnl
}){}dnl
dnl
dnl
dnl # 2 pick umax
dnl # 2 pick >bc bc@ umax
dnl # ( 5 x 3 -- 5 x 5 )
dnl # ( 3 x 5 -- 3 x 5 )
define({_2_PICK_UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_UMAX},{2 pick umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( u3 x2 u1 -- x3 x2 u )  u: umax(u3,u1)
__{}    push BC             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_UMAX{}dnl
}){}dnl
dnl
dnl
dnl # 3 pick umax
dnl # 3 pick >bc bc@ umax
dnl # ( 5 x2 x1 5 -- 5 x2 x1 5 )
dnl # ( 3 x2 x1 5 -- 3 x2 x1 5 )
define({_3_PICK_UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_UMAX},{3 pick umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  AF             ; 1:10      __INFO    ( u4 x3 x2 u1 -- u4 x3 x2 u )  u: umax(u4,u1)
__{}    pop  BC             ; 1:10      __INFO
__{}    push BC             ; 1:11      __INFO
__{}    push AF             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_UMAX{}dnl
}){}dnl
dnl
dnl
dnl # (  5 x2 x1  3 --  5 x2 x1  5 )
dnl # ( -5 x2 x1 -3 -- -5 x2 x1 -3 )
define({PUSH_PICK_MAX},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_MAX},{3 pick max},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_MAX},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#)>1,1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),1,{dnl
__{}__{}__ASM_TOKEN_PUSH_PICK_TO_BC($1){}dnl
__{}__{}__ASM_TOKEN_BC_FETCH_MAX},
__{}__IS_NUM($1),0,{
__{}__{} if ($1)
__{}__{} if (0x8000 & ($1))
__{}__{}  .error {$0}($@): 64kb overflow!
__{}__{} else
__{}__{}  if (($1) = 1)
__{}__{}    ld    C, E          ; 1:4       __INFO   ( x1 x0 -- x1 x0 ) bc = x1
__{}__{}    ld    B, D          ; 1:4       __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}  else
__{}__{}   if (($1) = 2)
__{}__{}    pop  BC             ; 1:10      __INFO   ( x2 x1 x0 -- x2 x1 x0 )  bc = x2
__{}__{}    push BC             ; 1:11      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}   else
__{}__{}    if (($1 = 3)
__{}__{}    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x0 )  bc = x3
__{}__{}    pop  BC             ; 1:10      __INFO
__{}__{}    push BC             ; 1:11      __INFO
__{}__{}    push AF             ; 1:11      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    else
__{}__{}    ld    C, L          ; 1:4       __INFO   ( x{}$1..x1 x0 -- x{}$1..x1 x ) x = max(x0, x{}$1)
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},2*($1)-4); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{}    sub   C             ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
__{}__{}    ld    A, H          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
__{}__{}    sbc   A, B          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
__{}__{}    rra                 ; 1:4       __INFO    carry to sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+5        ; 3:10      __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{} endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_MAX},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_MAX},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_MAX},
__{}__HEX_HL(0x8000 & ($1)),0x8000,{
__{}__{}  .error {$0}($@): 64kb overflow!},

__{}{
__{}__{}    ld    C, L          ; 1:4       __INFO   ( x{}$1..x1 x0 -- x{}$1..x1 x ) x = max(x0, x{}$1)
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL(2*($1)-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    sub   C             ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
__{}__{}    ld    A, H          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
__{}__{}    sbc   A, B          ; 1:4       __INFO    HL>=BC --> HL-BC>=0 --> not carry if HL is max
__{}__{}    rra                 ; 1:4       __INFO    carry to sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+5        ; 3:10      __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # (  5 --  5 ) $1 = 3
dnl # ( -5 -- -3 ) $1 =-3
define({PUSH_UMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_UMAX},{$1 umax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_UMAX},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[12:51/48]  __INFO
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    sub   C             ; 1:4       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    ld    A, H          ; 1:4       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    sbc   A, B          ; 1:4       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    jr   nc, $+4        ; 2:7/12    __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO},
__{}{
__{}__{}                       ;[11:39/34]  __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    sub  __FORM({%-15s},$1); 2:7       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    ld    A, H          ; 1:4       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    sbc   A, high __FORM({%-6s},$1); 2:7       __INFO    HL>=$1 --> HL-$1>=0 --> not carry if tos is umax
__{}__{}    jr   nc, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 -- ?  3 )
dnl # ( -5 -3 -- ? -5 )
define({MIN_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_MIN_DOWN},{min down},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MIN_DOWN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    sub   L             ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    ld    A, D          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    sbc   A, H          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    jp    p, $+4        ; 3:10      __INFO
    ex   DE, HL         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5  3 --  3 )
dnl # ( -5 -3 -- -5 )
define({MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_MIN},{min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    sub   L             ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    ld    A, D          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    sbc   A, H          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is min
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    jp    p, $+4        ; 3:10      __INFO
    ex   DE, HL         ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # bc=  5 (  3 --  3 )
dnl # bc= -5 ( -3 -- -5 )
define({BC_FETCH_MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_BC_FETCH_MIN},{bc@ min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BC_FETCH_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, C          ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is min
    sub   L             ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is min
    ld    A, B          ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is min
    sbc   A, H          ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is min
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   B             ; 1:4       __INFO
    jp    p, $+5        ; 3:10      __INFO
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5 x  3 -- x  3 )
dnl # ( -5 x -3 -- x -5 )
define({ROT_MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_MIN},{rot min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( x3 x2 x1 -- x2 x )  x: min(x3,x1){}dnl
__{}__ASM_TOKEN_BC_FETCH_MIN{}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 --  5  3 )
dnl # ( -5 -3 -- -5 -5 )
define({OVER_MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_MIN},{over min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is min
    sub   L             ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is min
    ld    A, D          ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is min
    sbc   A, H          ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is min
    rra                 ; 1:4       __INFO    carry to sign
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    jp    p, $+5        ; 3:10      __INFO
    ld    L, E          ; 1:4       __INFO
    ld    H, D          ; 1:4       __INFO{}dnl
}){}dnl
dnl
dnl
dnl # (  5 x  3 --  5 x  3 )
dnl # ( -5 x -3 -- -5 x -5 )
define({_2_PICK_MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_MIN},{2 pick min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( x3 x2 x1 -- x3 x2 x )  x: min(x3,x1)
__{}    push BC             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_MIN{}dnl
}){}dnl
dnl
dnl
dnl # (  5 x2 x1  3 --  5 x2 x1  3 )
dnl # ( -5 x2 x1 -3 -- -5 x2 x1 -5 )
define({_3_PICK_MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_MIN},{3 pick min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  AF             ; 1:10      __INFO    ( x4 x3 x2 x1 -- x4 x3 x2 x )  x: min(x4,x1)
__{}    pop  BC             ; 1:10      __INFO
__{}    push BC             ; 1:11      __INFO
__{}    push AF             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_MIN{}dnl
}){}dnl
dnl
dnl
dnl # (  5 --  3 ) $1 = 3
dnl # ( -5 -- -5 ) $1 =-3
define({PUSH_MIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_MIN},{$1 min},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_MIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}                       ;[16:66/58]  __INFO   ( x1 $1 -- x )  x: min(x1,$1)
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   $1<HL --> $1-HL<0 --> carry if num is min
__{}__{}    sub   L             ; 1:4       __INFO   $1<HL --> $1-HL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   $1<HL --> $1-HL<0 --> carry if num is min
__{}__{}    sbc   A, H          ; 1:4       __INFO   $1<HL --> $1-HL<0 --> carry if num is min
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+5        ; 3:10      __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO},
__{}{dnl
__{}define({_TMP_STACK_INFO},( x1 $1 -- x )  x: min(x1{{,}}$1)){}dnl
__{}__{}__MAKE_CODE_DUP_PUSH_GT_JP_FALSE($1,$+6)
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 -- ?  3 )
dnl # ( -5 -3 -- ? -5 )
define({UMIN_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_UMIN_DOWN},{umin down},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMIN_DOWN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    sub   L             ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    ld    A, D          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    sbc   A, H          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    jr   nc, $+3        ; 2:7/12    __INFO
    ex   DE, HL         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5  3 --  3 )
dnl # ( -5 -3 -- -5 )
define({UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_UMIN},{umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    sub   L             ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    ld    A, D          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    sbc   A, H          ; 1:4       __INFO    DE>=HL --> DE-HL>=0 --> not carry if HL is umin
    jr   nc, $+3        ; 2:7/12    __INFO
    ex   DE, HL         ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # bc=  5 (  3 --  3 )
dnl # bc=  5 ( -3 --  5 )
define({BC_FETCH_UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_BC_FETCH_UMIN},{bc@ umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BC_FETCH_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, C          ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is umin
    sub   L             ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is umin
    ld    A, B          ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is umin
    sbc   A, H          ; 1:4       __INFO    HL<=BC --> 0<=BC-HL --> not carry if HL is umin
    jr   nc, $+4        ; 2:7/12    __INFO
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # (  5 x  3 -- x  3 )
dnl # (  5 x -3 -- x  5 )
define({ROT_UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_UMIN},{rot umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( u3 x2 u1 -- x2 u )  u: umin(u3,u1){}dnl
__{}__ASM_TOKEN_BC_FETCH_UMIN{}dnl
}){}dnl
dnl
dnl
dnl # (  5  3 --  5  3 )
dnl # (  3  5 --  3  3 )
define({OVER_UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_UMIN},{over umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is umin
    sub   L             ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is umin
    ld    A, D          ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is umin
    sbc   A, H          ; 1:4       __INFO    HL<=DE --> 0<=DE-HL --> not carry if HL is umin
    jr   nc, $+4        ; 2:7/12    __INFO
    ld    L, E          ; 1:4       __INFO
    ld    H, D          ; 1:4       __INFO{}dnl
}){}dnl
dnl
dnl
dnl # ( 5 x 3 -- 5 x 3 )
dnl # ( 3 x 5 -- 3 x 3 )
define({_2_PICK_UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_UMIN},{2 pick umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO    ( u3 x2 u1 -- u3 x2 u )  u: umin(u3,u1)
__{}    push BC             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_UMIN{}dnl
}){}dnl
dnl
dnl
dnl # ( 5 x2 x1 3 -- 5 x2 x1 3 )
dnl # ( 3 x2 x1 5 -- 3 x2 x1 3 )
define({_3_PICK_UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_UMIN},{3 pick umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  AF             ; 1:10      __INFO    ( u4 x3 x2 u1 -- u4 x3 x2 u )  u: umin(u4,u1)
__{}    pop  BC             ; 1:10      __INFO
__{}    push BC             ; 1:11      __INFO
__{}    push AF             ; 1:11      __INFO{}dnl
__{}__ASM_TOKEN_BC_FETCH_UMIN{}dnl
}){}dnl
dnl
dnl
dnl # ( 5 -- 3 ) $1 = 3
dnl # ( 3 -- 3 ) $1 = 5
define({PUSH_UMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_UMIN},{$1 umin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_UMIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}                        ;[12:51/48] __INFO
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    sub   L             ; 1:4       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    ld    A, B          ; 1:4       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    sbc   A, H          ; 1:4       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    jr   nc, $+4        ; 2:7/12    __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO},
__{}{
__{}__{}                        ;[11:39/34] __INFO
__{}__{}    ld    A, __FORM({%-11s},$1); 2:7       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    sub   L             ; 1:4       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    ld    A, high __FORM({%-6s},$1); 2:7       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    sbc   A, H          ; 1:4       __INFO    HL<=$1 --> 0<=$1-HL --> not carry if tos is umin
__{}__{}    jr   nc, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- -x )
dnl # x = -x
define({NEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_NEGATE},{negate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_NEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO
    sub   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    sub   L             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 * x1
define({MUL},{dnl
__{}__ADD_TOKEN({__TOKEN_MUL},{*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MUL},{dnl
__{}__def({USE_MUL},{})dnl
__{}define({__INFO},__COMPILE_INFO)
    call MULTIPLY       ; 3:17      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- ? x3 )
dnl # x3 = x2 * x1
define({MUL_DOWN},{dnl
__{}__ADD_TOKEN({__TOKEN_MUL_DOWN},{over *},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MUL_DOWN},{dnl
__{}__def({USE_MUL},{})dnl
__{}define({__INFO},__COMPILE_INFO)
    call MULTIPLY       ; 3:17      __INFO   ( x2 x1 -- ? x3 )  x3 = x2 * x1}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 / x1
define({DIV},{dnl
__{}__ADD_TOKEN({__TOKEN_DIVMOD},{/},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DIV},{dnl
__{}__def({USE_DIV},{})dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    call DIVIDE         ; 3:17      __INFO
__{}    pop  DE             ; 1:10      __INFO{}dnl
}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 % x1
define({MOD},{dnl
__{}__ADD_TOKEN({__TOKEN_DIVMOD},{mod},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_DROP},{__dtto}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MOD},{dnl
__{}__def({USE_DIV},{})dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    call DIVIDE         ; 3:17      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO{}dnl
})dnl
dnl
dnl # ( x2 x1 -- r q )
dnl # x = x2 u% x1
define({DIVMOD},{dnl
__{}__ADD_TOKEN({__TOKEN_DIVMOD},{/mod},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DIVMOD},{dnl
__{}__def({USE_DIV},{})dnl
__{}define({__INFO},__COMPILE_INFO)
    call DIVIDE         ; 3:17      __INFO{}dnl
}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 u/ x1
define({UDIV},{dnl
__{}__ADD_TOKEN({__TOKEN_UDIVMOD},{u/},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UDIV},{dnl
__{}__def({USE_UDIV},{}){}dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    call UDIVIDE        ; 3:17      __INFO
__{}    pop  DE             ; 1:10      __INFO{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x2 u% x1
define({UMOD},{dnl
__{}__ADD_TOKEN({__TOKEN_UDIVMOD},{umod},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_DROP},{__dtto}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMOD},{dnl
__{}__def({USE_UDIV},{})dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    call UDIVIDE        ; 3:17      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO{}dnl
}){}dnl
dnl
dnl
dnl # ( x2 x1 -- r q )
dnl # x = x2 u% x1
define({UDIVMOD},{dnl
__{}__ADD_TOKEN({__TOKEN_UDIVMOD},{u/mod},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UDIVMOD},{dnl
__{}__def({USE_UDIV},{})dnl
__{}define({__INFO},__COMPILE_INFO)
    call UDIVIDE        ; 3:17      __INFO{}dnl
}){}dnl
dnl
dnl
dnl # "1+"
dnl # ( x1 -- x )
dnl # x = x1 + 1
define({_1ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_1ADD},{1+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc  HL             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # ( x -- x ) zero_flag: (x + 1) == 0
define({DUP_1ADD_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_1ADD_ZF_STORE},{dup 1+ zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_1ADD_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO   ( x -- x ) zero_flag: (x + 1) == 0
    and   H             ; 1:4       __INFO
    inc   A             ; 1:4       __INFO   set zero flag}){}dnl
dnl
dnl
dnl
dnl # "1-"
dnl # ( x1 -- x )
dnl # x = x1 - 1
define({_1SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_1SUB},{1-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    dec  HL             ; 1:6       __INFO   ( x -- x-1 )}){}dnl
dnl
dnl
dnl # "2+"
dnl # ( x1 -- x )
dnl # x = x1 + 2
define({_2ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2ADD},{2+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc  HL             ; 1:6       __INFO
    inc  HL             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # "2-"
dnl # ( x1 -- x )
dnl # x = x1 - 2
define({_2SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_2SUB},{2-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    dec  HL             ; 1:6       __INFO
    dec  HL             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # "swap 1+ swap"
dnl # ( x2 x1 -- x2+1 x1 )
define({SWAP_1ADD_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_1ADD_SWAP},{swap 1+ swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_1ADD_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc  DE             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # "swap 1- swap"
dnl # ( x2 x1 -- x2-1 x1 )
define({SWAP_1SUB_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_1SUB_SWAP},{swap 1- swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_1SUB_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    dec  DE             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # "swap 2+ swap"
dnl # ( x2 x1 -- x2+2 x1 )
define({SWAP_2ADD_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_2ADD_SWAP},{swap 2+ swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_2ADD_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc  DE             ; 1:6       __INFO
    inc  DE             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # "swap 2- swap"
dnl # ( x2 x1 -- x2-2 x1 )
define({SWAP_2SUB_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_2SUB_SWAP},{swap 2- swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_2SUB_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    dec  DE             ; 1:6       __INFO
    dec  DE             ; 1:6       __INFO}){}dnl
dnl
dnl
dnl # "rot +"
dnl # ( x3 x2 x1 -- x2 x1+x3 )
define({ROT_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_ADD},{rot +},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 x1+x3 )
    add  HL, BC         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # "rot -"
dnl # ( x3 x2 x1 -- x2 x1-x3 )
define({ROT_ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_SUB},{rot -},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_SUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 x1-x3 )
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # "rot 1+ nrot"
dnl # ( x3 x2 x1 -- x3+1 x2 x1 )
define({ROT_1ADD_NROT},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_1ADD_NROT},{rot 1+ nrot},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_1ADD_NROT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x3+1 x2 x1 )
    inc  BC             ; 1:6       __INFO
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # "rot 1+ nrot 2over nip"
dnl # ( x3 x2 x1 -- x3+1 x2 x1 x3+1 )
define({ROT_1ADD_NROT_2OVER_NIP},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_1ADD_NROT_2OVER_NIP},{rot 1+ -rot 2over nip},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_1ADD_NROT_2OVER_NIP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x3+1 x2 x1 x3+1 )
    inc  BC             ; 1:6       __INFO
    push BC             ; 1:11      __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # "rot 1- nrot"
dnl # ( x3 x2 x1 -- x3-1 x2 x1 )
define({ROT_1SUB_NROT},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_1SUB_NROT},{rot 1- nrot},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_1SUB_NROT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x3-1 x2 x1 )
    dec  BC             ; 1:6       __INFO
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # "rot 1- nrot 2over nip"
dnl # ( x3 x2 x1 -- x3-1 x2 x1 x3-1 )
define({ROT_1SUB_NROT_2OVER_NIP},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_1SUB_NROT_2OVER_NIP},{rot 1- -rot 2over nip},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_1SUB_NROT_2OVER_NIP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x3-1 x2 x1 x3-1 )
    dec  BC             ; 1:6       __INFO
    push BC             ; 1:11      __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # "rot 2+ nrot"
dnl # ( x3 x2 x1 -- x3+2 x2 x1 )
define({ROT_2ADD_NROT},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_2ADD_NROT},{rot 2+ nrot},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_2ADD_NROT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x3+2 x2 x1 )
    inc  BC             ; 1:6       __INFO
    inc  BC             ; 1:6       __INFO
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # "rot 2- nrot"
dnl # ( x3 x2 x1 -- x3-2 x2 x1 )
define({ROT_2SUB_NROT},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_2SUB_NROT},{rot 2- nrot},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_2SUB_NROT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x3-2 x2 x1 )
    dec  BC             ; 1:6       __INFO
    dec  BC             ; 1:6       __INFO
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # "2*"
dnl # ( x1 -- x )
dnl # x = x1 * 2
define({_2MUL},{dnl
__{}__ADD_TOKEN({__TOKEN_2MUL},{2*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2MUL},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # "2/"
dnl # ( x1 -- x )
dnl # x = x1 / 2
define({_2DIV},{dnl
__{}__ADD_TOKEN({__TOKEN_2DIV},{2/},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DIV},{dnl
__{}define({__INFO},__COMPILE_INFO)
    sra   H             ; 2:8       __INFO   with sign
    rr    L             ; 2:8       __INFO}){}dnl
dnl
dnl
dnl # "256 *"
dnl # ( x1 -- x )
dnl # x = x1 * 256
define({_256MUL},{dnl
__{}__ADD_TOKEN({__TOKEN_256MUL},{256*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_256MUL},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    H, L          ; 1:4       __INFO
    ld    L, 0x00       ; 2:7       __INFO}){}dnl
dnl
dnl
dnl # "256 /"
dnl # ( x1 -- x )
dnl # x = x1 / 256
define({_256DIV},{dnl
__{}__ADD_TOKEN({__TOKEN_256DIV},{256/},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_256DIV},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    L, H          ; 1:4       __INFO   with sign
    rl    H             ; 2:8       __INFO
    sbc   A, A          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
define({PUSH_MUL},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_MUL},{$1 *},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_MUL},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),{1},{
__{}__{}.  error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}  .error {$0}($@): $1 is pointer!},
__{}__IS_NUM($1),{0},{
__{}__{}  .error {$0}($@): M4 does not know the value of variable or constant $1!},
__{}{dnl
__{}__{}PUSH_MUL_MK1($1){}dnl
__{}__{}define({_BEST_OUT},{PUSH_MUL_MK1_OUT}){}dnl
__{}__{}define({_BEST_COST},PUSH_MUL_MK1_COST){}dnl
__{}__{}define({_BEST_INFO},{PUSH_MUL_MK1_INFO}){}dnl
__{}__{}PUSH_MUL_MK2($1){}dnl
__{}__{}ifelse(PUSH_MUL_CHECK_FIRST_IS_BETTER(PUSH_MUL_MK2_COST,_BEST_COST),{1},{dnl
__{}__{}__{}define({_BEST_OUT},{PUSH_MUL_MK2_OUT}){}dnl
__{}__{}__{}define({_BEST_COST},PUSH_MUL_MK2_COST){}dnl
__{}__{}__{}define({_BEST_INFO},PUSH_MUL_MK2_INFO){}dnl
__{}__{}}){}dnl
__{}__{}PUSH_MUL_MK3($1){}dnl
__{}__{}ifelse(PUSH_MUL_CHECK_FIRST_IS_BETTER(PUSH_MUL_MK3_COST,_BEST_COST),{1},{dnl
__{}__{}__{}define({_BEST_OUT},{PUSH_MUL_MK3_OUT}){}dnl
__{}__{}__{}define({_BEST_COST},PUSH_MUL_MK3_COST){}dnl
__{}__{}__{}define({_BEST_INFO},PUSH_MUL_MK3_INFO){}dnl
__{}__{}}){}dnl
__{}__{}PUSH_MUL_MK4($1){}dnl
__{}__{}ifelse(PUSH_MUL_CHECK_FIRST_IS_BETTER(PUSH_MUL_MK4_COST,_BEST_COST),{1},{dnl
__{}__{}__{}define({_BEST_OUT},{PUSH_MUL_MK4_OUT}){}dnl
__{}__{}__{}define({_BEST_COST},PUSH_MUL_MK4_COST){}dnl
__{}__{}__{}define({_BEST_INFO},PUSH_MUL_MK4_INFO){}dnl
__{}__{}}){}dnl
__{}__{}_BEST_INFO{}dnl
__{}__{}_BEST_OUT{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl ---------------------------------------------------------------------------
dnl ## 8-bit Arithmetic
dnl ---------------------------------------------------------------------------
dnl
dnl
dnl
dnl # ( -- )
define({R8ADD},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_R8ADD_R8STORE},{$1 $2 r8+ $1!},$@,$1){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( -- )  $3 = $1 + $2
define({R8ADD_R8STORE},{dnl
__{}ifelse(
__{}eval($#<3),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>3),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__IS_REG($1),0,{
__{}__{}  .error {$0}($@): $1 is not register name!},
__{}__IS_REG($2),0,{
__{}__{}  .error {$0}($@): $2 is not register name!},
__{}__IS_REG($3),0,{
__{}__{}  .error {$0}($@): $3 is not register name!},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_R8ADD_R8STORE},{$1 $2 r8+ $3!},$@){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_R8ADD_R8STORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<3),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>3),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__IS_REG($1),0,{
__{}__{}  .error {$0}($@): $1 is not register name!},
__{}__IS_REG($2),0,{
__{}__{}  .error {$0}($@): $2 is not register name!},
__{}__IS_REG($3),0,{
__{}__{}  .error {$0}($@): $3 is not register name!},
__{}len($3):translit({$1}, {a-z}, {A-Z}):translit({$1}, {a-z}, {A-Z}),1:translit({$2}, {a-z}, {A-Z}):translit({$3}, {a-z}, {A-Z}),{dnl
__{}__{}ifelse(
__{}__{}translit({$1}, {a-z}, {A-Z}),{A},{
__{}__{}__{}    add   A, A          ; 1:4       __INFO   ( -- )   $3 = $1 r8+ $2},
__{}__{}{
__{}__{}__{}    sla   $3             ; 2:8       __INFO   ( -- )   $3 = $1 r8+ $2})},
__{}{dnl
__{}__{}ifelse(
__{}__{}ifelse($1,{A},1,$1,{a},1,0),1,{
__{}__{}__{}    add   A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO   ( -- )   $3 = A r8+ $2},
__{}__{}ifelse($2,{A},1,$2,{a},1,0),1,{
__{}__{}__{}    add   A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $3 = $1 r8+ A},
__{}__{}translit({$1}, {a-z}, {A-Z}),translit({$2}, {a-z}, {A-Z}),{
__{}__{}__{}    ld    A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $3 = $1 r8+ $2
__{}__{}__{}    add   A, A          ; 1:4       __INFO},
__{}__{}{
__{}__{}__{}    ld    A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $3 = $1 r8+ $2
__{}__{}__{}    add   A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO}){}dnl
__{}__{}ifelse($3,{A},{},$3,{a},{},
__{}__{}{
__{}__{}__{}    ld    __FORM({%-14s},{$3, A}); ifelse(len($3),1,{1:4},len($3),3,{2:8},{?:?})       __INFO}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- )
define({R8SUB},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_R8SUB_R8STORE},{$1 $2 r8-},$@,$1){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( -- )  $3 = $1 - $2
define({R8SUB_R8STORE},{dnl
__{}ifelse(
__{}eval($#<3),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>3),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__IS_REG($1),0,{
__{}__{}  .error {$0}($@): $1 is not register name!},
__{}__IS_REG($2),0,{
__{}__{}  .error {$0}($@): $2 is not register name!},
__{}__IS_REG($3),0,{
__{}__{}  .error {$0}($@): $3 is not register name!},
__{}{dnl
__{}__{}__ADD_TOKEN({__TOKEN_R8SUB_R8STORE},{$1 $2 r8- $3!},$@){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_R8SUB_R8STORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<3),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>3),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__IS_REG($1),0,{
__{}__{}  .error {$0}($@): $1 is not register name!},
__{}__IS_REG($2),0,{
__{}__{}  .error {$0}($@): $2 is not register name!},
__{}__IS_REG($3),0,{
__{}__{}  .error {$0}($@): $3 is not register name!},
__{}translit({$1}, {a-z}, {A-Z}),translit({$2}, {a-z}, {A-Z}),{dnl
__{}__{}ifelse(
__{}__{}ifelse($3,{A},1,$3,{a},1,0),1,{
__{}__{}__{}    xor   A             ; 1:4       __INFO   ( -- )   $3 = $1 - $2},
__{}__{}len($3),1,{
__{}__{}__{}    ld   __FORM({%-15s},{$3, 0x00}); 2:7       __INFO   ( -- )   $3 = $1 - $2},
__{}__{}len($3),3,{
__{}__{}__{}    ld  format({%-16s},__FORM({%s},$3){, 0x00}); 3:11      __INFO   ( -- )   $3 = $1 - $2},
__{}__{}{
__{}__{}__{}  .error {$0}($@): $3 is unknown 8-bit register!}){}dnl
__{}},
__{}{dnl
__{}__{}ifelse(
__{}__{}ifelse($1,{A},1,$1,{a},1,0),1,{
__{}__{}__{}    sub   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO   ( -- )   $3 = A - $2},
__{}__{}ifelse($2,{A},1,$2,{a},1,0),1,{
__{}__{}__{}    neg                 ; 2:8       __INFO   ( -- )   $3 = $1 - A
__{}__{}__{}    add   A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO},
__{}__{}{
__{}__{}__{}    ld    A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $3 = $1 - $2
__{}__{}__{}    sub   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO}){}dnl
__{}__{}ifelse($3,{A},{},$3,{a},{},
__{}__{}{
__{}__{}__{}    ld    __FORM({%-14s},{$3, A}); ifelse(len($3),1,{1:4},len($3),3,{2:8},{?:?})       __INFO}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )
dnl # x = 256*hi(x1) + lo(x1+x2)
define({CADD},{dnl
__{}__ADD_TOKEN({__TOKEN_CADD},{c+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = 256*hi(x1) + lo(x2 + x1)
    add   A, L          ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )
dnl # x = 256*(hi(x1)+hi(x2)) + lo(x1)
define({HADD},{dnl
__{}__ADD_TOKEN({__TOKEN_HADD},{h+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = 256*(hi(x2) + hi(x1)) + lo(x1)
    add   A, H          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )
dnl # x = 256*hi(x1) + lo(x2-x1)
define({CSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_CSUB},{c-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = 256*hi(x1) + lo(x2 - x1)
    sub   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )
dnl # x = 256*(hi(x2)-hi(x1)) + lo(x1)
define({HSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_HSUB},{h-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = 256*(hi(x2) - hi(x1)) + lo(x1)
    sub   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( x1 -- x2 )
dnl # x2 = 256*hi(x1) + lo(x1+1)
define({_1CADD},{dnl
__{}__ADD_TOKEN({__TOKEN_1CADD},{1c+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1CADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   L             ; 1:4       __INFO   ( x1 -- x2 )   x2 = 256*hi(x1) + lo(x1 + 1)}){}dnl
dnl
dnl
dnl # ( c -- c )  zero_flag: (c + 1) == 0
define({DUP_1CADD_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_1CADD_ZF_STORE},{dup 1c+ zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_1CADD_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO   ( c -- c ) zero_flag: (c + 1) == 0
    inc   L             ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x1 -- x2 )
dnl # x2 = x1+256
define({_1HADD},{dnl
__{}__ADD_TOKEN({__TOKEN_1HADD},{1h+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1HADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   H             ; 1:4       __INFO   ( x1 -- x2 )   x2 = x1 + 256}){}dnl
dnl
dnl
dnl # ( h -- h ) zero_flag: (h + 1) == 0
define({DUP_1HADD_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_1HADD_ZF_STORE},{dup 1h+ zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_1HADD_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO   ( h -- h ) zero_flag: (h + 1) == 0
    inc   H             ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x1 -- x2 )
dnl # x2 = 256*hi(x1) + lo(x1-1)
define({_1CSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_1CSUB},{1c-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1CSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    dec   L             ; 1:4       __INFO   ( x1 -- x2 )   x2 = 256*hi(x1) + lo(x1 - 1)}){}dnl
dnl
dnl
dnl # ( x1 -- x2 )
dnl # x2 = x1-256
define({_1HSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_1HSUB},{1h-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1HSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    dec   H             ; 1:4       __INFO   ( x1 -- x2 )   x2 = x1 - 256}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )
dnl # x3 = hi(x1) + lo(lo(x2) + lo(x1))
define({OVER_CADD},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CADD},{over c+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )  x3 = hi(x1) + lo(lo(x2) + lo(x1))
    add   A, L          ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )
dnl # x3 = hi(x1) + lo(lo(x2) - lo(x1))
define({OVER_SWAP_CSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_SWAP_CSUB},{c-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_SWAP_CSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )  x3 = hi(x1) + lo(lo(x2) - lo(x1))
    sub   A, L          ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )
dnl # x3 = hi(hi(x2) + hi(x1)) + lo(x1)
define({OVER_HADD},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HADD},{over h+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )  x3 = hi(hi(x2) + hi(x1)) + lo(x1)
    add   A, H          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )
dnl # x3 = hi(hi(x2) - hi(x1)) + lo(x1)
define({OVER_SWAP_HSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_SWAP_HSUB},{h-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_SWAP_HSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )  x3 = hi(hi(x2) - hi(x1)) + lo(x1)
    sub   A, H          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # 0x8000 C@ C+
dnl # ( c1 -- c1+(adr) )
dnl # c = c2 + c1
define({PUSH_CFETCH_CADD},{dnl
__{}ifelse(
__{}$1,{},{
__{}__{}  .error {$0}($@): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CFETCH_CADD},{$1 c@ c+},$@){}dnl
__{}}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CFETCH_CADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}$1,{},{
__{}__{}  .error {$0}($@): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),1,{
__{}__{}    ld   BC,__FORM({%-12s},{$1}); 4:20      __INFO   ( c -- c+[$1] )
__{}__{}    ld    A,[BC]        ; 1:7       __INFO
__{}__{}    add   A, L          ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO},
__{}{
__{}__{}    ld    A,__FORM({%-12s},{[$1]}); 3:13      __INFO   ( c -- c+[$1] )
__{}__{}    add   A, L          ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # C@ 0x8000 C@ C+
dnl # ( c -- (c)+(adr) )
dnl # c = c2 + c1
define({CFETCH_PUSH_CFETCH_CADD},{dnl
__{}__ADD_TOKEN({__TOKEN_CFETCH_PUSH_CFETCH_CADD},{c@ $1 c@ c+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CFETCH_PUSH_CFETCH_CADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing address parameter!},
__{}$#,{1},{
    ld    A,__FORM({%-12s},{[$1]}); 3:13      __INFO   ( c -- (c)+($1) )
    add   A,[HL]        ; 1:7       __INFO
    ld    L, A          ; 1:4       __INFO},
__{}{
__{}__{}.error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl # 0x8000 C@ C+ 0x4000 C!
dnl # ( c -- )
define({PUSH_CFETCH_CADD_PUSH_CSTORE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CFETCH_CADD_PUSH_CSTORE},{$1 c@ c+ $2 c!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CFETCH_CADD_PUSH_CSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing two address parameters!},
$2,{},{
__{}__{}.error {$0}(): Missing second address parameter!},
__{}$#,{2},{
                        ;[9:47]     __INFO   ( c --  )
    ld    A,__FORM({%-12s},{[$1]}); 3:13      __INFO
    add   A, L          ; 1:4       __INFO
    ld  format({%-16s},__FORM({%s},[$2]){, A}); 3:13      __INFO   [$2] = [$1] + low TOS
    ex   DE, HL         ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO},
__{}{
__{}__{}.error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl # C@ 0x8000 C@ C+ 0x4000 C!
dnl # ( c -- )
define({CFETCH_PUSH_CFETCH_CADD_PUSH_CSTORE},{dnl
__{}__ADD_TOKEN({__TOKEN_CFETCH_PUSH_CFETCH_CADD_PUSH_CSTORE},{c@ $1 c@ c+ $2 c!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CFETCH_PUSH_CFETCH_CADD_PUSH_CSTORE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing two address parameters!},
$2,{},{
__{}__{}.error {$0}(): Missing second address parameter!},
__{}$#,{2},{
                        ;[9:47]     __INFO   ( c --  )
    ld    A,__FORM({%-12s},{[$1]}); 3:13      __INFO
    add   A,[HL]        ; 1:7       __INFO
    ld  format({%-16s},__FORM({%s},[$2]){, A}); 3:13      __INFO   [$2] = [$1] + [TOS]
    ex   DE, HL         ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO},
__{}{
__{}__{}.error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl # ( c -- c+n )
dnl # c = c + n
define({PUSH_CADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CADD},{$1 c+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing address parameter!},
__{}$#,{1},,{
__{}__{}.error {$0}($@): $# parameters found in macro!})
ifelse(__HAS_PTR($1),{1},{dnl
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld    A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:13     __INFO
__{}    add   A, L          ; 1:4      __INFO
__{}    ld    L, A          ; 1:4      __INFO},
__IS_NUM($1),{0},{dnl
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld    A, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 2:7      __INFO
__{}    add   A, L          ; 1:4      __INFO
__{}    ld    L, A          ; 1:4      __INFO},
{dnl
__{}ifelse(eval(($1)+3),{0},{dnl
__{}__{}    dec   L             ; 1:4       __INFO   ( c -- c-2 )
__{}__{}    dec   L             ; 1:4       __INFO
__{}__{}    dec   L             ; 1:4       __INFO},
__{}eval(($1)+2),{0},{dnl
__{}__{}    dec   L             ; 1:4       __INFO   ( c -- c-2 )
__{}__{}    dec   L             ; 1:4       __INFO},
__{}__{}eval(($1)+1),{0},{dnl
__{}__{}    dec   L             ; 1:4       __INFO   ( c -- c-1 )},
__{}__{}eval($1),{0},{snl
__{}__{}                        ;           __INFO   ( c -- c+0 )},
__{}__{}eval(($1)-1),{0},{dnl
__{}__{}    inc   L             ; 1:4       __INFO   ( c -- c+1 )},
__{}__{}eval(($1)-2),{0},{dnl
__{}__{}    inc   L             ; 1:4       __INFO   ( c -- c+1 )
__{}__{}    inc   L             ; 1:4       __INFO},
__{}__{}eval(($1)-3),{0},{dnl
__{}__{}    inc   L             ; 1:4       __INFO   ( c -- c+1 )
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   L             ; 1:4       __INFO},
__{}__{}{ifelse(eval((((($1) | 255) + 1) > 256) || (($1 + 256) < 128)),{1},{dnl
__{}__{}__{}    ; warning {$0}($@): Parameter $1 exceeds one byte limit!
__{}__{}__{}}){}dnl
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   ( d -- d+$1 )
__{}__{}    add   A, L          ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO}){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( c0 -- c1 )  c1 = abs(c0)
define({CABS},{dnl
__{}__ADD_TOKEN({__TOKEN_CABS},{cabs},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CABS},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO   ( c0 -- c1 )  c1 = abs(c0)
    sub   L             ; 1:4       __INFO
    jp    m, $+4        ; 3:10      __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )
dnl # x = 256*(hi(x1)+hi(x2)) + lo(x1)
define({HABS},{dnl
__{}__ADD_TOKEN({__TOKEN_HABS},{habs},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HABS},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO   ( h0 -- h1 )  h1 = abs(h0)
    sub   H             ; 1:4       __INFO
    jp    m, $+4        ; 3:10      __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( c0 -- -c0 )
define({CNEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_CNEGATE},{cnegate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CNEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO   ( c0 -- -c0 )
    sub   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( h0 -- -h0 )
define({HNEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_HNEGATE},{hnegate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HNEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO   ( h0 -- -h0 )
    sub   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl
dnl ---------------------------------------------------------------------------
dnl ## 16bit & 32bit mix Arithmetic
dnl ---------------------------------------------------------------------------
dnl
dnl
dnl
dnl # S>D
dnl # ( x1 -- sign(x1) x1 )
define({S_TO_D},{dnl
__{}__ADD_TOKEN({__TOKEN_S_TO_D},{s_to_d},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_S_TO_D},{dnl
__{}define({__INFO},{s_to_d}){}dnl

    push DE             ; 1:11      S>D   ( x -- d ) == ( x -- sign(x) x )
    ld    A, H          ; 1:4       S>D
    add   A, A          ; 1:4       S>D
    sbc   A, A          ; 1:4       S>D
    ld    D, A          ; 1:4       S>D
    ld    E, A          ; 1:4       S>D}){}dnl
dnl
dnl
dnl
dnl # D>S
dnl # ( 0 x1 -- x1 )
define({D_TO_S},{dnl
__{}__ADD_TOKEN({__TOKEN_D_TO_S},{d_to_s},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D_TO_S},{dnl
__{}define({__INFO},{d_to_s}){}dnl

    pop  DE             ; 1:10      D>S   ( d -- x ) == ( 0 lo -- lo )}){}dnl
dnl
dnl
dnl
dnl # ( hi lo x -- d2 ) == ( d x -- d2 )  d2 = d + x
define({MADD},{dnl
__{}__ADD_TOKEN({__TOKEN_MADD},{m+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MADD},{dnl
__{}define({__INFO},{m+}){}dnl

                        ;[11:57]    M+   ( d x -- d2 )  d2 = d + x
    ld    A, H          ; 1:4       M+
    add   A, A          ; 1:4       M+
    sbc   A, A          ; 1:4       M+   0xFF or 0x00
    ld    C, A          ; 1:4       M+   d2 = d + CCHL
    add  HL, DE         ; 1:11      M+   lo16(d)+x
    pop  DE             ; 1:10      M+
    adc   A, E          ; 1:4       M+
    ld    E, A          ; 1:4       M+
    ld    A, C          ; 1:4       M+
    adc   A, D          ; 1:4       M+
    ld    D, A          ; 1:4       M+   hi16(d)+hi16(x)}){}dnl
dnl
dnl
dnl
dnl # ( d n -- floored_remainder floored_quotient )
define({FMDIVMOD},{dnl
__{}__ADD_TOKEN({__TOKEN_FMDIVMOD},{fm/mod},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_FMDIVMOD},{dnl
__{}define({__INFO},{fm/mod}){}dnl
define({USE_F32DIV16},{})
    pop  BC             ; 1:10      {FM/MOD}   ( d n -- floored_remainder floored_quotient )
    call F32DIV16       ; 3:17      {FM/MOD}}){}dnl
dnl
dnl
dnl
dnl # ( d n -- symmetric_remander symmetric_quotient )
define({SMDIVREM},{dnl
__{}__ADD_TOKEN({__TOKEN_SMDIVREM},{sm/rem},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SMDIVREM},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}define({USE_S32DIV16},{})
__{}__{}    pop  BC             ; 1:10      __INFO   ( d n -- symmetric_remander symmetric_quotient )
__{}__{}    call S32DIV16       ; 3:17      __INFO
}){}dnl
dnl
dnl
dnl
dnl # ( ud u -- remainder quotient )
define({UMDIVMOD},{dnl
__{}__ADD_TOKEN({__TOKEN_UMDIVMOD},{um/mod},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMDIVMOD},{dnl
__{}define({__INFO},{um/mod}){}dnl
define({USE_U32DIV16},{})
    pop  BC             ; 1:10      {UM/MOD}   ( ud u -- remainder quotient )
    call U32DIV16       ; 3:17      {UM/MOD}}){}dnl
dnl
dnl
dnl
dnl # ( x1 x2 -- d )
define({MMUL},{dnl
__{}__ADD_TOKEN({__TOKEN_MMUL},{m*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MMUL},{dnl
__{}define({__INFO},{m*}){}dnl
define({USE_S16MUL},{})
    call S16MUL         ; 3:17      M*   ( x1 x2 -- d )}){}dnl
dnl
dnl
dnl
dnl # ( u1 u2 -- ud )
define({UMMUL},{dnl
__{}__ADD_TOKEN({__TOKEN_UMMUL},{um*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UMMUL},{dnl
__{}define({__INFO},{um*}){}dnl
define({USE_U16MUL},{})
    call U16MUL         ; 3:17      UM*   ( u1 u2 -- ud )}){}dnl
dnl
dnl
dnl
dnl # ( n1 n2 n3 -- n1*n2%n3 n1*n2/n3 )
define({MULDIVMOD},{dnl
__{}__ADD_TOKEN({__TOKEN_MULDIVMOD},{*/mod},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MULDIVMOD},{dnl
__{}define({__INFO},{*/mod}){}dnl
__{}__def({USE_S32DIV16}){}dnl
__{}__def({USE_S16MUL},{})
    ex  [SP],HL         ; 1:19      {*/MOD}   ( n1 n2 n3 -- n1*n2%n3 n1*n2/n3 )
    call S16MUL         ; 3:17      {*/MOD}
    ex   DE, HL         ; 1:4       {*/MOD}
    ex  [SP],HL         ; 1:19      {*/MOD}
    call S32DIV16       ; 3:17      {*/MOD}}){}dnl
dnl
dnl
dnl
dnl # ( n1 n2 n3 -- n1*n2/n3 )
define({MULDIV},{dnl
__{}__ADD_TOKEN({__TOKEN_MULDIV},{*/},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_MULDIV},{dnl
__{}define({__INFO},{*/}){}dnl
__{}__def({USE_S32DIV16}){}dnl
__{}__def({USE_S16MUL},{})
    ex  [SP],HL         ; 1:19      {*/}   ( n1 n2 n3 -- n1*n2/n3 )
    call S16MUL         ; 3:17      {*/}
    ex   DE, HL         ; 1:4       {*/}
    ex  [SP],HL         ; 1:19      {*/}
    call S32DIV16       ; 3:17      {*/}
    pop  DE             ; 1:10      {*/}}){}dnl
dnl
dnl
dnl
dnl ---------------------------------------------------------------------------
dnl ## 32bit Arithmetic ( DE = hi, HL = lo )
dnl ---------------------------------------------------------------------------
dnl
dnl
dnl
dnl # ( hi2 lo2 hi1 lo1 -- d2+d1 )
dnl # d = d2 + d1
define({DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_DADD},{d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DADD},{dnl
__{}define({__INFO},{d+}){}dnl

    pop  BC             ; 1:10      D+   ( hi2 lo2 hi1 lo1 -- d2+d1 )
    add  HL, BC         ; 1:11      D+   lo1+lo2
    ex   DE, HL         ; 1:4       D+
    pop  BC             ; 1:10      D+
    adc  HL, BC         ; 2:15      D+   hi1+hi2
    ex   DE, HL         ; 1:4       D+}){}dnl
dnl
dnl 2dup 2@ rot 2@ d+ 2over nip 2!
dnl # ( pd2 pd1 -- pd2 pd1 )
dnl # [pd1] += [pd2]
define({PDADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PDADD},{pd+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( pd2 pd1 -- pd2 pd1 )  [pd1] += [pd2] with align 4
    add   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    ld    B, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    adc   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    adc   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    adc   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    E, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( d -- d+n )
dnl # d = d + n
define({PUSHDOT_DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHDOT_DADD},{$1. d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSHDOT_DADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing address parameter!},
__{}$#,{1},,{
__{}__{}.error {$0}($@): $# parameters found in macro!})
ifelse(__HAS_PTR($1),{1},{dnl
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},($1+2)); 4:20      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($1),{0},{dnl
__{}    .error {$0}($@): The condition $1 cannot be evaluated},
{ifelse(dnl
__{}__{}eval(($1)+3*256*256*256),{0},{dnl
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-3*2^24 )
__{}__{}    dec   D             ; 1:4       __INFO
__{}__{}    dec   D             ; 1:4       __INFO},
__{}__{}eval(($1)+2*256*256*256),{0},{dnl
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-2^25 )
__{}__{}    dec   D             ; 1:4       __INFO},
__{}__{}eval(($1)+1*256*256*256),{0},{dnl
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-2^24 )},
__{}__{}eval(($1)+5*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-5*2^16 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+4*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^18 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+3*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-3*2^16 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+2*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^17 )
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+1*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^16 )},
__{}__{}eval(($1)+2*256),{0},{dnl
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-2^9 )
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    sub   H             ; 1:4       __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(($1)+1*256),{0},{dnl
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-2^8 )
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    sub   H             ; 1:4       __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(((($1) & 0xFFFF0000) == 0xFFFF0000) && ((($1) & 0xFF) == 0)),{1},{dnl
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   ( d -- d+$1 )
__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(($1)+2),{0},{dnl
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-2 )
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    sub   H             ; 1:4       __INFO   lo(d)-lo(d-2)
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(($1)+1),{0},{dnl
__{}__{}    ld    A, L          ; 1:4       __INFO   ( d -- d-1 )
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval($1),{0},{snl
__{}__{}                        ;           __INFO   ( d -- d+0 )},
__{}__{}eval(($1)-1),{0},{dnl
__{}__{}    inc  HL             ; 1:6       __INFO   lo++
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}eval(($1)-256),{0},{dnl
__{}__{}    inc   H             ; 1:4       __INFO   ( d -- d+256 )
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}eval(($1) & 0xFFFF00FF),{0},{dnl
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   ( d -- d+$1 )
__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}eval(($1)-1*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^16 )},
__{}__{}eval(($1)-2*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^17 )
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-3*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+3*2^16 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-4*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^18 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-5*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+5*2^16 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-1*256*256*256),{0},{dnl
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+2^24 )},
__{}__{}eval(($1)-2*256*256*256),{0},{dnl
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+2^25 )
__{}__{}    inc   D             ; 1:4       __INFO},
__{}__{}eval(($1)-3*256*256*256),{0},{dnl
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+3*2^24 )
__{}__{}    inc   D             ; 1:4       __INFO
__{}__{}    inc   D             ; 1:4       __INFO},
__{}__{}eval(($1) & 0xFFFFFF),{0},{dnl
__{}__{}    ld    A, __HEX_D($1)       ; 2:7       __INFO   ( d -- d+$1 )
__{}__{}    add   A, D          ; 1:4       __INFO
__{}__{}    ld    D, A          ; 1:4       __INFO},
__{}__{}eval(($1) & 0xFFFF),{0},{dnl
__{}__{}    ld   BC, __HEX_DE($1)     ; 3:10      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO},
__{}__{}__HEX_DE($1),{0x0000},{dnl
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO   ( d -- d+$1 )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}__HEX_DE($1),{0x0001},{dnl
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO   ( d -- d+$1 )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}__HEX_DE($1),{0xFFFF},{dnl
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO   ( d -- d{}$1 )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}__HEX_DE($1),{0xFFFE},{dnl
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO   ( d -- d{}$1 )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}{dnl
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   BC, __HEX_DE($1)     ; 3:10      __INFO
__{}__{}    adc  HL, BC         ; 2:15      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( d -- d+n )
dnl # d = d + n
define({PUSH2_DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DADD},{$1 $2 d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DADD},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),1,{
__{}__{}.error {$0}($@): Missing address parameter!},
__{}eval($#>2),{1},{
__{}__{}.error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1):__HAS_PTR($2),{1:1},{
__{}    ; warning {$0}($@): The conditions $1 and $2 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__HAS_PTR($1),{1},{
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__HAS_PTR($2):_TYP_DOUBLE,{1:small},{
__{}    ; warning {$0}($@): The condition $2 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__HAS_PTR($2),{1},{
__{}    ; warning {$0}($@): The condition $2 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ld    A, __FORM({%-11s},low $1); 2:7       __INFO
__{}    adc   A, E          ; 1:4       __INFO
__{}    ld    E, A          ; 1:4       __INFO
__{}    ld    A, __FORM({%-11s},high $1); 2:7       __INFO
__{}    adc   A, D          ; 1:4       __INFO
__{}    ld    D, A          ; 1:4       __INFO},
__IS_NUM($1):__IS_NUM($2),{0:0},{
__{}    ; warning {$0}($@): The conditions $1 and $2 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($1),{0},{
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($2),{0},{
__{}    ; warning {$0}($@): The condition $2 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($2); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
{dnl
__{}ifelse(dnl
__{}__HEX_HL($1):__HEX_HL($2),{0xFD00:0x0000},{
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-3*2^24 )
__{}__{}    dec   D             ; 1:4       __INFO
__{}__{}    dec   D             ; 1:4       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0xFE00:0x0000},{
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-2^25 )
__{}__{}    dec   D             ; 1:4       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0xFF00:0x0000},{
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-2^24 )},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFB:0x0000},{
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-5*2^16 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFC:0x0000},{
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^18 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFD:0x0000},{
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-3*2^16 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFE:0x0000},{
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^17 )
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFF:0x0000},{
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^16 )},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFF:0xFF00},{
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-2^8 )
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    sub   H             ; 1:4       __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__HEX_HL($1):__HEX_L($2),{0xFFFF:0x00},{
__{}__{}    ld    A, __HEX_H($2)       ; 2:7       __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFF:0xFFFE},{
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-2 )
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    sub   H             ; 1:4       __INFO   lo(d)-lo(d-2)
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__HEX_HL($1):__HEX_HL($2),{0xFFFF:0xFFFF},{
__{}__{}    ld    A, L          ; 1:4       __INFO   ( d -- d-1 )
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__HEX_HL($1):__HEX_HL($2),{0x0000:0x0000},{
__{}__{}                        ;           __INFO   ( d -- d+0 )},
__{}__HEX_HL($1):__HEX_HL($2),{0x0000:0x0001},{
__{}__{}    inc  HL             ; 1:6       __INFO   lo++
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__HEX_HL($1):__HEX_HL($2),{0x0000:0x0100},{
__{}__{}    inc   H             ; 1:4       __INFO   ( d -- d+256 )
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__HEX_HL($1):__HEX_L($2),{0x0000:0x00},{
__{}__{}    ld    A, __HEX_H($2)       ; 2:7       __INFO   ( d -- d+__HEX_HL($2) )
__{}__{}    add   A, H          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__HEX_HL($1):__HEX_HL($2),{0x0001:0x0000},{
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^16 )},
__{}__HEX_HL($1):__HEX_HL($2),{0x0002:0x0000},{
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^17 )
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0x0003:0x0000},{
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+3*2^16 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0x0004:0x0000},{
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^18 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0x0005:0x0000},{
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+5*2^16 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0x0100:0x0000},{
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+2^24 )},
__{}__HEX_HL($1):__HEX_HL($2),{0x0200:0x0000},{
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+2^25 )
__{}__{}    inc   D             ; 1:4       __INFO},
__{}__HEX_HL($1):__HEX_HL($2),{0x0300:0x0000},{
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+3*2^24 )
__{}__{}    inc   D             ; 1:4       __INFO
__{}__{}    inc   D             ; 1:4       __INFO},
__{}__HEX_L($1):__HEX_HL($2),{0x00:0x0000},{
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add   A, D          ; 1:4       __INFO
__{}__{}    ld    D, A          ; 1:4       __INFO},
__{}__HEX_HL($2),{0x0000},{
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO},
__{}__HEX_HL($1),{0x0000},{
__{}__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__HEX_HL($1),{0x0001},{
__{}__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__HEX_HL($1),{0xFFFF},{
__{}__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__HEX_HL($1),{0xFFFE},{
__{}__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}{
__{}__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO   ( d -- d+__HEX_DEHL(__HEX_HL($1)*65536+__HEX_HL($2)) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO{}define({_TMP_INFO},__INFO){}__LD_REG16({BC},$1,{BC},$2){}dnl
__{}__{}__CODE_16BIT
__{}__{}    adc  HL, BC         ; 2:15      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # "2dup D+"
dnl # ( hi1 lo1 -- d1 d1+d1 )
dnl # d0 = d1 + d1
define({_2DUP_DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_DADD},{2dup_d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_DADD},{dnl
__{}define({__INFO},{2dup_d+}){}dnl

    push  DE            ; 1:11      2dup D+   ( hi1 lo1 -- hi1 lo1 hi1+hi1+carry lo1+lo1 )
    push  HL            ; 1:11      2dup D+
    add  HL, HL         ; 1:11      2dup D+
    ex   DE, HL         ; 1:4       2dup D+
    adc  HL, HL         ; 2:15      2dup D+
    ex   DE, HL         ; 1:4       2dup D+}){}dnl
dnl
dnl
dnl # 2swap D+
dnl # ( d2 d1 -- d1+d2 )
dnl # ( hi2 lo2 hi1 lo1 -- hi1+hi2+carry lo1+lo2 )
define({_2SWAP_DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2SWAP_DADD},{2swap_d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2SWAP_DADD},{dnl
__{}define({__INFO},{2swap_d+}){}dnl

                        ;[7:54]     2swap D+   ( hi2 lo2 hi1 lo1 -- hi1+hi2+carry lo1+lo2 )
    pop  BC             ; 1:10      2swap D+   lo2
    add  HL, BC         ; 1:11      2swap D+
    ex   DE, HL         ; 1:4       2swap D+
    pop  BC             ; 1:10      2swap D+   hi2
    adc  HL, BC         ; 2:15      2swap D+
    ex   DE, HL         ; 1:4       2swap D+}){}dnl
dnl
dnl
dnl # 2over D+
dnl # ( d2 d1 -- d2 d1+d2 )
dnl # ( hi2 lo2 hi1 lo1 -- hi2 lo2 hi1+hi2+carry lo1+lo2 )
define({_2OVER_DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2OVER_DADD},{2over d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2OVER_DADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[9:93]     __INFO   ( hi2 lo2 hi1 lo1 -- hi2 lo2 hi1+hi2+carry lo1+lo2 )
    pop  BC             ; 1:10      __INFO   lo2
    add  HL, BC         ; 1:11      __INFO
    ex  [SP],HL         ; 1:19      __INFO   hi2
    ex   DE, HL         ; 1:4       __INFO
    adc  HL, DE         ; 2:15      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ex  [SP],HL         ; 1:19      __INFO
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 2over D+ 2swap
dnl # ( d2 d1 -- d3 d2 )  d3 = d2+d1
dnl # ( h2 l2 h1 l1 -- h3 l3 h2 l2 )
define({_2OVER_DADD_2SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_2OVER_DADD_2SWAP},{2over d+ 2swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2OVER_DADD_2SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[10:97]    __INFO   ( d2 d1 -- d3 d2 )  d3 = d2 + d1
    pop  BC             ; 1:10      __INFO   h2 -- . h1 l1   BC = l2
    add  HL, BC         ; 1:11      __INFO   h2 -- . h1 l3   BC = l2
    ex  [SP],HL         ; 1:19      __INFO   l3 -- . h1 h2   BC = l2
    ex   DE, HL         ; 1:4       __INFO   l3 -- . h2 h1   BC = l2
    adc  HL, DE         ; 2:15      __INFO   l3 -- . h2 h3   BC = l2
    ex  [SP],HL         ; 1:19      __INFO   h3 -- . h2 l3   BC = l2
    push HL             ; 1:11      __INFO   h3 l3 . h2 l3   BC = l2
    ld    L, C          ; 1:4       __INFO
    ld    H, B          ; 1:4       __INFO   h3 l3 . h2 l2}){}dnl
dnl
dnl
dnl
dnl # 2swap 2over D+
dnl # ( d2 d1 -- d1 d3 )  d3 = d2+d1
dnl # ( h2 l2 h1 l1 -- h1 l1 h3 l3 )
define({_2SWAP_2OVER_DADD},{dnl
__{}__ADD_TOKEN({__TOKEN_2SWAP_2OVER_DADD},{2swap 2over d+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2SWAP_2OVER_DADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[10:97]    __INFO   ( d2 d1 -- d1 d3 )  d3 = d2 + d1
    ld    C, L          ; 1:4       __INFO
    ld    B, H          ; 1:4       __INFO   h2 l2 . h1 l1   BC = l1
    pop  HL             ; 1:10      __INFO   h2 -- . h1 l2   BC = l1
    add  HL, BC         ; 1:11      __INFO   h2 -- . h1 l3   BC = l1
    ex  [SP],HL         ; 1:19      __INFO   l3 -- . h1 h2   BC = l1
    adc  HL, DE         ; 2:15      __INFO   l3 -- . h1 h3   BC = l1
    ex   DE, HL         ; 1:4       __INFO   l3 -- . h3 h1   BC = l1
    ex  [SP],HL         ; 1:19      __INFO   h1 -- . h3 l3   BC = l1
    push BC             ; 1:11      __INFO   h1 l1 . h3 l3   BC = l1}){}dnl
dnl
dnl
dnl # ( d2 d1 -- d )
dnl # d = d2 - d1
define({DSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_DSUB},{d-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DSUB},{dnl
__{}define({__INFO},{d-}){}dnl
ifelse(TYP_DSUB,{small},{
                       ;[12:74]     D-   ( hi2 lo2 hi1 lo1 -- d2-d1 )
    ld    B, D          ; 1:4       D-
    ld    C, E          ; 1:4       D-
    ex   DE, HL         ; 1:4       D-   DE = lo1
    pop  HL             ; 1:10      D-   HL = lo2
    or    A             ; 1:4       D-
    sbc  HL, DE         ; 2:15      D-   lo2-lo1
    ex   DE, HL         ; 1:4       D-
    pop  HL             ; 1:10      D-   HL = hi2
    sbc  HL, BC         ; 2:15      D-   hi2-hi1
    ex   DE, HL         ; 1:4       D-}
,{
                       ;[14:68]     D-   ( hi2 lo2 hi1 lo1 -- d2-d1 )
    pop  BC             ; 1:10      D-   BC = lo2
    ld    A, C          ; 1:4       D-
    sub   L             ; 1:4       D-   lo2-lo1
    ld    L, A          ; 1:4       D-
    ld    A, B          ; 1:4       D-
    sbc   A, H          ; 1:4       D-   lo2-lo1
    ld    H, A          ; 1:4       D-
    pop  BC             ; 1:10      D-   BC = hi2
    ld    A, C          ; 1:4       D-
    sbc   A, E          ; 1:4       D-   hi2-hi1
    ld    E, A          ; 1:4       D-
    ld    A, B          ; 1:4       D-
    sbc   A, D          ; 1:4       D-   hi2-hi1
    ld    D, A          ; 1:4       D-})}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 )
dnl # [pd1] = [pd2] - [pd1]
define({PDSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PDSUB},{pd-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( pd2 pd1 -- pd2 pd1 )  [pd1] = [pd2] - [pd1]  with align 4
    sub [HL]            ; 1:7       __INFO
    ld  [HL], A         ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    ld    B, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [HL], A         ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [HL], A         ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [HL], A         ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    E, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 )
dnl # [pd1] -= [pd2]
define({PDSUB_NEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDSUB_NEGATE},{pd- negate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDSUB_NEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO   ( pd2 pd1 -- pd2 pd1 )  [pd1] = -[pd2]  with align 4
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld  [DE],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    ld    B, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [DE],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [DE],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [DE],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    E, B          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd1 pd2 )
dnl # [pd2] = [pd1] - [pd2]
define({SWAP_PDSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_PDSUB},{swap pd-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_PDSUB},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO   ( pd2 pd1 -- pd1 pd2 )  [pd2] = [pd1] - [pd2]  with align 4
    ld    A,[DE]        ; 1:7       __INFO
    sub  [HL]           ; 1:7       __INFO
    ld   [HL], A        ; 1:7       __INFO
    ld     C, L         ; 1:4       __INFO
    ld     B, E         ; 1:4       __INFO
    inc    L            ; 1:4       __INFO
    inc    E            ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld   [HL], A        ; 1:7       __INFO
    inc    L            ; 1:4       __INFO
    inc    E            ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld   [HL], A        ; 1:7       __INFO
    inc    L            ; 1:4       __INFO
    inc    E            ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld   [HL], A        ; 1:7       __INFO
    ld     L, C         ; 1:4       __INFO
    ld     E, B         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # 2swap D-
dnl # ( d2 d1 -- d1-d2 )
define({_2SWAP_DSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_2SWAP_DSUB},{2swap_d-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2SWAP_DSUB},{dnl
__{}define({__INFO},{2swap_d-}){}dnl

                        ;[9:62]     2swap D-   ( hi2 lo2 hi1 lo1 -- d1-d2 )
    or    A             ; 1:4       2swap D-
    pop  BC             ; 1:10      2swap D-   lo2
    sbc  HL, BC         ; 2:15      2swap D-
    ex   DE, HL         ; 1:4       2swap D-
    pop  BC             ; 1:10      2swap D-   hi2
    sbc  HL, BC         ; 2:15      2swap D-
    ex   DE, HL         ; 1:4       2swap D-}){}dnl
dnl
dnl
dnl # 2over D-
dnl # ( d2 d1 -- d2 d1-d2 )
define({_2OVER_DSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_2OVER_DSUB},{2over_d-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2OVER_DSUB},{dnl
__{}define({__INFO},{2over_d-}){}dnl

                        ;[11:101]   2over D-   ( hi2 lo2 hi1 lo1 -- d2 d1-d2 )
    pop  BC             ; 1:10      2over D-   lo2
    or    A             ; 1:4       2over D-
    sbc  HL, BC         ; 2:15      2over D-
    ex  [SP],HL         ; 1:19      2over D-   hi2
    ex   DE, HL         ; 1:4       2over D-
    sbc  HL, DE         ; 2:15      2over D-
    ex   DE, HL         ; 1:4       2over D-
    ex  [SP],HL         ; 1:19      2over D-
    push BC             ; 1:11      2over D-}){}dnl
dnl
dnl
dnl # ( d -- d-n )
dnl # d = d - n
define({PUSHDOT_DSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHDOT_DSUB},{$1. d-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSHDOT_DSUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing address parameter!},
__{}$#,{1},,{
__{}__{}.error {$0}($@): $# parameters found in macro!})
ifelse(__HAS_PTR($1),{1},{dnl
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    or    A, A          ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},($1+2)); 4:20      __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($1),{0},{dnl
__{}    .error {$0}($@): The condition $1 cannot be evaluated},
{ifelse(dnl
__{}__{}eval(($1)+3*256*256*256),{0},{dnl
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+3*2^24 )
__{}__{}    inc   D             ; 1:4       __INFO
__{}__{}    inc   D             ; 1:4       __INFO},
__{}__{}eval(($1)+2*256*256*256),{0},{dnl
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+2^25 )
__{}__{}    inc   D             ; 1:4       __INFO},
__{}__{}eval(($1)+1*256*256*256),{0},{dnl
__{}__{}    inc   D             ; 1:4       __INFO   ( d -- d+2^24 )},
__{}__{}eval(($1)+5*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+5*2^16 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+4*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^18 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+3*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+3*2^16 )
__{}__{}    inc  DE             ; 1:6       __INFO
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+2*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^17 )
__{}__{}    inc  DE             ; 1:6       __INFO},
__{}__{}eval(($1)+1*256*256),{0},{dnl
__{}__{}    inc  DE             ; 1:6       __INFO   ( d -- d+2^16 )},
__{}__{}eval(($1)+256),{0},{dnl
__{}__{}    inc   H             ; 1:4       __INFO   ( d -- d+2^8 )
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}eval(($1)+1),{0},{dnl
__{}__{}    inc  HL             ; 1:6       __INFO   ( d -- d+1 )
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}eval($1),{0},{snl
__{}__{}                        ;           __INFO   ( d -- d+0 )},
__{}__{}eval(($1)-1),{0},{dnl
__{}__{}    ld    A, L          ; 1:4       __INFO   ( d -- d-1 )
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(($1)-2),{0},{dnl
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-2 )
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    dec  HL             ; 1:6       __INFO   lo--
__{}__{}    sub   H             ; 1:4       __INFO   lo(d)-lo(d-2)
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(($1)-256),{0},{dnl
__{}__{}    inc   H             ; 1:4       __INFO   ( d -- d-2^8 )
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--
__{}__{}    dec   H             ; 1:4       __INFO},
__{}__{}eval(($1) & 0xFFFF00FF),{0},{dnl
__{}__{}    ld    A, H          ; 1:4       __INFO   ( d -- d-$1 )
__{}__{}    sub  __HEX_H($1)           ; 2:7       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}eval(($1)-1*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^16 )},
__{}__{}eval(($1)-2*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^17 )
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-3*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-3*2^16 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-4*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-2^18 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-5*256*256),{0},{dnl
__{}__{}    dec  DE             ; 1:6       __INFO   ( d -- d-5*2^16 )
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO
__{}__{}    dec  DE             ; 1:6       __INFO},
__{}__{}eval(($1)-1*256*256*256),{0},{dnl
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-2^24 )},
__{}__{}eval(($1)-2*256*256*256),{0},{dnl
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-2^25 )
__{}__{}    dec   D             ; 1:4       __INFO},
__{}__{}eval(($1)-3*256*256*256),{0},{dnl
__{}__{}    dec   D             ; 1:4       __INFO   ( d -- d-3*2^24 )
__{}__{}    dec   D             ; 1:4       __INFO
__{}__{}    dec   D             ; 1:4       __INFO},
__{}__{}eval(($1) & 0xFFFFFF),{0},{dnl
__{}__{}    ld    A, D          ; 1:4       __INFO   ( d -- d-($1) )
__{}__{}    sub  __HEX_D($1)           ; 2:7       __INFO   ( d -- d-($1) )
__{}__{}    ld    D, A          ; 1:4       __INFO},
__{}__{}eval(($1) & 0xFFFF),{0},{dnl
__{}__{}    ld   BC, __HEX_DE(-($1))     ; 3:10      __INFO   ( d -- d-($1) )
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO},
__{}__{}eval(-($1) & 0xFFFF0000),{0},{dnl
__{}__{}    ld   BC, __HEX_HL(-($1))     ; 3:10      __INFO   ( d -- d-($1) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr   nc, $+3        ; 2:7/12    __INFO
__{}__{}    inc  DE             ; 1:6       __INFO   hi++},
__{}__{}eval((-($1) & 0xFFFF0000) - 0xFFFF0000),{0},{dnl
__{}__{}    ld   BC, __HEX_HL(-($1))     ; 3:10      __INFO   ( d -- d-($1) )
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    jr    c, $+3        ; 2:7/12    __INFO
__{}__{}    dec  DE             ; 1:6       __INFO   hi--},
__{}__{}{dnl
__{}__{}    ld   BC, __HEX_HL(-($1))     ; 3:10      __INFO
__{}__{}    add  HL, BC         ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    ld   BC, __HEX_DE(-($1))     ; 3:10      __INFO
__{}__{}    adc  HL, BC         ; 2:15      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( d -- d-n )
dnl # d = d - n
define({PUSH2_DSUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DSUB},{$1 $2 d-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DSUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),1,{
__{}__{}.error {$0}($@): Missing address parameter!},
__{}eval($#>2),{1},{
__{}__{}.error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1):__HAS_PTR($2),{1:1},{
__{}    ; warning {$0}($@): The conditions $1 and $2 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}    or    A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__HAS_PTR($1):__IS_NUM($2),{1:1},{
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC, __HEX_HL(-($2))     ; 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__HAS_PTR($1),{1},{
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},-($2)); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__HAS_PTR($2),{1},{
__{}    ; warning {$0}($@): The condition $2 cannot be evaluated
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2); 4:20      __INFO
__{}    or    A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($1):__IS_NUM($2),{0:0},{
__{}    ; warning {$0}($@): The conditions $1 and $2 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},-($2)); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($1),{0},{
__{}    ; warning {$0}($@): The condition $1 cannot be evaluated
__{}    ld   BC, __HEX_HL(-($2))     ; 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-(ifelse(eval($2),0,{},{1+})$1))); 3:10      __INFO
__{}    adc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__IS_NUM($2),{0},{
__{}    ; warning {$0}($@): The condition $2 cannot be evaluated
__{}    ld   BC, __FORM({%-11s},-($2)); 3:10      __INFO
__{}    add  HL, BC         ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld   BC, __FORM({%-11s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
{dnl
__{}__ASM_TOKEN_PUSH2_DADD(ifelse(eval($2),0,{__HEX_HL(-($1))},{__HEX_HL(-($1+1))}),__HEX_HL(-($2))){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( d -- ud )
dnl # ( hi lo -- uhi ulo )
dnl # ud is absolute value of d
define({DABS},{dnl
__{}__ADD_TOKEN({__TOKEN_DABS},{dabs},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DABS},{dnl
__{}define({__INFO},{dabs}){}dnl
define({USE_DNEGATE},{})
    ld    A, D          ; 1:4       dabs
    add   A, A          ; 1:4       dabs
    call  c, NEGATE_32  ; 3:17      dabs}){}dnl
dnl
dnl
dnl # ( 5 3 -- 5 )
dnl # ( -5 -3 -- -3 )
dnl # ( hi_2 lo_2 hi_1 lo_1 -- hi_max lo_max )
define({DMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_DMAX},{dmax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DMAX},{dnl
__{}define({__INFO},{dmax}){}dnl
define({USE_DMAX},{})
                        ;[5:141/166]dmax   ( hi_2 lo_2 hi_1 lo_1 -- hi_max lo_max )
    pop  BC             ; 1:10      dmax   BC = lo_2
    pop  AF             ; 1:10      dmax   AF = hi_2
    call MAX_32         ; 3:17      dmax}){}dnl
dnl
dnl
dnl
define({PUSH2_DMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DMAX},{$1 $2 dmax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DMAX},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<2),{1},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1):__HAS_PTR($2),{1:1},{
__{}__{}                       ;[27:92/116] __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    m, $+8        ; 3:10      __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($2,0)); 3:16      __INFO{}dnl
__{}},

__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[25:80/98]  __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld    A, L          ; 1:4       __INFO   num = ($1<<16)+$2
__{}__{}    sub   __FORM({%-14s},$2); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, H          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, __FORM({%-11s},high $2); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, C          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, D          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, B          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+8        ; 3:10      __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 3:10      __INFO{}dnl
__{}},

__{}__HAS_PTR($2),{1},{
__{}__{}                       ;[26:82/106] __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> not carry if num is max (or eq)
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    m, $+8        ; 3:10      __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($2,0)); 3:16      __INFO{}dnl
__{}},
__{}{
__{}__{}                        ;[23:62/82] __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld    A, L          ; 1:4       __INFO   num = ($1<<16)+$2
__{}__{}    sub   __FORM({%-14s},$2); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, H          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, __FORM({%-11s},high $2); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, E          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, __FORM({%-11s},$1); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, D          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, __FORM({%-11s},high $1); 2:7       __INFO   num<DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO{}dnl
__{}__{}ifelse(
__{}__{}__DEC_HL(32768&($1)),{32768},{
__{}__{}__{}    jp    m, $+9        ; 3:10      __INFO   negative constant __HEX_DEHL($1)},
__{}__{}__DEC_HL(32768&($1)),{0},{
__{}__{}__{}    jp    p, $+9        ; 3:10      __INFO   positive constant __HEX_DEHL($1)},
__{}__{}{
__{}__{}__{}  if (32768&($1))
__{}__{}__{}    jp    m, $+9        ; 3:10      __INFO   negative constant __HEX_DEHL($1)
__{}__{}__{}  else
__{}__{}__{}    jp    p, $+9        ; 3:10      __INFO   positive constant __HEX_DEHL($1)
__{}__{}__{}  endif})
__{}__{}    ld   HL, __FORM({%-11s},$2); 3:10      __INFO
__{}__{}    ld   DE, __FORM({%-11s},$1); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( 5 3 -- 3 )
dnl # ( -5 -3 -- -5 )
dnl # ( hi_2 lo_2 hi_1 lo_1 -- hi_min lo_min )
define({DMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_DMIN},{dmin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DMIN},{dnl
__{}define({__INFO},{dmin}){}dnl
define({USE_DMIN},{})
                        ;[5:141/166]dmin   ( hi_2 lo_2 hi_1 lo_1 -- hi_min lo_min )
    pop  BC             ; 1:10      dmin   BC = lo_2
    pop  AF             ; 1:10      dmin   AF = hi_2
    call MIN_32         ; 3:17      dmin}){}dnl
dnl
dnl
dnl
define({PUSH2_DMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DMIN},{$1 $2 dmin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DMIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<2),{1},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1):__HAS_PTR($2),{1:1},{
__{}__{}                       ;[27:92/116] __INFO   ( d -- d2 ) d2 = min(d,num)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+8        ; 3:10      __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($2,0)); 3:16      __INFO{}dnl
__{}},

__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[25:80/98]  __INFO   ( d -- d2 ) d2 = min(d,num)
__{}__{}    ld    A,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 2:7       __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__SIMPLIFY_EXPRESSION(high $2)); 2:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+8        ; 3:10      __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 3:10      __INFO{}dnl
__{}},

__{}__HAS_PTR($2),{1},{
__{}__{}                       ;[26:82/106] __INFO   ( d -- d2 ) d2 = min(d,num)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    jp    p, $+8        ; 3:10      __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($2,0)); 3:16      __INFO{}dnl
__{}},

__{}1,0,{
__{}__{}__MAKE_CODE_2DUP_PUSH2_DLT_CF_STORE($@,{( d2 d1 -- d )  d: dumax(d2,d1)},8,30,8,0,2,7)
__{}__{}    jr   nc, $+8        ; 2:7/12    __INFO
__{}__{}    ld   HL, __FORM({%-11s},$2); 3:10      __INFO
__{}__{}    ld   DE, __FORM({%-11s},$1); 3:10      __INFO{}dnl
__{}},

__{}{
__{}__{}                        ;[23:62/82] __INFO   ( d -- d2 ) d2 = min(d,num)
__{}__{}    ld    A, __FORM({%-11s},$2); 2:7       __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, __FORM({%-11s},high $2); 2:7       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, __FORM({%-11s},$1); 2:7       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, __FORM({%-11s},high $1); 2:7       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO{}dnl
__{}__{}ifelse(
__{}__{}__DEC_HL(32768&($1)),{32768},{
__{}__{}__{}    jp    m, $+9        ; 3:10      __INFO   negative constant __HEX_DEHL($1)},
__{}__{}__DEC_HL(32768&($1)),{0},{
__{}__{}__{}    jp    p, $+9        ; 3:10      __INFO   positive constant __HEX_DEHL($1)},
__{}__{}{
__{}__{}__{}  if (32768&($1))
__{}__{}__{}    jp    m, $+9        ; 3:10      __INFO   negative constant __HEX_DEHL($1)
__{}__{}__{}  else
__{}__{}__{}    jp    p, $+9        ; 3:10      __INFO   positive constant __HEX_DEHL($1)
__{}__{}__{}  endif})
__{}__{}    ld   HL, __FORM({%-11s},$2); 3:10      __INFO
__{}__{}    ld   DE, __FORM({%-11s},$1); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( 5. 3. -- 5. )
dnl # ( 3. 5. -- 5. )
dnl # ( hi_2 lo_2 hi_1 lo_1 -- hi_max lo_max )
define({DUMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_DUMAX},{dumax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUMAX},{
__{}define({__INFO},__COMPILE_INFO){}dnl
                       ;[16:103/83] __INFO   ( du2 du1 -- du )  du = dumax(du2,du1)
    pop  BC             ; 1:10      __INFO   BC = lo_2
    ld    A, L          ; 1:4       __INFO   du1-du2>=0 --> not carry du1 is dumax
    sub   C             ; 1:4       __INFO
    ld    A, H          ; 1:4       __INFO
    sbc   A, B          ; 1:4       __INFO
    ex  [SP],HL         ; 1:19      __INFO
    ld    A, E          ; 1:4       __INFO
    sbc   A, L          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    jr   nc, $+5        ; 2:7/12    __INFO
    ex   DE, HL         ; 1:4       __INFO   carry
    pop  AF             ; 1:10      __INFO   remove lo_1
    push BC             ; 1:11      __INFO   lo_2
    pop  HL             ; 1:10      __INFO   not carry}){}dnl
dnl
dnl
dnl # ( 5. 3. -- 5. 5. )
dnl # ( 3. 5. -- 3. 5. )
dnl # ( hi_2 lo_2 hi_1 lo_1 -- hi_2 lo_2 hi_max lo_max )
define({_2OVER_DUMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_2OVER_DUMAX},{2over dumax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2OVER_DUMAX},{
__{}define({__INFO},__COMPILE_INFO){}dnl
                       ;[18:127/103]__INFO   ( du2 du1 -- du2 du )  du = dumin(du2,du1)
    pop  BC             ; 1:10      __INFO   BC = lo_2
    ld    A, L          ; 1:4       __INFO   du1-du2>=0 --> not carry du1 is dumax
    sub   C             ; 1:4       __INFO
    ld    A, H          ; 1:4       __INFO
    sbc   A, B          ; 1:4       __INFO
    ex  [SP],HL         ; 1:19      __INFO
    ld    A, E          ; 1:4       __INFO
    sbc   A, L          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    jr   nc, $+6        ; 2:7/12    __INFO
    ld    E, L          ; 1:4       __INFO   carry
    ld    D, H          ; 1:4       __INFO   hi_2
    pop  AF             ; 1:10      __INFO   remove lo_1
    push BC             ; 1:11      __INFO   lo_2
    ex  [SP],HL         ; 1:19      __INFO   not carry
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl
define({PUSH2_DUMAX},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DUMAX},{$1 $2 dmax},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DUMAX},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<2),{1},{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1):__HAS_PTR($2),{1:1},{
__{}__{}                       ;[23:101/82] __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num>=DEHL --> num-DEHL>=0 --> not carry if num is max
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num>=DEHL --> num-DEHL>=0 --> not carry if num is max
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num>=DEHL --> num-DEHL>=0 --> not carry if num is max
__{}__{}    sbc   A, E          ; 1:4       __INFO   num>=DEHL --> num-DEHL>=0 --> not carry if num is max
__{}__{}    ld    A, B          ; 1:4       __INFO   num>=DEHL --> num-DEHL>=0 --> not carry if num is max
__{}__{}    sbc   A, D          ; 1:4       __INFO   num>=DEHL --> num-DEHL>=0 --> not carry if num is max
__{}__{}    jr    c, $+7        ; 2:7/12    __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($2,0)); 3:16      __INFO{}dnl
__{}},

__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[21:83/70]  __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld    A, L          ; 1:4       __INFO   num = ($1<<16)+$2
__{}__{}    sub   __FORM({%-14s},$2); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, H          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, __FORM({%-11s},high $2); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, C          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, D          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, B          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    jr   nc, $+7        ; 2:7/12    __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 3:10      __INFO{}dnl
__{}},

__{}__HAS_PTR($2),{1},{
__{}__{}                       ;[21:83/70]  __INFO   ( d -- d2 ) d2 = max(d,num)
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($2,0)); 4:20      __INFO   num = ($1<<16)+$2
__{}__{}    ld    A, L          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sub   C             ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, H          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, B          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    sbc   A, __FORM({%-11s},$1); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    ld    A, D          ; 1:4       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    sbc   A, __FORM({%-11s},high $1); 2:7       __INFO   num>DEHL --> 0>DEHL-num --> carry if num is max
__{}__{}    jr   nc, $+7        ; 2:7/12    __INFO
__{}__{}    ld   DE,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO{}dnl
__{}},

__{}{
__{}__{}__SET_SUMS(8,27){}dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DUGE_CF_STORE($@){}dnl
__{}__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( ud1 -- ud )  ud: dumax(d2,__VIEW_DE_HL($1,$2)){}dnl
__{}__{}__CODE_2DUP_PUSH2_DUGE_CF_STORE
__{}__{}    jr    c, $+8        ; 2:7/12    __INFO
__{}__{}    ld   HL, __FORM({%-11s},$2); 3:10      __INFO
__{}__{}    ld   DE, __FORM({%-11s},$1); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( 5. 3. -- 3. )
dnl # ( 3. 5. -- 3. )
dnl # ( hi_2 lo_2 hi_1 lo_1 -- hi_min lo_min )
define({DUMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_DUMIN},{dumin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUMIN},{
__{}define({__INFO},__COMPILE_INFO){}dnl
                       ;[16:103/83] __INFO   ( du2 du1 -- du )  du = dumin(du2,du1)
    pop  BC             ; 1:10      __INFO   BC = lo_2
    ld    A, C          ; 1:4       __INFO   0<=du2-du1 --> not carry du1 is dumin
    sub   L             ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    ex  [SP],HL         ; 1:19      __INFO
    ld    A, L          ; 1:4       __INFO
    sbc   A, E          ; 1:4       __INFO
    ld    A, H          ; 1:4       __INFO
    sbc   A, D          ; 1:4       __INFO
    jr   nc, $+5        ; 2:7/12    __INFO
    ex   DE, HL         ; 1:4       __INFO   carry
    pop  AF             ; 1:10      __INFO   remove lo_1
    push BC             ; 1:11      __INFO   lo_2
    pop  HL             ; 1:10      __INFO   not carry}){}dnl
dnl
dnl
dnl # ( 5. 3. -- 5. 3. )
dnl # ( 3. 5. -- 3. 3. )
dnl # ( hi_2 lo_2 hi_1 lo_1 -- hi_2 lo_2 hi_min lo_min )
define({_2OVER_DUMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_2OVER_DUMIN},{2over dumin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2OVER_DUMIN},{
__{}define({__INFO},__COMPILE_INFO){}dnl
                       ;[18:127/103]__INFO   ( du2 du1 -- du2 du )  du = dumin(du2,du1)
    pop  BC             ; 1:10      __INFO   BC = lo_2
    ld    A, C          ; 1:4       __INFO   0<=du2-du1 --> not carry du1 is dumin
    sub   L             ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    ex  [SP],HL         ; 1:19      __INFO
    ld    A, L          ; 1:4       __INFO
    sbc   A, E          ; 1:4       __INFO
    ld    A, H          ; 1:4       __INFO
    sbc   A, D          ; 1:4       __INFO
    jr   nc, $+6        ; 2:7/12    __INFO
    ld    E, L          ; 1:4       __INFO   carry
    ld    D, H          ; 1:4       __INFO   hi_2
    pop  AF             ; 1:10      __INFO   remove lo_1
    push BC             ; 1:11      __INFO   lo_2
    ex  [SP],HL         ; 1:19      __INFO   not carry
    push BC             ; 1:11      __INFO}){}dnl
dnl
dnl
dnl
define({PUSH2_DUMIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DUMIN},{$1 $2 dumin},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DUMIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<2),{1},{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1):__HAS_PTR($2),{1:1},{
__{}__{}                       ;[23:101/82] __INFO   ( ud -- ud2 ) d2 = dumin(ud,num)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    jr   nc, $+7        ; 2:7/12    __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($2,0)); 3:16      __INFO{}dnl
__{}},

__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[21:83/70]  __INFO   ( ud -- ud2 ) d2 = dumin(ud,num)
__{}__{}    ld    A,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 2:7       __INFO   num = ($1<<16)+$2
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__SIMPLIFY_EXPRESSION(high $2)); 2:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    jr   nc, $+7        ; 2:7/12    __INFO
__{}__{}    ld    D, B          ; 1:4       __INFO
__{}__{}    ld    E, C          ; 1:4       __INFO
__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($2)); 3:10      __INFO{}dnl
__{}},

__{}__HAS_PTR($2),{1},{
__{}__{}                       ;[21:83/70]  __INFO   ( ud -- ud2 ) d2 = dumin(ud,num)
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($2,0)); 4:20      __INFO   num = ($1<<16)+$2
__{}__{}    ld    A, C          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sub   L             ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A, B          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    sbc   A, H          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 2:7       __INFO
__{}__{}    sbc   A, E          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    ld    A,__FORM({%-12s},__SIMPLIFY_EXPRESSION(high $1)); 2:7       __INFO
__{}__{}    sbc   A, D          ; 1:4       __INFO   num<DEHL --> num-DEHL<0 --> carry if num is min
__{}__{}    jr   nc, $+7        ; 2:7/12    __INFO
__{}__{}    ld   DE,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:10      __INFO
__{}__{}    ld    H, B          ; 1:4       __INFO
__{}__{}    ld    L, C          ; 1:4       __INFO{}dnl
__{}},

__{}{
__{}__{}__SET_SUMS(8,27){}dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DULE_CF_STORE($@){}dnl
__{}__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( ud1 -- ud )  ud: dumin(d2,__VIEW_DE_HL($1,$2)){}dnl
__{}__{}__CODE_2DUP_PUSH2_DULE_CF_STORE
__{}__{}    jr    c, $+8        ; 2:7/12    __INFO
__{}__{}    ld   HL, __FORM({%-11s},$2); 3:10      __INFO
__{}__{}    ld   DE, __FORM({%-11s},$1); 3:10      __INFO{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( d -- -d )
define({DNEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_DNEGATE},{dnegate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DNEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}define({USE_DNEGATE},{})
__{}                        ;[3:79]     __INFO   ( hi lo -- -hi -lo )
__{}    call NEGATE_32      ; 3:17      __INFO{}dnl
}){}dnl
dnl
dnl
dnl # ( pd -- pd )
define({PDNEGATE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDNEGATE},{pdnegate},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDNEGATE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO   ( pd -- pd )  [pd] = -[pd]  with align 4
    ld    B, A          ; 1:4       __INFO
    sub [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( p1 -- p1 )
dnl # [p1] = -[p1]
define({PNEGATE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PNEGATE},{pnegate{}eval(($1)*8)},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PNEGATE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    xor   A             ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    xor   A             ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A,0x00        ; 2:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    xor   A             ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    ld    B, A          ; 1:4       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A, B          ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A, B          ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    xor   A             ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    ld    B, A          ; 1:4       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A, B          ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A, B          ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A, B          ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO},
__{}eval($1),5,{
__{}                       ;format({%-11s},[14:eval(28+38*$1)]) __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    xor   A             ; 1:4       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO
__{}    ld    A, 0x00       ; 2:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    xor   A             ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    ld    B, A          ; 1:4       __INFO
__{}    ld    C, A          ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    ld    A, C          ; 1:4       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO},
__{}{
__{}                       ;format({%-11s},[14:eval(44+35*$1)]) __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] = -[p{}eval(8*($1))] with align $1
__{}    xor   A             ; 1:4       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    push HL             ; 1:11      __INFO
__{}    ld   BC, __HEX_HL(__HEX_L($1-1)*256)     ; 3:10      __INFO
__{}    ld    A, C          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    pop  HL             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl # "D1+"
dnl # ( d -- d+1 )
define({D1ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_D1ADD},{d1+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D1ADD},{dnl
__{}define({__INFO},{d1+}){}dnl

    inc  HL             ; 1:6       D1+   lo word
    ld    A, L          ; 1:4       D1+
    or    H             ; 1:4       D1+
    jr   nz, $+3        ; 2:7/12    D1+
    inc  DE             ; 1:6       D1+   hi word}){}dnl
dnl
dnl
dnl # "2dup 2@ d1+ 2!" but with pointer
dnl # ( pd -- pd )  [pd] += 1
define({PD1ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_PD1ADD},{pd1+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PD1ADD},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc  [HL]           ; 1:11      __INFO   ( pd -- pd )  [pd] += 1 with align 4
    jr    nz, $+14      ; 2:7/12    __INFO
    ld     C, L         ; 1:4       __INFO
    inc    L            ; 1:4       __INFO
    inc  [HL]           ; 1:11      __INFO
    jr    nz, $+8       ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    inc  [HL]           ; 1:11      __INFO
    jr    nz, $+4       ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    inc  [HL]           ; 1:11      __INFO
    ld     L, C         ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( p1 -- p1 )
dnl # [p1] += 1
define({P1ADD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_P1ADD},{p{}eval(($1)*8) 1+},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_P1ADD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    inc [HL]            ; 1:11      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] += 1  with align $1},
__{}eval($1),2,{
__{}    inc [HL]            ; 1:11      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] += 1  with align $1
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    inc [HL]            ; 1:11      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] += 1  with align $1
__{}    jr    nz, $+10      ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    inc [HL]            ; 1:11      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] += 1  with align $1
__{}    jr   nz, $+14       ; 2:7/12    __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    jr   nz, $+8        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    jr   nz, $+4        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    ld    L, C          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    inc [HL]            ; 1:11      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] += 1  with align $1
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    ld    L, 0x00       ; 2:7       __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] += 1  with align $1
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl # "D1-"
dnl # ( d -- d-1 )
define({D1SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_D1SUB},{d1-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D1SUB},{dnl
__{}define({__INFO},{d1-}){}dnl

    ld    A, L          ; 1:4       D1-   ( d -- d-1 )
    or    H             ; 1:4       D1-
    dec  HL             ; 1:6       D1-   lo word
    jr   nz, $+3        ; 2:7/12    D1-
    dec  DE             ; 1:6       D1-   hi word}){}dnl
dnl
dnl
dnl # "2dup 2@ d1- 2!" but with pointer
dnl # ( pd -- pd )  [pd] -= 1
define({PD1SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_PD1SUB},{pd1-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PD1SUB},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(1,0,{
                ;[19:34,71,100,110] __INFO   ( pd -- pd )  [pd] -= 1 with align 4
    xor   A             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    jr   nz, $+16       ; 2:7/12    __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    jr   nz, $+9        ; 2:7/12    __INFO
    dec [HL]            ; 1:11      __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    jr   nz, $+4        ; 2:7/12    __INFO
    dec [HL]            ; 1:11      __INFO
    inc   L             ; 1:4       __INFO
    dec [HL]            ; 1:11      __INFO
    ld    L, C          ; 1:4       __INFO
    dec [HL]            ; 1:11      __INFO},
1,1,{
                 ;[20:33,66,91,101] __INFO   ( pd -- pd )  [pd] -= 1 with align 4
    ld    A, 0xFF       ; 2:7       __INFO
    add   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    jr    c, $+16       ; 2:7/12    __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    add   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    jr    c, $+9        ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    add   A,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    jr    c, $+4        ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    dec [HL]            ; 1:11      __INFO
    ld    L, C          ; 1:4       __INFO},
1,0,{
                ;[20:34,67,100,114] __INFO   ( pd -- pd )  [pd] -= 1 with align 4
    xor    A            ; 1:4       __INFO
    or     A,[HL]       ; 1:7       __INFO
    jr    nz, $+17      ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    or   [HL]           ; 1:7       __INFO
    jr    nz, $+11      ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    or   [HL]           ; 1:7       __INFO
    jr    nz, $+5       ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    dec    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    dec    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    dec    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO},
1,0,{
                ;[21:34,75,108,118] __INFO   ( pd -- pd )  [pd] -= 1 with align 4
    dec  [HL]           ; 1:11      __INFO
    ld     A,[HL]       ; 1:7       __INFO
    inc    A            ; 1:4       __INFO
    jr    nz, $+18      ; 2:7/12    __INFO
    ld     C, L         ; 1:4       __INFO
    inc    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    ld     A,[HL]       ; 1:7       __INFO
    inc    A            ; 1:4       __INFO
    jr     z, $+10      ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    ld     A,[HL]       ; 1:7       __INFO
    inc    A            ; 1:4       __INFO
    jr     z, $+4       ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    ld     L, C         ; 1:4       __INFO},
{
               ;[23:37,74,103,113] __INFO   ( pd -- pd )  [pd] -= 1 with align 4
    ld     B, 0x01      ; 2:7       __INFO
    ld     A,[HL]       ; 1:7       __INFO
    sub    A, B         ; 1:4       __INFO
    ld   [HL],A         ; 1:7       __INFO
    jr    nc, $+18      ; 2:7/12    __INFO
    ld     C, L         ; 1:4       __INFO
    inc    L            ; 1:4       __INFO
    ld     A,[HL]       ; 1:7       __INFO
    sub    A, B         ; 1:4       __INFO
    ld   [HL],A         ; 1:7       __INFO
    jr     z, $+10      ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    ld     A,[HL]       ; 1:7       __INFO
    sub    A, B         ; 1:4       __INFO
    ld   [HL],A         ; 1:7       __INFO
    jr     z, $+4       ; 2:7/12    __INFO
    inc    L            ; 1:4       __INFO
    dec  [HL]           ; 1:11      __INFO
    ld     L, C         ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p1 -- p1 )
dnl # [p1] -= 1
define({P1SUB},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_P1SUB},{p{}eval(($1)*8) 1-},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_P1SUB},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    dec [HL]            ; 1:11      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] -= 1  with align $1},
__{}eval($1),2,{
__{}    ld    A, 0xFF       ; 2:7       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] -= 1  with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    dec [HL]            ; 1:11      __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A, 0xFF       ; 2:7       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] -= 1  with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+11       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc [HL]            ; 1:11      __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),4,{
__{}                 ;[20:33,66,91,101] __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] -= 1  with align $1
__{}    ld    A, 0xFF       ; 2:7       __INFO
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+16       ; 2:7/12    __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+9        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+4        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    dec [HL]            ; 1:11      __INFO
__{}    ld    L, C          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ld    A, 0xFF       ; 2:7       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] -= 1  with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+5        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO
__{}    ld    L, 0x00       ; 2:7       __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] -= 1  with align $1
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A, 0xFF       ; 2:7       __INFO
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    jr    c, $+4        ; 2:7/12    __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl # "D2+"
dnl # ( d -- d+2 )
define({D2ADD},{dnl
__{}__ADD_TOKEN({__TOKEN_D2ADD},{d2+},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D2ADD},{dnl
__{}define({__INFO},{d2+}){}dnl

    ld   BC, 0x0002     ; 3:10      D2+   ( d -- d+2 )
    add  HL, BC         ; 1:11      D2+   lo word
    jr   nc, $+3        ; 2:7/12    D2+
    inc  DE             ; 1:6       D2+   hi word}){}dnl
dnl
dnl
dnl # "D2-"
dnl # ( d -- d-2 )
define({D2SUB},{dnl
__{}__ADD_TOKEN({__TOKEN_D2SUB},{d2-},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D2SUB},{dnl
__{}define({__INFO},{d2-}){}dnl

    ld    A, H          ; 1:4       D2-   ( d -- d-2 )
    dec  HL             ; 1:6       D2-   lo word
    dec  HL             ; 1:6       D2-   lo word
    sub   H             ; 1:4       D2-
    jr   nc, $+3        ; 2:7/12    D2-
    dec  DE             ; 1:6       D2-   hi word}){}dnl
dnl
dnl
dnl # "D2*"
dnl # ( d -- d*2 )
define({D2MUL},{dnl
__{}__ADD_TOKEN({__TOKEN_D2MUL},{d2*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D2MUL},{dnl
__{}define({__INFO},{d2*}){}dnl

    add  HL, HL         ; 1:11      D2*   lo word
    rl    E             ; 2:8       D2*
    rl    D             ; 2:8       D2*   hi word}){}dnl
dnl
dnl
dnl # "D2/"
dnl # ( d -- d/2 )
define({D2DIV},{dnl
__{}__ADD_TOKEN({__TOKEN_D2DIV},{d2/},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D2DIV},{dnl
__{}define({__INFO},{d2/}){}dnl

    sra   D             ; 2:8       D2/   with sign
    rr    E             ; 2:8       D2/
    rr    H             ; 2:8       D2/
    rr    L             ; 2:8       D2/}){}dnl
dnl
dnl
dnl # "D256*"
dnl # ( d -- d*256 )
define({D256MUL},{dnl
__{}__ADD_TOKEN({__TOKEN_D256MUL},{d256*},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D256MUL},{dnl
__{}define({__INFO},{d256*}){}dnl

    ld    D, E          ; 1:4       D256*
    ld    E, H          ; 1:4       D256*
    ld    H, L          ; 1:4       D256*
    ld    L, 0x00       ; 2:7       D256*}){}dnl
dnl
dnl
dnl # "D256/"
dnl # ( d -- d/256 )
define({D256DIV},{dnl
__{}__ADD_TOKEN({__TOKEN_D256DIV},{d256/},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D256DIV},{dnl
__{}define({__INFO},{d256/}){}dnl

    ld    L, H          ; 1:4       D256/
    ld    H, E          ; 1:4       D256/
    ld    E, D          ; 1:4       D256/
    rl    D             ; 2:8       D256/   with sign
    sbc   A, A          ; 1:4       D256/
    ld    D, A          ; 1:4       D256/}){}dnl
dnl
dnl
dnl
dnl
dnl
dnl ---------------------------------------------------------------------------
dnl ## X bit Arithmetic ( DE = [p2], HL = [p1] )
dnl ---------------------------------------------------------------------------
dnl
dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] += [p2]
define({PADD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PADD},{p{}eval(($1)*8)+},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PADD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    or    A             ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] with align $1
__{}    add   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] += [p2] + carry
define({PADC},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PADC},{p{}eval(($1)*8)+c},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PADC},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] + carry  with align $1
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] + carry  with align $1
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] + carry  with align $1
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] + carry  with align $1
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] + carry  with align $1
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] += [p{}eval(8*($1))_2] + carry  with align $1
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    adc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] = [p2] - [p1]
define({PSUB},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PSUB},{p{}eval(8*($1))-},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PSUB},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    or    A             ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] with align $1
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] = [p2] - [p1]
define({PSBC},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PSBC},{p{}eval(8*($1))-c},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PSBC},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] - carry  with align $1
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] - carry  with align $1
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] - carry  with align $1
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] - carry  with align $1
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] - carry  with align $1
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] = [p{}eval(8*($1))_2] - [p{}eval(8*($1))_1] - carry  with align $1
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] -= [p2]
define({PSUB_NEGATE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PSUB_NEGATE},{pd- negate},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PSUB_NEGATE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ex   DE, HL         ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] -= [p{}eval(8*($1))_2] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}eval($1),2,{
__{}    ex   DE, HL         ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] -= [p{}eval(8*($1))_2] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ex   DE, HL         ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] -= [p{}eval(8*($1))_2] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ex   DE, HL         ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] -= [p{}eval(8*($1))_2] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ex   DE, HL         ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] -= [p{}eval(8*($1))_2] with align $1
__{}    or    A             ; 1:4       __INFO
__{}    ld    B, L          ; 1:4       __INFO   = 0
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}{
__{}    ex   DE, HL         ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] -= [p{}eval(8*($1))_2] with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld  [DE],A          ; 1:7       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p3 p2 p1 -- p3 p2 p1 )
dnl # [p1] = [p3] u* [p2]
define({PUMUL},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({USE_PUMUL}){}dnl
__{}ifdef({PUMUL_MIN},{ifelse(eval(PUMUL_MIN>$1),1,{define({PUMUL_MIN},$1)})},{define({PUMUL_MIN},$1)}){}dnl
__{}ifdef({PUMUL_MAX},{ifelse(eval(PUMUL_MAX<$1),1,{define({PUMUL_MAX},$1)})},{define({PUMUL_MAX},$1)}){}dnl
__{}__ADD_TOKEN({__TOKEN_PUMUL},{p{}eval(($1)*8)u*},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUMUL},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO
__{}ifelse(PUMUL_MIN:PUMUL_MAX,1:1,{dnl
__{}__{}    call P8UMUL         ; 3:17      __INFO},
__{}PUMUL_MIN:PUMUL_MAX,2:2,{dnl
__{}__{}    call P16UMUL        ; 3:17      __INFO},
__{}PUMUL_MIN:PUMUL_MAX,256:256,{dnl
__{}__{}    call P2048UMUL      ; 3:17      __INFO},
__{}{dnl
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO
__{}__{}    call PXUMUL         ; 3:17      __INFO})
__{}    push BC             ; 1:11      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] = [p2] / [p1]
dnl # [p2] = [p2] mod [p1]
define({PUDIVMOD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({USE_PUDIVMOD}){}dnl
__{}ifdef({PUDM_MIN},{ifelse(eval(PUDM_MIN>$1),1,{define({PUDM_MIN},$1)})},{define({PUDM_MIN},$1)}){}dnl
__{}ifdef({PUDM_MAX},{ifelse(eval(PUDM_MAX<$1),1,{define({PUDM_MAX},$1)})},{define({PUDM_MAX},$1)}){}dnl
__{}__ADD_TOKEN({__TOKEN_PUDIVMOD},{p{}eval(($1)*8)u/mod},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUDIVMOD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO
__{}ifelse(PUDM_MIN:PUDM_MAX,1:1,{dnl
__{}__{}    call P8UDM          ; 3:17      __INFO},
__{}PUDM_MIN:PUDM_MAX,2:2,{dnl
__{}__{}    call P16UDM         ; 3:17      __INFO},
__{}PUDM_MIN:PUDM_MAX,256:256,{dnl
__{}__{}    call P2048UDM       ; 3:17      __INFO},
__{}eval(PUDM_MIN<=32):eval(PUDM_MAX<=32),1:1,{dnl
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO
__{}__{}    call P256UDM        ; 3:17      __INFO},
__{}{dnl
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO
__{}__{}    call PUDM           ; 3:17      __INFO})
__{}    push BC             ; 1:11      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] = [p2] / [p1]
dnl # [p2] = [p2] mod [p1]
define({PDIVMOD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({USE_PUDIVMOD}){}dnl
__{}define({USE_PDIVMOD}){}dnl
__{}ifdef({PUDM_MIN},{ifelse(eval(PUDM_MIN>$1),1,{define({PUDM_MIN},$1)})},{define({PUDM_MIN},$1)}){}dnl
__{}ifdef({PUDM_MAX},{ifelse(eval(PUDM_MAX<$1),1,{define({PUDM_MAX},$1)})},{define({PUDM_MAX},$1)}){}dnl
__{}__ADD_TOKEN({__TOKEN_PDIVMOD},{p{}eval(($1)*8)/mod},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDIVMOD},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO
__{}ifelse(PUDM_MIN:PUDM_MAX,1:1,{dnl
__{}__{}    call P8DM           ; 3:17      __INFO},
__{}PUDM_MIN:PUDM_MAX,2:2,{dnl
__{}__{}    call P16DM          ; 3:17      __INFO},
__{}PUDM_MIN:PUDM_MAX,256:256,{dnl
__{}__{}    call P2048DM        ; 3:17      __INFO},
__{}{dnl
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO
__{}__{}    call PDM            ; 3:17      __INFO})
__{}    push BC             ; 1:11      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
