dnl ## Logic
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x1 & x2
define({AND},{dnl
__{}__ADD_TOKEN({__TOKEN_AND},{and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_AND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x )  x = x2 & x1
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- )  set zf: x1 & x2
define({AND_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_AND_ZF_STORE},{and zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_AND_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- )  zero_flag: x2 & x1
    and   L             ; 1:4       __INFO
    jr   nz, $+4        ; 2:7/12    __INFO
    ld    A, D          ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # over and
dnl # over swap and
dnl # ( x1 x0 -- x1 x )  x = x0 & x1
define({OVER_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_AND},{over and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_AND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x1 x0 -- x1 x )  x = x0 & x1
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x3 x2 x1 -- x2 x )  x = x1 & x3
define({ROT_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_AND},{rot and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_AND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 x )  x = x1 & x3
    ld    A, C          ; 1:4       __INFO
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x1 -- x3 ) ( R: x2 -- x2 ) x3 = x1 & x2
define({R_FETCH_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_R_FETCH_AND},{r@ and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_R_FETCH_AND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    exx                 ; 1:4       __INFO   ( x1 -- x3 ) ( R: x2 -- x2 ) x3 = x1 & x2
    ld    A,[HL]        ; 1:7       __INFO   lo
    inc   L             ; 1:4       __INFO
    ex   AF, AF'        ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO   hi
    dec   L             ; 1:4       __INFO
    exx                 ; 1:4       __INFO
    and   H             ; 1:4       __INFO   hi
    ld    H, A          ; 1:4       __INFO
    ex   AF, AF'        ; 1:4       __INFO
    and   L             ; 1:4       __INFO   lo
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl #    ( x2 x1 x0 -- x2 x1 x )  x = x0 & x2
define({_2_PICK_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_AND},{2 pick and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_AND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x2 x1 x0 -- x2 x1 x )  x = x0 & x2
    push BC             ; 1:11      __INFO
    ld    A, C          ; 1:4       __INFO
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl #    ( x3 x2 x1 x0 -- x3 x2 x1 x )  x = x0 & x2
define({_3_PICK_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_AND},{3 pick and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_AND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x )  x = x0 & x3
    pop  BC             ; 1:10      __INFO
    push BC             ; 1:11      __INFO
    push AF             ; 1:11      __INFO
    ld    A, C          ; 1:4       __INFO
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # $1 pick and
dnl # ( xn .. x1 x0 -- xn .. x1 x )  x == x0 & xn
define({PUSH_PICK_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_AND},{$1 pick and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_AND},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<1),1,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HEX_HL(0x8000 & ($1)),{0x8000},{
__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0 & x$1
__{}__{}    push HL             ; 1:11      __INFO   pointer version
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    D,[HL]        ; 1:7       __INFO
__{}__{}    pop  HL             ; 1:10      __INFO
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    pop  DE             ; 1:10      __INFO},

__IS_NUM($1),{0},{
__{}__{} if (($1) & 0x8000)
__{}__{}    .error {$0}($@): Parameter is negative!
__{}__{} else
__{}__{}  if (($1) = 0)
__{}__{}                        ;           __INFO   ( x0 -- x0 )
__{}__{}  else
__{}__{}   if (($1) = 1){}dnl
__{}__{}__ASM_TOKEN_OVER_AND
__{}__{}   else
__{}__{}    if (($1) = 2){}dnl
__{}__{}__ASM_TOKEN_2_PICK_AND
__{}__{}    else
__{}__{}     if (($1) = 3){}dnl
__{}__{}__ASM_TOKEN_3_PICK_AND
__{}__{}     else
__{}__{}    ld    A, L          ; 1:4       __INFO   ( $1 .. x1 x0 -- $1 .. x1 x )  x == x0 & $1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-4+2*($1))); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    and [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}     endif
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{
__{}__{}                        ;           __INFO   ( x0 -- x0 )},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_AND},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_AND},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_AND},
__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0 & x$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$1-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    and [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- x&n )
dnl # x = x & n
define({PUSH_AND},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_AND},{$1 and},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_AND},{dnl
__{}define({__INFO},{push_and}){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{
__{}                       ;[10:42]     $1 and   ( x1 -- x )  x = x1 & $1
__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      $1 and
__{}    and   H             ; 1:4       $1 and
__{}    ld    H, A          ; 1:4       $1 and
__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      $1 and
__{}    and   L             ; 1:4       $1 and
__{}    ld    L, A          ; 1:4       $1 and},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__AND_REG16_16BIT({HL},$1){}dnl
})}){}dnl
dnl
dnl
dnl # ( b a -- b&$1 a )
define({SWAP_PUSH_AND_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_PUSH_AND_SWAP},{swap $1 and swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_PUSH_AND_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__AND_REG16_16BIT({DE},$1){}dnl
})}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x1 | x2
define({OR},{dnl
__{}__ADD_TOKEN({__TOKEN_OR},{or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x )  x = x2 | x1
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- )  zero_flag: x1 | x2
define({OR_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_OR_ZF_STORE},{or zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OR_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO   ( x2 x1 -- )  zero_flag: x2 | x1
    or    H             ; 1:4       __INFO
    or    D             ; 1:4       __INFO
    or    E             ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # over or
dnl # over swap or
dnl # ( x1 x0 -- x1 x )  x = x0 | x1
define({OVER_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_OR},{over or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_OR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x1 x0 -- x1 x )  x = x0 | x1
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x3 x2 x1 -- x2 x )  x = x1 | x3
define({ROT_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_OR},{rot or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_OR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 x )  x = x1 | x3
    ld    A, C          ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x1 -- x3 ) ( R: x2 -- x2 ) x3 = x1 | x2
define({R_FETCH_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_R_FETCH_OR},{r@ or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_R_FETCH_OR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    exx                 ; 1:4       __INFO   ( x1 -- x3 ) ( R: x2 -- x2 ) x3 = x1 | x2
    ld    A,[HL]        ; 1:7       __INFO   lo
    inc   L             ; 1:4       __INFO
    ex   AF, AF'        ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO   hi
    dec   L             ; 1:4       __INFO
    exx                 ; 1:4       __INFO
    or    H             ; 1:4       __INFO   hi
    ld    H, A          ; 1:4       __INFO
    ex   AF, AF'        ; 1:4       __INFO
    or    L             ; 1:4       __INFO   lo
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl #    ( x2 x1 x0 -- x2 x1 x )  x = x0 | x2
define({_2_PICK_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_OR},{2 pick or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_OR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x2 x1 x0 -- x2 x1 x )  x = x0 | x2
    push BC             ; 1:11      __INFO
    ld    A, C          ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl #    ( x3 x2 x1 x0 -- x3 x2 x1 x )  x = x0 | x2
define({_3_PICK_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_OR},{3 pick or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_OR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x )  x = x0 | x3
    pop  BC             ; 1:10      __INFO
    push BC             ; 1:11      __INFO
    push AF             ; 1:11      __INFO
    ld    A, C          ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # $1 pick or
dnl # ( xn .. x1 x0 -- xn .. x1 x )  x == x0 | xn
define({PUSH_PICK_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_OR},{$1 pick or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_OR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<1),1,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HEX_HL(0x8000 & ($1)),{0x8000},{
__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0 | x$1
__{}__{}    push HL             ; 1:11      __INFO   pointer version
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    D,[HL]        ; 1:7       __INFO
__{}__{}    pop  HL             ; 1:10      __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    pop  DE             ; 1:10      __INFO},

__IS_NUM($1),{0},{
__{}__{} if (($1) & 0x8000)
__{}__{}    .error {$0}($@): Parameter is negative!
__{}__{} else
__{}__{}  if (($1) = 0)
__{}__{}                        ;           __INFO   ( x0 -- x0 )
__{}__{}  else
__{}__{}   if (($1) = 1){}dnl
__{}__{}__ASM_TOKEN_OVER_OR
__{}__{}   else
__{}__{}    if (($1) = 2){}dnl
__{}__{}__ASM_TOKEN_2_PICK_OR
__{}__{}    else
__{}__{}     if (($1) = 3){}dnl
__{}__{}__ASM_TOKEN_3_PICK_OR
__{}__{}     else
__{}__{}    ld    A, L          ; 1:4       __INFO   ( $1 .. x1 x0 -- $1 .. x1 x )  x == x0 | $1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-4+2*($1))); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    or  [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}     endif
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{
__{}__{}                        ;           __INFO   ( x0 -- x0 )},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_OR},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_OR},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_OR},
__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0 | x$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$1-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    or  [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- x|n )
dnl # x = x | n
define({PUSH_OR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_OR},{$1 or},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_OR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__OR_REG16_16BIT({HL},$1){}dnl
})}){}dnl
dnl
dnl
dnl # ( b a -- b|$1 a )
define({SWAP_PUSH_OR_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_PUSH_OR_SWAP},{swap $1 or swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_PUSH_OR_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__OR_REG16_16BIT({DE},$1){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( x1 u -- x )  x = x1 | 2**u
define({BITSET},{dnl
__{}__ADD_TOKEN({__TOKEN_BITSET},{bitset},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_BITSET},{dnl
__{}define({__INFO},{bitset}){}dnl
__{}ifelse(eval($#>1),{1},{
__{}__{}  .error {$0}($@): $# parameters found in macro!},

__{}_TYP_SINGLE,{fast},{
__{}__{}                       ;[22:91/41]  bitset   ( x1 u -- x )  x = x1 | 2**u
__{}__{}    ld    A, 0xF0       ; 2:7       bitset
__{}__{}    and   L             ; 1:4       bitset
__{}__{}    or    H             ; 1:4       bitset
__{}__{}    ex   DE, HL         ; 1:4       bitset
__{}__{}    jr   nz, $+16       ; 2:7/12    bitset   out of range 0..15
__{}__{}    ld    A, E          ; 1:4       bitset   A = 0000 rnnn
__{}__{}    rlca                ; 1:4       bitset   A = 000r nnn0
__{}__{}    rlca                ; 1:4       bitset   A = 00rn nn00
__{}__{}    add   A, 0xE0       ; 2:7       bitset   A = ???n nn00 carry = r
__{}__{}    ccf                 ; 1:4       bitset   A = ???n nn00 carry = i = 1-r
__{}__{}    adc   A, A          ; 1:4       bitset   A = ??nn n00i
__{}__{}    or   0xC4           ; 2:7       bitset   A = 11nn n101 = set n,L   or   A = 11nn n100 = set n,H
__{}__{}    ld  ($+4), A        ; 3:13      bitset
__{}__{}    set   0, L          ; 2:8       bitset
__{}__{}    pop  DE             ; 1:10      bitset   fast version can be changed with "{define({_TYP_SINGLE},{default})}"{}dnl
__{}},

__{}{
__{}__{}__def({USE_BITSET16}){}dnl
__{}__{}    call BITSET16       ; 3:17      bitset   ( x1 u -- x )  x = x1 | 2**u
__{}__{}    pop  DE             ; 1:10      bitset   default version can be changed with "{define({_TYP_SINGLE},{fast})}"{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- x|2**n )
dnl # x = x | 2**n
define({PUSH_BITSET},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_BITSET},{$1 bitset},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_BITSET},{dnl
__{}define({__INFO},{push_bitset}){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{__def({USE_LSHIFT})
__{}                       ;[19:109]    push_bitset($1)   ( x1 -- x )  x = x1 | 2**$1
__{}    push DE             ; 1:11      push_bitset($1)
__{}    push HL             ; 1:11      push_bitset($1)
__{}    ld   HL, 0x0001     ; 3:10      push_bitset($1)
__{}    ld   HL,__FORM({%-12s},$1); 3:16      push_bitset($1)
__{}    call DE_LSHIFT      ; 3:17      push_bitset($1)   ( x1 u -- ? x2 )  x2 = x1<<u
__{}    pop  DE             ; 1:10      push_bitset($1)
__{}    ld    A, E          ; 1:4       push_bitset($1)   ( x2 x1 -- x )  x = x2 | x1
__{}    or    L             ; 1:4       push_bitset($1)
__{}    ld    L, A          ; 1:4       push_bitset($1)
__{}    ld    A, D          ; 1:4       push_bitset($1)
__{}    or    H             ; 1:4       push_bitset($1)
__{}    ld    H, A          ; 1:4       push_bitset($1)
__{}    pop  DE             ; 1:10      push_bitset($1)},
__IS_NUM($1),{0},{define({_TMP_INFO},{push_bitset($1)})
__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}if (($1)>=0)
__{} if (($1)<8){}dnl
__{}__OR_REG8_8BIT({L},{1<<($1)})
__{} else
__{}  if (($1)<16){}dnl
__{}__OR_REG8_8BIT({H},{1<<($1-8)})
__{}  endif
__{} endif
__{}endif},
{dnl
__{}ifelse(eval(($1)<0),{1},{
__{}__{}  .error {$0}($@): negative parameters found in macro!},
__{}eval(($1)>15),{1},{
__{}__{}  .warning {$0}($@): Out of range zero to 15th bit.},
__{}{define({_TMP_INFO},{push_bitset($1)})
__{}__{}ifelse(
__{}__{}eval(($1)< 8),{1},{__OR_REG8_8BIT({L},eval(1<<($1)))},
__{}__{}eval(($1)<16),{1},{__OR_REG8_8BIT({H},eval(1<<($1-8)))})}){}dnl
})}){}dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # x = x1 ^ x2
define({XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_XOR},{xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x )  x = x2 ^ x1
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- )  set zf: x1 ^ x2
define({XOR_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_XOR_ZF_STORE},{xor zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_XOR_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    or    A             ; 1:4       __INFO   ( x2 x1 -- )  zero_flag: x2 ^ x1
    sbc  HL, DE         ; 2:15      __INFO
    pop  HL             ; 1:10      __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # over xor
dnl # over swap xor
dnl # ( x1 x0 -- x1 x )  x = x0 ^ x1
define({OVER_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_XOR},{over xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x1 x0 -- x1 x )  x = x0 ^ x1
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x3 x2 x1 -- x2 x )  x = x1 ^ x3
define({ROT_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_XOR},{rot xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 x )  x = x1 ^ x3
    ld    A, C          ; 1:4       __INFO
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( x1 -- x3 ) ( R: x2 -- x2 ) x3 = x1 ^ x2
define({R_FETCH_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_R_FETCH_XOR},{r@ xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_R_FETCH_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    exx                 ; 1:4       __INFO   ( x1 -- x3 ) ( R: x2 -- x2 ) x3 = x1 ^ x2
    ld    A,[HL]        ; 1:7       __INFO   lo
    inc   L             ; 1:4       __INFO
    ex   AF, AF'        ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO   hi
    dec   L             ; 1:4       __INFO
    exx                 ; 1:4       __INFO
    xor   H             ; 1:4       __INFO   hi
    ld    H, A          ; 1:4       __INFO
    ex   AF, AF'        ; 1:4       __INFO
    xor   L             ; 1:4       __INFO   lo
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl #    ( x2 x1 x0 -- x2 x1 x )  x = x0 ^ x2
define({_2_PICK_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_XOR},{2 pick xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  BC             ; 1:10      __INFO   ( x2 x1 x0 -- x2 x1 x )  x = x0 ^ x2
    push BC             ; 1:11      __INFO
    ld    A, C          ; 1:4       __INFO
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl #    ( x3 x2 x1 x0 -- x3 x2 x1 x )  x = x0 ^ x2
define({_3_PICK_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_3_PICK_XOR},{3 pick xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3_PICK_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    pop  AF             ; 1:10      __INFO   ( x3 x2 x1 x0 -- x3 x2 x1 x )  x = x0 ^ x3
    pop  BC             ; 1:10      __INFO
    push BC             ; 1:11      __INFO
    push AF             ; 1:11      __INFO
    ld    A, C          ; 1:4       __INFO
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, B          ; 1:4       __INFO
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # $1 pick xor
dnl # ( xn .. x1 x0 -- xn .. x1 x )  x == x0 ^ xn
define({PUSH_PICK_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_PICK_XOR},{$1 pick xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_PICK_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<1),1,{
__{}__{}  .error {$0}($@): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HEX_HL(0x8000 & ($1)),{0x8000},{
__{}__{}  .error {$0}($@): Parameter is negative!},

__{}__HAS_PTR($1),{1},{
__{}__{}    push DE             ; 1:11      __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0 ^ x$1
__{}__{}    push HL             ; 1:11      __INFO   pointer version
__{}__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    add  HL, HL         ; 1:11      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    D,[HL]        ; 1:7       __INFO
__{}__{}    pop  HL             ; 1:10      __INFO
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}    pop  DE             ; 1:10      __INFO},

__IS_NUM($1),{0},{
__{}__{} if (($1) & 0x8000)
__{}__{}    .error {$0}($@): Parameter is negative!
__{}__{} else
__{}__{}  if (($1) = 0)
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   ( x0 -- 0 )
__{}__{}  else
__{}__{}   if (($1) = 1){}dnl
__{}__{}__ASM_TOKEN_OVER_XOR
__{}__{}   else
__{}__{}    if (($1) = 2){}dnl
__{}__{}__ASM_TOKEN_2_PICK_XOR
__{}__{}    else
__{}__{}     if (($1) = 3){}dnl
__{}__{}__ASM_TOKEN_3_PICK_XOR
__{}__{}     else
__{}__{}    ld    A, L          ; 1:4       __INFO   ( $1 .. x1 x0 -- $1 .. x1 x )  x == x0 ^ $1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __FORM({%-11s},__SIMPLIFY_EXPRESSION(0-4+2*($1))); 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    xor [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO
__{}__{}     endif
__{}__{}    endif
__{}__{}   endif
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL($1),0x0000,{__ASM_TOKEN_DROP_PUSH(0)},
__{}__HEX_HL($1),0x0001,{__ASM_TOKEN_OVER_XOR},
__{}__HEX_HL($1),0x0002,{__ASM_TOKEN_2_PICK_XOR},
__{}__HEX_HL($1),0x0003,{__ASM_TOKEN_3_PICK_XOR},
__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   ( x$1 .. x1 x0 -- x$1 .. x1 x )  x == x0 ^ x$1
__{}__{}    ld    B, H          ; 1:4       __INFO
__{}__{}    ld   HL, __HEX_HL($1+$1-4)     ; 3:10      __INFO
__{}__{}    add  HL, SP         ; 1:11      __INFO
__{}__{}    xor [HL]            ; 1:7       __INFO
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    ld    H,[HL]        ; 1:7       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # ( x -- x^n )
dnl # x = x ^ n
define({PUSH_XOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_XOR},{$1 xor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_XOR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__XOR_REG16_16BIT({HL},$1){}dnl
})}){}dnl
dnl
dnl
dnl # ( b a -- b^$1 a )
define({SWAP_PUSH_XOR_SWAP},{dnl
__{}__ADD_TOKEN({__TOKEN_SWAP_PUSH_XOR_SWAP},{swap $1 xor swap},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_SWAP_PUSH_XOR_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__XOR_REG16_16BIT({DE},$1){}dnl
})}){}dnl
dnl
dnl
dnl # ( x1 -- x )
dnl # x = ~x1
dnl # -1   -> false
dnl # false-> true
define({INVERT},{dnl
__{}__ADD_TOKEN({__TOKEN_INVERT},{invert},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_INVERT},{
__{}define({__INFO},{__COMPILE_INFO}){}dnl
    ld    A, L          ; 1:4       __INFO
    cpl                 ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, H          ; 1:4       __INFO
    cpl                 ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( u1 -- u2 )
dnl # lo(u1) = ~lo(u1)
define({CINVERT},{dnl
__{}__ADD_TOKEN({__TOKEN_CINVERT},{cinvert},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CINVERT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
    ld    A, L          ; 1:4       __INFO    ( u1 -- u2 ) u2: hi(u1) & ~lo(u1)
    cpl                 ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( u1 -- u2 )
dnl # hi(u1) = ~hi(u1)
define({HINVERT},{dnl
__{}__ADD_TOKEN({__TOKEN_HINVERT},{hinvert},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HINVERT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
    ld    A, H          ; 1:4       __INFO    ( u1 -- u2 ) u2: lo(u1) & ~hi(u1)
    cpl                 ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( a b c -- ((a-b) (c-b) U<) )
dnl # b <= a < c
define({WITHIN},{dnl
__{}__ADD_TOKEN({__TOKEN_WITHIN},{within},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_WITHIN},{dnl
__{}define({__INFO},{within}){}dnl
ifelse(TYP_WITHIN,{fast},{
                       ;[18:91]     within ( a b c -- bool=(b<=a<c) )   ;# fast version can be changed with "define({TYP_WITHIN},{name})", name=fast
    ld    A, L          ; 1:4       within
    sub   E             ; 1:4       within
    ld    C, A          ; 1:4       within
    ld    A, H          ; 1:4       within
    sbc   A, D          ; 1:4       within
    ld    B, A          ; 1:4       within BC = c-b
    pop  HL             ; 1:10      within
    or    A             ; 1:4       within
    sbc  HL, DE         ; 2:15      within HL = a-b
    ld    A, L          ; 1:4       within
    sub   C             ; 1:4       within
    ld    A, H          ; 1:4       within
    sbc   A, B          ; 1:4       within (a-b) - (c-b) < 0
    sbc   A, A          ; 1:4       within
    ld    L, A          ; 1:4       within
    ld    H, A          ; 1:4       within
    pop  DE             ; 1:10      within ( a b c -- ((a-b) (c-b) U<) )}dnl
,{
                       ;[16:97]     within ( a b c -- bool=(b<=a<c) )   ;# default version can be changed with "define({TYP_WITHIN},{name})", name=fast
    ld    A, L          ; 1:4       within
    sub   E             ; 1:4       within
    ld    C, A          ; 1:4       within
    ld    A, H          ; 1:4       within
    sbc   A, D          ; 1:4       within
    ld    B, A          ; 1:4       within BC = c-b
    pop  HL             ; 1:10      within
    or    A             ; 1:4       within
    sbc  HL, DE         ; 2:15      within HL = a-b
    or    A             ; 1:4       within
    sbc  HL, BC         ; 2:15      within (a-b) - (c-b) < 0
    sbc  HL, HL         ; 2:15      within
    pop  DE             ; 1:10      within ( a b c -- ((a-b) (c-b) U<) )})}){}dnl
dnl
dnl
dnl # ( a $1 $2 -- ((a-$1) ($2-$1) U<) )
dnl # $1 <= a < $2
define({PUSH2_WITHIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_WITHIN},{$1 $2 within},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_WITHIN},{dnl
__{}define({__INFO},{push2_within}){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing parameters!},
__{}$#,{1},{
__{}__{}.error {$0}($@): The second parameter is missing!},
__{}eval($#>2),{1},{
__{}__{}.error {$0}($@): $# parameters found in macro!},
{define({_TMP_INFO},{$1 $2 within}){}define({PUSH2_WITHIN_CODE},__WITHIN($1,$2))
__{}                        ;format({%-11s},[eval(2+__WITHIN_B):eval(15+__WITHIN_C)])_TMP_INFO   ( {TOS} -- bool )  bool=($1<={TOS}<$2){}dnl
__{}PUSH2_WITHIN_CODE
__{}    sbc  HL, HL         ; 2:15      _TMP_INFO   HL = 0x0000 or 0xffff}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( c3 c2 c1 -- ((c3-c2) (c1-c2) U<) )
dnl # c2 <= c3 < c1
define({LO_WITHIN},{dnl
__{}__ADD_TOKEN({__TOKEN_LO_WITHIN},{lo_within},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_LO_WITHIN},{dnl
__{}define({__INFO},__COMPILE_INFO)
                       ;[10:59]     __INFO   ( c3 c2 c1 -- bool=(c2<=c3<c1) )
    ld    A, L          ; 1:4       __INFO
    sub   E             ; 1:4       __INFO
    ld    C, A          ; 1:4       __INFO   C = c1-c2
    pop  HL             ; 1:10      __INFO   L = c3
    ld    A, L          ; 1:4       __INFO
    sub   E             ; 1:4       __INFO   c3-c2
    sub   C             ; 1:4       __INFO   (c3-c2)-(c1-c2)
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff
    pop  DE             ; 1:10      __INFO   ( c3 c2 c1 -- ((c3-c2) (c1-c2) U<) ){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x3 x2 -- ((x3-x2) (x1-x2) U<) )
dnl # x2 <= x3 < $1
define({PUSH_WITHIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_WITHIN},{$1 within},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_WITHIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__HAS_PTR($1),1,{
                       ;[18:110]    __INFO   ( x3 x2 $1 -- bool=(x2<=x3<$1) )
    ld    C, L          ; 1:4       __INFO
    ld    B, H          ; 1:4       __INFO   BC = x2
    ld   HL,__FORM({%-12s},$1); 3:16      __INFO   lo
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO   $1-x2
    ex   DE, HL         ; 1:4       __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO   x3-x2
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO   (x3-x2)-($1-x2)
    pop  DE             ; 1:10      __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff},
__HAS_PTR($1),1,{
                       ;[18:110]    __INFO   ( x3 x2 $1 -- bool=(x2<=x3<$1) )
    xor   A             ; 1:4       __INFO
    sub   L             ; 1:4       __INFO
    ld    C, A          ; 1:4       __INFO
    sbc   A, H          ; 1:4       __INFO
    sub   L             ; 1:4       __INFO
    ld    B, A          ; 1:4       __INFO   BC =-x2
    ld   HL,__FORM({%-12s},$1); 3:16      __INFO   lo
    add  HL, BC         ; 1:11      __INFO   $1-x2
    ex   DE, HL         ; 1:4       __INFO
    add  HL, BC         ; 1:11      __INFO   x3-x2
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO   (x3-x2)-($1-x2)
    pop  DE             ; 1:10      __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff},
__HAS_PTR($1),1,{
                       ;[20:109]    __INFO   ( x3 x2 $1 -- bool=(x2<=x3<$1) )
    ex   DE, HL         ; 1:4       __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO   x3-x2
    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO   lo
    sub   E             ; 1:4       __INFO
    ld    E, A          ; 1:4       __INFO
    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      __INFO   hi
    sbc   A, D          ; 1:4       __INFO
    ld    D, A          ; 1:4       __INFO   $1-x2
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO   (x3-x2)-($1-x2)
    pop  DE             ; 1:10      __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff},
{
                       ;[18:97]     __INFO   ( x3 x2 $1 -- bool=(x2<=x3<$1) )
    ex   DE, HL         ; 1:4       __INFO
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO   x3-x2
    ld    A, low __FORM({%-7s},$1); 2:7       __INFO
    sub   E             ; 1:4       __INFO
    ld    E, A          ; 1:4       __INFO
    ld    A, high __FORM({%-6s},$1); 2:7       __INFO
    sbc   A, D          ; 1:4       __INFO
    ld    D, A          ; 1:4       __INFO   $1-x2
    or    A             ; 1:4       __INFO
    sbc  HL, DE         ; 2:15      __INFO   (x3-x2)-($1-x2)
    pop  DE             ; 1:10      __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( c3 c2 -- ((c3-c2) ($1-c2) U<) )
dnl # c2 <= c3 < $1
define({PUSH_LO_WITHIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_LO_WITHIN},{$1 lo_within},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_LO_WITHIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__HAS_PTR($1),1,{
                       ;[11:58]     __INFO   ( c3 c2 $1 -- bool=(c2<=c3<$1) )
    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
    sub   L             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO   $1-c2
    ld    A, E          ; 1:4       __INFO
    sub   L             ; 1:4       __INFO   c3-c2
    sub   H             ; 1:4       __INFO   (c3-c2)-($1-c2)
    pop  DE             ; 1:10      __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff},
{
                       ;[10:52]     __INFO   ( c3 c2 $1 -- bool=(c2<=c3<$1) )
    ld    A, low __FORM({%-7s},$1); 2:7       __INFO
    sub   L             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO   $1-c2
    ld    A, E          ; 1:4       __INFO
    sub   L             ; 1:4       __INFO   c3-c2
    sub   H             ; 1:4       __INFO   (c3-c2)-($1-c2)
    pop  DE             ; 1:10      __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff}){}dnl
}){}dnl
dnl
dnl
dnl # ( a $1 $2 -- ((a-$1) ($2-$1) U<) )
dnl # $1 <= a < $2
define({PUSH2_LO_WITHIN},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_LO_WITHIN},{$1 $2 lo_within},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_LO_WITHIN},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing parameters!},
__{}$#,{1},{
__{}__{}  .error {$0}($@): The second parameter is missing!},
__{}eval($#>2),{1},{
__{}__{}  .error {$0}($@): $# parameters found in macro!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[ifelse(__HAS_PTR($2),{1},{14:65},{13:59})]    __INFO   ( a $1 $2 -- bool=($1<=a<$2) )
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    ld    C, A          ; 1:4       __INFO   C = $1
__{}__{}    ld    A, ifelse(__HAS_PTR($2),{1},{__FORM({%-11s},__PTR_ADD($2,0)); 3:13},{__FORM({%-11s},$2); 2:7 })      __INFO
__{}__{}    sub   C             ; 1:4       __INFO
__{}__{}    ld    B, A          ; 1:4       __INFO   B = ($2)-[$1]
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    sub   C             ; 1:4       __INFO   A = a -($1)
__{}__{}    sub   B             ; 1:4       __INFO   A = (a -($1)) - ([$2]-($1))
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff},
__{}__HAS_PTR($2),{1},{dnl
__{}__{}ifelse(eval($1),{0},{
__{}__{}__{}                        ;[8:40]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO
__{}__{}__{}    ld    B, A          ; 1:4       __INFO   B = $2 - {{$1}}
__{}__{}__{}    ld    A, L          ; 1:4       __INFO},
__{}__{}eval($1),{1},{
__{}__{}__{}                       ;[10:48]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO
__{}__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}__{}    ld    B, A          ; 1:4       __INFO   B = $2 - {{$1}}
__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}    dec   A             ; 1:4       __INFO   A = a - {{$1}}},
__{}__{}__HEX_HL($1),{0xFFFF},{
__{}__{}__{}                       ;[10:48]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO
__{}__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}__{}    ld    B, A          ; 1:4       __INFO   B = $2 - {{$1}}
__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}    inc   A             ; 1:4       __INFO   A = a - {{$1}}},
__{}__{}{
__{}__{}__{}                       ;[12:54]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($2,0)); 3:13      __INFO
__{}__{}__{}    sub   __FORM({%-14s},$1); 2:7       __INFO
__{}__{}__{}    ld    B, A          ; 1:4       __INFO   B = $2 - {{$1}}
__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}    sub   __FORM({%-14s},$1); 2:7       __INFO   A = a - {{$1}}})
__{}__{}    sub   B             ; 1:4       __INFO   A = (a - {{$1}}) - ($2 - {{$1}})
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff},
__{}{dnl
__{}__{}ifelse(__IS_NUM($1),{0},{
__{}__{}__{}                        ;[7:33]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}    sub   __FORM({%-14s},$1); 2:7       __INFO   A = a-($1)},
__{}__{}{dnl
__{}__{}__{}ifelse(eval($1),{0},{
__{}__{}__{}__{}                        ;[5:26]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}__{}    ld    A, L          ; 1:4       __INFO},
__{}__{}__{}eval($1),{1},{
__{}__{}__{}__{}                        ;[6:30]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}__{}    dec   A             ; 1:4       __INFO   A = a-($1)},
__{}__{}__{}__HEX_HL($1),{0xFFFF},{
__{}__{}__{}__{}                        ;[6:30]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}__{}    inc   A             ; 1:4       __INFO   A = a-($1)},
__{}__{}__{}{
__{}__{}__{}__{}                        ;[7:33]     __INFO   ( a -- bool=($1<=a<$2) )
__{}__{}__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}__{}__{}    sub   __HEX_L($1)          ; 2:7       __INFO   A = a-($1)}){}dnl
__{}__{}}){}dnl
__{}__{}__{}ifelse(__IS_NUM($1):__IS_NUM($2),{1:1},{
__{}__{}__{}    sub  __HEX_L($2-($1))           ; 2:7       __INFO   carry: a-($1) - (($2)-($1))},
__{}__{}{
__{}__{}__{}    sub  low __FORM({%-11s},$2-($1)); 2:7       __INFO   carry: a-($1) - (($2)-($1))})
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = 0x0000 or 0xffff}){}dnl
}){}dnl
dnl
dnl
dnl # -------------------------------------
dnl
dnl # ( -- x )
dnl # x = 0xFFFF
define({TRUE},{dnl
__{}__ADD_TOKEN({__TOKEN_TRUE},{true},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_TRUE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld   HL, 0xffff     ; 3:10      __INFO}){}dnl
dnl
dnl # ( -- x )
dnl # x = 0
define({FALSE},{dnl
__{}__ADD_TOKEN({__TOKEN_FALSE},{false},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_FALSE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld   HL, 0x0000     ; 3:10      __INFO}){}dnl
dnl
dnl # -------------------------------------
dnl
dnl # 0=
dnl # ( x1 -- bool )
dnl # if ( x1 ) bool = 0; else bool = 0xFFFF;
dnl # 0 if 16-bit number not equal to zero, -1 if equal
define({_0EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_0EQ},{0=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_0EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[5:29]     __INFO   ( x -- bool )  bool: x == 0
    ld    A, H          ; 1:4       __INFO
    dec  HL             ; 1:6       __INFO
    sub   H             ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = bool}){}dnl
dnl
dnl
dnl # 1+ 0=
dnl # ( x1 -- bool )
dnl # if ( x1 == 0xFFFF ) bool = 0xFFFF; else bool = 0;
define({_1ADD_0EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_1ADD_0EQ},{1+ 0=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1ADD_0EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[6:30]     __INFO   ( x -- bool )  bool: x == -1
    ld    A, H          ; 1:4       __INFO
    and   L             ; 1:4       __INFO
    add   A, 0x01       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO   HL = bool}){}dnl
dnl
dnl
dnl # 0<>
dnl # ( x1 -- bool )
dnl # if ( x1<>0 ) bool = 0; else bool = 0xFFFF;
dnl # 0 if 16-bit zero, -1 if not equal zero
define({_0NE},{dnl
__{}__ADD_TOKEN({__TOKEN_0NE},{0<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_0NE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(_TYP_SINGLE,small,{
__{}                        ;[6:30]     __INFO   ( x -- bool )  bool: x <> 0  ;# small version can be changed with "define({TYP_D0EQ},{default})"
__{}    ld    A, L          ; 1:4       __INFO
__{}    or    H             ; 1:4       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}{
__{}                        ;[7:25/20]  __INFO   ( x -- bool )  bool: x <> 0  ;# default version can be changed with "define({TYP_D0EQ},{small})"
__{}    ld    A, L          ; 1:4       __INFO
__{}    or    H             ; 1:4       __INFO
__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool}){}dnl
 }){}dnl
dnl
dnl
dnl # 0<
dnl # ( x1 -- bool )
define({_0LT},{dnl
__{}__ADD_TOKEN({__TOKEN_0LT},{0<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_0LT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(TYP_0LT,{small},{
__{}                        ;[4:23]     __INFO   ( x -- bool )  bool: x < 0  ;# small version can be changed with "define({TYP_D0EQ},{default})"
__{}    rl    H             ; 2:8       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{
__{}                        ;[5:20]     __INFO   ( x -- bool )  bool: x < 0  ;# default version can be changed with "define({TYP_D0EQ},{small})"
__{}    rl    H             ; 2:8       __INFO
__{}    sbc   A, A          ; 1:4       __INFO
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl # 0>
dnl # ( x1 -- bool )
define({_0GT},{dnl
__{}__ADD_TOKEN({__TOKEN_0GT},{0>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_0GT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(1,0,{
__{}                        ;[9:41/20]  __INFO   ( x -- bool )  bool: x > 0
__{}    ld    A, L          ; 1:4       __INFO
__{}    or    H             ; 1:4       __INFO
__{}    jr    z, $+7        ; 2:7/12    __INFO   zero is false and result
__{}    ld    A, H          ; 1:4       __INFO
__{}    sub   0x80          ; 2:7       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{
__{}                        ;[7:36]     __INFO   ( x -- bool )  bool: x > 0
__{}    ld    A, H          ; 1:4       __INFO   save sign
__{}    dec  HL             ; 1:6       __INFO   zero to negative
__{}    or    H             ; 1:4       __INFO
__{}    sub   0x80          ; 2:7       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 0<=
dnl # ( x1 -- bool )
define({_0LE},{dnl
__{}__ADD_TOKEN({__TOKEN_0LE},{0<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_0LE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[6:33]     __INFO   ( x -- bool )  bool: x <= 0
    ld    A, H          ; 1:4       __INFO   save sign
    dec  HL             ; 1:6       __INFO   zero to negative
    or    H             ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO   carry if zero or negative HL
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # 0>=
dnl # ( x1 -- bool )
define({_0GE},{dnl
__{}__ADD_TOKEN({__TOKEN_0GE},{0>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_0GE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[5:26]     __INFO   ( x -- bool )  bool: x >= 0
    ld    A, H          ; 1:4       __INFO
    sub   0x80          ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # ------------ signed -----------------
dnl
dnl
dnl # 2dup =
dnl # ( x2 x1 -- x2 x1 ) A = bool
define({_2DUP_EQ2A},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_EQ2A},{2dup =},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_EQ2A},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    add  HL, DE         ; 1:11      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF{}dnl
}){}dnl
dnl
dnl
dnl # 2dup <>
dnl # ( x2 x1 -- x2 x1 ) A = bool
define({_2DUP_NE2A},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_NE2A},{2dup <>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_NE2A},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    add  HL, DE         ; 1:11      __INFO
__{}    jr    z, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF{}dnl
}){}dnl
dnl
dnl
dnl # 2dup <
dnl # ( x2 x1 -- x2 x1 ) A = bool
define({_2DUP_LT2A},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_LT2A},{2dup <},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_LT2A},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, E          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    sub   L             ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    ld    A, D          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    sbc   A, H          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff{}dnl
}){}dnl
dnl
dnl
dnl # 2dup >=
dnl # ( x2 x1 -- x2 x1 ) A = bool
define({_2DUP_GE2A},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_GE2A},{2dup >=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_GE2A},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, E          ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    sub   L             ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    ld    A, D          ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    sbc   A, H          ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    sub  0x80           ; 2:7       __INFO   sign --> invert carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff{}dnl
}){}dnl
dnl
dnl
dnl # 2dup <=
dnl # ( x2 x1 -- x2 x1 ) A = bool
define({_2DUP_LE2A},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_LE2A},{2dup <=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_LE2A},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, L          ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    sub   E             ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    ld    A, H          ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    sbc   A, D          ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    sub  0x80           ; 2:7       __INFO   sign --> invert carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff{}dnl
}){}dnl
dnl
dnl
dnl # 2dup >
dnl # ( x2 x1 -- x2 x1 ) A = bool
define({_2DUP_GT2A},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_GT2A},{2dup >},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_GT2A},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, L          ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    sub   E             ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    ld    A, H          ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    sbc   A, D          ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff{}dnl
}){}dnl
dnl
dnl
dnl # ------------ over condition -----------------
dnl
dnl
dnl # over =
dnl # ( x2 x1 -- x2 bool )
define({OVER_EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_EQ},{over =},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # over <>
dnl # ( x2 x1 -- x2 bool )
define({OVER_NE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_NE},{over <>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_NE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    xor   A             ; 1:4       __INFO
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # over <
dnl # ( x2 x1 -- x2 bool )
define({OVER_LT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_LT},{over <},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_LT},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, L          ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    sub   E             ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    ld    A, H          ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    sbc   A, D          ; 1:4       __INFO   DE>HL --> 0>HL-DE --> carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # over >=
dnl # ( x2 x1 -- x2 bool )
define({OVER_GE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_GE},{over >=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_GE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, L          ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    sub   E             ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    ld    A, H          ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    sbc   A, D          ; 1:4       __INFO   DE<=HL --> 0<=HL-DE --> no carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    sub  0x80           ; 2:7       __INFO   sign --> invert carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # over <=
dnl # ( x2 x1 -- x2 bool )
define({OVER_LE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_LE},{over <=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_LE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, E          ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    sub   L             ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    ld    A, D          ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    sbc   A, H          ; 1:4       __INFO   DE>=HL --> DE-HL>=0 --> no carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    sub  0x80           ; 2:7       __INFO   sign --> invert carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # over >
dnl # ( x2 x1 -- x2 bool )
define({OVER_GT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_GT},{over >},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_GT},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    ld    A, E          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    sub   L             ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    ld    A, D          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    sbc   A, H          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl
dnl ;# ----------------------------------------------------
dnl
dnl
dnl
dnl # rot <
dnl # ( x2 x1 -- x2 bool )
define({ROT_LT},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_LT},{rot <},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_LT},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 bool ) bool: x1 < x3
__{}    ld    A, L          ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
__{}    sub   C             ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
__{}    ld    A, H          ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
__{}    sbc   A, B          ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   B             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # rot >=
dnl # ( x2 x1 -- x2 bool )
define({ROT_GE},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_GE},{rot >=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_GE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 bool ) bool: x1 >= x3
__{}    ld    A, L          ; 1:4       __INFO   BC<=HL --> 0<=HL-BC --> no carry if true
__{}    sub   C             ; 1:4       __INFO   BC<=HL --> 0<=HL-BC --> no carry if true
__{}    ld    A, H          ; 1:4       __INFO   BC<=HL --> 0<=HL-BC --> no carry if true
__{}    sbc   A, B          ; 1:4       __INFO   BC<=HL --> 0<=HL-BC --> no carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   B             ; 1:4       __INFO
__{}    sub  0x80           ; 2:7       __INFO   sign --> invert carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # rot <=
dnl # ( x2 x1 -- x2 bool )
define({ROT_LE},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_LE},{rot <=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_LE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 bool ) bool: x1 <= x3
__{}    scf                 ; 1:4       __INFO   0 >= HL - BC
__{}    sbc  HL, BC         ; 2:15      __INFO   0 > HL - BC - carry
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   B             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl # rot >
dnl # ( x2 x1 -- x2 bool )
define({ROT_GT},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_GT},{rot >},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_GT},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 bool ) bool: x1 > x3
__{}    ld    A, C          ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
__{}    sub   L             ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
__{}    ld    A, B          ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
__{}    sbc   A, H          ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   B             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl
dnl ;# ----------------------------------------------------
dnl
dnl
dnl # =
dnl # ( x1 x2 -- bool )
dnl # equal ( x1 == x2 )
define({EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_EQ},{=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_EQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER_EQ{}dnl
__{}__ASM_TOKEN_NIP{}dnl
}){}dnl
dnl
dnl
dnl
dnl # <>
dnl # ( x1 x2 -- bool )
dnl # not equal ( x1 <> x2 )
define({NE},{dnl
__{}__ADD_TOKEN({__TOKEN_NE},{<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_NE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER_NE{}dnl
__{}__ASM_TOKEN_NIP{}dnl
}){}dnl
dnl
dnl
dnl
dnl # <
dnl # ( x2 x1 -- bool )
dnl # signed ( x2 < x1 ) --> ( x2 - x1 < 0 ) --> carry is true
define({LT},{dnl
__{}__ADD_TOKEN({__TOKEN_LT},{<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_LT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER_GT{}dnl
__{}__ASM_TOKEN_NIP{}dnl
}){}dnl
dnl
dnl
dnl
dnl # <=
dnl # ( x2 x1 -- bool )
dnl # signed ( x2 <= x1 ) --> ( x2 - 1 < x1 ) --> ( x2 - x1 - 1 < 0 ) --> carry is true
dnl # signed ( x2 <= x1 ) --> ( 0 <= x1 - x2 ) --> no carry is true
define({LE},{dnl
__{}__ADD_TOKEN({__TOKEN_LE},{<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_LE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER_GE{}dnl
__{}__ASM_TOKEN_NIP{}dnl
}){}dnl
dnl
dnl
dnl
dnl # >
dnl # ( x2 x1 -- bool )
dnl # signed ( x2 > x1 ) --> ( 0 > x1 - x2 ) --> carry is true
define({GT},{dnl
__{}__ADD_TOKEN({__TOKEN_GT},{>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_GT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER_LT{}dnl
__{}__ASM_TOKEN_NIP{}dnl
}){}dnl
dnl
dnl
dnl
dnl # >=
dnl # ( x2 x1 -- bool )
dnl # signed ( x2 >= x1 ) --> ( x2 + 1 > x1 ) --> ( 0 > x1 - x2 - 1 ) --> carry is true
dnl # signed ( x2 >= x1 ) --> ( x2 - x1 >= 0 ) --> no carry is true
define({GE},{dnl
__{}__ADD_TOKEN({__TOKEN_GE},{>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_GE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_OVER_LE{}dnl
__{}__ASM_TOKEN_NIP{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------------------- push condition --------------------------
dnl
dnl
dnl
dnl # ( x -- x|n )
dnl # x = x | n
define({PUSH_EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_EQ},{$1 =},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_EQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing address parameter!},
__{}$#,{1},,{
__{}__{}.error {$0}($@): $# parameters found in macro!})
__{}ifelse(__HAS_PTR($1),{1},{dnl
__{}__{}                       ;[12:58/59]  __INFO
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}__{}    sbc  HL, BC         ; 2:15      __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}    .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                       ;[11:48/49]  __INFO
__{}__{}    ld   BC, __FORM({%-11s},$1); 3:10      __INFO
__{}__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}__{}    sbc  HL, BC         ; 2:15      __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO   HL = bool},
__{}{dnl
__{}__{}ifelse(eval($1),{0},{dnl
__{}__{}                        ;[6:30]     __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval($1),{1},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1) & 0xffff) - 0xffff),{0},{dnl
__{}__{}                        ;[7:36]     __INFO
__{}__{}    inc   HL            ; 1:6       __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval($1),{255},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval($1),{256},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) - 0xff00),{0},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff00),{0},{dnl
__{}__{}                        ;[8:37]     __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff),{0},{dnl
__{}__{}                        ;[8:37]     __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1)>>8) & 0xff),{1},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1)>>8) & 0xff),{255},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff),{1},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    dec   L             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff),{255},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1) & 0xff)-((($1)>>8) & 0xff)),{0},{dnl
__{}__{}                       ;[11:48/35]  __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1) = hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}{dnl
__{}__{}                       ;[12:51/38]  __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f )
dnl # f = x <> $1
define({PUSH_NE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_NE},{$1 <>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_NE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}__{}.error {$0}(): Missing address parameter!},
__{}$#,{1},,{
__{}__{}.error {$0}($@): $# parameters found in macro!})
__{}ifelse(__HAS_PTR($1),{1},{dnl
__{}__{}                       ;[12:56/51]  __INFO
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}__{}    sbc  HL, BC         ; 2:15      __INFO
__{}__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}    .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                       ;[11:46/41]  __INFO
__{}__{}    ld   BC, __FORM({%-11s},$1); 3:10      __INFO
__{}__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}__{}    sbc  HL, BC         ; 2:15      __INFO
__{}__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool},
__{}{dnl
__{}__{}ifelse(eval($1),{0},{dnl
__{}__{}                        ;[7:25/20]  __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool},
__{}__{}eval($1),{0},{dnl
__{}__{}                        ;[6:30]     __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval($1),{1},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1) & 0xffff) - 0xffff),{0},{dnl
__{}__{}                        ;[7:36]     __INFO
__{}__{}    inc   HL            ; 1:6       __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval($1),{255},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval($1),{256},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) - 0xff00),{0},{dnl
__{}__{}                        ;[7:34]     __INFO
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff00),{0},{dnl
__{}__{}                        ;[8:37]     __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff),{0},{dnl
__{}__{}                        ;[8:37]     __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1)>>8) & 0xff),{1},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    dec   H             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval((($1)>>8) & 0xff),{255},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   lo($1)
__{}__{}    xor   L             ; 1:4       __INFO
__{}__{}    inc   H             ; 1:4       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff),{1},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    dec   L             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}eval(($1) & 0xff),{255},{dnl
__{}__{}                        ;[9:41]     __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   hi($1)
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}__{}{dnl
__{}__{}                       ;[11:46/41]  __INFO
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      __INFO   BC = $1
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO
__{}__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = true}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x < $1
define({PUSH_LT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_LT},{$1 <},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_LT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HAS_PTR($1),1,{
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sub   C             ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sbc   A, B          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HEX_HL($1),0x8000,{
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: min},

__{}__HEX_HL($1),0x8001,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL<$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min+1},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-1},

__{}__HEX_HL($1),0x0000,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero},

__{}__HEX_HL($1),0x0001,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero+1},

__{}__HEX_HL($1),0x7FFF,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL<$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max},

__{}__IS_NUM($1),0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION(0x8000+$1)){}dnl
__{}__{}  if ((0xFFFF & ($1))=0x8000)
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: min
__{}__{}  else
__{}__{}   if ($1)
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<$1 --> (0x8000+HL)<(0x8000+$1)
__{}__{}    sub  __FORM({%-15s},$1); 2:7       __INFO   (0x8000+HL)<($0_TMP) --> (0x8000+HL)-($0_TMP)<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   (0x8000+HL)<($0_TMP) --> (0x8000+HL)-($0_TMP)<0 --> true if carry
__{}__{}    adc   A, A          ; 1:4       __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    sbc   A, __FORM({%-11s},__SIMPLIFY_EXPRESSION(128+($1)>>8)); 2:7       __INFO   (0x8000+HL)<($0_TMP) --> (0x8000+HL)-($0_TMP)<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}   else
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero
__{}__{}   endif
__{}__{}  endif},

__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<$1 --> (0x8000+HL)<(0x8000+$1)
__{}__{}    sub  __HEX_L($1)           ; 2:7       __INFO   (0x8000+HL)<__HEX_HL(0x8000+$1) --> L-__HEX_L($1)<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   (0x8000+HL)<__HEX_HL(0x8000+$1) --> (H+0x80)-__HEX_H(0x8000+$1)<0 --> true if carry
__{}__{}    adc   A, A          ; 1:4       __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    sbc   A, __HEX_H(0x8000+$1)       ; 2:7       __INFO   (0x8000+HL)<__HEX_HL(0x8000+$1) -->  (H+0x80)-__HEX_H(0x8000+$1)<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: default{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x <= $1
define({PUSH_LE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_LE},{$1 <=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_LE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HAS_PTR($1),1,{
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   HL<=$1 --> $1-HL --> true if (sign ^ overflow) == 0
__{}__{}    sub   L             ; 1:4       __INFO   true if (sign ^ overflow) == 0 --> (sign ^ overflow ^ 1) == 1
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    jp   pe, $+4        ; 3:10      __INFO   jump if overflow is set
__{}__{}    cpl                 ; 1:4       __INFO   invert all bits (include sign) if not overflow
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HAS_PTR($1),1,{
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, C          ; 1:4       __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    sub   L             ; 1:4       __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    ld    A, B          ; 1:4       __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HEX_HL($1),0x8000,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL<=$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min},

__{}__HEX_HL($1),0xFFFE,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<=$1
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-2},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<=$1
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-1},

__{}__HEX_HL($1),0x0000,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<=$1
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero},

__{}__HEX_HL($1),0x7FFE,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL<=$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max-1},

__{}__HEX_HL($1),0x7FFF,{
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: max},

__{}__IS_NUM($1),0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION(1+$1)){}dnl
__{}__{}  if ((0xFFFF & ($1)) = 0x7FFF)
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: max
__{}__{}  else
__{}__{}   if ((0xFFFF & ($1)) = 0xFFFF)
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<=$1
__{}__{}    add   A, A          ; 1:4       __INFO   sign to carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-1
__{}__{}   else
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<=$1 --> HL<$1+1
__{}__{}    sub  __FORM({%-15s},$0_TMP); 2:7       __INFO   HL<$0_TMP --> HL-$1-1<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$0_TMP --> HL-$1-1<0 --> true if carry
__{}__{}    adc   A, A          ; 1:4       __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    sbc   A, high __FORM({%-6s},$0_TMP); 2:7       __INFO   HL<$0_TMP --> HL-$1-1<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}   endif
__{}__{}  endif},

__{}__HEX_H($1):__HEX_HL(0x8000 & ($1)),__HEX_L($1):0x8000,{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL<=__HEX_HL($1) --> HL>__HEX_HL($1) (negative constant)
__{}__{}    cp    L             ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo and negative constant},

__{}__HEX_HL(0x8000 & ($1)),0x8000,{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL<=__HEX_HL($1) --> HL>__HEX_HL($1) (negative constant)
__{}__{}    sub   L             ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: negative constant},

__{}__HEX_H($1):__HEX_HL(0x8000 & ($1)),__HEX_L($1):0x0000,{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL<=__HEX_HL($1) --> 0<=__HEX_HL($1)-HL
__{}__{}    cp    L             ; 1:4       __INFO   HL<=__HEX_HL($1) --> 0<=__HEX_L($1)-L --> true if not carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL<=__HEX_HL($1) --> 0<=__HEX_H($1)-H --> true if not carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo and positive constant},

__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<=$1 --> HL<$1+1
__{}__{}    sub  __HEX_L($1+1)           ; 2:7       __INFO   (0x8000+HL)<__HEX_HL(0x8001+$1) --> L-__HEX_L($1+1)<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   (0x8000+HL)<__HEX_HL(0x8001+$1) --> (H+0x80)-__HEX_H(0x8001+$1)<0 --> true if carry
__{}__{}    adc   A, A          ; 1:4       __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    rra                 ; 1:4       __INFO
__{}__{}    sbc   A, __HEX_H(0x8001+$1)       ; 2:7       __INFO   (0x8000+HL)<__HEX_HL(0x8001+$1) -->  (H+0x80)-__HEX_H(0x8001+$1)<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: default{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x >= $1
define({PUSH_GE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_GE},{$1 >=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_GE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HAS_PTR($1),1,{
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO   HL>=$1 --> HL-$1>=0 --> true if not carry
__{}__{}    sub   C             ; 1:4       __INFO   HL>=$1 --> HL-$1>=0 --> true if not carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1 --> HL-$1>=0 --> true if not carry
__{}__{}    sbc   A, B          ; 1:4       __INFO   HL>=$1 --> HL-$1>=0 --> true if not carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HEX_HL($1),0x8000,{
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: min},

__{}__HEX_HL($1),0x8001,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL>=$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min+1},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-1},

__{}__HEX_HL($1),0x0000,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero},

__{}__HEX_HL($1),0x0001,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero+1},

__{}__HEX_HL($1),0x7FFF,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL>=$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max},

__{}__IS_NUM($1),0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION($1)){}dnl
__{}__{}define({$0_TMPm1},__SIMPLIFY_EXPRESSION(-1+$0_TMP)){}dnl
__{}__{} if (0x8000 & ($0_TMP))
__{}__{}  if (0x7FFF & ($0_TMP))
__{}__{}    ld    A, L          ; 1:4       __INFO   HL>=$0_TMP --> HL<$0_TMP (negative constant)
__{}__{}    sub  __FORM({%-15s},$0_TMP); 2:7       __INFO   HL<$0_TMP --> L-__HEX_L($0_TMP)<0 --> true if carry (negative constant)
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    sbc   A,high __FORM({%-7s},$0_TMP); 2:7       __INFO   HL<$0_TMP --> H-__HEX_H($0_TMP)<0 --> true if carry (negative constant)
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: negative constant
__{}__{}  else
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: min
__{}__{}  endif
__{}__{} else
__{}__{}  if ($0_TMP)
__{}__{}    ld    A, __FORM({%-11s},$0_TMPm1); 2:7       __INFO   HL>=$0_TMP --> HL>$0_TMPm1
__{}__{}    cp    L             ; 1:4       __INFO   HL>$0_TMPm1 --> 0>__HEX_L($0_TMPm1)-L --> true if carry (positive constant)
__{}__{}   if (256*(0xFF & ($0_TMPm1))!=(0xFF00 & ($0_TMPm1)))
__{}__{}    ld    A,high __FORM({%-7s},$0_TMPm1); 2:7       __INFO
__{}__{}   endif
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$0_TMPm1 --> 0>__HEX_H($0_TMPm1)-H --> true if carry (positive constant)
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: positive constant
__{}__{}  else
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero
__{}__{}  endif
__{}__{} endif},

__{}__HEX_HL(0x8000 & ($1)),0x8000,{
__{}__{}    ld    A, L          ; 1:4       __INFO   HL>=$1 --> HL<$1 (negative constant)
__{}__{}    sub  __HEX_L($1)           ; 2:7       __INFO   HL<$1 --> L-__HEX_L($1)<0 --> true if carry (negative constant)
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    sbc   A, __HEX_H($1)       ; 2:7       __INFO   HL<$1 --> H-__HEX_H($1)<0 --> true if carry (negative constant)
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: negative constant},

__{}__HEX_H($1-1):__HEX_HL(0x8000 & ($1)),__HEX_L($1-1):0x0000,{
__{}__{}    ld    A, __HEX_L($1-1)       ; 2:7       __INFO   HL>=$1 --> HL>$1-1
__{}__{}    cp    L             ; 1:4       __INFO   HL>$1-1 --> 0>__HEX_L($1-1)-L --> true if carry (positive constant)
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1-1 --> 0>__HEX_H($1-1)-H --> true if carry (positive constant)
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi($1-1) == lo($1-1) and positive constant},

__{}{
__{}__{}    ld    A, __HEX_L($1-1)       ; 2:7       __INFO   HL>=$1 --> HL>$1-1
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1-1 --> 0>__HEX_L($1-1)-L --> true if carry (positive constant)
__{}__{}    ld    A, __HEX_H($1-1)       ; 2:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1-1 --> 0>__HEX_H($1-1)-H --> true if carry (positive constant)
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: positive constant{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x > $1
define({PUSH_GT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_GT},{$1 >},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_GT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HAS_PTR($1):__NOT_USE_BC,1:1,{
__{}__{}dnl # [15:67]
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   HL>$1 --> $1-HL --> true if (sign ^ overflow) == 1
__{}__{}    sub   L             ; 1:4       __INFO
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO
__{}__{}    jp   po, $+4        ; 3:10      __INFO   jump if overflow is unset
__{}__{}    cpl                 ; 1:4       __INFO   invert all bits (include sign) if overflow
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HAS_PTR($1),1,{
__{}__{}dnl # [14:67]
__{}__{}    ld   BC, __FORM({%-11s},__PTR_ADD($1,0)); 4:20      __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    ld    A, C          ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    ld    A, B          ; 1:4       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   B             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HEX_HL($1),0x8000,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL>$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min},

__{}__HEX_HL($1),0xFFFE,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    inc  HL             ; 1:6       __INFO
__{}__{}    and   H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-2},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-1},

__{}__HEX_HL($1),0x0000,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero},

__{}__HEX_HL($1),0x7FFE,{
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL>$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max-1},

__{}__HEX_HL($1),0x7FFF,{
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: max},

__{}__IS_NUM($1),0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION($1)){}dnl
__{}__{}define({$0_TMPm1},__SIMPLIFY_EXPRESSION(-1+$0_TMP)){}dnl
__{}__{} if (0x8000 & ($0_TMP))
__{}__{}  if (0x7FFF & ($0_TMP))
__{}__{}   if ($1+1)
__{}__{}    ld    A, L          ; 1:4       __INFO       __INFO   HL>$0_TMP --> HL>=$0_TMPm1 --> HL<$0_TMPm1 (negative constant)
__{}__{}    sub  __FORM({%-15s},$0_TMPm1); 2:7   HL<$0_TMPm1 --> L-$0_TMPm1<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    sbc   A,high __FORM({%-7s},$0_TMPm1); 2:7   HL<$0_TMPm1 --> H-hi($0_TMPm1)<0 --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: negative constant
__{}__{}   else
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero-1
__{}__{}   endif
__{}__{}  else
__{}__{}    ld    A, 0x80       ; 2:7       __INFO   HL>$1
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min
__{}__{}  endif
__{}__{} else
__{}__{}  if ($0_TMP)
__{}__{}   if ((0xFFFF & ($_TMP))=0x7FFF)
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: max
__{}__{}   else
__{}__{}    ld    A, __FORM({%-11s},$0_TMP); 2:7       __INFO   HL>$1 --> HL>$0_TMP
__{}__{}    cp    L             ; 1:4       __INFO   HL>$0_TMP --> 0>lo($0_TMP)-L --> true if carry
__{}__{}    if (256*(0xFF & ($0_TMP))!=(0xFF00 & ($0_TMP)))
__{}__{}    ld    A,high __FORM({%-7s},$0_TMP); 2:7       __INFO
__{}__{}    endif
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$0_TMP --> 0>hi($0_TMP)-H --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: positive constant
__{}__{}   endif
__{}__{}  else
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    dec  HL             ; 1:6       __INFO
__{}__{}    or    H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: zero
__{}__{}  endif
__{}__{} endif},

__{}__HEX_H($1):__HEX_HL(0x8000 & ($1)),__HEX_L($1):0x8000,{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL>$1 --> 0>__HEX_HL($1)-HL --> true if carry
__{}__{}    cp    L             ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    sub  0x80           ; 2:7       __INFO   sign  --> invert (negative constant) carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo and negative constant},

__{}__HEX_HL(0x8000 & ($1)),0x8000,{
__{}__{}    ld    A, L          ; 1:4       __INFO       __INFO   HL>__HEX_HL($1) --> HL>=__HEX_HL($1+1)
__{}__{}    sub  __HEX_L($1+1)           ; 2:7       __INFO   HL>=__HEX_HL($1+1) --> L-__HEX_L($1+1)<0 --> true if not carry
__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}    sbc   A, __HEX_H($1+1)       ; 2:7       __INFO   HL>=__HEX_HL($1+1) --> H-__HEX_H($1+1)<0 --> true if not carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> invert carry because negative constant
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: negative constant},

__{}__HEX_H($1),__HEX_L($1),{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL>$1 --> 0>__HEX_HL($1)-HL --> true if carry
__{}__{}    cp    L             ; 1:4       __INFO   HL>$1 --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1 --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo and positive constant},

__{}{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL>$1 --> 0>__HEX_HL($1)-HL --> true if carry
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1 --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1 --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign  --> invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: positive constant{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------------------- dup push condition --------------------------
dnl
dnl
dnl
define({DUP_PUSH_EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_EQ},{dup $1 =},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_EQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}                       ;[13:69/70]  __INFO   ( x -- x f )
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL,__FORM({%-12s},$1); 3:16      __INFO
__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO   bool: x==$1},
__{}{dnl
__{}__{}dnl # __MAKE_BEST_CODE_R16_CP(__INFO,__INFO   ( x x -- x bool ),HL,$1,6,37,0,37){}dnl
__{}__{}define({_TMP_INFO},__INFO){}dnl
__{}__{}define({_TMP_STACK_INFO},__INFO{   ( x -- x f )}){}dnl
__{}__{}__EQ_MAKE_BEST_CODE($1,6,37,0,37){}dnl
__{}__{}define({__TMP_CODE},{dnl
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    sub 0x01            ; 2:7       __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}__{}    push HL             ; 1:11      __INFO
__{}__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: x==$1}){}dnl
__{}__{}ifelse(_TYP_SINGLE:eval(_TMP_BEST_B*100+_TMP_BEST_C<=1266),small:1,{
__{}__{}__{}__TMP_CODE},
__{}__{}_TYP_SINGLE,small,{
__{}__{}__{}define({_TMP_BEST_CODE},__LD_R16(HL,-($1))){}dnl
__{}__{}__{}                       ;[12:66]     __INFO   ( x -- x x )
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    add  HL, DE         ; 1:11      __INFO
__{}__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}__{}    or    L             ; 1:4       __INFO
__{}__{}__{}    sub 0x01            ; 2:7       __INFO
__{}__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: x==$1},
__{}__{}eval(_TMP_BEST_P<=1784),1,{
__{}__{}__{}__TMP_CODE},
__{}__{}{
__{}__{}__{}define({_TMP_BEST_CODE},__LD_R16(HL,$1)){}dnl
__{}__{}__{}                       ;[13:63/56]  __INFO   ( x -- x f )
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}__{}    ld    H, A          ; 1:4       __INFO   bool: x==$1}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
define({DUP_PUSH_NE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_NE},{dup $1 <>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_NE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}                       ;[13:67/62]  __INFO   ( x -- x f )
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL,__FORM({%-12s},$1); 3:16      __INFO
__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   bool: x<>$1},
__{}{dnl
__{}__{}dnl # __MAKE_BEST_CODE_R16_CP(__INFO,__INFO   ( x x -- x bool ),HL,$1,6,37,0,37){}dnl
__{}__{}define({_TMP_INFO},__INFO){}dnl
__{}__{}define({_TMP_STACK_INFO},__INFO{   ( x -- x f )}){}dnl
__{}__{}__EQ_MAKE_BEST_CODE($1,6,37,0,37){}dnl
__{}__{}define({__TMP_CODE},{dnl
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}__{}    push HL             ; 1:11      __INFO
__{}__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: x<>$1}){}dnl
__{}__{}ifelse(_TYP_SINGLE:eval(_TMP_BEST_B*100+_TMP_BEST_C<=1266),small:1,{
__{}__{}__{}__TMP_CODE},
__{}__{}_TYP_SINGLE,small,{
__{}__{}__{}define({_TMP_BEST_CODE},__LD_R16(HL,-($1))){}dnl
__{}__{}__{}                       ;[12:66]     __INFO   ( x -- x x )
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    add  HL, DE         ; 1:11      __INFO
__{}__{}__{}    ld    A, H          ; 1:4       __INFO
__{}__{}__{}    or    L             ; 1:4       __INFO
__{}__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: x<>$1},
__{}__{}eval(_TMP_BEST_P<=1768),1,{
__{}__{}__{}__TMP_CODE},
__{}__{}{
__{}__{}__{}define({_TMP_BEST_CODE},__LD_R16(HL,$1)){}dnl
__{}__{}__{}                       ;[13:61/56]  __INFO   ( x -- x f )
__{}__{}__{}    push DE             ; 1:11      __INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   bool: x<>$1}){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------ 2dup condition -----------------
dnl
dnl
dnl
dnl # 2dup =
dnl # ( x1 x2 -- x1 x2 bool )
define({_2DUP_EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_EQ},{2dup =},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   ( x2 x1 -- x2 x1 bool ) bool: x1 == x2{}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup <>
dnl # ( x1 x2 -- x1 x2 bool )
define({_2DUP_NE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_EQ},{2dup <>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_NE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   ( x2 x1 -- x2 x1 bool ) bool: x1 <> x2{}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup <
dnl # ( x1 x2 -- x1 x2 bool )
define({_2DUP_LT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_LT},{2dup <},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_LT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(_TYP_SINGLE,fast,{dnl
__{}__{}__ASM_TOKEN_2DUP_LT2A{}dnl
__{}__{}__ASM_TOKEN_AAPUSH   ( x2 x1 -- x2 x1 bool ) bool: x2 < x1},
__{}{
__{}__{}    push DE             ; 1:11      __INFO   DE < HL
__{}__{}    ex   DE, HL         ; 1:4       __INFO   HL < DE
__{}__{}    xor   A             ; 1:4       __INFO   HL - DE < 0
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}__{}    xor   H             ; 1:4       __INFO
__{}__{}    xor   D             ; 1:4       __INFO
__{}__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}__{}    ld    L, A          ; 1:4       __INFO
__{}__{}    ld    H, A          ; 1:4       __INFO   ( x2 x1 -- x2 x1 bool ) bool: x2 < x1{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup >
dnl # ( x1 x2 -- x1 x2 bool )
define({_2DUP_GT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_GT},{2dup >},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_GT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_2DUP_GT2A{}dnl
__{}__ASM_TOKEN_AAPUSH   ( x2 x1 -- x2 x1 bool ) bool: x2 > x1{}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup <=
dnl # ( x1 x2 -- x1 x2 bool )
define({_2DUP_LE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_LE},{2dup <=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_LE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    push DE             ; 1:11      __INFO   DE <= HL
__{}    ex   DE, HL         ; 1:4       __INFO   HL <= DE
__{}    scf                 ; 1:4       __INFO   HL - DE - carry < 0
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    rra                 ; 1:4       __INFO   carry --> sign
__{}    xor   H             ; 1:4       __INFO
__{}    xor   D             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO   sign --> carry
__{}    sbc   A, A          ; 1:4       __INFO   0x00 or 0xff
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   ( x2 x1 -- x2 x1 bool ) bool: x2 < x1{}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup >=
dnl # ( x1 x2 -- x1 x2 bool )
define({_2DUP_GE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_GE},{2dup >=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_GE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__ASM_TOKEN_2DUP_GE2A{}dnl
__{}__ASM_TOKEN_AAPUSH   ( x2 x1 -- x2 x1 bool ) bool: x2 >= x1{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------------------- rot condition --------------------------
dnl
dnl
dnl
dnl # rot =
dnl # ( x3 x2 x1 -- x2 bool ) bool: x3 == x1
define({ROT_EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_EQ},{rot =},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 bool ) bool: x3 == x1
__{}    xor   A             ; 1:4       __INFO   A = 0x00
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl
dnl # rot <>
dnl # ( x3 x2 x1 -- x2 bool ) bool: x3 <> x1
define({ROT_NE},{dnl
__{}__ADD_TOKEN({__TOKEN_ROT_NE},{rot <>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ROT_NE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}    pop  BC             ; 1:10      __INFO   ( x3 x2 x1 -- x2 bool ) bool: x3 <> x1
__{}    xor   A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------------------- unsigned condition --------------------------
dnl
dnl
dnl
dnl # ( x1 x2 -- x )
dnl # equal ( x1 == x2 )
define({UEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_EQ},{u=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UEQ},{dnl
__{}__ASM_TOKEN_EQ{}dnl
}){}dnl
dnl
dnl # ( x1 x2 -- x )
dnl # not equal ( x1 <> x2 )
define({UNE},{dnl
__{}__ADD_TOKEN({__TOKEN_NE},{u<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UNE},{dnl
__{}__ASM_TOKEN_NE{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # unsigned ( x2 < x1 ) --> ( x2 - x1 < 0 ) --> carry is true
define({ULT},{dnl
__{}__ADD_TOKEN({__TOKEN_ULT},{u<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ULT},{dnl
__{}define({__INFO},{ult}){}dnl

                        ;[7:41]     u<
    ld    A, E          ; 1:4       u<   DE<HL --> DE-HL<0 --> carry if true
    sub   L             ; 1:4       u<   DE<HL --> DE-HL<0 --> carry if true
    ld    A, D          ; 1:4       u<   DE<HL --> DE-HL<0 --> carry if true
    sbc   A, H          ; 1:4       u<   DE<HL --> DE-HL<0 --> carry if true
    sbc  HL, HL         ; 2:15      u<
    pop  DE             ; 1:10      u<}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # unsigned ( x2 <= x1 ) --> ( x2 < x1 + 1 ) --> ( x2 - x1 - 1 < 0) --> carry is true
dnl # unsigned ( x2 <= x1 ) --> ( 0 <= x1 - x2 ) --> no carry is true
define({ULE},{dnl
__{}__ADD_TOKEN({__TOKEN_ULE},{u<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_ULE},{dnl
__{}define({__INFO},{ule}){}dnl

    scf                 ; 1:4       u<=
    ex   DE, HL         ; 1:4       u<=
    sbc  HL, DE         ; 2:15      u<=
    sbc  HL, HL         ; 2:15      u<=
    pop  DE             ; 1:10      u<=}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # unsigned ( x2 > x1 ) --> ( 0 > x1 - x2 ) --> carry is true
define({UGT},{dnl
__{}__ADD_TOKEN({__TOKEN_UGT},{u>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UGT},{dnl
__{}define({__INFO},{ugt}){}dnl

    or    A             ; 1:4       u>
    sbc  HL, DE         ; 2:15      u>
    sbc  HL, HL         ; 2:15      u>
    pop  DE             ; 1:10      u>}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x )
dnl # unsigned ( x2 >= x1 ) --> ( x2 + 1 > x1 ) --> ( 0 > x1 - x2 - 1 ) --> carry is true
define({UGE},{dnl
__{}__ADD_TOKEN({__TOKEN_UGE},{u>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_UGE},{dnl
__{}define({__INFO},{uge}){}dnl

    scf                 ; 1:4       u>=
    sbc  HL, DE         ; 2:15      u>=
    sbc  HL, HL         ; 2:15      u>=
    pop  DE             ; 1:10      u>=}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 bool )  bool: x1 u< x2
define({OVER_ULT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_ULT},{over u<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_ULT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    or    A             ; 1:4       __INFO   ( x2 x1 -- x2 bool )  bool: x1 u< x2
    sbc  HL, DE         ; 2:15      __INFO   HL<DE --> HL-DE<0 --> carry if true
    sbc  HL, HL         ; 2:15      __INFO   HL<DE --> HL-DE<0 --> carry if true}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 bool )  bool: x1 u<= x2
define({OVER_ULE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_ULE},{over u<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_ULE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    scf                 ; 1:4       __INFO   ( x2 x1 -- x2 bool )  bool: x1 u<= x2
    sbc  HL, DE         ; 2:15      __INFO   HL<=DE --> HL-DE-carry<0 --> carry if true
    sbc  HL, HL         ; 2:15      __INFO   HL<=DE --> HL-DE-carry<0 --> carry if true}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 bool )  bool: x1 u>= x2
define({OVER_UGE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_UGE},{over u>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_UGE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    scf                 ; 1:4       __INFO   ( x2 x1 -- x2 bool )  bool: x1 u>= x2
    ld    A, E          ; 1:4       __INFO   HL>=DE --> 0>DE-HL-carry --> carry if true
    sbc   A, L          ; 1:4       __INFO   HL>=DE --> 0>DE-HL-carry --> carry if true
    ld    A, D          ; 1:4       __INFO   HL>=DE --> 0>DE-HL-carry --> carry if true
    sbc   A, H          ; 1:4       __INFO   HL>=DE --> 0>DE-HL-carry --> carry if true
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 bool )  bool: x1 u> x2
define({OVER_UGT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_UGT},{over u>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_UGT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x2 bool )  bool: x1 u> x2
    sub   L             ; 1:4       __INFO   HL>DE --> 0>DE-HL --> carry if true
    ld    A, D          ; 1:4       __INFO   HL>DE --> 0>DE-HL --> carry if true
    sbc   A, H          ; 1:4       __INFO   HL>DE --> 0>DE-HL --> carry if true
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # ------------------------- push unsigned condition --------------------------
dnl
dnl
dnl
dnl # ( x -- x|n )
dnl # x = x | n
define({PUSH_UEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_EQ},{$1 u=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_UEQ},{dnl
__{}__ASM_TOKEN_PUSH_EQ($@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f )
dnl # f = x <> $1
define({PUSH_UNE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_NE},{$1 u<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_UNE},{dnl
__{}__ASM_TOKEN_PUSH_NE($@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x u< $1
define({PUSH_ULT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_ULT},{$1 u<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_ULT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HEX_HL($1),0x0000,{
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: min},

__{}__NOT_USE_BC:__HAS_PTR($1),1:1,{
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   HL<$1 --> 0<=$1-HL-carry --> true if not carry
__{}__{}    sbc   A, L          ; 1:4       __INFO   HL<$1 --> 0<=$1-HL-carry --> true if not carry
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO   HL<$1 --> 0<=$1-HL-carry --> true if not carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL<$1 --> 0<=$1-HL-carry --> true if not carry
__{}__{}    ccf                 ; 1:4       __INFO   invert carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer and BC save},

__{}1,1,{dnl # lepsi reseni! optimalizuje vic veci...
__{}__{}define({$0_CODE},__MAKE_CODE_SUB_STREAM(BC,
__{}__{}__{}L,ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,0)},__IS_NUM($1),1,__HEX_L($1),__SIMPLIFY_EXPRESSION(255&($1))),
__{}__{}__{}H,ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,1)},__IS_NUM($1),1,__HEX_H($1),__SIMPLIFY_EXPRESSION(255&(($1)>>8))))){}dnl
__{}__{}$0_CODE{}dnl
__{}__{}__ASM_TOKEN_DROP_CF_FETCH{}dnl
__{}},

__{}__HAS_PTR($1),1,{
__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sub   C             ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sbc   A, B          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HEX_HL($1),0x0001,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min+1},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max},

__{}__{}__HEX_L($1),0x00,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1 --> HL-__HEX_HL($1)<0
__{}__{}    sub  __HEX_H($1)           ; 2:7       __INFO   HL<$1 --> H-__HEX_H($1)-never_carry<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: lo is zero},

__{}__IS_NUM($1),0,{
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sub  __FORM({%-15s},$1); 2:7       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sbc   A, high __FORM({%-6s},$1); 2:7       __INFO   HL<$1 --> HL-$1<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable},

__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<$1 --> L-__HEX_L($1)<0 --> true if carry
__{}__{}    sub  __HEX_L($1)           ; 2:7       __INFO   HL<$1 --> L-__HEX_L($1)<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1 --> H-__HEX_H($1)<0 --> true if carry
__{}__{}    sbc   A, __HEX_H($1)       ; 2:7       __INFO   HL<$1 --> H-__HEX_H($1)<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: default{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x u<= $1
define({PUSH_ULE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_ULE},{$1 u<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_ULE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: max},

__{}__HAS_PTR($1),1,{
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    sub   L             ; 1:4       __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL<=$1 --> 0<=$1-HL --> true if not carry
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__IS_NUM($1),0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION(1+$1)){}dnl
__{}__{}  if (65535 & ($1+1))
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<=$1 --> HL<$1+1
__{}__{}    sub  __FORM({%-15s},$0_TMP); 2:7       __INFO   HL<$0_TMP --> HL-$1-1<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$0_TMP --> HL-$1-1<0 --> true if carry
__{}__{}    sbc   A, high __FORM({%-6s},$0_TMP); 2:7       __INFO   HL<$0_TMP --> HL-$1-1<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}  else
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: max
__{}__{}  endif},

__{}1,1,{dnl # lepsi reseni! optimalizuje vic veci... napriklad 0xCC34 --> 0xCC --> cpl --> 0x33
__{}__{}__RESET_SUMS{}dnl
__{}__{}define({$0_CODE_ULE},__MAKE_CODE_SUB_STREAM(BC,
__{}__{}__{}L,__HEX_L($1+1),
__{}__{}__{}H,__HEX_H($1+1))){}dnl
__{}__{}define({$0_P_ULE},eval(__SUM_CLOCKS+__BYTE_PRICE*__SUM_BYTES)){}dnl
__{}__{}__RESET_SUMS{}dnl
__{}__{}define({$0_CODE_UGT},__MAKE_CODE_SUB_STREAM(BC,
__{}__{}__{}__HEX_L($1),L,
__{}__{}__{}__HEX_H($1),H)){}dnl
__{}__{}define({$0_P_UGT},eval(4+__SUM_CLOCKS+__BYTE_PRICE*(1+__SUM_BYTES))){}dnl
__{}__{}ifelse(eval($0_P_ULE<=$0_P_UGT),1,{dnl
__{}__{}__{}$0_CODE_ULE},
__{}__{}{dnl
__{}__{}__{}$0_CODE_UGT
__{}__{}__{}    ccf                 ; 1:4       __INFO}){}dnl
__{}__{}__ASM_TOKEN_DROP_CF_FETCH{}dnl
__{}},

__{}__HEX_HL($1),0x0000,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<=$1
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min},

__{}__HEX_HL($1),0xFFFE,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max-1},

__{}__{}__HEX_L($1),0xFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<=$1 --> HL-__HEX_HL($1+1)<0
__{}__{}    sub  __HEX_H($1+1)           ; 2:7       __INFO   H-__HEX_H($1+1)-never_carry<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: lo is 255},

__{}__HEX_H($1),__HEX_L($1),{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL<=__HEX_HL($1) --> 0<=__HEX_HL($1)-HL
__{}__{}    cp    L             ; 1:4       __INFO   HL<=__HEX_HL($1) --> 0<=__HEX_L($1)-L --> true if not carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL<=__HEX_HL($1) --> 0<=__HEX_H($1)-H --> true if not carry
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo},

__{}{
__{}__{}    ld    A, L          ; 1:4       __INFO   HL<=$1 --> HL<$1+1
__{}__{}    sub  __HEX_L($1+1)           ; 2:7       __INFO   HL<$1+1 --> L-__HEX_L($1+1)<0 --> true if carry
__{}__{}    ld    A, H          ; 1:4       __INFO   HL<$1+1 --> H-__HEX_H($1)<0 --> true if carry
__{}__{}    sbc   A, __HEX_H($1+1)       ; 2:7       __INFO   HL<$1+1 --> H-__HEX_H($1+1)<0 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: default{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x u>= $1
define({PUSH_UGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_UGE},{$1 u>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_UGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HEX_HL($1),0x0000,{
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: min},

__{}__HAS_PTR($1),1,{
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   HL>=$1 --> 0>$1-HL-carry --> true if carry
__{}__{}    sbc   A, L          ; 1:4       __INFO   HL>=$1 --> 0>$1-HL-carry --> true if carry
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO   HL>=$1 --> 0>$1-HL-carry --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>=$1 --> 0>$1-HL-carry --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__IS_NUM($1),0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION(-($1))){}dnl
__{}__{}  if ($1)
__{}__{}    ld   BC, __FORM({%-11s},$0_TMP); 3:10      __INFO   HL>=$1 --> HL+0x10000-$1>=0x10000 --> HL+$0_TMP>=65536
__{}__{}    add  HL, BC         ; 1:11      __INFO   HL>=$1 --> HL+$0_TMP>=65536 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}  else
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: min
__{}__{}  endif},

__{}1,1,{dnl # lepsi reseni! optimalizuje vic veci... napriklad 0xCC34 --> 0xCC --> cpl --> 0x33
__{}__{}__RESET_SUMS{}dnl
__{}__{}define({$0_CODE},__MAKE_CODE_SUB_STREAM(BC,
__{}__{}__{}__HEX_L($1-1),L,
__{}__{}__{}__HEX_H($1-1),H)){}dnl
__{}__{}ifelse(__HAS_PTR($1):eval(__SUM_CLOCKS+__SUM_BYTES*__BYTE_PRICE>21+4*__BYTE_PRICE),0:1,{
__{}__{}__{}    ld   BC, __HEX_HL(-($1))     ; 3:10      __INFO   HL>=$1 --> HL+0x10000-$1>=0x10000 --> HL+__HEX_HL((-$1))>=65536
__{}__{}__{}    add  HL, BC         ; 1:11      __INFO   HL>=$1 --> HL+__HEX_HL(-($1))>=65536 --> true if carry},
__{}__{}{$0_CODE}){}dnl
__{}__{}__ASM_TOKEN_DROP_CF_FETCH{}dnl
__{}},

__{}__HEX_HL($1),0x0001,{
__{}__{}dnl # lepsi je "xor A + cp L + sbc A,H"
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min+1},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>=$1
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max},

__{}__NOT_USE_BC:__IS_NUM($1),1:0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION(-1+$1)){}dnl
__{}__{}  if ($1)
__{}__{}    ld    A, __FORM({%-11s},$0_TMP); 2:7       __INFO   HL>=$1 --> HL>$1-1
__{}__{}    sub   L             ; 1:4       __INFO   HL>$0_TMP --> 0>$0_TMP-HL --> true if carry
__{}__{}    ld    A, high __FORM({%-6s},$0_TMP); 2:7       __INFO   HL>$0_TMP --> 0>$0_TMP-HL --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$0_TMP --> 0>$0_TMP-HL --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}  else
__{}__{}  .warning The condition is always True!
__{}__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool, variant: min
__{}__{}  endif},

__{}__HEX_L($1),0x00,{
__{}__{}    ld    A, __HEX_H($1-1)       ; 2:7       __INFO   HL>=$1 --> 0>__HEX_HL($1-1)-HL
__{}__{}    sub   H             ; 1:4       __INFO   0>__HEX_H($1-1)-H-never_carry --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: lo is zero},

__{}__HEX_H($1-1),__HEX_L($1-1),{
__{}__{}    ld    A, __HEX_L($1-1)       ; 2:7       __INFO   HL>=$1 --> 0>$1-1-HL
__{}__{}    cp    L             ; 1:4       __INFO   HL>$1-1 -->  0> __HEX_L($1-1)-L --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1-1 -->  0> __HEX_H($1-1)-H --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo},

__{}__{}__NOT_USE_BC,1,{
__{}__{}    ld    A, __HEX_L($1-1)       ; 2:7       __INFO   HL>=$1 --> HL>$1-1
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1-1 --> 0>__HEX_L($1-1)-L --> true if carry
__{}__{}    ld    A, __HEX_H($1-1)       ; 2:7       __INFO   HL>$1-1 --> 0>__HEX_H($1-1)-H --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1-1 --> 0>__HEX_H($1-1)-H --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: BC save},

__{}{
__{}__{}    ld   BC, __HEX_HL(-($1))     ; 3:10      __INFO   HL>=$1 --> HL-$1>=0 --> HL+65536-$1>=65536
__{}__{}    add  HL, BC         ; 1:11      __INFO   HL>=$1 --> HL+__HEX_HL(-($1))>=65536 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: default and <> 0{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- f ) f: x u> $1
define({PUSH_UGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_UGT},{$1 u>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_UGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($#<1),1,{
__{}__{}.error {$0}(): Missing parameter!},

__{}eval($#>1),1,{
__{}__{}.error {$0}($@): $# parameters found in macro!},

__{}__HEX_HL($1),0xFFFF,{
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: max},

__{}__IS_NUM($1):__HAS_PTR($1),0:0,{
__{}__{}define({$0_TMP},__SIMPLIFY_EXPRESSION(0xFFFF-($1))){}dnl
__{}__{}  if (0xFFFF & ($1+1))
__{}__{}    ld   BC, __FORM({%-11s},$0_TMP); 3:10      __INFO   HL>$1 --> HL-$1-1>=0 --> HL+65535-$1>=65536
__{}__{}    add  HL, BC         ; 1:11      __INFO   HL>$1 --> HL+$0_TMP>=65536 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}  else
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: max
__{}__{}  endif},

__{}1,1,{dnl # lepsi reseni! optimalizuje vic veci...
__{}__{}__RESET_SUMS{}dnl
__{}__{}define({$0_CODE},__MAKE_CODE_SUB_STREAM(BC,
__{}__{}__{}ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,0)},__IS_NUM($1),1,__HEX_L($1),__SIMPLIFY_EXPRESSION(255&($1))),L,
__{}__{}__{}ifelse(__HAS_PTR($1),1,{__PTR_ADD($1,1)},__IS_NUM($1),1,__HEX_H($1),__SIMPLIFY_EXPRESSION(255&(($1)>>8))),H)){}dnl
__{}__{}ifelse(__HAS_PTR($1):eval(__SUM_CLOCKS+__SUM_BYTES*__BYTE_PRICE>21+4*__BYTE_PRICE),0:1,{
__{}__{}__{}    ld   BC, __HEX_HL(0xFFFF-($1))     ; 3:10      __INFO   HL>$1 --> HL-$1-1>=0 --> HL+65535-$1>=65536
__{}__{}__{}    add  HL, BC         ; 1:11      __INFO   HL>$1 --> HL+__HEX_HL(0xFFFF-($1))>=65536 --> true if carry},
__{}__{}{$0_CODE}){}dnl
__{}__{}__ASM_TOKEN_DROP_CF_FETCH{}dnl
__{}},

__{}__HAS_PTR($1),1,{
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,0)); 3:13      __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    ld    A, __FORM({%-11s},__PTR_ADD($1,1)); 3:13      __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: pointer},

__{}__HEX_HL($1),0x0000,{
__{}__{}dnl # lepsi je: "xor A + cp L + sbc A,H + sbc HL,HL" !!!
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    or    L             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: min},

__{}__HEX_HL($1),0xFFFE,{
__{}__{}    ld    A, H          ; 1:4       __INFO   HL>$1
__{}__{}    and   L             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: max-1},

__{}__NOT_USE_BC:__IS_NUM($1),1:0,{
__{}__{}  if (0xFFFF & ($1+1))
__{}__{}    ld    A, __FORM({%-11s},$1); 2:7       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    ld    A, high __FORM({%-6s},$1); 2:7       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1 --> 0>$1-HL --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: variable
__{}__{}  else
__{}__{}  .warning The condition is always False!
__{}__{}    ld   HL, 0x0000     ; 3:10      __INFO   HL = bool, variant: max
__{}__{}  endif},

__{}__{}__HEX_L($1),0xFF,{
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   HL>$1 --> 0>__HEX_HL($1)-HL
__{}__{}    sub   H             ; 1:4       __INFO   HL>$1 --> 0>__HEX_H($1)-H-never_carry --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: lo is 255},

__{}__HEX_H($1),__HEX_L($1),{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL>__HEX_HL($1) --> 0>__HEX_HL($1)-HL
__{}__{}    cp    L             ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>__HEX_HL($1) --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: hi == lo},

__{}__NOT_USE_BC,1,{
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO   HL>$1 --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    sub   L             ; 1:4       __INFO   HL>$1 --> 0>__HEX_L($1)-L --> true if carry
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO   HL>$1 --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    sbc   A, H          ; 1:4       __INFO   HL>$1 --> 0>__HEX_H($1)-H --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: BC save},

__{}{
__{}__{}    ld   BC, __HEX_HL(0xFFFF-($1))     ; 3:10      __INFO   HL>$1 --> HL-$1-1>=0 --> HL+65535-$1>=65536
__{}__{}    add  HL, BC         ; 1:11      __INFO   HL>$1 --> HL+__HEX_HL(0xFFFF-($1))>=65536 --> true if carry
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool, variant: default{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------------------- dup push unsigned condition --------------------------
dnl
dnl
dnl
dnl # ( x -- x bool )
dnl # equal ( x == $1 )
define({DUP_PUSH_UEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_EQ},{dup $1 u=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_UEQ},{dnl
__{}__ASM_TOKEN_DUP_PUSH_EQ($@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- x bool )
dnl # not equal ( x <> $1 )
define({DUP_PUSH_UNE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_NE},{dup $1 u<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_UNE},{dnl
__{}__ASM_TOKEN_DUP_PUSH_NE($@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- x bool )
dnl # unsigned ( x < $1 ) --> ( x - $1 < 0 ) --> carry is true
define({DUP_PUSH_ULT},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_ULT},{dup $1 u<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_ULT},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}define({__SUM_BYTES},8){}dnl
__{}define({__SUM_CLOCKS},46){}dnl
__{}define({__TMP_CODE},{dnl
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}dnl
__{}__{}__LD_R16(HL,$1){
__{}__{}    ld    A, E          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}__{}    sub   L             ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}__{}    ld    A, D          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}__{}    sbc   A, H          ; 1:4       __INFO   DE<HL --> DE-HL<0 --> carry if true
__{}__{}    sbc  HL, HL         ; 2:15      __INFO}){}dnl
__{}format({%36s},;[__SUM_BYTES:format({%-8s},__SUM_CLOCKS] ))__INFO   ( x -- x bool )
__{}__TMP_CODE{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- x bool )
dnl # unsigned ( x <= $1 ) --> ( x < $1 + 1 ) --> ( x - $1 - 1 < 0) --> carry is true
dnl # unsigned ( x <= $1 ) --> ( 0 <= $1 - x ) --> no carry is true
define({DUP_PUSH_ULE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_ULE},{dup $1 u<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_ULE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}define({__SUM_BYTES},8){}dnl
__{}define({__SUM_CLOCKS},59){}dnl
__{}define({__TMP_CODE},{dnl
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}dnl
__{}__{}__LD_R16(HL,$1){
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO
__{}__{}    pop  DE             ; 1:10      __INFO}){}dnl
__{}format({%36s},;[__SUM_BYTES:format({%-8s},__SUM_CLOCKS] ))__INFO   ( x -- x bool )
__{}__TMP_CODE{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- x bool )
dnl # unsigned ( x > $1 ) --> ( 0 > $1 - x ) --> carry is true
define({DUP_PUSH_UGT},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_UGT},{dup $1 u>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_UGT},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}define({__SUM_BYTES},8){}dnl
__{}define({__SUM_CLOCKS},59){}dnl
__{}define({__TMP_CODE},{dnl
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}dnl
__{}__{}__LD_R16(HL,$1){
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO
__{}__{}    pop  DE             ; 1:10      __INFO}){}dnl
__{}format({%36s},;[__SUM_BYTES:format({%-8s},__SUM_CLOCKS] ))__INFO   ( x -- x bool )
__{}__TMP_CODE{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x -- x bool )
dnl # unsigned ( x >= $1 ) --> ( x + 1 > $1 ) --> ( 0 > $1 - x - 1 ) --> carry is true
define({DUP_PUSH_UGE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_UGE},{dup $1 u>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_UGE},{dnl
__{}define({__INFO},__COMPILE_INFO)
__{}define({__SUM_BYTES},8){}dnl
__{}define({__SUM_CLOCKS},59){}dnl
__{}define({__TMP_CODE},{dnl
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO}dnl
__{}__{}__LD_R16(HL,$1){
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    sbc  HL, DE         ; 2:15      __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO
__{}__{}    pop  DE             ; 1:10      __INFO}){}dnl
__{}format({%36s},;[__SUM_BYTES:format({%-8s},__SUM_CLOCKS] ))__INFO   ( x -- x bool )
__{}__TMP_CODE{}dnl
}){}dnl
dnl
dnl
dnl
dnl # ------------- single shifts ----------------
dnl
dnl # ( x u -- x)
dnl # shifts x left u places
define({LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_LSHIFT},{lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_LSHIFT},{dnl
__{}define({__INFO},{lshift}){}dnl
ifdef({USE_LSHIFT},,define({USE_LSHIFT},{}))
    call DE_LSHIFT      ; 3:17      <<   ( x1 u -- x1<<u )
    pop  DE             ; 1:10      <<}){}dnl
dnl
dnl
dnl # ( x u -- x)
dnl # shifts x right u places
define({RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_RSHIFT},{rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_RSHIFT},{dnl
__{}define({__INFO},{rshift}){}dnl
ifdef({USE_RSHIFT},,define({USE_RSHIFT},{}))
    call DE_RSHIFT      ; 3:17      >>   ( x1 u -- x1>>u )
    pop  DE             ; 1:10      >>}){}dnl
dnl
dnl
dnl # 1 <<
dnl # x 1 lshift
dnl # ( x -- x)
dnl # shifts x left 1 place
define({_1LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_1LSHIFT},{1 lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1LSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO   ( u -- u<<1 )}){}dnl
dnl
dnl
dnl # 2 <<
dnl # x 2 lshift
dnl # ( x -- x)
dnl # shifts x left 2 places
define({_2LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_2LSHIFT},{2 lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2LSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO   ( u -- u<<2 )
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 3 <<
dnl # x 3 lshift
dnl # ( x -- x)
dnl # shifts x left 3 places
define({_3LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_3LSHIFT},{3 lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3LSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO   ( u -- u<<3 )
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 4 <<
dnl # x 4 lshift
dnl # ( x -- x)
dnl # shifts x left 4 places
define({_4LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_4LSHIFT},{4 lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4LSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO   ( u -- u<<4 )
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 5 <<
dnl # x 5 lshift
dnl # ( x -- x)
dnl # shifts x left 5 places
define({_5LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_5LSHIFT},{5 lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_5LSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO   ( u -- u<<5 )
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO}){}dnl
dnl
dnl
dnl # 6 <<
dnl # x 6 lshift
dnl # ( x -- x)
dnl # shifts x left 6 places
define({_6LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_6LSHIFT},{6lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_6LSHIFT},{dnl
__{}define({__INFO},{6lshift}){}dnl

                       ;[12:47]     6 lshift   ( u -- u<<6 )
    ld    A, H          ; 1:4       6 lshift
    and   0x03          ; 2:7       6 lshift   .... ..98   7654 3210
    rra                 ; 1:4       6 lshift   .... ...9 8 7654 3210
    rr    L             ; 2:8       6 lshift   .... ...9   8765 4321 0
    rra                 ; 1:4       6 lshift   0... .... 9 8765 4321
    rr    L             ; 2:8       6 lshift   0... ....   9876 5432 1
    rra                 ; 1:4       6 lshift   10.. .... . 9876 5432
    ld    H, L          ; 1:4       6 lshift
    ld    L, A          ; 1:4       6 lshift}){}dnl
dnl
dnl
dnl # 7 <<
dnl # x 7 lshift
dnl # ( x -- x)
dnl # shifts x left 7 places
define({_7LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_7LSHIFT},{7lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_7LSHIFT},{dnl
__{}define({__INFO},{7lshift}){}dnl

                        ;[8:32]     7 lshift   ( u -- u<<7 )
    xor   A             ; 1:4       7 lshift
    srl   H             ; 2:8       7 lshift
    rr    L             ; 2:8       7 lshift
    ld    H, L          ; 1:4       7 lshift
    rra                 ; 1:4       7 lshift
    ld    L, A          ; 1:4       7 lshift}){}dnl
dnl
dnl
dnl # 8 <<
dnl # x 8 lshift
dnl # ( x -- x)
dnl # shifts x left 8 places
define({_8LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_8LSHIFT},{8lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_8LSHIFT},{dnl
__{}define({__INFO},{8lshift}){}dnl

    ld    H, L          ; 1:4       8 lshift   ( u -- u<<8 )
    ld    L, 0x00       ; 2:7       8 lshift}){}dnl
dnl
dnl
dnl # 9 <<
dnl # x 9 lshift
dnl # ( x -- x)
dnl # shifts x left 9 places
define({_9LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_9LSHIFT},{9lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_9LSHIFT},{dnl
__{}define({__INFO},{9lshift}){}dnl

    sla   L             ; 2:8       9 lshift   ( u -- u<<9 )
    ld    H, L          ; 1:4       9 lshift
    ld    L, 0x00       ; 2:7       9 lshift}){}dnl
dnl
dnl
dnl # 10 <<
dnl # x 10 lshift
dnl # ( x -- x)
dnl # shifts x left 10 places
define({_10LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_10LSHIFT},{10lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_10LSHIFT},{dnl
__{}define({__INFO},{10lshift}){}dnl

    ld    A, L          ; 1:4       10 lshift   ( u -- u<<10 )
    add   A, A          ; 1:4       10 lshift
    add   A, A          ; 1:4       10 lshift
    ld    H, A          ; 1:4       10 lshift
    ld    L, 0x00       ; 2:7       10 lshift}){}dnl
dnl
dnl
dnl # 11 <<
dnl # x 11 lshift
dnl # ( x -- x)
dnl # shifts x left 11 places
define({_11LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_11LSHIFT},{11lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_11LSHIFT},{dnl
__{}define({__INFO},{11lshift}){}dnl

    ld    A, L          ; 1:4       11 lshift   ( u -- u<<11 )
    add   A, A          ; 1:4       11 lshift
    add   A, A          ; 1:4       11 lshift
    add   A, A          ; 1:4       11 lshift
    ld    H, A          ; 1:4       11 lshift
    ld    L, 0x00       ; 2:7       11 lshift}){}dnl
dnl
dnl
dnl # 12 <<
dnl # x 12 lshift
dnl # ( x -- x)
dnl # shifts x left 12 places
define({_12LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_12LSHIFT},{12lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_12LSHIFT},{dnl
__{}define({__INFO},{12lshift}){}dnl

    ld    A, L          ; 1:4       12 lshift   ( u -- u<<12 )
    add   A, A          ; 1:4       12 lshift
    add   A, A          ; 1:4       12 lshift
    add   A, A          ; 1:4       12 lshift
    add   A, A          ; 1:4       12 lshift
    ld    H, A          ; 1:4       12 lshift
    ld    L, 0x00       ; 2:7       12 lshift}){}dnl
dnl
dnl
dnl # 13 <<
dnl # x 13 lshift
dnl # ( x -- x)
dnl # shifts x left 13 places
define({_13LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_13LSHIFT},{13lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_13LSHIFT},{dnl
__{}define({__INFO},{13lshift}){}dnl

    ld    A, L          ; 1:4       13 lshift   ( u -- u<<13 )
    rrca                ; 1:4       13 lshift
    rrca                ; 1:4       13 lshift
    rrca                ; 1:4       13 lshift
    and  0xE0           ; 2:7       13 lshift
    ld    H, A          ; 1:4       13 lshift
    ld    L, 0x00       ; 2:7       13 lshift}){}dnl
dnl
dnl
dnl # 14 <<
dnl # x 14 lshift
dnl # ( x -- x)
dnl # shifts x left 14 places
define({_14LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_14LSHIFT},{14lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_14LSHIFT},{dnl
__{}define({__INFO},{14lshift}){}dnl

    ld    A, L          ; 1:4       14 lshift   ( u -- u<<14 )
    rrca                ; 1:4       14 lshift
    rrca                ; 1:4       14 lshift
    and  0xC0           ; 2:7       14 lshift
    ld    H, A          ; 1:4       14 lshift
    ld    L, 0x00       ; 2:7       14 lshift}){}dnl
dnl
dnl
dnl # 15 <<
dnl # x 15 lshift
dnl # ( x -- x)
dnl # shifts x left 15 places
define({_15LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_15LSHIFT},{15lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_15LSHIFT},{dnl
__{}define({__INFO},{15lshift}){}dnl

    xor   A             ; 1:4       15 lshift   ( u -- u<<15 )
    rr    L             ; 2:8       15 lshift
    ld    L, A          ; 1:4       15 lshift
    rra                 ; 1:4       15 lshift
    ld    H, A          ; 1:4       15 lshift}){}dnl
dnl
dnl
dnl # 16 <<
dnl # x 16 lshift
dnl # ( x -- x)
dnl # shifts x left 16 places
define({_16LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_16LSHIFT},{16lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_16LSHIFT},{dnl
__{}define({__INFO},{16lshift}){}dnl

    ld   HL, 0x0000     ; 3:10      16 lshift   ( u -- u<<16 )}){}dnl
dnl
dnl
dnl
dnl # 1 >>
dnl # x 1 rshift
dnl # ( u -- u )
dnl # shifts u right 1 place
define({_1RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_1RSHIFT},{1rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1RSHIFT},{dnl
__{}define({__INFO},{1rshift}){}dnl

    srl   H             ; 2:8       1 rshift   ( u -- u>>1 )
    rr    L             ; 2:8       1 rshift}){}dnl
dnl
dnl
dnl # 2 >>
dnl # x 2 rshift
dnl # ( u -- u )
dnl # shifts u right 2 places
define({_2RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_2RSHIFT},{2rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2RSHIFT},{dnl
__{}define({__INFO},{2rshift}){}dnl

    srl   H             ; 2:8       2 rshift   ( u -- u>>2 )
    rr    L             ; 2:8       2 rshift
    srl   H             ; 2:8       2 rshift
    rr    L             ; 2:8       2 rshift}){}dnl
dnl
dnl
dnl # 3 >>
dnl # x 3 rshift
dnl # ( u -- u )
dnl # shifts u right 3 places
define({_3RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_3RSHIFT},{3rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_3RSHIFT},{dnl
__{}define({__INFO},{3rshift}){}dnl

    ld    A, L          ; 1:4       3 rshift   ( u -- u>>3 )
    srl   H             ; 2:8       3 rshift
    rra                 ; 1:4       3 rshift
    srl   H             ; 2:8       3 rshift
    rra                 ; 1:4       3 rshift
    srl   H             ; 2:8       3 rshift
    rra                 ; 1:4       3 rshift
    ld    L, A          ; 1:4       3 rshift}){}dnl
dnl
dnl
dnl # 4 >>
dnl # x 4 rshift
dnl # ( u -- u )
dnl # shifts u right 4 places
define({_4RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_4RSHIFT},{4rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4RSHIFT},{dnl
__{}define({__INFO},{4rshift}){}dnl

    ld    A, L          ; 1:4       4 rshift   ( u -- u>>4 )
    srl   H             ; 2:8       4 rshift
    rra                 ; 1:4       4 rshift
    srl   H             ; 2:8       4 rshift
    rra                 ; 1:4       4 rshift
    srl   H             ; 2:8       4 rshift
    rra                 ; 1:4       4 rshift
    srl   H             ; 2:8       4 rshift
    rra                 ; 1:4       4 rshift
    ld    L, A          ; 1:4       4 rshift}){}dnl
dnl
dnl
dnl
dnl # 5 >>
dnl # u 5 rshift
dnl # ( u -- u )
dnl # shifts u right 5 places
define({_5RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_5RSHIFT},{5rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_5RSHIFT},{dnl
__{}define({__INFO},{5rshift}){}dnl

    xor   A             ; 1:4       5 rshift   ( u -- u>>5 )
    add  HL, HL         ; 1:11      5 rshift
    adc   A, A          ; 1:4       5 rshift
    add  HL, HL         ; 1:11      5 rshift
    adc   A, A          ; 1:4       5 rshift
    add  HL, HL         ; 1:11      5 rshift
    adc   A, A          ; 1:4       5 rshift
    ld    L, H          ; 1:4       5 rshift
    ld    H, A          ; 1:4       5 rshift}){}dnl
dnl
dnl
dnl
dnl # 6 >>
dnl # u 6 rshift
dnl # ( u -- u )
dnl # shifts u right 6 places
define({_6RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_6RSHIFT},{6rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_6RSHIFT},{dnl
__{}define({__INFO},{6rshift}){}dnl

    xor   A             ; 1:4       6 rshift   ( u -- u>>6 )
    add  HL, HL         ; 1:11      6 rshift
    adc   A, A          ; 1:4       6 rshift
    add  HL, HL         ; 1:11      6 rshift
    adc   A, A          ; 1:4       6 rshift
    ld    L, H          ; 1:4       6 rshift
    ld    H, A          ; 1:4       6 rshift}){}dnl
dnl
dnl
dnl
dnl # 7 >>
dnl # u 7 rshift
dnl # ( u -- u )
dnl # shifts u right 7 places
define({_7RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_7RSHIFT},{7rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_7RSHIFT},{dnl
__{}define({__INFO},{7rshift}){}dnl

    xor   A             ; 1:4       7 rshift   ( u -- u>>7 )
    add  HL, HL         ; 1:11      7 rshift
    adc   A, A          ; 1:4       7 rshift
    ld    L, H          ; 1:4       7 rshift
    ld    H, A          ; 1:4       7 rshift}){}dnl
dnl
dnl
dnl # 8 >>
dnl # u 8 rshift
dnl # ( u -- u )
dnl # shifts u right 8 places
define({_8RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_8RSHIFT},{8rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_8RSHIFT},{dnl
__{}define({__INFO},{8rshift}){}dnl

    ld    L, H          ; 1:4       8 rshift   ( u -- u>>8 )
    ld    H, 0x00       ; 2:7       8 rshift}){}dnl
dnl
dnl
dnl # 9 >>
dnl # u 9 rshift
dnl # ( u -- u )
dnl # shifts u right 9 places
define({_9RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_9RSHIFT},{9rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_9RSHIFT},{dnl
__{}define({__INFO},{9rshift}){}dnl

    srl   H             ; 2:8       9 rshift   ( u -- u>>9 )
    ld    L, H          ; 1:4       9 rshift
    ld    H, 0x00       ; 2:7       9 rshift}){}dnl
dnl
dnl
dnl # 10 >>
dnl # u 10 rshift
dnl # ( u -- u )
dnl # shifts u right 10 places
define({_10RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_10RSHIFT},{10rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_10RSHIFT},{dnl
__{}define({__INFO},{10rshift}){}dnl

    srl   H             ; 2:8       10 rshift   ( u -- u>>10 )
    srl   H             ; 2:8       10 rshift
    ld    L, H          ; 1:4       10 rshift
    ld    H, 0x00       ; 2:7       10 rshift}){}dnl
dnl
dnl
dnl # 11 >>
dnl # u 11 rshift
dnl # ( u -- u )
dnl # shifts u right 11 places
define({_11RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_11RSHIFT},{11rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_11RSHIFT},{dnl
__{}define({__INFO},{11rshift}){}dnl

    ld    A, H          ; 1:4       11 rshift   ( u -- u>>11 )
    and  0xF8           ; 2:7       11 rshift
    rrca                ; 1:4       11 rshift
    rrca                ; 1:4       11 rshift
    rrca                ; 1:4       11 rshift
    ld    L, A          ; 1:4       11 rshift
    ld    H, 0x00       ; 2:7       11 rshift}){}dnl
dnl
dnl
dnl # 12 >>
dnl # u 12 rshift
dnl # ( u -- u )
dnl # shifts u right 12 places
define({_12RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_12RSHIFT},{12rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_12RSHIFT},{dnl
__{}define({__INFO},{12rshift}){}dnl

    ld    A, H          ; 1:4       12 rshift   ( u -- u>>12 )
    and  0xF0           ; 2:7       12 rshift
    rrca                ; 1:4       12 rshift
    rrca                ; 1:4       12 rshift
    rrca                ; 1:4       12 rshift
    rrca                ; 1:4       12 rshift
    ld    L, A          ; 1:4       12 rshift
    ld    H, 0x00       ; 2:7       12 rshift}){}dnl
dnl
dnl
dnl # 13 >>
dnl # u 13 rshift
dnl # ( u -- u )
dnl # shifts u right 13 places
define({_13RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_13RSHIFT},{13rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_13RSHIFT},{dnl
__{}define({__INFO},{13rshift}){}dnl

    ld    A, H          ; 1:4       13 rshift   ( u -- u>>13 )
    and  0xE0           ; 2:7       13 rshift
    rlca                ; 1:4       13 rshift
    rlca                ; 1:4       13 rshift
    rlca                ; 1:4       13 rshift
    ld    L, A          ; 1:4       13 rshift
    ld    H, 0x00       ; 2:7       13 rshift}){}dnl
dnl
dnl
dnl # 14 >>
dnl # u 14 rshift
dnl # ( u -- u )
dnl # shifts u right 14 places
define({_14RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_14RSHIFT},{14rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_14RSHIFT},{dnl
__{}define({__INFO},{14rshift}){}dnl

    ld    A, H          ; 1:4       14 rshift   ( u -- u>>14 )
    and  0xC0           ; 2:7       14 rshift
    rlca                ; 1:4       14 rshift
    rlca                ; 1:4       14 rshift
    ld    L, A          ; 1:4       14 rshift
    ld    H, 0x00       ; 2:7       14 rshift}){}dnl
dnl
dnl
dnl # 15 >>
dnl # u 15 rshift
dnl # ( u -- u )
dnl # shifts u right 15 places
define({_15RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_15RSHIFT},{15rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_15RSHIFT},{dnl
__{}define({__INFO},{15rshift}){}dnl

    xor   A             ; 1:4       15 rshift   ( u -- u>>15 )
    rl    H             ; 2:8       15 rshift
    ld    H, A          ; 1:4       15 rshift
    adc   A, A          ; 1:4       15 rshift
    ld    L, A          ; 1:4       15 rshift}){}dnl
dnl
dnl
dnl # 16 >>
dnl # u 16 rshift
dnl # ( u -- u )
dnl # shifts u right 16 places
define({_16RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_16RSHIFT},{16rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_16RSHIFT},{dnl
__{}define({__INFO},{16rshift}){}dnl

    ld   HL, 0x0000     ; 3:10      16 rshift   ( u -- u>>16 )}){}dnl
dnl
dnl
dnl
dnl # ( u -- u )
dnl # shifs u right $1 places
define({PUSH_RSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_RSHIFT},{$1 rshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_RSHIFT},{dnl
__{}define({__INFO},{push_rshift}){}dnl
ifelse($1,{},{
__{}__{}    .error {$0}(): Missing address parameter!},
__{}$#,{1},{dnl
__{}__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}__{}    .error {$0}($@): Pointer as parameter is not supported!},
__{}__{}__IS_NUM($1),{0},{
__{}__{}__{}    .error {$0}($@): M4 does not know the "{$1}" value and therefore cannot create the code!},
__{}__{}{dnl
__{}__{}__{}ifelse(eval($1),{0},{
__{}__{}__{}                        ;           $1 rshift},
__{}__{}__{}eval($1),{1},{__ASM_TOKEN_1RSHIFT},
__{}__{}__{}eval($1),{2},{__ASM_TOKEN_2RSHIFT},
__{}__{}__{}eval($1),{3},{__ASM_TOKEN_3RSHIFT},
__{}__{}__{}eval($1),{4},{__ASM_TOKEN_4RSHIFT},
__{}__{}__{}eval($1),{5},{__ASM_TOKEN_5RSHIFT},
__{}__{}__{}eval($1),{6},{__ASM_TOKEN_6RSHIFT},
__{}__{}__{}eval($1),{7},{__ASM_TOKEN_7RSHIFT},
__{}__{}__{}eval($1),{8},{__ASM_TOKEN_8RSHIFT},
__{}__{}__{}eval($1),{9},{__ASM_TOKEN_9RSHIFT},
__{}__{}__{}eval($1),{10},{__ASM_TOKEN_10RSHIFT},
__{}__{}__{}eval($1),{11},{__ASM_TOKEN_11RSHIFT},
__{}__{}__{}eval($1),{12},{__ASM_TOKEN_12RSHIFT},
__{}__{}__{}eval($1),{13},{__ASM_TOKEN_13RSHIFT},
__{}__{}__{}eval($1),{14},{__ASM_TOKEN_14RSHIFT},
__{}__{}__{}eval($1),{15},{__ASM_TOKEN_15RSHIFT},
__{}__{}__{}eval($1),{16},{__ASM_TOKEN_16RSHIFT},
__{}__{}__{}eval(($1)>16),{1},{
__{}__{}__{}                        ;           $1 rshift --> 16 rshift{}__ASM_TOKEN_16RSHIFT},
__{}__{}__{}{
__{}__{}__{}    .error {$0}($@): negative parameters found in macro! Use {PUSH_LSHIFT}(eval(-($1))).})})},
__{}__{}{
__{}__{}    .error {$0}($@): $# parameters found in macro!}){}dnl
}){}dnl
dnl
dnl
dnl # ( u -- u )
dnl # shifs u left $1 places
define({PUSH_LSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_LSHIFT},{$1 lshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_LSHIFT},{dnl
__{}define({__INFO},{push_lshift}){}dnl
ifelse($1,{},{
__{}__{}    .error {$0}(): Missing address parameter!},
__{}$#,{1},{dnl
__{}__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}__{}    .error {$0}($@): Pointer as parameter is not supported!},
__{}__{}__IS_NUM($1),{0},{
__{}__{}__{}    .error {$0}($@): M4 does not know the "{$1}" value and therefore cannot create the code!},
__{}__{}{dnl
__{}__{}__{}ifelse(eval($1),{0},{
__{}__{}__{}                        ;           $1 lshift},
__{}__{}__{}eval($1),{1},{__ASM_TOKEN_1LSHIFT},
__{}__{}__{}eval($1),{2},{__ASM_TOKEN_2LSHIFT},
__{}__{}__{}eval($1),{3},{__ASM_TOKEN_3LSHIFT},
__{}__{}__{}eval($1),{4},{__ASM_TOKEN_4LSHIFT},
__{}__{}__{}eval($1),{5},{__ASM_TOKEN_5LSHIFT},
__{}__{}__{}eval($1),{6},{__ASM_TOKEN_6LSHIFT},
__{}__{}__{}eval($1),{7},{__ASM_TOKEN_7LSHIFT},
__{}__{}__{}eval($1),{8},{__ASM_TOKEN_8LSHIFT},
__{}__{}__{}eval($1),{9},{__ASM_TOKEN_9LSHIFT},
__{}__{}__{}eval($1),{10},{__ASM_TOKEN_10LSHIFT},
__{}__{}__{}eval($1),{11},{__ASM_TOKEN_11LSHIFT},
__{}__{}__{}eval($1),{12},{__ASM_TOKEN_12LSHIFT},
__{}__{}__{}eval($1),{13},{__ASM_TOKEN_13LSHIFT},
__{}__{}__{}eval($1),{14},{__ASM_TOKEN_14LSHIFT},
__{}__{}__{}eval($1),{15},{__ASM_TOKEN_15LSHIFT},
__{}__{}__{}eval($1),{16},{__ASM_TOKEN_16LSHIFT},
__{}__{}__{}eval(($1)>16),{1},{
__{}__{}__{}                        ;           $1 lshift --> 16 lshift{}__ASM_TOKEN_16LSHIFT},
__{}__{}__{}{
__{}__{}__{}    .error {$0}($@): negative parameters found in macro! Use {PUSH_RSHIFT}(eval(-($1))).})})},
__{}__{}{
__{}__{}    .error {$0}($@): $# parameters found in macro!}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # -------------------------- 8 bits --------------------------
dnl
dnl
dnl
dnl # ( -- )
define({AND_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_AND_REG8_REG8},{and($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_AND_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $1 = $1 and $2
    and   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO
    ld    __FORM({%-14s},{$1, A}); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- )
define({OR_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_OR_REG8_REG8},{or($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_OR_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $1 = $1 or $2
    or    __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO
    ld    __FORM({%-14s},{$1, A}); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- )
define({XOR_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_XOR_REG8_REG8},{xor($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_XOR_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- )   $1 = $1 xor $2
    xor   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO
    ld    __FORM({%-14s},{$1, A}); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( c2 x1 -- x3 )  x3 = hi(x1) & (c2 & c1)
define({CAND},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CAND},{cand},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CAND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = hi(x1) + lo(x2 & x1)
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )  x3 = hi(x2 & x1) + lo(x1)
define({HAND},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HAND},{hand},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HAND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = hi(x2 & x1) + lo(x1)
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( c2 x1 -- x3 )  x3 = c2 | x1
define({COR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_COR},{cor},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_COR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( c2 x1 -- x3 )  x3 = c2 | x1
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )  x3 = hi(x2 | x1) + lo(x1)
define({HOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HOR},{hor},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = hi(x2 | x1) + lo(x1)
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( c2 c1 -- c2 c1 ) zero_flag zf: lo(c2 | c1) c+ 1
define({_2DUP_COR_1CADD_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_COR_1CADD_ZF_STORE},{2dup cor 1c+ zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_COR_1CADD_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( c2 c1 -- c2 c1 )  zero_flag: (c2 | c1) + 1
    or    L             ; 1:4       __INFO
    inc   A             ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( c2 x1 -- )  zero_flag = (c2 | x1) + 1
define({_2DUP_COR_1ADD_ZF_STORE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_COR_1ADD_ZF_STORE},{2dup cor 1+ zf!},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_COR_1ADD_ZF_STORE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( c2 x1 -- c2 x1 )  zero_flag = (c2 | x1) + 1
    or    L             ; 1:4       __INFO
    and   H             ; 1:4       __INFO
    inc   A             ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )  x3 = hi(x1) + lo(x2 ^ x1)
define({CXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CXOR},{cxor},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CXOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = hi(x1) + lo(x2 ^ x1)
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x3 )  x3 = hi(x2 ^ x1) + lo(x1)
define({HXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HXOR},{hxor},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HXOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x3 )   x3 = hi(x2 ^ x1) + lo(x1)
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = hi(x1) + lo(x2 & x1)
define({OVER_CAND},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CAND},{over cand},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CAND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )   x3 = hi(x1) + lo(x2 & x1)
    and   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = hi(x2 & x1) + lo(x1)
define({OVER_HAND},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HAND},{over hand},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HAND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )   x3 = hi(x2 & x1) + lo(x1)
    and   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = hi(x1) + lo(x2 | x1)
define({OVER_COR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_COR},{over cor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_COR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )   x3 = hi(x1) + lo(x2 | x1)
    or    L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = hi(x2 | x1) + lo(x1)
define({OVER_HOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HOR},{over hor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )   x3 = hi(x2 | x1) + lo(x1)
    or    H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = hi(x1) + lo(x2 ^ x1)
define({OVER_CXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CXOR},{over cxor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CXOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )   x3 = hi(x1) + lo(x2 ^ x1)
    xor   L             ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( x2 x1 -- x2 x3 )  x3 = hi(x2 ^ x1) + lo(x1)
define({OVER_HXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HXOR},{over hxor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HXOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO   ( x2 x1 -- x2 x3 )   x3 = hi(x2 ^ x1) + lo(x1)
    xor   H             ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( -- f )
define({EQ_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_EQ_REG8_REG8},{eq($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_EQ_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- f )   f = ($1 == $2)
    xor   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO
    sub  0x01           ; 2:7       __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- f )
define({NE_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_NE_REG8_REG8},{ne($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_NE_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- f )   f = ($1 <> $2)
    xor   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO
    add   A, 0xFF       ; 2:7       __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- f )
define({ULT_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_ULT_REG8_REG8},{ult($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_ULT_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- f )   f = ($1 < $2)
    sub   __FORM({%-14s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO   $1<$2 --> $1-$2<0 --> carry if true
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- f )
define({ULE_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_ULE_REG8_REG8},{ule($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_ULE_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   ( -- f )   f = ($1 <= $2) = ($1 < $2 + 1)
    scf                 ; 1:4       __INFO
    sbc   A, __FORM({%-11s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO   $1<$2+1 --> $1-$2-1<0 --> carry if true
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- f )
define({UGT_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_UGT_REG8_REG8},{ugt($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_UGT_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO   ( -- f )   f = ($1 > $2)
    sub   __FORM({%-14s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   $1>$2 --> 0>$2-$1 --> carry if true
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( -- f )
define({UGE_REG8_REG8},{dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{dnl
__{}__ADD_TOKEN({__TOKEN_UGE_REG8_REG8},{uge($1,$2)},$@){}dnl
})}){}dnl
dnl
define({__ASM_TOKEN_UGE_REG8_REG8},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(
eval($#<2),1,{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),1,{
__{}  .error {$0}($@): Unexpected parameter!},
__IS_REG($1),0,{
__{}  .error {$0}($@): $1 is not register name!},
__IS_REG($2),0,{
__{}  .error {$0}($@): $2 is not register name!},
{
    ld    A, __FORM({%-11s},$2); ifelse(len($2),1,{1:4},len($2),3,{2:8},{?:?})       __INFO   ( -- f )   f = ($1 >= $2) = ($1 + 1 > $2)
    scf                 ; 1:4       __INFO
    sbc   A, __FORM({%-11s},$1); ifelse(len($1),1,{1:4},len($1),3,{2:8},{?:?})       __INFO   $1+1>$2 --> 0>$2-$1-1 --> carry if true
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO
}){}dnl
}){}dnl
dnl
dnl
dnl
dnl #; ------- ccond ( c2 c1 -- bool ) ---------
dnl
dnl
dnl # c=
dnl # ( c2 c1 -- bool )
define({CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_CEQ},{c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CEQ_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- bool )  bool: lo(char2) c= lo(char1){}dnl
__{}__CODE_2DUP_CEQ_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # c<>
dnl # ( c2 c1 -- bool )
define({CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_CNE},{c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CNE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CNE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- bool )  bool: lo(char2) c<> lo(char1){}dnl
__{}__CODE_2DUP_CNE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # c<
dnl # ( c2 c1 -- bool )
define({CLT},{dnl
__{}__ADD_TOKEN({__TOKEN_CLT},{c<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CLT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- bool )  bool: lo(char2) c< lo(char1){}dnl
__{}__CODE_2DUP_CLT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # c<=
dnl # ( c2 c1 -- bool )
define({CLE},{dnl
__{}__ADD_TOKEN({__TOKEN_CLE},{c<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CLE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- bool )  bool: lo(char2) c<= lo(char1){}dnl
__{}__CODE_2DUP_CLE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # c>=
dnl # ( c2 c1 -- bool )
define({CGE},{dnl
__{}__ADD_TOKEN({__TOKEN_CGE},{c>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- bool )  bool: lo(char2) c>= lo(char1){}dnl
__{}__CODE_2DUP_CGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # c>
dnl # ( c2 c1 -- bool )
define({CGT},{dnl
__{}__ADD_TOKEN({__TOKEN_CGT},{c>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- bool )  bool: lo(char2) c> lo(char1){}dnl
__{}__CODE_2DUP_CGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # cu<
dnl # ( u2 u1 -- bool )
define({CULT},{dnl
__{}__ADD_TOKEN({__TOKEN_CULT},{cu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CULT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: lo(u2) cu< lo(u1){}dnl
__{}__CODE_2DUP_CULT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # cu<=
dnl # ( u2 u1 -- bool )
define({CULE},{dnl
__{}__ADD_TOKEN({__TOKEN_CULE},{cu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CULE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: lo(u2) cu<= lo(u1){}dnl
__{}__CODE_2DUP_CULE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # cu>=
dnl # ( u2 u1 -- bool )
define({CUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_CUGE},{cu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CUGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: lo(u2) cu>= lo(u1){}dnl
__{}__CODE_2DUP_CUGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # cu>
dnl # ( u2 u1 -- bool )
define({CUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_CUGT},{cu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CUGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: lo(u2) cu> lo(u1){}dnl
__{}__CODE_2DUP_CUGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ------------------ 2dup ccond ------------------
dnl
dnl
dnl # 2dup c=
dnl # ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c== lo(char1)
define({_2DUP_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CEQ},{2dup c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CEQ_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c= lo(char1){}dnl
__{}__CODE_2DUP_CEQ_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup c<>
dnl # ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c<> lo(char1)
define({_2DUP_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CNE},{2dup c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CNE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CNE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c<> lo(char1){}dnl
__{}__CODE_2DUP_CNE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup c<
dnl # ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c< lo(char1)
define({_2DUP_CLT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CLT},{2dup c<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CLT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c< lo(char1){}dnl
__{}__CODE_2DUP_CLT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup c<=
dnl # ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c<= lo(char1)
define({_2DUP_CLE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CLE},{2dup c<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CLE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c<= lo(char1){}dnl
__{}__CODE_2DUP_CLE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup c>=
dnl # ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c>= lo(char1)
define({_2DUP_CGE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CGE},{2dup c>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c>= lo(char1){}dnl
__{}__CODE_2DUP_CGE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup c>
dnl # ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c> lo(char1)
define({_2DUP_CGT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CGT},{2dup c>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 char1 bool )  bool: lo(char2) c> lo(char1){}dnl
__{}__CODE_2DUP_CGT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup cu<
dnl # ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu< lo(u1)
define({_2DUP_CULT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CULT},{2dup cu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CULT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu< lo(u1){}dnl
__{}__CODE_2DUP_CULT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup cu<=
dnl # ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu<= lo(u1)
define({_2DUP_CULE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CULE},{2dup cu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CULE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu<= lo(u1){}dnl
__{}__CODE_2DUP_CULE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup cu>=
dnl # ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu>= lo(u1)
define({_2DUP_CUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CUGE},{2dup cu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CUGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGE_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu>= lo(u1){}dnl
__{}__CODE_2DUP_CUGE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup cu>
dnl # ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu> lo(u1)
define({_2DUP_CUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_CUGT},{2dup cu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_CUGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGT_CF_STORE(E,L){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: lo(u2) cu> lo(u1){}dnl
__{}__CODE_2DUP_CUGT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl #; ------- over ccond ( u2 u1 -- u2 bool ) ---------
dnl
dnl
dnl # over c=
dnl #( char2 char1 -- char2 bool )  bool: lo(char1) c== lo(char2)
define({OVER_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CEQ},{over c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CEQ_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 bool )  bool: lo(char1) c= lo(char2){}dnl
__{}__CODE_2DUP_CEQ_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over c<>
dnl #( char2 char1 -- char2 bool )  bool: lo(char1) c<> lo(char2)
define({OVER_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CNE},{over c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CNE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CNE_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 bool )  bool: lo(char1) c<> lo(char2){}dnl
__{}__CODE_2DUP_CNE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over c<
dnl #( char2 char1 -- char2 bool )  bool: lo(char1) c< lo(char2)
define({OVER_CLT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CLT},{over c<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CLT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CLT_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 bool )  bool: lo(char1) c< lo(char2){}dnl
__{}__CODE_2DUP_CLT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over c<=
dnl #( char2 char1 -- char2 bool )  bool: lo(char1) c<= lo(char2)
define({OVER_CLE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CLE},{over c<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CLE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CLE_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 bool )  bool: lo(char1) c<= lo(char2){}dnl
__{}__CODE_2DUP_CLE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over c>=
dnl #( char2 char1 -- char2 bool )  bool: lo(char1) c>= lo(char2)
define({OVER_CGE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CGE},{over c>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CGE_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 bool )  bool: lo(char1) c>= lo(char2){}dnl
__{}__CODE_2DUP_CGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over c>
dnl #( char2 char1 -- char2 bool )  bool: lo(char1) c> lo(char2)
define({OVER_CGT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CGT},{over c>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CGT_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( char2 char1 -- char2 bool )  bool: lo(char1) c> lo(char2){}dnl
__{}__CODE_2DUP_CGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over cu<
dnl # ( u2 u1 -- u2 bool )  bool: lo(u1) cu< lo(u2)
define({OVER_CULT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CULT},{over cu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CULT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CULT_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: lo(u1) cu< lo(u2){}dnl
__{}__CODE_2DUP_CULT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over cu<=
dnl # ( u2 u1 -- u2 bool )  bool: lo(u1) cu<= lo(u2)
define({OVER_CULE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CULE},{over cu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CULE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CULE_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: lo(u1) cu<= lo(u2){}dnl
__{}__CODE_2DUP_CULE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over cu>=
dnl # ( u2 u1 -- u2 bool )  bool: lo(u1) cu>= lo(u2)
define({OVER_CUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CUGE},{over cu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CUGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CUGE_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: lo(u1) cu>= lo(u2){}dnl
__{}__CODE_2DUP_CUGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over cu>
dnl # ( u2 u1 -- u2 bool )  bool: lo(u1) cu> lo(u2)
define({OVER_CUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CUGT},{over cu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CUGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CUGT_CF_STORE(L,E){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: lo(u1) cu> lo(u2){}dnl
__{}__CODE_2DUP_CUGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl
dnl # +-----------------------------------------------------------+
dnl # |                       hcond version                       |
dnl # +-----------------------------------------------------------+
dnl
dnl
dnl #; ------- hcond ( x2 x1 -- bool ) ---------
dnl
dnl
dnl # h=
dnl # ( x2 x1 -- bool )
define({HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_HEQ},{h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CEQ_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- bool )  bool: hi(x2) c= hi(x1){}dnl
__{}__CODE_2DUP_CEQ_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # h<>
dnl # ( x2 x1 -- bool )
define({HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_HNE},{h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HNE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CNE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- bool )  bool: hi(x2) c<> hi(x1){}dnl
__{}__CODE_2DUP_CNE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # h<
dnl # ( x2 x1 -- bool )
define({HLT},{dnl
__{}__ADD_TOKEN({__TOKEN_HLT},{h<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HLT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- bool )  bool: hi(x2) c< hi(x1){}dnl
__{}__CODE_2DUP_CLT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # h<=
dnl # ( x2 x1 -- bool )
define({HLE},{dnl
__{}__ADD_TOKEN({__TOKEN_HLE},{h<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HLE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- bool )  bool: hi(x2) c<= hi(x1){}dnl
__{}__CODE_2DUP_CLE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # h>=
dnl # ( x2 x1 -- bool )
define({HGE},{dnl
__{}__ADD_TOKEN({__TOKEN_HGE},{h>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- bool )  bool: hi(x2) c>= hi(x1){}dnl
__{}__CODE_2DUP_CGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # h>
dnl # ( x2 x1 -- bool )
define({HGT},{dnl
__{}__ADD_TOKEN({__TOKEN_HGT},{h>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- bool )  bool: hi(x2) c> hi(x1){}dnl
__{}__CODE_2DUP_CGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # hu<
dnl # ( u2 u1 -- bool )
define({HULT},{dnl
__{}__ADD_TOKEN({__TOKEN_HULT},{hu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HULT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: hi(u2) cu< hi(u1){}dnl
__{}__CODE_2DUP_CULT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # hu<=
dnl # ( u2 u1 -- bool )
define({HULE},{dnl
__{}__ADD_TOKEN({__TOKEN_HULE},{hu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HULE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: hi(u2) cu<= hi(u1){}dnl
__{}__CODE_2DUP_CULE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # hu>=
dnl # ( u2 u1 -- bool )
define({HUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_HUGE},{hu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HUGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: hi(u2) cu>= hi(u1){}dnl
__{}__CODE_2DUP_CUGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # hu>
dnl # ( u2 u1 -- bool )
define({HUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_HUGT},{hu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_HUGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(1,10,eval(10+__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- bool )  bool: hi(u2) cu> hi(u1){}dnl
__{}__CODE_2DUP_CUGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH
__{}    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ------------------ 2dup hcond ------------------
dnl
dnl
dnl # 2dup h=
dnl # ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c= hi(x1)
define({_2DUP_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HEQ},{2dup h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CEQ_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c= hi(x1){}dnl
__{}__CODE_2DUP_CEQ_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup h<>
dnl # ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c<> hi(x1)
define({_2DUP_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HNE},{2dup h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HNE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CNE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c<> hi(x1){}dnl
__{}__CODE_2DUP_CNE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup h<
dnl # ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c< hi(x1)
define({_2DUP_HLT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HLT},{2dup h<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HLT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c< hi(x1){}dnl
__{}__CODE_2DUP_CLT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup h<=
dnl # ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c<= hi(x1)
define({_2DUP_HLE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HLE},{2dup h<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HLE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CLE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c<= hi(x1){}dnl
__{}__CODE_2DUP_CLE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup h>=
dnl # ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c>= hi(x1)
define({_2DUP_HGE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HGE},{2dup h>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c>= hi(x1){}dnl
__{}__CODE_2DUP_CGE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup h>
dnl # ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c> hi(x1)
define({_2DUP_HGT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HGT},{2dup h>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CGT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 x1 bool )  bool: hi(x2) c> hi(x1){}dnl
__{}__CODE_2DUP_CGT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup hu<
dnl # ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu< hi(u1)
define({_2DUP_HULT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HULT},{2dup hu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HULT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu< hi(u1){}dnl
__{}__CODE_2DUP_CULT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup hu<=
dnl # ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu<= hi(u1)
define({_2DUP_HULE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HULE},{2dup hu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HULE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CULE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu<= hi(u1){}dnl
__{}__CODE_2DUP_CULE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup hu>=
dnl # ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu>= hi(u1)
define({_2DUP_HUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HUGE},{2dup hu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HUGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGE_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu>= hi(u1){}dnl
__{}__CODE_2DUP_CUGE_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # 2dup hu>
dnl # ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu> hi(u1)
define({_2DUP_HUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_HUGT},{2dup hu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_HUGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__SET_SUMS(2,15,eval(15+2*__BYTE_PRICE)){}dnl
__{}__MAKE_CODE_2DUP_CUGT_CF_STORE(D,H){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( u2 u1 -- u2 u1 bool )  bool: hi(u2) cu> hi(u1){}dnl
__{}__CODE_2DUP_CUGT_CF_STORE
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl #; ------- over hcond ( u2 u1 -- u2 bool ) ---------
dnl
dnl
dnl # over h=
dnl #( x2 x1 -- x2 bool )  bool: hi(x1) c= hi(x2)
define({OVER_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HEQ},{over h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CEQ_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 bool )  bool: hi(x1) c= hi(x2){}dnl
__{}__CODE_2DUP_CEQ_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over h<>
dnl #( x2 x1 -- x2 bool )  bool: hi(x1) c<> hi(x2)
define({OVER_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HNE},{over h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HNE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CNE_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 bool )  bool: hi(x1) c<> hi(x2){}dnl
__{}__CODE_2DUP_CNE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over h<
dnl #( x2 x1 -- x2 bool )  bool: hi(x1) c< hi(x2)
define({OVER_HLT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HLT},{over h<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HLT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CLT_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 bool )  bool: hi(x1) c< hi(x2){}dnl
__{}__CODE_2DUP_CLT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over h<=
dnl #( x2 x1 -- x2 bool )  bool: hi(x1) c<= hi(x2)
define({OVER_HLE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HLE},{over h<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HLE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CLE_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 bool )  bool: hi(x1) c<= hi(x2){}dnl
__{}__CODE_2DUP_CLE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over h>=
dnl #( x2 x1 -- x2 bool )  bool: hi(x1) c>= hi(x2)
define({OVER_HGE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HGE},{over h>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CGE_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 bool )  bool: hi(x1) c>= hi(x2){}dnl
__{}__CODE_2DUP_CGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over h>
dnl #( x2 x1 -- x2 bool )  bool: hi(x1) c> hi(x2)
define({OVER_HGT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HGT},{over h>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CGT_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( x2 x1 -- x2 bool )  bool: hi(x1) c> hi(x2){}dnl
__{}__CODE_2DUP_CGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over hu<
dnl # ( u2 u1 -- u2 bool )  bool: hi(u1) cu< hi(u2)
define({OVER_HULT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HULT},{over hu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HULT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CULT_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: hi(u1) cu< hi(u2){}dnl
__{}__CODE_2DUP_CULT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over hu<=
dnl # ( u2 u1 -- u2 bool )  bool: hi(u1) cu<= hi(u2)
define({OVER_HULE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HULE},{over hu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HULE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CULE_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: hi(u1) cu<= hi(u2){}dnl
__{}__CODE_2DUP_CULE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over hu>=
dnl # ( u2 u1 -- u2 bool )  bool: hi(u1) cu>= hi(u2)
define({OVER_HUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HUGE},{over hu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HUGE},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CUGE_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: hi(u1) cu>= hi(u2){}dnl
__{}__CODE_2DUP_CUGE_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl # over hu>
dnl # ( u2 u1 -- u2 bool )  bool: hi(u1) cu> hi(u2)
define({OVER_HUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_HUGT},{over hu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_HUGT},{
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__RESET_SUMS{}dnl
__{}__MAKE_CODE_2DUP_CUGT_CF_STORE(H,D){}dnl
__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO    ( u2 u1 -- u2 bool )  bool: hi(u1) cu> hi(u2){}dnl
__{}__CODE_2DUP_CUGT_CF_STORE{}dnl
__{}__CODE_DROP_CARRY_FETCH}){}dnl
dnl
dnl
dnl
dnl
dnl #; ------- rot hcond/ccond ( u3 u2 u1 -- u2 bool ) ---------
dnl
dnl
dnl
dnl # rot c=
dnl # ( c3 c2 c1 -- c2 bool )
dnl # equal ( lo(c3) == lo(c1) )
define({_2_PICK_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN__2_PICK_CEQ},{rot c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN__2_PICK_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[7:40]     __INFO   ( u3 u2 u1 -- u2 bool )  bool: lo(u3) == lo(u1)
    ld    A, L          ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    xor   L             ; 1:4       __INFO   ignores the higher byte
    sub  0x01           ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # rot c<>
dnl # ( c3 c2 c1 -- c2 bool )
dnl # not equal ( lo(c3) <> lo(c1) )
define({_2_PICK_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN__2_PICK_CNE},{rot c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN__2_PICK_CNE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[7:40]     __INFO   ( u3 u2 u1 -- u2 bool )  bool: lo(u3) <> lo(u1)
    ld    A, L          ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    xor   L             ; 1:4       __INFO   ignores the higher byte
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # rot 8 rshift swap 8 rshift C=
dnl # ( u3 u2 u1 -- u2 bool )
dnl # equal ( hi(u3) == hi(u1) )
define({_2_PICK_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN__2_PICK_HEQ},{rot h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN__2_PICK_HEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[6:36]     __INFO   ( u3 u2 u1 -- u2 bool )  bool: hi(u3) == hi(u1)
    pop  AF             ; 1:10      __INFO
    xor   H             ; 1:4       __INFO   ignores the lower byte
    sub  0x01           ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # rot 8 rshift swap 8 rshift  c<>
dnl # ( u3 u2 u1 -- u2 bool )
dnl # not equal ( hi(u3) <> hi(u1) )
define({_2_PICK_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN__2_PICK_HNE},{rot h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN__2_PICK_HNE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[6:36]     __INFO   ( u3 u2 u1 -- u2 bool )  bool: hi(u3) <> hi(u1)
    pop  AF             ; 1:10      __INFO
    xor   H             ; 1:4       __INFO   ignores the lower byte
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl #; ------- 2 pick hcond/ccond ( u3 u2 u1 -- u3 u2 bool ) ---------
dnl
dnl
dnl
dnl # 2 pick c=
dnl # ( c3 c2 c1 -- c3 c2 bool )
dnl # equal ( lo(c3) == lo(c1) )
define({_2_PICK_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_CEQ},{2 pick c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[8:51]     __INFO   ( u3 u2 u1 -- u3 u2 bool )  bool: lo(u3) == lo(u1)
    ld    A, L          ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    push HL             ; 1:11      __INFO
    xor   L             ; 1:4       __INFO   ignores the higher byte
    sub  0x01           ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # 2 pick c<>
dnl # ( c3 c2 c1 -- c3 c2 bool )
dnl # not equal ( lo(c3) <> lo(c1) )
define({_2_PICK_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_CNE},{2 pick c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_CNE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[8:51]     __INFO   ( u3 u2 u1 -- u3 u2 bool )  bool: lo(u3) <> lo(u1)
    ld    A, L          ; 1:4       __INFO
    pop  HL             ; 1:10      __INFO
    push HL             ; 1:11      __INFO
    xor   L             ; 1:4       __INFO   ignores the higher byte
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # 2 pick 8 rshift swap 8 rshift C=
dnl # ( u3 u2 u1 -- u3 u2 bool )
dnl # equal ( hi(u3) == hi(u1) )
define({_2_PICK_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_HEQ},{2 pick h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_HEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[7:47]     __INFO   ( u3 u2 u1 -- u3 u2 bool )  bool: hi(u3) == hi(u1)
    pop  AF             ; 1:10      __INFO
    push AF             ; 1:11      __INFO
    xor   H             ; 1:4       __INFO   ignores the lower byte
    sub  0x01           ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # 2 pick 8 rshift swap 8 rshift  c<>
dnl # ( u3 u2 u1 -- u3 u2 bool )
dnl # not equal ( hi(u3) <> hi(u1) )
define({_2_PICK_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_2_PICK_HNE},{2 pick h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2_PICK_HNE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[7:47]     __INFO   ( u3 u2 u1 -- u3 u2 bool )  bool: hi(u3) <> hi(u1)
    pop  AF             ; 1:10      __INFO
    push AF             ; 1:11      __INFO
    xor   H             ; 1:4       __INFO   ignores the lower byte
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl #; ------- 8-bit-const ccond ( c -- bool ) ---------
dnl
dnl
dnl # ( char -- bool )  bool: lo(char) == lo($1)
define({PUSH_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CEQ},{$1 c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CEQ(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- bool )  bool: lo(char) <> $1
define({PUSH_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CNE},{$1 c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CNE(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- bool ) bool: char c< lo($1)
define({PUSH_CLT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CLT},{$1 c<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CLT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CLT(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- bool ) bool: char c<= lo($1)
define({PUSH_CLE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CLE},{$1 c<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CLE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CLE(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- bool ) bool: char c>= lo($1)
define({PUSH_CGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CGE},{$1 c>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CGE(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- bool ) bool: char c> lo($1)
define({PUSH_CGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CGT},{$1 c>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CGT(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: lo(u1) u< lo($1)
define({PUSH_CULT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CULT},{$1 cu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CULT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CULT(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: lo(u1) u<= lo($1)
define({PUSH_CULE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CULE},{$1 cu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CULE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CULE(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: lo(u1) u>= lo($1)
define({PUSH_CUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CUGE},{$1 cu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CUGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CUGE(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: lo(u1) u> lo($1)
define({PUSH_CUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_CUGT},{$1 cu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_CUGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}__MAKE_CODE_PUSH_CUGT(L,$@){}dnl
}){}dnl
dnl
dnl
dnl
dnl #; ------- 8-bit-const hcond ( u -- bool ) ---------
dnl
dnl
dnl
dnl
dnl # ( x1 -- bool ) bool: hi(x1) c= hi($1)
define({PUSH_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HEQ},{$1 h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CEQ(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CEQ(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x1 -- bool ) bool: hi(x1) c<> hi($1)
define({PUSH_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HNE},{$1 h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CNE(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CNE(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x1 -- bool ) bool: hi(x1) c< hi($1)
define({PUSH_HLT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HLT},{$1 h<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HLT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CLT(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CLT(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x1 -- bool ) bool: hi(x1) c<= hi($1)
define({PUSH_HLE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HLE},{$1 h<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HLE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CLE(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CLE(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x1 -- bool ) bool: hi(x1) c>= hi($1)
define({PUSH_HGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HGE},{$1 h>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CGE(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CGE(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( x1 -- bool ) bool: hi(x1) c> hi($1)
define({PUSH_HGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HGT},{$1 h>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CGT(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CGT(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: hi(u1) u< hi($1)
define({PUSH_HULT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HULT},{$1 hu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HULT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CULT(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CULT(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: hi(u1) u<= hi($1)
define({PUSH_HULE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HULE},{$1 hu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HULE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CULE(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CULE(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: hi(u1) u>= hi($1)
define({PUSH_HUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HUGE},{$1 hu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HUGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CUGE(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CUGE(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( u1 -- bool )  bool: hi(u1) u> hi($1)
define({PUSH_HUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_HUGT},{$1 hu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_HUGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}__HAS_PTR($1),{1},{dnl
__{}__{}__MAKE_CODE_PUSH_CUGT(H,__PTR_ADD($1,1))},
__{}{dnl
__{}__{}__MAKE_CODE_PUSH_CUGT(H,__SIMPLIFY_EXPRESSION(($1)/256)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl #; ------- dup 8-bit-const ccond/hcond ( u -- u bool ) ---------
dnl
dnl
dnl
define({DUP_PUSH_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_CEQ},{dup $1 c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{dnl
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[10:54]     __INFO   ( char -- char f )  f:lo(tos) == lo($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    sub   E             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFE},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:lo(tos) == 254
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFF},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:lo(tos) == 255
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0x00},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:lo(tos) == 0
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0x01},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:lo(tos) == 1
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:lo(tos) == lo($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __FORM({%-11s},$1); 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:lo(tos) == __HEX_L($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __FORM({%-11s},$1); 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool}){}dnl
}){}dnl
dnl
dnl
dnl
define({DUP_PUSH_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_CNE},{dup $1 c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_CNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{dnl
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[10:54]     __INFO   ( char -- char f )  f:lo(char) <> lo($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    sub   E             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFE},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:lo(char) <> 254
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFF},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:lo(char) <> 255
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0x00},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:lo(char) <> 0
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0x01},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:lo(char) <> 1
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, E          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:lo(char) <> lo($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __FORM({%-11s},low $1); 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:lo(char) <> __HEX_L($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __HEX_L($1)       ; 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool}){}dnl
}){}dnl
dnl
dnl
dnl
define({DUP_PUSH_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_HEQ},{dup $1 h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_HEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{dnl
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[10:54]     __INFO   ( char -- char f )  f:hi(tos) == hi([addr+1])
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    sub   D             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0xFE},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:hi(tos) == 254
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0xFF},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:hi(tos) == 255
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0x00},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:hi(tos) == 0
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0x01},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:hi(tos) == 1
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:hi(tos) == hi($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A,__FORM({%-12s},high $1); 2:7       __INFO
__{}__{}    sub   D             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:hi(tos) == __HEX_H($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}    sub   D             ; 1:4       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool}){}dnl
}){}dnl
dnl
dnl
dnl
define({DUP_PUSH_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_HNE},{dup $1 h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_HNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{dnl
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>1),{1},{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                       ;[10:54]     __INFO   ( char -- char f )  f:hi(tos) <> hi([addr+1])
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    sub   D             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0xFE},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:hi(tos) <> 254
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0xFF},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:hi(tos) <> 255
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0x00},{
__{}__{}                        ;[7:41]     __INFO   ( char -- char f )  f:hi(tos) <> 0
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0x01},{
__{}__{}                        ;[8:45]     __INFO   ( char -- char f )  f:hi(tos) <> 1
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, D          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:hi(tos) <> hi($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __FORM({%-11s},high $1); 2:7       __INFO
__{}__{}    sub   D             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[9:48]     __INFO   ( char -- char f )  f:hi(tos) <> __HEX_H($1)
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A, __HEX_H($1)       ; 2:7       __INFO
__{}__{}    sub   D             ; 1:4       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- char bool )  bool: lo(char) u< lo($1)
define({DUP_PUSH_CULT},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_CULT},{dup $1 cu<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_CULT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),{1},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL{,}__FORM({%-12s},__PTR_ADD($1,0)); 3:16      __INFO
__{}__{}    ld    A{,} E          ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO   E < $1 --> E - $1 < 0 --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: pointer},

__{}__HEX_L($1),{0x00},{
__{}__{}  .warning The condition is always False!
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL{,} 0x0000     ; 3:10      __INFO   variant: zero},

__{}__IS_NUM($1),{0},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} E          ; 1:4       __INFO
__{}__{}    sub  __FORM({%-15s},$1); 2:7       __INFO   E < $1 --> E - $1 < 0 --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: no number},

__{}{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} E          ; 1:4       __INFO
__{}__{}    sub  __HEX_L($1)           ; 2:7       __INFO   E < $1 --> E - $1 < 0 --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: default}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- char bool )  bool: lo(char) u<= lo($1)
define({DUP_PUSH_CULE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_CULE},{dup $1 cu<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_CULE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),{1},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,}__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E <= $1 --> 0 <= $1 - E --> not carry if true
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: pointer},

__{}__HEX_L($1),{0x00},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E <= $1 --> 0 <= $1 - E --> not carry if true
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO },

__{}__HEX_L($1),{0xFF},{
__{}__{}  .warning The condition is always True!
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL{,} 0xFFFF     ; 3:10      __INFO   variant: 255},

__{}__IS_NUM($1),{0},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} __FORM({%-11s},$1); 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E <= $1 --> 0 <= $1 - E --> not carry if true
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: no number},

__{}{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} __HEX_L($1)       ; 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E <= $1 --> 0 <= $1 - E --> not carry if true
__{}__{}    ccf                 ; 1:4       __INFO
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: default}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- char bool )  bool: lo(char) u>= lo($1)
define({DUP_PUSH_CUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_CUGE},{dup $1 cu>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_CUGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),{1},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,}__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    sbc   A{,} E          ; 1:4       __INFO   E >= $1 --> 0 > $1 - E - carry --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: pointer},

__{}__HEX_L($1),{0x00},{
__{}__{}  .warning The condition is always True!
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL{,} 0xFFFF     ; 3:10      __INFO   variant: zero},

__{}__IS_NUM($1),{0},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} __FORM({%-11s},$1); 2:7       __INFO
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    sbc   A{,} E          ; 1:4       __INFO   E >= $1 --> 0 > $1 - E - carry --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: no number},

__{}{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} __HEX_L($1)       ; 2:7       __INFO
__{}__{}    scf                 ; 1:4       __INFO
__{}__{}    sbc   A{,} E          ; 1:4       __INFO   E >= $1 --> 0 > $1 - E - carry --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: default}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- char bool )  bool: lo(char) u> lo($1)
define({DUP_PUSH_CUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_DUP_PUSH_CUGT},{dup $1 cu>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUP_PUSH_CUGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}__HAS_PTR($1),{1},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,}__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E > $1 --> 0 > $1 - E --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: pointer},

__{}__HEX_L($1),{0x00},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    xor   A             ; 1:4       __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E > $1 --> 0 > $1 - E --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: zero},

__{}__HEX_L($1),{0xFF},{
__{}__{}  .warning The condition is always False!
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld   HL{,} 0x0000     ; 3:10      __INFO   variant: 255},

__{}__IS_NUM($1),{0},{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} __FORM({%-11s},$1); 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E > $1 --> 0 > $1 - E --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: no number},

__{}{
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    push HL             ; 1:11      __INFO
__{}__{}    ld    A{,} __HEX_L($1)       ; 2:7       __INFO
__{}__{}    sub   E             ; 1:4       __INFO   E > $1 --> 0 > $1 - E --> carry if true
__{}__{}    sbc  HL{,} HL         ; 2:15      __INFO   variant: default}){}dnl
}){}dnl
dnl
dnl
dnl
dnl #; ------- over c@ over c@ c= ( addr2 addr1 -- addr2 addr1 bool ) ---------
dnl
dnl
dnl
dnl # over c@ over c@ C=
dnl # ( addr2 addr1 -- addr2 addr1 bool )
dnl # bool: char2 == char1
dnl # 8-bit compares the contents of two addresses.
define({OVER_CFETCH_OVER_CFETCH_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_CFETCH_OVER_CFETCH_CEQ},{over c@ over c@ c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_CFETCH_OVER_CFETCH_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[8:51]     __INFO   ( addr2 addr1 -- addr2 addr1 bool )  bool: [addr2] == [addr1]
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    sub  0x01           ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl
dnl
dnl
dnl # ( addr -- bool )  bool: [addr] == lo($1)
define({CFETCH_PUSH_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_CFETCH_PUSH_CEQ},{c@ $1 c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CFETCH_PUSH_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[8:42]     __INFO   ( addr -- bool )  bool: [addr] == lo($1)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    xor  [HL]           ; 1:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFE},{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] == 254
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0xFF,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] == 255
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x00,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] == 0
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x01,{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] == 1
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    dec   A             ; 1:4       __INFO   ignores the higher byte
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] == lo($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __FORM({%-15s},$1); 2:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] == __HEX_L($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __HEX_L($1)           ; 2:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   set bool{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( addr -- bool )  bool: [addr] <> lo($1)
define({CFETCH_PUSH_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_CFETCH_PUSH_CNE},{c@ $1 c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CFETCH_PUSH_CNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[8:42]     __INFO   ( addr -- bool )  bool: [addr] <> lo($1)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    xor  [HL]           ; 1:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFE},{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] <> 254
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0xFF,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] <> 255
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x00,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] <> 0
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x01,{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] <> 1
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    dec   A             ; 1:4       __INFO   ignores the higher byte
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] <> lo($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __FORM({%-15s},$1); 2:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] <> __HEX_L($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __HEX_L($1)           ; 2:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   set bool{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( addr -- bool )  bool: [addr] == hi($1)
define({CFETCH_PUSH_HEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_CFETCH_PUSH_HEQ},{c@ $1 h=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CFETCH_PUSH_HEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[8:42]     __INFO   ( addr -- bool )  bool: [addr] == hi($1)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    xor  [HL]           ; 1:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0xFE},{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] == 254
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),0xFF,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] == 255
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),0x00,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] == 0
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),0x01,{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] == 1
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    dec   A             ; 1:4       __INFO   ignores the higher byte
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] == hi($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __FORM({%-15s},high $1); 2:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] == __HEX_H($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __HEX_H($1)           ; 2:7       __INFO
__{}__{}    sub  0x01           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   set bool{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( addr -- bool )  bool: [addr] <> hi($1)
define({CFETCH_PUSH_HNE},{dnl
__{}__ADD_TOKEN({__TOKEN_CFETCH_PUSH_HNE},{c@ $1 h<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_CFETCH_PUSH_HNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[8:42]     __INFO   ( addr -- bool )  bool: [addr] <> hi($1)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      __INFO
__{}__{}    xor  [HL]           ; 1:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),{0xFE},{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] <> 254
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),0xFF,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] <> 255
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),0x00,{
__{}__{}                        ;[5:29]     __INFO   ( addr -- bool )  bool: [addr] <> 0
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_H($1),0x01,{
__{}__{}                        ;[6:33]     __INFO   ( addr -- bool )  bool: [addr] <> 1
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    dec   A             ; 1:4       __INFO   ignores the higher byte
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] <> hi($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __FORM({%-15s},high $1); 2:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[7:36]     __INFO   ( addr -- bool )  bool: [addr] <> __HEX_H($1)
__{}__{}    ld    A,[HL]        ; 1:7       __INFO
__{}__{}    xor  __HEX_H($1)           ; 2:7       __INFO
__{}__{}    add   A, 0xFF       ; 2:7       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   set bool{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl #; ------- 1+ 8-bit-const ccond ( char -- bool ) ---------
dnl
dnl
dnl
dnl # ( char -- bool )  bool: lo(char)+1 == lo($1)
define({_1ADD_PUSH_CEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_1ADD_PUSH_CEQ},{1+ $1 c=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1ADD_PUSH_CEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[9:43]     __INFO   ( char -- bool )  bool: lo(char)+1 == lo($1)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    sub  0x01           ; 2:7       __INFO   A == 0 ?
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),{0xFF},{
__{}__{}                        ;[6:30]     __INFO   ( char -- bool )  bool: lo(char)+1 == 255
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    add   A, 0x01       ; 2:7       __INFO   A == 255 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x00,{
__{}__{}                        ;[5:26]     __INFO   ( char -- bool )  bool: lo(char)+1 == 0
__{}__{}    ld    A, L          ; 1:4       __INFO   ignores the lower byte
__{}__{}    add   A, 0x01       ; 2:7       __INFO   A == 255 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x01,{
__{}__{}                        ;[5:26]     __INFO   ( char -- bool )  bool: lo(char)+1 == 1
__{}__{}    ld    A, L          ; 1:4       __INFO   ignores the higher byte
__{}__{}    sub  0x01           ; 2:7       __INFO   A == 0 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1):_TYP_SINGLE,0x02:fast,{
__{}__{}                        ;[7:26/27]  __INFO   ( char -- bool )  bool: lo(char)+1 == 2
__{}__{}    ld    H, 0xFF       ; 2:7       __INFO
__{}__{}    dec   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    jr    z, $+3        ; 2:7/12    __INFO
__{}__{}    inc   H             ; 1:4       __INFO
__{}__{}    ld    L, H          ; 1:4       __INFO   HL = bool},
__{}__HEX_L($1),0x02,{
__{}__{}                        ;[6:30]     __INFO   ( char -- bool )  bool: lo(char)+1 == 2
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    dec   A             ; 1:4       __INFO   ignores the higher byte
__{}__{}    sub  0x01           ; 2:7       __INFO   A == 0 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                        ;[7:33]     __INFO   ( char -- bool )  bool: lo(char)+1 == lo($1)
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    sub  __FORM({%-15s},$1); 2:7       __INFO   ignores the higher byte
__{}__{}    add   A, 0x01       ; 2:7       __INFO   A == 255 ?
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[7:33]     __INFO   ( char -- bool )  bool: lo(char)+1 == __HEX_L($1)
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    sub  __HEX_L($1)           ; 2:7       __INFO   ignores the higher byte
__{}__{}    add   A, 0x01       ; 2:7       __INFO   A == 255 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( char -- bool )  bool: lo(char)+1 <> lo($1)
define({_1ADD_PUSH_CNE},{dnl
__{}__ADD_TOKEN({__TOKEN_1ADD_PUSH_CNE},{1+ $1 c<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1ADD_PUSH_CNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse($1,{},{
__{}__{}  .error {$0}(): Missing address parameter!},
__{}eval($#>1),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}__HAS_PTR($1),{1},{
__{}__{}                        ;[9:43]     __INFO   ( char -- bool )  bool: lo(char)+1 <> lo($1)
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      __INFO
__{}__{}    dec   A             ; 1:4       __INFO
__{}__{}    sub   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    add   A, 0xFF       ; 2:7       __INFO   A <> 0 ?
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1):_TYP_SINGLE,{0xFF:small},{
__{}__{}                        ;[6:30]     __INFO   ( char -- bool )  bool: lo(char)+1 <> 254+1
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    inc   A             ; 1:4       __INFO
__{}__{}    sub  0xFF           ; 2:7       __INFO   A <> 255 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0xFF,{
__{}__{}                        ;[7:26/24]  __INFO   ( char -- bool )  bool: lo(char)+1 <> 254+1
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    jr    z, $+4        ; 2:7/12    __INFO
__{}__{}    ld    L, 0xFF       ; 2:7       __INFO
__{}__{}    ld    H, L          ; 1:4       __INFO   HL = bool},
__{}__HEX_L($1):_TYP_SINGLE,{0x00:small},{
__{}__{}                        ;[5:26]     __INFO   ( char -- bool )  bool: lo(char)+1 <> 255+1
__{}__{}    ld    A, L          ; 1:4       __INFO   ignores the higher byte
__{}__{}    sub  0xFF           ; 2:7       __INFO   A <> 255 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x00,{
__{}__{}                        ;[6:22/20]  __INFO   ( char -- bool )  bool: lo(char)+1 <> 255+1
__{}__{}    inc   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    jr    z, $+4        ; 2:7/12    __INFO
__{}__{}    ld    L, 0xFF       ; 2:7       __INFO
__{}__{}    ld    H, L          ; 1:4       __INFO   HL = bool},
__{}__HEX_L($1):_TYP_SINGLE,0x01:fast,{
__{}__{}                        ;[7:26/24]     __INFO   ( char -- bool )  bool: lo(char)+1 <> 0+1
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    dec   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    jr    z, $+4        ; 2:7/12    __INFO
__{}__{}    ld    L, 0xFF       ; 2:7       __INFO
__{}__{}    ld    H, L          ; 1:4       __INFO   HL = bool},
__{}__HEX_L($1),0x01,{
__{}__{}                        ;[5:26]     __INFO   ( char -- bool )  bool: lo(char)+1 <> 0+1
__{}__{}    ld    A, L          ; 1:4       __INFO   ignores the higher byte
__{}__{}    add   A, 0xFF       ; 2:7       __INFO   A <> 0 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool},
__{}__HEX_L($1),0x02,{
__{}__{}                        ;[6:22/20]  __INFO   ( char -- bool )  bool: lo(char)+1 <> 1+1
__{}__{}    dec   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    jr    z, $+4        ; 2:7/12    __INFO
__{}__{}    ld    L, 0xFF       ; 2:7       __INFO
__{}__{}    ld    H, L          ; 1:4       __INFO   HL = bool},
__{}__HEX_L($1),0x03,{
__{}__{}                        ;[7:26/24]  __INFO   ( char -- bool )  bool: lo(char)+1 <> 2+1
__{}__{}    dec   L             ; 1:4       __INFO
__{}__{}    dec   L             ; 1:4       __INFO   ignores the higher byte
__{}__{}    jr    z, $+4        ; 2:7/12    __INFO
__{}__{}    ld    L, 0xFF       ; 2:7       __INFO
__{}__{}    ld    H, L          ; 1:4       __INFO   HL = bool},
__{}__IS_NUM($1),{0},{dnl
__{}__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{}__{}                        ;[7:33]     __INFO   ( char -- bool )  bool: lo(char)+1 <> lo($1)
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    sub  __FORM({%-15s},$1); 2:7       __INFO   ignores the higher byte
__{}__{}    sub  0xFF           ; 2:7       __INFO   A <> 255 ?
__{}__{}    sbc  HL, BC         ; 2:15      __INFO   HL = bool},
__{}{
__{}__{}                        ;[7:33]     __INFO   ( char -- bool )  bool: lo(char)+1 <> __HEX_L($1)
__{}__{}    ld    A, L          ; 1:4       __INFO
__{}__{}    sub  __HEX_L($1)           ; 2:7       __INFO   ignores the higher byte
__{}__{}    sub  0xFF           ; 2:7       __INFO   A <> 255 ?
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   HL = bool{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # -------------------------- 32 bits --------------------------
dnl
dnl # ------------- double shifts ----------------
dnl
dnl
dnl # ( d1 u -- d )  d = d1 << u
dnl # shifts d1 left u places
define({DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_DLSHIFT},{dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DLSHIFT},{dnl
__{}define({__INFO},{dlshift}){}dnl
__def({USE_DLSHIFT})
    call LSHIFT32       ; 3:17      D<<   ( d1 u -- d )  d = d1 << u}){}dnl
dnl
dnl
dnl
dnl # ( d1 1 -- d )  d = d1 << 1
dnl # shifts d1 left 1 bits
define({_1_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_1_DLSHIFT},{1 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO  ( d1 1 -- d )  d = d1 << 1
    rl    E             ; 2:8       __INFO
    rl    D             ; 2:8       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 1 -- pd )  [pd] <<= 1
dnl # shifts [pd] left 1 bits
define({_1_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_1_PDLSHIFT},{1 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 1 -- pd )  [pd] <<= 1  with align 4
    sla [HL]            ; 2:15      __INFO  Thnx Busy!
    inc   L             ; 1:4       __INFO
    rl  [HL]            ; 2:15      __INFO
    inc   L             ; 1:4       __INFO
    rl  [HL]            ; 2:15      __INFO
    inc   L             ; 1:4       __INFO
    rl  [HL]            ; 2:15      __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( p1 -- p1 )
dnl # [p1] <<= 1
define({_1_PLSHIFT},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_1_PLSHIFT},{1 plshift{}eval(($1)*8)},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1_PLSHIFT},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    sla [HL]            ; 2:15      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] <<= 1  with align $1},
__{}eval($1),2,{
__{}    sla [HL]            ; 2:15      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] <<= 1  with align $1
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    sla [HL]            ; 2:15      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] <<= 1  with align $1
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    sla [HL]            ; 2:15      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] <<= 1  with align $1
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    ld    L, C          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    or    A             ; 1:4       __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] <<= 1  with align $1
__{}    rl  [HL]            ; 2:15      __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    jr   nz, $-3        ; 2:7/12    __INFO
__{}    ld    L, 0x00       ; 2:7       __INFO},
__{}{
__{}    sla [HL]            ; 2:15      __INFO   ( p{}eval(8*($1)) -- p{}eval(8*($1)) )  [p{}eval(8*($1))] <<= 1  with align $1
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    rl  [HL]            ; 2:15      __INFO
__{}    djnz $-3            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( d1 4 -- d )  d = d1 << 4
dnl # shifts d1 left 4 bits
define({_4_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_4_DLSHIFT},{4 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO  ( d1 4 -- d )  d = d1 << 4
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    rl    D             ; 2:8       __INFO
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    rl    D             ; 2:8       __INFO
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    rl    D             ; 2:8       __INFO
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    rl    D             ; 2:8       __INFO
    ld    E, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 4 -- pd )  [pd] <<= 4
dnl # shifts [pd] left 4 bits
define({_4_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_4_PDLSHIFT},{4 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO  ( pd 4 -- pd )  [pd] <<= 4  with align 4
    rld                 ; 2:18      __INFO  A[HL]=0xA021-->0xA210
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA243-->0xA432
    inc   L             ; 1:4       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA465-->0xA654
    inc   L             ; 1:4       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA687-->0xA876
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 8 -- d )  d = d1 << 8
dnl # shifts d1 left 8 bits
define({_8_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_8_DLSHIFT},{8 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_8_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    D, E          ; 1:4       __INFO  ( d1 8 -- d )  d = d1 << 8
    ld    E, H          ; 1:4       __INFO
    ld    H, L          ; 1:4       __INFO
    ld    L, 0x00       ; 2:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 8 -- pd )  [pd] <<= 8
dnl # shifts [pd] left 8 bits
define({_8_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_8_PDLSHIFT},{8 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_8_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 8 -- pd )  [pd] <<= 8  with align 4
    ld    A,[HL]        ; 1:7       __INFO
    ld  [HL],0x00       ; 2:10      __INFO
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    ld  [HL],B          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 12 -- d )  d = d1 << 12
dnl # shifts d1 left 12 bits
define({_12_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_12_DLSHIFT},{12 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_12_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO  ( d1 12 -- d )  d = d1 << 12
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO
    adc   A, A          ; 1:4       __INFO
    ld    D, A          ; 1:4       __INFO
    ld    E, H          ; 1:4       __INFO
    ld    H, L          ; 1:4       __INFO
    ld    L, 0x00       ; 2:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 12 -- pd )  [pd] <<= 12
dnl # shifts [pd] left 12 bits
define({_12_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_12_PDLSHIFT},{12 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_12_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO  ( pd 12 -- pd )  [pd] <<= 12  with align 4
    ld    C,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO  0x00
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],C          ; 1:7       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA021-->0xA210
    inc   L             ; 1:4       __INFO
    ld    C,[HL]        ; 1:7       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA243-->0xA432
    inc   L             ; 1:4       __INFO
    ld  [HL],C          ; 1:7       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA465-->0xA654
    dec   L             ; 1:4       __INFO
    dec   L             ; 1:4       __INFO
    dec   L             ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 16 -- d )  d = d1 << 16
dnl # shifts d1 left 16 bits
define({_16_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_16_DLSHIFT},{16 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_16_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO  ( d1 16 -- d )  d = d1 << 16
    ld   HL, 0x0000     ; 3:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 16 -- pd )  [pd] <<= 16
dnl # shifts [pd] left 16 bits
define({_16_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_16_PDLSHIFT},{16 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_16_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 16 -- pd )  [pd] <<= 16  with align 4
    ld    A,[HL]        ; 1:7       __INFO
    ld  [HL],0x00       ; 2:10      __INFO
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],0x00       ; 2:10      __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 20 -- d )  d = d1 << 20
dnl # shifts d1 left 20 bits
define({_20_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_20_DLSHIFT},{20 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_20_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    add  HL, HL         ; 1:11      __INFO  ( d1 20 -- d )  d = d1 << 20
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO
    add  HL, HL         ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld   HL, 0x0000     ; 3:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 20 -- pd )  [pd] <<= 20
dnl # shifts [pd] left 20 bits
define({_20_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_20_PDLSHIFT},{20 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_20_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO  ( pd 20 -- pd )  [pd] <<= 20  with align 4
    ld    C,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],C          ; 1:7       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA021-->0xA210
    inc   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA243-->0xA432
    dec   L             ; 1:4       __INFO
    dec   L             ; 1:4       __INFO
    dec   L             ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 24 -- d )  d = d1 << 24
dnl # shifts d1 left 24 bits
define({_24_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_24_DLSHIFT},{24 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_24_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    D, L          ; 1:4       __INFO  ( d1 24 -- d )  d = d1 << 24
    ld   HL, 0x0000     ; 3:10      __INFO
    ld    E, L          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 24 -- pd )  [pd] <<= 24
dnl # shifts [pd] left 24 bits
define({_24_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_24_PDLSHIFT},{24 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_24_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 24 -- pd )  [pd] <<= 24  with align 4
    xor   A             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 28 -- d )  d = d1 << 28
dnl # shifts d1 left 28 bits
define({_28_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_28_DLSHIFT},{28 dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_28_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO  ( d1 28 -- d )  d = d1 << 28
    add   A, A          ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO
    ld    D, A          ; 1:4       __INFO
    ld   HL, 0x0000     ; 3:10      __INFO
    ld    E, L          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 28 -- pd )  [pd] <<= 28
dnl # shifts [pd] left 28 bits
define({_28_PDLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_28_PDLSHIFT},{28 pdlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_28_PDLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 28 -- pd )  [pd] <<= 28  with align 4
    xor   A             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rld                 ; 2:18      __INFO  A[HL]=0xA021-->0xA210
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 u -- d )  d = d1 << u
dnl # shifts d1 left u places
define({_2_PICK_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN__2_PICK_DLSHIFT},{rot dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN__2_PICK_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__def({USE__2_PICK_DLSHIFT})
    pop  BC             ; 1:10      __INFO   ( d1 -- d )  d = d1 << BC
    call BC_LSHIFT32    ; 3:17      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( u -- d )  d = $1. << u
define({PUSH2__2_PICK_DLSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2__2_PICK_DLSHIFT},{rot dlshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2__2_PICK_DLSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__def({USE__2_PICK_DLSHIFT})
    ld    C, L          ; 1:4       __INFO   ( u -- d )  d = __VIEW_DE_HL($@) << u
    ld    B, H          ; 1:4       __INFO
    push  DE            ; 1:11      __INFO{}dnl
__ASM_TOKEN_2DROP_PUSH2($@)
    call BC_LSHIFT32    ; 3:17      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 u -- d )  d = d1 >> u
dnl # shifts d1 right u places
define({DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_DRSHIFT},{drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DRSHIFT},{dnl
__{}define({__INFO},{drshift}){}dnl
__def({USE_DRSHIFT})
    call RSHIFT32       ; 3:17      D>>   ( d1 u -- d )  d = d1 >> u}){}dnl
dnl
dnl
dnl
dnl # ( d1 1 -- d )  d = d1 >> 1
dnl # shifts d1 right 1 bits
define({_1_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_1_DRSHIFT},{1 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    srl   D             ; 2:8       __INFO  ( d1 1 -- d )  d = d1 >> 1
    rr    E             ; 2:8       __INFO
    rr    H             ; 2:8       __INFO
    rr    L             ; 2:8       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 1 -- pd )  [pd] >>= 1
dnl # shifts [pd] right 1 bits
define({_1_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_1_PDRSHIFT},{1 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_1_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   L             ; 1:4       __INFO  ( pd 1 -- pd )  [pd] >>= 1  with align 4
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    srl [HL]            ; 2:15      __INFO  Thnx Busy!
    dec   L             ; 1:4       __INFO
    rr  [HL]            ; 2:15      __INFO
    dec   L             ; 1:4       __INFO
    rr  [HL]            ; 2:15      __INFO
    dec   L             ; 1:4       __INFO
    rr  [HL]            ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 4 -- d )  d = d1 << 4
dnl # shifts d1 right 4 bits
define({_4_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_4_DRSHIFT},{4 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(1,1,{
                       ;[25:128]    __INFO  ( d1 4 -- d )  d = d1 >> 4
    ld    A, E          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    ld    L, H          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    ld    A, E          ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765->0876
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765->0876
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765->0876
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765->0876
    rra                 ; 1:4       __INFO
    ld    E, A          ; 1:4       __INFO},
1,1,{
                       ;[30:120]    __INFO  ( d1 4 -- d )  d = d1 >> 4
    ld    A, E          ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  87654321->08765432
    rra                 ; 1:4       __INFO
    rr    H             ; 2:8       __INFO
    rr    L             ; 2:8       __INFO
    srl   D             ; 2:8       __INFO  87654321->08765432
    rra                 ; 1:4       __INFO
    rr    H             ; 2:8       __INFO
    rr    L             ; 2:8       __INFO
    srl   D             ; 2:8       __INFO  87654321->08765432
    rra                 ; 1:4       __INFO
    rr    H             ; 2:8       __INFO
    rr    L             ; 2:8       __INFO
    srl   D             ; 2:8       __INFO  87654321->08765432
    rra                 ; 1:4       __INFO
    rr    H             ; 2:8       __INFO
    rr    L             ; 2:8       __INFO
    ld    E, A          ; 1:4       __INFO},
{
                       ;[24:152]    __INFO  ( d1 4 -- d )  d = d1 >> 4
    ld    A, E          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  654321->5432.10
    adc   A, A          ; 1:4       __INFO
    ld    L, H          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    xor   A             ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  008765->0876.50
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  008765->0876.50
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  008765->0876.50
    adc   A, A          ; 1:4       __INFO
    add  HL, HL         ; 1:11      __INFO  008765->0876.50
    adc   A, A          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld    E, D          ; 1:4       __INFO
    ld    D, A          ; 1:4       __INFO}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( pd 4 -- pd )  [pd] >>= 4
dnl # shifts [pd] right 4 bits
define({_4_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_4_PDRSHIFT},{4 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   L             ; 1:4       __INFO  ( pd 4 -- pd )  [pd] >>= 4  with align 4
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    xor   A             ; 1:4       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA087-->0xA708
    dec   L             ; 1:4       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA765-->0xA576
    dec   L             ; 1:4       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA543-->0xA354
    dec   L             ; 1:4       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA321-->0xA132}){}dnl
dnl
dnl
dnl
dnl # ( d1 8 -- d )  d = d1 >> 8
dnl # shifts d1 right 8 bits
define({_8_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_8_DRSHIFT},{8 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_8_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    L, H          ; 1:4       __INFO  ( d1 8 -- d )  d = d1 >> 8
    ld    H, E          ; 1:4       __INFO
    ld    E, D          ; 1:4       __INFO
    ld    D, 0x00       ; 2:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 8 -- pd )  [pd] >>= 8
dnl # shifts [pd] right 8 bits
define({_8_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_8_PDRSHIFT},{8 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_8_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   L             ; 1:4       __INFO  ( pd 8 -- pd )  [pd] >>= 8  with align 4
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    ld  [HL],0x00       ; 2:10      __INFO
    dec   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    ld  [HL],B          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 12 -- d )  d = d1 >> 12
dnl # shifts d1 right 12 bits
define({_12_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_12_DRSHIFT},{12 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_12_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, H          ; 1:4       __INFO  ( d1 12 -- d )  d = d1 >> 12
    srl   D             ; 2:8       __INFO  876543..->087654..
    rr    E             ; 2:8       __INFO
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  876543..->087654..
    rr    E             ; 2:8       __INFO
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  876543..->087654..
    rr    E             ; 2:8       __INFO
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  876543..->087654..
    rr    E             ; 2:8       __INFO
    rra                 ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    H, E          ; 1:4       __INFO
    ld    E, D          ; 1:4       __INFO
    ld    D, 0x00       ; 2:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 12 -- pd )  [pd] >>= 12
dnl # shifts [pd] right 12 bits
define({_12_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_12_PDRSHIFT},{12 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_12_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    xor   A             ; 1:4       __INFO  ( pd 12 -- pd )  [pd] >>= 12  with align 4
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO  0x00
    dec   L             ; 1:4       __INFO
    ld    C,[HL]        ; 1:7       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA087-->0xA708
    dec   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],C          ; 1:7       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA765-->0xA576
    dec   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA543-->0xA354
}){}dnl
dnl
dnl
dnl
dnl # ( d1 16 -- d )  d = d1 >> 16
dnl # shifts d1 right 16 bits
define({_16_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_16_DRSHIFT},{16 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_16_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ex   DE, HL         ; 1:4       __INFO  ( d1 16 -- d )  d = d1 >> 16
    ld   DE, 0x0000     ; 3:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 16 -- pd )  [pd] >>= 16
dnl # shifts [pd] right 16 bits
define({_16_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_16_PDRSHIFT},{16 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_16_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   L             ; 1:4       __INFO  ( pd 16 -- pd )  [pd] >>= 16  with align 4
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    xor   A             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld    C,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld  [HL],C          ; 1:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 20 -- d )  d = d1 >> 20
dnl # shifts d1 right 20 bits
define({_20_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_20_DRSHIFT},{20 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_20_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, E          ; 1:4       __INFO  ( d1 20 -- d )  d = d1 >> 20
    srl   D             ; 2:8       __INFO  8765....->0876....
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765....->0876....
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765....->0876....
    rra                 ; 1:4       __INFO
    srl   D             ; 2:8       __INFO  8765....->0876....
    rra                 ; 1:4       __INFO
    ld    E, A          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld   DE, 0x0000     ; 3:10      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 20 -- pd )  [pd] >>= 20
dnl # shifts [pd] right 20 bits
define({_20_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_20_PDRSHIFT},{20 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_20_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    inc   L             ; 1:4       __INFO  ( pd 20 -- pd )  [pd] >>= 20  with align 4
    inc   L             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    xor   A             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld    C,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    dec   L             ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA087-->0xA708
    dec   L             ; 1:4       __INFO
    ld  [HL],C          ; 1:7       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA765-->0xA576}){}dnl
dnl
dnl
dnl
dnl # ( d1 24 -- d )  d = d1 >> 24
dnl # shifts d1 right 24 bits
define({_24_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_24_DRSHIFT},{24 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_24_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    L, D          ; 1:4       __INFO  ( d1 24 -- d )  d = d1 >> 24
    ld   DE, 0x0000     ; 3:10      __INFO
    ld    H, D          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 24 -- pd )  [pd] >>= 24
dnl # shifts [pd] right 24 bits
define({_24_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_24_PDRSHIFT},{24 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_24_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 24 -- pd )  [pd] >>= 24  with align 4
    xor   A             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 28 -- d )  d = d1 >> 28
dnl # shifts d1 right 28 bits
define({_28_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_28_DRSHIFT},{28 drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_28_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, D          ; 1:4       __INFO  ( d1 28 -- d )  d = d1 >> 28
    rra                 ; 1:4       __INFO
    rra                 ; 1:4       __INFO
    rra                 ; 1:4       __INFO
    rra                 ; 1:4       __INFO
    and  0x0F           ; 2:7       __INFO
    ld    L, A          ; 1:4       __INFO
    ld   DE, 0x0000     ; 3:10      __INFO
    ld    H, D          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( pd 28 -- pd )  [pd] >>= 28
dnl # shifts [pd] right 28 bits
define({_28_PDRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_28_PDRSHIFT},{28 pdrshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_28_PDRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    C, L          ; 1:4       __INFO  ( pd 28 -- pd )  [pd] >>= 28  with align 4
    xor   A             ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    B,[HL]        ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld  [HL],B          ; 1:7       __INFO
    rrd                 ; 2:18      __INFO  A[HL]=0xA087-->0xA708}){}dnl
dnl
dnl
dnl
dnl # ( d1 u -- d )  d = d1 >> u
dnl # shifts d1 right u places
define({_2_PICK_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN__2_PICK_DRSHIFT},{rot drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN__2_PICK_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__def({USE__2_PICK_DRSHIFT})
    pop  BC             ; 1:10      __INFO   ( d1 -- d )  d = d1 >> BC
    call BC_RSHIFT32    ; 3:17      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( u -- d )  d = $1. >> u
define({PUSH2__2_PICK_DRSHIFT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2__2_PICK_DRSHIFT},{rot drshift},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2__2_PICK_DRSHIFT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__def({USE__2_PICK_DRSHIFT})
    ld    C, L          ; 1:4       __INFO   ( u -- d )  d = __VIEW_DE_HL($@) >> u
    ld    B, H          ; 1:4       __INFO
    push  DE            ; 1:11      __INFO{}dnl
__ASM_TOKEN_2DROP_PUSH2($@)
    call BC_RSHIFT32    ; 3:17      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( d1 d2 -- d )
dnl # d = d1 & d2
define({DAND},{dnl
__{}__ADD_TOKEN({__TOKEN_DAND},{dand},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DAND},{dnl
__{}define({__INFO},{dand}){}dnl

    pop  BC             ; 1:10      dand   ( d2 d1 -- d )  d = d2 & d1
    ld    A, C          ; 1:4       dand
    and   L             ; 1:4       dand
    ld    L, A          ; 1:4       dand
    ld    A, B          ; 1:4       dand
    and   H             ; 1:4       dand
    ld    H, A          ; 1:4       dand
    pop  BC             ; 1:10      dand
    ld    A, C          ; 1:4       dand
    and   E             ; 1:4       dand
    ld    E, A          ; 1:4       dand
    ld    A, B          ; 1:4       dand
    and   D             ; 1:4       dand
    ld    D, A          ; 1:4       dand}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 )
dnl # [pd1] &= [pd2]
define({PDAND},{dnl
__{}__ADD_TOKEN({__TOKEN_PDAND},{pdand},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDAND},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( pd2 pd1 -- pd2 pd1 )  [pd1] &= [pd2] with align 4
    and [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    ld    B, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    and [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    and [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    and [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    E, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] &= [p2]
define({PAND},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PAND},{p{}eval(($1)*8)and},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PAND},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] &= [p{}eval(8*($1))_2] with align $1
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] &= [p{}eval(8*($1))_2] with align $1
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] &= [p{}eval(8*($1))_2] with align $1
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] &= [p{}eval(8*($1))_2] with align $1
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] &= [p{}eval(8*($1))_2] with align $1
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] &= [p{}eval(8*($1))_2] with align $1
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    and [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = d1 & n
define({PUSHDOT_DAND},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHDOT_DAND},{pushdot_dand},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSHDOT_DAND},{dnl
__{}define({__INFO},{pushdot_dand}){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{dnl
__{}__{}                        ;[20:84]    $1. dand
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,3)); 3:13      $1. dand
__{}__{}    and   D             ; 1:4       $1. dand
__{}__{}    ld    D, A          ; 1:4       $1. dand
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,2)); 3:13      $1. dand
__{}__{}    and   E             ; 1:4       $1. dand
__{}__{}    ld    E, A          ; 1:4       $1. dand
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      $1. dand
__{}__{}    and   H             ; 1:4       $1. dand
__{}__{}    ld    H, A          ; 1:4       $1. dand
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      $1. dand
__{}__{}    and   L             ; 1:4       $1. dand
__{}__{}    ld    L, A          ; 1:4       $1. dand},
__IS_NUM($1),{0},{dnl
__{}__{}  .error {$0}($@): M4 does not know the 32-bit value "{$1}"!},
{dnl
__{}__{}define({_TMP_INFO},{$1. dand}){}dnl
__{}__{}__AND_REG16_16BIT({HL},$1){}dnl
__{}__{}__AND_REG16_16BIT({DE},__HEX_DE($1)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = d1 & n
define({PUSH2_DAND},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DAND},{$1 $2 d&},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DAND},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),1,{
__{}  .error {$0}($@): Missing address parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__AND_REG16_16BIT({HL},$2){}dnl
__{}ifelse(
__{}__HEX_L($2),0x00,{__AND_REG16_16BIT({DE},$1,{L},0x00)},
__{}__HEX_H($2),0x00,{__AND_REG16_16BIT({DE},$1,{H},0x00)},
__{}{__AND_REG16_16BIT({DE},$1)}){}dnl
})}){}dnl
dnl
dnl
dnl # ( d1 d2 -- d )
dnl # d = d1 | d2
define({DOR},{dnl
__{}__ADD_TOKEN({__TOKEN_DOR},{dor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DOR},{dnl
__{}define({__INFO},{dor}){}dnl

    pop  BC             ; 1:10      dor   ( d2 d1 -- d )  d = d2 | d1
    ld    A, C          ; 1:4       dor
    or    L             ; 1:4       dor
    ld    L, A          ; 1:4       dor
    ld    A, B          ; 1:4       dor
    or    H             ; 1:4       dor
    ld    H, A          ; 1:4       dor
    pop  BC             ; 1:10      dor
    ld    A, C          ; 1:4       dor
    or    E             ; 1:4       dor
    ld    E, A          ; 1:4       dor
    ld    A, B          ; 1:4       dor
    or    D             ; 1:4       dor
    ld    D, A          ; 1:4       dor}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 )
dnl # [pd1] |= [pd2]
define({PDOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PDOR},{pdor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( pd2 pd1 -- pd2 pd1 )  [pd1] |= [pd2] with align 4
    or  [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    ld    B, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    or  [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    or  [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    or  [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    E, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] |= [p2]
define({POR},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_POR},{p{}eval(($1)*8)or},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_POR},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] |= [p{}eval(8*($1))_2] with align $1
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] |= [p{}eval(8*($1))_2] with align $1
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] |= [p{}eval(8*($1))_2] with align $1
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] |= [p{}eval(8*($1))_2] with align $1
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] |= [p{}eval(8*($1))_2] with align $1
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] |= [p{}eval(8*($1))_2] with align $1
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 )
dnl # [p1] ^= [p2]
define({PXOR},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PXOR},{p{}eval(($1)*8)xor},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PXOR},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] ^= [p{}eval(8*($1))_2] with align $1
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO},
__{}eval($1),2,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] ^= [p{}eval(8*($1))_2] with align $1
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),3,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] ^= [p{}eval(8*($1))_2] with align $1
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   E             ; 1:4       __INFO},
__{}eval($1),4,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] ^= [p{}eval(8*($1))_2] with align $1
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, E          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ld    E, B          ; 1:4       __INFO},
__{}eval($1),256,{
__{}    ld    A,[DE]        ; 1:7       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] ^= [p{}eval(8*($1))_2] with align $1
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-5        ; 2:7/12    __INFO},
__{}{
__{}    ld    C, L          ; 1:4       __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 )  [p{}eval(8*($1))_1] ^= [p{}eval(8*($1))_2] with align $1
__{}    push DE             ; 1:11      __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    ld  [HL],A          ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-5            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = d1 | n
define({PUSHDOT_DOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHDOT_DOR},{pushdot_dor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSHDOT_DOR},{dnl
__{}define({__INFO},{pushdot_dor}){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{dnl
__{}__{}                        ;[20:84]    $1. dor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,3)); 3:13      $1. dor
__{}__{}    or    D             ; 1:4       $1. dor
__{}__{}    ld    D, A          ; 1:4       $1. dor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,2)); 3:13      $1. dor
__{}__{}    or    E             ; 1:4       $1. dor
__{}__{}    ld    E, A          ; 1:4       $1. dor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      $1. dor
__{}__{}    or    H             ; 1:4       $1. dor
__{}__{}    ld    H, A          ; 1:4       $1. dor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      $1. dor
__{}__{}    or    L             ; 1:4       $1. dor
__{}__{}    ld    L, A          ; 1:4       $1. dor},
__IS_NUM($1),{0},{dnl
__{}__{}  .error {$0}($@): M4 does not know the 32-bit value "{$1}"!},
{dnl
__{}__{}define({_TMP_INFO},{$1. dor}){}dnl
__{}__{}__OR_REG16_16BIT({HL},$1){}dnl
__{}__{}__OR_REG16_16BIT({DE},__HEX_DE($1)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = d1 | n
define({PUSH2_DOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DOR},{$1 $2 d|},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DOR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),1,{
__{}  .error {$0}($@): Missing address parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__{}__OR_REG16_16BIT({HL},$2){}dnl
__{}__{}__OR_REG16_16BIT({DE},$1){}dnl
})}){}dnl
dnl
dnl
dnl
dnl # ( d1 u -- d )  d == d1 | 2**u
define({DBITSET},{dnl
__{}__ADD_TOKEN({__TOKEN_DBITSET},{dbitset},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DBITSET},{dnl
__{}define({__INFO},{dbitset}){}dnl
ifelse(eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{ifelse(_TYP_DOUBLE,{fast},{
__{}                       ;[26:108/45] dbitset   ( d1 u -- d )  d = d1 | 2**u   fast version
__{}    ld    A, 0xE0       ; 2:7       dbitset
__{}    and   L             ; 1:4       dbitset
__{}    or    H             ; 1:4       dbitset
__{}    ld    A, L          ; 1:4       dbitset   A = 000r rnnn
__{}    pop  HL             ; 1:10      dbitset
__{}    ex   DE, HL         ; 1:4       dbitset
__{}    jr   nz, $+19       ; 2:7/12    dbitset   out of range 0..31
__{}    rlca                ; 1:4       dbitset   2x
__{}    rlca                ; 1:4       dbitset   4x
__{}    rlca                ; 1:4       dbitset   8x
__{}    ld    C, A          ; 1:4       dbitset   C = rrnn n000, nnn = 0..7, rr=(L:0,H:1,E:2,D:3) --> 5-rr=(L:5,H:4,E:3,D:2)
__{}    rlca                ; 1:4       dbitset
__{}    rlca                ; 1:4       dbitset
__{}    and  0x03           ; 1:4       dbitset
__{}    ld    B, A          ; 1:4       dbitset   B = 0000 00rr
__{}    ld    A, C          ; 1:4       dbitset   A = rrnn n000
__{}    or   0xC5           ; 2:7       dbitset   A = 11nn n101     = set n, L
__{}    sub   B             ; 1:4       dbitset   A = 11nn n101 - B = set n, DEHL
__{}    ld  ($+4), A        ; 3:13      dbitset
__{}    set   0, L          ; 2:8       dbitset},
{__def({USE_BITSET32})
__{}    call BITSET32       ; 3:17      dbitset   ( d1 u -- d )  d = d1 | 2**u   default version})})}){}dnl
dnl
dnl
dnl
dnl # ( d -- d|2**n )
dnl # d = d | 2**n
define({PUSH_DBITSET},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH_DBITSET},{push_dbitset},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH_DBITSET},{dnl
__{}define({__INFO},{push_dbitset}){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{__def({USE__2_PICK_DLSHIFT})
__{}                        ;[28:145]   push_dbitset($1)   ( d1 -- d )  d = d1 | 2**$1
__{}    push DE             ; 1:11      push_dbitset($1)
__{}    push HL             ; 1:11      push_dbitset($1)
__{}    ld   HL, 0x0001     ; 3:10      push_dbitset($1)
__{}    ld    E, H          ; 1:4       push_dbitset($1)
__{}    ld    D, H          ; 1:4       push_dbitset($1)   DEHL = 0x00000001
__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      push_dbitset($1)
__{}    call BC_LSHIFT32    ; 3:17      push_dbitset($1)   ( d1 -- d )  d = d1<<BC
__{}    pop  BC             ; 1:10      push_dbitset($1)
__{}    ld    A, C          ; 1:4       push_dbitset($1)
__{}    or    L             ; 1:4       push_dbitset($1)
__{}    ld    L, A          ; 1:4       push_dbitset($1)
__{}    ld    A, B          ; 1:4       push_dbitset($1)
__{}    or    H             ; 1:4       push_dbitset($1)
__{}    ld    H, A          ; 1:4       push_dbitset($1)
__{}    pop  BC             ; 1:10      push_dbitset($1)
__{}    ld    A, C          ; 1:4       push_dbitset($1)
__{}    or    E             ; 1:4       push_dbitset($1)
__{}    ld    E, A          ; 1:4       push_dbitset($1)
__{}    ld    A, B          ; 1:4       push_dbitset($1)
__{}    or    D             ; 1:4       push_dbitset($1)
__{}    ld    D, A          ; 1:4       push_dbitset($1)},
__IS_NUM($1),{0},{define({_TMP_INFO},{push_dbitset($1)})
__{}  .warning {$0}($@): M4 does not know the "{$1}" value and therefore cannot optimize the code.
__{} if (($1)>=0)
__{} if (($1)<8){}dnl
__{}__OR_REG8_8BIT({L},{(1<<($1))})
__{} else
__{} if (($1)<16){}dnl
__{}__OR_REG8_8BIT({H},{(1<<($1-8))})
__{} else
__{} if (($1)<24){}dnl
__{}__OR_REG8_8BIT({E},{(1<<($1-16))})
__{} else
__{} if (($1)<32){}dnl
__{}__OR_REG8_8BIT({D},{(1<<($1-24))})
__{} endif
__{} endif
__{} endif
__{} endif
__{} endif},
{dnl
__{}ifelse(eval(($1)<0),{1},{
__{}__{}  .error {$0}($@): negative parameters found in macro!},
__{}eval(($1)>31),{1},{
__{}__{}  .warning {$0}($@): Out of range zero to 31th bit.},
__{}{define({_TMP_INFO},{push_dbitset($1)})
__{}__{}ifelse(
__{}__{}eval(($1)< 8),{1},{__OR_REG8_8BIT({L},eval(1<<($1)))},
__{}__{}eval(($1)<16),{1},{__OR_REG8_8BIT({H},eval(1<<($1-8)))},
__{}__{}eval(($1)<24),{1},{__OR_REG8_8BIT({E},eval(1<<($1-16)))},
__{}__{}eval(($1)<32),{1},{__OR_REG8_8BIT({D},eval(1<<($1-24)))})}){}dnl
})}){}dnl
dnl
dnl
dnl # ( d1 d2 -- d )
dnl # d = d1 ^ d2
define({DXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_DXOR},{dxor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DXOR},{dnl
__{}define({__INFO},{dxor}){}dnl

    pop  BC             ; 1:10      dxor   ( d2 d1 -- d )  d = d2 ^ d1
    ld    A, C          ; 1:4       dxor
    xor    L            ; 1:4       dxor
    ld    L, A          ; 1:4       dxor
    ld    A, B          ; 1:4       dxor
    xor    H            ; 1:4       dxor
    ld    H, A          ; 1:4       dxor
    pop  BC             ; 1:10      dxor
    ld    A, C          ; 1:4       dxor
    xor    E            ; 1:4       dxor
    ld    E, A          ; 1:4       dxor
    ld    A, B          ; 1:4       dxor
    xor    D            ; 1:4       dxor
    ld    D, A          ; 1:4       dxor}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 )
dnl # [pd1] ^= [pd2]
define({PDXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PDXOR},{pdxor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDXOR},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[DE]        ; 1:7       __INFO   ( pd2 pd1 -- pd2 pd1 )  [pd1] ^= [pd2] with align 4
    xor [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    ld    B, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ld    E, B          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = d1 ^ n
define({PUSHDOT_DXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHDOT_DXOR},{pushdot_dxor},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSHDOT_DXOR},{dnl
__{}define({__INFO},{pushdot_dxor}){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{dnl
__{}__{}                        ;[20:84]    $1. dxor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,3)); 3:13      $1. dxor
__{}__{}    xor   D             ; 1:4       $1. dxor
__{}__{}    ld    D, A          ; 1:4       $1. dxor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,2)); 3:13      $1. dxor
__{}__{}    xor   E             ; 1:4       $1. dxor
__{}__{}    ld    E, A          ; 1:4       $1. dxor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      $1. dxor
__{}__{}    xor   H             ; 1:4       $1. dxor
__{}__{}    ld    H, A          ; 1:4       $1. dxor
__{}__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      $1. dxor
__{}__{}    xor   L             ; 1:4       $1. dxor
__{}__{}    ld    L, A          ; 1:4       $1. dxor},
__IS_NUM($1),{0},{dnl
__{}__{}  .error {$0}($@): M4 does not know the 32-bit value "{$1}"!},
{dnl
__{}__{}define({_TMP_INFO},{$1. dxor}){}dnl
__{}__{}__XOR_REG16_16BIT({HL},$1){}dnl
__{}__{}__XOR_REG16_16BIT({DE},__HEX_DE($1)){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = d1 ^ n
define({PUSH2_DXOR},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DXOR},{$1 $2 d^},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DXOR},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),1,{
__{}  .error {$0}($@): Missing address parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
{dnl
__{}__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}__{}__XOR_REG16_16BIT({HL},$2){}dnl
__{}__{}__XOR_REG16_16BIT({DE},$1){}dnl
})}){}dnl
dnl
dnl
dnl # ( d1 -- d )
dnl # d = ~d1
define({DINVERT},{dnl
__{}__ADD_TOKEN({__TOKEN_DINVERT},{dinvert},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DINVERT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A, L          ; 1:4       __INFO   ( d1 -- d )  d = ~d1
    cpl                 ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    A, H          ; 1:4       __INFO
    cpl                 ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO
    ld    A, E          ; 1:4       __INFO
    cpl                 ; 1:4       __INFO
    ld    E, A          ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    cpl                 ; 1:4       __INFO
    ld    D, A          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # ( pd -- pd )
dnl # [pd] = ~[pd]
define({PDINVERT},{dnl
__{}__ADD_TOKEN({__TOKEN_PDINVERT},{pdinvert},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDINVERT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    ld    A,[HL]        ; 1:7       __INFO   ( pd -- pd )  [pd] = ~[pd]  with align 4
    cpl                 ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    cpl                 ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    cpl                 ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    cpl                 ; 1:4       __INFO
    ld  [HL],A          ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO}){}dnl
dnl
dnl
dnl # D0=
dnl # ( d -- f )
dnl # if ( x1x2 ) bool = 0; else bool = 0xFFFF;
dnl # 0 if 32-bit number not equal to zero, -1 if equal
define({D0EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_D0EQ},{d0=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D0EQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(TYP_D0EQ,{small},{
                        ;[8:54]     __INFO   ( hi lo -- bool )   ;# small version can be changed with "define({TYP_D0EQ},{default})"
    add  HL, DE         ; 1:11      __INFO   carry: 0    1
    sbc   A, A          ; 1:4       __INFO          0x00 0xff
    or    H             ; 1:4       __INFO          H    0xff
    dec  HL             ; 1:6       __INFO
    sub   H             ; 1:4       __INFO   carry: 1|0  0
    sbc  HL, HL         ; 2:15      __INFO   bool: D == 0
    pop   DE            ; 1:10      __INFO},
{
                        ;[9:48]     __INFO   ( hi lo -- bool )   ;# fast version can be changed with "define({TYP_D0EQ},{small})"
    ld    A, D          ; 1:4       __INFO
    or    E             ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    sub   0x01          ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: D == 0
    pop   DE            ; 1:10      __INFO})}){}dnl
dnl
dnl
dnl # 2dup d0=
dnl # ( d -- d f )
define({_2DUP_D0EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_D0EQ},{2dup d0=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_D0EQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(TYP_D0EQ,{small},{
                        ;[9:59]     __INFO   ( d -- d bool )   ;# small version can be changed with "define({TYP_D0EQ},{default})"
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    add  HL, DE         ; 1:11      __INFO   carry: 0    1
    sbc   A, A          ; 1:4       __INFO          0x00 0xff
    or    H             ; 1:4       __INFO          H    0xff
    dec  HL             ; 1:6       __INFO
    sub   H             ; 1:4       __INFO   carry: 1|0  0
    sbc  HL, HL         ; 2:15      __INFO   bool: D == 0},
{
                       ;[10:53]     __INFO   ( d -- d bool )   ;# fast version can be changed with "define({TYP_D0EQ},{small})"
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    or    E             ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    sub   0x01          ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: D == 0}){}dnl
}){}dnl
dnl
dnl
dnl # ( pd1 -- pd1 bool )
dnl # equal ( [pd1] == 0 )
define({PD0EQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PD0EQ},{pd0=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PD0EQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd1 -- pd1 bool )  bool == [pd1] == 0  with align 4
    ld    A,[HL]        ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    sub 0x01            ; 2:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # equal ( [pd2] == 0 )
define({OVER_PD0EQ_NIP},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_PD0EQ_NIP},{over pd0= nip},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_PD0EQ_NIP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool == [pd2] == 0  with align 4
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    sub 0x01            ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # D0<>
dnl # ( d -- f )
dnl # if ( x1x2 ) bool = 0; else bool = 0xFFFF;
dnl # 0 if 32-bit number equal to zero, -1 if not equal
define({D0NE},{dnl
__{}__ADD_TOKEN({__TOKEN_D0NE},{d0<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D0NE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[9:48]     __INFO   ( hi lo -- bool )
    ld    A, D          ; 1:4       __INFO
    or    E             ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: D <> 0
    pop   DE            ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # 2dup d0<>
dnl # ( d -- d f )
define({_2DUP_D0NE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_D0NE},{2dup d0<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_D0NE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                       ;[10:53]     __INFO   ( d -- d bool )
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    ld    A, D          ; 1:4       __INFO
    or    E             ; 1:4       __INFO
    or    H             ; 1:4       __INFO
    or    L             ; 1:4       __INFO
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: D <> 0}){}dnl
dnl
dnl
dnl # ( pd1 -- pd1 bool )
dnl # not equal ( [pd1] <> 0 )
define({PD0NE},{dnl
__{}__ADD_TOKEN({__TOKEN_PD0NE},{pd0<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PD0NE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd1 -- pd1 bool )  bool == [pd1] <> 0  with align 4
    ld    A,[HL]        ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    add   A, 0xFF       ; 2:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # ( p1 -- p1 bool )
dnl # bool = [p1] <> 0
define({P0NE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_P0NE},{p{}eval(8*($1)) 0<>},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_P0NE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] <> 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] <> 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] <> 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] <> 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] <> 0  with align $1
__{}    ld   DE, 0xFFFF     ; 3:10      __INFO
__{}    xor   A             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+6        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    inc  DE             ; 1:6       __INFO
__{}    ld    L, 0x00       ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] <> 0  with align $1
__{}    ld   DE, 0xFFFF     ; 3:10      __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    xor   A             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    djnz $-3            ; 2:8/13    __INFO
__{}    inc  DE             ; 1:6       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # not equal ( [pd2] <> 0 )
define({OVER_PD0NE_NIP},{dnl
__{}__ADD_TOKEN({__TOKEN_OVER_PD0NE_NIP},{over pd0<> nip},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_OVER_PD0NE_NIP},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool == [pd2] <> 0  with align 4
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    or  [HL]            ; 1:7       __INFO
    add   A, 0xFF       ; 2:7       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # D0<
dnl # ( d -- bool )
define({D0LT},{dnl
__{}__ADD_TOKEN({__TOKEN_D0LT},{d0<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_D0LT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(TYP_D0LT,{small},{
                        ;[5:34]     __INFO   ( hi lo -- bool D<0 )
    rl    D             ; 2:8       __INFO
    pop  DE             ; 1:11      __INFO
    sbc  HL, HL         ; 2:15      __INFO}
,{
                        ;[6:31]     __INFO   ( hi lo -- bool D<0 )
    rl    D             ; 2:8       __INFO
    pop  DE             ; 1:11      __INFO
    sbc   A, A          ; 1:4       __INFO
    ld    L, A          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO   bool: D < 0})}){}dnl
dnl
dnl
dnl # D=
dnl # ( d2 d1 -- bool )
dnl # equal ( d1 == d2 )
define({DEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_DEQ},{d=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
                     ;[15:90/69,91] __INFO  ( d2 d1 -- bool )
    pop  BC             ; 1:10      __INFO   BC = lo_2
    xor   A             ; 1:4       __INFO    A = 0x00
    sbc  HL, BC         ; 2:15      __INFO   HL = lo_1 - lo_2
    pop  HL             ; 1:10      __INFO   HL = hi_2
    jr   nz, $+7        ; 2:7/12    __INFO
    sbc  HL, DE         ; 2:15      __INFO   HL = hi_2 - hi_1
    jr   nz, $+3        ; 2:7/12    __INFO
    dec   A             ; 1:4       __INFO    A = 0xFF
    ld    L, A          ; 1:4       __INFO
    ld    H, A          ; 1:4       __INFO   HL = bool d2==d1
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # equal ( [pd1] == [pd2] )
define({PDEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PDEQ},{pd=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDEQ},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool = [pd1] == [pd2] with align 4
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    jr   nz, $+22       ; 2:7/12    __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    jr   nz, $+14       ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    jr   nz, $+8        ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    sub 0x01            ; 2:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO}){}dnl
dnl
dnl
dnl
dnl # $1. D=
dnl # ( d1 -- bool )
dnl # equal ( d1 == $1 )
define({PUSHDOT_DEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSHDOT_DEQ},{$1. d=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSHDOT_DEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing address parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
__HAS_PTR($1),{1},{
__{}                        ;[20:106]   $1. D=   ( d1 -- bool )  bool: d1 == $1
__{}    ld   BC,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 4:20      $1. D=
__{}    xor   A             ; 1:4       $1. D=
__{}    sbc  HL, BC         ; 2:15      $1. D=
__{}    jr   nz, $+10       ; 2:7/12    $1. D=
__{}    ld   HL,__FORM({%-12s},__PTR_ADD($1,2)); 3:16      $1. D=
__{}    sbc  HL, DE         ; 2:15      $1. D=
__{}    jr   nz, $+3        ; 2:7/12    $1. D=
__{}    dec   A             ; 1:4       $1. D=   A = 0xFF
__{}    ld    L, A          ; 1:4       $1. D=
__{}    ld    H, A          ; 1:4       $1. D=   HL = bool
__{}    pop  DE             ; 1:10      $1. D=},
__IS_NUM($1),{0},{
__{}  .error {$0}($@): M4 does not know $1 parameter value!},
{ifelse(eval($1),0,{__ASM_TOKEN_D0EQ},
__{}__{}{define({_TMP_INFO},{$1. D=}){}define({_TMP_STACK_INFO},{ _TMP_INFO   ( d1 -- bool )  bool: d1 == $1}){}__LD_REG16({HL},__HEX_DE($1),{HL},0,{BC},__HEX_HL($1)){}
__{}__{}__DEQ_MAKE_BEST_CODE($1,6,29,0,0){}dnl
__{}__{}define({_TMP_P},eval(59+80+__CLOCKS_16BIT+8*(16+__BYTES_16BIT))){}dnl #     price = 16*(clocks + 4*bytes)
__{}__{}ifelse(eval(8*_TMP_P<_TMP_BEST_P),{1},{
__{}__{}                        ;[eval(16+__BYTES_16BIT):59/eval(80+__CLOCKS_16BIT)] $1. D=   ( d1 -- bool )  bool: d1 == $1
__{}__{}    ld   BC, __HEX_HL($1)     ; 3:10      $1. D=
__{}__{}    xor   A             ; 1:4       $1. D=
__{}__{}    sbc  HL, BC         ; 2:15      $1. D=
__{}__{}    jr   nz, $+__FORM({%-9s},eval(7+__BYTES_16BIT)); 2:7/12    $1. D={}dnl
__{}__{}__CODE_16BIT
__{}__{}    sbc  HL, DE         ; 2:15      $1. D=
__{}__{}    jr   nz, $+3        ; 2:7/12    $1. D=
__{}__{}    dec   A             ; 1:4       $1. D=   A = 0xFF
__{}__{}    ld    L, A          ; 1:4       $1. D=
__{}__{}    ld    H, A          ; 1:4       $1. D=   HL = bool
__{}__{}    pop  DE             ; 1:10      $1. D=},{
__{}__{}_TMP_BEST_CODE
__{}__{}    sub  0x01           ; 2:7       $1. D=
__{}__{}    sbc   A, A          ; 1:4       $1. D=
__{}__{}    ld    L, A          ; 1:4       $1. D=
__{}__{}    ld    H, A          ; 1:4       $1. D=   HL = bool
__{}__{}    pop  DE             ; 1:10      $1. D=})})})}){}dnl
dnl
dnl
dnl
dnl # hi lo D=
dnl # ( d -- bool )
dnl # equal ( d == (hi<<16)+lo )
define({PUSH2_DEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DEQ},{$1 $2 d=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),{1},{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
eval((__IS_NUM($1)+__IS_NUM($2))<2),{1},{
__{}__SET_SUMS(13,70){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({HL},$1,{HL},0x0000,{BC},$2){}dnl
__{}__LD_REG16({BC},$2){}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-8s},__SUM_CLOCKS/eval(49+__CLOCKS_16BIT)])__INFO   ( d1 -- bool )  bool: d1 == $1*65536+$2{}__CODE_16BIT
__{}    xor   A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO{}__LD_REG16({HL},$1,{HL},0x0000,{BC},$2)
__{}    jr   nz, $+__FORM({%-9s},eval(7+__BYTES_16BIT)); 2:7/12    __INFO{}dnl
__{}__CODE_16BIT
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool
__{}    pop  DE             ; 1:10      __INFO},
__HEX_HL($1):__HEX_HL($2),0x0000:0x0000,{dnl
__{}__ASM_TOKEN_D0EQ},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}define({_TMP_STACK_INFO},{ _TMP_INFO   ( d1 -- bool )  bool: d1 == eval((__HEX_HL($1)<<16)+__HEX_HL($2))}){}__LD_REG16({HL},__HEX_HL($1),{HL},0,{BC},__HEX_HL($2)){}dnl
__{}__DEQ_MAKE_BEST_CODE(eval((__HEX_HL($1)<<16)+__HEX_HL($2)),6,29,0,0){}dnl
__{}define({_TMP_P},eval(59+80+__CLOCKS_16BIT+8*(16+__BYTES_16BIT))){}dnl #     price = 16*(clocks + 4*bytes)
__{}ifelse(eval(8*_TMP_P<_TMP_BEST_P),{1},{
__{}format({%28s},;[eval(16+__BYTES_16BIT):)format({%-8s},eval(80+__CLOCKS_16BIT)/59])__INFO   ( d1 -- bool )  bool: d1 == __HEX_DEHL((__HEX_HL($1)<<16)+__HEX_HL($2))
__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO
__{}    xor   A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    jr   nz, $+__FORM({%-9s},eval(7+__BYTES_16BIT)); 2:7/12    __INFO{}dnl
__{}__CODE_16BIT
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool
__{}    pop  DE             ; 1:10      __INFO},{
__{}_TMP_BEST_CODE
__{}    sub  0x01           ; 2:7       __INFO
__{}    sbc   A, A          ; 1:4       __INFO
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # hi lo D=
dnl # ( d -- bool )
dnl # equal ( d == (hi<<16)+lo )
define({_2DUP_PUSH2_DEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSH2_DEQ},{2dup $1 $2 d=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSH2_DEQ},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),{1},{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
eval((__IS_NUM($1)+__IS_NUM($2))<2),{1},{
__{}__SET_SUMS(14,75){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({HL},$2,{HL},0x0000,{BC},$1){}dnl
__{}__LD_REG16({BC},$1,{A},0x00){}dnl
__{}                        ;format({%-11s},[__SUM_BYTES:eval(54+__CLOCKS_16BIT)/__SUM_CLOCKS])__INFO   ( d -- d bool )  bool: d1 == $1*65536+$2
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    xor   A             ; 1:4       __INFO{}__CODE_16BIT
__{}    sbc  HL, BC         ; 2:15      __INFO{}__LD_REG16({HL},$2,{HL},0x0000,{BC},$1)
__{}    jr   nz, $+__FORM({%-9s},eval(7+__BYTES_16BIT)); 2:7/12    __INFO{}dnl
__{}__CODE_16BIT
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr   nz, $+3        ; 2:7/12    __INFO
__{}    dec   A             ; 1:4       __INFO   A = 0xFF
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool},
__HEX_HL($1):__HEX_HL($2),0x0000:0x0000,{
__{}                        ;format({%-11s},[10:53])__INFO   ( d -- d bool )  bool: d == 0
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A, D          ; 1:4       __INFO
__{}    or    E             ; 1:4       __INFO
__{}    or    H             ; 1:4       __INFO
__{}    or    L             ; 1:4       __INFO
__{}    sub   0x01          ; 2:7       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
{dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}define({_TMP_STACK_INFO},{ }__INFO{   ( d -- d bool )  bool: d==$1*65536+$2}){}dnl
__{}__DEQ_MAKE_BEST_CODE(__HEX_DE_HL($1,$2),6,37,0,0){}dnl
__{}__DEQ_MAKE_HLDE_CODE(__HEX_DE_HL($1,$2),9+{_TMP_ZERO}){}dnl
__{}ifelse(_TMP_ZERO,{1},{dnl
__{}__{}define({_TMP_B},eval(_TMP_B+5)){}dnl
__{}__{}define({_TMP_T}, eval(_TMP_NJ+19)){}dnl  ;# true
__{}__{}define({_TMP_F}, eval(_TMP_J+8)){}dnl    ;# false
__{}__{}define({_TMP_F2},eval(_TMP_NJ+20)){}dnl # false2
__{}__{}define({_TMP_HLDE_CODE},{dnl
__{}__{}__{}                     ;[_TMP_B:_TMP_T/_TMP_F,_TMP_F2] _TMP_INFO   ( d -- d bool )
__{}__{}__{}}_TMP_HLDE_CODE{
__{}__{}__{}    jr   nz, $+3        ; 2:7/12    _TMP_INFO
__{}__{}__{}    dec   A             ; 1:4       _TMP_INFO   A = 0xFF = true
__{}__{}__{}    ld    L, A          ; 1:4       _TMP_INFO
__{}__{}__{}    ld    H, A          ; 1:4       _TMP_INFO   bool: d==__HEX_DE_HL($1,$2)})},
__{}{dnl
__{}__{}define({_TMP_B},eval(_TMP_B+6)){}dnl
__{}__{}define({_TMP_T}, eval(_TMP_NJ+20)){}dnl  ;# true
__{}__{}define({_TMP_F}, eval(_TMP_J+15)){}dnl   ;# false
__{}__{}define({_TMP_F2},eval(_TMP_NJ+22)){}dnl # false2
__{}__{}define({_TMP_HLDE_CODE},{dnl
__{}__{}__{}                     ;[_TMP_B:_TMP_T/_TMP_F,_TMP_F2] _TMP_INFO   ( d -- d bool )
__{}__{}__{}}_TMP_HLDE_CODE{
__{}__{}__{}    jr    z, $+4        ; 2:7/12    _TMP_INFO
__{}__{}__{}    ld    L, 0x01       ; 2:7       _TMP_INFO
__{}__{}__{}    dec   L             ; 1:4       _TMP_INFO
__{}__{}__{}    ld    H, L          ; 1:4       _TMP_INFO   bool: d==__HEX_DE_HL($1,$2)})}){}dnl
__{}define({_TMP_P},eval(8*_TMP_T+4*_TMP_F+4*_TMP_F2+64*_TMP_B)){}dnl #     price = 16*(clocks + 4*bytes)
__{}define({_TMP},eval(_TMP_BEST_P<=_TMP_P)){}dnl
__{}ifelse(_TMP,{0},{
__{}__{}if 0
__{}__{}; price: _TMP_BEST_P})
__{}_TMP_BEST_CODE
__{}    sub 0x01            ; 2:7       _TMP_INFO
__{}    ex   DE, HL         ; 1:4       _TMP_INFO
__{}    push HL             ; 1:11      _TMP_INFO
__{}    sbc  HL, HL         ; 2:15      _TMP_INFO   bool: d==__HEX_DE_HL($1,$2){}dnl
__{}ifelse(_TMP,{0},{
__{}__{}else
__{}__{}; price: _TMP_P
__{}__{}_TMP_HLDE_CODE
__{}__{}endif})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # hi lo D<>
dnl # ( d -- bool )
dnl # not equal ( d1 <> (hi<<16)+lo )
define({PUSH2_DNE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DNE},{$1 $2 d<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),{1},{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
eval((__IS_NUM($1)+__IS_NUM($2))<2),{1},{
__{}__SET_SUMS(13,68){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({HL},$1,{HL},0x0000,{BC},$2){}dnl
__{}__LD_REG16({BC},$2){}dnl
__{}format({%28s},;[__SUM_BYTES:)format({%-8s},__SUM_CLOCKS/eval(51+__CLOCKS_16BIT)])__INFO   ( d1 -- bool )  bool: d1 == $1*65536+$2{}__CODE_16BIT
__{}    xor   A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO{}__LD_REG16({HL},$1,{HL},0x0000,{BC},$2)
__{}    jr   nz, $+__FORM({%-9s},eval(6+__BYTES_16BIT)); 2:7/12    __INFO{}dnl
__{}__CODE_16BIT
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = true
__{}    pop  DE             ; 1:10      __INFO},
__HEX_HL($1):__HEX_HL($2),0x0000:0x0000,{dnl
__{}__ASM_TOKEN_D0NE},
{dnl
__{}define({_TMP_INFO},__COMPILE_INFO){}dnl
__{}define({_TMP_STACK_INFO},{ _TMP_INFO   ( d1 -- bool )  bool: d1 == $1}){}__LD_REG16({HL},__HEX_HL($1),{HL},0,{BC},__HEX_HL($2)){}dnl
__{}__DEQ_MAKE_BEST_CODE(__HEX_DE_HL($1,$2),6,29,0,0){}dnl
__{}define({_TMP_P},eval(61+78+__CLOCKS_16BIT+8*(16+__BYTES_16BIT))){}dnl #     price = 16*(clocks + 4*bytes)
__{}ifelse(eval(8*_TMP_P<_TMP_BEST_P),{1},{
__{}format({%28s},;[eval(16+__BYTES_16BIT):)format({%-8s},eval(78+__CLOCKS_16BIT)/61])__INFO   ( d1 -- bool )  bool: d1 == __HEX_DEHL((__HEX_HL($1)<<16)+__HEX_HL($2))
__{}    ld   BC, __HEX_HL($2)     ; 3:10      __INFO
__{}    xor   A             ; 1:4       __INFO
__{}    sbc  HL, BC         ; 2:15      __INFO
__{}    jr   nz, $+__FORM({%-9s},eval(6+__BYTES_16BIT)); 2:7/12    __INFO{}dnl
__{}__CODE_16BIT
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = bool
__{}    pop  DE             ; 1:10      __INFO},{
__{}_TMP_BEST_CODE
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    sbc   A, A          ; 1:4       __INFO
__{}    ld    L, A          ; 1:4       __INFO
__{}    ld    H, A          ; 1:4       __INFO   HL = bool
__{}    pop  DE             ; 1:10      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # hi lo D=
dnl # ( d -- bool )
dnl # equal ( d == (hi<<16)+lo )
define({_2DUP_PUSH2_DNE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSH2_DNE},{2dup $1 $2 d<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSH2_DNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(eval($#<2),{1},{
__{}  .error {$0}($@): Missing parameter!},
eval($#>2),{1},{
__{}  .error {$0}($@): $# parameters found in macro!},
eval((__IS_NUM($1)+__IS_NUM($2))<2),{1},{
__{}__SET_SUMS(14,73){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({HL},$2,{HL},0x0000,{BC},$1){}dnl
__{}__LD_REG16({BC},$1,{A},0x00){}dnl
__{}format({%36s},;[__SUM_BYTES:eval(56+__CLOCKS_16BIT){,}__SUM_CLOCKS/eval(__SUM_CLOCKS-5)] )__INFO   ( d -- d bool )  bool: d1 == $1*65536+$2
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    xor   A             ; 1:4       __INFO{}__CODE_16BIT
__{}    sbc  HL, BC         ; 2:15      __INFO{}__LD_REG16({HL},$2,{HL},0x0000,{BC},$1)
__{}    jr   nz, $+format({%-9s},eval(6+__BYTES_16BIT)); 2:7/12    __INFO{}dnl
__{}__CODE_16BIT
__{}    sbc  HL, DE         ; 2:15      __INFO
__{}    jr    z, $+5        ; 2:7/12    __INFO
__{}    ld   HL, 0xFFFF     ; 3:10      __INFO   HL = true},
__HEX_HL($1):__HEX_HL($2),0x0000:0x0000,{
__{}                        ;format({%-11s},[10:53])__INFO   ( d -- d bool )  bool: d == 0
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A, D          ; 1:4       __INFO
__{}    or    E             ; 1:4       __INFO
__{}    or    H             ; 1:4       __INFO
__{}    or    L             ; 1:4       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
{dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}define({_TMP_STACK_INFO},{ }__INFO{   ( d -- d bool )  bool: d<>$1*65536+$2}){}dnl
__{}__DEQ_MAKE_BEST_CODE(__HEX_DE_HL($1,$2),6,37,0,0){}dnl
__{}__DEQ_MAKE_HLDE_CODE(__HEX_DE_HL($1,$2),9){}dnl
__{}define({_TMP_B},eval(_TMP_B+5)){}dnl
__{}define({_TMP_T}, eval(_TMP_J+10)){}dnl   ;# true
__{}define({_TMP_T2},eval(_TMP_NJ+17)){}dnl  ;# true2
__{}define({_TMP_F}, eval(_TMP_NJ+12)){}dnl  ;# false
__{}define({_TMP_HLDE_CODE},{dnl
__{}__{}                     ;[_TMP_B:_TMP_T,_TMP_T2/_TMP_F] _TMP_INFO   ( d -- d bool )
__{}__{}}_TMP_HLDE_CODE{
__{}__{}    jr    z, $+5        ; 2:7/12    _TMP_INFO
__{}__{}    ld   HL, 0xFFFF     ; 3:10      _TMP_INFO   bool: d<>__HEX_DE_HL($1,$2)}){}dnl
__{}define({_TMP_P},eval(4*_TMP_T+4*_TMP_T2+8*_TMP_F+64*_TMP_B)){}dnl #     price = 16*(clocks + 4*bytes)
__{}define({_TMP},eval(_TMP_BEST_P<=_TMP_P)){}dnl
__{}ifelse(_TMP,{0},{
__{}__{}if 0
__{}__{}; price: _TMP_BEST_P})
__{}_TMP_BEST_CODE
__{}    add   A, 0xFF       ; 2:7       _TMP_INFO
__{}    ex   DE, HL         ; 1:4       _TMP_INFO
__{}    push HL             ; 1:11      _TMP_INFO
__{}    sbc  HL, HL         ; 2:15      _TMP_INFO   bool: d<>__HEX_DE_HL($1,$2){}dnl
__{}ifelse(_TMP,{0},{
__{}__{}else
__{}__{}; price: _TMP_P
__{}__{}_TMP_HLDE_CODE
__{}__{}endif})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # Du=
dnl # ( ud2 ud1 -- bool )
dnl # equal ( ud1 == ud2 )
define({DUEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_DEQ},{du=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUEQ},{dnl
__{}__ASM_TOKEN_DEQ{}dnl
}){}dnl
dnl
dnl
dnl # D<>
dnl # ( d2 d1 -- bool )
dnl # not equal ( d1 != d2 )
define({DNE},{dnl
__{}__ADD_TOKEN({__TOKEN_DNE},{d<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DNE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                       ;[15:71,88/83]__INFO  ( d2 d1 -- bool )
    pop  BC             ; 1:10      __INFO   n h2    . h1 l1  BC= lo(d2) = l2
    xor   A             ; 1:4       __INFO   n h2    . h1 l1  A = 0x00
    sbc  HL, BC         ; 2:15      __INFO   n h2    . h1 --  HL= l1 - l2
    pop  HL             ; 1:10      __INFO   n       . h1 h2  HL= hi(d2) = h2
    jr   nz, $+6        ; 2:7/12    __INFO   n       . h1 h2
    sbc  HL, DE         ; 2:15      __INFO   n       . h1 h2  HL = h2 - h1
    jr    z, $+5        ; 2:7/12    __INFO   n       . h1 h2
    ld   HL, 0xFFFF     ; 3:10      __INFO   n       . h1 ff  HL = true
    pop  DE             ; 1:10      __INFO           . n  ff}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # not equal ( [pd1] != [pd2] )
define({PDNE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDNE},{pd<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDNE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool = [pd1] != [pd2] with align 4
    ld    C, L          ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    jr   nz, $+18       ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    jr   nz, $+12       ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    jr   nz, $+6        ; 2:7/12    __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    xor [HL]            ; 1:7       __INFO
    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
    ld     L, C         ; 1:4       __INFO
    ex    DE, HL        ; 1:4       __INFO
    sbc   HL, HL        ; 2:15      __INFO}){}dnl
dnl
dnl
dnl # Du<>
dnl # ( ud2 ud1 -- bool )
dnl # not equal ( ud1 != ud2 )
define({DUNE},{dnl
__{}__ADD_TOKEN({__TOKEN_DNE},{du<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUNE},{dnl
__{}__ASM_TOKEN_DNE{}dnl
}){}dnl
dnl
dnl
dnl # du<
dnl # 2swap du>
dnl # ( ud2 ud1 -- bool )  bool: ud2 du< ud1
dnl # unsigned ( ud2 < ud1 ) --> ( d2 - d1 < 0 ) --> carry is true
define({DULT},{dnl
__{}__ADD_TOKEN({__TOKEN_DULT},{du<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DULT},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[11:76]    __INFO   ( ud2 ud1 -- bool )  bool: ud2 du< ud1
    pop  BC             ; 1:10      __INFO   lo(ud2)
    ld    A, C          ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
    sub   L             ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
    ld    A, B          ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
    sbc   A, H          ; 1:4       __INFO   BC<HL --> BC-HL<0 --> carry if true
    pop  HL             ; 1:10      __INFO   hi(ud2)
    sbc  HL, DE         ; 2:15      __INFO   HL<DE --> HL-DE<0 --> carry if true
    sbc  HL, HL         ; 2:15      __INFO   bool: ud2<ud1
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # du<=
dnl # 2swap du>=
dnl # ( ud2 ud1 -- bool )  bool: ud2 du<= ud1
dnl # (ud2 <= ud1)  -->  (ud2 < ud1 + 1) -->  (ud2 - ud1 - 1 < 0) -->  carry if true
define({DULE},{dnl
__{}__ADD_TOKEN({__TOKEN_DULE},{du<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DULE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[12:80]    __INFO   ( ud2 ud1 -- bool )  bool: ud2 du<= ud1
    pop  BC             ; 1:10      __INFO   lo(ud2)
    scf                 ; 1:4       __INFO
    ld    A, C          ; 1:4       __INFO   BC<=HL --> BC<HL+1 --> BC-HL-1<0 --> carry if true
    sbc   A, L          ; 1:4       __INFO   BC<=HL --> BC<HL+1 --> BC-HL-1<0 --> carry if true
    ld    A, B          ; 1:4       __INFO   BC<=HL --> BC<HL+1 --> BC-HL-1<0 --> carry if true
    sbc   A, H          ; 1:4       __INFO   BC<=HL --> BC<HL+1 --> BC-HL-1<0 --> carry if true
    pop  HL             ; 1:10      __INFO   hi(ud2)
    sbc  HL, DE         ; 2:15      __INFO   HL<=DE --> HL<DE+1 --> HL-DE-1<0 --> carry if true
    sbc  HL, HL         ; 2:15      __INFO   bool: ud2<=ud1
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # du>=
dnl # 2swap du<=
dnl # ( ud2 ud1 -- bool )  bool: ud2 du>= ud1
dnl # (ud2 >= ud1)  -->  (ud2 + 1 > ud1) -->  (0 > ud1 - ud2 - 1) -->  carry if true
define({DUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_DUGE},{du>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUGE},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[12:80]    __INFO   ( ud2 ud1 -- bool )  bool: ud2 du>= ud1
    pop  BC             ; 1:10      __INFO   lo(ud2)
    scf                 ; 1:4       __INFO
    sbc  HL, BC         ; 2:15      __INFO   BC>=HL --> BC+1>HL --> 0>HL-BC-1 --> carry if true
    pop  HL             ; 1:10      __INFO   hi(ud2)
    ld    A, E          ; 1:4       __INFO   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    sbc   A, L          ; 1:4       __INFO   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    ld    A, D          ; 1:4       __INFO   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    sbc   A, H          ; 1:4       __INFO   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    sbc  HL, HL         ; 2:15      __INFO   bool: ud2>=ud1
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # du>
dnl # 2swap du<
dnl # ( ud2 ud1 -- bool )  bool: ud2 du> ud1
define({DUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_DUGT},{du>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DUGT},{dnl
__{}define({__INFO},__COMPILE_INFO)
                        ;[13:77]    __INFO   ( ud2 ud1 -- bool )  bool: ud2 du> ud1
    pop  BC             ; 1:10      __INFO   lo(ud2)
    ld    A, L          ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
    sub   C             ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
    ld    A, H          ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
    sbc   A, B          ; 1:4       __INFO   BC>HL --> 0>HL-BC --> carry if true
    pop  BC             ; 1:10      __INFO   hi(ud2)
    ld    A, E          ; 1:4       __INFO   BC>DE --> 0>DE-BC --> carry if true
    sbc   A, C          ; 1:4       __INFO   BC>DE --> 0>DE-BC --> carry if true
    ld    A, D          ; 1:4       __INFO   BC>DE --> 0>DE-BC --> carry if true
    sbc   A, B          ; 1:4       __INFO   BC>DE --> 0>DE-BC --> carry if true
    sbc  HL, HL         ; 2:15      __INFO   bool: ud2>ud1
    pop  DE             ; 1:10      __INFO}){}dnl
dnl
dnl
dnl # D<
dnl # ( d2 d1 -- bool )
dnl # signed ( d2 < d1 ) --> ( d2 - d1 < 0 ) --> carry is true
define({DLT},{dnl
__{}__ADD_TOKEN({__TOKEN_DLT},{d<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DLT},{dnl
__{}define({__INFO},{dlt}){}dnl
ifelse(_TYP_DOUBLE,{function},{ifdef({USE_FCE_DLT},,define({USE_FCE_DLT},{yes}))
                        ;[8:62]     D<   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    pop  BC             ; 1:10      D<   l2
    pop  AF             ; 1:10      D<   h2
    call FCE_DLT        ; 3:17      D<   carry if true
    pop  DE             ; 1:10      D<
    sbc  HL, HL         ; 2:15      D<   bool: d2<d1},
{
                       ;[17:93]     D<   ( d2 d1 -- bool )   ;# fast version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      D<   lo_2
    ld    A, C          ; 1:4       D<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    sub   L             ; 1:4       D<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    ld    A, B          ; 1:4       D<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    sbc   A, H          ; 1:4       D<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    pop  HL             ; 1:10      D<   hi_2
    ld    A, L          ; 1:4       D<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    sbc   A, E          ; 1:4       D<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    ld    A, H          ; 1:4       D<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    sbc   A, D          ; 1:4       D<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    rra                 ; 1:4       D<                                   -->  sign if true
    xor   H             ; 1:4       D<
    xor   D             ; 1:4       D<
    add   A, A          ; 1:4       D<                                   --> carry if true
    sbc  HL, HL         ; 2:15      D<   bool: d2<d1
    pop  DE             ; 1:10      D<})}){}dnl
dnl
dnl
dnl # D<=
dnl # 2swap D>=
dnl # ( d2 d1 -- f )
define({DLE},{dnl
__{}__ADD_TOKEN({__TOKEN_DLE},{d<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DLE},{dnl
__{}define({__INFO},{dle}){}dnl
ifelse(_TYP_DOUBLE,{function},{ifdef({USE_FCE_DGT},,define({USE_FCE_DGT},{yes}))
                        ;[9:66]     D<=   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    pop  BC             ; 1:10      D<=   l2
    pop  AF             ; 1:10      D<=   h2
    call FCE_DGT        ; 3:17      D<=   D> carry if true --> D<= carry if false
    ccf                 ; 1:4       D<=   invert carry
    pop  DE             ; 1:10      D<=
    sbc  HL, HL         ; 2:15      D<=   bool: d2<=d1},
{
                       ;[18:97]     D<=   ( d2 d1 -- bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      D<=   lo_2
    ld    A, L          ; 1:4       D<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    sub   C             ; 1:4       D<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    ld    A, H          ; 1:4       D<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    sbc   A, B          ; 1:4       D<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    pop  HL             ; 1:10      D<=   hi_2
    ld    A, E          ; 1:4       D<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    sbc   A, L          ; 1:4       D<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    ld    A, D          ; 1:4       D<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    sbc   A, H          ; 1:4       D<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    rra                 ; 1:4       D<=                                      --> no sign  if true
    xor   B             ; 1:4       D<=
    xor   D             ; 1:4       D<=
    add   A, A          ; 1:4       D<=                                      --> no carry if true
    ccf                 ; 1:4       D<=                                      --> carry    if true
    sbc  HL, HL         ; 2:15      D<=   bool: d2<d1
    pop  DE             ; 1:10      D<=})}){}dnl
dnl
dnl
dnl # D>=
dnl # 2swap D<=
dnl # ( d2 d1 -- bool )
dnl # (d2 >= d1)  -->  (d2 + 1 > d1) -->  (0 > d1 - d2 - 1) -->  carry if true
define({DGE},{dnl
__{}__ADD_TOKEN({__TOKEN_DGE},{d>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DGE},{dnl
__{}define({__INFO},{dge}){}dnl
ifelse(_TYP_DOUBLE,{function},{ifdef({USE_FCE_DLT},,define({USE_FCE_DLT},{yes}))
                        ;[9:66]     D>=   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    pop  BC             ; 1:10      D>=   l2
    pop  AF             ; 1:10      D>=   h2
    call FCE_DLT        ; 3:17      D>=   D< carry if true --> D>= carry if false
    ccf                 ; 1:4       D>=   invert carry
    pop  DE             ; 1:10      D>=
    sbc  HL, HL         ; 2:15      D>=   bool: d2>=d1},
{
                        ;[16:96]    D>=   ( d2 d1 -- bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      D>=   lo(ud2)
    scf                 ; 1:4       D>=
    sbc  HL, BC         ; 2:15      D>=   BC>=HL --> BC+1>HL --> 0>HL-BC-1 --> carry if true
    pop  HL             ; 1:10      D>=   hi(ud2)
    ld    A, E          ; 1:4       D>=   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    sbc   A, L          ; 1:4       D>=   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    ld    A, D          ; 1:4       D>=   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    sbc   A, H          ; 1:4       D>=   HL>=DE --> HL+1>DE --> 0>DE-HL-1 --> carry if true
    rra                 ; 1:4       D>=                                    -->  sign if true
    xor   H             ; 1:4       D>=
    xor   D             ; 1:4       D>=
    add   A, A          ; 1:4       D>=                                    --> carry if true
    sbc  HL, HL         ; 2:15      D>=   bool: d2>=d1
    pop  DE             ; 1:10      D>=})}){}dnl
dnl
dnl
dnl # D>
dnl # 2swap D<
dnl # ( d2 d1 -- bool )
define({DGT},{dnl
__{}__ADD_TOKEN({__TOKEN_DGT},{d>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_DGT},{dnl
__{}define({__INFO},{dgt}){}dnl
ifelse(_TYP_DOUBLE,{function},{ifdef({USE_FCE_DGT},,define({USE_FCE_DGT},{yes}))
                        ;[8:62]     D>   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    pop  BC             ; 1:10      D>   l2
    pop  AF             ; 1:10      D>   h2
    call FCE_DGT        ; 3:17      D>   carry if true
    pop  DE             ; 1:10      D>
    sbc  HL, HL         ; 2:15      D>   bool: d2>d1},
{
                        ;[17:93]    D>   ( d2 d1 -- bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      D>   lo(ud2)
    ld    A, L          ; 1:4       D>   BC>HL --> 0>HL-BC --> carry if true
    sub   C             ; 1:4       D>   BC>HL --> 0>HL-BC --> carry if true
    ld    A, H          ; 1:4       D>   BC>HL --> 0>HL-BC --> carry if true
    sbc   A, B          ; 1:4       D>   BC>HL --> 0>HL-BC --> carry if true
    pop  BC             ; 1:10      D>   hi(ud2)
    ld    A, E          ; 1:4       D>   BC>DE --> 0>DE-BC --> carry if true
    sbc   A, C          ; 1:4       D>   BC>DE --> 0>DE-BC --> carry if true
    ld    A, D          ; 1:4       D>   BC>DE --> 0>DE-BC --> carry if true
    sbc   A, B          ; 1:4       D>   BC>DE --> 0>DE-BC --> carry if true
    rra                 ; 1:4       D>                     --> sign  if true
    xor   B             ; 1:4       D>
    xor   D             ; 1:4       D>
    add   A, A          ; 1:4       D>                     --> carry if true
    sbc  HL, HL         ; 2:15      D>   bool: d2>d1
    pop  DE             ; 1:10      D>})}){}dnl
dnl
dnl
dnl # $1 $2 du<
dnl # $1. du<
dnl # ( d -- bool )  bool: d du< $1.
define({PUSH2_DULT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DULT_OVER_SWAP},{$1 $2 du<},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DULT_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}__RESET_SUMS{}dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DULT_CF_STORE($@){}dnl
__{}__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( ud -- bool )  bool: ud du< __VIEW_DE_HL($1,$2){}dnl
__{}__{}__CODE_2DUP_PUSH2_DULT_CF_STORE{}dnl
__{}__{}__CODE_DROP_CARRY_FETCH   bool: d < __VIEW_DE_HL($1,$2){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 du<=
dnl # $1. du<=
dnl # ( d -- bool )  bool: d du<= $1.
define({PUSH2_DULE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DULE_OVER_SWAP},{$1 $2 du<=},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DULE_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{
__{}__{}__RESET_SUMS{}dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DULE_CF_STORE($@){}dnl
__{}__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}__{}format({%28s},;[__SUM_BYTES:)format({%-7s},__SUM_CLOCKS]) __INFO   ( ud -- bool )  bool: ud du<= __VIEW_DE_HL($1,$2){}dnl
__{}__{}__CODE_2DUP_PUSH2_DULE_CF_STORE{}dnl
__{}__{}__CODE_DROP_CARRY_FETCH   bool: d <= __VIEW_DE_HL($1,$2){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 du>=
dnl # $1. du>=
dnl # ( d -- bool )  bool: d du>= $1.
define({PUSH2_DUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DUGE_OVER_SWAP},{$1 $2 du>=},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DUGE_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}__{}define({$0_B0},__BYTES){}dnl
__{}__{}define({$0_C0},__CLOCKS){}dnl
__{}__{}dnl # -----------
__{}__{}define({$0_P1},0x7FFFFFFF){}dnl
__{}__{}ifelse(__HAS_PTR($1):__HEX_HL((0xFFFF&($2))>0),0:0x0001,{dnl # lo16 != 0
__{}__{}__{}__RESET_SUMS{}dnl
__{}__{}__{}define({$0_BC_LO},__LD_R16({BC},__HEX_HL(-($2)))){}dnl
__{}__{}__{}define({$0_BC_HI},__LD_R16({BC},0xFFFF-$1,{BC},__HEX_HL(-($2)))){}dnl
__{}__{}__{}define({$0_B1},eval($0_B0+4+__SUM_BYTES)){}dnl
__{}__{}__{}define({$0_C1},eval($0_C0+30+__SUM_CLOCKS)){}dnl
__{}__{}__{}define({$0_P1},eval($0_C1+__BYTE_PRICE*$0_B1)){}dnl
__{}__{}}){}dnl
__{}__{}dnl # -----------
__{}__{}define({$0_P2},0x7FFFFFFF){}dnl
__{}__{}ifelse(__HEX_HL((0xFFFF&($2))>0),0x0001,{dnl  # lo16 != 0
__{}__{}__{}__RESET_SUMS{}dnl
__{}__{}__{}ifelse(__IS_NUM($2),1,{dnl
__{}__{}__{}__{}define({$0_L},__HEX_L(-($2))){}dnl
__{}__{}__{}__{}define({$0_H},__HEX_H(-($2))){}dnl
__{}__{}__{}},
__{}__{}__{}__HAS_PTR($2),0,{dnl
__{}__{}__{}__{}define({$0_L},__SIMPLIFY_EXPRESSION(255&(-($2)))){}dnl
__{}__{}__{}__{}define({$0_H},__SIMPLIFY_EXPRESSION(255&((-$2)>>8))){}dnl
__{}__{}__{}}){}dnl
__{}__{}__{}ifelse(__IS_NUM($1),1,{dnl
__{}__{}__{}__{}define({$0_E},__HEX_L($1)){}dnl
__{}__{}__{}__{}define({$0_D},__HEX_H($1)){}dnl
__{}__{}__{}},
__{}__{}__{}__HAS_PTR($1),1,{dnl
__{}__{}__{}__{}define({$0_E},__PTR_ADD($1,0)){}dnl
__{}__{}__{}__{}define({$0_D},__PTR_ADD($1,1)){}dnl
__{}__{}__{}},
__{}__{}__{}{dnl
__{}__{}__{}__{}define({$0_E},__SIMPLIFY_EXPRESSION(255&($1))){}dnl
__{}__{}__{}__{}define({$0_D},__SIMPLIFY_EXPRESSION(255&(($1)>>8))){}dnl
__{}__{}__{}}){}dnl
__{}__{}__{}define({$0_BC},__LD_R16({BC},-($2))){}dnl
__{}__{}__{}define({$0_A_LO},__LD_REG8_SAVE_CARRY(A,$0_E,{B},$0_H,{C},$0_L)){}dnl
__{}__{}__{}__ADD_SUMS(__BYTES,__CLOCKS){}dnl
__{}__{}__{}define({$0_A_HI},__LD_REG8_SAVE_CARRY(A,$0_D,{B},$0_H,{C},$0_L)){}dnl
__{}__{}__{}__ADD_SUMS(__BYTES,__CLOCKS){}dnl
__{}__{}__{}define({$0_B2},eval($0_B0+3+__SUM_BYTES)){}dnl
__{}__{}__{}define({$0_C2},eval($0_C0+19+__SUM_CLOCKS)){}dnl
__{}__{}__{}define({$0_P2},eval($0_C2+__BYTE_PRICE*$0_B2)){}dnl
__{}__{}}){}dnl
__{}__{}dnl # -----------
__{}__{}__RESET_SUMS{}dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DUGE_CF_STORE($@){}dnl
__{}__{}define({$0_B3},eval($0_B0+__SUM_BYTES)){}dnl
__{}__{}define({$0_C3},eval($0_C0+__SUM_CLOCKS)){}dnl
__{}__{}define({$0_P3},eval($0_C3+__BYTE_PRICE*$0_B3)){}dnl
__{}__{}ifelse(eval($0_P1<=$0_P2 && $0_P1 <= $0_P3),1,{
__{}__{}__{}format({%28s},;[$0_B1:)format({%-7s},$0_C1]) __INFO   ( ud -- bool )  bool: ud du>= __VIEW_DE_HL($1,$2){}dnl
__{}__{}__{}$0_BC_LO
__{}__{}__{}    add  HL{,} BC         ; 1:11      __INFO
__{}__{}__{}    ex   DE{,} HL         ; 1:4       __INFO{}dnl
__{}__{}__{}$0_BC_HI
__{}__{}__{}    adc  HL{,} BC         ; 2:15      __INFO},
__{}__{}eval($0_P2 <= $0_P3),1,{
__{}__{}__{}format({%28s},;[$0_B2:)format({%-7s},$0_C2]) __INFO   ( ud -- bool )  bool: ud du>= __VIEW_DE_HL($1,$2){}dnl
__{}__{}__{}$0_BC
__{}__{}__{}    add  HL{,} BC         ; 1:11      __INFO{}dnl
__{}__{}__{}$0_A_LO
__{}__{}__{}    sbc   A{,} E          ; 1:4       __INFO{}dnl
__{}__{}__{}$0_A_HI
__{}__{}__{}    sbc   A{,} D          ; 1:4       __INFO},
__{}__{}{
__{}__{}__{}format({%28s},;[$0_B3:)format({%-7s},$0_C3]) __INFO   ( ud -- bool )  bool: ud du>= __VIEW_DE_HL($1,$2){}dnl
__{}__{}__CODE_2DUP_PUSH2_DUGE_CF_STORE{}dnl
__{}__{}}){}dnl
__{}__{}__CODE_DROP_CARRY_FETCH   bool: d >= __VIEW_DE_HL($1,$2){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 du>
dnl # $1. du>
dnl # ( d -- bool )  bool: d du> $1.
define({PUSH2_DUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DUGT_OVER_SWAP},{$1 $2 du>},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DUGT_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__MAKE_CODE_DROP_CARRY_FETCH{}dnl
__{}__{}define({$0_B0},__BYTES){}dnl
__{}__{}define({$0_C0},__CLOCKS){}dnl
__{}__{}dnl # -----------
__{}__{}define({$0_P1},0x7FFFFFFF){}dnl
__{}__{}ifelse(__HAS_PTR($1):__HAS_PTR($2),0:0,{dnl
__{}__{}__{}__RESET_SUMS{}dnl
__{}__{}__{}define({$0_BC_LO},__LD_R16({BC},0xFFFF-$2)){}dnl
__{}__{}__{}define({$0_BC_HI},__LD_R16({BC},0xFFFF-$1,{BC},0xFFFF-$2)){}dnl
__{}__{}__{}define({$0_B1},eval($0_B0+4+__SUM_BYTES)){}dnl
__{}__{}__{}define({$0_C1},eval($0_C0+30+__SUM_CLOCKS)){}dnl
__{}__{}__{}define({$0_P1},eval($0_C1+__BYTE_PRICE*$0_B1)){}dnl
__{}__{}}){}dnl
__{}__{}dnl # -----------
__{}__{}define({$0_P2},0x7FFFFFFF){}dnl
__{}__{}ifelse(__HAS_PTR($2),0,{dnl
__{}__{}__{}__RESET_SUMS{}dnl
__{}__{}__{}ifelse(__IS_NUM($2),1,{dnl
__{}__{}__{}__{}define({$0_L},__HEX_L(0xFFFF-$2)){}dnl
__{}__{}__{}__{}define({$0_H},__HEX_H(0xFFFF-$2)){}dnl
__{}__{}__{}},
__{}__{}__{}__HAS_PTR($2),0,{dnl
__{}__{}__{}__{}define({$0_L},__SIMPLIFY_EXPRESSION(255&(0xFFFF-$2))){}dnl
__{}__{}__{}__{}define({$0_H},__SIMPLIFY_EXPRESSION(255&((0xFFFF-$2)>>8))){}dnl
__{}__{}__{}}){}dnl
__{}__{}__{}ifelse(__IS_NUM($1),1,{dnl
__{}__{}__{}__{}define({$0_E},__HEX_L($1)){}dnl
__{}__{}__{}__{}define({$0_D},__HEX_H($1)){}dnl
__{}__{}__{}},
__{}__{}__{}__HAS_PTR($1),1,{dnl
__{}__{}__{}__{}define({$0_E},__PTR_ADD($1,0)){}dnl
__{}__{}__{}__{}define({$0_D},__PTR_ADD($1,1)){}dnl
__{}__{}__{}},
__{}__{}__{}{dnl
__{}__{}__{}__{}define({$0_E},__SIMPLIFY_EXPRESSION(255&($1))){}dnl
__{}__{}__{}__{}define({$0_D},__SIMPLIFY_EXPRESSION(255&(($1)>>8))){}dnl
__{}__{}__{}}){}dnl
__{}__{}__{}define({$0_BC},__LD_R16({BC},0xFFFF-$2)){}dnl
__{}__{}__{}define({$0_A_LO},__LD_REG8_SAVE_CARRY(A,$0_E,{B},$0_H,{C},$0_L)){}dnl
__{}__{}__{}__ADD_SUMS(__BYTES,__CLOCKS){}dnl
__{}__{}__{}define({$0_A_HI},__LD_REG8_SAVE_CARRY(A,$0_D,{B},$0_H,{C},$0_L)){}dnl
__{}__{}__{}__ADD_SUMS(__BYTES,__CLOCKS){}dnl
__{}__{}__{}define({$0_B2},eval($0_B0+3+__SUM_BYTES)){}dnl
__{}__{}__{}define({$0_C2},eval($0_C0+19+__SUM_CLOCKS)){}dnl
__{}__{}__{}define({$0_P2},eval($0_C2+__BYTE_PRICE*$0_B2)){}dnl
__{}__{}}){}dnl
__{}__{}dnl # -----------
__{}__{}__RESET_SUMS{}dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DUGT_CF_STORE($@){}dnl
__{}__{}define({$0_B3},eval($0_B0+__SUM_BYTES)){}dnl
__{}__{}define({$0_C3},eval($0_C0+__SUM_CLOCKS)){}dnl
__{}__{}define({$0_P3},eval($0_C3+__BYTE_PRICE*$0_B3)){}dnl
__{}__{}ifelse(eval($0_P1<=$0_P2 && $0_P1 <= $0_P3),1,{
__{}__{}__{}format({%28s},;[$0_B1:)format({%-7s},$0_C1]) __INFO   ( ud -- bool )  bool: ud du> __VIEW_DE_HL($1,$2){}dnl
__{}__{}__{}$0_BC_LO
__{}__{}__{}    add  HL{,} BC         ; 1:11      __INFO
__{}__{}__{}    ex   DE{,} HL         ; 1:4       __INFO{}dnl
__{}__{}__{}$0_BC_HI
__{}__{}__{}    adc  HL{,} BC         ; 2:15      __INFO},
__{}__{}eval($0_P2 <= $0_P3),1,{
__{}__{}__{}format({%28s},;[$0_B2:)format({%-7s},$0_C2]) __INFO   ( ud -- bool )  bool: ud du> __VIEW_DE_HL($1,$2){}dnl
__{}__{}__{}$0_BC
__{}__{}__{}    add  HL{,} BC         ; 1:11      __INFO{}dnl
__{}__{}__{}$0_A_LO
__{}__{}__{}    sbc   A{,} E          ; 1:4       __INFO{}dnl
__{}__{}__{}$0_A_HI
__{}__{}__{}    sbc   A{,} D          ; 1:4       __INFO},
__{}__{}{
__{}__{}__{}format({%28s},;[$0_B3:)format({%-7s},$0_C3]) __INFO   ( ud -- bool )  bool: ud du> __VIEW_DE_HL($1,$2){}dnl
__{}__{}__CODE_2DUP_PUSH2_DUGT_CF_STORE{}dnl
__{}__{}}){}dnl
__{}__{}__CODE_DROP_CARRY_FETCH   bool: d > __VIEW_DE_HL($1,$2){}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 d<
dnl # $1. d<
dnl # ( d -- bool )
dnl # signed ( d < $1. ) --> ( d - $1. < 0 ) --> carry is true
define({PUSH2_DLT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DLT_OVER_SWAP},{$1 $2 d<},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DLT_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}_TYP_DOUBLE,{function},{
__{}__{}__def({USE_FCE_DLT}){}dnl
__{}__{}__SET_SUMS(10,70){}dnl
__{}__{}define({_TMP_INFO},__INFO){}dnl
__{}__{}__LD_REG16({DE},$1,{HL},$2){}dnl
__{}__{}__LD_REG16({HL},$2){}dnl
__{}__{}                        ;[__SUM_BYTES:__SUM_CLOCKS]    __INFO   ( d -- bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
__{}__{}    push HL             ; 1:10      __INFO   hi16(d)
__{}__{}    ld   C, E           ; 1:4       __INFO
__{}__{}    ld   B, D           ; 1:4       __INFO   lo16(d){}dnl
__{}__{}__CODE_16BIT{}dnl
__{}__{}__LD_REG16({DE},$1,{HL},$2){}__CODE_16BIT
__{}__{}    pop  AF             ; 1:10      __INFO   hi16(d)
__{}__{}    call FCE_DLT        ; 3:17      __INFO   carry if true
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d < $1*65536+$2},

__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DLT_CF_STORE($@,{( d -- bool )   default version can be changed with to "function"},3,25,,25,,25)
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d < $1*65536+$2}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 d<=
dnl # $1. d<=
dnl # ( d -- bool )
dnl # signed ( d <= $1. ) --> ( 0 > $1. - d ) --> not carry is true
define({PUSH2_DLE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DLE_OVER_SWAP},{$1 $2 d<=},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DLE_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}_TYP_DOUBLE,{function},{
__{}__{}__def({USE_FCE_DGT}){}dnl
__{}__{}__SET_SUMS(11,74){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({DE},$1,{HL},$2){}dnl
__{}__LD_REG16({HL},$2){}dnl
__{}                        ;[__SUM_BYTES:__SUM_CLOCKS]    __INFO   ( d -- bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
__{}    push HL             ; 1:10      __INFO   hi16(d)
__{}    ld   C, E           ; 1:4       __INFO
__{}    ld   B, D           ; 1:4       __INFO   lo16(d){}__CODE_16BIT{}__LD_REG16({DE},$1,{HL},$2){}__CODE_16BIT
__{}    pop  AF             ; 1:10      __INFO   hi16(d)
__{}    call FCE_DGT        ; 3:17      __INFO   carry if true
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d <= $1*65536+$2},

__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DLE_CF_STORE($@,{( d -- bool )   default version can be changed to "function"},3,25,,25,,25)
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d <= $1*65536+$2{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 d>=
dnl # $1. d>=
dnl # ( d -- bool )
dnl # signed ( d >= $1. ) --> ( d - $1. < 0 ) --> not carry is true
define({PUSH2_DGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DGE_OVER_SWAP},{$1 $2 d>=},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DGE_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},

__{}_TYP_DOUBLE,{function},{
__{}__{}__def({USE_FCE_DLT}){}dnl
__{}__{}__SET_SUMS(11,74){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({DE},$1,{HL},$2){}dnl
__{}__LD_REG16({HL},$2){}dnl
__{}                        ;[__SUM_BYTES:__SUM_CLOCKS]    __INFO   ( d -- bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
__{}    push HL             ; 1:10      __INFO   hi16(d)
__{}    ld   C, E           ; 1:4       __INFO
__{}    ld   B, D           ; 1:4       __INFO   lo16(d){}__CODE_16BIT{}__LD_REG16({DE},$1,{HL},$2){}__CODE_16BIT
__{}    pop  AF             ; 1:10      __INFO   hi16(d)
__{}    call FCE_DLT        ; 3:17      __INFO   carry if true
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d >= $1*65536+$2},

__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DGE_CF_STORE($@,{( d -- bool )   default version can be changed with to "function"},3,25,,25,,25)
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d >= $1*65536+$2}){}dnl
}){}dnl
dnl
dnl
dnl # $1 $2 d>
dnl # $1. d>
dnl # ( d -- bool )
dnl # signed ( d > $1. ) --> ( 0 > $1. - d ) --> carry is true
define({PUSH2_DGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PUSH2_DGT_OVER_SWAP},{$1 $2 d>},$@){}dnl
__{}__ADD_TOKEN({__TOKEN_NIP},{__dtto},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUSH2_DGT_OVER_SWAP},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}(): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}_TYP_DOUBLE,{function},{
__{}__{}__def({USE_FCE_DGT}){}dnl
__{}__{}__SET_SUMS(10,70){}dnl
__{}define({_TMP_INFO},__INFO){}dnl
__{}__LD_REG16({DE},$1,{HL},$2){}dnl
__{}__LD_REG16({HL},$2){}dnl
__{}                        ;[__SUM_BYTES:__SUM_CLOCKS]    __INFO   ( d -- bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
__{}    push HL             ; 1:10      __INFO   hi16(d)
__{}    ld   C, E           ; 1:4       __INFO
__{}    ld   B, D           ; 1:4       __INFO   lo16(d){}__CODE_16BIT{}__LD_REG16({DE},$1,{HL},$2){}__CODE_16BIT
__{}    pop  AF             ; 1:10      __INFO   hi16(d)
__{}    call FCE_DGT        ; 3:17      __INFO   carry if true
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d > $1*65536+$2},
__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DGT_CF_STORE($@,{( d -- bool )   default version can be changed with to "function"},3,25,,25,,25)
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d > $1*65536+$2{}dnl
__{}}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup d. d<
dnl # ( d -- d f )
define({_2DUP_PUSH2_DLT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSH2_DLT},{2dup $1 $2 d<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSH2_DLT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DLT_CF_STORE($@,{( d -- d bool )},4,30,,30,,30)
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d < $1*65536+$2}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup d. d<=
dnl # ( d -- d f )
define({_2DUP_PUSH2_DLE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSH2_DLE},{2dup $1 $2 d<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSH2_DLE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DLE_CF_STORE($@,{( d -- d bool )},4,30,,30,,30)
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d <= $1*65536+$2}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup d. d>=
dnl # ( d -- d f )
define({_2DUP_PUSH2_DGE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSH2_DGE},{2dup $1 $2 d>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSH2_DGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DGE_CF_STORE($@,{( d -- d bool )},4,30,,30,,30)
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d >= $1*65536+$2}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup d. d>
dnl # ( d -- d f )
define({_2DUP_PUSH2_DGT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSH2_DGT},{2dup $1 $2 d>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSH2_DGT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(
__{}eval($#<2),1,{
__{}__{}  .error {$0}($@): Missing parameter!},
__{}eval($#>2),1,{
__{}__{}  .error {$0}($@): Unexpected parameter!},
__{}{dnl
__{}__{}__MAKE_CODE_2DUP_PUSH2_DGT_CF_STORE($@,{( d -- d bool )},4,30,,30,,30)
__{}__{}    push DE             ; 1:11      __INFO
__{}__{}    ex   DE, HL         ; 1:4       __INFO
__{}__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d > $1*65536+$2}){}dnl
}){}dnl
dnl
dnl
dnl # ( pud2 pud1 -- pud2 pud1 bool )
dnl # unsigned ( [pud2] u< [pud1] ) --> ( [pud2] - [pud1] u< 0 ) --> carry is true
define({PDULT},{dnl
__{}__ADD_TOKEN({__TOKEN_PDULT},{pdult},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDULT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pud2 pud1 -- pud2 pud1 bool )  bool == [pud2] u< [pud1]  with align 4
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: [pud2]u<[pud1]}){}dnl
dnl
dnl
dnl # ( pud2 pud1 -- pud2 pud1 bool )
dnl # unsigned ( [pud2] u<= [pud1] ) --> ( 0 <= [pud1] - [pud2] ) --> not carry is true
define({PDULE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDULE},{pdule},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDULE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pud2 pud1 -- pud2 pud1 bool )  bool == [pud2] u<= [pud1]  with align 4
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld    E, C          ; 1:4       __INFO
    ccf                 ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: [pud2]u<=[pud1]}){}dnl
dnl
dnl
dnl # ( pud2 pud1 -- pud2 pud1 bool )
dnl # unsigned ( [pud2] u>= [pud1] ) --> ( [pud2] - [pud1] u>= 0 ) --> not carry is true
define({PDUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDUGE},{pduge},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDUGE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pud2 pud1 -- pud2 pud1 bool )  bool == [pud2] >= [pud1]  with align 4
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    ccf                 ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: [pud2]u>=[pud1]}){}dnl
dnl
dnl
dnl # ( pud2 pud1 -- pud2 pud1 bool )
dnl # unsigned ( [pud2] u> [pud1] ) --> ( 0 > [pud1] - [pud2] ) --> carry is true
define({PDUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PDUGT},{pdugt},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDUGT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pud2 pud1 -- pud2 pud1 bool )  bool == [pud2] u> [pud1]  with align 4
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    ld    E, C          ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: [pud2]u>[pud1]}){}dnl
dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # signed ( [pd2] < [pd1] ) --> ( [pd2] - [pd1] < 0 ) --> carry is true
define({PDLT},{dnl
__{}__ADD_TOKEN({__TOKEN_PDLT},{pdlt},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDLT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool == [pd2] < [pd1]  with align 4
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    rra                 ; 1:4       __INFO   sign if true
    xor [HL]            ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    xor [HL]            ; 1:7       __INFO
    add   A, A          ; 1:4       __INFO   carry if true
    sbc  HL, HL         ; 2:15      __INFO   bool: [pd2]<[pd1]}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # signed ( [pd2] >= [pd1] ) --> ( [pd2] - [pd1] >= 0 ) --> not carry is true
define({PDGE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDGE},{pdge},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDGE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool == [pd2] >= [pd1]  with align 4
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, L          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    rra                 ; 1:4       __INFO   not sign if true
    xor [HL]            ; 1:7       __INFO
    ld    L, C          ; 1:4       __INFO
    ex   DE, HL         ; 1:4       __INFO
    xor [HL]            ; 1:7       __INFO
    add   A, A          ; 1:4       __INFO   not carry if true
    ccf                 ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: [pd2]>=[pd1]}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # signed ( [pd2] <= [pd1] ) --> ( 0 <= [pd1] - [pd2] ) --> not carry is true
define({PDLE},{dnl
__{}__ADD_TOKEN({__TOKEN_PDLE},{pdle},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDLE},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool == [pd2] <= [pd1]  with align 4
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    ld    B, A          ; 1:4       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    rra                 ; 1:4       __INFO   not sign if true
    xor [HL]            ; 1:7       __INFO
    ld    E, C          ; 1:4       __INFO
    xor   B             ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO   not carry if true
    ccf                 ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: [pd2]<=[pd1]}){}dnl
dnl
dnl
dnl # ( pd2 pd1 -- pd2 pd1 bool )
dnl # signed ( [pd2] > [pd1] ) --> ( 0 > [pd1] - [pd2] ) --> carry is true
define({PDGT},{dnl
__{}__ADD_TOKEN({__TOKEN_PDGT},{pdgt},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PDGT},{dnl
__{}define({__INFO},__COMPILE_INFO)
    push DE             ; 1:11      __INFO   ( pd2 pd1 -- pd2 pd1 bool )  bool == [pd2] > [pd1]  with align 4
    ex   DE, HL         ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sub [HL]            ; 1:7       __INFO
    ld    C, E          ; 1:4       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    inc   L             ; 1:4       __INFO
    inc   E             ; 1:4       __INFO
    ld    A,[DE]        ; 1:7       __INFO
    ld    B, A          ; 1:4       __INFO
    sbc   A,[HL]        ; 1:7       __INFO
    rra                 ; 1:4       __INFO   sign if true
    xor [HL]            ; 1:7       __INFO
    ld    E, C          ; 1:4       __INFO
    xor   B             ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO   carry if true
    sbc  HL, HL         ; 2:15      __INFO   bool: [pd2]>[pd1]}){}dnl
dnl
dnl
dnl
dnl # 4dup D=
dnl # ( d d -- d d f )
define({_4DUP_DEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DEQ},{4dup D=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DEQ},{
__{}define({__INFO},__COMPILE_INFO){}dnl
                       ;[20:138/-21,+1] __INFO   ( d2 d1 -- d2 d1 bool )
    pop  AF             ; 1:10      __INFO   h2          . h1 l1  AF= lo(d2) = l2
    pop  BC             ; 1:10      __INFO               . h1 l1  BC= hi(d2) = h2
    push BC             ; 1:11      __INFO   h2          . h1 l1
    push AF             ; 1:11      __INFO   h2 l2       . h1 l1
    push DE             ; 1:11      __INFO   h2 l2 h1    . h1 l1
    push AF             ; 1:11      __INFO   h2 l2 h1 l2 . h1 l1
    ex   DE, HL         ; 1:4       __INFO   h2 l2 h1 l2 . l1 h1
    xor   A             ; 1:4       __INFO   h2 l2 h1 l2 . l1 h1  A = 0x00
    sbc  HL, BC         ; 2:15      __INFO   h2 l2 h1 l2 . l1 --  hi(d1)-hi(d2)
    pop  HL             ; 1:10      __INFO   h2 l2 h1    . l1 l2
    jr   nz, $+7        ; 2:7/12    __INFO   h2 l2 h1    . l1 l2
    sbc  HL, DE         ; 2:15      __INFO   h2 l2 h1    . l1 --  lo(d2)-lo(d1)
    jr   nz, $+3        ; 2:7/12    __INFO   h2 l2 h1    . l1 --
    dec   A             ; 1:4       __INFO   h2 l2 h1    . l1 --  A = 0xFF
    ld    L, A          ; 1:4       __INFO   h2 l2 h1    . l1 -f
    ld    H, A          ; 1:4       __INFO   h2 l2 h1    . l1 ff  HL= bool d2==d1}){}dnl
dnl
dnl
dnl
dnl # 4dup Du=
dnl # ( ud2 ud1 -- ud2 ud1 bool )
dnl # equal ( ud1 == ud2 )
define({_4DUP_DUEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DEQ},{4dup du=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DUEQ},{dnl
__{}__ASM_TOKEN_4DUP_DEQ{}dnl
}){}dnl
dnl
dnl
dnl
dnl # 4dup D<>
dnl # ( d d -- d d f )
define({_4DUP_DNE},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DNE},{4dup D<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DNE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(_TYP_DOUBLE,{fast},{
            ;[26:71,86,143,149/147] __INFO   ( d2 d1 -- d2 d1 bool )   ;# fast version can be changed with "define({_TYP_DOUBLE},{default})"
    pop  BC             ; 1:10      __INFO   h2       . h1 l1  BC= lo(d2) = l2
    ld    A, C          ; 1:4       __INFO   h2       . h1 l1  A = lo(l2)
    sub   L             ; 1:4       __INFO   h2       . h1 l1  lo(l2) - lo(l1)
    jr   nz, $+16       ; 2:7/12    __INFO   h2       . h1 l1  --> A = 0xFF
    ld    A, B          ; 1:4       __INFO   h2       . h1 l1  A = hi(l2)
    sub   H             ; 1:4       __INFO   h2       . h1 l1  hi(l2) - hi(l1)
    jr   nz, $+12       ; 2:7/12    __INFO   h2       . h1 l1  --> A = 0xFF
    ex  [SP],HL         ; 1:19      __INFO   l1       . h1 h2  HL= hi(d2) = h2
    ld    A, L          ; 1:4       __INFO   l1       . h1 h2  A = lo(h2)
    sub   E             ; 1:4       __INFO   l1       . h1 h2  lo(h2) - lo(l1)
    ld    A, H          ; 1:4       __INFO   l1       . h1 h2  A = hi(h2)
    ex  [SP],HL         ; 1:19      __INFO   h2       . h1 l1
    jr   nz, $+5        ; 2:7/12    __INFO   h2       . h1 l1  --> A = 0xFF
    sub   D             ; 1:4       __INFO   h2       . h1 l1  hi(h2) - hi(h1)
    jr    z, $+4        ; 2:7/12    __INFO   h2       . h1 l1  --> A = 0
    ld    A, 0xFF       ; 2:7       __INFO   h2       . h1 l1
    push BC             ; 1:11      __INFO   h2 l2    . h1 l1
    push DE             ; 1:11      __INFO   h2 l2 h1 . h1 l1
    ex   DE, HL         ; 1:4       __INFO   h2 l2 h1 . l1 h1
    ld    H, A          ; 1:4       __INFO   h2 l2 h1 . l1 f-
    ld    L, A          ; 1:4       __INFO   h2 l2 h1 . l1 ff HL= bool d2<>d1},
{
                  ;[20:119,136/131] __INFO   ( d2 d1 -- d2 d1 bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{fast})"
    pop  AF             ; 1:10      __INFO   h2          . h1 l1  AF = lo(d2) = l2
    pop  BC             ; 1:10      __INFO               . h1 l1  BC = hi(d2) = h2
    push BC             ; 1:11      __INFO   h2          . h1 l1
    push AF             ; 1:11      __INFO   h2 l2       . h1 l1
    push DE             ; 1:11      __INFO   h2 l2 h1    . h1 l1
    push AF             ; 1:11      __INFO   h2 l2 h1 l2 . h1 l1
    ex   DE, HL         ; 1:4       __INFO   h2 l2 h1 l2 . l1 h1
    xor   A             ; 1:4       __INFO   h2 l2 h1 l2 . l1 h1
    sbc  HL, BC         ; 2:15      __INFO   h2 l2 h1 l2 . l1 --  hi(d1)-hi(d2)
    pop  HL             ; 1:10      __INFO   h2 l2 h1    . l1 l2
    jr   nz, $+6        ; 2:7/12    __INFO   h2 l2 h1    . l1 l2
    sbc  HL, DE         ; 2:15      __INFO   h2 l2 h1    . l1 --  lo(d2)-lo(d1)
    jr    z, $+5        ; 2:7/12    __INFO   h2 l2 h1    . l1 --
    ld   HL, 0xFFFF     ; 3:10      __INFO   h2 l2 h1    . l1 ff  HL= bool d2<>d1})}){}dnl
dnl
dnl
dnl
dnl # 4dup Du<>
dnl # ( ud2 ud1 -- ud2 ud1 bool )
dnl # not equal ( ud1 <> ud2 )
define({_4DUP_DUNE},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DNE},{4dup du<>},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DUNE},{dnl
__{}__ASM_TOKEN_4DUP_DNE{}dnl
}){}dnl
dnl
dnl
dnl
dnl # 4dup D<
dnl # ( d d -- d d f )
define({_4DUP_DLT},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DLT},{4dup D<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DLT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(_TYP_DOUBLE,{function},{define({USE_FCE_4DUP_DLT},{yes})
                        ;[7:201]    __INFO   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    call FCE_4DUP_DLT   ; 3:17      __INFO   carry if true
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: d2<d1},
{
                       ;[20:137]    __INFO   ( d2 d1 -- d2 d1 bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      __INFO   lo_2
    ld    A, C          ; 1:4       __INFO   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    sub   L             ; 1:4       __INFO   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    ld    A, B          ; 1:4       __INFO   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    sbc   A, H          ; 1:4       __INFO   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    ex  [SP],HL         ; 1:19      __INFO   hi_2
    ld    A, L          ; 1:4       __INFO   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    sbc   A, E          ; 1:4       __INFO   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    ld    A, H          ; 1:4       __INFO   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    sbc   A, D          ; 1:4       __INFO   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    rra                 ; 1:4       __INFO                                   -->  sign if true
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO                                   --> carry if true
    ex  [SP],HL         ; 1:19      __INFO   lo_1
    push BC             ; 1:11      __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: d2<d1})}){}dnl
dnl
dnl
dnl
dnl # 4dup Du<
dnl # ( ud ud -- ud ud f )
define({_4DUP_DULT},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DULT},{4dup_dult},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DULT},{dnl
__{}define({__INFO},{4dup_dult}){}dnl

                       ;[16:121]    4dup Du<   ( ud2 ud1 -- ud2 ud1 bool )
    pop  BC             ; 1:10      4dup Du<   lo_2
    ld    A, C          ; 1:4       4dup Du<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    sub   L             ; 1:4       4dup Du<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    ld    A, B          ; 1:4       4dup Du<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    sbc   A, H          ; 1:4       4dup Du<   lo_2<lo_1 --> BC<HL --> BC-HL<0 --> carry if true
    ex  [SP],HL         ; 1:19      4dup Du<   hi_2
    ld    A, L          ; 1:4       4dup Du<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    sbc   A, E          ; 1:4       4dup Du<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    ld    A, H          ; 1:4       4dup Du<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    sbc   A, D          ; 1:4       4dup Du<   hi_2<hi_1 --> HL<DE --> HL-DE<0 --> carry if true
    ex  [SP],HL         ; 1:19      4dup Du<   lo_1
    push BC             ; 1:11      4dup Du<
    push DE             ; 1:11      4dup Du<
    ex   DE, HL         ; 1:4       4dup Du<
    sbc  HL, HL         ; 2:15      4dup Du<   bool: ud2<ud1}){}dnl
dnl
dnl
dnl
dnl # 4dup D>=
dnl # ( d d -- d d f )
define({_4DUP_DGE},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DGE},{4dup D>=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DGE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(_TYP_DOUBLE,{function},{define({USE_FCE_4DUP_DLT},{yes})
                        ;[8:51]     __INFO   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    call FCE_4DUP_DLT   ; 3:17      __INFO   D< carry if true --> D>= carry if false
    ccf                 ; 1:4       __INFO   invert carry
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: d2<=d1},
{
                       ;[21:141]    __INFO   ( d2 d1 -- d2 d1 bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      __INFO   lo_2
    ld    A, C          ; 1:4       __INFO   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    sub   L             ; 1:4       __INFO   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    ld    A, B          ; 1:4       __INFO   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    sbc   A, H          ; 1:4       __INFO   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    ex  [SP],HL         ; 1:19      __INFO   hi_2
    ld    A, L          ; 1:4       __INFO   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    sbc   A, E          ; 1:4       __INFO   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    ld    A, H          ; 1:4       __INFO   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    sbc   A, D          ; 1:4       __INFO   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    rra                 ; 1:4       __INFO                                      --> no sign  if true
    xor   H             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO                                      --> no carry if true
    ccf                 ; 1:4       __INFO                                      --> carry    if true
    ex  [SP],HL         ; 1:19      __INFO   lo_1
    push BC             ; 1:11      __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: d2>=d1})}){}dnl
dnl
dnl
dnl
dnl # 4dup Du>=
dnl # ( ud ud -- ud ud f )
define({_4DUP_DUGE},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DUGE},{4dup_duge},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DUGE},{dnl
__{}define({__INFO},{4dup_duge}){}dnl

                       ;[17:125]    4dup Du>=   ( ud2 ud1 -- ud2 ud1 bool )
    pop  BC             ; 1:10      4dup Du>=   lo_2
    ld    A, C          ; 1:4       4dup Du>=   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    sub   L             ; 1:4       4dup Du>=   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    ld    A, B          ; 1:4       4dup Du>=   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    sbc   A, H          ; 1:4       4dup Du>=   lo_2>=lo_1 --> BC>=HL --> BC-HL>=0 --> no carry if true
    ex  [SP],HL         ; 1:19      4dup Du>=   hi_2
    ld    A, L          ; 1:4       4dup Du>=   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    sbc   A, E          ; 1:4       4dup Du>=   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    ld    A, H          ; 1:4       4dup Du>=   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    sbc   A, D          ; 1:4       4dup Du>=   hi_2>=hi_1 --> HL>=DE --> HL-DE>=0 --> no carry if true
    ccf                 ; 1:4       4dup Du>=                                      --> carry    if true
    ex  [SP],HL         ; 1:19      4dup Du>=   lo_1
    push BC             ; 1:11      4dup Du>=
    push DE             ; 1:11      4dup Du>=
    ex   DE, HL         ; 1:4       4dup Du>=
    sbc  HL, HL         ; 2:15      4dup Du>=   bool: ud2>=ud1}){}dnl
dnl
dnl
dnl
dnl # 4dup D<=
dnl # ( d d -- d d f )
define({_4DUP_DLE},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DLE},{4dup D<=},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DLE},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse(_TYP_DOUBLE,{function},{define({USE_FCE_4DUP_DGT},{yes})
                        ;[8:51]     __INFO   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    call FCE_4DUP_DGT   ; 3:17      __INFO   D> carry if true --> D<= carry if false
    ccf                 ; 1:4       __INFO   invert carry
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: d2<=d1},
{
                       ;[21:141]    __INFO   ( d2 d1 -- d2 d1 bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      __INFO   lo_2
    ld    A, L          ; 1:4       __INFO   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    sub   C             ; 1:4       __INFO   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    ld    A, H          ; 1:4       __INFO   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    sbc   A, B          ; 1:4       __INFO   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    ex  [SP],HL         ; 1:19      __INFO   hi_2
    ld    A, E          ; 1:4       __INFO   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    sbc   A, L          ; 1:4       __INFO   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    ld    A, D          ; 1:4       __INFO   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    sbc   A, H          ; 1:4       __INFO   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    rra                 ; 1:4       __INFO                                      --> no sign  if true
    xor   B             ; 1:4       __INFO
    xor   D             ; 1:4       __INFO
    add   A, A          ; 1:4       __INFO                                      --> no carry if true
    ccf                 ; 1:4       __INFO                                      --> carry    if true
    ex  [SP],HL         ; 1:19      __INFO   lo_1
    push BC             ; 1:11      __INFO
    push DE             ; 1:11      __INFO
    ex   DE, HL         ; 1:4       __INFO
    sbc  HL, HL         ; 2:15      __INFO   bool: d2<=d1})}){}dnl
dnl
dnl
dnl
dnl # 4dup Du<=
dnl # ( ud ud -- ud ud f )
define({_4DUP_DULE},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DULE},{4dup_dule},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DULE},{dnl
__{}define({__INFO},{4dup_dule}){}dnl

                       ;[17:125]    4dup Du<=   ( ud2 ud1 -- ud2 ud1 bool )
    pop  BC             ; 1:10      4dup Du<=   lo_2
    ld    A, L          ; 1:4       4dup Du<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    sub   C             ; 1:4       4dup Du<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    ld    A, H          ; 1:4       4dup Du<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    sbc   A, B          ; 1:4       4dup Du<=   lo_2<=lo_1 --> BC<=HL --> 0<=HL-BC --> no carry if true
    ex  [SP],HL         ; 1:19      4dup Du<=   hi_2
    ld    A, E          ; 1:4       4dup Du<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    sbc   A, L          ; 1:4       4dup Du<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    ld    A, D          ; 1:4       4dup Du<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    sbc   A, H          ; 1:4       4dup Du<=   hi_2<=hi_1 --> HL<=DE --> 0<=DE-HL --> no carry if true
    ccf                 ; 1:4       4dup Du<=                                      --> carry    if true
    ex  [SP],HL         ; 1:19      4dup Du<=   lo_1
    push BC             ; 1:11      4dup Du<=
    push DE             ; 1:11      4dup Du<=
    ex   DE, HL         ; 1:4       4dup Du<=
    sbc  HL, HL         ; 2:15      4dup Du<=   bool: ud2<=ud1}){}dnl
dnl
dnl
dnl
dnl # 4dup D>
dnl # ( d d -- d d f )
define({_4DUP_DGT},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DGT},{4dup_dgt},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DGT},{dnl
__{}define({__INFO},{4dup_dgt}){}dnl
ifelse(_TYP_DOUBLE,{function},{define({USE_FCE_4DUP_DGT},{yes})
                        ;[7:201]    4dup D>   ( d2 d1 -- d2 d1 bool )   ;# function version can be changed with "define({_TYP_DOUBLE},{default})"
    call FCE_4DUP_DGT   ; 3:17      4dup D>   carry if true
    push DE             ; 1:11      4dup D>
    ex   DE, HL         ; 1:4       4dup D>
    sbc  HL, HL         ; 2:15      4dup D>   bool: d2>d1},
{
                       ;[20:137]    4dup D>   ( d2 d1 -- d2 d1 bool )   ;# default version can be changed with "define({_TYP_DOUBLE},{function})"
    pop  BC             ; 1:10      4dup D>   lo_2
    ld    A, L          ; 1:4       4dup D>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    sub   C             ; 1:4       4dup D>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    ld    A, H          ; 1:4       4dup D>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    sbc   A, B          ; 1:4       4dup D>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    ex  [SP],HL         ; 1:19      4dup D>   hi_2
    ld    A, E          ; 1:4       4dup D>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    sbc   A, L          ; 1:4       4dup D>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    ld    A, D          ; 1:4       4dup D>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    sbc   A, H          ; 1:4       4dup D>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    rra                 ; 1:4       4dup D>                                   --> sign  if true
    xor   B             ; 1:4       4dup D>
    xor   D             ; 1:4       4dup D>
    add   A, A          ; 1:4       4dup D>                                   --> carry if true
    ex  [SP],HL         ; 1:19      4dup D>   lo_1
    push BC             ; 1:11      4dup D>
    push DE             ; 1:11      4dup D>
    ex   DE, HL         ; 1:4       4dup D>
    sbc  HL, HL         ; 2:15      4dup D>   bool: d2>d1})}){}dnl
dnl
dnl
dnl
dnl # 4dup Du>
dnl # ( ud ud -- ud ud f )
define({_4DUP_DUGT},{dnl
__{}__ADD_TOKEN({__TOKEN_4DUP_DUGT},{4dup_dugt},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_4DUP_DUGT},{dnl
__{}define({__INFO},{4dup_dugt}){}dnl

                       ;[16:121]    4dup Du>   ( ud2 ud1 -- ud2 ud1 bool )
    pop  BC             ; 1:10      4dup Du>   lo_2
    ld    A, L          ; 1:4       4dup Du>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    sub   C             ; 1:4       4dup Du>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    ld    A, H          ; 1:4       4dup Du>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    sbc   A, B          ; 1:4       4dup Du>   lo_2>lo_1 --> BC>HL --> 0>HL-BC --> carry if true
    ex  [SP],HL         ; 1:19      4dup Du>   hi_2
    ld    A, E          ; 1:4       4dup Du>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    sbc   A, L          ; 1:4       4dup Du>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    ld    A, D          ; 1:4       4dup Du>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    sbc   A, H          ; 1:4       4dup Du>   hi_2>hi_1 --> HL>DE --> 0>DE-HL --> carry if true
    ex  [SP],HL         ; 1:19      4dup Du>   lo_1
    push BC             ; 1:11      4dup Du>
    push DE             ; 1:11      4dup Du>
    ex   DE, HL         ; 1:4       4dup Du>
    sbc  HL, HL         ; 2:15      4dup Du>   bool: ud2>ud1}){}dnl
dnl
dnl
dnl
dnl # 2dup D. D=
dnl # ( d -- d f )
define({_2DUP_PUSHDOT_DEQ},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSHDOT_DEQ},{2dup_pushdot_deq},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSHDOT_DEQ},{dnl
__{}define({__INFO},{2dup_pushdot_deq}){}dnl
dnl
__{}define({_TMP_INFO},{2dup $1 D=}){}dnl
__{}define({_TMP_STACK_INFO},{ _TMP_INFO   ( d1 -- d1 bool )   __HEX_DEHL($1) == DEHL}){}dnl
__{}ifelse($1,{},{
__{}__{}    .error {$0}(): Missing parameter!},
__{}$#,{1},{dnl
__{}__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}__{}                        ;[21:111]   _TMP_INFO    ( d1 -- d1 bool )
__{}__{}__{}    ex   DE, HL         ; 1:4       _TMP_INFO
__{}__{}__{}    push HL             ; 1:11      _TMP_INFO
__{}__{}__{}    xor   A             ; 1:4       _TMP_INFO
__{}__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,2)); 4:20      _TMP_INFO   hi16($1)
__{}__{}__{}    sbc  HL, BC         ; 2:15      _TMP_INFO   hi16(d1)-BC
__{}__{}__{}    jr   nz, $+10       ; 2:7/12    _TMP_INFO
__{}__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:16      _TMP_INFO   lo16($1)
__{}__{}__{}    sbc  HL, DE         ; 2:15      _TMP_INFO   HL-lo16(d1)
__{}__{}__{}    jr   nz, $+3        ; 2:7/12    _TMP_INFO
__{}__{}__{}    dec   A             ; 1:4       _TMP_INFO   A = 0xFF = true
__{}__{}__{}    ld    L, A          ; 1:4       _TMP_INFO
__{}__{}__{}    ld    H, A          ; 1:4       _TMP_INFO   bool: d1==$1},
__{}__{}__IS_NUM($1),{0},{
__{}__{}__{}   .error {$0}($@): M4 does not know $1 parameter value!},
__{}__{}{dnl
__{}__{}__{}__DEQ_MAKE_BEST_CODE($1,6,37,0,0){}dnl
__{}__{}__{}__DEQ_MAKE_HLDE_CODE($1,10){}dnl
__{}__{}__{}define({_TMP_B},eval(_TMP_B+5)){}dnl
__{}__{}__{}ifelse(_TMP_ZERO,{1},{dnl
__{}__{}__{}__{}define({_TMP_J},eval(_TMP_J+8)){}dnl #    false
__{}__{}__{}__{}define({_TMP_J2},eval(_TMP_NJ+20)){}dnl # false2
__{}__{}__{}__{}define({_TMP_NJ},eval(_TMP_NJ+19)){}dnl # true
__{}__{}__{}__{}define({_TMP_HLDE_CODE},{dnl
__{}__{}__{}__{}__{}                     ;[_TMP_B:_TMP_NJ/_TMP_J/_TMP_J2] _TMP_INFO   ( d1 -- d1 bool )
__{}__{}__{}__{}__{}}_TMP_HLDE_CODE{
__{}__{}__{}__{}__{}    jr   nz, $+3        ; 2:7/12    _TMP_INFO
__{}__{}__{}__{}__{}    dec   A             ; 1:4       _TMP_INFO   A = 0xFF = true
__{}__{}__{}__{}__{}    ld    L, A          ; 1:4       _TMP_INFO
__{}__{}__{}__{}__{}    ld    H, A          ; 1:4       _TMP_INFO   bool: d1==$1})},
__{}__{}__{}{dnl
__{}__{}__{}__{}define({_TMP_J},eval(_TMP_J+15)){}dnl #   false
__{}__{}__{}__{}define({_TMP_J2},eval(_TMP_NJ+27)){}dnl # false2
__{}__{}__{}__{}define({_TMP_NJ},eval(_TMP_NJ+26)){}dnl # true
__{}__{}__{}__{}define({_TMP_HLDE_CODE},{dnl
__{}__{}__{}__{}__{}                     ;[_TMP_B:_TMP_NJ/_TMP_J,_TMP_J2] _TMP_INFO   ( d1 -- d1 bool )
__{}__{}__{}__{}__{}}_TMP_HLDE_CODE{
__{}__{}__{}__{}__{}    jr   nz, $+3        ; 2:7/12    _TMP_INFO
__{}__{}__{}__{}__{}    scf                 ; 1:4       _TMP_INFO
__{}__{}__{}__{}__{}    sbc  HL, HL         ; 2:15      _TMP_INFO   bool: d1==$1})}){}dnl
__{}__{}__{}define({_TMP_P},eval(8*_TMP_NJ+4*_TMP_J+4*_TMP_J2+64*_TMP_B)){}dnl #     price = 16*(clocks + 4*bytes)
__{}__{}__{}define({_TMP},eval(_TMP_BEST_P<=_TMP_P)){}dnl
__{}__{}__{}ifelse(_TMP,{0},{
__{}__{}__{}__{}if 0
__{}__{}__{}__{}; price: _TMP_BEST_P})
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}    sub 0x01            ; 2:7       _TMP_INFO
__{}__{}__{}    ex   DE, HL         ; 1:4       _TMP_INFO
__{}__{}__{}    push HL             ; 1:11      _TMP_INFO
__{}__{}__{}    sbc  HL, HL         ; 2:15      _TMP_INFO   bool: d1==$1{}dnl
__{}__{}__{}ifelse(_TMP,{0},{
__{}__{}__{}__{}else
__{}__{}__{}__{}; price: _TMP_P
__{}__{}__{}__{}_TMP_HLDE_CODE
__{}__{}__{}__{}endif})})},
__{}{
__{}    .error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl # 2dup D. D<>
dnl # ( d -- d f )
define({_2DUP_PUSHDOT_DNE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSHDOT_DNE},{2dup_pushdot_dne},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSHDOT_DNE},{dnl
__{}define({__INFO},{2dup_pushdot_dne}){}dnl
dnl
__{}define({_TMP_INFO},{2dup $1 D<>}){}dnl
__{}define({_TMP_STACK_INFO},{ _TMP_INFO   ( d1 -- d1 bool )   __HEX_DEHL($1) <> DEHL}){}dnl
__{}ifelse($1,{},{
__{}__{}    .error {$0}(): Missing parameter!},
__{}$#,{1},{dnl
__{}__{}ifelse(__HAS_PTR($1),{1},{
__{}__{}__{}                       ;[21:109]    _TMP_INFO    ( d1 -- d1 bool )
__{}__{}__{}    ex   DE, HL         ; 1:4       _TMP_INFO
__{}__{}__{}    push HL             ; 1:11      _TMP_INFO
__{}__{}__{}    xor   A             ; 1:4       _TMP_INFO
__{}__{}__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,2)); 4:20      _TMP_INFO   hi16($1)
__{}__{}__{}    sbc  HL, BC         ; 2:15      _TMP_INFO   hi16(d1)-BC
__{}__{}__{}    jr   nz, $+9        ; 2:7/12    _TMP_INFO
__{}__{}__{}    ld   HL,__FORM({%-12s},__SIMPLIFY_EXPRESSION($1)); 3:16      _TMP_INFO   lo16($1)
__{}__{}__{}    sbc  HL, DE         ; 2:15      _TMP_INFO   HL-lo16(d1)
__{}__{}__{}    jr    z, $+5        ; 2:7/12    _TMP_INFO
__{}__{}__{}    ld   HL, 0xFFFF     ; 3:10      _TMP_INFO   bool: d1<>$1},
__{}__{}__IS_NUM($1),{0},{
__{}__{}__{}   .error {$0}($@): M4 does not know $1 parameter value!},
__{}__{}{dnl
__{}__{}__{}__DEQ_MAKE_BEST_CODE($1,6,37,0,0){}dnl
__{}__{}__{}__DEQ_MAKE_HLDE_CODE($1,9){}dnl
__{}__{}__{}define({_TMP_B},eval(_TMP_B+5)){}dnl
__{}__{}__{}define({_TMP_J},eval(_TMP_J+10)){}dnl
__{}__{}__{}define({_TMP_J2},eval(_TMP_NJ+12)){}dnl
__{}__{}__{}define({_TMP_NJ},eval(_TMP_NJ+17)){}dnl
__{}__{}__{}define({_TMP_P},eval(8*_TMP_J2+4*_TMP_NJ+4*_TMP_J+64*_TMP_B)){}dnl #     price = 16*(clocks + 4*bytes)
__{}__{}__{}define({_TMP_HLDE_CODE},{dnl
__{}__{}__{}__{}                     ;[_TMP_B:_TMP_J,_TMP_NJ/_TMP_J2] _TMP_INFO   ( d1 -- d1 bool )
__{}__{}__{}__{}}_TMP_HLDE_CODE{
__{}__{}__{}__{}    jr    z, $+5        ; 2:7/12    _TMP_INFO
__{}__{}__{}__{}    ld   HL, 0xFFFF     ; 3:10      _TMP_INFO   bool: d1<>$1}){}dnl
__{}__{}__{}define({_TMP},eval(_TMP_BEST_P<=_TMP_P)){}dnl
__{}__{}__{}ifelse(_TMP,{0},{
__{}__{}__{}__{}if 0
__{}__{}__{}__{}; price: _TMP_BEST_P})
__{}__{}__{}_TMP_BEST_CODE
__{}__{}__{}__{}    add   A, 0xFF       ; 2:7       _TMP_INFO
__{}__{}__{}__{}    ex   DE, HL         ; 1:4       _TMP_INFO
__{}__{}__{}__{}    push HL             ; 1:11      _TMP_INFO
__{}__{}__{}__{}    sbc  HL, HL         ; 2:15      _TMP_INFO   bool: d1==$1{}dnl
__{}__{}__{}ifelse(_TMP,{0},{
__{}__{}__{}__{}else
__{}__{}__{}__{}; price: _TMP_P
__{}__{}__{}__{}_TMP_HLDE_CODE
__{}__{}__{}__{}endif})})},
__{}{
__{}    .error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl # 2dup D. D>
dnl # ( d -- d f )
define({_2DUP_PUSHDOT_DGT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSHDOT_DGT},{2dup_pushdot_dgt},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSHDOT_DGT},{dnl
__{}define({__INFO},{2dup_pushdot_dgt}){}dnl
ifelse($1,{},{
    .error {$0}(): Missing parameter!},
$#,{1},{ifelse(__HAS_PTR($1),{1},{
__{}                        ;[24:116]   2dup $1 D>    ( d1 -- d1 bool )
__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      2dup $1 D>    DEHL>$1     $1 = ...A
__{}    sub   L             ; 1:4       2dup $1 D>    DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      2dup $1 D>    DEHL>$1     $1 = ..A.
__{}    sbc   A, H          ; 1:4       2dup $1 D>    DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,2)); 4:20      2dup $1 D>    DEHL>$1     $1 = BC..
__{}    ld    A, C          ; 1:4       2dup $1 D>    DEHL>$1     $1 = .A..
__{}    sbc   A, E          ; 1:4       2dup $1 D>    DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    ld    A, B          ; 1:4       2dup $1 D>    DEHL>$1     $1 = A...
__{}    sbc   A, D          ; 1:4       2dup $1 D>    DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    rra                 ; 1:4       2dup $1 D>    DEHL>$1              --> sign  if true
__{}    xor   D             ; 1:4       2dup $1 D>
__{}    xor   B             ; 1:4       2dup $1 D>
__{}    add   A, A          ; 1:4       2dup $1 D>    DEHL>$1              --> carry if true
__{}    push DE             ; 1:11      2dup $1 D>
__{}    ex   DE, HL         ; 1:4       2dup $1 D>
__{}    sbc  HL, HL         ; 2:15      2dup $1 D>    bool: d1>$1},
__{}__IS_NUM($1),{0},{
__{}   .error {$0}($@): M4 does not know $1 parameter value!},
__{}{
__{}                       ;[21:92]     2dup $1 D>   ( d1 -- d1 bool )   ;# default version
__{}    ld    A, D          ; 1:4       2dup $1 D>
__{}    sub  0x80           ; 2:7       2dup $1 D>{}ifelse(eval((($1) & 0x80000000) - 0x80000000),0,{
__{}__{}    jr    c, $+14       ; 2:7/12    2dup $1 D>   positive d1 > negative constant --> true},
__{}__{}{
__{}__{}    jr   nc, $+14       ; 2:7/12    2dup $1 D>   negative d1 > positive constant --> false})
__{}    ld    A, __HEX_L($1)       ; 2:7       2dup $1 D>   DEHL>$1     $1 = ...A
__{}    sub   L             ; 1:4       2dup $1 D>   DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    ld    A, __HEX_H($1)       ; 2:7       2dup $1 D>   DEHL>$1     $1 = ..A.
__{}    sbc   A, H          ; 1:4       2dup $1 D>   DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    ld    A, __HEX_E($1)       ; 2:7       2dup $1 D>   DEHL>$1     $1 = .A..
__{}    sbc   A, E          ; 1:4       2dup $1 D>   DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    ld    A, __HEX_D($1)       ; 2:7       2dup $1 D>   DEHL>$1     $1 = A...
__{}    sbc   A, D          ; 1:4       2dup $1 D>   DEHL>$1 --> 0>A-DEHL --> carry if true
__{}    push DE             ; 1:11      2dup $1 D>
__{}    ex   DE, HL         ; 1:4       2dup $1 D>
__{}    sbc  HL, HL         ; 2:15      2dup $1 D>   bool: d1>$1})},
{
    .error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl # 2dup D. D<=
dnl # ( d -- d f )
define({_2DUP_PUSHDOT_DLE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSHDOT_DLE},{2dup_pushdot_dle},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSHDOT_DLE},{dnl
__{}define({__INFO},{2dup_pushdot_dle}){}dnl
ifelse($1,{},{
    .error {$0}(): Missing parameter!},
$#,{1},{ifelse(__HAS_PTR($1),{1},{
__{}                        ;[25:119]   2dup $1 D<=    ( d1 -- d1 bool )
__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,0)); 3:13      2dup $1 D<=    DEHL<=$1     $1 = ...A
__{}    sub   L             ; 1:4       2dup $1 D<=    DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ld    A,__FORM({%-12s},__PTR_ADD($1,1)); 3:13      2dup $1 D<=    DEHL<=$1     $1 = ..A.
__{}    sbc   A, H          ; 1:4       2dup $1 D<=    DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,2)); 4:20      2dup $1 D<=    DEHL<=$1     $1 = BC..
__{}    ld    A, C          ; 1:4       2dup $1 D<=    DEHL<=$1     $1 = .A..
__{}    sbc   A, E          ; 1:4       2dup $1 D<=    DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ld    A, B          ; 1:4       2dup $1 D<=    DEHL<=$1     $1 = A...
__{}    sbc   A, D          ; 1:4       2dup $1 D<=    DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    rra                 ; 1:4       2dup $1 D<=    DEHL<=$1               --> no sign  if true
__{}    xor   D             ; 1:4       2dup $1 D<=
__{}    xor   B             ; 1:4       2dup $1 D<=
__{}    sub  0x80           ; 2:7       2dup $1 D<=    DEHL<=$1               --> carry if true
__{}    push DE             ; 1:11      2dup $1 D<=
__{}    ex   DE, HL         ; 1:4       2dup $1 D<=
__{}    sbc  HL, HL         ; 2:15      2dup $1 D<=    bool: d1<=$1},
__{}__IS_NUM($1),{0},{
__{}   .error {$0}($@): M4 does not know $1 parameter value!},
__{}{
__{}                       ;[21:93]     2dup $1 D<=   ( d1 -- d1 bool )   ;# default version
__{}    ld    A, D          ; 1:4       2dup $1 D<=
__{}    add   A, A          ; 1:4       2dup $1 D<={}ifelse(eval((($1) & 0x80000000) - 0x80000000),0,{
__{}__{}    jr   nc, $+15       ; 2:7/12    2dup $1 D<=   positive d1 <= negative constant --> false},
__{}__{}{
__{}__{}    jr    c, $+15       ; 2:7/12    2dup $1 D<=   negative d1 <= positive constant --> true})
__{}    ld    A, __HEX_L($1)       ; 2:7       2dup $1 D<=   DEHL<=$1     $1 = ...A
__{}    sub   L             ; 1:4       2dup $1 D<=   DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ld    A, __HEX_H($1)       ; 2:7       2dup $1 D<=   DEHL<=$1     $1 = ..A.
__{}    sbc   A, H          ; 1:4       2dup $1 D<=   DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ld    A, __HEX_E($1)       ; 2:7       2dup $1 D<=   DEHL<=$1     $1 = .A..
__{}    sbc   A, E          ; 1:4       2dup $1 D<=   DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ld    A, __HEX_D($1)       ; 2:7       2dup $1 D<=   DEHL<=$1     $1 = A...
__{}    sbc   A, D          ; 1:4       2dup $1 D<=   DEHL<=$1 --> 0<=A-DEHL --> no carry if true
__{}    ccf                 ; 1:4       2dup $1 D<=   DEHL<=$1               -->    carry if true
__{}    push DE             ; 1:11      2dup $1 D<=
__{}    ex   DE, HL         ; 1:4       2dup $1 D<=
__{}    sbc  HL, HL         ; 2:15      2dup $1 D<=   bool: d1<=$1})},
{
    .error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl # 2dup $1. D<
dnl # ( d -- d f )
define({_2DUP_PUSHDOT_DLT},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSHDOT_DLT},{2dup $1. d<},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSHDOT_DLT},{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
ifelse($1,{},{
    .error {$0}(): Missing parameter!},
$#,{1},{ifelse(__HAS_PTR($1),{1},{
__{}                        ;[24:118]   __INFO    ( d1 -- d1 bool )
__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      __INFO    DEHL<$1     $1 = ..BC
__{}    ld    A, L          ; 1:4       __INFO    DEHL<$1
__{}    sub   C             ; 1:4       __INFO    DEHL<$1 --> DEHL-..BC<0 --> carry if true
__{}    ld    A, H          ; 1:4       __INFO    DEHL<$1
__{}    sbc   A, B          ; 1:4       __INFO    DEHL<$1 --> DEHL-..BC<0 --> carry if true
__{}    ld   BC,__FORM({%-12s},($1+2)); 4:20      __INFO    DEHL<$1     $1 = BC..
__{}    ld    A, E          ; 1:4       __INFO    DEHL<$1
__{}    sbc   A, C          ; 1:4       __INFO    DEHL<$1 --> DEHL-BC..<0 --> carry if true
__{}    ld    A, D          ; 1:4       __INFO    DEHL<$1
__{}    sbc   A, B          ; 1:4       __INFO    DEHL<$1 --> DEHL-BC..<0 --> carry if true
__{}    rra                 ; 1:4       __INFO    DEHL<$1                 --> sign  if true
__{}    xor   D             ; 1:4       __INFO
__{}    xor   B             ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO    DEHL<$1                 --> carry if true
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO    bool: d1<$1},
__{}__IS_NUM($1),{0},{
__{}   .error {$0}($@): M4 does not know $1 parameter value!},
__{}{
__{}                       ;[20:89]     __INFO   ( d1 -- d1 bool )   ;# default version
__{}    ld    A, D          ; 1:4       __INFO
__{}    add   A, A          ; 1:4       __INFO{}ifelse(eval((($1) & 0x80000000) - 0x80000000),0,{
__{}__{}    jr   nc, $+14       ; 2:7/12    __INFO   positive d1 < negative constant --> false},
__{}__{}{
__{}__{}    jr    c, $+14       ; 2:7/12    __INFO   negative d1 < positive constant --> true})
__{}    ld    A, L          ; 1:4       __INFO   DEHL<$1 --> DEHL-__HEX_DEHL($1)<0 --> carry if true
__{}    sub   A, __HEX_L($1)       ; 2:7       __INFO   DEHL<$1 --> ...A-0x......format({%02X},eval((($1)>>0) & 0xFF))<0 --> carry if true
__{}    ld    A, H          ; 1:4       __INFO   DEHL<$1 --> DEHL-__HEX_DEHL($1)<0 --> carry if true
__{}    sbc   A, __HEX_H($1)       ; 2:7       __INFO   DEHL<$1 --> ..A.-0x....format({%02X},eval((($1)>>8) & 0xFF))..<0 --> carry if true
__{}    ld    A, E          ; 1:4       __INFO   DEHL<$1 --> DEHL-__HEX_DEHL($1)<0 --> carry if true
__{}    sbc   A, __HEX_E($1)       ; 2:7       __INFO   DEHL<$1 --> .A..-0x..format({%02X},eval((($1)>>16) & 0xFF))....<0 --> carry if true
__{}    ld    A, D          ; 1:4       __INFO   DEHL<$1 --> DEHL-__HEX_DEHL($1)<0 --> carry if true
__{}    sbc   A, __HEX_D($1)       ; 2:7       __INFO   DEHL<$1 --> A...-0x{}format({%02X},eval((($1)>>24) & 0xFF))......<0 --> carry if true
__{}    push DE             ; 1:11      __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: d1<$1})},
{
    .error {$0}($@): $# parameters found in macro!}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # 2dup D. D>=
dnl # ( d -- d f )
define({_2DUP_PUSHDOT_DGE},{dnl
__{}__ADD_TOKEN({__TOKEN_2DUP_PUSHDOT_DGE},{2dup_pushdot_dge},$@){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_2DUP_PUSHDOT_DGE},{dnl
__{}define({__INFO},{2dup_pushdot_dge}){}dnl
ifelse($1,{},{
    .error {$0}(): Missing parameter!},
$#,{1},{ifelse(__HAS_PTR($1),{1},{
__{}                        ;[25:121]   2dup $1 D>=    ( d1 -- d1 bool )
__{}    ld   BC,__FORM({%-12s},__PTR_ADD($1,0)); 4:20      2dup $1 D>=    DEHL>=$1     $1 = ..BC
__{}    ld    A, L          ; 1:4       2dup $1 D>=    DEHL>=$1
__{}    sub   C             ; 1:4       2dup $1 D>=    DEHL>=$1 --> DEHL-..BC>=0 --> no carry if true
__{}    ld    A, H          ; 1:4       2dup $1 D>=    DEHL>=$1
__{}    sbc   A, B          ; 1:4       2dup $1 D>=    DEHL>=$1 --> DEHL-..BC>=0 --> no carry if true
__{}    ld   BC,__FORM({%-12s},($1+2)); 4:20      2dup $1 D>=    DEHL>=$1     $1 = BC..
__{}    ld    A, E          ; 1:4       2dup $1 D>=    DEHL>=$1
__{}    sbc   A, C          ; 1:4       2dup $1 D>=    DEHL>=$1 --> DEHL-BC..>=0 --> no carry if true
__{}    ld    A, D          ; 1:4       2dup $1 D>=    DEHL>=$1
__{}    sbc   A, B          ; 1:4       2dup $1 D>=    DEHL>=$1 --> DEHL-BC..>=0 --> no carry if true
__{}    rra                 ; 1:4       2dup $1 D>=    DEHL>=$1                  --> no sign  if true
__{}    xor   D             ; 1:4       2dup $1 D>=
__{}    xor   B             ; 1:4       2dup $1 D>=
__{}    sub  0x80           ; 2:7       2dup $1 D>=    DEHL>=$1                  --> carry if true
__{}    push DE             ; 1:11      2dup $1 D>=
__{}    ex   DE, HL         ; 1:4       2dup $1 D>=
__{}    sbc  HL, HL         ; 2:15      2dup $1 D>=    bool: d1<$1},
__{}__IS_NUM($1),{0},{
__{}   .error {$0}($@): M4 does not know $1 parameter value!},
__{}{
__{}                       ;[22:96]     2dup $1 D>=   ( d1 -- d1 bool )   ;# default version
__{}    ld    A, D          ; 1:4       2dup $1 D>=
__{}    sub  0x80           ; 2:7       2dup $1 D>={}ifelse(eval((($1) & 0x80000000) - 0x80000000),0,{
__{}__{}    jr    c, $+15       ; 2:7/12    2dup $1 D>=   positive d1 >= negative constant --> true},
__{}__{}{
__{}__{}    jr   nc, $+15       ; 2:7/12    2dup $1 D>=   negative d1 >= positive constant --> false})
__{}    ld    A, L          ; 1:4       2dup $1 D>=   DEHL>=$1 --> DEHL-__HEX_DEHL($1)>=0 --> no carry if true
__{}    sub   A, __HEX_L($1)       ; 2:7       2dup $1 D>=   DEHL>=$1 --> ...A-0x......format({%02X},eval((($1)>>0) & 0xFF))>=0 --> no carry if true
__{}    ld    A, H          ; 1:4       2dup $1 D>=   DEHL>=$1 --> DEHL-__HEX_DEHL($1)>=0 --> no carry if true
__{}    sbc   A, __HEX_H($1)       ; 2:7       2dup $1 D>=   DEHL>=$1 --> ..A.-0x....format({%02X},eval((($1)>>8) & 0xFF))..>=0 --> no carry if true
__{}    ld    A, E          ; 1:4       2dup $1 D>=   DEHL>=$1 --> DEHL-__HEX_DEHL($1)>=0 --> no carry if true
__{}    sbc   A, __HEX_E($1)       ; 2:7       2dup $1 D>=   DEHL>=$1 --> .A..-0x..format({%02X},eval((($1)>>16) & 0xFF))....>=0 --> no carry if true
__{}    ld    A, D          ; 1:4       2dup $1 D>=   DEHL>=$1 --> DEHL-__HEX_DEHL($1)>=0 --> no carry if true
__{}    sbc   A, __HEX_D($1)       ; 2:7       2dup $1 D>=   DEHL>=$1 --> A...-0x{}format({%02X},eval((($1)>>24) & 0xFF))......>=0 --> no carry if true
__{}    ccf                 ; 1:4       2dup $1 D>=   DEHL<=$1                        -->    carry if true
__{}    push DE             ; 1:11      2dup $1 D>=
__{}    ex   DE, HL         ; 1:4       2dup $1 D>=
__{}    sbc  HL, HL         ; 2:15      2dup $1 D>=   bool: d1<$1})},
{
    .error {$0}($@): $# parameters found in macro!})}){}dnl
dnl
dnl
dnl
dnl
dnl
dnl
dnl
dnl ---------------------------------------------------------------------------
dnl ## X bit Logic ( DE = [p2], HL = [p1] )
dnl ---------------------------------------------------------------------------
dnl
dnl
dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 bool )
dnl # equal ( [p1] == [p2] )
define({PEQ},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PEQ},{p{}eval(8*($1))=},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PEQ},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+9        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+16       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+9        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+22       ; 2:7/12    __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+14       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+8        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-6        ; 2:7/12    __INFO
__{}    scf                 ; 1:4       __INFO
__{}    ld    L, 0x00       ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == [p{}eval(8*($1))_2]  with align $1
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-6            ; 2:8/13    __INFO
__{}    scf                 ; 1:4       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( p1 -- p1 bool )
dnl # bool = [p1] == 0
define({P0EQ},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_P0EQ},{p{}eval(8*($1)) 0=},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_P0EQ},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == 0  with align $1
__{}    ld    A,[HL]        ; 1:7       __INFO
__{}    or    A             ; 1:4       __INFO
__{}    jr   nz, $+16       ; 2:7/12    __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+10       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+6        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    sub 0x01            ; 2:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == 0  with align $1
__{}    xor   A             ; 1:4       __INFO
__{}    ld    D, A          ; 1:4       __INFO
__{}    ld    E, A          ; 1:4       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+6        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    dec  DE             ; 1:6       __INFO
__{}    ld    L, 0x00       ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO},
__{}{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_1 -- p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] == 0  with align $1
__{}    xor   A             ; 1:4       __INFO
__{}    ld    D, A          ; 1:4       __INFO
__{}    ld    E, A          ; 1:4       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    or  [HL]            ; 1:7       __INFO
__{}    jr   nz, $+5        ; 2:7/12    __INFO
__{}    djnz $-3            ; 2:8/13    __INFO
__{}    dec  DE             ; 1:6       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl
dnl # ( p2 p1 -- p2 p1 bool )
dnl # not equal ( [p1] != [p2] )
define({PNE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PNE},{p{}eval(8*($1))<>},$@)}){}dnl
}){}dnl
dnl
dnl
dnl
define({__ASM_TOKEN_PNE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] != [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] != [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] != [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+14       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+7        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] != [p{}eval(8*($1))_2]  with align $1
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+18       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+12       ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+6        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
__{}    ld     L, C         ; 1:4       __INFO
__{}    ex    DE, HL        ; 1:4       __INFO
__{}    sbc   HL, HL        ; 2:15      __INFO},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] != [p{}eval(8*($1))_2]  with align $1
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+6        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-6        ; 2:7/12    __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
__{}    ld    L, 0x00       ; 2:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO},
__{}{
__{}    push DE             ; 1:11      __INFO   ( p{}eval(8*($1))_2 p{}eval(8*($1))_1 -- p{}eval(8*($1))_2 p{}eval(8*($1))_1 bool )  bool = [p{}eval(8*($1))_1] != [p{}eval(8*($1))_2]  with align $1
__{}    ld    C, L          ; 1:4       __INFO
__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    xor [HL]            ; 1:7       __INFO
__{}    jr   nz, $+6        ; 2:7/12    __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-6            ; 2:8/13    __INFO
__{}    add   A, 0xFF       ; 2:7       __INFO   carry if not zero
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( pu2 pu1 -- pu2 pu1 bool )
dnl # unsigned ( [pu2] u< [pu1] ) --> ( [pu2] - [pu1] u< 0 ) --> carry is true
define({PULT},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PULT},{p{}eval(8*($1))ult},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PULT},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u< [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<[pu{}eval(8*($1))_1]},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u< [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<[pu{}eval(8*($1))_1]},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u< [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<[pu{}eval(8*($1))_1]},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u< [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<[pu{}eval(8*($1))_1]},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u< [pu{}eval(8*($1))_1]  with align 4
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<[pu{}eval(8*($1))_1]},
__{}{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u< [pu{}eval(8*($1))_1]  with align 4
__{}    ld    C, L          ; 1:4       __INFO
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<[pu{}eval(8*($1))_1]})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( pu2 pu1 -- pu2 pu1 bool )
dnl # unsigned ( [pu2] u>= [pu1] ) --> ( [pu2] - [pu1] u>= 0 ) --> not carry is true
define({PUGE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PUGE},{p{}eval(8*($1))uge},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUGE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u>= [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>=[pu{}eval(8*($1))_1]},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u>= [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>=[pu{}eval(8*($1))_1]},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u>= [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>=[pu{}eval(8*($1))_1]},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u>= [pu{}eval(8*($1))_1]  with align 4
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>=[pu{}eval(8*($1))_1]},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u>= [pu{}eval(8*($1))_1]  with align 4
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>=[pu{}eval(8*($1))_1]},
__{}{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u>= [pu{}eval(8*($1))_1]  with align 4
__{}    ld    C, L          ; 1:4       __INFO
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>=[pu{}eval(8*($1))_1]})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( pu2 pu1 -- pu2 pu1 bool )
dnl # unsigned ( [pu2] u> [pu1] ) --> ( 0 u> [pu1] - [pu2] ) --> carry is true
define({PUGT},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PUGT},{p{}eval(8*($1))ugt},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PUGT},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u> [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>[pu{}eval(8*($1))_1]},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u> [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>[pu{}eval(8*($1))_1]},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u> [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>[pu{}eval(8*($1))_1]},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u> [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>[pu{}eval(8*($1))_1]},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u> [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>[pu{}eval(8*($1))_1]},
__{}{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u> [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u>[pu{}eval(8*($1))_1]})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl # ( pu2 pu1 -- pu2 pu1 bool )
dnl # unsigned ( [pu2] u<= [pu1] ) --> ( 0 u<= [pu1] - [pu2] ) --> not carry is true
define({PULE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}__ADD_TOKEN({__TOKEN_PULE},{p{}eval(8*($1))ule},$@)}){}dnl
}){}dnl
dnl
define({__ASM_TOKEN_PULE},{dnl
ifelse($1,{},{
__{}  .error {$0}(): Missing  parameter!},
eval($#>1),{1},{
__{}  .error {$0}($@): Unexpected parameter!},
__HAS_PTR($1),{1},{
__{}  .error {$0}($@): Parameter is pointer!},
__SAVE_EVAL($1),{0},{
__{}  .error {$0}($@): The parameter is 0!},
__SAVE_EVAL($1>256),{1},{
__{}  .error {$0}($@): The parameter is greater than 256!},
__SAVE_EVAL($1<0),{1},{
__{}  .error {$0}($@): The parameter is negative!},
{dnl
__{}define({__INFO},__COMPILE_INFO){}dnl
__{}ifelse(eval($1),1,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u<= [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<=[pu{}eval(8*($1))_1]},
__{}eval($1),2,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u<= [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<=[pu{}eval(8*($1))_1]},
__{}eval($1),3,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u<= [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    dec   L             ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<=[pu{}eval(8*($1))_1]},
__{}eval($1),4,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u<= [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sub [HL]            ; 1:7       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<=[pu{}eval(8*($1))_1]},
__{}eval($1),256,{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u<= [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    jr   nz, $-4        ; 2:7/12    __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<=[pu{}eval(8*($1))_1]},
__{}{
__{}    push DE             ; 1:11      __INFO   ( pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 -- pu{}eval(8*($1))_2 pu{}eval(8*($1))_1 bool )  bool == [pu{}eval(8*($1))_2] u<= [pu{}eval(8*($1))_1]  with align 4
__{}    ex   DE, HL         ; 1:4       __INFO
__{}    ld    C, L          ; 1:4       __INFO
__{}ifelse(TYP_P,{small},{dnl
__{}__{}    or    A             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1)       ; 2:7       __INFO},
__{}{dnl
__{}__{}    ld    A,[DE]        ; 1:7       __INFO
__{}__{}    sub [HL]            ; 1:7       __INFO
__{}__{}    inc   L             ; 1:4       __INFO
__{}__{}    inc   E             ; 1:4       __INFO
__{}__{}    ld    B, __HEX_L($1-1)       ; 2:7       __INFO})
__{}    ld    A,[DE]        ; 1:7       __INFO
__{}    sbc   A,[HL]        ; 1:7       __INFO
__{}    inc   L             ; 1:4       __INFO
__{}    inc   E             ; 1:4       __INFO
__{}    djnz $-4            ; 2:8/13    __INFO
__{}    ld    L, C          ; 1:4       __INFO
__{}    ccf                 ; 1:4       __INFO
__{}    sbc  HL, HL         ; 2:15      __INFO   bool: [pu{}eval(8*($1))_2]u<=[pu{}eval(8*($1))_1]})}){}dnl
}){}dnl
dnl
dnl
dnl
dnl
dnl
dnl
